#
# common makefile for all MAP diags.
#

# Workaround NT 'deficiencies':
#  change \'s to /'s in env vars
EQUATOR_ROOT := $(subst \,/,$(EQUATOR_ROOT))
ETI_TOOLS := $(subst \,/,$(ETI_TOOLS))

#
# define the tools
#
CC	= $(EQUATOR_ROOT)/bin/scc
LINK	= $(CC)
AR	= $(EQUATOR_ROOT)/bin/ar
OBJDUMP = $(EQUATOR_ROOT)/bin/objdump
SORT	= sort

#
#  Make sure MAPARCH is defined.
#
ifndef MAPARCH
MAPARCH=map1000
endif

#
# Includes
#
CINCLUDE += -I.
CINCLUDE += -I$(EQUATOR_ROOT)/usr_compiler/release/usr/include/eti
CINCLUDE += -I$(EQUATOR_ROOT)/usr_compiler/release/usr/include/eti/$(MAPARCH)

#
# Libraries
#
LIBS =

# 
# The need for the following ugliness should go away once the media_src
# tree renames it's mapCA directory to mapca...
# 
ifeq ($(MAPARCH),map1000)
DIAG_INCDIRS = -I$(ETI_TOOLS)/media_src/media_lib/$(MAPARCH)/include
DIAG_LIBDIRS=  -L$(ETI_TOOLS)/media_src/media_lib/$(MAPARCH)/lib/standalone
else
DIAG_INCDIRS = -I$(ETI_TOOLS)/media_src/media_lib/mapCA/include
DIAG_LIBDIRS=  -L$(ETI_TOOLS)/media_src/media_lib/mapCA/lib/standalone
endif

CINCLUDE += $(DIAG_INCDIRS)
LFLAGS = $(DIAG_LIBDIRS)

#
# Common C flags (note that -ansi is now the default).
#

# Disable dismissable loads... possible compiler bug related to
# dismissable loads and aggressive loop unrolling.
#
CFLAGS += -mP3OPT_allow_dismissable_loads=FALSE

#
# Combine CFLAGS with CDEFS, CINCLUDE, and finally add in command line flags
#
CFLAGS +=  $(CINCLUDE)

# inference rules
.SUFFIXES : .c .s .o .ast


