#ifndef JBIG2_H
#define JBIG2_H

//#include <mm.h>
#include "stdtypes.h"

enum PSTATE { initialize, process, finish };

#define JBIG2_STRIPSPERBAND   48	//50 /* tuneable to affect performance */

typedef struct _JBIG2State {
   /* image dimensions */
   int pixels;
   int scanlines;
   int bytesperline;
   int compressedSize;

   enum PSTATE processingState;
   
   /* Keeps track of current strip and band being processed */
   int stripNumber;
   int bandNumber;
   int totalStripCnt; /* total number of strips in current image */
   int lastStripCnt; /* number of nonzero scanlines in last strip */
   int totalBandCnt;  /* total number of bands in current image */
   int lastBandCnt;  /* number of strips in last band */

   // Input Ping-Pong Buffers to store JBIG2_STRIPSPERBAND
   // ** FIXME -> Need to increase this if JBIG2_STRIPSPERBAND changes
   unsigned char inpBuffer[2][(7200*JBIG2_STRIPSPERBAND)/8];
   bool			 bufferId;		// 0 or 1 indicating which buffer is currently being processed

   /* Keeping track of the current output address & filled buffer size*/
   unsigned char *outCurAddress;

   // Needed by Silx encoder
   void *dgp_state;
   void *enc_cookie;
} JBIG2State;

#endif
