#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stdtypes.h"
#include "jbig2.h"

extern void   jbigTaskInit();
extern bool   jbigValidateRequest(uint32 pixels, uint32 scanlines, uint32 *err);
extern bool   jbigTask();
extern uint8* getAddressAndSize (uint32 *);

uint8* scanOneImage (uint32* compSize);

FILE 	*ifile;

/* at later time, main() function, ifile, & ofile to be obsolete */

void main (int argc, char **argv)
{
  uint32 size;
  uint8  *addr;
  FILE   *ofile;

   if (argc < 3) {
	printf ("Usage: %s inputImagefile outputJBIG2Encodedfile\n", argv[0]);
	exit(-1);
   }
#ifdef FILE_READ
   else if ((ifile=fopen(argv[1], "rb")) == NULL) {
        printf("%s: can't open %s\n", argv[0], argv[1]);
        exit(-1);
   }
#endif
   else if((ofile=fopen(argv[2],"wb")) == NULL) {
        printf("%s: can't make %s\n", argv[0], argv[2]);
        fclose(ifile);
        exit(-1);
   }

   addr = scanOneImage (&size);

   fwrite (addr, size, 1, ofile);

   fclose (ofile);
}


uint8* scanOneImage (uint32* compSize)
{
   uint8  *addr;
   uint32 errCode;
   char header[10];
   uint32 pixels;
   uint32 scanlines;
   /* at later time, this done by powerup */
   jbigTaskInit();
   fscanf(ifile,"%s\n", header);
   if(strncmp(header,"P4",2)){
	printf ("<jbigTsk> Not PBM format\n");
	exit (-1);
   }
   fscanf(ifile,"%d %d\n",&pixels, &scanlines);
   /* at later time, this done by command parser task */
   if (!jbigValidateRequest( pixels, scanlines, &errCode )) {
	printf ("<jbigTsk> Error %d in Parameters\n", errCode);
	exit (-1);
   }

   /* at later time, this done by scheduler */
   while (jbigTask());

   addr = getAddressAndSize (compSize);

   return (addr);
}
