/*
 *M*****************************************************************************
 *M*  Product:  XEROX OSG/OSCG/EIDC S2X Board                                  *
 *M*****************************************************************************
 *M*                                                                           *
 *M*                    COPYRIGHT (C) 2001 XEROX CORPORATION                   *
 *M*                    ALL RIGHTS RESERVED                                    *
 *M*                                                                           *
 *M*****************************************************************************
 *M*
 *M*    MODULE NAME  :  stdtypes.h
 *M*
 *M*    PURPOSE      :  Standard Type declarations common to EIDC
 *M*
 *M*    DESCRIPTION  :  ?
 *M*                    ?
 *M*
 *******************************************************************************
 **     AUTHOR IDENTITY                                                        *
 *******************************************************************************
 **
 **  Initials  Name
 **  --------  ------------------------------
 **  mdd       Marlin Diehl
 **   nl       Nathan Lund
 **   rn       Ramesh Nagarajan
 **   pt       Phil Turkovitz
 **
 *******************************************************************************
 **     SVCS MODULE REVISION HISTORY:                                          *
 *******************************************************************************
 **  Revision    Date    Author  Description
 **  --------  --------  ------  ----------------------
 **  XXXXXXXX  YY.MM.DD  ???     ??
 *******************************************************************************
 */

#ifndef  _STDTYPES_H
#define  _STDTYPES_H

/*****************/
/* Include files */
/*****************/

/*********************/
/* Constant #defines */
/*********************/
#define ZERO              0
#define ONE               1
 
//#ifdef TRUE    /* if TRUE already defined make sure it is defined to 1 */
//#if TRUE != 1
//#define TRUE              1
//#endif
//#else          /* else if TRUE is not defined, define it to 1 */
//#define TRUE              1
//#endif

//#ifdef FALSE   /* if FALSE already defined make sure it is defined to 0 */
//#if (FALSE != 0)
//#define FALSE             0
//#endif
//#else          /* else if FALSE is not defined, define it to 0 */
//#define FALSE             0
//#endif

//#define PCVERSION		// Running on a PC
#define FILE_READ		// Reading from a file instead of live video

#ifndef FALSE
#define FALSE              0
#endif

#ifndef TRUE
#define TRUE               1    
#endif

#ifndef NO
#define NO                0
#endif

#ifndef YES
#define YES               1    
#endif

#ifndef NULL
#define NULL              0
#endif

#define OFF               0
#define ON                1
#define CLOSED            0
#define OPENED            1
#define TOGGLE            2

#define ENABLED           1
#define DISABLED          0
#define ENABLE            1
#define DISABLE           0
#define PASS	           1
#define FAIL	           0
//#define TOP	              1
//#define BOTTOM	           0
 

// Timer Tick definitions below assume 5 msec per timer tick
#define TT_10MSEC          2
#define TT_50MSEC          10
#define TT_100MSEC         ( 10 * TT_10MSEC)
#define TT_500MSEC         ( 50 * TT_10MSEC) 
#define TT_1SEC            (100 * TT_10MSEC)
#define TT_2SEC            (  2 * TT_1SEC)
#define TT_5SEC            (  5 * TT_1SEC)
#define TT_10SEC           ( 10 * TT_1SEC)
#define TT_15SEC           ( 15 * TT_1SEC) 
#define TT_30SEC           ( 30 * TT_1SEC)
#define TT_1MIN            ( 60 * TT_1SEC)
#define TT_2MIN            (120 * TT_1SEC)
#define TT_LONG_TOUT       TT_2MIN

/*********************/
/* Macro definitions */
/*********************/
#define MIN(A,B) ((A) < (B) ? (A) : (B))
#define MAX(A,B) ((A) > (B) ? (A) : (B))

//#define LO_BYTE(A) ((A) & 0x00ff)
//#define HI_BYTE(A) ((A) >> 8)

/************/
/* Typedefs */
/************/
typedef unsigned char   bool;     /* TRUE/FALSE boolean variable */
typedef unsigned char   uint8;    /*  8-bit range 0 to 255 */
typedef char            int8;
typedef unsigned short  uint16;	 /* 16-bit range 0 to 65,535 */
typedef short           int16;
typedef unsigned int    uint32;   /* 32-bit range 0 to 4,294,967,295 */
typedef int             int32;
// typedef double          int64;

typedef  int (*PFI)(void);		  /* pointer to function returning  int */
typedef void (*PFV)(void);		  /* pointer to function returning void */
typedef void (*PFPC)(char);	  /* pointer to function passing a char */

 
/*************************/
/* Structure definitions */
/*************************/

typedef union
{   unsigned long l;
    struct
    {   unsigned char hi_msb; 
        unsigned char hi_lsb; 
        unsigned char lo_msb; 
        unsigned char lo_lsb; 
    } bytes; 
} O4_bytes;


typedef union
{   
    unsigned short w;
    unsigned short all;
    struct
    {   unsigned char msb;
        unsigned char lsb;
    } bytes;
} O2_bytes;


/*****************/
/* Exported Data */
/*****************/

/********************************/
/* Exported function prototypes */
/********************************/



#endif //_STDTYPES_H


