
#ifndef Compression_h_INCLUDED
#define Compression_h_INCLUDED

class ICompression
{
 public:


  ICompression ( void );
  virtual ~ICompression ( void );
  
  // set Size
  virtual BOOL SetSize (ULONG width, ULONG height, ULONG bytesPerLine,
			ULONG bitsPerPixel, ULONG channels);  

  // start a new page
  virtual BOOL Compress (unsigned char* imageData, ULONG dataSize,
			 unsigned char** compressedData, 
			 ULONG* compressedDataSize); 

  // allocate output buffer
  virtual BOOL AllocateOutputBuffer ( LONG expectedCompressionFactor );

  // give caller a chance to free the buffer
  virtual void ClearOutputBuffer (void);

 protected:

  // image parameters
  ULONG m_width;
  ULONG m_height;
  ULONG m_bpl;
  ULONG m_bpp;
  ULONG m_channels;

  ULONG m_padding;

  // compressed buffer
  unsigned char* m_pCompressedData; 
  ULONG m_compressedDataSize; 

};

#endif
