#include "stdafx.h"

#include "OemBase.h"


BOOL APIENTRY OEMBitBlt(
    SURFOBJ   *psoTrg,
    SURFOBJ   *psoSrc,
    SURFOBJ   *psoMask,
    CLIPOBJ   *pco,
    XLATEOBJ  *pxlo,
    RECTL     *prclTrg,
    POINTL    *pptlSrc,
    POINTL    *pptlMask,
    BRUSHOBJ  *pbo,
    POINTL    *pptlBrush,
    ROP4      rop4 )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoTrg->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvBitBlt( psoTrg, psoSrc, psoMask, pco, pxlo, prclTrg,
        pptlSrc, pptlMask, pbo, pptlBrush, rop4 );
}

BOOL APIENTRY OEMStretchBlt(
    SURFOBJ         *psoDest,
    SURFOBJ         *psoSrc,
    SURFOBJ         *psoMask,
    CLIPOBJ         *pco,
    XLATEOBJ        *pxlo,
    COLORADJUSTMENT *pca,
    POINTL          *pptlHTOrg,
    RECTL           *prclDest,
    RECTL           *prclSrc,
    POINTL          *pptlMask,
    ULONG            iMode )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoDest->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvStretchBlt( psoDest, psoSrc, psoMask, pco, pxlo, pca,
        pptlHTOrg, prclDest, prclSrc, pptlMask, iMode );
}

BOOL APIENTRY APIENTRY OEMCopyBits(
    SURFOBJ        *psoDest,
    SURFOBJ        *psoSrc,
    CLIPOBJ        *pco,
    XLATEOBJ       *pxlo,
    RECTL          *prclDest,
    POINTL         *pptlSrc )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoDest->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvCopyBits( psoDest, psoSrc, pco, pxlo, prclDest, pptlSrc );
}

BOOL APIENTRY OEMTextOut(
    SURFOBJ    *pso,
    STROBJ     *pstro,
    FONTOBJ    *pfo,
    CLIPOBJ    *pco,
    RECTL      *prclExtra,
    RECTL      *prclOpaque,
    BRUSHOBJ   *pboFore,
    BRUSHOBJ   *pboOpaque,
    POINTL     *pptlOrg,
    MIX         mix )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvTextOut( pso, pstro, pfo, pco, prclExtra,
        prclOpaque, pboFore, pboOpaque, pptlOrg, mix );
}

BOOL APIENTRY OEMStrokePath(
    SURFOBJ    *pso,
    PATHOBJ    *ppo,
    CLIPOBJ    *pco,
    XFORMOBJ   *pxo,
    BRUSHOBJ   *pbo,
    POINTL     *pptlBrushOrg,
    LINEATTRS  *plineattrs,
    MIX         mix )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvStrokePath( pso, ppo, pco, pxo, pbo, pptlBrushOrg,
        plineattrs, mix );
}

BOOL APIENTRY OEMFillPath(
    SURFOBJ    *pso,
    PATHOBJ    *ppo,
    CLIPOBJ    *pco,
    BRUSHOBJ   *pbo,
    POINTL     *pptlBrushOrg,
    MIX         mix,
    FLONG       flOptions )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvFillPath( pso, ppo, pco, pbo, pptlBrushOrg, mix,
        flOptions );
}

BOOL APIENTRY OEMStrokeAndFillPath(
    SURFOBJ    *pso,
    PATHOBJ    *ppo,
    CLIPOBJ    *pco,
    XFORMOBJ   *pxo,
    BRUSHOBJ   *pboStroke,
    LINEATTRS  *plineattrs,
    BRUSHOBJ   *pboFill,
    POINTL     *pptlBrushOrg,
    MIX         mixFill,
    FLONG       flOptions )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvStrokeAndFillPath( pso, ppo, pco, pxo, pboStroke,
        plineattrs, pboFill, pptlBrushOrg, mixFill, flOptions );
}


BOOL APIENTRY OEMRealizeBrush(
    BRUSHOBJ   *pbo,
    SURFOBJ    *psoTarget,
    SURFOBJ    *psoPattern,
    SURFOBJ    *psoMask,
    XLATEOBJ   *pxlo,
    ULONG       iHatch )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoTarget->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvRealizeBrush( pbo, psoTarget, psoPattern, psoMask, pxlo, iHatch );
}

BOOL APIENTRY OEMStartPage( SURFOBJ *pso )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvStartPage( pso );
}

BOOL APIENTRY OEMSendPage( SURFOBJ *pso ) 
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvSendPage( pso ) ;
}

ULONG APIENTRY OEMEscape(
    SURFOBJ    *pso,
    ULONG       iEsc,
    ULONG       cjIn,
    PVOID       pvIn,
    ULONG       cjOut,
    PVOID       pvOut )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvEscape( pso, iEsc, cjIn, pvIn, cjOut, pvOut );
}

BOOL APIENTRY OEMStartDoc( SURFOBJ *pso, PWSTR pwszDocName, DWORD dwJobId )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvStartDoc( pso, pwszDocName, dwJobId );
}

BOOL APIENTRY OEMEndDoc( SURFOBJ *pso, FLONG fl )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvEndDoc( pso, fl );
}


PIFIMETRICS APIENTRY OEMQueryFont(
    DHPDEV      dhpdev,
    ULONG       iFile,
    ULONG       iFace,
    ULONG      *pid )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvQueryFont( dhpdev, iFile, iFace, pid );
}

PVOID APIENTRY OEMQueryFontTree(
    DHPDEV      dhpdev,
    ULONG       iFile,
    ULONG       iFace,
    ULONG       iMode,
    ULONG      *pid )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvQueryFontTree( dhpdev, iFile, iFace, iMode, pid );
}

LONG APIENTRY OEMQueryFontData(
    DHPDEV      dhpdev,
    FONTOBJ    *pfo,
    ULONG       iMode,
    HGLYPH      hg,
    GLYPHDATA  *pgd,
    PVOID       pv,
    ULONG       cjSize )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvQueryFontData( dhpdev, pfo, iMode, hg, pgd, pv, cjSize );
}

BOOL APIENTRY OEMQueryAdvanceWidths(
    DHPDEV      dhpdev,
    FONTOBJ    *pfo,
    ULONG       iMode,
    HGLYPH     *phg,
    PVOID       pvWidths,
    ULONG       cGlyphs )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvQueryAdvanceWidths( dhpdev, pfo, iMode, phg, pvWidths, cGlyphs );
}

ULONG APIENTRY OEMFontManagement(
    SURFOBJ    *pso,
    FONTOBJ    *pfo,
    ULONG       iMode,
    ULONG       cjIn,
    PVOID       pvIn,
    ULONG       cjOut,
    PVOID       pvOut )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvFontManagement( pso, pfo, iMode, cjIn, pvIn, cjOut, pvOut );
}

ULONG APIENTRY OEMGetGlyphMode( DHPDEV dhpdev, FONTOBJ *pfo )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvGetGlyphMode( dhpdev, pfo );
}

BOOL APIENTRY OEMNextBand( SURFOBJ *pso, POINTL *pptl )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvNextBand( pso, pptl );
}

BOOL APIENTRY OEMStartBanding( SURFOBJ *pso, POINTL *pptl )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvStartBanding( pso, pptl );
}

ULONG APIENTRY OEMDitherColor(
    DHPDEV  dhpdev,
    ULONG   iMode,
    ULONG   rgbColor,
    ULONG  *pulDither )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvDitherColor( dhpdev, iMode, rgbColor, pulDither );
}

BOOL APIENTRY OEMLineTo(
    SURFOBJ    *pso,
    CLIPOBJ    *pco,
    BRUSHOBJ   *pbo,
    LONG        x1,
    LONG        y1,
    LONG        x2,
    LONG        y2,
    RECTL      *prclBounds,
    MIX         mix )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(pso->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvLineTo( pso, pco, pbo, x1, y1, x2, y2, prclBounds, mix );
}

BOOL APIENTRY OEMStretchBltROP(
    SURFOBJ         *psoDest,
    SURFOBJ         *psoSrc,
    SURFOBJ         *psoMask,
    CLIPOBJ         *pco,
    XLATEOBJ        *pxlo,
    COLORADJUSTMENT *pca,
    POINTL          *pptlHTOrg,
    RECTL           *prclDest,
    RECTL           *prclSrc,
    POINTL          *pptlMask,
    ULONG            iMode,
    BRUSHOBJ        *pbo,
    ROP4             rop4 )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoDest->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvStretchBltROP( psoDest, psoSrc, psoMask, pco, pxlo, pca,
        pptlHTOrg, prclDest, prclSrc, pptlMask, iMode, pbo, rop4 );
}

BOOL APIENTRY OEMPlgBlt(
    SURFOBJ         *psoDst,
    SURFOBJ         *psoSrc,
    SURFOBJ         *psoMask,
    CLIPOBJ         *pco,
    XLATEOBJ        *pxlo,
    COLORADJUSTMENT *pca,
    POINTL          *pptlBrushOrg,
    POINTFIX        *pptfixDest,
    RECTL           *prclSrc,
    POINTL          *pptlMask,
    ULONG           iMode )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoDst->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvPlgBlt( psoDst, psoSrc, psoMask, pco, pxlo, pca,
        pptlBrushOrg, pptfixDest, prclSrc, pptlMask, iMode );
}

BOOL APIENTRY OEMAlphaBlend(
    SURFOBJ    *psoDest,
    SURFOBJ    *psoSrc,
    CLIPOBJ    *pco,
    XLATEOBJ   *pxlo,
    RECTL      *prclDest,
    RECTL      *prclSrc,
    BLENDOBJ   *pBlendObj )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoDest->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvAlphaBlend( psoDest, psoSrc, pco, pxlo, prclDest, prclSrc,
        pBlendObj );
}

BOOL APIENTRY OEMGradientFill(
    SURFOBJ    *psoDest,
    CLIPOBJ    *pco,
    XLATEOBJ   *pxlo,
    TRIVERTEX  *pVertex,
    ULONG       nVertex,
    PVOID       pMesh,
    ULONG       nMesh,
    RECTL      *prclExtents,
    POINTL     *pptlDitherOrg,
    ULONG       ulMode )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoDest->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvGradientFill( psoDest, pco, pxlo, pVertex, nVertex, pMesh,
        nMesh, prclExtents, pptlDitherOrg, ulMode );
}

BOOL APIENTRY OEMTransparentBlt(
    SURFOBJ    *psoDst,
    SURFOBJ    *psoSrc,
    CLIPOBJ    *pco,
    XLATEOBJ   *pxlo,
    RECTL      *prclDst,
    RECTL      *prclSrc,
    ULONG      iTransColor,
    ULONG      ulReserved )
{
    PDEVOBJ pdevobj = reinterpret_cast<PDEVOBJ>(psoDst->dhpdev);
    IOemBase * ptr = static_cast<IOemBase *>(pdevobj->pdevOEM);
    return ptr->DrvTransparentBlt( psoDst, psoSrc, pco, pxlo, prclDst,
        prclSrc, iTransColor, ulReserved );
}

