#ifndef OemTiff_h_INCLUDED
#define OemTiff_h_INCLUDED

#include <fstream>

#include "OemPlane.h"
#include "TiffOutSurf.h"

/*

  IOemTiff is a full-blown working TIFF-based printer driver.  The output
  is an uncompressed TIFF file.

*/

class IOemTiff : public IOemPlane
{
public:

    IOemTiff( void );

    //
    // IPrintOemUni methods (See Win 2000 Driver DDK documentation.
    // 
       
    //
    // DDI hook methods.
    // 

    virtual BOOL DrvStartDoc ( SURFOBJ *, PWSTR, DWORD ); 
    virtual BOOL DrvStartPage( SURFOBJ * ); 
    virtual BOOL DrvEndDoc   ( SURFOBJ *, FLONG );    

    //
    // IOemPlane methods
    //

    virtual size_t writeData( PDEVOBJ, unsigned char *, size_t );

protected:

    virtual HRESULT initFrom( IOemBase * );

private:

    TiffOutSurf m_tiff;
    bool m_isReset;

};

#endif
