
#ifndef TfxOutput_h_INCLUDED
#define TfxOutput_h_INCLUDED

extern "C"
{
#include "iomrc.h"
}

#include "feeder.h"

class ITfxOutput
{
public:


    ITfxOutput ( void ) ;
	~ITfxOutput ( void ) ;

	// open a TFX file
	BOOL TfxStartDoc (); 

	// start a new page
	BOOL TfxStartPage ( PDEVOBJ pdevobj,
		IPrintOemDriverUni* pOEMHelp ); 

	// write the first strip of the selector plane
	// this call defines the size of the page, and the size of its strips
	BOOL TfxWriteFirstSelectorStrip (ULONG width, ULONG height,
		ULONG stripHeight, ULONG xres, ULONG yres, unsigned char* buffer,
		ULONG bufferSize, IO_COMPRESSION comp);  

	// write another strip of the selector plane
	BOOL TfxWriteNextSelectorStrip (unsigned char* buffer,
		ULONG bufferSize);  

	// add image data
	BOOL TfxAddImage (ULONG layer, ULONG xpos, ULONG ypos, 
			 ULONG width, ULONG height, ULONG xres, ULONG yres, 
			 unsigned char* buffer, ULONG bufferSize, IO_COMPRESSION comp);  

	// end page
	BOOL TfxEndPage ();   

	// close TFX file
	BOOL TfxEndDoc ();    

protected:
	 
	// handles for the I/O libs
	ULONG m_instanceID;
	ULONG m_outIoDoc;
	ULONG m_outIoPage;
	ULONG m_outIoSelector;

	// class that buffers the output of mrcio and feeds it
	// to the spool buffer
	TiffSpoolBufferFeeder *m_sbh;

	// constants for the I/O libs
	const DOCTYPE m_outDocType;

	// page definitions
	ULONG m_xRes, m_yRes, m_stripHeight, m_width, m_height;
	IO_COMPRESSION m_selComp;

	// strip counter
	ULONG m_stripCount;
	
	// spool buffer stuff;
	PDEVOBJ m_pdevobj;
	IPrintOemDriverUni* m_pOEMHelp;
};

#endif
