/*************************************************************************
**
**  DigiPaper Codebase
**    
**  Pedro Felzenszwalb, January 1999
**  most of the code was stolen from tc2ps
**  
**  27.7.2000 / dhtesq.
**  Resurrection...
**
**	15.3.2001 / dhtesq.
**	Re-resurrection for tfx...
**
**************************************************************************/

/*
 *
 * $Header: /project/icons/cvsroot/digipaper/src/DgpPdf/DgpPdf_ops.c,v 1.1 2001/03/20 01:36:44 dtracy Exp $
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include "dgp_state.h"
#include "token_t.h"
#include "hash_table.h"
#include "libsupercache.h"
#include "extension_t.h"     // libzephyr...
#include "DgpPdf_util.h"
#include "encodings.h"

//#include "writeXiff3.h"      // Has includes necessary to prototype ipcore GetSymlibOffset()...
/*
#ifndef _WIN32
#include "undecl-stdio.h"
#endif
*/

DGP_RCSID("@(#)$Header: /project/icons/cvsroot/digipaper/src/DgpPdf/DgpPdf_ops.c,v 1.1 2001/03/20 01:36:44 dtracy Exp $");

/* ipcore routine used, simpler to include this than all of the necessary
   header file (i couldn't even figure out all of the right ones...) */
/*
ErrCode CDECL
wp_XifGetSymlibOffset(XDoc *xDoc, UInt32 symlibOffset, Int32 *pOffset,
              Int32 *pBytes);
*/


#ifdef  DGP_DBUG
const char sampim_name[] = "sampim";
const char sampim_data_name[] = "sampimData";
#else
const char sampim_name[] = "sm";
const char sampim_data_name[] = "smD";
#endif


/* actually defined in xiff_ops_util.c */
//extern boolean alloc_dict_arrays(XiffPerPageDictData* dict_data);
//extern void init_pext_info(posext_info* pext_info);

// Stub this out for now.  Original is no longer among the living.
// Idea is to hash the tokens against their original libraries? / dhtesq.
static ErrCode
make_tok_hash(Dgp_Int32     num_uniqids,
              Dgp_Int32     *num_toks,
              token         **toks,
              DgpAdt_HashTable *tok_hash,
              Dgp_State     *dgp_state)
{
  //    DGP_PROLOGUE("make_tok_hash()", DGP_PERRSTATE);

    //hashhash
  dgp_state = dgp_state;

  num_uniqids = num_uniqids;
  num_toks = num_toks;
  toks = toks;
  tok_hash = NULL;
  return(cSuccessful);

    //ERR_CLEANUP:
    //    ERR_RETURN;
}

/* Read all of the dictionaries in the tc file into the XiffPerPageDictData
   struct. 

Attempted revision of ReadXiffDicts().  We'll use the supercache/zephyr interface
to retrieve tokens and position blocks for every page in the document. / dhtesq.

*/
ErrCode
retrieveAllDictionaries(DgpPdfState           *state, 
                        Dgp_Int32             num_uniqids, 
                        Dgp_UInt32            *uniqids,
                        Dgp_State             *dgp_state)
{
  DGP_PROLOGUE("retrieveAllDictionaries()", DGP_PERRSTATE);

  //Dgp_Int32 i, j;
  Dgp_Bool fetched = DGP_FALSE;
  //zephDictionaryInfo zephDict;

  /* Number of non-color dictionaries. */
  state->num_uniqids = num_uniqids;

  /* Allocate the dictionary arrays. */
  /*
  DGP_CHECK_ALLOC_CLEANUP(state->dictblock = (void **)DGP_MALLOC(num_uniqids * sizeof(*(state->dictblock))));
  DGP_CHECK_ALLOC_CLEANUP(state->num_toks = (Dgp_Int32 *)DGP_MALLOC(num_uniqids * sizeof(*(state->num_toks))));
  DGP_CHECK_ALLOC_CLEANUP(state->toks = (token **)DGP_MALLOC(num_uniqids * sizeof(*(state->toks))));
  DGP_CHECK_ALLOC_CLEANUP(state->num_extensions = (Dgp_Int32 *)DGP_MALLOC(num_uniqids * sizeof(*(state->num_extensions))));
  DGP_CHECK_ALLOC_CLEANUP(state->extensions = (Extension **)DGP_MALLOC(num_uniqids * sizeof(*(state->extensions))));
  */

  // Now we ask supercache for the specified dictionaries.
  // For now, we skip the position blocks.  Still unclear when position information became available
  // in previous incarnation.
  //DGP_ERR_PASS_CLEANUP(zephOpenDictionary(state->zephDoc, num_uniqids, uniqids, &zephDict));
  
  DGP_ERR_PASS_CLEANUP(suGetTokenDictionary(state->cache, 0, num_uniqids, uniqids, &state->entry));
  //DGP_ERR_PASS_CLEANUP(suGetTokenDictionaryH(state->cache, 0, zephDict, &state->entry));
  fetched = DGP_TRUE;
  DGP_ERR_PASS_CLEANUP(suExtractTokenDictionary(state->entry, &state->segment));
  
  //DGP_ERR_PASS_CLEANUP(zephCloseDictionary(&zephDict));
  
  /* Create a hash table for token lookup if there is more than
     1 dictionary in the document. num_uniqids tells you the number
     of unique dictionary ids. */

  if(num_uniqids > 1) {
    /* Make a HashTable that we can use to look up tokens... */
	  /*
    DGP_ERR_PASS_CLEANUP(make_tok_hash( num_uniqids,
                                        state->num_toks,
                                        state->toks,
                                        &state->tok_hash,
                                        dgp_state));
										*/
  } else {
    /* No need to create a hash table here... */
    //state->toks_pg = state->dictionary->toks[0];
    
    /* Hash table not used, so it should be set to null. */
    state->tok_hash = (DgpAdt_HashTable)NULL;
  }

  /* Clear the resid variables so we know if we need to clean them up later. */
  state->residual_toks = (token *)NULL;
  state->num_residual_toks = 0;
  
  /* Finally check to see if this is a scaled document, if so, warn the user. */
#if 0
  for (i = 0; i < num_uniqids; i++) {
    if(state->dictionary->exts[i] == NULL){
        continue;
    }
    for (j = 0; j < state->dictionary->extCount[i]; j++) {
      if (state->dictionary->exts[i][j].tag == SCALEDTOK_EXT_TAG) {
            /* This is a scaled document, because it has the
            an extension to a dictionary block with the SCALEDTOK_EXT_TAG
            tag. */
          DGP_WARNF0("Scaled documents will not be handled correctly.");
      }
    }
  }
#endif

  NORMAL_RETURN;

ERR_CLEANUP:

  //if(state->dictblock != NULL) DGP_FREE(state->dictblock);
  /*
  if(state->extensions != NULL) DGP_FREE(state->extensions);
  if(state->num_extensions != NULL) DGP_FREE(state->num_extensions);
  if(state->toks != NULL) DGP_FREE(state->toks);
  if(state->num_toks != NULL) DGP_FREE(state->num_toks);
  */

  if(fetched){
      suReleaseReference(state->entry);
  }

  ERR_RETURN;
}
