/*************************************************************************
**
**  DigiPaper Codebase
**    
**  Pedro Felzenszwalb, January 1999
**  
**	15.3.2001 / dhtesq.
**	Re-resurrection for tfx...
**
**************************************************************************/

/*
 * RCS Header
 *
 * $Header: /project/icons/cvsroot/digipaper/src/DgpPdf/encodings.h,v 1.1 2001/03/20 01:36:44 dtracy Exp $
 */

#ifndef __ENCODINGS_H
#define __ENCODINGS_H

#include <stdlib.h>
#include "DgpPdf_util.h"

/* cookie to carry around memory (no asssumptions should be made about what
   is in the memory) */
typedef struct {
  Dgp_Allocators a;
  Dgp_UInt8 *buf;
  Dgp_Int32 buf_len;
} *ReusableBuffer;

/* get a pointer of size 'size + sizeof(Dgp_UInt32)' (the added space is protection
   for alignment changes), assign the value to 'ptr'.
   iff 'ptr' is set to NULL, there was an error, otherwise 'ptr'
   will point to a buffer of at least 'size' bytes.  'rebuf' should be
   of type ReusableBuffer.  */
#define GetReusableBufferPtr(ptr, size, rebuf)				\
{									\
  Dgp_Int32 __size = (size)+sizeof(Dgp_UInt32);					\
  if(__size > (rebuf)->buf_len) {					\
    if(((ptr) = ((rebuf)->a.realloc)((rebuf)->buf, __size))) {		\
      (rebuf)->buf_len = __size;					\
      (rebuf)->buf = (Dgp_UInt8 *)(ptr);					\
    }									\
  } else {								\
    (ptr) = (void *)((rebuf)->buf);					\
  }									\
}

/* init cookie used for num string and g4 encoding */
ErrCode
InitReusableBuffer(ReusableBuffer *rebuf, Dgp_State *dgp_state);

/* cleanup memory used for num string and g4 encoding */
void 
CleanupReusableBuffer(ReusableBuffer *rebuf);

#ifdef _LITTLE_ENDIAN
/* convert a buffer made for long access to a buffer for char access */
void
convert_ulong_2_uchar(void *buf, Dgp_Int32 buf_len);

/* convert a buffer made for char access to a buffer for long access */
void
convert_uchar_2_ulong(void *buf, Dgp_Int32 buf_len);
#endif

ErrCode
g4encode(ReusableBuffer     rebuf, 
         void               *raw_buf, 
         Dgp_Int32          width,
         Dgp_Int32          height, 
         Dgp_Int32          longs_per_row, 
         DgpPdfState        *state, 
         Dgp_Int8           **_buf, 
         Dgp_Int32          *_buf_len,
         Dgp_State          *dgp_state);

#endif /* __ENCODINGS_H */
