// DigiviewerView.cpp : implementation of the CDigiviewerView class
//

#include "stdafx.h"

#include <math.h>
#include <algorithm>

#include <assert.h>

#include "Digiviewer.h"
#include "Dixie.h"
#include "DigiviewerDoc.h"
#include "DigiviewerView.h"
#include "MainFrm.h"
#include "TestHighlight.h"
#include "Dixie2Option.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CStatusBar *pStatus;

const double CDigiviewerView::m_maxRes = 5.00;
const double CDigiviewerView::m_minRes = 0.01;

const double CDigiviewerView::m_zoomTable[] = 
{ 
    0.01, 0.05, 0.10, 0.20, 0.30,    0.40, 0.50, 0.60, 0.70, 0.80,
    0.90, 1.00, 2.00, 3.00, 4.00,    5.00 
};
 
const size_t CDigiviewerView::m_zoomTableSize = 
    sizeof(m_zoomTable) / sizeof(double);


/////////////////////////////////////////////////////////////////////////////
// CDigiviewerView

IMPLEMENT_DYNCREATE(CDigiviewerView, CView)

BEGIN_MESSAGE_MAP(CDigiviewerView, CView)
	//{{AFX_MSG_MAP(CDigiviewerView)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FILE_SAVE,  OnFileSave)
	ON_COMMAND(ID_VIEW_RES_5_1,   OnViewRes5_1)
	ON_COMMAND(ID_VIEW_RES_4_1,   OnViewRes4_1)
	ON_COMMAND(ID_VIEW_RES_3_1,   OnViewRes3_1)
	ON_COMMAND(ID_VIEW_RES_2_1,   OnViewRes2_1)
	ON_COMMAND(ID_VIEW_RES_1_1,   OnViewRes1_1)
	ON_COMMAND(ID_VIEW_RES_1_10,  OnViewRes1_10)
	ON_COMMAND(ID_VIEW_RES_2_10,  OnViewRes2_10)
	ON_COMMAND(ID_VIEW_RES_3_10,  OnViewRes3_10)
	ON_COMMAND(ID_VIEW_RES_4_10,  OnViewRes4_10)
	ON_COMMAND(ID_VIEW_RES_5_10,  OnViewRes5_10)
	ON_COMMAND(ID_VIEW_RES_6_10,  OnViewRes6_10)
	ON_COMMAND(ID_VIEW_RES_7_10,  OnViewRes7_10)
	ON_COMMAND(ID_VIEW_RES_8_10,  OnViewRes8_10)
	ON_COMMAND(ID_VIEW_RES_9_10,  OnViewRes9_10)
	ON_COMMAND(ID_VIEW_RES_1_20,  OnViewRes1_20)
    ON_COMMAND(ID_VIEW_RES_1_100, OnViewRes1_100)
	ON_COMMAND(ID_VIEW_ZOOM_FITTOPAGE, OnViewZoomFittopage)
	ON_COMMAND(ID_VIEW_ZOOM_FITTOWIDTH, OnViewZoomFittowidth)
	ON_COMMAND(ID_VIEW_ROTATE_270, OnViewRotate270)
	ON_COMMAND(ID_VIEW_ROTATE_90, OnViewRotate90)
	ON_COMMAND(ID_VIEW_ROTATE_180, OnViewRotate180)
	ON_COMMAND(ID_VIEW_ROTATE_0, OnViewRotate0)
	ON_COMMAND(ID_VIEW_PAGE_NEXT, OnViewPageNext)
	ON_COMMAND(ID_VIEW_PAGE_PREV, OnViewPagePrev)
	ON_COMMAND(ID_VIEW_PAN, OnViewPan)
	ON_COMMAND(ID_VIEW_ROTATE, OnViewRotate)
	ON_COMMAND(ID_VIEW_ZOOM_IN, OnViewZoomIn)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PAN, OnUpdateViewPan)
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_CBN_CLOSEUP(IDC_PAGELIST, OnCloseupPagelist)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ROTATE_0, OnUpdateViewRotate0)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ROTATE_180, OnUpdateViewRotate180)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ROTATE_270, OnUpdateViewRotate270)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ROTATE_90, OnUpdateViewRotate90)
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_5_1,   OnUpdateViewRes5_1   )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_4_1,   OnUpdateViewRes4_1   )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_3_1,   OnUpdateViewRes3_1   )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_2_1,   OnUpdateViewRes2_1   )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_1_1,   OnUpdateViewRes1_1   )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_1_10,  OnUpdateViewRes1_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_2_10,  OnUpdateViewRes2_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_3_10,  OnUpdateViewRes3_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_4_10,  OnUpdateViewRes4_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_5_10,  OnUpdateViewRes5_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_6_10,  OnUpdateViewRes6_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_7_10,  OnUpdateViewRes7_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_8_10,  OnUpdateViewRes8_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_9_10,  OnUpdateViewRes9_10  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_1_20,  OnUpdateViewRes1_20  )
	ON_UPDATE_COMMAND_UI(ID_VIEW_RES_1_100, OnUpdateViewRes1_100 )
	ON_COMMAND(ID_VIEW_ZOOM_OUT, OnViewZoomOut)
	ON_COMMAND(ID_VIEW_HIGHLIGHT, OnViewHighlight)
	ON_UPDATE_COMMAND_UI(ID_VIEW_HIGHLIGHT, OnUpdateViewHighlight)
	ON_COMMAND(ID_VIEW_HYPERLINK, OnViewHyperlink)
	ON_UPDATE_COMMAND_UI(ID_VIEW_HYPERLINK, OnUpdateViewHyperlink)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ANNOTATION, OnUpdateViewAnnotation)
	ON_COMMAND(ID_VIEW_ANNOTATION, OnViewAnnotation)
	ON_COMMAND(ID_EDIT_CLEARANNOTATIONLIST, OnEditClearannotationlist)
	ON_COMMAND(ID_EDIT_CLEARHIGHLIGHTLIST, OnEditClearhighlightlist)
	ON_COMMAND(ID_EDIT_CLEARHYPERLINK, OnEditClearhyperlink)
	ON_COMMAND(ID_EDIT_ADDITEM, OnEditAdditem)
	ON_COMMAND(ID_EDIT_ANNOTATIONFROMFILE, OnEditAnnotationfromfile)
	ON_COMMAND(ID_EDIT_ANNOTATIONTOFILE, OnEditAnnotationtofile)
	ON_COMMAND(ID_EDIT_OPTIONS, OnEditOptions)
	ON_COMMAND(ID_FILE_OPENPRINTJOB, OnFileOpenprintjob)
	ON_COMMAND(ID_FILE_CLOSEPRINTJOB, OnFileCloseprintjob)
	ON_COMMAND(ID_FILE_PRINTONEJOB, OnFilePrintonejob)
	ON_COMMAND(ID_VIEW_PAGE_FIRST, OnViewPageFirst)
	ON_COMMAND(ID_VIEW_PAGE_LAST, OnViewPageLast)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PAGE_FIRST, OnUpdateViewPageFirst)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PAGE_LAST, OnUpdateViewPageLast)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PAGE_PREV, OnUpdateViewPagePrev)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PAGE_NEXT, OnUpdateViewPageNext)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_IN, OnUpdateViewZoomIn)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_OUT, OnUpdateViewZoomOut)
	ON_COMMAND(ID_VIEW_ROTATE_CW, OnViewRotateCw)
	ON_COMMAND(ID_VIEW_ZOOM_100, OnViewZoom100)
	ON_COMMAND(ID_VIEW_ZOOM_125, OnViewZoom125)
	ON_COMMAND(ID_VIEW_ZOOM_150, OnViewZoom150)
	ON_COMMAND(ID_VIEW_ZOOM_200, OnViewZoom200)
	ON_COMMAND(ID_VIEW_ZOOM_50, OnViewZoom50)
	ON_COMMAND(ID_VIEW_ZOOM_75, OnViewZoom75)
	ON_CBN_SELCHANGE(IDC_PAGELIST, OnSelchangePagelist)
	ON_CBN_KILLFOCUS(IDC_PAGELIST, OnKillfocusPagelist)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_100, OnUpdateViewZoom100)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_125, OnUpdateViewZoom125)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_150, OnUpdateViewZoom150)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_200, OnUpdateViewZoom200)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_50, OnUpdateViewZoom50)
	ON_UPDATE_COMMAND_UI(ID_VIEW_ZOOM_75, OnUpdateViewZoom75)
	//}}AFX_MSG_MAP
    // Standard printing commands
    //ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
    ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDigiviewerView construction/destruction

CDigiviewerView::CDigiviewerView( void )
{
}

CDigiviewerView::~CDigiviewerView( void ) { }

BOOL CDigiviewerView::PreCreateWindow(CREATESTRUCT& cs)
{
    // TODO: Modify the Window class or styles here by modifying
    //  the CREATESTRUCT cs

    return CView::PreCreateWindow(cs);
}

BOOL CDigiviewerView::
Create( LPCTSTR          lpszClassName, 
        LPCTSTR          lpszWindowName,
        DWORD            dwStyle,
        const RECT     & rect,
        CWnd           * pParentWnd,
        UINT             nID,
        CCreateContext * pContext )
{
    return CWnd::Create( lpszClassName,
                         lpszWindowName,
                         dwStyle,
                         rect,
                         pParentWnd,
                         nID,
                         pContext);
}

/////////////////////////////////////////////////////////////////////////////
// CDigiviewerView drawing

void CDigiviewerView::OnDraw( CDC * /*pDC*/ ) { }

/////////////////////////////////////////////////////////////////////////////
// CDigiviewerView printing

BOOL CDigiviewerView::OnPreparePrinting( CPrintInfo * pInfo )
{
    // default preparation
    return DoPreparePrinting(pInfo);
}

void CDigiviewerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add extra initialization before printing
}

void CDigiviewerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
    // TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDigiviewerView diagnostics

#ifdef _DEBUG
void CDigiviewerView::AssertValid( void ) const
{
    CView::AssertValid();
}

void CDigiviewerView::Dump( CDumpContext & dc) const
{
    CView::Dump(dc);
}

// non-debug version is inline
CDigiviewerDoc* CDigiviewerView::GetDocument( void )
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDigiviewerDoc)));
    return (CDigiviewerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDigiviewerView message handlers

CDixie * CDigiviewerView::getDixie( void )
{
    CDigiviewerDoc * pMyDoc = GetDocument();

    return pMyDoc? &(pMyDoc->m_dixie) : NULL;
}

int CDigiviewerView::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
    if( CView::OnCreate(lpCreateStruct) == -1 )
    {
        return -1;
    }
        
    const CRect rect(0,0,0,0);
        
    CDixie * const pDixie = getDixie();
    assert( pDixie );  //JBTODO:  Figure out if this is right.

    pDixie->Create(NULL, WS_VISIBLE, rect, this, ID_DIXIE_CTRL);
                
    return 0;
}

void CDigiviewerView::OnFilePrint( void )
{
    CDixie * const pDixie = getDixie();
    
    if( pDixie )
    {
        CString file = pDixie->GetM_file();

        if( file != _T("") )
        {
            pDixie->printFile( file );
        }
    }
}

void CDigiviewerView::OnFileSave( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        CString file = pDixie->GetM_file();
    
        if( file != _T("") )
        {
            pDixie->saveFile( file );
        }
    }
}

void CDigiviewerView::OnInitialUpdate( void ) 
{
    // Save the status bar pointer in a static variable.
    // JBTODO:  Is this the cleanest way to do this?
    CMainFrame *pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
    pStatus = &pFrame->m_wndStatusBar;
    
    OnViewZoomFittopage();

    CView::OnInitialUpdate();
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
//
// Zoom-Related stuff.
//
//
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CDigiviewerView::setPixelRatio( double ratio )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        if( (m_minRes <= ratio) && (ratio <= m_maxRes) )            
        {
            pDixie->zoom( ratio, ratio );           
        }
    }
}

bool CDigiviewerView::pixelRatioIs( double ratio )
{
    CDixie * const pDixie = getDixie();

    bool retVal = false;

    if( pDixie )
    {
        double xZoom = pDixie->GetZoomX();
        double yZoom = pDixie->GetZoomY();

        retVal = ((xZoom == yZoom) && (xZoom == ratio));
    }

    return retVal;
}

bool CDigiviewerView::pixelRatioIsNear( double ratio )
{
    CDixie * const pDixie = getDixie();

    bool retVal = false;

    if( pDixie )
    {
        const double xZoom = pDixie->GetZoomX();
        const double yZoom = pDixie->GetZoomY();

        const double xZ_yZ = xZoom / yZoom;

        if( fabs(1 - xZ_yZ) < 0.01 )
        {
            const double r_xZ = ratio / xZoom;

            retVal = (fabs(1 - r_xZ) < 0.01);
        }
    }

    return retVal;
}

/****************
 *
 * Zoom in.
 *
 */

void CDigiviewerView::OnViewZoomIn( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        double xZoom = pDixie->GetZoomX() * 1.5;
        double yZoom = pDixie->GetZoomY() * 1.5;

        // Kluge to take care of rounding that happens inside
        // of Dixie.  Dixie truncates to nearest hundreth.
        xZoom = std::_cpp_max( xZoom, m_minRes * 2 );
        yZoom = std::_cpp_max( yZoom, m_minRes * 2 );

        xZoom = std::_cpp_min( xZoom, m_maxRes );
        yZoom = std::_cpp_min( yZoom, m_maxRes );

        pDixie->zoom( xZoom, yZoom );
    }
}

/****************
 *
 * Zoom out.
 *
 */

void CDigiviewerView::OnViewZoomOut( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        double xZoom = pDixie->GetZoomX() / 1.5;
        double yZoom = pDixie->GetZoomY() / 1.5;

        xZoom = std::_cpp_max( xZoom, m_minRes );
        yZoom = std::_cpp_max( yZoom, m_minRes );

        pDixie->zoom( xZoom, yZoom );
    }
}

void CDigiviewerView::OnViewZoomFittowidth( void )
{ 
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        const long dispWidth = pDixie->GetDispAreaWidth();
        const long pageWidth = pDixie->pageWidth();

        const double ratio = double(dispWidth)/double(pageWidth);

        HDC hDc = ::GetWindowDC( NULL );

        setPixelRatio( ratio );
    }
}

void CDigiviewerView::OnViewZoomFittopage ( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {        
        const long dispWidth  = pDixie->GetDispAreaWidth();
        const long dispHeight = pDixie->GetDispAreaHeight();

        const long pageWidth  = pDixie->pageWidth();
        const long pageHeight = pDixie->pageHeight();

        const double wRat = double(dispWidth )/double(pageWidth );
        const double hRat = double(dispHeight)/double(pageHeight);

        double ratio = std::_cpp_min( wRat, hRat );
               
        HDC hDc = ::GetWindowDC( NULL );

        setPixelRatio( ratio );
    }
}

void CDigiviewerView::OnViewRes1_100    ( void ) { setPixelRatio( 0.01 ); }
void CDigiviewerView::OnViewRes1_20     ( void ) { setPixelRatio( 0.05 ); }
void CDigiviewerView::OnViewRes1_10     ( void ) { setPixelRatio( 0.10 ); }
void CDigiviewerView::OnViewRes2_10     ( void ) { setPixelRatio( 0.20 ); }
void CDigiviewerView::OnViewRes3_10     ( void ) { setPixelRatio( 0.30 ); }
void CDigiviewerView::OnViewRes4_10     ( void ) { setPixelRatio( 0.40 ); }
void CDigiviewerView::OnViewRes5_10     ( void ) { setPixelRatio( 0.50 ); }
void CDigiviewerView::OnViewRes6_10     ( void ) { setPixelRatio( 0.60 ); }
void CDigiviewerView::OnViewRes7_10     ( void ) { setPixelRatio( 0.70 ); }
void CDigiviewerView::OnViewRes8_10     ( void ) { setPixelRatio( 0.80 ); }
void CDigiviewerView::OnViewRes9_10     ( void ) { setPixelRatio( 0.90 ); }
void CDigiviewerView::OnViewRes1_1      ( void ) { setPixelRatio( 1.00 ); }
void CDigiviewerView::OnViewRes2_1      ( void ) { setPixelRatio( 2.00 ); }
void CDigiviewerView::OnViewRes3_1      ( void ) { setPixelRatio( 3.00 ); }
void CDigiviewerView::OnViewRes4_1      ( void ) { setPixelRatio( 4.00 ); }
void CDigiviewerView::OnViewRes5_1      ( void ) { setPixelRatio( 5.00 ); }

void CDigiviewerView::OnUpdateViewRes1_100(CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.01 ));}
void CDigiviewerView::OnUpdateViewRes1_20 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.05 ));}
void CDigiviewerView::OnUpdateViewRes1_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.10 ));}
void CDigiviewerView::OnUpdateViewRes2_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.20 ));}
void CDigiviewerView::OnUpdateViewRes3_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.30 ));}
void CDigiviewerView::OnUpdateViewRes4_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.40 ));}
void CDigiviewerView::OnUpdateViewRes5_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.50 ));}
void CDigiviewerView::OnUpdateViewRes6_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.60 ));}
void CDigiviewerView::OnUpdateViewRes7_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.70 ));}
void CDigiviewerView::OnUpdateViewRes8_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.80 ));}
void CDigiviewerView::OnUpdateViewRes9_10 (CCmdUI *p) {p->SetCheck(pixelRatioIs( 0.90 ));}
void CDigiviewerView::OnUpdateViewRes1_1  (CCmdUI *p) {p->SetCheck(pixelRatioIs( 1.00 ));}
void CDigiviewerView::OnUpdateViewRes2_1  (CCmdUI *p) {p->SetCheck(pixelRatioIs( 2.00 ));}
void CDigiviewerView::OnUpdateViewRes3_1  (CCmdUI *p) {p->SetCheck(pixelRatioIs( 3.00 ));}
void CDigiviewerView::OnUpdateViewRes4_1  (CCmdUI *p) {p->SetCheck(pixelRatioIs( 4.00 ));}
void CDigiviewerView::OnUpdateViewRes5_1  (CCmdUI *p) {p->SetCheck(pixelRatioIs( 5.00 ));}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
//
// Orientation/Rotation-Related Stuff.
//
//
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

int CDigiviewerView::getRotateIndex( void )
{
    // Make up some default value.  If there is no Dixie, we
    // assume that there is no rotation.

    int index = 0;

    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        index = pDixie->GetRotateDegree();
    }

    return index;
}

/****************
 *
 * Communicate the new orietation to Dixie.
 *
 * @param index The new zoom index.  Allowed values are 0 through 3.
 *
 * <li> 0 original orientation.
 * <li> 1  90 degree counterclockwise.
 * <li> 2 180 degree counterclockwise.
 * <li> 3 270 degree counterclockwise.
 *
 * Passing a value that is out of range is an assertion failure.
 */

void CDigiviewerView::setRotateIndex( int index )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        assert( index >= 0 );
        assert( index <  4 );

        pDixie->rotatePage( index );
    }
}

/****************
*
* Rotate the image 90 degrees counterclockwise (left).
*
*/

void CDigiviewerView::OnViewRotate( void ) //JBTODO: Rename to OnViewRotateLeft()?
{
    setRotateIndex( (getRotateIndex()+1) % 4 );
}

void CDigiviewerView::OnViewRotateCw() 
{
    // +3 == -1 modulo 4.  Using -1 creates some ambiguity with compilers.
    // +3 is unambiguous.
    setRotateIndex( (getRotateIndex()+3) % 4 );
}

void CDigiviewerView::OnViewRotate0  ( void ) { setRotateIndex( 0 ); }
void CDigiviewerView::OnViewRotate90 ( void ) { setRotateIndex( 1 ); }
void CDigiviewerView::OnViewRotate180( void ) { setRotateIndex( 2 ); }
void CDigiviewerView::OnViewRotate270( void ) { setRotateIndex( 3 ); } 

void CDigiviewerView::OnUpdateViewRotate0  (CCmdUI *p) {p->SetCheck(getRotateIndex()==0);}
void CDigiviewerView::OnUpdateViewRotate90 (CCmdUI *p) {p->SetCheck(getRotateIndex()==1);}
void CDigiviewerView::OnUpdateViewRotate180(CCmdUI *p) {p->SetCheck(getRotateIndex()==2);}
void CDigiviewerView::OnUpdateViewRotate270(CCmdUI *p) {p->SetCheck(getRotateIndex()==3);}

//////////////////////////////////////////////////////////////////////////
// OnViewPage*() commands.

void CDigiviewerView::OnViewPageNext( void ) 
{       
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        if( pDixie->GetM_file() != _T("") )
        {
            int pageNumber = pDixie->GetPage();
            ++pageNumber;
                
            if( pageNumber <= pDixie->GetNumPages() )
            {
                pDixie->gotoPage(pageNumber);
                updateStatusBar();
            }
        }
    }
}

void CDigiviewerView::OnViewPagePrev( void ) 
{
    CDixie * const pDixie = getDixie();
    
    if( pDixie->GetM_file() != _T("") )
    {
        int pageNumber = pDixie->GetPage();
        --pageNumber;
                
        if( pageNumber >= 1 )
        {
            pDixie->gotoPage( pageNumber );
            updateStatusBar();
        }
    }
}

void CDigiviewerView::OnViewPageFirst() 
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        if( pDixie->GetM_file() != _T("") )
        {
            const int pageNumber = 1;
                
            if( pageNumber <= pDixie->GetNumPages() )
            {
                pDixie->gotoPage(pageNumber);
                updateStatusBar();
            }
        }
    }
}

void CDigiviewerView::OnViewPageLast() 
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        if( pDixie->GetM_file() != _T("") )
        {
            pDixie->gotoPage( pDixie->GetNumPages() );
            updateStatusBar();
        }
    }	
}

//////////////////////////////////////////////////////////////////////////
// OnViewPan*() commands.

void CDigiviewerView::OnViewPan( void )
{
    CDixie * const pDixie = getDixie();
    
    // JBTODO:  Should there be a "TogglePanMode()?"
    if( pDixie )
    {
        pDixie->SetPanMode( !(pDixie->GetPanMode()) );
    }
}

void CDigiviewerView::OnUpdateViewPan( CCmdUI * pCmdUI )
{
    CDixie * const pDixie = getDixie();
    
    // I use the !! operator since the type preturn by GetPanMode is
    // actuall "BOOL", not bool.  BOOL could be an int.
    if( pDixie )
    {
        pCmdUI->SetCheck( !!(pDixie->GetPanMode()) );
    }
}

//////////////////////////////////////////////////////////////////////////
// OnEdit*() commands

void CDigiviewerView::OnEditClearannotationlist( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        pDixie->ClearAnnotationList();
    }
}

void CDigiviewerView::OnEditClearhighlightlist( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        pDixie->ClearHighlightList();
    }
}

void CDigiviewerView::OnEditClearhyperlink( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        pDixie->ClearHyperlinkList();
    }
}

void CDigiviewerView::OnEditAdditem( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        CTestHighlight tdlg;
 
        if( tdlg.DoModal() == IDOK )
        {
            // We allocate 4 of each of these even though we may only need 1.
            COLORREF color[4];
            RECT      rect[4];

            // count defaults to 1, for the one rectangle below.
            int count = 1;

            rect [0].left   = tdlg.m_l;
            rect [0].top    = tdlg.m_t;
            rect [0].right  = tdlg.m_r;
            rect [0].bottom = tdlg.m_b;
            color[0]        = tdlg.m_color;

            // JBTODO:  I am not sure of the reason for m_duplicate.
            if( tdlg.m_duplicate == TRUE )
            {
                rect [1].left   = rect [0].right+1;
                rect [1].right  = rect [1].left+(rect[0].right - rect[0].left);
                rect [1].top    = rect [0].top;
                rect [1].bottom = rect [0].bottom;
                color[1]        = color[0];

                rect [2].left   = rect [0].left;
                rect [2].right  = rect [0].right;
                rect [2].top    = rect [0].bottom+1;
                rect [2].bottom = rect [2].top + (rect[0].bottom - rect[0].top);
                color[2]        = color[0];

                rect [3].left   = rect [0].right+1;
                rect [3].right  = rect [1].left+(rect[0].right - rect[0].left);
                rect [3].top    = rect [0].bottom+1;
                rect [3].bottom = rect [3].top + (rect[0].bottom - rect[0].top);
                color[3]        = color[0];

                // If we ended up in this block, count becomes 4 for the 3 extra
                // rectangles above.
                count = 4;
            }

            switch( tdlg.m_type )
            {
                case 0:
                pDixie->HighlightText((long *)rect, (long *)color, count, tdlg.m_pagenum, tdlg.m_content, true );
                break;
            
                case 1:
                pDixie->HighlightHyperlink((long *)rect, (long *)color, count, tdlg.m_pagenum, tdlg.m_content, true);
                break;
            
                case 2:
                pDixie->AddAnnotation((long *)&rect[0],tdlg.m_pagenum, tdlg.m_content, true);
                break;
        
                default: break;
            }
        }
    }
}

void CDigiviewerView::OnEditOptions( void )
{ 
    CDixie * const pDixie = getDixie();
 
    if( pDixie )
    {
        CDixie2Option dlg;

        dlg.m_hi_color        = pDixie->GetHighlightColor();
        dlg.m_hyp_color       = pDixie->GetHyperlinkColor();
        dlg.m_ann_color       = pDixie->GetAnnotateColor();
        dlg.m_annborder_color = pDixie->GetAnnotateBoundaryColor();
        dlg.m_ann_show        = pDixie->GetShowAnnotation();

        if( dlg.DoModal() == IDOK )
        {
            pDixie->SetHighlightColor       (dlg.m_hi_color       );
            pDixie->SetHyperlinkColor       (dlg.m_hyp_color      );
            pDixie->SetAnnotateColor        (dlg.m_ann_color      );
            pDixie->SetAnnotateBoundaryColor(dlg.m_annborder_color);
            pDixie->SetShowAnnotation       (dlg.m_ann_show       );
        }
    }
}

void CDigiviewerView::OnEditAnnotationfromfile( void )
{
    CDixie * const pDixie = getDixie();
 
    if( pDixie )
    {
        CFileDialog filedialog( true, 
                                _T("txt"),
                                NULL,
                                OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                                _T("Annotation Files(*.txt)|*.txt|"),
                                NULL );
    
        if(filedialog.DoModal() == IDOK)
        {
            CString filename = filedialog.GetPathName();
        
            if( filename != _T("") )
            {
                pDixie->AnnotationFromFile(filename);
            }
        }
    }
}

void CDigiviewerView::OnEditAnnotationtofile( void )
{
    CDixie * const pDixie = getDixie();
 
    if( pDixie )
    {
        CFileDialog filedialog( false, 
                                _T("txt"),
                                NULL,
                                OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                                _T("Annotation Files(*.txt)|*.txt|"),
                                NULL );
    
        if(filedialog.DoModal() == IDOK)
        {
            CString filename = filedialog.GetPathName();
        
            if( filename != _T("") )
            {
                pDixie->AnnotationToFile(filename);
            }
        }
    }   
}

void CDigiviewerView::OnSize( UINT nType, int cx, int cy ) 
{
    CView::OnSize( nType, cx, cy );

    CDixie * const pDixie = getDixie();
 
    if( pDixie )
    {
        CRect rect;
        GetClientRect(rect);
        pDixie->SetWindowPos( NULL, 0, 0, 
                              rect.right  - rect.left,
                              rect.bottom - rect.top,
                              SWP_SHOWWINDOW);
    }
}

void CDigiviewerView::updateStatusBar( void )
{
    CDixie * const pDixie = getDixie();

    if( pStatus && pDixie && (pDixie->GetNumPages() > 0) )
    {
        int page = pDixie->GetPage();

        if( page > 0 )
        {
            CString str;

            str.Format( _T("Page %d of %d"), page, pDixie->GetNumPages() );
            pStatus->SetPaneText( 1, str );

            CMainFrame * pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
            CComboBox  * pCombo = (CComboBox *)(pFrame->m_wndDlgBar.GetDlgItem(IDC_PAGELIST));
            pCombo->SetCurSel( page - 1 );
        }
        else
        {
            pStatus->SetPaneText( 1, _T("") );
        }
    }
}

void CDigiviewerView::
OnUpdate( CView * /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/ )
{
    CDixie * const pDixie = getDixie();

    if( pDixie && pDixie->GetM_file() != _T("") )
    {
        updatePageList();
        updateStatusBar();
    }
}

void CDigiviewerView::OnCloseupPagelist( void ) 
{
    CDixie * const pDixie = getDixie();
 
    if( pDixie )
    {
        // Although this seems sort of wierd at first glance, I think it
        // makes sense...
        //
        // What we do here is get the actual string that the page list combo
        // box used.  Thus, we force the pages shown in the combo box to be
        // the pages we go to.  The benefit is that what we see is what we
        // get.  The disadvantage is that this function is a bit convoluted.

        CMainFrame * pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
        CComboBox  * pCombo = (CComboBox *)(pFrame->m_wndDlgBar.GetDlgItem(IDC_PAGELIST));

        CString pageLabel;

        int item = pCombo->GetCurSel();

        // Get the label for the current sell in the pagelist combo box.

        if( item != CB_ERR )
        {
            pCombo->GetLBText( item, pageLabel );
        }
        
        // JBTODO: I'm not sure we need this if at all.  I think scanf() fails
        // gracefully.
        if( !pageLabel.IsEmpty() )     // If there was a string there...
        {
            // JBTODO: I'm not sure we should default the page number to 1 here.
            // Doing so mean that should something go wrong, we always go to page
            // 1.  I'm not sure if that is the right behavior.
            int pageNum = 1;  // If we cannot parse the page, then go to page 1.
                
            _stscanf( pageLabel, _T("%d"), &pageNum );
                
            // Test to make sure that this page we go is actually in our document.
            if( (pageNum <= pDixie->GetNumPages()) &&
                (pageNum >  0                    )  )
            {
                pDixie->gotoPage( pageNum );
                updateStatusBar();
            }
        }
    }
}

void CDigiviewerView::updatePageList( void )
{
    CMainFrame * pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
    CDialogBar * pBar   = &(pFrame->m_wndDlgBar);
    CComboBox  * pCombo = (CComboBox *)(pBar->GetDlgItem(IDC_PAGELIST));
        
    pCombo->ResetContent();

    CDixie * const pDixie = getDixie();

    if( pDixie && (pDixie->GetNumPages() > 0) )
    {
        for ( int i=1; i <= pDixie->GetNumPages(); i++ )
        {
            CString pageLabel;
            pageLabel.Format( _T("%d"), i );
            pCombo->AddString( pageLabel );
        }
    }
}


void CDigiviewerView::OnSelchangePagelist() 
{
    OnCloseupPagelist();
}


void CDigiviewerView::OnKillfocusPagelist() 
{
    CDixie * const pDixie = getDixie();
    
    if( pDixie )
    {

        CMainFrame * pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
        CComboBox  * pCombo = (CComboBox *)(pFrame->m_wndDlgBar.GetDlgItem(IDC_PAGELIST));

        CString text;

        pCombo->GetWindowText( text );


        int ind = pCombo->FindStringExact( -1, text );

        if( ind != CB_ERR )
        {
            pCombo->SetCurSel( ind );
            OnCloseupPagelist();
        }
        else
        {
            pCombo->SetCurSel( pDixie->GetPage() - 1);
        }

    }   
}

//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
//
// Highlight, Hyperlink, and Annotation Stuff.
//
//
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void CDigiviewerView::OnViewHighlight( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        pDixie->SetShowHighlight( !(pDixie->GetShowHighlight()) );
    }
}

void CDigiviewerView::OnViewHyperlink( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
       pDixie->SetShowHyperlink( !(pDixie->GetShowHyperlink()) );
    }
}

void CDigiviewerView::OnViewAnnotation( void )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        //At present, there are three states:
        //#define  ANNOTATIONNOSHOW    0
        //#define  ANNOTATIONUNDERLINE 1
        //#define  ANNOTATIONBORDER    2
        //JBTODO: We should make something more robust than a hard-coded %3 here.
    
        pDixie->SetShowAnnotation( (pDixie->GetShowAnnotation()+1) % 3 );     
    }
}

// I am using the booleanize (!!) "operator" to make sure that the output
// of each of the GetShow*() functions is truly 0 or 1.  The reason is that
// SetCheck() actually takes an int that can be 0, 1, or 2 legally, not a
// boolean.  For GetShowAnnotation() the need for this is obvious.  (It
// returns an integer value that can take on three states.  For the other
// two cases, this is just a safety precaution.  If, by some accident,
// BOOL is treated as int, then there is some danger that something other
// than 1 or 0 can come out.

void CDigiviewerView::OnUpdateViewHighlight( CCmdUI * pCmdUI )
{ 
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        pCmdUI->SetCheck( !!(pDixie->GetShowHighlight()) );
    }
}

void CDigiviewerView::OnUpdateViewHyperlink( CCmdUI * pCmdUI )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        pCmdUI->SetCheck( !!(pDixie->GetShowHyperlink()) );
    }
}

void CDigiviewerView::OnUpdateViewAnnotation( CCmdUI * pCmdUI )
{
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        pCmdUI->SetCheck( !!(pDixie->GetShowAnnotation()) );
    }
} 

BEGIN_EVENTSINK_MAP(CDigiviewerView, CView)
    //{{AFX_EVENTSINK_MAP(CTestHighlight)
        ON_EVENT(CDigiviewerView, ID_DIXIE_CTRL, 2 /* OnHyperlink */, OnOnHyperlinkDixiectrl, VTS_BSTR)
        ON_EVENT(CDigiviewerView, ID_DIXIE_CTRL, 1 /* OnHyperlink */, OnOnHighlightDixiectrl, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
        ON_EVENT(CDigiviewerView, ID_DIXIE_CTRL, 3 /* OnHyperlink */, OnOnAnnotationDixiectrl, VTS_BSTR)
    //}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDigiviewerView::OnOnHyperlinkDixiectrl( LPCTSTR linkString )
{
    MessageBox( linkString );
}

void CDigiviewerView::
OnOnHighlightDixiectrl( long top, long left, long bottom, long right )
{
// I wanted to disable this message box without removing code from Dixie.
// This effectively removes it.

#if 0

   CString loc;
   loc.Format( _T("(%ld, %ld)    (%ld, %ld)"), left, top, right, bottom );
   MessageBox( loc );     
#endif

}

void CDigiviewerView::OnOnAnnotationDixiectrl( LPCTSTR annotationString )
{
    MessageBox( annotationString );
}

void CDigiviewerView::OnFileOpenprintjob() 
{
    CDixie * const pDixie = getDixie();

    if( !pDixie || (pDixie->GetM_file() == _T("")) ) {return;}

    if( m_hDC ) return;

      PRINTDLG pd;
      int firstPage=0, lastPage=0;

      // Initialize the PRINTDLG members.  
      pd.lStructSize         = sizeof(PRINTDLG); 
      pd.hDevMode            = NULL; 
      pd.hDevNames           = NULL; 
      pd.Flags               = PD_RETURNDC | PD_NOSELECTION; 
      pd.hwndOwner           = NULL; // hwnd; 
      pd.hDC                 = NULL; 
      pd.nFromPage           = firstPage + 1; 
      pd.nToPage             = lastPage  + 1;
      pd.nMinPage            = firstPage + 1; 
      pd.nMaxPage            = lastPage  + 1; 
      pd.nCopies             = 1; 
      pd.hInstance           = NULL; 
      pd.lCustData           = 0L; 
      pd.lpfnPrintHook       = NULL; 
      pd.lpfnSetupHook       = NULL; 
      pd.lpPrintTemplateName = NULL; 
      pd.lpSetupTemplateName = NULL; 
      pd.hPrintTemplate      = NULL; 
      pd.hSetupTemplate      = NULL;
     // Display the PRINT dialog box.  
      if(!PrintDlg(&pd)) {
          return;
      }

      if (pd.Flags & PD_PAGENUMS) {
        firstPage = pd.nFromPage - 1;
        lastPage = pd.nToPage - 1;
      }
      m_hDC = pd.hDC;
      pd.hDC = NULL;
      if(pd.hDevMode != NULL) GlobalFree(pd.hDevMode);
      if(pd.hDevNames != NULL) GlobalFree(pd.hDevNames);
      if(pDixie->printOpen( _T("test"), (long)m_hDC) == 0) m_hDC = NULL;
	
}

void CDigiviewerView::OnFileCloseprintjob( void )
{
    if( m_hDC )
    {
        CDixie * const pDixie = getDixie();

        if( pDixie )
        {
            pDixie->printClose( long(m_hDC) );
        }
    }

    m_hDC = NULL;
}

void CDigiviewerView::OnFilePrintonejob( void ) 
{
    if( m_hDC )
    {
        CDixie * const pDixie = getDixie();

        if( pDixie )
        {
            // JBTODO:  Should this be checking to see if there is a
            // file here?
            pDixie->printPageTo( pDixie->GetM_file() );
        }
    }
}

void CDigiviewerView::OnUpdateViewPageFirst( CCmdUI * pCmdUI )
{
    CDixie * const pDixie = getDixie();

    bool enable = false;

    if( pDixie )
    {
        if( pDixie->GetM_file() != _T("") )
        {
            const int pageNumber = pDixie->GetPage();
                
            enable = (pageNumber > 1);
        }
    }

    pCmdUI->Enable( enable );
}

void CDigiviewerView::OnUpdateViewPageLast(CCmdUI* pCmdUI) 
{	
    CDixie * const pDixie = getDixie();

    bool enable = false;

    if( pDixie )
    {
        if( pDixie->GetM_file() != _T("") )
        {
            const int pageNumber = pDixie->GetPage();
                
            const int numPages = pDixie->GetNumPages();
            
            enable = ((pageNumber >= 1) && (pageNumber < numPages));
        }
    }

    pCmdUI->Enable( enable );
}

void CDigiviewerView::OnUpdateViewPagePrev(CCmdUI* pCmdUI) 
{	
    OnUpdateViewPageFirst( pCmdUI );
}

void CDigiviewerView::OnUpdateViewPageNext(CCmdUI* pCmdUI) 
{
    OnUpdateViewPageLast( pCmdUI );	
}

void CDigiviewerView::OnUpdateViewZoomIn( CCmdUI* pCmdUI )
{	
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        const double xZoom = pDixie->GetZoomX();
        const double yZoom = pDixie->GetZoomY();

        double zoom = std::_cpp_min( xZoom, yZoom );

        pCmdUI->Enable( zoom < m_maxRes );
    }
    else
    {
        pCmdUI->Enable( false );
    }
}

void CDigiviewerView::OnUpdateViewZoomOut(CCmdUI* pCmdUI) 
{	
    CDixie * const pDixie = getDixie();

    if( pDixie )
    {
        const double xZoom = pDixie->GetZoomX();
        const double yZoom = pDixie->GetZoomY();

        double zoom = std::_cpp_max( xZoom, yZoom );
    
        pCmdUI->Enable( zoom > m_minRes );
    }
    else
    {
        pCmdUI->Enable( false );
    }
}


void CDigiviewerView::doOnUpdateViewZoom( double zoom, CCmdUI * pCmdUI )
{
    CDixie * const pDixie = getDixie();

    zoom /= 100.0;

    if( pDixie )
    {
        long width = std::_cpp_min( pDixie->pageWidth(), pDixie->pageHeight() );

        if( width >= 1 )
        {
            // Get the drawing context for the root window.
            HDC hDc = ::GetWindowDC( NULL );

            const double scrPixPerInch = GetDeviceCaps( hDc, LOGPIXELSX );

            double pagePixSize = 8.5 / double(width);

            pCmdUI->SetCheck( pixelRatioIsNear( zoom * pagePixSize * scrPixPerInch ) );
        }
    }
}

void CDigiviewerView::OnUpdateViewZoom100(CCmdUI* pCmdUI) {doOnUpdateViewZoom( 100, pCmdUI );}
void CDigiviewerView::OnUpdateViewZoom125(CCmdUI* pCmdUI) {doOnUpdateViewZoom( 125, pCmdUI );}
void CDigiviewerView::OnUpdateViewZoom150(CCmdUI* pCmdUI) {doOnUpdateViewZoom( 150, pCmdUI );}
void CDigiviewerView::OnUpdateViewZoom200(CCmdUI* pCmdUI) {doOnUpdateViewZoom( 200, pCmdUI );}
void CDigiviewerView::OnUpdateViewZoom50 (CCmdUI* pCmdUI) {doOnUpdateViewZoom(  50, pCmdUI );}
void CDigiviewerView::OnUpdateViewZoom75 (CCmdUI* pCmdUI) {doOnUpdateViewZoom(  75, pCmdUI );}


// JBTODO-- Currently, we assume the page is 8.5 inches wide, and the
// dot pitch on the monitor is .25.  We can do better.
void CDigiviewerView::doOnViewZoom( double zoom )
{
    CDixie * const pDixie = getDixie();

    zoom /= 100.0;

    if( pDixie )
    {
        long width = std::_cpp_min( pDixie->pageWidth(), pDixie->pageHeight() );

        if( width >= 1 )
        {
            // Get the drawing context for the root window.
            HDC hDc = ::GetWindowDC( NULL );

            const double scrPixPerInch = GetDeviceCaps( hDc, LOGPIXELSX );

            double pagePixSize = 8.5 / double(width);

            setPixelRatio( zoom * pagePixSize * scrPixPerInch );
        }
    }
}

void CDigiviewerView::OnViewZoom200( void ) {doOnViewZoom( 200 );}
void CDigiviewerView::OnViewZoom150( void ) {doOnViewZoom( 150 );}
void CDigiviewerView::OnViewZoom125( void ) {doOnViewZoom( 125 );}
void CDigiviewerView::OnViewZoom100( void ) {doOnViewZoom( 100 );}
void CDigiviewerView::OnViewZoom75 ( void ) {doOnViewZoom(  75 );}
void CDigiviewerView::OnViewZoom50 ( void ) {doOnViewZoom(  50 );}