// DigiviewerView.h : interface of the CDigiviewerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIGIVIEWERVIEW_H__890C7D5F_26BC_11D4_80CD_00C04F603782__INCLUDED_)
#define AFX_DIGIVIEWERVIEW_H__890C7D5F_26BC_11D4_80CD_00C04F603782__INCLUDED_

#include "dixie.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CDigiviewerView : public CView
{
protected: // create from serialization only
    CDigiviewerView();
    DECLARE_DYNCREATE(CDigiviewerView)
    void OnHighperlink(LPCTSTR string);

// Attributes
public:

    CDigiviewerDoc * GetDocument( void );
    
    CDixie * getDixie( void );

// Operations
public:

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CDigiviewerView)
    public:
    virtual void OnDraw(CDC* pDC);  // overridden to draw this view
    virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
    virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
    virtual void OnInitialUpdate();
    protected:
    virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
    virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
    virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
    virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);

    //}}AFX_VIRTUAL

    // Implementation

private:
    
    const static double m_maxRes;
    const static double m_minRes;

    // The table of preset zoom values and the size of said table.
    const static double m_zoomTable[];
    const static size_t m_zoomTableSize;

    void setPixelRatio( double );
    bool pixelRatioIs( double );
    bool pixelRatioIsNear( double );

    void doOnViewZoom      ( double zoom );
    void doOnUpdateViewZoom( double zoom, CCmdUI * pCmdUI );

    // index can only take on the values 0-3.
    //
    // -- 0 indicates no rotation.
    // -- 1 indicates a  90 degree counterclockwise rotation.
    // -- 2 indicates a 180 degree counterclockwise rotation.
    // -- 3 indicates a 270 degree counterclockwise rotation.
    void setRotateIndex( int index );

public:
    
    virtual ~CDigiviewerView( void );
    
    int getRotateIndex( void );

    HDC m_hDC;

#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:
    void updateStatusBar();
    void updatePageList();
// Generated message map functions
protected:
    //{{AFX_MSG(CDigiviewerView)
	afx_msg void OnFilePrint();
	afx_msg void OnFileSave();
    afx_msg void OnViewRes5_1();
    afx_msg void OnViewRes4_1();
    afx_msg void OnViewRes3_1();
    afx_msg void OnViewRes2_1();
    afx_msg void OnViewRes1_1();
    afx_msg void OnViewRes1_10();
    afx_msg void OnViewRes2_10();
    afx_msg void OnViewRes3_10();
    afx_msg void OnViewRes4_10();
    afx_msg void OnViewRes5_10();
    afx_msg void OnViewRes6_10();
    afx_msg void OnViewRes7_10();
    afx_msg void OnViewRes8_10();
    afx_msg void OnViewRes9_10();
    afx_msg void OnViewRes1_20();
    afx_msg void OnViewRes1_100();
    afx_msg void OnViewZoomFittopage();
    afx_msg void OnViewZoomFittowidth();
    afx_msg void OnViewRotate270();
    afx_msg void OnViewRotate90();
    afx_msg void OnViewRotate180();
    afx_msg void OnViewRotate0();
    afx_msg void OnViewPageNext();
    afx_msg void OnViewPagePrev();
    afx_msg void OnViewPan();
    afx_msg void OnViewRotate();
    afx_msg void OnViewZoomIn();
    afx_msg void OnUpdateViewPan(CCmdUI* pCmdUI);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnCloseupPagelist();
    afx_msg void OnUpdateViewRotate0(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRotate180(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRotate270(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRotate90(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes5_1 (CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes4_1 (CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes3_1 (CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes2_1 (CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes1_1 (CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes1_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes2_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes3_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes4_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes5_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes6_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes7_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes8_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes9_10(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes1_20(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewRes1_100(CCmdUI* pCmdUI);
    afx_msg void OnViewZoomOut();
    afx_msg void OnViewHighlight();
    afx_msg void OnUpdateViewHighlight(CCmdUI* pCmdUI);
    afx_msg void OnViewHyperlink();
    afx_msg void OnUpdateViewHyperlink(CCmdUI* pCmdUI);
    afx_msg void OnUpdateViewAnnotation(CCmdUI* pCmdUI);
    afx_msg void OnViewAnnotation();
    afx_msg void OnEditClearannotationlist();
    afx_msg void OnEditClearhighlightlist();
    afx_msg void OnEditClearhyperlink();
    afx_msg void OnEditAdditem();
    afx_msg void OnOnHyperlinkDixiectrl(LPCTSTR linkString);
    afx_msg void OnOnHighlightDixiectrl(long top, long left, long bottom, long right) ;
    afx_msg void OnOnAnnotationDixiectrl(LPCTSTR linkString);
    afx_msg void OnEditAnnotationfromfile();
    afx_msg void OnEditAnnotationtofile();
    afx_msg void OnEditOptions();
    afx_msg void OnFileOpenprintjob();
    afx_msg void OnFileCloseprintjob();
    afx_msg void OnFilePrintonejob();
	afx_msg void OnViewPageFirst();
	afx_msg void OnViewPageLast();
	afx_msg void OnUpdateViewPageFirst(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewPageLast(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewPagePrev(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewPageNext(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoomIn(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoomOut(CCmdUI* pCmdUI);
	afx_msg void OnViewRotateCw();
	afx_msg void OnViewZoom100();
	afx_msg void OnViewZoom125();
	afx_msg void OnViewZoom150();
	afx_msg void OnViewZoom200();
	afx_msg void OnViewZoom50();
	afx_msg void OnViewZoom75();
	afx_msg void OnSelchangePagelist();
	afx_msg void OnKillfocusPagelist();
	afx_msg void OnUpdateViewZoom100(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoom125(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoom150(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoom200(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoom50(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoom75(CCmdUI* pCmdUI);
    DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DigiviewerView.cpp
inline CDigiviewerDoc* CDigiviewerView::GetDocument()
   { return (CDigiviewerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DIGIVIEWERVIEW_H__890C7D5F_26BC_11D4_80CD_00C04F603782__INCLUDED_)
