/*
 * JBIG2 standard Huffman tables built by $Header: /project/icons/cvsroot/digipaper/tools/libjbig2.help/compile-stdhuff.c,v 1.5 2002/10/17 22:43:32 jlin Exp $
 */
#include "util.h"
#include "hufftable.h"
DGP_RCSID("@(#)JBIG2 standard Huffman tables built by $Header: /project/icons/cvsroot/digipaper/tools/libjbig2.help/compile-stdhuff.c,v 1.5 2002/10/17 22:43:32 jlin Exp $");
static table_line stdhuffA_lines[4] = {
    { 00000,     0,  1,  4 },
    { 0x002,    16,  2,  8 },
    { 0x006,   272,  3, 16 },
    { 0x007, 65808,  3, 32 } 
    };
static void * stdhuffA_lineptrs[4] = {
    (void *)&stdhuffA_lines[0], (void *)&stdhuffA_lines[1],
    (void *)&stdhuffA_lines[2], (void *)&stdhuffA_lines[3]
    };
hufftable_spec stdhuffA = {
    DGP_FALSE, DGP_TRUE, DGP_FALSE,
    4, stdhuffA_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x6,
	      0x10,       0x20,       0x40,       0x80,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x2,        0x7,
	       0xf,       0x1f,       0x3f,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffA_lineptrs[0], &stdhuffA_lineptrs[0],
	&stdhuffA_lineptrs[1], &stdhuffA_lineptrs[2],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4],
	&stdhuffA_lineptrs[4], &stdhuffA_lineptrs[4]
	}
    };

static table_line stdhuffDW1_lines[7] = {
    { 00000,     0,  1,  0 },
    { 0x002,     1,  2,  0 },
    { 0x006,     2,  3,  0 },
    { 0x00e,     3,  4,  3 },
    { 0x01e,    11,  5,  6 },
    { 0x03e,    75,  6, 32 },
    { 0x03f,     0,  6,  0 } 
    };
static void * stdhuffDW1_lineptrs[7] = {
    (void *)&stdhuffDW1_lines[0], (void *)&stdhuffDW1_lines[1],
    (void *)&stdhuffDW1_lines[2], (void *)&stdhuffDW1_lines[3],
    (void *)&stdhuffDW1_lines[4], (void *)&stdhuffDW1_lines[5],
    (void *)&stdhuffDW1_lines[6]
    };
hufftable_spec stdhuffDW1 = {
    DGP_FALSE, DGP_TRUE, DGP_TRUE,
    7, stdhuffDW1_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1e,       0x3e,       0x80,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1e,       0x3f,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDW1_lineptrs[0], &stdhuffDW1_lineptrs[0],
	&stdhuffDW1_lineptrs[1], &stdhuffDW1_lineptrs[2],
	&stdhuffDW1_lineptrs[3], &stdhuffDW1_lineptrs[4],
	&stdhuffDW1_lineptrs[5], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7],
	&stdhuffDW1_lineptrs[7], &stdhuffDW1_lineptrs[7]
	}
    };

static table_line stdhuffDW2_lines[9] = {
    { 0x0fe,  -256,  8,  8 },
    { 00000,     0,  1,  0 },
    { 0x002,     1,  2,  0 },
    { 0x006,     2,  3,  0 },
    { 0x00e,     3,  4,  3 },
    { 0x01e,    11,  5,  6 },
    { 0x0ff,  -257,  8, 32 },
    { 0x07e,    75,  7, 32 },
    { 0x03e,     0,  6,  0 } 
    };
static void * stdhuffDW2_lineptrs[9] = {
    (void *)&stdhuffDW2_lines[1], (void *)&stdhuffDW2_lines[2],
    (void *)&stdhuffDW2_lines[3], (void *)&stdhuffDW2_lines[4],
    (void *)&stdhuffDW2_lines[5], (void *)&stdhuffDW2_lines[8],
    (void *)&stdhuffDW2_lines[7], (void *)&stdhuffDW2_lines[0],
    (void *)&stdhuffDW2_lines[6]
    };
hufftable_spec stdhuffDW2 = {
    DGP_TRUE, DGP_TRUE, DGP_TRUE,
    9, stdhuffDW2_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1e,       0x3e,       0x7e,
	      0xfe,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1e,       0x3e,       0x7e,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDW2_lineptrs[0], &stdhuffDW2_lineptrs[0],
	&stdhuffDW2_lineptrs[1], &stdhuffDW2_lineptrs[2],
	&stdhuffDW2_lineptrs[3], &stdhuffDW2_lineptrs[4],
	&stdhuffDW2_lineptrs[5], &stdhuffDW2_lineptrs[6],
	&stdhuffDW2_lineptrs[7], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9],
	&stdhuffDW2_lineptrs[9], &stdhuffDW2_lineptrs[9]
	}
    };

static table_line stdhuffDH1_lines[6] = {
    { 00000,     1,  1,  0 },
    { 0x002,     2,  2,  0 },
    { 0x006,     3,  3,  0 },
    { 0x00e,     4,  4,  3 },
    { 0x01e,    12,  5,  6 },
    { 0x01f,    76,  5, 32 } 
    };
static void * stdhuffDH1_lineptrs[6] = {
    (void *)&stdhuffDH1_lines[0], (void *)&stdhuffDH1_lines[1],
    (void *)&stdhuffDH1_lines[2], (void *)&stdhuffDH1_lines[3],
    (void *)&stdhuffDH1_lines[4], (void *)&stdhuffDH1_lines[5]
    };
hufftable_spec stdhuffDH1 = {
    DGP_FALSE, DGP_TRUE, DGP_FALSE,
    6, stdhuffDH1_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1e,       0x40,       0x80,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1f,       0x3f,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDH1_lineptrs[0], &stdhuffDH1_lineptrs[0],
	&stdhuffDH1_lineptrs[1], &stdhuffDH1_lineptrs[2],
	&stdhuffDH1_lineptrs[3], &stdhuffDH1_lineptrs[4],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6],
	&stdhuffDH1_lineptrs[6], &stdhuffDH1_lineptrs[6]
	}
    };

static table_line stdhuffDH2_lines[8] = {
    { 0x07e,  -255,  7,  8 },
    { 00000,     1,  1,  0 },
    { 0x002,     2,  2,  0 },
    { 0x006,     3,  3,  0 },
    { 0x00e,     4,  4,  3 },
    { 0x01e,    12,  5,  6 },
    { 0x07f,  -256,  7, 32 },
    { 0x03e,    76,  6, 32 } 
    };
static void * stdhuffDH2_lineptrs[8] = {
    (void *)&stdhuffDH2_lines[1], (void *)&stdhuffDH2_lines[2],
    (void *)&stdhuffDH2_lines[3], (void *)&stdhuffDH2_lines[4],
    (void *)&stdhuffDH2_lines[5], (void *)&stdhuffDH2_lines[7],
    (void *)&stdhuffDH2_lines[0], (void *)&stdhuffDH2_lines[6]
    };
hufftable_spec stdhuffDH2 = {
    DGP_TRUE, DGP_TRUE, DGP_FALSE,
    8, stdhuffDH2_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1e,       0x3e,       0x7e,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1e,       0x3e,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDH2_lineptrs[0], &stdhuffDH2_lineptrs[0],
	&stdhuffDH2_lineptrs[1], &stdhuffDH2_lineptrs[2],
	&stdhuffDH2_lineptrs[3], &stdhuffDH2_lineptrs[4],
	&stdhuffDH2_lineptrs[5], &stdhuffDH2_lineptrs[6],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8],
	&stdhuffDH2_lineptrs[8], &stdhuffDH2_lineptrs[8]
	}
    };

static table_line stdhuffFS1_lines[14] = {
    { 0x01c, -2048,  5, 10 },
    { 0x008, -1024,  4,  9 },
    { 0x009,  -512,  4,  8 },
    { 0x00a,  -256,  4,  7 },
    { 0x01d,  -128,  5,  6 },
    { 0x01e,   -64,  5,  5 },
    { 0x00b,   -32,  4,  5 },
    { 00000,     0,  2,  7 },
    { 0x002,   128,  3,  7 },
    { 0x003,   256,  3,  8 },
    { 0x00c,   512,  4,  9 },
    { 0x00d,  1024,  4, 10 },
    { 0x03e, -2049,  6, 32 },
    { 0x03f,  2048,  6, 32 } 
    };
static void * stdhuffFS1_lineptrs[14] = {
    (void *)&stdhuffFS1_lines[7], (void *)&stdhuffFS1_lines[8],
    (void *)&stdhuffFS1_lines[9], (void *)&stdhuffFS1_lines[1],
    (void *)&stdhuffFS1_lines[2], (void *)&stdhuffFS1_lines[3],
    (void *)&stdhuffFS1_lines[6], (void *)&stdhuffFS1_lines[10],
    (void *)&stdhuffFS1_lines[11], (void *)&stdhuffFS1_lines[0],
    (void *)&stdhuffFS1_lines[4], (void *)&stdhuffFS1_lines[5],
    (void *)&stdhuffFS1_lines[12], (void *)&stdhuffFS1_lines[13]
    };
hufftable_spec stdhuffFS1 = {
    DGP_TRUE, DGP_TRUE, DGP_FALSE,
    14, stdhuffFS1_lines, 2, DGP_TRUE,
    {
	         0,          0,          0,        0x2,
	       0x8,       0x1c,       0x3e,       0x80,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0, 0xffffffff,          0,        0x3,
	       0xd,       0x1e,       0x3f,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffFS1_lineptrs[0], &stdhuffFS1_lineptrs[0],
	&stdhuffFS1_lineptrs[0], &stdhuffFS1_lineptrs[1],
	&stdhuffFS1_lineptrs[3], &stdhuffFS1_lineptrs[9],
	&stdhuffFS1_lineptrs[12], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14],
	&stdhuffFS1_lineptrs[14], &stdhuffFS1_lineptrs[14]
	}
    };

static table_line stdhuffFS2_lines[15] = {
    { 0x008, -1024,  4,  9 },
    { 00000,  -512,  3,  8 },
    { 0x009,  -256,  4,  7 },
    { 0x01a,  -128,  5,  6 },
    { 0x01b,   -64,  5,  5 },
    { 0x00a,   -32,  4,  5 },
    { 0x00b,     0,  4,  5 },
    { 0x01c,    32,  5,  5 },
    { 0x01d,    64,  5,  6 },
    { 0x00c,   128,  4,  7 },
    { 0x001,   256,  3,  8 },
    { 0x002,   512,  3,  9 },
    { 0x003,  1024,  3, 10 },
    { 0x01e, -1025,  5, 32 },
    { 0x01f,  2048,  5, 32 } 
    };
static void * stdhuffFS2_lineptrs[15] = {
    (void *)&stdhuffFS2_lines[1], (void *)&stdhuffFS2_lines[10],
    (void *)&stdhuffFS2_lines[11], (void *)&stdhuffFS2_lines[12],
    (void *)&stdhuffFS2_lines[0], (void *)&stdhuffFS2_lines[2],
    (void *)&stdhuffFS2_lines[5], (void *)&stdhuffFS2_lines[6],
    (void *)&stdhuffFS2_lines[9], (void *)&stdhuffFS2_lines[3],
    (void *)&stdhuffFS2_lines[4], (void *)&stdhuffFS2_lines[7],
    (void *)&stdhuffFS2_lines[8], (void *)&stdhuffFS2_lines[13],
    (void *)&stdhuffFS2_lines[14]
    };
hufftable_spec stdhuffFS2 = {
    DGP_TRUE, DGP_TRUE, DGP_FALSE,
    15, stdhuffFS2_lines, 3, DGP_TRUE,
    {
	         0,          0,          0,          0,
	       0x8,       0x1a,       0x40,       0x80,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0, 0xffffffff, 0xffffffff,        0x3,
	       0xc,       0x1f,       0x3f,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffFS2_lineptrs[0], &stdhuffFS2_lineptrs[0],
	&stdhuffFS2_lineptrs[0], &stdhuffFS2_lineptrs[0],
	&stdhuffFS2_lineptrs[4], &stdhuffFS2_lineptrs[9],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15],
	&stdhuffFS2_lineptrs[15], &stdhuffFS2_lineptrs[15]
	}
    };

static table_line stdhuffDS1_lines[21] = {
    { 0x0fc,   -15,  8,  3 },
    { 0x1fc,    -7,  9,  1 },
    { 0x0fd,    -5,  8,  1 },
    { 0x1fd,    -3,  9,  0 },
    { 0x07c,    -2,  7,  0 },
    { 0x00a,    -1,  4,  0 },
    { 00000,     0,  2,  1 },
    { 0x01a,     2,  5,  0 },
    { 0x03a,     3,  6,  0 },
    { 0x004,     4,  3,  4 },
    { 0x03b,    20,  6,  1 },
    { 0x00b,    22,  4,  4 },
    { 0x00c,    38,  4,  5 },
    { 0x01b,    70,  5,  6 },
    { 0x01c,   134,  5,  7 },
    { 0x03c,   262,  6,  7 },
    { 0x07d,   390,  7,  8 },
    { 0x03d,   646,  6, 10 },
    { 0x1fe,   -16,  9, 32 },
    { 0x1ff,  1670,  9, 32 },
    { 0x001,     0,  2,  0 } 
    };
static void * stdhuffDS1_lineptrs[21] = {
    (void *)&stdhuffDS1_lines[6], (void *)&stdhuffDS1_lines[20],
    (void *)&stdhuffDS1_lines[9], (void *)&stdhuffDS1_lines[5],
    (void *)&stdhuffDS1_lines[11], (void *)&stdhuffDS1_lines[12],
    (void *)&stdhuffDS1_lines[7], (void *)&stdhuffDS1_lines[13],
    (void *)&stdhuffDS1_lines[14], (void *)&stdhuffDS1_lines[8],
    (void *)&stdhuffDS1_lines[10], (void *)&stdhuffDS1_lines[15],
    (void *)&stdhuffDS1_lines[17], (void *)&stdhuffDS1_lines[4],
    (void *)&stdhuffDS1_lines[16], (void *)&stdhuffDS1_lines[0],
    (void *)&stdhuffDS1_lines[2], (void *)&stdhuffDS1_lines[1],
    (void *)&stdhuffDS1_lines[3], (void *)&stdhuffDS1_lines[18],
    (void *)&stdhuffDS1_lines[19]
    };
hufftable_spec stdhuffDS1 = {
    DGP_TRUE, DGP_TRUE, DGP_TRUE,
    21, stdhuffDS1_lines, 2, DGP_TRUE,
    {
	         0,          0,          0,        0x4,
	       0xa,       0x1a,       0x3a,       0x7c,
	      0xfc,      0x1fc,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0, 0xffffffff,        0x1,        0x4,
	       0xc,       0x1c,       0x3d,       0x7d,
	      0xfd,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDS1_lineptrs[0], &stdhuffDS1_lineptrs[0],
	&stdhuffDS1_lineptrs[0], &stdhuffDS1_lineptrs[2],
	&stdhuffDS1_lineptrs[3], &stdhuffDS1_lineptrs[6],
	&stdhuffDS1_lineptrs[9], &stdhuffDS1_lineptrs[13],
	&stdhuffDS1_lineptrs[15], &stdhuffDS1_lineptrs[17],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21],
	&stdhuffDS1_lineptrs[21], &stdhuffDS1_lineptrs[21]
	}
    };

static table_line stdhuffDS2_lines[22] = {
    { 0x0fc,   -31,  8,  4 },
    { 0x1fc,   -15,  9,  2 },
    { 0x0fd,   -11,  8,  2 },
    { 0x1fd,    -7,  9,  1 },
    { 0x07c,    -5,  7,  1 },
    { 0x00a,    -3,  4,  1 },
    { 0x002,    -1,  3,  1 },
    { 0x003,     1,  3,  1 },
    { 0x01a,     3,  5,  1 },
    { 0x03a,     5,  6,  1 },
    { 0x004,     7,  3,  5 },
    { 0x03b,    39,  6,  2 },
    { 0x00b,    43,  4,  5 },
    { 0x00c,    75,  4,  6 },
    { 0x01b,   139,  5,  7 },
    { 0x01c,   267,  5,  8 },
    { 0x03c,   523,  6,  8 },
    { 0x07d,   779,  7,  9 },
    { 0x03d,  1291,  6, 11 },
    { 0x1fe,   -32,  9, 32 },
    { 0x1ff,  3339,  9, 32 },
    { 00000,     0,  2,  0 } 
    };
static void * stdhuffDS2_lineptrs[22] = {
    (void *)&stdhuffDS2_lines[21], (void *)&stdhuffDS2_lines[6],
    (void *)&stdhuffDS2_lines[7], (void *)&stdhuffDS2_lines[10],
    (void *)&stdhuffDS2_lines[5], (void *)&stdhuffDS2_lines[12],
    (void *)&stdhuffDS2_lines[13], (void *)&stdhuffDS2_lines[8],
    (void *)&stdhuffDS2_lines[14], (void *)&stdhuffDS2_lines[15],
    (void *)&stdhuffDS2_lines[9], (void *)&stdhuffDS2_lines[11],
    (void *)&stdhuffDS2_lines[16], (void *)&stdhuffDS2_lines[18],
    (void *)&stdhuffDS2_lines[4], (void *)&stdhuffDS2_lines[17],
    (void *)&stdhuffDS2_lines[0], (void *)&stdhuffDS2_lines[2],
    (void *)&stdhuffDS2_lines[1], (void *)&stdhuffDS2_lines[3],
    (void *)&stdhuffDS2_lines[19], (void *)&stdhuffDS2_lines[20]
    };
hufftable_spec stdhuffDS2 = {
    DGP_TRUE, DGP_TRUE, DGP_TRUE,
    22, stdhuffDS2_lines, 2, DGP_TRUE,
    {
	         0,          0,          0,        0x2,
	       0xa,       0x1a,       0x3a,       0x7c,
	      0xfc,      0x1fc,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0, 0xffffffff,          0,        0x4,
	       0xc,       0x1c,       0x3d,       0x7d,
	      0xfd,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDS2_lineptrs[0], &stdhuffDS2_lineptrs[0],
	&stdhuffDS2_lineptrs[0], &stdhuffDS2_lineptrs[1],
	&stdhuffDS2_lineptrs[4], &stdhuffDS2_lineptrs[7],
	&stdhuffDS2_lineptrs[10], &stdhuffDS2_lineptrs[14],
	&stdhuffDS2_lineptrs[16], &stdhuffDS2_lineptrs[18],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22],
	&stdhuffDS2_lineptrs[22], &stdhuffDS2_lineptrs[22]
	}
    };

static table_line stdhuffDS3_lines[21] = {
    { 0x07a,   -21,  7,  4 },
    { 0x0fc,    -5,  8,  0 },
    { 0x07b,    -4,  7,  0 },
    { 0x018,    -3,  5,  0 },
    { 00000,    -2,  2,  2 },
    { 0x019,     2,  5,  0 },
    { 0x036,     3,  6,  0 },
    { 0x07c,     4,  7,  0 },
    { 0x0fd,     5,  8,  0 },
    { 0x001,     6,  2,  6 },
    { 0x01a,    70,  5,  5 },
    { 0x037,   102,  6,  5 },
    { 0x038,   134,  6,  6 },
    { 0x039,   198,  6,  7 },
    { 0x03a,   326,  6,  8 },
    { 0x03b,   582,  6,  9 },
    { 0x03c,  1094,  6, 10 },
    { 0x07d,  2118,  7, 11 },
    { 0x0fe,   -22,  8, 32 },
    { 0x0ff,  4166,  8, 32 },
    { 0x002,     0,  2,  0 } 
    };
static void * stdhuffDS3_lineptrs[21] = {
    (void *)&stdhuffDS3_lines[4], (void *)&stdhuffDS3_lines[9],
    (void *)&stdhuffDS3_lines[20], (void *)&stdhuffDS3_lines[3],
    (void *)&stdhuffDS3_lines[5], (void *)&stdhuffDS3_lines[10],
    (void *)&stdhuffDS3_lines[6], (void *)&stdhuffDS3_lines[11],
    (void *)&stdhuffDS3_lines[12], (void *)&stdhuffDS3_lines[13],
    (void *)&stdhuffDS3_lines[14], (void *)&stdhuffDS3_lines[15],
    (void *)&stdhuffDS3_lines[16], (void *)&stdhuffDS3_lines[0],
    (void *)&stdhuffDS3_lines[2], (void *)&stdhuffDS3_lines[7],
    (void *)&stdhuffDS3_lines[17], (void *)&stdhuffDS3_lines[1],
    (void *)&stdhuffDS3_lines[8], (void *)&stdhuffDS3_lines[18],
    (void *)&stdhuffDS3_lines[19]
    };
hufftable_spec stdhuffDS3 = {
    DGP_TRUE, DGP_TRUE, DGP_TRUE,
    21, stdhuffDS3_lines, 2, DGP_TRUE,
    {
	         0,          0,          0,        0x6,
	       0xc,       0x18,       0x36,       0x7a,
	      0xfc,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0, 0xffffffff,        0x2,        0x5,
	       0xb,       0x1a,       0x3c,       0x7d,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDS3_lineptrs[0], &stdhuffDS3_lineptrs[0],
	&stdhuffDS3_lineptrs[0], &stdhuffDS3_lineptrs[3],
	&stdhuffDS3_lineptrs[3], &stdhuffDS3_lineptrs[3],
	&stdhuffDS3_lineptrs[6], &stdhuffDS3_lineptrs[13],
	&stdhuffDS3_lineptrs[17], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21],
	&stdhuffDS3_lineptrs[21], &stdhuffDS3_lineptrs[21]
	}
    };

static table_line stdhuffDT1_lines[13] = {
    { 00000,     1,  1,  0 },
    { 0x002,     2,  2,  1 },
    { 0x00c,     4,  4,  0 },
    { 0x00d,     5,  4,  1 },
    { 0x01c,     7,  5,  1 },
    { 0x01d,     9,  5,  2 },
    { 0x03c,    13,  6,  2 },
    { 0x07a,    17,  7,  2 },
    { 0x07b,    21,  7,  3 },
    { 0x07c,    29,  7,  4 },
    { 0x07d,    45,  7,  5 },
    { 0x07e,    77,  7,  6 },
    { 0x07f,   141,  7, 32 } 
    };
static void * stdhuffDT1_lineptrs[13] = {
    (void *)&stdhuffDT1_lines[0], (void *)&stdhuffDT1_lines[1],
    (void *)&stdhuffDT1_lines[2], (void *)&stdhuffDT1_lines[3],
    (void *)&stdhuffDT1_lines[4], (void *)&stdhuffDT1_lines[5],
    (void *)&stdhuffDT1_lines[6], (void *)&stdhuffDT1_lines[7],
    (void *)&stdhuffDT1_lines[8], (void *)&stdhuffDT1_lines[9],
    (void *)&stdhuffDT1_lines[10], (void *)&stdhuffDT1_lines[11],
    (void *)&stdhuffDT1_lines[12]
    };
hufftable_spec stdhuffDT1 = {
    DGP_FALSE, DGP_TRUE, DGP_FALSE,
    13, stdhuffDT1_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x6,
	       0xc,       0x1c,       0x3c,       0x7a,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x2,        0x5,
	       0xd,       0x1d,       0x3c,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDT1_lineptrs[0], &stdhuffDT1_lineptrs[0],
	&stdhuffDT1_lineptrs[1], &stdhuffDT1_lineptrs[2],
	&stdhuffDT1_lineptrs[2], &stdhuffDT1_lineptrs[4],
	&stdhuffDT1_lineptrs[6], &stdhuffDT1_lineptrs[7],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13],
	&stdhuffDT1_lineptrs[13], &stdhuffDT1_lineptrs[13]
	}
    };

static table_line stdhuffDT2_lines[13] = {
    { 00000,     1,  1,  0 },
    { 0x002,     2,  2,  0 },
    { 0x006,     3,  3,  1 },
    { 0x01c,     5,  5,  0 },
    { 0x01d,     6,  5,  1 },
    { 0x03c,     8,  6,  1 },
    { 0x07a,    10,  7,  0 },
    { 0x07b,    11,  7,  1 },
    { 0x07c,    13,  7,  2 },
    { 0x07d,    17,  7,  3 },
    { 0x07e,    25,  7,  4 },
    { 0x0fe,    41,  8,  5 },
    { 0x0ff,    73,  8, 32 } 
    };
static void * stdhuffDT2_lineptrs[13] = {
    (void *)&stdhuffDT2_lines[0], (void *)&stdhuffDT2_lines[1],
    (void *)&stdhuffDT2_lines[2], (void *)&stdhuffDT2_lines[3],
    (void *)&stdhuffDT2_lines[4], (void *)&stdhuffDT2_lines[5],
    (void *)&stdhuffDT2_lines[6], (void *)&stdhuffDT2_lines[7],
    (void *)&stdhuffDT2_lines[8], (void *)&stdhuffDT2_lines[9],
    (void *)&stdhuffDT2_lines[10], (void *)&stdhuffDT2_lines[11],
    (void *)&stdhuffDT2_lines[12]
    };
hufftable_spec stdhuffDT2 = {
    DGP_FALSE, DGP_TRUE, DGP_FALSE,
    13, stdhuffDT2_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x6,
	       0xe,       0x1c,       0x3c,       0x7a,
	      0xfe,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x2,        0x6,
	       0xd,       0x1d,       0x3c,       0x7e,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDT2_lineptrs[0], &stdhuffDT2_lineptrs[0],
	&stdhuffDT2_lineptrs[1], &stdhuffDT2_lineptrs[2],
	&stdhuffDT2_lineptrs[3], &stdhuffDT2_lineptrs[3],
	&stdhuffDT2_lineptrs[5], &stdhuffDT2_lineptrs[6],
	&stdhuffDT2_lineptrs[11], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13],
	&stdhuffDT2_lineptrs[13], &stdhuffDT2_lineptrs[13]
	}
    };

static table_line stdhuffDT3_lines[13] = {
    { 00000,     1,  1,  0 },
    { 0x004,     2,  3,  0 },
    { 0x00c,     3,  4,  0 },
    { 0x01c,     4,  5,  0 },
    { 0x00d,     5,  4,  1 },
    { 0x005,     7,  3,  3 },
    { 0x03a,    15,  6,  1 },
    { 0x03b,    17,  6,  2 },
    { 0x03c,    21,  6,  3 },
    { 0x03d,    29,  6,  4 },
    { 0x03e,    45,  6,  5 },
    { 0x07e,    77,  7,  6 },
    { 0x07f,   141,  7, 32 } 
    };
static void * stdhuffDT3_lineptrs[13] = {
    (void *)&stdhuffDT3_lines[0], (void *)&stdhuffDT3_lines[1],
    (void *)&stdhuffDT3_lines[5], (void *)&stdhuffDT3_lines[2],
    (void *)&stdhuffDT3_lines[4], (void *)&stdhuffDT3_lines[3],
    (void *)&stdhuffDT3_lines[6], (void *)&stdhuffDT3_lines[7],
    (void *)&stdhuffDT3_lines[8], (void *)&stdhuffDT3_lines[9],
    (void *)&stdhuffDT3_lines[10], (void *)&stdhuffDT3_lines[11],
    (void *)&stdhuffDT3_lines[12]
    };
hufftable_spec stdhuffDT3 = {
    DGP_FALSE, DGP_TRUE, DGP_FALSE,
    13, stdhuffDT3_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x4,
	       0xc,       0x1c,       0x3a,       0x7e,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x1,        0x5,
	       0xd,       0x1c,       0x3e,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDT3_lineptrs[0], &stdhuffDT3_lineptrs[0],
	&stdhuffDT3_lineptrs[1], &stdhuffDT3_lineptrs[1],
	&stdhuffDT3_lineptrs[3], &stdhuffDT3_lineptrs[5],
	&stdhuffDT3_lineptrs[6], &stdhuffDT3_lineptrs[11],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13],
	&stdhuffDT3_lineptrs[13], &stdhuffDT3_lineptrs[13]
	}
    };

static table_line stdhuffDT3_neg_lines[14] = {
    { 00000,     1,  2,  0 },
    { 0x004,     2,  3,  0 },
    { 0x00c,     3,  4,  0 },
    { 0x01c,     4,  5,  0 },
    { 0x00d,     5,  4,  1 },
    { 0x005,     7,  3,  3 },
    { 0x03a,    15,  6,  1 },
    { 0x03b,    17,  6,  2 },
    { 0x03c,    21,  6,  3 },
    { 0x03d,    29,  6,  4 },
    { 0x03e,    45,  6,  5 },
    { 0x07e,    77,  7,  6 },
    { 0x001,     0,  2, 32 },
    { 0x07f,   141,  7, 32 } 
    };
static void * stdhuffDT3_neg_lineptrs[14] = {
    (void *)&stdhuffDT3_neg_lines[0], (void *)&stdhuffDT3_neg_lines[12],
    (void *)&stdhuffDT3_neg_lines[1], (void *)&stdhuffDT3_neg_lines[5],
    (void *)&stdhuffDT3_neg_lines[2], (void *)&stdhuffDT3_neg_lines[4],
    (void *)&stdhuffDT3_neg_lines[3], (void *)&stdhuffDT3_neg_lines[6],
    (void *)&stdhuffDT3_neg_lines[7], (void *)&stdhuffDT3_neg_lines[8],
    (void *)&stdhuffDT3_neg_lines[9], (void *)&stdhuffDT3_neg_lines[10],
    (void *)&stdhuffDT3_neg_lines[11], (void *)&stdhuffDT3_neg_lines[13]
    };
hufftable_spec stdhuffDT3_neg = {
    DGP_TRUE, DGP_TRUE, DGP_FALSE,
    14, stdhuffDT3_neg_lines, 2, DGP_TRUE,
    {
	         0,          0,          0,        0x4,
	       0xc,       0x1c,       0x3a,       0x7e,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0, 0xffffffff,        0x1,        0x5,
	       0xd,       0x1c,       0x3e,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffDT3_neg_lineptrs[0], &stdhuffDT3_neg_lineptrs[0],
	&stdhuffDT3_neg_lineptrs[0], &stdhuffDT3_neg_lineptrs[2],
	&stdhuffDT3_neg_lineptrs[4], &stdhuffDT3_neg_lineptrs[6],
	&stdhuffDT3_neg_lineptrs[7], &stdhuffDT3_neg_lineptrs[12],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14],
	&stdhuffDT3_neg_lineptrs[14], &stdhuffDT3_neg_lineptrs[14]
	}
    };

static table_line stdhuffRD1_lines[5] = {
    { 0x004,    -2,  3,  0 },
    { 0x005,    -1,  3,  0 },
    { 00000,     0,  1,  0 },
    { 0x006,     1,  3,  0 },
    { 0x007,     2,  3,  0 } 
    };
static void * stdhuffRD1_lineptrs[5] = {
    (void *)&stdhuffRD1_lines[2], (void *)&stdhuffRD1_lines[0],
    (void *)&stdhuffRD1_lines[1], (void *)&stdhuffRD1_lines[3],
    (void *)&stdhuffRD1_lines[4]
    };
hufftable_spec stdhuffRD1 = {
    DGP_FALSE, DGP_FALSE, DGP_FALSE,
    5, stdhuffRD1_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x4,
	      0x10,       0x20,       0x40,       0x80,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x1,        0x7,
	       0xf,       0x1f,       0x3f,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffRD1_lineptrs[0], &stdhuffRD1_lineptrs[0],
	&stdhuffRD1_lineptrs[1], &stdhuffRD1_lineptrs[1],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5],
	&stdhuffRD1_lineptrs[5], &stdhuffRD1_lineptrs[5]
	}
    };

static table_line stdhuffRD2_lines[13] = {
    { 0x07c,   -24,  7,  4 },
    { 0x03c,    -8,  6,  2 },
    { 0x01c,    -4,  5,  1 },
    { 0x00c,    -2,  4,  0 },
    { 0x004,    -1,  3,  0 },
    { 00000,     0,  1,  0 },
    { 0x005,     1,  3,  0 },
    { 0x00d,     2,  4,  0 },
    { 0x01d,     3,  5,  1 },
    { 0x03d,     5,  6,  2 },
    { 0x07d,     9,  7,  4 },
    { 0x07e,   -25,  7, 32 },
    { 0x07f,    25,  7, 32 } 
    };
static void * stdhuffRD2_lineptrs[13] = {
    (void *)&stdhuffRD2_lines[5], (void *)&stdhuffRD2_lines[4],
    (void *)&stdhuffRD2_lines[6], (void *)&stdhuffRD2_lines[3],
    (void *)&stdhuffRD2_lines[7], (void *)&stdhuffRD2_lines[2],
    (void *)&stdhuffRD2_lines[8], (void *)&stdhuffRD2_lines[1],
    (void *)&stdhuffRD2_lines[9], (void *)&stdhuffRD2_lines[0],
    (void *)&stdhuffRD2_lines[10], (void *)&stdhuffRD2_lines[11],
    (void *)&stdhuffRD2_lines[12]
    };
hufftable_spec stdhuffRD2 = {
    DGP_TRUE, DGP_TRUE, DGP_FALSE,
    13, stdhuffRD2_lines, 1, DGP_TRUE,
    {
	         0,          0,        0x2,        0x4,
	       0xc,       0x1c,       0x3c,       0x7c,
	     0x100,      0x200,      0x400,      0x800,
	    0x1000,     0x2000,     0x4000,     0x8000,
	   0x10000,    0x20000,    0x40000,    0x80000,
	  0x100000,   0x200000,   0x400000,   0x800000,
	 0x1000000,  0x2000000,  0x4000000,  0x8000000,
	0x10000000, 0x20000000, 0x40000000, 0x80000000
	},
    {
	         0,          0,        0x1,        0x5,
	       0xd,       0x1d,       0x3d,       0x7f,
	      0xff,      0x1ff,      0x3ff,      0x7ff,
	     0xfff,     0x1fff,     0x3fff,     0x7fff,
	    0xffff,    0x1ffff,    0x3ffff,    0x7ffff,
	   0xfffff,   0x1fffff,   0x3fffff,   0x7fffff,
	  0xffffff,  0x1ffffff,  0x3ffffff,  0x7ffffff,
	 0xfffffff, 0x1fffffff, 0x3fffffff, 0x7fffffff
	},
    {
	&stdhuffRD2_lineptrs[0], &stdhuffRD2_lineptrs[0],
	&stdhuffRD2_lineptrs[1], &stdhuffRD2_lineptrs[1],
	&stdhuffRD2_lineptrs[3], &stdhuffRD2_lineptrs[5],
	&stdhuffRD2_lineptrs[7], &stdhuffRD2_lineptrs[9],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13],
	&stdhuffRD2_lineptrs[13], &stdhuffRD2_lineptrs[13]
	}
    };

