/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1992-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

/* Prototypes for common library functions that the idiot compiler
 * libraries failed to supply.  They will be added as needed.
 * Since Watcom DID supply these, we have to use them only in the
 * Unix world.
 */

#ifndef _ANSIPROT_H_INCLUDED_
#define _ANSIPROT_H_INCLUDED_

#ifdef _MSC_VER
#pragma pack(push, ansiprot_h, 1)
#endif

#ifndef _TYPES_PUB_INCLUDED
#include "types.pub"
#endif

IP_RCSINFO(ansiprot_h_RCSInfo, "$RCSfile: ansiprot.h,v $; $Revision: 1.2 $");
/* $Date: 2000/07/08 00:38:13 $ */

/* Linux appears not to need these prototypes... / dhtesq. */
#if defined(_UNIX_) && !defined(X86_LINUX)

#include <stdio.h>
#include <stdarg.h>
#include <stddef.h>
#include <sys/time.h>
#include <sys/resource.h>

/* make prototypes usable from C++ */
#ifdef __cplusplus
extern "C" {
#endif

/* memory.h functions */
void	*memchr( const void *__s, int __c, size_t __n);
void	*memmove( void *__s1, const void *__s2, size_t __n);
void	*memset( void *__s, int __c, size_t __n);

/* stdlib functions */
int	 system(const char *s);

/* ctype functions */
int	 tolower(int c);
int	 toupper(int c);

/* stdio functions */
#ifndef SEEK_SET
#define SEEK_SET        0     /* Set file pointer to "offset" */
#define SEEK_CUR        1     /* Set file pointer to current plus "offset" */
#define SEEK_END        2     /* Set file pointer to EOF plus "offset" */
#endif

int	 fclose( FILE *stream);
int	 fgetc (FILE *stream);
int      ungetc(int c, FILE *stream);
int	 fprintf( FILE *__fp, const char *__format, ...);
int	 vsprintf( char *s, const char *format, va_list arg);
int	 fputc (int c, FILE *stream);
size_t	 fread( void *ptr, size_t size, size_t nobj, FILE *stream);
int	 fscanf( FILE *stream, const char *__format, ...);
int	 fseek( FILE *stream, long offset, int origin);
size_t	 fwrite( const void *ptr, size_t size, size_t nobj, FILE *stream);
int	 remove( const char *filename);
void	 rewind( FILE *stream);
int      sscanf( const char *s, const char *__format, ...);
int	_flsbuf (unsigned int, FILE *);
int	_filbuf (FILE *);

/* time functions */
struct rusage;		/* might not be defined yet */
int	 getrusage( int __id, struct rusage *__myrusage);

#ifdef __cplusplus
}
#endif

#endif /* !_UNIX_ */

#ifdef _MSC_VER
#pragma pack(pop, ansiprot_h)
#endif

#endif /* _ANSIPROT_H_INCLUDED_ */

/*

$Log: ansiprot.h,v $
Revision 1.2  2000/07/08 00:38:13  dtracy
x86_linux added to supported os's.

Revision 1.1.1.1  1999/09/20 18:18:19  jlin
Imported sources

Revision 1.18  1998/10/19 23:51:05  aber
aber on Mon Oct 19 16:51:04 PDT 1998

ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v

CommonCheck: Add pragma pack for structure alignment consistency between
client includes and pre-build libraries.

Revision 1.17  1995/12/13 02:40:09  ejaquith
ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v

CommonCheck: Added ";" to end of IP_RCSINFO() macro.

 * Revision 1.16  1995/10/07  02:31:20  ddavies
 * ddavies on Fri Oct 6 19:30:42 PDT 1995
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Added prototype for vsprintf.  As usual the SunOS protos think this function
 * is only fit for C++ users.
 *
 * Revision 1.15  1995/07/19  19:37:59  ddavies
 * ddavies on Wed Jul 19 12:37:22 PDT 1995
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Add prototypes for tolower and toupper, which the SunOS version of gcc
 * thinks are only needed by C++ programmers.
 *
 * Revision 1.14  1995/06/06  01:28:44  ddavies
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Added C++ Boilerplate.
 *
 * Revision 1.13  1995/02/03  00:56:42  lperry
 * lperry on Thu Feb 2 16:56:11 PST 1995
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Add prototype for ungetc() which is needed by JPEG libs.
 *
 * Revision 1.12  1994/09/15  01:19:49  ddavies
 * ddavies on Wed Sep 14 18:18:38 PDT 1994
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Change sscanf's prototype to have "const char *s" as the first arg instead
 * of char *s.  This makes it match the Solaris gcc prototypes.
 *
 * Revision 1.11  1994/09/08  00:16:35  lperry
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Conditionally define away IP_RCSINFO macro on PRODUCTION.
 *
 * Revision 1.10  1994/05/05  00:53:13  ddavies
 * ddavies on Wed May 4 17:51:42 PDT 1994
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Add more constants and prototypes that were missing in the gcc include
 * files.  Some of these were declared to be C++ things in the gcc include
 * files.  Dummies.
 *
 * Revision 1.9  1994/05/02  20:34:04  jcraig
 * jcraig on Mon May 2 13:33:21 PDT 1994
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * add prototypes for sscanf, fscanf, and fclose so that the glyph code
 * will compile with gcc
 *
 * Revision 1.8  1993/12/09  23:38:07  macleod
 * macleod on Thu Dec 9 15:37:40 PST 1993
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Changed getrusage definition so that gcc wouldn't complain if
 * getrusage was already defined using ints rather than int32.
 *
 * Revision 1.7  1993/12/02  18:37:16  ddavies
 * ddavies on Thu Dec 2 10:35:03 PST 1993
 *
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Add "struct rusage" before declaration of getrusage so that rusage doesn't
 * have to be defined before we see this file.  This was needed in Solaris 2.2, 2.3.
 * Also put RCS magic into a macro that doesn't generate compiler warnings.
 *
 * Revision 1.6  1993/11/05  01:15:37  ddavies
 * ansiprot.h -> /product/ipcore/ipshared/include/RCS/ansiprot.h,v
 *
 * Add RCS magic to have string specifying this file's name, rev number and
 * last edit date into the object file.  Also add change log at the bottom.
 *

*/

