/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1996-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */
/*
 * jchuff.h
 *
 * Copyright (C) 1991-1995, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file contains declarations for Huffman entropy encoding routines
 * that are shared between the sequential encoder (jchuff.c) and the
 * progressive encoder (jcphuff.c).  No other modules need to see these.
 */

#ifndef JCHUFF_H_INCLUDED
#define JCHUFF_H_INCLUDED

#ifdef _MSC_VER
#pragma pack(push, jchuff_h, 1)
#endif

/* Derived data constructed for each Huffman table */

typedef struct {
  unsigned int ehufco[256];	/* code for each symbol */
  char ehufsi[256];		/* length of code for each symbol */
  /* If no code has been allocated for a symbol S, ehufsi[S] contains 0 */
} c_derived_tbl;

/* Short forms of external names for systems with brain-damaged linkers. */

#ifdef NEED_SHORT_EXTERNAL_NAMES
#define jpeg_make_c_derived_tbl	jMkCDerived
#define jpeg_gen_optimal_table	jGenOptTbl
#endif /* NEED_SHORT_EXTERNAL_NAMES */

/* Expand a Huffman table definition into the derived format */
EXTERN ErrCode CDECL 
jpeg_make_c_derived_tbl (
    IPState    *pIPState,
    j_compress_ptr cinfo,
    JHUFF_TBL  *htbl,
    c_derived_tbl **pdtbl);

/* Generate an optimal table definition given the specified counts */
EXTERN ErrCode CDECL 
jpeg_gen_optimal_table (
    IPState    *pIPState,
    j_compress_ptr cinfo,
    JHUFF_TBL  *htbl,
    long	freq[]);

#ifdef _MSC_VER
#pragma pack(pop, jchuff_h)
#endif

#endif /* JCHUFF_H_INCLUDED */

