/*****************************************************************
 *  Copyright (c) 1992, Xerox Corporation.  All rights reserved. *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*
 *  pcprocdm.c
 *
 *  Private routines:
 *	ip_getLongestWin31Access():	Dummy C implementation of routine that
 *					returns the length in bytes of the
 *					longest memory access this processor
 *					will normally make.  This is called
 *					only on Windows 3.1 systems.
 */


#include <stdio.h>
#include "types.pub"
#include "ipscore.prv"
#include "iaerror.pub"
#include "defines.pub"

    /* prototypes */
#include "shrpixr.pub"
#include "shrpixr.prv"

IP_RCSINFO(RCSInfo, "$RCSfile: pcprocdm.c,v $; $Revision: 1.1.1.1 $; $Date: 1999/09/20 18:18:17 $");

/**************************************************************************
 *  ip_getLongestWin31Access()
 *	This procedure determines the length of the longest memory access
 *	commonly used on the current processor.  It is only called on
 *	Windows 3.1 machines.  It's written in assmebly code.
 *
 *	pLongestAccess:	Pointer to the returned number of bytes in the
 *			longest type of memory access this processor
 *			normally makes.
 *
 **************************************************************************/
void CDECL 
ip_getLongestWin31Access (
    IPState    *pIPState,
    Int32      *pLongestAccess)
{
    PROLOGUE;

	/* Keep compiler happy */
    pIPState = pIPState;
    __error__ = __error__;

	/* This is a dummy implementation.  If the MMX stuff isn't linked,
	 * the longest access is always 4 bytes.
	 */
    *pLongestAccess = 4;
}


/*

$Log: pcprocdm.c,v $
Revision 1.1.1.1  1999/09/20 18:18:17  jlin
Imported sources

Revision 1.3  1998/01/15 01:46:59  ddavies
pcprocdm.c -> /product/ipcore/ipshared/src/RCS/pcprocdm.c,v

CommonCheck: Fix WATCOM complaints about unused procedure args.

Revision 1.2  1998/01/13 23:54:11  ddavies
pcprocdm.c -> /product/ipcore/ipshared/src/RCS/pcprocdm.c,v

CommonCheck: Add IPState parameter to almost all procedures.

Revision 1.1  1996/10/28 20:21:27  ddavies
Initial revision

Revision 1.1  1996/10/24 19:55:47  ddavies
Initial revision


*/


