/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


#ifndef  ALPLIB_H_INCLUDED
#define  ALPLIB_H_INCLUDED

#ifdef _MSC_VER
#pragma pack(push, alplib_h, 1)
#endif

IP_RCSINFO(alplib_h_RCSInfo, "$RCSfile: alplib.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:10 $ */


 /*------------------------------------------------------------------------*
  *                          Useful macros
  *------------------------------------------------------------------------*/

#define MIN(x,y)      (((x) < (y)) ? (x) : (y))
#define MAX(x,y)      (((x) > (y)) ? (x) : (y))
#define ABS(x)        (((x) < 0) ? (-1 * (x)) : (x))
#define SIGN(x)       (((x) < 0) ? -1 : 1)

/* Notice how these ALWAYS do byteswapping, whereas the FLIPs below
 * do it conditionally w.r.t. the platform.
 */
#define BYTE_SWAP_SHORT(x) \
  ( ( ((x) >> 8) & 0x00ff) | ( ((x) << 8) & 0xff00) )

#define BYTE_SWAP_INT(x) \
  ( ( (BYTE_SWAP_SHORT((x)) << 16) ) | ( (BYTE_SWAP_SHORT((x) >> 16)) \
                                          & 0x0000ffff) )


 /*------------------------------------------------------------------------*
  *                     Port compatibility macros
  *------------------------------------------------------------------------*/
#if _ALPACA_IMAGE_FMT_ == cAlpacaPCFmt

#define FLIP_SHORT(x)	BYTE_SWAP_SHORT(x)
#define FLIP_INT(x)	BYTE_SWAP_INT(x)

#else  /* _ALPACA_IMAGE_FMT_ == cAlpacaPCFmt */

#define  FLIP_SHORT(x)    (x)
#define  FLIP_INT(x)      (x)

#endif  /* _ALPACA_IMAGE_FMT_ == cAlpacaPCFmt */


#ifdef _MSC_VER
#pragma pack(pop, alplib_h)
#endif

#endif  /* ALPLIB_H_INCLUDED */


/*

$Log: alplib.h,v $
Revision 1.1.1.1  1999/09/20 18:19:10  jlin
Imported sources

Revision 1.21  1998/10/02 18:24:29  aber
alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.20  1996/02/01 03:58:29  ejaquith
ejaquith on Wed Jan 31 19:58:04 PST 1996

alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v

Fixed typo, from _ALPACA_IMAGE_FMT   to: _ALPACA_IMAGE_FMT_

 * Revision 1.19  1996/01/30  21:02:09  ejaquith
 * ejaquith on Tue Jan 30 13:01:23 PST 1996
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * For defining FLIP_SHORT() and FLIP_INT() changed contingency to be
 * #if _ALPACA_IMAGE_FMT == cAlpacaPCFmt
 * instead of #ifdef _386_ARCH_
 *
 * Revision 1.18  1996/01/27  22:41:37  ejaquith
 * ejaquith on Sat Jan 27 14:40:30 PST 1996
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Added BYTE_SWAP_SHORT() and BYTE_SWAP_INT() macros, which always
 * byteswap, no matter the platform.
 * Updated FLIP_SHORT() and FLIP_INT() to use these when #def _386_ARCH_
 *
 * Revision 1.17  1995/12/13  04:03:57  ejaquith
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * CommonCheck: Added ";" to IP_RCSINFO().
 * Removed function comment blocks from before prototypes and
 * added special prototype comment.
 *
 * Revision 1.16  1995/09/29  00:26:15  ejaquith
 * ejaquith on Thu Sep 28 17:25:03 PDT 1995
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Killed macros: TRUE, FALSE, ON, OFF, FATAL(), O_BINARY, O_TEXT
 * because either nothing uses them in IPWrap or they are obsolete (TRUE,FALSE)
 *
 * Revision 1.15  1995/08/31  22:02:40  ejaquith
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * CommonCheck: Stripped all #includes.
 * Changed IPState to IPWState.
 *
 * Revision 1.14  1995/08/04  19:08:30  ejaquith
 * ejaquith on Fri Aug 4 12:08:11 PDT 1995
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Removed the FRAME_BITS, etc stuff.   (oops for adding it!)
 *
 * Revision 1.13  1995/08/04  01:26:51  ejaquith
 * ejaquith on Thu Aug 3 18:24:46 PDT 1995
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Cleaned up these silly macros (finally!!)
 * Killed Min() Max() Abs() Sign() macros (dont worry --
 * MIN() MAX() ABS() SIGN() still exist)
 * Changed Fatal() to FATAL()
 * Changed Flip_Int()/Flip_Short() to FLIP_INT()/FLIP_SHORT()
 *
 * And don't anyone get any funny ideas about putting them back because I'll
 * do this again .... muhawhawha
 *
 * Revision 1.12  1995/08/01  20:40:09  ejaquith
 * ejaquith on Tue Aug 1 13:39:33 PDT 1995
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Added back in macros like "FRAME_BITS" for universal framing for all images
 * that was accidentally deleted.
 *
 * Revision 1.11  1995/07/29  04:22:13  ddavies
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Update to new style.
 *
 * Revision 1.10  1994/10/10  22:59:12  lperry
 * lperry on Mon Oct 10 15:54:23 PDT 1994
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Moved include of shros.pub up into alplib.h rather than having it
 * "hidden" in memory.pub.
 * Also created macros flip_short() and flip_int(). These do what you'd
 * expect on little-endian machines, but are no-ops on big-endians.
 * These had previously been defined as functions in port.c.
 * That file is now obsolete.
 *
 * Revision 1.9  1994/09/08  00:31:53  lperry
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Remove Date from RCS macro. Test for redundant types.pub includes.
 *
 * Revision 1.8  1994/05/05  00:59:57  ddavies
 * ddavies on Wed May 4 17:58:45 PDT 1994
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Change abortV macro so that it doesn't call _abortV, which doesn't exist.
 * Also include ansiprot.h to get fprintf for the abortX macros.
 *
 * Revision 1.7  1994/04/26  02:20:16  ddavies
 * ddavies on Mon Apr 25 19:19:01 PDT 1994
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Have this file include <stdio.h> so that every C file doesn't have to.
 * <stdio.h> defines FILE, which is used by the iopro.h prototypes.  Why should
 * a C file have to include <stdio.h> so that a bunch of prototypes it doesn't need
 * will be happy?
 *
 * Revision 1.6  1994/02/04  20:07:14  dferrell
 * dferrell on Fri Feb 4 12:06:26 PST 1994
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Removed memory allocation macros--they're all in memory.pub now.
 * Added #include of memory.pub.
 *
 * Revision 1.5  1993/12/29  20:02:45  lperry
 * lperry on Wed Dec 29 12:01:17 PST 1993
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Added code to print file and line number at which
 * abort was called in addition to function name
 *
 * Revision 1.4  1993/12/09  20:01:03  macleod
 * macleod on Thu Dec 9 12:00:41 PST 1993
 *
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Disabled the definition of INT8, INT16, INT32, ..., which are
 * never used.
 *
 * Revision 1.3  1993/12/03  01:09:30  ddavies
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Put RCS magic into macro that doesn't generate compiler warnings.
 *
 * Revision 1.2  1993/11/06  02:59:08  ddavies
 * alplib.h -> /product/ipcore/ipwrap/include/RCS/alplib.h,v
 *
 * Add RCS strings so file's name, revision and date appear in the object file.
 * Also automatically add a change log at the bottom of the file.
 *

*/
