/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


#ifndef  BMP_H_INCLUDED
#define  BMP_H_INCLUDED

#ifdef _MSC_VER
#pragma pack(push, bmp_h, 1)
#endif

IP_RCSINFO(bmp_h_RCSInfo, "$RCSfile: bmp.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:10 $ */



/*******************************************************************
   BITMAPFILEHEADER
*******************************************************************/

typedef struct tagBITMAPFILEHEADER {

    Int16	bfType;		/* file type; must be "BM" */
    Int16	bfSize;		/* length of the file;
				   sizeof(BITMAPFILEHEADER) +
				   sizeof(BITMAPINFOHEADER) +
				   size of color table +
				   size of DIB bits */
#if 1
    Int16	bfFill1;	/* remainder of the bfSize field */
#endif
    Int16	bfReserved1;	/* don't care (set to 0)*/
    Int16	bfReserved2;	/* don't care (set to 0)*/
    Int16	bfOffBits;	/* offset from beginning of file
				   to first byte of image data */
#if 1
    Int16	bfFill2;	/* remainder of the bfOffBits field */
#endif
} BITMAPFILEHEADER;

#define BMFHBYTES 14


/*******************************************************************
   BITMAPINFOHEADER
*******************************************************************/

typedef struct tagBITMAPINFOHEADER {

    Int32	biSize;		/* size of the BITMAPINFOHEADER structure */
    Int32	biWidth;	/* bitmap width in pixels */
    Int32	biHeight;	/* bitmap height in pixels */
    Int16	biPlanes;	/* number of bitmap planes */
    Int16	biBitCount;	/* number of bits per pixel */
    Int32	biCompression;	/* compression format (0 == uncompressed) */
    Int32	biSizeImage;	/* size of image in bytes */
    Int32	biXPelsPerMeter; /* pixels per meter in x direction */
    Int32	biYPelsPerMeter; /* pixels per meter in y direction */
    Int32	biClrUsed; 	/* number of colors used */
    Int32	biClrImportant;	/* number of important colors used */
} BITMAPINFOHEADER;


/*******************************************************************
   RGBQUAD
*******************************************************************/

typedef struct tagRGBQUAD {

    UInt8	rgbBlue;	/* blue color from 0 to 255 */
    UInt8	rgbGreen;	/* green color from 0 to 255 */
    UInt8	rgbRed;		/* red color from 0 to 255 */
    UInt8	rgbReserved;	/* reserved field */
} RGBQUAD;

 
/**************************************************************
     BMP_MAGIC
***************************************************************/
#define  BMP_MAGIC     0x4d42		/* ('M' << 8) | 'B' */
 
#ifdef _MSC_VER
#pragma pack(pop, bmp_h)
#endif

#endif  /* BMP_H_INCLUDED */

/*

$Log: bmp.h,v $
Revision 1.1.1.1  1999/09/20 18:19:10  jlin
Imported sources

Revision 1.8  1998/10/02 18:24:46  aber
bmp.h -> /product/ipcore/ipwrap/include/RCS/bmp.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.7  1995/12/13 04:04:26  ejaquith
bmp.h -> /product/ipcore/ipwrap/include/RCS/bmp.h,v

CommonCheck: Added ";" to IP_RCSINFO().
Removed function comment blocks from before prototypes and
added special prototype comment.

 * Revision 1.6  1995/08/31  22:02:50  ejaquith
 * bmp.h -> /product/ipcore/ipwrap/include/RCS/bmp.h,v
 *
 * CommonCheck: Stripped all #includes.
 * Changed IPState to IPWState.
 *
 * Revision 1.5  1995/07/31  17:59:30  ejaquith
 * ejaquith on Mon Jul 31 10:59:03 PDT 1995
 *
 * bmp.h -> /product/ipcore/ipwrap/include/RCS/bmp.h,v
 *
 * Standardizing changes -- first pass.
 *
 * Revision 1.4  1994/09/08  00:32:24  lperry
 * bmp.h -> /product/ipcore/ipwrap/include/RCS/bmp.h,v
 *
 * Remove Date from RCS macro. Test for redundant types.pub includes.
 *
 * Revision 1.3  1993/12/03  01:09:51  ddavies
 * bmp.h -> /product/ipcore/ipwrap/include/RCS/bmp.h,v
 *
 * Put RCS magic into macro that doesn't generate compiler warnings.
 *
 * Revision 1.2  1993/11/06  02:59:48  ddavies
 * bmp.h -> /product/ipcore/ipwrap/include/RCS/bmp.h,v
 *
 * Add RCS strings so file's name, revision and date appear in the object file.
 * Also automatically add a change log at the bottom of the file.
 *

*/
