/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef EPSUTIL_H
#define EPSUTIL_H

/* epsutil.c
 *
 * $Log: epsutil.h,v $
 * Revision 1.1.1.1  1999/09/20 18:19:11  jlin
 * Imported sources
 *
 * Revision 1.5  1998/10/05 19:12:38  aber
 * epsutil.h -> /product/ipcore/ipwrap/include/RCS/epsutil.h,v
 *
 * CommonCheck: Fix module name in all-encompassing ifdef to be upper-case, to avoid
 * naming conflict with packing pragma name.
 *
 * Revision 1.4  1998/10/02 18:25:21  aber
 * epsutil.h -> /product/ipcore/ipwrap/include/RCS/epsutil.h,v
 *
 * CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
 * using libraries and includes.
 *
 * Revision 1.3  1997/06/30 23:16:09  ddavies
 * ddavies on Mon Jun 30 16:15:30 PDT 1997
 *
 * epsutil.h -> /product/ipcore/ipwrap/include/RCS/epsutil.h,v
 *
 * Comment out defunct prototype for epsUiltInit (which wasn't valid anyway).
 *
 * Revision 1.2  1995/07/31 17:59:41  ejaquith
 * epsutil.h -> /product/ipcore/ipwrap/include/RCS/epsutil.h,v
 *
 * Standardizing changes -- first pass.
 *
 * Revision 1.1  1994/10/21  17:19:34  ejaquith
 * Initial revision
 *
 * 
 *    Rev 1.3   24 Jun 1994 18:14:22   MSEIDNER
 * 
 * 
 *    Rev 1.2   23 Jun 1994 16:46:50   MSEIDNER
 * 
 * 
 *    Rev 1.1   22 Jun 1994 15:52:32   SMARTIN
 * Compiled for the first time.
 */

#ifdef _MSC_VER
#pragma pack(push, epsutil_h, 1)
#endif

/* epsUtilInit()
 *
 * call this function once during a reading session to initialize the 
 * globals that are used by these routines.
 */
/* This is commented out in epsutil.c, so it might as well be commented out
 * here too.  A declaration with no args make gcc -Wstrict-prototypes sad.
 */
#if 0
void epsUtilInit();
#endif

/* epsHeaderRead()
 *
 * reads the header of the EPS file to get information describing the image.
 * returns if the image is color, the depth, width, and height.
 */
int epsHeaderRead( void *gfioToken, Bool *bColor, UInt8 *depth, UInt32 *width, UInt32 *height );

/* epsScanlineRead ()
 *
 * starting from the current file position, reads the ASCII values for the 
 * image data and convert to binary pixel values to be placed in the buffer
 * 
 * 24-bit images are assumed to be RGB packed.  8-bit are assumed to be one 
 * byte for one pixel.  1-bit images are assumed to be one byte for 8 pixels.
 */
int epsScanlineRead( GDATA *pGData, void *gfioToken, char *buffer );

unsigned char get_buffered_char( void *fptr );
void init_rd_buffer( void );

#ifdef _MSC_VER
#pragma pack(pop, epsutil_h)
#endif

#endif /* EPSUTIL_H */
