/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef GDEFS_H
#define GDEFS_H

#ifdef _MSC_VER
#pragma pack(push, gdefs_h, 1)
#endif

/* gdefs.h
 *
 * $Header: /project/icons/cvsroot/ipcore/src/ipwrap/include/gdefs.h,v 1.1.1.1 1999/09/20 18:19:11 jlin Exp $
 *
 * DESCRIPTION
 *   Defines structure for exchange of common image attributes in imageio.
 *      (Holds the current image state).
 *
 * $Log: gdefs.h,v $
 * Revision 1.1.1.1  1999/09/20 18:19:11  jlin
 * Imported sources
 *
 * Revision 1.3  1998/10/02 18:25:32  aber
 * gdefs.h -> /product/ipcore/ipwrap/include/RCS/gdefs.h,v
 *
 * CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
 * using libraries and includes.
 *
 * Revision 1.2  1995/07/31 17:59:47  ejaquith
 * gdefs.h -> /product/ipcore/ipwrap/include/RCS/gdefs.h,v
 *
 * Standardizing changes -- first pass.
 *
 * Revision 1.1  1994/10/21  17:19:42  ejaquith
 * Initial revision
 *
 * 
 *    Rev 1.8   26 Sep 1994 15:29:46   EHOPPE
 * Added resolution fields to GData struct.
 * 
 *    Rev 1.7   20 Sep 1994 16:39:56   EHOPPE
 * Add resolution fields to GData structure.
 */

/*
 * INCLUDES
 */

/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*******************************************************************/
/* This structure identifies the generic graphics bitmap header    */
/*******************************************************************/
typedef struct tagGDATA
{
   /* describe the image */
    UInt8       depth;             /* image depth */
    Int32       x_dim;             /* image width */
    Int32       y_dim;             /* image height */
    Int32       xDPI;              /* image X resolution */
    Int32       yDPI;              /* image Y resolution */
    UInt8       bits_pixel;        /* bits per plane */
    UInt8       nplanes;           /* color planes */
    UInt8       gray_or_color;     /* grayscale or color: gray = 2 color = 1 */
    UInt8       *palette_data;     /* store the palette pointer here */
                                   /* if bits_pixel=8, nplanes=1, and gray_or_color=1 */
                                   /* then palette_data is used.  All other conditions */
                                   /* either have a default, or don't use a palette */
    UInt32      bytesPerLine;      /* MANDATORY for PCX! */
                                        
   /* used by all formats */
    UInt8       format;
    UInt32      ftype;
    void        *internal_data;    /* data used by file format */
} GDATA;

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */

#ifdef _MSC_VER
#pragma pack(pop, gdefs_h)
#endif

#endif
