/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef GFIO_H
#define GFIO_H
 
/*
 * gfio.h - Sun/Solaris/Unix  file I/O platform dependent prototypes.
 *
$Log: gfio.h,v $
Revision 1.1.1.1  1999/09/20 18:19:11  jlin
Imported sources

Revision 1.5  1998/10/05 19:12:39  aber
gfio.h -> /product/ipcore/ipwrap/include/RCS/gfio.h,v

CommonCheck: Fix module name in all-encompassing ifdef to be upper-case, to avoid
naming conflict with packing pragma name.

Revision 1.4  1998/10/02 18:25:37  aber
gfio.h -> /product/ipcore/ipwrap/include/RCS/gfio.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.3  1996/01/17 23:12:01  ddavies
ddavies on Wed Jan 17 15:11:03 PST 1996

gfio.h -> /product/ipcore/ipwrap/include/RCS/gfio.h,v

If we're compiling for WATCOM 10.5 on NT, define CDECL as __cdecl instead
of _cdecl.  The documentation says they're the same, but this appears to
be a lie.

 * Revision 1.2  1995/07/31  17:59:49  ejaquith
 * gfio.h -> /product/ipcore/ipwrap/include/RCS/gfio.h,v
 *
 * Standardizing changes -- first pass.
 *
 * Revision 1.1  1994/10/21  17:19:45  ejaquith
 * Initial revision
 *
 */ 

#ifdef _MSC_VER
#pragma pack(push, gfio_h, 1)
#endif

#ifndef CDECL
#ifdef __WATCOMC__
#ifdef __NT__	/* We're on WATCOM 10.5 on NT */
#define CDECL __cdecl
#else		/* This is WATCOM 9.0.1 on Windows */
#define CDECL _cdecl
#endif	/* __NT__ */
#else	/* This is not WATCOM, so forget CDECL */
#define CDECL
#endif  /* Watcom or not */
#endif  /* CDECL defined already? */

#ifndef SEEK_SET
#define SEEK_SET 0
#endif
#ifndef SEEK_CUR
#define SEEK_CUR 1
#endif
#ifndef SEEK_END
#define SEEK_END 2
#endif

/*************************************************************
 * GFIO_CreateFileToken () - Create (malloc) and init a file token
 *             for a file given its name and FILE.
 * Inputs:
 *             file     - An already opened stream handle
 *                        or NULL.
 *             filename - A string containing the file name and
 *                        optionally its path.
 *
 * Returns:
 *             A pointer to the file token for the new file, or
 *             NULL if the file token could not be created
 *
 * Notes:
 *             The platform specific information for files
 *             is stored in the file tokens which are passed
 *             in to GFIO.  If file is NULL, the file open
 *             flag is set to FALSE, otherwise it is TRUE.
 *
 * See Also: 
 *             GFIO_DestroyFileToken ()
 */
void * CDECL GFIO_CreateFileToken(char *filename, FILE *file);

/*************************************************************
 * GFIO_DestroyFileToken () - free resources taken by 
 *             a file token.
 *             
 * Inputs:
 *             void * ft - a file token
 *
 * Returns:
 *
 *             Nothing
 *
 * See Also: 
 *             GFIO_CreateFileToken ()
 */
void CDECL
GFIO_DestroyFileToken (void *filetoken);



FILE * CDECL GFIO_GetFileHandle( void *filetoken );
char * CDECL GFIO_GetFileName( void *filetoken );

#ifdef _MSC_VER
#pragma pack(pop, gfio_h)
#endif

#endif /* GFIO_H */
