/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


/*
*  hauscomp.h
*
*    Public function interface definitions.
*
*        Constant and type definitions for Hausdorff module
*
*/


#ifndef _HAUSCOMP_H_INCLUDED_
#define _HAUSCOMP_H_INCLUDED_

#ifdef _MSC_VER
#pragma pack(push, hauscomp_h, 1)
#endif

IP_RCSINFO(hauscomp_h_RCSInfo, "$RCSfile: hauscomp.h,v $; $Revision: 1.1.1.1 $; $Date: 1999/09/20 18:19:11 $");

typedef struct
{
    void    *pIMS;       /* Ptr to internal representation of the model set */
    UInt8   *pBitmapData;/* Where all the data for these bitmaps is stored */
    UInt8  **ppBitmaps;  /* Array of ptrs to each of the bitmap's upper left
			  * corner, excluding frame and padding */
    UInt8    nBitmaps;   /* Number of image bitmaps in this model */
} modelType;


#ifdef _MSC_VER
#pragma pack(pop, hauscomp_h)
#endif

#endif /* _HAUSCOMP_H_INCLUDED_ */

/*
$Log: hauscomp.h,v $
Revision 1.1.1.1  1999/09/20 18:19:11  jlin
Imported sources

Revision 1.3  1998/10/02 18:25:50  aber
hauscomp.h -> /product/ipcore/ipwrap/include/RCS/hauscomp.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.2  1995/12/13 04:08:03  ejaquith
hauscomp.h -> /product/ipcore/ipwrap/include/RCS/hauscomp.h,v

CommonCheck: Added ";" to IP_RCSINFO().
Removed function comment blocks from before prototypes and
added special prototype comment.

 * Revision 1.1  1995/10/30  17:53:38  ejaquith
 * Initial revision
 *
 */
