/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


#ifndef _HIMETRIC_H_INCLUDED_
#define _HIMETRIC_H_INCLUDED_

#ifdef _MSC_VER
#pragma pack(push, himetric_h, 1)
#endif

IP_RCSINFO(himetric_h_RCSInfo, "$RCSfile: himetric.h,v $; $Revision: 1.1.1.1 $; $Date: 1999/09/20 18:19:11 $");

/* 2540 HI_METRIC units per inch */

/*  Upper left corner assumption:
 *    We assumme that the HI_METRICS have 0,0 in the upper left corner and
 *    that -y moves down the image and +x moves to the right.
 */
#define HIMET_TO_PIX_X(x, xres)   ((Int32)( (x)*(xres)*(1.0/2540) + 0.5))
#define HIMET_TO_PIX_Y(y, yres)   ((Int32)(-(y)*(yres)*(1.0/2540) + 0.5))
#define HIMET_TO_PIX_W(w, xres)   ((Int32)( (w)*(xres)*(1.0/2540) + 0.5))
#define HIMET_TO_PIX_H(h, yres)   ((Int32)( (h)*(yres)*(1.0/2540) + 0.5))

#define PIX_TO_HIMET_X(x, xres)   ( (Int32)((x)*2540*(1.0/(xres)) + 0.5))
#define PIX_TO_HIMET_Y(y, yres)   (-(Int32)((y)*2540*(1.0/(yres)) + 0.5))
#define PIX_TO_HIMET_W(w, xres)   ( (Int32)((w)*2540*(1.0/(xres)) + 0.5))
#define PIX_TO_HIMET_H(h, yres)   ( (Int32)((h)*2540*(1.0/(yres)) + 0.5))

#define HIMET_TO_PIX_X_IP(x, xres) (x)=((Int32)((  x )*(xres)*(1.0/2540) +0.5))
#define HIMET_TO_PIX_Y_IP(y, yres) (y)=((Int32)((-(y))*(yres)*(1.0/2540) +0.5))
#define HIMET_TO_PIX_W_IP(w, xres) (w)=((Int32)((  w )*(xres)*(1.0/2540) +0.5))
#define HIMET_TO_PIX_H_IP(h, yres) (h)=((Int32)((  h )*(yres)*(1.0/2540) +0.5))

#define PIX_TO_HIMET_X_IP(x, xres) (x)= ((Int32)((x)*2540*(1.0/(xres)) + 0.5))
#define PIX_TO_HIMET_Y_IP(y, yres) (y)=-((Int32)((y)*2540*(1.0/(yres)) + 0.5))
#define PIX_TO_HIMET_W_IP(w, xres) (w)= ((Int32)((w)*2540*(1.0/(xres)) + 0.5))
#define PIX_TO_HIMET_H_IP(h, yres) (h)= ((Int32)((h)*2540*(1.0/(yres)) + 0.5))


#ifdef _MSC_VER
#pragma pack(pop, himetric_h)
#endif

#endif /* _HIMETRIC_H_INCLUDED_ */

/*
$Log: himetric.h,v $
Revision 1.1.1.1  1999/09/20 18:19:11  jlin
Imported sources

Revision 1.2  1998/10/02 18:25:52  aber
himetric.h -> /product/ipcore/ipwrap/include/RCS/himetric.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.1  1996/01/27 22:21:46  ejaquith
Initial revision

 */
