/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */
/*
** File:        histo.h
**
** Description: Definition of histograms together with macros and
**              prototypes of handling routines
**
** Author:      Luc Vincent
** Hacked into IPWRAP by P. MacLeod
**
*/


#ifndef HISTO_INCLUDED
#define HISTO_INCLUDED

#ifdef _MSC_VER
#pragma pack(push, histo_h, 1)
#endif

IP_RCSINFO(histo_h_RCSInfo, "$RCSfile: histo.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:11 $ */

/************************************************************
 ********************** TYPE DEFINITION *********************
 ************************************************************/

typedef struct {
    Int32  minval;   /* minimal value represented in the histogram */
    Int32  maxval;   /* maximal value represented in the histogram */
    Int32 *array;    /* pointer to array of data allocated for histogram */
    Int32  size;     /* size of histograms (how many bins allocated) */
    Int32 *data;     /* histogram data. In fact, pointer to the
		        bin that would contain the # of pixels at
			value 0 (even though minval may be != 0).
			This speeds up and simplified access to data */
} Histo;

#define HISTO_GET_MINVAL(histo)     ((histo)->minval)
#define HISTO_SET_MINVAL(histo, v)  HISTO_GET_MINVAL(histo) = (Int32) (v)

#define HISTO_GET_MAXVAL(histo)     ((histo)->maxval)
#define HISTO_SET_MAXVAL(histo, v)  HISTO_GET_MAXVAL(histo) = (Int32) (v)

#define HISTO_GET_ARRAY(histo)      ((histo)->array)
#define HISTO_SET_ARRAY(histo, a)   HISTO_GET_ARRAY(histo) = (Int32 *) (a)

#define HISTO_GET_SIZE(histo)       ((histo)->size)
#define HISTO_SET_SIZE(histo, s)    HISTO_GET_SIZE(histo) = (Int32) (s)

#define HISTO_GET_DATA(histo)       ((histo)->data)
#define HISTO_SET_DATA(histo, d)    HISTO_GET_DATA(histo) = (Int32 *) (d)

#ifdef _MSC_VER
#pragma pack(pop, histo_h)
#endif

#endif /* HISTO_INCLUDED */

/*
 * $Log: histo.h,v $
 * Revision 1.1.1.1  1999/09/20 18:19:11  jlin
 * Imported sources
 *
 * Revision 1.6  1998/10/02 18:25:54  aber
 * histo.h -> /product/ipcore/ipwrap/include/RCS/histo.h,v
 *
 * CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
 * using libraries and includes.
 *
 * Revision 1.5  1995/12/13 04:08:12  ejaquith
 * histo.h -> /product/ipcore/ipwrap/include/RCS/histo.h,v
 *
 * CommonCheck: Added ";" to IP_RCSINFO().
 * Removed function comment blocks from before prototypes and
 * added special prototype comment.
 *
 * Revision 1.4  1995/08/31  22:03:17  ejaquith
 * histo.h -> /product/ipcore/ipwrap/include/RCS/histo.h,v
 *
 * CommonCheck: Stripped all #includes.
 * Changed IPState to IPWState.
 *
 * Revision 1.3  1995/07/31  17:45:14  dferrell
 * histo.h -> /product/ipcore/ipwrap/include/RCS/histo.h,v
 *
 * First iteration of IPWrap transmogrification.
 *
 *
 */
