/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


/* internal.h  --  internal memory format for scanned images */
 
#ifndef INTERNAL_H
#define INTERNAL_H

#ifdef _MSC_VER
#pragma pack(push, internal_h, 1)
#endif

IP_RCSINFO(internal_h_RCSInfo, "$RCSfile: internal.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:11 $ */

/* This password is version 2.0 */
#define PASSWORD ('V' << 24) + (VERSION << 16) + ('.' << 8) + RELEASE
#define VERSION '2'
#define RELEASE '0'
#define OLDPASSWORD ('V' << 24) + (OLDVERSION << 16) + ('.' << 8) + OLDRELEASE
#define OLDVERSION '1'
#define OLDRELEASE '3'
#define CTRL_L          '\014'          /* control-L (seperator) */
#define VERSION_NUMBER  "2.0"           /* valid version number */
 
/* This header is sent in front of the data */
struct header {
  int length;
  int password;
  int pixels;
  int scanlines;
  int bytesperSL;
  int bitsperPixel;
  unsigned dummy : 1;
  unsigned histoValid : 1;
  unsigned imageExists : 1;
  unsigned maskExists : 1;
  int maskbytesperSL;
  int maskbitsperPixel;
  int maskmaxValue;
  int whiteValue;
  int blackValue;
  int trcLength;
  };
 
 
/* Structure of TRC knots for adjusting pixel values. */
struct knot {
  double input;
  double output;
  };
 



typedef struct item
   {
   char   *string;
   struct item   *next;
   struct item   *head;
   struct item   *tail;
   } HEADER;
#endif



/* public functions */
HEADER   *readheader();
HEADER   *copyheader();
HEADER   *createheader();
HEADER   *getheaderdefaults();
char   *getheaderparam();
int   getfield();
int   imageValid();
int   maskValid();
void   checkheader();
void   restrictheader();
void   writeheader();
void   freeheader();
void   setparam();
void   deleteparam();
struct header   *getheader();
void   putheader();

#define HEADER_NOTHING_PRESENT      0
#define HEADER_SECTION_PRESENT      1
#define HEADER_FIELD_PRESENT      2
#define HEADER_ALL_PRESENT      3

#define SP_UNDEFINED    0x00
#define SP_CHAR         0x01
#define SP_UCHAR        0x02
#define SP_INT          0x03
#define SP_LONG         0x04
#define SP_FLOAT        0x05
#define SP_DOUBLE       0x06
#define SP_OCTAL        0x07
#define SP_HEX          0x08
#define SP_FCOMPLEX     0x09
#define SP_DCOMPLEX     0x0a
#define SP_SHORT        0x0b
#define SP_USHORT       0x0c
#define SP_UINT         0x0d


#ifdef _MSC_VER
#pragma pack(pop, internal_h)
#endif

/* Change Log
 *
 * K. Knox, 20-Jul-84 17:59:13, Created first version.
 * K. Knox, 21-Aug-84 17:09:38, Added "imageExists" and "trcLength".
 * K. Knox, 23-Aug-84 16:07:28, Added total byte "length" of header & TRC.
 * K. Knox, 31-Aug-84 12:42:49, Added "whiteValue" and "blackValue".
 * K. Knox, 22-Sep-86 12:42:49, Replaced the "signed" parameter with "dummy".
 * J. Bollman, 16-Mar-89, added ifndef around file
 * B. Fuss, 23-May-89, added 2.0 capabilities, changed PASSWORD
 * B. Fuss, 22-Jan-90, added support for SP_{SHORT, USHORT, UINT}.
 *
 *
 */

/*

$Log: internal.h,v $
Revision 1.1.1.1  1999/09/20 18:19:11  jlin
Imported sources

Revision 1.8  1998/10/02 18:26:02  aber
internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.7  1995/12/13 04:08:35  ejaquith
internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v

CommonCheck: Added ";" to IP_RCSINFO().
Removed function comment blocks from before prototypes and
added special prototype comment.

 * Revision 1.6  1995/08/31  22:03:25  ejaquith
 * internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v
 * internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v
 *
 * CommonCheck: Stripped all #includes.
 * Changed IPState to IPWState.
 *
 * Revision 1.5  1995/07/31  18:00:10  ejaquith
 * internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v
 *
 * Standardizing changes -- first pass.
 *
 * Revision 1.4  1994/09/08  00:33:56  lperry
 * internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v
 *
 * Remove Date from RCS macro. Test for redundant types.pub includes.
 *
 * Revision 1.3  1993/12/03  01:10:27  ddavies
 * internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v
 *
 * Put RCS magic into macro that doesn't generate compiler warnings.
 *
 * Revision 1.2  1993/11/06  03:00:44  ddavies
 * internal.h -> /product/ipcore/ipwrap/include/RCS/internal.h,v
 *
 * Add RCS strings so file's name, revision and date appear in the object file.
 * Also automatically add a change log at the bottom of the file.
 *

*/

