/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


/* 
 *  iodef.h:  i/o globals
 *
 */

#ifndef  IODEF_H_INCLUDED
#define  IODEF_H_INCLUDED

#ifdef _MSC_VER
#pragma pack(push, iodef_h, 1)
#endif

IP_RCSINFO(iodef_h_RCSInfo, "$RCSfile: iodef.h,v $; $Revision: 1.2 $");
/* $Date: 2000/02/29 00:24:37 $ */

/* directory indicators in filepath */
#ifdef macintosh
#define DIR_SEP_STRING ":"
#define DIR_SEP_CHAR ':'
#endif
#ifdef __WINDOWS_386__
#define DIR_SEP_STRING "\\"
#define DIR_SEP_CHAR '\\'
#endif
#ifdef _WIN32
#define DIR_SEP_STRING "\\"
#define DIR_SEP_CHAR '\\'
#endif
#ifdef __NT__
#define DIR_SEP_STRING "\\"
#define DIR_SEP_CHAR '\\'
#endif
#ifdef _UNIX_
#define DIR_SEP_STRING "/"
#define DIR_SEP_CHAR '/'
#endif
#ifdef arm
#define DIR_SEP_STRING "/"
#define DIR_SEP_CHAR '/'
#endif

#ifdef _MSC_VER
#pragma pack(pop, iodef_h)
#endif

#endif  /* IODEF_H_INCLUDED */

/*

$Log: iodef.h,v $
Revision 1.2  2000/02/29 00:24:37  jlin
Add strong arm related changes

 * Revision 1.1.1.1  1999/09/20  18:19:12  jlin
 * Imported sources
 *
Revision 1.14  1998/10/02 18:26:06  aber
iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.13  1996/01/17 23:12:58  ddavies
iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v

If we're compiling for WATCOM 10.5 on NT, use the __NT__ var to set
DIR_SEP_STRING to \ and DIR_SEP_CHAR to \.

 * Revision 1.12  1995/12/13  04:08:51  ejaquith
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * CommonCheck: Added ";" to IP_RCSINFO().
 * Removed function comment blocks from before prototypes and
 * added special prototype comment.
 *
 * Revision 1.11  1995/10/18  04:09:40  ddavies
 * ddavies on Tue Oct 17 21:09:09 PDT 1995
 *
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Add DIR_SEP_STRING for WIN32 (Microsoft Visual C++) systems.
 *
 * Revision 1.10  1995/08/31  22:03:28  ejaquith
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * CommonCheck: Stripped all #includes.
 * Changed IPState to IPWState.
 *
 * Revision 1.9  1995/07/29  02:04:01  jcraig
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * first rev of cleanup change
 *
 * Revision 1.8  1994/09/08  00:34:01  lperry
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Remove Date from RCS macro. Test for redundant types.pub includes.
 *
 * Revision 1.7  1994/08/26  01:48:38  lperry
 * lperry on Thu Aug 25 18:47:28 PDT 1994
 *
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Removed external declarations for struct FileHeader
 * and FiletypeString variables as these ae now longer globals.
 *
 * Revision 1.6  1994/05/05  01:01:47  ddavies
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Add "const" to declaration of FiletypeString.
 *
 * Revision 1.5  1994/02/12  02:03:35  dferrell
 * dferrell on Fri Feb 11 18:03:06 PST 1994
 *
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Fixed problem with DIR_SEP_CHAR definition.
 *
 * Revision 1.4  1994/02/12  01:22:31  dferrell
 * dferrell on Fri Feb 11 17:21:44 PST 1994
 *
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Added #defines for directory path separators (/, \, :).
 *
 * Revision 1.3  1993/12/03  01:10:32  ddavies
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Put RCS magic into macro that doesn't generate compiler warnings.
 *
 * Revision 1.2  1993/11/06  03:00:56  ddavies
 * iodef.h -> /product/ipcore/ipwrap/include/RCS/iodef.h,v
 *
 * Add RCS strings so file's name, revision and date appear in the object file.
 * Also automatically add a change log at the bottom of the file.
 *

*/

