/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */
/*
 *
 *    pcx.h
 *
 *
 *    PCX DIL structures
 *
 *
 *    ImageMan Image Processing Library
 *
 *    Copyright (c) 1991 Data Techniques, Inc.
 *		All Rights Reserved
 *
 *
 *Revision-History
 *  1 PCX.H 7-Mar-90,11:37:58,`JGD' Version 1.0 Release
 *  2 PCX.H 1-May-91,10:09:08,`THK' Added PCXPAL typedef.
 *  3 PCX.H 23-Jul-91,14:31:10,`JGD' V 1.00 Src Release
 *Revision-History
 */


/*Keyword-Flag   "%v %f %w %n"
 * "3 23-Jul-91,14:31:10 JGD PCX.H"
 */

#ifndef PCX_H
#define PCX_H


#ifdef _MSC_VER
#pragma pack(push, pcx_h, 1)
#endif



/* header definitions for .pcx files */

typedef struct pcxheadTAG {
	char man; 	       /* 10==PC Paintbrush PCX */
	char ver;			 /* 0=2.5,2=2.8 w/pal info,3=2.8 w/o info,5=3.0 w/palette info */
	char enc;          /* encoding scheme - 1=PCX run-length encoding */
	char bits;         /* bits/pixel per color plane  */
	short win[4];		 /* dimension of picture (xmin,ymin),(xmax,ymax) */
	short  hrez;		    /* horizontal resolution of display device */
	short  vrez;			 /* vertical resolution of display device */
	unsigned char colmap[48]; /* color palette for 16 colors (intensity 0..255)*3 */
	char reserved;     
    char nplanes;		 /* # of color planes in original image */
	short byteline;     /* # of bytes per scan line in the image */
	short  palinfo;		 /* palette info - 1 = color/BW, 2 = grayscale */
	char filler[58];   
} pcxhead;

typedef pcxhead FAR *LPPCXHEAD;

typedef struct tagPCXPAL {
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} PCXPAL;

/* imgxpcx.h */
#define EXP_NOOPEN		1		/* unable to open file */
#define EXP_WRITE_HEAD	2		/* unable to write header */
#define EXP_WRITE			3		/* error during writing of data */

int IMXDLbegin_write( GDATA *pcx_param, void *ft );
int FillPCXHead(LPPCXHEAD pPCX, GDATA *lpDIB);
void pcx_write_open( GDATA *pcx_param, void *ft );
int write_pcx_line( void *fptr, GDATA *phdr, char *in_bufr );
void pcx_close( void *ft );
void pcx_write_palette( void *ft, GDATA *phdr );
int write_line( char *p, void *fp, unsigned int n );
int OpenFile( UINT fuMode, void *fu );
int _lclose( HFILE hf );
UINT _lwrite( void *hf, char *hpvBuffer, UINT cbBuffer );
void clr_mem( char *start, int length );
int pcx_read_open( GDATA *hptr, void *ft );
int pcx_read_line( GDATA *hptr, char *buf_ptr, void *fp );
int read_line( char *p, void *fp, int max );
int pcx_read_palette( char *p_addr, void *fptr );
int OpenPCX( GDATA *phdr, void *fptr, int mode );
int WritePCX( GDATA *phdr, char *buffer );
int ClosePCX( GDATA *phdr );
int ReadPCX( GDATA *phdr, char *gbuffer );
void pack24( char *bptr, UInt32 nBytesPerLine);
void unpack24( char *bptr, int blen );
/* ejaquith    commented this out and added to top of pcx.c: */
/*static void pcx_planes( unsigned char *pixels, unsigned char *bitplanes,
  int bytesperline, int planes, int bitsperpixel );*/
                        
  

#ifdef _MSC_VER
#pragma pack(pop, pcx_h)
#endif

#endif /* PCX_H */
