/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef PTYPES_H
#define PTYPES_H

#ifdef _MSC_VER
#pragma pack(push, ptypes_h, 1)
#endif

#define LPSTR char *
#define FAR
#define NEAR 
#define PASCAL
#define HANDLE char **
#define TRUE 1
#define FALSE 0
#define GHND 1
#define VOID void

#ifdef PCX
#define IMXDLget_ext PCXget_ext
#define IMXDLget_ver PCXget_ver
#define IMXDLbegin_write PCXbegin_write
#define IMXDLwrite_block PCXwrite_block
#define IMXDLend_write PCXend_write
#define set_error PCXset_error
#endif

#ifdef BMP
#define IMXDLget_ext BMPget_ext
#define IMXDLget_ver BMPget_ver
#define IMXDLbegin_write BMPbegin_write
#define IMXDLwrite_block BMPwrite_block
#define IMXDLend_write BMPend_write
#define set_error BMPset_error
#endif

/* OpenFile() Flags */

#define OF_READ 	    0x0000
#define OF_WRITE	    0x0001
#define OF_READWRITE	    0x0002
#define OF_SHARE_COMPAT	    0x0000
#define OF_SHARE_EXCLUSIVE  0x0010
#define OF_SHARE_DENY_WRITE 0x0020
#define OF_SHARE_DENY_READ  0x0030
#define OF_SHARE_DENY_NONE  0x0040
#define OF_PARSE	    0x0100
#define OF_DELETE	    0x0200
#define OF_VERIFY	    0x0400  
#define OF_SEARCH	    0x0400	
#define OF_CANCEL	    0x0800
#define OF_CREATE	    0x1000
#define OF_PROMPT	    0x2000
#define OF_EXIST	    0x4000
#define OF_REOPEN	    0x8000

typedef unsigned long DWORD;
typedef long LONG;
typedef unsigned int WORD;
typedef unsigned char BYTE;
typedef short BOOL;
typedef unsigned int UINT;
typedef void * HFILE;
typedef char * HGLOBAL;


#ifdef BMP_VERSION

typedef struct tagBITMAPINFOHEADER {

    Int32	biSize;		/* size of the BITMAPINFOHEADER structure */
    Int32	biWidth;	/* bitmap width in pixels */
    Int32	biHeight;	/* bitmap height in pixels */
    Int16	biPlanes;	/* number of bitmap planes */
    Int16	biBitCount;	/* number of bits per pixel */
    Int32	biCompression;	/* compression format (0 == uncompressed) */
    Int32	biSizeImage;	/* size of image in bytes */
    Int32	biXPelsPerMeter; /* pixels per meter in x direction */
    Int32	biYPelsPerMeter; /* pixels per meter in y direction */
    Int32	biClrUsed; 	/* number of colors used */
    Int32	biClrImportant;	/* number of important colors used */
} BITMAPINFOHEADER;

#else /* BMP_VESION */

typedef struct tagBITMAPINFOHEADER
{
    DWORD   biSize;
    LONG    biWidth;
    LONG    biHeight;
    WORD    biPlanes;
    WORD    biBitCount;
    DWORD   biCompression;
    DWORD   biSizeImage;
    LONG    biXPelsPerMeter;
    LONG    biYPelsPerMeter;
    DWORD   biClrUsed;
    DWORD   biClrImportant;
} BITMAPINFOHEADER;

#endif /* BMP_VESION */


typedef BITMAPINFOHEADER *LPBITMAPINFOHEADER;

typedef struct tagnRGBQUAD
{
    BYTE    rgbBlue;
    BYTE    rgbGreen;
    BYTE    rgbRed;
    BYTE    rgbReserved;
} RGBQUAD;

typedef struct tagBITMAPINFO
{
    BITMAPINFOHEADER bmiHeader;
    RGBQUAD	     bmiColors[1];
} BITMAPINFO;
typedef BITMAPINFO FAR* LPBITMAPINFO;

/* OpenFile() Structure */
typedef struct tagOFSTRUCT
{
    BYTE cBytes;
    BYTE fFixedDisk;
    UINT nErrCode;
    BYTE reserved[4];
    char szPathName[128];
} OFSTRUCT;
typedef OFSTRUCT*       POFSTRUCT;
typedef OFSTRUCT NEAR* NPOFSTRUCT;
typedef OFSTRUCT FAR*  LPOFSTRUCT;

#ifdef BMP_VERSION

typedef struct tagBITMAPFILEHEADER {

    Int16	bfType;		/* file type; must be "BM" */
    Int16	bfSize;		/* length of the file;
				   sizeof(BITMAPFILEHEADER) +
				   sizeof(BITMAPINFOHEADER) +
				   size of color table +
				   size of DIB bits */
    Int16	bfFill1;	/* remainder of the bfSize field */
    Int16	bfReserved1;	/* don't care (set to 0)*/
    Int16	bfReserved2;	/* don't care (set to 0)*/
    Int16	bfOffBits;	/* offset from beginning of file
				   to first byte of image data */
    Int16	bfFill2;	/* remainder of the bfOffBits field */
} BITMAPFILEHEADER;

#else /* BMP_VERSION */

typedef struct tagBITMAPFILEHEADER
{
    UINT    bfType;
    DWORD   bfSize;
    UINT    bfReserved1;
    UINT    bfReserved2;
    DWORD   bfOffBits;
} BITMAPFILEHEADER;

#endif /* BMP_VERSION */


/* this really belongs in one of gfio .h file */
typedef struct tagToken
{
   char* filename;
   FILE* handle;
} Token;



/* from winsim.c */
int OpenFile( UINT fuMode, void *fu );
void clr_mem( char *start, int length );
UINT _lwrite( void *hf, char *hpvBuffer, UINT cbBuffer );



#ifdef _MSC_VER
#pragma pack(pop, ptypes_h)
#endif


#endif /* PTYPES_H */
