/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


/*
 * Description of header for files containing raster images
 */

#ifndef _RASTERFILE_H
#define _RASTERFILE_H

#ifdef _MSC_VER
#pragma pack(push, rastrfil_h, 1)
#endif


IP_RCSINFO(rastrfil_h_RCSInfo, "$RCSfile: rastrfil.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:12 $ */

struct rasterfile {
   int   ras_magic;      /* magic number */
   int   ras_width;      /* width (pixels) of image */
   int   ras_height;      /* height (pixels) of image */
   int   ras_depth;      /* depth (1, 8, or 24 bits) of pixel */
   int   ras_length;      /* length (bytes) of image */
   int   ras_type;      /* type of file; see RT_* below */
   int   ras_maptype;      /* type of colormap; see RMT_* below */
   int   ras_maplength;      /* length (bytes) of following map */
   /* color map follows for ras_maplength bytes, followed by image */
};
#define   RAS_MAGIC   0x59a66a95

   /* Sun supported ras_type's */
#define RT_OLD      0   /* Raw pixrect image in 68000 byte order */
#define RT_STANDARD   1   /* Raw pixrect image in 68000 byte order */
#define RT_BYTE_ENCODED   2   /* Run-length compression of bytes */
#define RT_FORMAT_RGB   3   /* XRGB or RGB instead of XBGR or BGR */
#define RT_FORMAT_TIFF   4   /* tiff <-> standard rasterfile */
#define RT_FORMAT_IFF   5   /* iff (TAAC format) <-> standard rasterfile */
#define RT_EXPERIMENTAL 0xffff   /* Reserved for testing */

   /* Sun registered ras_maptype's */
#define RMT_RAW      2
   /* Sun supported ras_maptype's */
#define RMT_NONE   0   /* ras_maplength is expected to be 0 */
#define RMT_EQUAL_RGB   1   /* red[ras_maplength/3],green[],blue[] */

/*
 * NOTES:
 *    Each line of the image is rounded out to a multiple of 16 bits.
 *   This corresponds to the rounding convention used by the memory pixrect
 *   package (/usr/include/pixrect/memvar.h) of the SunWindows system.
 *   The ras_encoding field (always set to 0 by Sun's supported software)
 *   was renamed to ras_length in release 2.0.  As a result, rasterfiles
 *   of type 0 generated by the old software claim to have 0 length; for
 *   compatibility, code reading rasterfiles must be prepared to compute the
 *   true length from the width, height, and depth fields.
 */

#ifdef _MSC_VER
#pragma pack(pop, rastrfil_h)
#endif

#endif /*!_rasterfile_h*/

/*

$Log: rastrfil.h,v $
Revision 1.1.1.1  1999/09/20 18:19:12  jlin
Imported sources

Revision 1.9  1998/10/05 19:12:45  aber
rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v

CommonCheck: Fix module name in all-encompassing ifdef to be upper-case, to avoid
naming conflict with packing pragma name.

Revision 1.8  1998/10/02 18:27:00  aber
rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v

CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
using libraries and includes.

Revision 1.7  1995/12/13 04:11:43  ejaquith
rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v

CommonCheck: Added ";" to IP_RCSINFO().
Removed function comment blocks from before prototypes and
added special prototype comment.

 * Revision 1.6  1995/08/31  22:04:01  ejaquith
 * rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v
 *
 * CommonCheck: Stripped all #includes.
 * Changed IPState to IPWState.
 *
 * Revision 1.5  1995/07/31  18:01:00  ejaquith
 * rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v
 *
 * Standardizing changes -- first pass.
 * Standardizing changes -- first pass.
 *
 * Revision 1.4  1994/09/08  00:35:47  lperry
 * rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v
 *
 * Remove Date from RCS macro. Test for redundant types.pub includes.
 *
 * Revision 1.3  1993/12/03  01:11:44  ddavies
 * rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v
 *
 * Put RCS magic into macro that doesn't generate compiler warnings.
 *
 * Revision 1.2  1993/11/06  03:03:07  ddavies
 * rastrfil.h -> /product/ipcore/ipwrap/include/RCS/rastrfil.h,v
 *
 * Add RCS strings so file's name, revision and date appear in the object file.
 *

*/

