/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


/* 
 *  streldef.h:  global names for structuring elements
 */

#ifndef  STRELDEF_H_INCLUDED
#define  STRELDEF_H_INCLUDED

#ifdef _MSC_VER
#pragma pack(push, streldef_h, 1)
#endif

IP_RCSINFO(streldef_h_RCSInfo, "$RCSfile: streldef.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:12 $ */


/*
  Note the use of the dummy values
  strelListStart and strelListEnd. These
  must always be the first and last entries. They are used
  to determine the number of values in the list.
  (end - start) provides one more than the number of values,
  and is used to size arrays. Element zero of the array
  won't be used, since its index is strelListStart
*/

typedef Int32 StrelID;

/* List start value */
#define strelListStart 0

/* Strels initialized by strel1Inits() */
#define strel2h 1
#define strel2v 2
#define strel3h 3
#define strel3v 4
#define strel4h 5
#define strel4v 6
#define strel5h 7
#define strel5v 8
#define strel6h 9
#define strel6v 10
#define strel7h 11
#define strel7v 12
#define strel8h 13
#define strel8v 14
#define strel9h 15
#define strel9v 16
#define strel10h 17
#define strel10v 18
#define strel11h 19
#define strel11v 20
#define strel15h 21
#define strel15v 22
#define strel19h 23
#define strel19v 24
#define strel20h 25
#define strel20v 26
#define strel25h 27
#define strel25v 28
#define strel30h 29
#define strel30v 30
#define strel35h 31
#define strel35v 32
#define strel40h 33
#define strel40v 34
#define strel45h 35
#define strel45v 36
#define strel50h 37
#define strel50v 38
#define strel1 39
#define strel2 40
#define strel3 41
#define strel4 42
#define strel5 43
#define strel2dp 44
#define strel2dm 45

/* Strels initialized by strel11Inits() */
#define s_pepper_1 46
#define s_pepper_2 47
#define s_pepper_3 48
#define s_pepper_4 49
#define s_salt_1 50
#define s_salt_2 51
#define s_salt_3 52
#define s_repl3 53
#define s_repl4 54
#define s_rulew9h7 55
#define s_ruleh9w7 56

/* Strels initialized by strel12Inits() */
#define strelF40h 57
#define strelF40v 58
#define s_4_2_t 59
#define strelItal1 60
#define strelHTR 61
#define strelVLT 62
#define s_v21_right 63
#define emptyStrel 64

/* 
  Define a member for unnamed strels, i.e. custom strels.
  This value will initially be assigned to a strel in the 
  createStrel function. It will be overwritten for any
  of the named strels. This will allow us to detect
  unnamed strels or strels which have not been generated
  under the control of the strel manager
*/
#define unknownStrel 65

/* List terminator - for counting purposes */
#define strelListEnd 66


#ifdef _MSC_VER
#pragma pack(pop, streldef_h)
#endif

#endif  /* STRELDEF_H_INCLUDED */
 
/*
 * $Log: streldef.h,v $
 * Revision 1.1.1.1  1999/09/20 18:19:12  jlin
 * Imported sources
 *
 * Revision 1.15  1998/10/02 18:27:18  aber
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
 * using libraries and includes.
 *
 * Revision 1.14  1995/12/13 04:12:38  ejaquith
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * CommonCheck: Added ";" to IP_RCSINFO().
 * Removed function comment blocks from before prototypes and
 * added special prototype comment.
 *
 * Revision 1.13  1995/09/05  18:20:25  dferrell
 * dferrell on Tue Sep 5 11:20:06 PDT 1995
 *
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Removed GET_STREL and GET_STREL_REFCOUNT macros.
 *
 * Revision 1.12  1995/08/31  22:04:10  ejaquith
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * CommonCheck: Stripped all #includes.
 * Changed IPState to IPWState.
 *
 * Revision 1.11  1995/08/30  22:58:48  dferrell
 * dferrell on Wed Aug 30 15:58:37 PDT 1995
 *
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * replaced enumeration of strel IDs with typedef Int32 and a bunch of
 * #defines.
 *
 * Revision 1.10  1995/08/30  17:03:56  ejaquith
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Modified the GET_STREL() and GET_STREL_REFCOUNT() macros to first
 * check that pIPWState is not NULL and that pIPWState->strelInfo is not
 * NULL before accessing the array in pIPWState->strelInfo.
 * If either condition is not true, we return NULL for the macro value.
 * (uh, on looking at this GET_STREL_REFCOUNT() should technically return
 * 0 explicitly, but noone uses this anyway!)
 *
 * Revision 1.9  1995/07/31  17:47:08  dferrell
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * First iteration of IPWrap transmogrification.
 *
 * Revision 1.8  1995/01/26  22:40:24  lperry
 * lperry on Thu Jan 26 14:39:42 PST 1995
 *
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Add enumeration member unknown Strel to the
 * StrelID enumeration.
 *
 * Revision 1.7  1995/01/24  22:57:47  lperry
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Change namedStrelxx enums to strelxx. Limit the
 * set of strels in the enumeration to those initialized
 * in strel1Inits(), strel11Inits() and strel12Inits().
 * Other strels can always be created but these are
 * separate instances, outside the strel manager.
 *
 * Revision 1.6  1994/12/08  04:40:12  ddavies
 * ddavies on Wed Dec 7 20:39:27 PST 1994
 *
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Add emptyStrel and strelEmptyStrel.  This is used to test our
 * ability to correctly handle a structure element containing only don't-care
 * terms.
 *
 * Revision 1.5  1994/09/08  00:36:24  lperry
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Remove Date from RCS macro. Test for redundant types.pub includes.
 *
 * Revision 1.4  1994/08/10  22:29:09  lperry
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Add globals for new strels and an enumerated type
 * "StrelID" containing the "names" of all predefined strels.
 *
 * Revision 1.3  1993/12/03  01:12:07  ddavies
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Put RCS magic into macro that doesn't generate compiler warnings.
 *
 * Revision 1.2  1993/11/06  03:03:49  ddavies
 * streldef.h -> /product/ipcore/ipwrap/include/RCS/streldef.h,v
 *
 * Add RCS strings so file's name, revision and date appear in the object file.
 * Also automatically add a change log at the bottom of the file.
 *
 */

