/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */


/*
*  tiffccut.h
*
*    Public function interface definitions for utility routines
*	used in CCITT MH, MR and MMR compression and decompression.
*	This file has a .h suffix so that coreCheckProtos won't
*	complain about the Leffler interface conventions.
*
*        Function prototypes
*        Necessary include files.
*        Constant and type definitions
*
*/

#ifndef _TIFFCCUT_H_INCLUDED_
#define _TIFFCCUT_H_INCLUDED_

IP_RCSINFO(tiffccut_h_RCSInfo, "$RCSfile: tiffccut.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:13 $ */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifdef _MSC_VER
#pragma pack(push, tiffccut_h, 1)
#endif

/* This routine will not be recognized by the automatic documentation code.
 * SourceLocation:: tiffccut.c */
int
ccittPreEncode (
    TIFF*               tif);

/* This routine will not be recognized by the automatic documentation code.
 * SourceLocation:: tiffccut.c */
int
ccittPreDecode (
    TIFF               *tif);

/* This routine will not be recognized by the automatic documentation code.
 * SourceLocation:: tiffccut.c */
void
ccittCleanup (
    TIFF               *tif);

/* This routine will not be recognized by the automatic documentation code.
 * SourceLocation:: tiffccut.c */
void
ccittClose (
    TIFF               *tif);

/* This routine will not be recognized by the automatic documentation code.
 * SourceLocation:: tiffccut.c */
int
ccittWriteEOLsAndFlush (
    TIFF               *tif,
    UInt32		numEOLs,
    UInt32		EOLType);


#ifdef _MSC_VER
#pragma pack(pop, tiffccut_h)
#endif

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _TIFFCCUT_H_INCLUDED_ */

/*

 $Log: tiffccut.h,v $
 Revision 1.1.1.1  1999/09/20 18:19:13  jlin
 Imported sources

 Revision 1.3  1998/10/02 18:27:26  aber
 tiffccut.h -> /product/ipcore/ipwrap/include/RCS/tiffccut.h,v

 CommonCheck: Updated copyright notice, and added pragma packing of 1 for clients
 using libraries and includes.

 Revision 1.2  1996/05/07 17:08:04  ejaquith
 ejaquith on Tue May 7 10:07:14 PDT 1996

 tiffccut.h -> /product/ipcore/ipwrap/include/RCS/tiffccut.h,v

 Added comment before each proto:
 This routine will not be recognized by the automatic documentation code.
 Changed "SourceLocation:::" to "SourceLocation::" so that it will in fact
 NOT be recognized.

 Revision 1.1  1996/05/01 23:59:17  ddavies
 Initial revision

 Revision 1.1  1996/05/01 23:37:30  ddavies
 Initial revision


 */

