/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef XIFINFO_H_INCLUDED
#define XIFINFO_H_INCLUDED

IP_RCSINFO(xifinfo_hRCSInfo, "$RCSfile: xifinfo.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:13 $ */

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, xifinfo_h, 1)
#endif

/* xifinfo.h
 *
 * DESCRIPTION
 *	 Declarations for XIFF information
 *
 */

/*
 * INCLUDES
 */

/*
 * CONSTANTS
 */

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * XIF Document information
 *
 * The following structure describes the data returned by the
 * XIF_GetDocInfo() function.
 */
typedef struct XIF_DOCINFO
{
    UInt8 version;			/* Version of XIFF */
    UInt8 revision;			/* Revision of this version of XIFF */
    UInt16 wNPages;			/* Number of pages in file */
    Int8 *pAuthorBlock;			/* Author string (NULL if none) */
    UInt16 wAuthorBlockBytes;		/* Size of author string */
    Int32 dwReferencePageOffset;	/* Reference page offset (-1 if none) */
    XIF_DOCHANDLE xDocHandle;		/* Document handle, used to identify
					 * this document in the document level
					 * routines */
} XIF_DOCINFO;


/*
 * XIF Page Information
 *
 * The following structure describes the data returned by the
 * XIF_GetPageInfo() function.
 */
typedef struct XIF_PAGEINFO
{
    Int32 dwPageOffset;			/* Page offset */
    UInt32 *pdwImageCounts;		/* Image count for each layer */
    UInt32 dwLayersPresent;		/* Number of layers present (may
					 * include empty layers) */
    UInt16 wAnnotationCount;		/* Number of annotations on page */
    XIF_IMGHANDLE xPrimImgHandle;	/* Primary image handle */
    XIF_PAGEHANDLE xPageHandle;		/* Page handle, used to identify this
					 * page in the page level routines */
} XIF_PAGEINFO;


/*
 * XIF Image information
 *
 * The following structure describes the data returned by the
 * XIF_GetImageInfo() function.
 */
typedef struct XIF_IMGINFO
{
    XIF_IMGHANDLE xImgHandle;		/* Image handle to this image */
    XIF_IMGTYPE xImgType;		/* Image type (XIF_IMGTYPE_PRIMARY,
					 * XIF_IMGTYPE_LAYER or
					 * XIF_IMGTYPE_MASK) */
    UInt32 dwImgLayer;			/* Image layer in the MRC model */
    UInt32 dwImgOffset;			/* Image offset within the layer */
    UInt32 dwXOffset;			/* X location in page coordinates */
    UInt32 dwYOffset;			/* Y location in page coordinates */
    UInt32 dwXResolution;		/* X Resolution of image in dpm */
    UInt32 dwYResolution;		/* Y Resolution of image in dpm */
    UInt32 dwWidth;			/* Width in image's X resolution units
					 */
    UInt32 dwHeight;			/* Height in image's Y resolution units
					 */
    UInt32 dwBestStripHeight;		/* For best performance, read strips
					 * with height a multiple of this. */
    XIF_COMPRESSION xCompression;	/* Compression type for src/dst */
    XIF_COLORTYPE xColorType;		/* Color type (see XIF_COLORTYPE) */
    UInt8 pPalette[256*3];		/* Color palette if XIF_COLORTYPE is:
					 * XIF_COLORTYPE_COLOR4 or
					 * XIF_COLORTYPE_COLOR8.
					 * Palette is RGB triples (chunky):
					 * RGBRGB... */
    UInt32 dwMaskImages;		/* Number of mask images */
} XIF_IMGINFO;


/*
 * XIF Annotation information
 *
 * The following structure describes the data returned by the
 * XIF_GetAnnotInfo() function.
 */
typedef struct XIF_ANNOTINFO
{
    UInt16 wAnnotType;			/* Type of annotation */
    UInt32 dwXOffset;			/* Offset in X direction in page
					 * coordinates */
    UInt32 dwYOffset;			/* Offset in X direction in page
					 * coordinates */
    UInt32 dwWidth;			/* Width in page coordinates */
    UInt32 dwHeight;			/* Height in page coordinates */
    UInt32 dwFlags;			/* Annotation flags (see xiff.h) */
    UInt32 dwAnnotLength;		/* Length of annotation data, in bytes
					 */
} XIF_ANNOTINFO;


/*
 * PROTOTYPES
 */


#ifdef _MSC_VER
#pragma pack(pop, xifinfo_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* XIFINFO_H_INCLUDED */
