/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef XIFRTOK_H_INCLUDED
#define XIFRTOK_H_INCLUDED

IP_RCSINFO(xifrtok_hRCSInfo, "$RCSfile: xifrtok.h,v $; $Revision: 1.1.1.1 $");
/* $Date: 1999/09/20 18:19:13 $ */

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, xifrtok_h, 1)
#endif

/* xifrtok.H
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/* This defines the offsets of the items within the position block header */
#define cXifTCPosPositionVersion	0
#define cXifTCPosPositionSize		cXifTCPosPositionVersion + 1
#define cXifTCPosPositionDictCount	cXifTCPosPositionSize + 4
#define cXifTCPosPositionDictIDs	cXifTCPosPositionDictCount + 2

/* This defines the offsets of the items within the token dictionary header */
#define cXifTCPosDictVersion	    0
#define cXifTCPosDictSize	    cXifTCPosDictVersion + 1

/* Define the position block and dictionary versions currently exported */
#define cXifTCPositionVersion   0
#define cXifTCDictVersion	0

/*
 * MACROS
 */

/*
 * TYPEDEFS
 */

/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */
ErrCode CDECL
wp_XifDetokenizeImage(XImg *xImg, UInt8 *pCmpData, UInt32 dwCmpBytes,
		   UInt8 *pImgData, UInt32 dwBytesPerRow);
ErrCode CDECL
wp_XifReadTokenDictionary(XDoc *xDoc, UInt32 dictNum);
ErrCode CDECL
wp_XifInterpretTokenHeader(XFile *xFile, UInt8 *pCmpData, UInt32 dwCmpBytes,
    UInt16 *pdwDictCount, UInt32 **ppdwDictIDs, UInt8 **ppTundraData,
    UInt32 *pdwTundraBytes);

#ifdef _MSC_VER
#pragma pack(pop, xifrtok_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* XIFRTOK_H_INCLUDED */
