/*
 * Trade secret of ScanSoft, Inc.
 * Copyright (c) 1991-1998, ScanSoft, Inc.  All rights reserved.
 * Copyright protection claimed includes all forms and matters of 
 * copyrightable material and information now allowed by statutory or 
 * judicial law or hereinafter granted; including, without limitation,
 * material generated from the software programs which are displayed on 
 * the screen such as icons, screen display looks, etc.
 */

#ifndef XIFXTIFF_H_INCLUDED
#define XIFXTIFF_H_INCLUDED

IP_RCSINFO(xifXTIFF_hRCSInfo, "$RCSfile: xiftiff.h,v $; $Revision: 1.2 $");
/* $Date: 2000/02/29 00:24:37 $ */

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef _MSC_VER
#pragma pack(push, xiftiff_h, 1)
#endif

/* xiftiff.h
 *
 */

/*
 * INCLUDES
 */


/*
 * CONSTANTS
 */

/* TIFF equates for Tag names and Field types */

/* Byte orders */
#define II      0x4949
#define MM      0x4D4D

#if defined (__WATCOMC__) || defined (_WIN32) || defined(WIN32) || defined(arm)
#define NATIVEORDER II
#else
#define NATIVEORDER MM
#endif
 
/* Public Tags */
#define NEWSUBFILETYPE			254
#define SUBFILETYPE			255
#define IMAGEWIDTH			256 
#define IMAGELENGTH			257
#define BITSPERSAMPLE			258
#define COMPRESSION			259
#define PHOTOMETRICINTERPRETATION	262
#define THRESHHOLDING			263
#define CELLWIDTH			264
#define CELLLENGTH			265
#define FILLORDER			266
#define DOCUMENTNAME			269
#define IMAGEDESCRIPTION		270
#define MAKE				271
#define MODEL				272
#define STRIPOFFSETS			273
#define ORIENTATION			274
#define SAMPLESPERPIXEL			277
#define ROWSPERSTRIP			278
#define STRIPBYTECOUNTS			279
#define MINSAMPLEVALUE			280
#define MAXSAMPLEVALUE			281
#define XRESOLUTION			282
#define YRESOLUTION			283
#define PLANARCONFIGURATION		284
#define PAGENAME			285
#define XPOSITION			286
#define YPOSITION			287
#define FREEOFFSETS			288
#define FREEBYTECOUNTS			289
#define GRAYRESPONSEUNIT		290
#define GRAYRESPONSECURVE		291
#define T4OPTIONS			292
#define T6OPTIONS			293
#define RESOLUTIONUNIT			296
#define PAGENUMBER			297
#define COLORRESPONSEUNIT		300
#define TRANSFERFUNCTION		301
#define SOFTWARE			305
#define DATETIME			306
#define ARTIST				315
#define HOSTCOMPUTER			316
#define PREDICTOR			317
#define WHITEPOINT			318
#define PRIMARYCHROMATICITIES		319
#define COLORMAP			320
#define HALFTONEHINTS			321
#define TILEWIDTH			322
#define TILELENGTH			323
#define TILEOFFSETS			324
#define TILEBYTECOUNTS			325
#define SUBIFDS				330
#define INKSET				332
#define INKNAMES			333
#define NUMBEROFINKS			334
#define DOTRANGE			336
#define TARGETPRINTER			337
#define EXTRASAMPLES			338
#define SAMPLEFORMAT			339
#define SMINSAMPLEVALUE			340
#define SMAXSAMPLEVALUE			341
#define TRANSFERRANGE			342
 
#define JPEGPROC			512
#define JPEGINTERCHANGEFORMAT		513
#define JPEGINTERCHANGEFORMATLENGTH	514
#define JPEGRESTARTINTERVAL		515
#define JPEGLOSSLESSPREDICTORS		517
#define JPEGPOINTTRANSFORMS		518
#define JPEGQTABLES			519
#define JPEGDCTABLES			520
#define JPEGACTABLES			521
#define YCBCRCOEFFICIENTS		529
#define YCBCRSUBSAMPLING		530
#define YCBCRPOSITIONING		531
#define REFERENCEBLACKWHITE		532
#define COPYRIGHT			33432
#define ANNOTATIONOFFSETS		34730   /* private Xerox tag */
#define MASKIFDS			34731   /* private Xerox tag (XIFF 2.0 only) */
#define IMAGELAYER			34732   /* private Xerox tag */
#define IMAGELAYERCONTENT		34733   /* private Xerox tag */
#define RESERVEDTAG			34734   /* private Xerox tag */

 
/* Data Types */
#define IFDBYTE				1
#define IFDASCII			2
#define IFDSHORT			3
#define IFDLONG				4
#define IFDRATIONAL			5
#define IFDSBYTE			6
#define IFDUNDEFINED			7
#define IFDSSHORT			8
#define IFDSLONG			9
#define IFDSRATIONAL			10
#define IFDFLOAT			11
#define IFDDOUBLE			12

/* Resolution Units */
#define NONE				1
#define INCHES				2
#define CENTIMETERS			3
 
/* compression constants */
#define XTIFF_NOCOMPRESSBYTE	1       /* No compression, byte aligned */
#define XTIFF_CCITT3		2       /* CCITT Group 3 1-Dimensional */
#define XTIFF_FAXCCITT3		3       /* Fax Compatible CCITT Group 3 */
#define XTIFF_FAXCCITT4		4       /* Fax Compatible CCITT Group 4 */
#define XTIFF_LZW		5       /* LZW compression */
#define XTIFF_JPEG		6       /* JPEG compression */
#define XTIFF_FAXCCITT3_MR	7       /* CCITT Group 3 Fax 2-Dimensional */
#define XTIFF_NOCOMPRESSWORD	32771   /* No compression, word aligned */
#define XTIFF_PACKBITS		32773   /* Packbits compression */
#define XTIFF_XEROX_TOKENIZATION	34667   /* Tokenization (symbols only) */
#define XTIFF_XEROX_WAVELET	34668   /* Wavelet */
#define XTIFF_XEROX_HVQ		34669   /* Hierarchical vector quantization */
#define XTIFF_XEROX_LZ77		34670	/* Xerox's Lempel-Ziv 77 */
#define XTIFF_XEROX_LOSSYDITHER	34672   /* Lossy Dither
					 * Note, these images require special
					 * image processing to reapply them to
					 * the image they were extracted from
					 * (base image):
					 * 1. Morphological "open" with a 3x3
					 *   strel, keep opened and original
					 *   around.
					 * 2. XOR the opened with the base
					 *   image.
					 * 3. SUBTRACT (and with the inverse)
					 *   the opened image from the original
					 *   image.
					 * 4. OR the subtracted image with the
					 *   base image.
					 */
#define XTIFF_XEROX_LLTOKENIZATION 34673/* Lossless Tokenization (symbols only)
					 */

/* Photometric interpretation values */
#define XTIFF_PHOTOMETRIC_WHITEISZERO	0   /* 0 = white */
#define XTIFF_PHOTOMETRIC_BLACKISZERO	1   /* 0 = black */
#define XTIFF_PHOTOMETRIC_RGB		2   /* Values are RG&B,
					     * black = (0,0,0) */
#define XTIFF_PHOTOMETRIC_PALETTE	3   /* Values are indices to a color
					     * palette */
#define XTIFF_PHOTOMETRIC_TRANSPARENCY	4   /* 0 = transparent, 1 = opaque */
#define XTIFF_PHOTOMETRIC_CMYK		5   /* CMYK photometry */
#define XTIFF_PHOTOMETRIC_YCBCR		6   /* YCbCr photometry */

/* Planar configurations */
#define XTIFF_PLANAR_CHUNKY		1   /* RGBRGBRGB... */
#define XTIFF_PLANAR_PLANES		2   /* RRR...RGGG...GBBB...B */

/* NewSubFileTypes */
#define XTIFF_SUBFILE_LOWERRES		0x01   /* Is a reduced resolution
						* version of another */
#define XTIFF_SUBFILE_MULTIPAGE		0x02   /* Is a single page of a multi
						* page document */
#define XTIFF_SUBFILE_MASK		0x04   /* Is a transparency mask */
#define XTIFF_SUBFILE_MRC		0x10   /* Is a part of Mixed Raster
						* Content page */


/*
 * MACROS
 */
#define Rational2Long(rat)	\
	(rat.denominator? (long)(((long)rat.numerator + \
				  ((long)rat.denominator >> 1)) / \
				 (long)rat.denominator): 0L)
#define Rational2Float(rat)	\
	(rat.denominator != 0.0? (float)rat.numerator / \
	 (float)rat.denominator: 0.0)

/*
 * TYPEDEFS
 */

typedef struct TiffHeader {
    UInt16 byteOrder;
    UInt16 version;
    UInt32 firstIfd;
} TiffHeader;

typedef struct TiffFile {
    void* file;
    UInt16 byteOrder;
    Int32 firstIfd;
    Int32 pageIFD;
} TiffFile;

typedef struct FieldEntry {  /* structure of a TIFF directory entry */
    UInt16 tagID;
    UInt16 type;
    UInt32 len;
    UInt32 offset;
    void* data;
} FieldEntry;
#define XTIFF_FIELDSIZE	    12	    /* 12 bytes per field entry */

typedef struct {
    UInt32 numerator;
    UInt32 denominator;
} Rational;

typedef struct {
    Int32 numerator;
    Int32 denominator;
} SignedRational;

/* Image Layer Content, found in primary IFD */
typedef struct ILContent {
    UInt32 layersPresent;	    /* Number of layers mentioned */
    UInt32 *imageCounts;	    /* Number of image each layer. Note:
				     * layer 2 count does not include the
				     * primary IFD. */
} ILContent;

/*
typedef float	Float32;
typedef double	Float64;
*/


/* The fields that should be used by normal users of this library are
 *   ImageWidth - the width of the image in pixels
 *   ImageLength - the height of the image in pixels
 *   type - XTIFF_BINARY: 1 bit image 
 *          XTIFF_GRAY16: 4 bit grayscale image
 *          XTIFF_GRAY256: 8 bit grayscale image
 *          XTIFF_PALETTE256: 8 bit image with a colormap
 *          XTIFF_FULLCOLOR: 24 bit image
 *          XTIFF_OTHER: some other type of image that can only be
s *                      determined by looking at other variables
 *   Xdpi, Ydpi - the resolution in both dimensions
 *   Xloc, Yloc - the location of the upper left corner in DPM
 *   RowsPerStrip - how much to break up the image, things are likely to
 *                  to go most efficiently if the data is read or written
 *                  in chunks of this many scanlines. It is also better
 *                  if this number is a multiple of 16.
 *
 */

typedef struct TiffFields{
    UInt8 dataTransferred;		/* the fields have been read/written */
    UInt16 fieldCount;			/* number of fields in the IFD */
    Int32 nextIFD;			/* file offset of the next IFD */

    Float64 Xdpi;                       /* derived value */
    Float64 Ydpi;                       /* derived value */
    Float64 Xloc;                       /* derived value, in inches */
    Float64 Yloc;                       /* derived value, in inches */
    Int16 type;				/* derived value */

    UInt16 Compression;			/* COMPRESSION */
    UInt16 PhotometricInterpretation;	/* PHOTOMETRICINTERPRETATION */
    UInt16 Orientation;			/* ORIENTATION */
    UInt16* GrayResponseCurve;		/* GRAYRESPONSECURVE */
    UInt16* HalftoneHints;		/* HALFTONEHINTS */
    UInt16 GrayResponseUnit;		/* GRAYRESPONSEUNIT */
    UInt16 SubFileType;			/* SUBFILETYPE */
    UInt16 NewSubFileType;		/* NEWSUBFILETYPE */
    UInt16 Threshholding;		/* THRESHHOLDING */
    UInt16 CellWidth;			/* CELLWIDTH */
    UInt16 CellLength;			/* CELLLENGTH */
    UInt16* MinSampleValue;		/* MINSAMPLEVALUE */
    UInt16* MaxSampleValue;		/* MAXSAMPLEVALUE */
    UInt16 PageCount;			/* PAGENUMBER [1] */
    UInt16 PageNumber;			/* PAGENUMBER [0] */

    /* layout of the uncompressed data */
    UInt16* BitsPerSample;		/* BITSPERSAMPLE */
    UInt16* SampleFormat;		/* SAMPLEFORMAT */
    UInt16 PlanarConfiguration;		/* PLANARCONFIGURATION */
    UInt16 SamplesPerPixel;		/* SAMPLESPERPIXEL */
    UInt16 FillOrder;			/* FILLORDER */
    
    /* The geometry of the image */
    UInt32 ImageWidth;			/* IMAGEWIDTH */
    UInt32 ImageLength;			/* IMAGELENGTH */
    Rational XPosition;                 /* XPOSITION */
    Rational YPosition;                 /* YPOSITION */
    Rational XResolution;               /* XRESOLUTION */
    Rational YResolution;               /* YRESOLUTION */
    UInt16 ResolutionUnit;		/* RESOLUTIONUNIT */

    /* Alpha information */
    UInt16 ExtraSamplesCount;		/* EXTRASAMPLES */
    UInt16* ExtraSamples;

    /* Palette color information */
    UInt16* Colormap;			/* COLORMAP */

    /* CCITT G3 & G4 stuff */
    UInt32 T4Options;			/* T4OPTIONS */
    UInt32 T6Options;			/* T6OPTIONS */

    /* LZW stuff */
    UInt16 Predictor;			/* PREDICTOR */

    /* JPEG Stuff */
    UInt16 JPEGProc;			/* JPEGPROC */
    UInt16 JPEGRestartInterval;		/* JPEGRESTARTINTERVAL */
    UInt32 JPEGInterchangeFormat;	/* JPEGINTERCHANGEFORMAT */
    UInt32 JPEGInterchangeFormatLength;	/* JPEGINTERCHANGEFORMATLENGTH */
    UInt16* JPEGLosslessPredictors;	/* JPEGLOSSLESSPREDICTORS */
    UInt16* JPEGPointTransforms;	/* JPEGPOINTTRANSFORMS */
    UInt32* JPEGQTableOffsets;		/* JPEGQTABLES */
    UInt32* JPEGDCTableOffsets;		/* JPEGDCTABLES */
    UInt32* JPEGACTableOffsets;		/* JPEGACTABLES */
    UInt32 JPEGQuality;			/* JPEG Quality factor (1-100) */

    /* Tiling information */
    UInt32* TileOffsets;		/* TILEOFFSETS */
    UInt32* TileByteCounts;		/* TILEBYTECOUNTS */
    UInt32 TileWidth;			/* TILEWIDTH */
    UInt32 TileLength;			/* TILELENGTH */
    UInt32 TilesAcross;			/* derived value */
    UInt32 TilesDown;			/* derived value */
    UInt32 TileCount;			/* derived value */

    /* strip information */
    UInt32* StripOffsets;		/* STRIPOFFSETS */
    UInt32* StripByteCounts;		/* STRIPBYTECOUNTS */
    UInt32 RowsPerStrip;		/* ROWSPERSTRIP */
    UInt32 StripsPerImage;		/* derived value */

#ifdef XTIFF_YCBCR
    Rational* YCbCrCoeffiecients;       /* YCRCBCOEFFICIENTS */
    UInt16 YCbCrSubSamplingHor;		/* YCBCRSUBSAMPLING [0] */
    UInt16 YCbCrSubSamplingVer;		/* YCBCRSUBSAMPLING [1] */
    UInt16 YCbCrPositioning;		/* YCBCRPOSITIONING */
#endif
#ifdef XTIFF_COLORIMETRY_INFO
    Rational* WhitePoint;               /* WHITEPOINT */
    Rational* PrimaryChromaticities;    /* PRIMARYCHROMATICITIES */
    UInt16* TransferFunction;		/* TRANSFERFUNCTION */
    UInt16 TransferFunctionSize;	/* the size of TRANSFERFUNCTION */
    UInt16* TransferRange;		/* TRANSFERRANGE */
    Rational* ReferenceBlackWhite;      /* REFERENCEBLACKWHITE */
#endif
#ifdef XTIFF_SEP_INFO
    /* Information about separated images */
    UInt16 InkSet;			/* INKSET */
    UInt16 NumberOfInks;		/* NUMBEROFINKS */
    Int8* InkNames;			/* INKNAMES */
    UInt16 InkNameLength;		/* INKNAMELENGTH */
    UInt16* DotRange;			/* DOTRANGE */
    UInt16 DotRangeLength;		/* DOTRANGELENGTH */
    Int8* TargetPrinter;		/* TARGETPRINTER */
#endif
#ifdef XTIFF_TEXT_INFO
    Int8* ImageDescription;		/* IMAGEDESCRIPTION */
    Int8* Software;		        /* SOFTWARE */
    Int8* DateTime;		        /* DATETIME */
#endif

    Int32 *SubIFDs;			/* SUBIFDS */
    UInt32 SubIFDCount;			/* derived value */

    /* Xerox extensions to TIFF */
    Int32 MaskIFDs;			/* MASKIFDS */
    UInt32 ImageLayer[2];		/* Image layer and order within layer (1, 2, ... ) */
    UInt32 *AnnotationOffsets;		/* ANNOTATIONS (XIFF 2.0 only) */
    UInt16 AnnotationCount;		/* derived value (XIFF 2.0 only) */
    ILContent ILContent;		/* Image Layer CONTENT */
} TiffFields;


/*
 * ENUMS
 */

/*
 * GLOBAL VARIABLE DECLARATIONS
 */

/*
 * FUNCTION PROTOTYPES
 */

#ifdef _MSC_VER
#pragma pack(pop, xiftiff_h)
#endif

#ifdef __cplusplus
}
#endif

#endif /* XIFXTIFF_H_INCLUDED */
