/*****************************************************************
 *  Trade Secret of Xerox Corporation.                           *
 *  Copyright (c) 1991-1996, Xerox Corporation.                  *
 *  All rights reserved.                                         *
 *  Copyright protection claimed includes all forms and matters  *
 *  of copyrightable material and information now allowed by     *
 *  statutory or judicial law or hereafter granted, including    *
 *  without limitation, material generated from the software     *
 *  programs which are displayed on the screen such as icons,    *
 *  screen display looks, etc.                                   *
 *****************************************************************/

/*	hvqlut1.c:	Hierarchical Vector Quantization LUTs (1 of 2)
 *
 *	Look-up tables for HVQ compressor -- w_HVQCompress()
 *
 */


#define _HVQLUT1_C_

#include <stdio.h>
#include <math.h>

#ifdef __GNUC__
#include "ansiprot.h"
#endif

#include "ipwcore.prv"
#include "geomadt.h"
#include "pixr.h"
#include "imageref.pub"
#include "defines.pub"
#include "memory.pub"

/* prototypes */
#include "shrpixr.pub"
#include "props.pub"

/* static HVQ LUTs */
#include "hvq.h"

IP_RCSINFO(hvqlut1_c_RCSInfo, "$RCSfile: hvqlut1.c,v $; $Revision: 1.1.1.1 $; $Date: 1999/09/20 18:19:13 $");

#if defined(macintosh) || defined(__WATCOMC__)

UInt8 hvqelut_2x1_1a[] = {
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   4,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  1,   1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,
  1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   6,   6,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,
  1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   4,   6,   6,   6,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,
  1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,
  1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,
  6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,
  1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,
  6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,
  1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   3,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   3,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,
  2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,
  2,   2,   2,   2,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,
  2,   2,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,   2,
  2,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,   2,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   2,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,
  5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,  11,  11,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   6,   6,   6,
  6,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 36,  36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,
 36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,
  4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,
  4,   4,  10,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,
 18,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,  18,
 18,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   5,   5,   5,   5,
  5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,   9,  12,
 11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
  8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,   9,  12,  12,
 12,  11,  11,  11,  11,  11,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  27,  27,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,   9,  12,  12,  12,
 12,  12,  12,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  27,  27,  27,  27,  27,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,   8,   8,   8,   9,   9,   9,   9,   9,  13,  13,  13,  13,  13,
 13,  13,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  27,  27,  27,  27,  27,  27,  27,  27,  21,  21,  21,  21,  21,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,   8,   9,   9,   9,   9,   9,  13,  13,  13,  13,  13,  13,
 13,  14,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,   9,   9,   9,   9,  13,  13,  13,  13,  13,  13,  13,
 14,  14,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,   9,  13,  13,  13,  13,  13,  13,  13,  14,  14,
 14,  14,  14,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  13,  13,  13,  13,  13,  13,  14,  14,  14,
 14,  14,  16,  16,  16,  15,  19,  19,  18,  18,  18,  18,  18,  18,  18,  24,
 24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  13,  13,  13,  14,  14,  14,  14,  14,
 14,  16,  16,  16,  16,  19,  19,  19,  19,  18,  18,  18,  18,  18,  24,  24,
 24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  14,  14,  14,  14,  14,
 16,  16,  16,  16,  16,  19,  19,  19,  19,  19,  18,  18,  18,  24,  24,  24,
 24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  14,  16,
 16,  16,  16,  16,  19,  19,  19,  19,  19,  19,  19,  23,  24,  24,  24,  24,
 24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,
 16,  16,  20,  20,  20,  20,  19,  19,  19,  19,  23,  23,  24,  24,  24,  24,
 24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  20,  20,  20,  20,  20,  20,  20,  19,  23,  23,  23,  23,  24,  24,  24,
 24,  24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  38,  38,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  20,  20,  20,  20,  20,  20,  20,  23,  23,  23,  23,  25,  24,  24,
 24,  24,  24,  24,  27,  27,  27,  27,  27,  27,  34,  38,  38,  38,  40,  40,
 40,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  20,  20,  20,  20,  20,  20,  22,  23,  23,  23,  23,  25,  25,  28,
 28,  28,  28,  28,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  36,  36,  36,  36,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  20,  20,  20,  22,  22,  22,  22,  23,  23,  23,  25,  25,  25,  28,
 28,  28,  28,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  40,  40,  40,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  23,  26,  26,  26,  25,  28,  28,
 28,  28,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  40,  40,  40,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  26,  26,  28,  28,
 28,  30,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  40,  40,  40,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  26,  26,  29,  29,
 30,  30,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  40,  40,  40,  47,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  26,  29,  29,  29,
 29,  30,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  40,  40,  47,  47,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  56,  56,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  29,  29,  29,  29,
 29,  31,  31,  31,  35,  35,  34,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  40,  47,  47,  47,  47,  49,  49,  49,  49,  49,  49,  49,  49,
 56,  56,  56,  56,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  29,  29,  29,  29,  29,
 31,  31,  31,  31,  35,  35,  35,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  47,  47,  47,  47,  47,  47,  49,  49,  49,  49,  49,  56,  56,
 56,  56,  56,  56,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  31,
 31,  31,  31,  35,  35,  35,  35,  35,  34,  34,  34,  42,  42,  38,  38,  38,
 38,  40,  47,  47,  47,  47,  47,  47,  47,  47,  49,  49,  56,  56,  56,  56,
 56,  56,  56,  56,  67,  67,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  31,  31,
 31,  31,  35,  35,  35,  35,  35,  37,  37,  41,  42,  42,  42,  42,  42,  42,
 42,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  56,  56,  56,  56,  56,
 56,  56,  56,  56,  67,  67,  67,  67,  67,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  22,  22,  22,  22,  22,  22,  33,  33,  33,  33,  33,  33,  31,  31,  31,
 31,  31,  35,  35,  35,  37,  37,  37,  41,  41,  42,  42,  42,  42,  42,  42,
 42,  47,  47,  47,  47,  47,  47,  47,  47,  47,  56,  56,  56,  56,  56,  56,
 56,  56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  79,  79,  79,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  22,  22,  22,  22,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,  31,
 31,  35,  35,  37,  37,  37,  37,  37,  41,  41,  42,  42,  42,  42,  42,  42,
 42,  42,  47,  47,  47,  47,  47,  47,  47,  47,  54,  56,  56,  56,  56,  56,
 56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  79,  79,  79,  79,  79,  95,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  37,  37,  37,  37,  37,  37,  41,  41,  41,  42,  42,  42,  42,  42,  42,
 42,  42,  47,  47,  47,  47,  47,  47,  54,  54,  54,  54,  56,  56,  56,  56,
 56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,
 67,  61,  61,  61,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  32,
 32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  37,  37,  37,  37,  41,  41,  41,  41,  41,  42,  42,  42,  42,  42,
 42,  42,  52,  47,  47,  47,  54,  54,  54,  54,  54,  54,  59,  59,  56,  56,
 56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,
 67,  67,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  37,  37,  37,  37,  41,  41,  41,  41,  41,  42,  42,  42,  42,  42,
 42,  52,  52,  52,  52,  54,  54,  54,  54,  54,  54,  54,  59,  59,  59,  59,
 59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,
 67,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  37,  37,  41,  41,  41,  41,  41,  45,  45,  45,  45,  48,  48,
 48,  52,  52,  52,  52,  52,  54,  54,  54,  54,  54,  54,  59,  59,  59,  59,
 59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  37,  41,  41,  41,  41,  41,  45,  45,  45,  45,  45,  48,  48,
 48,  52,  52,  52,  52,  52,  54,  54,  54,  54,  54,  59,  59,  59,  59,  59,
 59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  44,  44,  44,  44,  45,  45,  45,  45,  45,  45,  46,  48,  48,
 48,  52,  52,  52,  52,  52,  52,  54,  54,  54,  54,  59,  59,  59,  59,  59,
 59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,
 33,  33,  44,  44,  44,  44,  44,  44,  45,  45,  45,  45,  46,  46,  48,  48,
 48,  52,  52,  52,  52,  52,  58,  58,  58,  58,  54,  59,  59,  59,  59,  59,
 59,  59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  44,  44,  44,  44,  44,  44,  44,  45,  45,  46,  46,  46,  48,  48,
 48,  53,  52,  52,  52,  52,  58,  58,  58,  58,  58,  59,  59,  59,  59,  59,
 59,  59,  59,  59,  67,  67,  67,  67,  67,  67,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  44,  44,  44,  44,  44,  44,  44,  44,  46,  46,  46,  46,  48,  48,
 53,  53,  53,  52,  52,  58,  58,  58,  58,  58,  58,  58,  59,  59,  59,  59,
 59,  59,  59,  71,  67,  67,  67,  67,  67,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  44,  44,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  53,
 53,  53,  53,  53,  57,  58,  58,  58,  58,  58,  58,  65,  65,  65,  71,  71,
 71,  71,  71,  71,  71,  71,  67,  67,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  50,  53,
 53,  53,  53,  57,  57,  57,  58,  58,  58,  58,  65,  65,  65,  65,  71,  71,
 71,  71,  71,  71,  71,  71,  71,  79,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  50,  55,
 55,  55,  57,  57,  57,  57,  57,  58,  58,  65,  65,  65,  65,  65,  71,  71,
 71,  71,  71,  71,  71,  71,  71,  79,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  55,  55,
 55,  55,  57,  57,  57,  57,  57,  58,  65,  65,  65,  65,  65,  71,  71,  71,
 71,  71,  71,  71,  71,  71,  71,  81,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  55,  55,
 55,  55,  60,  60,  60,  60,  60,  66,  66,  65,  65,  65,  65,  71,  71,  71,
 71,  71,  71,  71,  71,  71,  81,  81,  81,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  55,  55,  55,
 55,  60,  60,  60,  60,  60,  66,  66,  66,  68,  68,  68,  68,  71,  71,  71,
 71,  71,  71,  71,  71,  81,  81,  81,  81,  81,  79,  79,  79,  79,  79,  79,
 79,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  55,  55,  55,
 55,  60,  60,  60,  60,  60,  66,  66,  66,  66,  68,  68,  68,  68,  71,  71,
 71,  71,  71,  71,  81,  81,  81,  81,  81,  81,  81,  79,  79,  79,  79,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  39,  44,  44,  44,  44,  44,  50,  50,  50,  50,  55,  55,  55,  55,
 62,  62,  62,  62,  62,  62,  66,  66,  66,  66,  66,  68,  68,  68,  71,  71,
 71,  71,  71,  81,  81,  81,  81,  81,  81,  81,  81,  81,  79,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  44,  44,  44,  44,  50,  50,  50,  63,  63,  63,  63,  63,
 62,  62,  62,  62,  62,  62,  66,  66,  66,  66,  66,  68,  68,  68,  71,  71,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  44,  44,  44,  50,  63,  63,  63,  63,  63,  63,  63,
 63,  63,  62,  62,  62,  62,  70,  70,  70,  70,  70,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 130, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  44,  44,  63,  63,  63,  63,  63,  63,  63,  63,
 63,  63,  63,  62,  62,  62,  70,  70,  70,  70,  70,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95, 104, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 130, 130, 130, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  64,  64,  64,  63,  63,  63,  63,  63,  63,  63,  63,
 63,  63,  63,  63,  63,  70,  70,  70,  70,  70,  73,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95, 104, 104, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 130, 130, 130, 130, 130, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  64,  64,  64,  64,  64,  64,  63,  63,  63,  63,  63,  63,
 63,  63,  63,  69,  69,  69,  70,  70,  70,  73,  73,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,
 88,  88,  88,  88,  88,  88,  88, 103,  95,  95, 104, 104, 104, 104, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 130, 130, 130, 130, 130, 130, 130, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  64,  64,  64,  64,  64,  64,  64,  63,  63,  63,  63,  63,
 63,  63,  69,  69,  69,  69,  69,  70,  70,  73,  73,  73,  73,  75,  75,  77,
 77,  77,  77,  82,  82,  81,  81,  81,  81,  81,  81,  81,  81,  93,  93,  93,
 88,  88,  88,  88,  88, 103, 103, 103, 103, 103, 103, 104, 104, 104, 104, 104,
104, 104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 130, 130, 130, 130, 130, 130, 130, 130, 130, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  63,  63,  63,  63,
 69,  69,  69,  69,  69,  69,  69,  74,  74,  73,  73,  73,  75,  75,  75,  75,
 77,  77,  82,  82,  82,  82,  81,  81,  81,  81,  81,  81,  93,  93,  93,  93,
 93,  93,  93,  88, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 104, 104,
104, 104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  63,  63,  69,
 69,  69,  69,  69,  69,  69,  74,  74,  74,  74,  74,  75,  75,  75,  75,  75,
 80,  82,  82,  82,  82,  82,  82,  81,  81,  81,  81,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107, 107,
107, 107, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 69,  69,  69,  69,  69,  69,  74,  74,  74,  74,  74,  75,  75,  75,  75,  80,
 80,  80,  82,  82,  82,  82,  85,  85,  89,  89,  89,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107, 107,
107, 107, 107, 107, 107, 107, 114, 114, 114, 114, 114, 114, 114, 114, 114, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,  43,  43,  43,  43,
 43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  74,  74,  74,  74,  74,  74,  74,  75,  75,  80,  80,
 80,  80,  84,  84,  85,  85,  85,  85,  89,  89,  89,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107,
107, 107, 107, 107, 107, 107, 107, 114, 114, 128, 128, 128, 128, 128, 128, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  72,  74,  74,  74,  74,  74,  74,  74,  80,  80,  80,
 80,  84,  84,  84,  85,  85,  85,  89,  89,  89,  89,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107,
107, 107, 107, 107, 107, 107, 107, 128, 128, 128, 128, 128, 128, 128, 128, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  72,  74,  74,  74,  74,  74,  74,  74,  80,  80,  80,
 80,  84,  84,  84,  85,  85,  85,  89,  89,  89,  89,  89,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107,
107, 107, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  76,  76,  74,  74,  74,  74,  74,  74,  80,  80,  86,
 86,  86,  86,  86,  85,  85,  89,  89,  89,  89,  89,  89,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143,
153, 153, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  76,  76,  76,  76,  76,  74,  74,  74,  74,  80,  86,  86,
 86,  86,  86,  86,  86,  85,  89,  89,  89,  89,  89,  89,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  76,  76,  76,  76,  76,  76,  76,  76,  74,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  92,  92,  92,  92,  92,  92,  92,  92,  93,  93,  93,
 93,  93,  93, 110, 110, 110, 103, 103, 103, 103, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  86,  86,  86,  86,
 86,  90,  90,  90,  90,  90,  92,  92,  92,  92,  92,  92,  97,  97,  97,  97,
 93,  93, 110, 110, 110, 110, 110, 113, 113, 115, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 127, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  87,  90,  90,  90,
 90,  90,  90,  90,  90,  90,  92,  92,  92,  92,  92,  97,  97,  97,  97, 102,
102, 102, 110, 110, 110, 110, 110, 113, 113, 113, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 127, 127, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 128, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  78,  78,  78,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  87,  87,  87,  87,  90,  90,
 90,  90,  90,  90,  90,  91,  91,  92,  92,  92,  97,  97,  97,  97, 102, 102,
102, 108, 110, 110, 110, 110, 110, 113, 113, 113, 113, 115, 115, 115, 115, 115,
115, 115, 115, 115, 127, 127, 127, 127, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 128, 128, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  78,  78,  78,  78,
 78,  76,  76,  76,  76,  76,  76,  76,  76,  87,  87,  87,  87,  87,  90,  90,
 90,  90,  90,  90,  91,  91,  91,  91,  92,  97,  97,  97,  97,  97, 102, 102,
102, 108, 110, 110, 110, 110, 110, 113, 113, 113, 113, 113, 115, 115, 115, 115,
115, 115, 115, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128, 128, 128, 128,
128, 128, 128, 128, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
153, 153, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  64,  64,  64,  64,  64,  64,  64,  64,  78,  78,  78,  78,  78,  78,
 78,  78,  76,  76,  76,  76,  76,  87,  87,  87,  87,  87,  87,  87,  87,  90,
 90,  90,  90,  91,  91,  91,  91,  96,  96,  97,  97,  97,  97, 102, 102, 102,
102, 108, 108, 110, 110, 110, 110, 113, 113, 113, 113, 113, 113, 115, 115, 115,
115, 115, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128, 128, 128,
128, 128, 128, 128, 128, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
153, 153, 153, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  64,  64,  64,  64,  64,  64,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  76,  76,  87,  87,  87,  87,  87,  87,  87,  87,  87,  90,
 90,  90,  91,  91,  91,  91,  96,  96,  96,  96,  97,  97, 102, 102, 102, 102,
108, 108, 108, 110, 110, 110, 110, 113, 113, 113, 113, 113, 113, 113, 115, 115,
125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128, 128,
128, 128, 128, 128, 128, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
153, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  64,  64,  64,  64,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,
 90,  91,  91,  91,  91,  96,  96,  96,  96,  96, 101, 101, 102, 102, 102, 102,
108, 108, 108, 110, 110, 110, 110, 113, 113, 113, 113, 113, 113, 113, 125, 125,
125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128,
128, 128, 128, 128, 128, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  64,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,
 91,  91,  91,  91,  96,  96,  96,  96,  96, 101, 101, 101, 101, 106, 106, 106,
108, 108, 108, 108, 112, 112, 112, 112, 113, 113, 113, 113, 113, 125, 125, 125,
125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128,
128, 128, 128, 147, 147, 155, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,
 99,  99,  99,  96,  96,  96,  96,  96, 101, 101, 101, 101, 101, 106, 106, 106,
106, 108, 108, 112, 112, 112, 112, 112, 112, 113, 113, 113, 113, 125, 125, 125,
125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128,
147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  99,
 99,  99,  99,  99,  96,  96,  96,  96, 101, 101, 101, 101, 101, 106, 106, 106,
106, 108, 108, 112, 112, 112, 112, 112, 112, 112, 113, 113, 123, 125, 125, 125,
125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 153, 153, 153, 153, 153, 153, 153, 153, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  99,
 99,  99,  99,  99,  99,  99,  96, 101, 101, 101, 101, 101, 101, 106, 106, 106,
106, 106, 112, 112, 112, 112, 112, 112, 112, 112, 123, 123, 123, 125, 125, 125,
125, 125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 153, 153, 153, 153, 153, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99, 101, 101, 101, 101, 101, 101, 111, 111, 111,
111, 111, 116, 117, 117, 117, 117, 117, 117, 123, 123, 123, 123, 123, 125, 125,
125, 125, 125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 146, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 153, 153, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99, 101, 101, 101, 101, 101, 111, 111, 111, 111,
111, 116, 116, 117, 117, 117, 117, 117, 117, 123, 123, 123, 123, 123, 123, 125,
125, 125, 125, 125, 125, 125, 127, 127, 127, 127, 127, 146, 146, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 155, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99,  99, 101, 101, 101, 111, 111, 111, 111, 111,
111, 116, 116, 117, 117, 117, 117, 117, 117, 119, 123, 123, 123, 123, 123, 123,
125, 125, 125, 125, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 155, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,
 83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99, 105, 109, 109, 111, 111, 111, 111, 111, 111,
116, 116, 116, 116, 117, 117, 117, 117, 119, 119, 123, 123, 123, 123, 123, 123,
123, 125, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 147,
147, 147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,
 83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99, 105, 105, 105, 105, 109, 109, 109, 111, 111, 111, 111, 111, 111,
116, 116, 116, 116, 117, 117, 117, 119, 119, 119, 119, 123, 123, 123, 123, 123,
123, 134, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 147,
147, 147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100,
100, 105, 105, 105, 105, 105, 109, 109, 109, 109, 109, 111, 111, 111, 111, 116,
116, 116, 116, 116, 117, 120, 120, 119, 119, 119, 119, 126, 126, 126, 126, 126,
126, 134, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 146,
147, 147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 162, 162, 162, 162,
162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100, 100,
100, 105, 105, 105, 105, 105, 109, 109, 109, 109, 109, 109, 111, 111, 111, 116,
116, 116, 116, 116, 120, 120, 120, 120, 119, 119, 126, 126, 126, 126, 126, 126,
126, 134, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 146,
146, 147, 147, 147, 147, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100, 100, 100,
100, 100, 105, 105, 105, 109, 109, 109, 109, 109, 109, 109, 111, 111, 116, 116,
116, 116, 116, 120, 120, 120, 120, 120, 122, 122, 122, 126, 126, 126, 126, 126,
126, 134, 134, 134, 134, 134, 134, 138, 138, 138, 146, 146, 146, 146, 146, 146,
146, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,
 78,  98,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100, 100, 100, 100, 100,
100, 100, 105, 105, 109, 109, 109, 109, 109, 109, 109, 109, 109, 111, 116, 116,
116, 116, 124, 124, 124, 120, 120, 122, 122, 122, 122, 126, 126, 126, 126, 126,
136, 136, 134, 134, 138, 138, 138, 138, 138, 138, 146, 146, 146, 146, 146, 146,
154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,
 98,  98,  98,  94,  94,  94,  94,  94,  94, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 105, 109, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121,
121, 124, 124, 124, 124, 124, 124, 122, 122, 122, 122, 132, 132, 132, 132, 132,
136, 136, 136, 138, 138, 138, 138, 138, 138, 145, 145, 146, 146, 146, 146, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  94,  94,  94, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121,
121, 121, 124, 124, 124, 124, 124, 124, 131, 131, 131, 132, 132, 132, 132, 135,
136, 136, 136, 136, 138, 138, 138, 145, 145, 145, 145, 145, 146, 146, 146, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 175, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  94, 100, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121,
121, 121, 124, 124, 124, 124, 124, 124, 131, 131, 131, 132, 132, 132, 132, 135,
136, 136, 136, 136, 136, 138, 145, 145, 145, 145, 145, 145, 145, 146, 154, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 175, 175, 175, 184, 184, 184, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121,
121, 121, 121, 124, 124, 124, 124, 124, 131, 131, 131, 131, 132, 132, 135, 135,
135, 136, 136, 136, 136, 144, 145, 145, 145, 145, 145, 145, 145, 154, 154, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121, 121,
121, 121, 121, 124, 124, 124, 124, 124, 131, 131, 131, 131, 132, 135, 135, 135,
135, 135, 136, 136, 144, 144, 144, 145, 145, 145, 145, 145, 145, 156, 156, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231
};

UInt8 hvqelut_2x1_1b[] = {
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 124, 124, 124, 124, 131, 131, 131, 131, 131, 135, 135, 135,
135, 141, 141, 144, 144, 144, 144, 144, 145, 145, 145, 145, 156, 156, 156, 156,
156, 156, 154, 154, 154, 154, 154, 154, 162, 162, 162, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 124, 124, 131, 131, 131, 131, 131, 137, 137, 137, 137,
137, 141, 141, 141, 144, 144, 144, 144, 144, 145, 145, 156, 156, 156, 156, 156,
156, 156, 156, 156, 154, 154, 154, 154, 162, 175, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100,
100, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 124, 124, 131, 131, 131, 131, 131, 137, 137, 137, 137,
141, 141, 141, 141, 149, 144, 144, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 156, 172, 172, 172, 172, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 177, 177, 177, 177, 177, 177, 177, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 121, 124, 131, 131, 131, 131, 137, 137, 137, 137, 137,
141, 141, 141, 149, 149, 149, 152, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 156, 172, 172, 172, 172, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 140, 140, 140, 140, 131, 137, 137, 137, 137, 137, 141,
141, 141, 149, 149, 149, 149, 152, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121,
121, 121, 121, 121, 140, 140, 140, 140, 140, 140, 140, 137, 137, 137, 137, 141,
141, 141, 149, 149, 149, 151, 151, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121,
121, 121, 121, 140, 140, 140, 140, 140, 140, 140, 140, 140, 137, 137, 141, 141,
141, 149, 149, 151, 151, 151, 151, 151, 152, 152, 159, 156, 156, 156, 156, 156,
156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 172, 172, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121,
121, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150,
149, 151, 151, 151, 151, 151, 151, 151, 159, 159, 159, 159, 156, 156, 156, 156,
156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121,
140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150,
150, 151, 151, 151, 151, 151, 151, 159, 159, 159, 159, 159, 159, 156, 156, 156,
156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182,
182, 182, 182, 182, 182, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 140,
140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150,
150, 150, 151, 151, 151, 151, 159, 159, 159, 159, 159, 159, 159, 164, 164, 164,
168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182,
182, 182, 182, 182, 182, 182, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 142,
142, 142, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150, 150,
150, 150, 150, 151, 151, 151, 159, 159, 159, 159, 159, 164, 164, 164, 164, 168,
168, 168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182,
182, 182, 182, 182, 182, 182, 182, 184, 184, 184, 184, 184, 184, 184, 200, 200,
200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 142,
142, 142, 142, 142, 142, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150, 150,
150, 150, 150, 150, 161, 161, 161, 161, 161, 161, 161, 164, 164, 164, 167, 168,
168, 168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182, 182,
182, 182, 182, 182, 182, 182, 182, 182, 184, 184, 184, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242,
 51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133,
142, 142, 142, 142, 142, 142, 142, 142, 140, 140, 140, 150, 150, 150, 150, 150,
150, 150, 150, 150, 161, 161, 161, 161, 161, 161, 164, 164, 164, 164, 167, 168,
168, 168, 168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182, 182,
182, 182, 182, 182, 182, 182, 182, 182, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242,
 51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133,
142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 150, 150, 150,
150, 150, 150, 150, 161, 161, 161, 161, 161, 161, 164, 164, 164, 167, 167, 168,
168, 168, 168, 168, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 182,
182, 182, 182, 182, 182, 182, 182, 182, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 150, 150, 150,
150, 150, 150, 157, 157, 161, 161, 161, 161, 164, 164, 164, 167, 167, 167, 168,
168, 168, 171, 171, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 182, 182, 182, 182, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 150, 150, 150,
157, 157, 157, 157, 157, 165, 161, 161, 161, 164, 164, 164, 167, 167, 167, 168,
171, 171, 171, 171, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 157, 157, 157,
157, 157, 157, 157, 165, 165, 165, 165, 169, 169, 169, 169, 167, 167, 167, 171,
171, 171, 171, 171, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 142, 142, 142, 142, 142, 142, 142, 142, 142, 158, 157, 157, 157, 157, 157,
157, 157, 157, 157, 165, 165, 165, 165, 169, 169, 169, 169, 169, 169, 171, 171,
171, 171, 171, 171, 179, 179, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118, 118,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 142, 142, 142, 142, 142, 142, 142, 158, 158, 158, 157, 157, 157, 157,
157, 157, 157, 165, 165, 165, 165, 165, 169, 169, 169, 169, 169, 169, 174, 174,
174, 174, 174, 179, 179, 179, 179, 181, 181, 181, 181, 181, 189, 189, 185, 185,
185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98, 139, 139, 118, 118, 118, 133, 133,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 142, 142, 142, 142, 142, 158, 158, 158, 158, 158, 158, 157, 157, 157,
157, 157, 157, 165, 165, 165, 165, 165, 169, 169, 169, 169, 169, 169, 174, 174,
174, 174, 174, 179, 179, 179, 179, 179, 181, 181, 181, 189, 189, 189, 189, 189,
189, 189, 189, 189, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98, 139, 139, 139, 139, 139, 139, 139, 133, 133,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 142, 142, 142, 142, 158, 158, 158, 158, 158, 158, 158, 158, 157, 157,
157, 157, 157, 165, 165, 165, 165, 165, 165, 169, 169, 169, 169, 169, 176, 174,
174, 174, 179, 179, 179, 179, 179, 183, 183, 183, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 201, 201, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 133, 142, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 157,
157, 157, 165, 165, 165, 165, 165, 165, 165, 169, 169, 169, 169, 176, 176, 176,
176, 180, 180, 179, 179, 179, 183, 183, 183, 183, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 201, 201, 201, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 160, 160, 160, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
163, 157, 165, 165, 165, 165, 165, 165, 173, 173, 169, 169, 176, 176, 176, 176,
176, 180, 180, 180, 179, 183, 183, 183, 183, 183, 191, 189, 189, 189, 189, 189,
189, 189, 189, 189, 201, 201, 201, 201, 204, 204, 200, 200, 200, 200, 200, 200,
200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 160, 160, 160, 160, 160, 160, 158, 158, 158, 158, 158, 158, 158, 163, 163,
163, 163, 165, 165, 165, 165, 165, 173, 173, 173, 173, 173, 176, 176, 176, 176,
180, 180, 180, 180, 180, 183, 183, 183, 183, 191, 191, 191, 189, 189, 189, 189,
189, 189, 189, 201, 201, 201, 201, 201, 204, 204, 204, 204, 200, 200, 200, 200,
200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
160, 160, 160, 160, 160, 160, 160, 160, 158, 158, 158, 158, 158, 163, 163, 163,
163, 163, 163, 165, 165, 165, 173, 173, 173, 173, 173, 173, 176, 176, 176, 176,
180, 180, 180, 180, 180, 187, 187, 187, 187, 191, 191, 191, 191, 189, 189, 189,
189, 189, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 200,
200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 158, 158, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 176, 176, 176,
180, 180, 180, 180, 187, 187, 187, 187, 187, 191, 191, 191, 191, 193, 193, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 204,
204, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 133, 133, 133, 133, 133, 133, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 173, 176, 176,
180, 180, 180, 180, 187, 187, 187, 187, 187, 191, 191, 193, 193, 193, 197, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 204,
204, 207, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 133, 133, 133, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 173, 176, 180,
180, 180, 180, 187, 187, 187, 187, 187, 187, 193, 193, 193, 193, 197, 197, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 207,
207, 207, 214, 214, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 173, 186, 186,
180, 190, 190, 190, 190, 190, 190, 190, 195, 195, 195, 195, 197, 197, 198, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 207, 207, 207,
207, 207, 214, 214, 214, 214, 214, 210, 210, 210, 210, 210, 210, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  98,  98, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 186, 186, 186, 186,
186, 190, 190, 190, 190, 190, 190, 190, 190, 195, 195, 195, 197, 197, 198, 198,
198, 198, 198, 201, 201, 201, 201, 201, 204, 204, 204, 207, 207, 207, 207, 207,
207, 214, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 186, 186, 186, 186, 186, 186,
186, 190, 190, 190, 190, 190, 190, 190, 190, 195, 195, 195, 197, 199, 199, 198,
198, 198, 202, 202, 201, 201, 201, 201, 204, 207, 207, 207, 207, 207, 207, 207,
207, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170,
163, 178, 178, 178, 178, 178, 173, 173, 186, 186, 186, 186, 186, 186, 186, 186,
186, 190, 190, 190, 190, 190, 190, 196, 196, 196, 195, 195, 199, 199, 199, 199,
199, 202, 202, 202, 202, 201, 206, 206, 207, 207, 207, 207, 207, 207, 207, 207,
214, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170,
178, 178, 178, 178, 178, 178, 178, 186, 186, 186, 186, 186, 186, 186, 186, 186,
186, 186, 190, 190, 190, 190, 196, 196, 196, 196, 196, 199, 199, 199, 199, 199,
202, 202, 202, 202, 202, 206, 206, 206, 206, 207, 207, 207, 207, 207, 207, 207,
214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170,
178, 178, 178, 178, 178, 178, 178, 186, 186, 186, 186, 186, 186, 186, 186, 186,
186, 186, 190, 190, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 199, 199,
202, 202, 202, 202, 202, 206, 206, 206, 206, 206, 207, 207, 207, 207, 207, 214,
214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170,
178, 178, 178, 178, 178, 178, 178, 178, 186, 186, 186, 186, 186, 186, 186, 186,
186, 186, 190, 196, 196, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 199,
202, 202, 202, 202, 206, 206, 206, 206, 206, 206, 206, 207, 207, 207, 207, 214,
214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160,
160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178,
178, 178, 178, 178, 178, 178, 178, 178, 188, 186, 186, 186, 186, 186, 186, 186,
186, 186, 186, 196, 196, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 199,
202, 205, 205, 205, 208, 208, 206, 206, 206, 206, 206, 207, 207, 207, 214, 214,
214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 235, 235, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160,
160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178,
178, 178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 186, 186, 186, 186, 186,
194, 194, 194, 196, 196, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 205,
205, 205, 205, 205, 208, 208, 208, 208, 206, 211, 211, 211, 211, 211, 214, 214,
214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 160, 160,
160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178,
178, 178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 186, 194, 194, 194,
194, 194, 194, 194, 196, 196, 196, 196, 196, 196, 196, 196, 199, 205, 205, 205,
205, 205, 205, 205, 205, 208, 208, 208, 211, 211, 211, 211, 211, 211, 214, 214,
214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 196, 196, 196, 196, 196, 196, 196, 209, 205, 205, 205,
205, 205, 205, 205, 205, 208, 208, 211, 211, 211, 211, 211, 211, 211, 216, 219,
219, 219, 219, 214, 218, 218, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 194, 196, 196, 196, 196, 196, 209, 209, 209, 209, 205,
205, 205, 205, 205, 205, 205, 211, 211, 211, 211, 211, 211, 211, 216, 216, 219,
219, 219, 219, 219, 219, 218, 218, 218, 218, 218, 227, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 194, 203, 203, 203, 203, 209, 209, 209, 209, 209, 209,
209, 205, 205, 205, 205, 212, 212, 212, 212, 212, 212, 212, 216, 216, 216, 219,
219, 219, 219, 219, 219, 219, 218, 227, 227, 227, 227, 227, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209, 209,
209, 209, 205, 205, 205, 212, 212, 212, 212, 212, 215, 215, 216, 216, 216, 219,
219, 219, 219, 219, 219, 219, 227, 227, 227, 227, 227, 227, 227, 225, 225, 225,
225, 225, 231, 231, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178, 178,
178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 212, 212, 212, 212, 212, 215, 215, 215, 216, 216, 216, 219,
219, 219, 219, 219, 219, 219, 227, 227, 227, 227, 227, 227, 227, 227, 225, 225,
225, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178, 178,
178, 178, 178, 192, 192, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 209, 212, 212, 212, 215, 215, 215, 215, 215, 216, 216, 216, 216,
219, 219, 219, 219, 219, 219, 227, 227, 227, 227, 227, 227, 229, 229, 229, 229,
235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 178, 178, 178,
192, 192, 192, 192, 192, 192, 192, 192, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 212, 215, 215, 215, 215, 215, 217, 216, 216, 216, 220,
219, 219, 219, 219, 219, 226, 226, 227, 227, 227, 229, 229, 229, 229, 229, 229,
235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 178, 178, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 188, 188, 194, 194, 194,
194, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 213, 215, 215, 215, 217, 217, 217, 217, 217, 220, 220,
220, 220, 219, 226, 226, 226, 226, 226, 229, 229, 229, 229, 229, 229, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 194, 194, 194,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 213, 213, 213, 213, 217, 217, 217, 217, 217, 217, 217, 220, 220,
220, 220, 220, 226, 226, 226, 226, 226, 229, 229, 229, 229, 229, 229, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 170, 170, 170, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 194, 194,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 213, 213, 213, 213, 213, 217, 217, 217, 217, 217, 217, 220, 220, 220,
220, 220, 220, 226, 226, 226, 226, 226, 232, 232, 229, 229, 229, 229, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209,
213, 213, 213, 213, 213, 213, 213, 213, 217, 217, 221, 221, 221, 220, 220, 220,
220, 224, 224, 226, 226, 226, 226, 226, 232, 232, 232, 232, 232, 232, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 213,
213, 213, 213, 213, 213, 213, 213, 213, 221, 221, 221, 221, 221, 221, 220, 220,
224, 224, 224, 224, 226, 226, 226, 232, 232, 232, 232, 232, 232, 232, 232, 232,
232, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 213, 213, 213,
213, 213, 213, 213, 213, 213, 213, 213, 221, 221, 221, 221, 221, 221, 221, 224,
224, 224, 224, 224, 230, 230, 230, 232, 232, 232, 232, 232, 232, 232, 232, 232,
232, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213,
213, 213, 213, 213, 213, 213, 213, 213, 223, 221, 221, 221, 221, 221, 221, 224,
224, 224, 224, 230, 230, 230, 230, 232, 232, 232, 232, 232, 232, 232, 232, 232,
232, 232, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213,
213, 213, 213, 213, 213, 213, 213, 223, 223, 223, 223, 221, 221, 221, 221, 224,
224, 224, 230, 230, 230, 230, 230, 233, 232, 232, 232, 232, 232, 232, 232, 232,
232, 232, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213, 213,
213, 213, 213, 213, 213, 213, 223, 223, 223, 223, 223, 223, 223, 221, 221, 224,
224, 224, 230, 230, 230, 233, 233, 233, 233, 234, 232, 232, 232, 232, 232, 232,
237, 237, 239, 239, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213, 213,
213, 213, 213, 213, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223, 223, 224,
224, 230, 230, 233, 233, 233, 233, 233, 234, 234, 236, 236, 236, 236, 236, 237,
237, 237, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223, 223,
230, 233, 233, 233, 233, 233, 233, 234, 234, 236, 236, 236, 236, 236, 237, 237,
237, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223,
233, 233, 233, 233, 233, 233, 234, 234, 234, 236, 236, 236, 236, 237, 237, 237,
237, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223,
233, 233, 233, 233, 233, 234, 234, 234, 236, 236, 236, 236, 237, 237, 237, 237,
239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223,
233, 233, 233, 233, 234, 234, 234, 234, 236, 236, 236, 237, 237, 237, 237, 237,
239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 223, 223, 223,
233, 233, 233, 234, 234, 234, 234, 236, 236, 236, 237, 237, 237, 237, 237, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228,
233, 233, 234, 234, 234, 234, 234, 236, 236, 237, 237, 237, 237, 237, 237, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 234, 234, 234, 234, 234, 236, 236, 237, 237, 237, 237, 237, 237, 239, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 234, 234, 234, 234, 234, 236, 237, 237, 237, 237, 237, 237, 237, 240, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242,
242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 234, 234, 234, 236, 237, 237, 237, 237, 237, 237, 237, 240, 240, 240,
240, 239, 239, 239, 239, 239, 239, 239, 239, 241, 241, 242, 242, 242, 242, 242,
242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 234, 234, 234, 237, 237, 237, 237, 237, 237, 237, 240, 240, 240, 240,
240, 240, 240, 239, 239, 239, 241, 241, 241, 241, 241, 241, 245, 242, 242, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 238, 238, 238, 237, 237, 237, 237, 237, 237, 240, 240, 240, 240, 240,
240, 240, 240, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 237, 237, 237, 240, 240, 240, 240, 240, 240,
240, 240, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 240, 240, 240, 240, 240, 240,
240, 241, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 240, 240, 240, 240, 241,
241, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 240, 240, 241, 241,
241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 241, 241, 241,
241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 241, 241, 241,
241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245,
245, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 252, 252, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 241,
241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245,
245, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 252, 252, 252, 252, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243,
241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245,
245, 248, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243,
243, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245,
248, 248, 248, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243,
243, 244, 244, 244, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 248, 248,
248, 248, 248, 249, 249, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 251, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222,
222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243,
244, 244, 244, 244, 244, 245, 245, 245, 245, 246, 246, 246, 246, 246, 248, 248,
248, 248, 248, 249, 249, 249, 249, 249, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 251, 251, 251, 251, 251, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222,
222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 246, 246, 248, 248,
248, 248, 249, 249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 252, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222,
222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 246, 248, 248, 248,
248, 249, 249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 252, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222,
222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 248, 248, 248,
248, 249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222,
222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 248, 248, 248,
249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252,
252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222,
222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 248, 248, 248, 249,
249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252,
252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222,
222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 248, 248, 248, 249,
249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252,
252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 248, 248, 249, 249,
249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250,
251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252,
252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 248, 248, 249, 249, 249,
249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251,
251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 248, 248, 249, 249, 249,
249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251,
251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 248, 249, 249, 249, 249,
249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251,
251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 248, 249, 249, 249, 249, 249,
249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251,
251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 248, 249, 249, 249, 249, 249,
249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251,
251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 249, 249, 249, 249, 249, 249,
250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251,
251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 249, 249, 249, 249, 249, 249, 250,
250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251,
252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 246, 249, 249, 249, 249, 249, 250, 250,
250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 249, 249, 250, 250, 250,
250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 249, 249, 250, 250, 250,
250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 249, 250, 250, 250, 250,
250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 250, 250, 250, 250, 250,
250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 250, 250, 250, 250, 250, 250,
251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252,
252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243,
243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 250, 250, 250, 250, 250, 250, 251,
251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252,
252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250, 250, 250, 251, 251,
251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252,
252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 249, 250, 250, 250, 250, 251, 251, 251, 251,
251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252,
252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250, 251, 251, 251, 251, 251,
251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 251, 251, 251, 251, 251, 251,
251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 250, 250, 251, 251, 251, 251, 251, 251, 251,
251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251,
251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251,
251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251,
251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251,
252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252,
252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252,
252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 228,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252,
252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 228,
228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252,
252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 228, 228,
228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 228, 228,
228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 251,
252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255
};

UInt8 *hvqelut_2x1_1[] = {hvqelut_2x1_1a, hvqelut_2x1_1b};


UInt8 hvqelut_2x2_1a[] = {
  0,   0,   0,   0,   0,   1,   1,   1,   1,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,
  6,  19,  19,   6,  19,  19,  19,   6,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,   6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  88,  19,  19,  19,  19,  19,  19,  19,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  98,  88,  88,  88,  98, 126,  88,  88,  88,  88,
126, 126, 126, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   0,   0,   0,   1,   1,   1,   1,   1,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,   6,   6,
  6,  19,   6,  19,  19,   6,   6,  19,   6,  19,  19,  19,  19,  19,   6,  19,
 19,  19,  19,   6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 66,  19,  19,  88,  19,  88,  66,  19,  88,  88,  88,  88,  88,  88,  88,  19,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88, 126,  88, 126, 126, 126, 126, 126, 126,  88, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   0,   0,   1,   1,   1,   1,   1,   1,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,  19,   6,   6,  19,   6,  19,   6,   6,
  6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  88,  88,  19,
 66,  19,  19,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88, 126, 126, 126, 126, 126, 126, 126, 126,  88, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   0,   1,   1,   1,   1,   1,   1,   3,   3,   3,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,
  6,  19,   6,   6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  66,  66,  19,  66,  19,
 19,  19,  19,  19,  19,  19,  88,  88,  88,  98,  19,  19,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88, 126,
 88,  88,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  66,  66,  19,  66,  19,
 19,  19,  19,  19,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88, 126,  88,  88, 126,
 88,  88,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  2,   1,   1,   1,   3,   3,   3,   3,   3,   5,   5,   5,   5,   5,   8,   8,
  8,   8,   8,   8,  10,  10,  11,   6,   6,   6,   6,  19,   6,   6,   6,   6,
 28,   6,  19,  19,  19,  19,  19,  28,  19,  19,  19,  28,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  66,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  66,  66,  66,  66,  19,  66,  19,  88,  19,
 19,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158,
  2,   2,   2,   3,   3,   3,   3,   4,   5,   5,   5,   5,   5,   5,   8,   8,
  8,   8,  10,  10,  10,  18,  10,  14,  14,  14,  14,  19,  20,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  19,  66,  66,  88,  88,  66,  19,  88,  19,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158,
  2,   2,   2,   3,   3,   9,   4,   4,   9,   9,   9,  18,  18,  18,  18,  18,
 18,   9,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 19,  19,  18,  19,  18,  19,  18,  19,  18,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  63,  19,  19,  19,  88,  77,  77,  77,  77,  77,  77,  77,  77,  77,
 77,  98,  98,  77,  77,  88,  77,  77,  77,  77,  77,  88,  88,  77,  88,  98,
 77,  98,  98,  98,  98,  77,  88,  98,  98,  98,  98,  98,  98,  88,  88,  98,
 88,  98,  98,  88,  98,  88,  88,  98,  98,  98,  88,  98,  98,  88,  98,  98,
 98,  98,  88,  98,  98,  98,  98,  98,  98,  98,  88,  98,  88,  98,  98,  98,
 88,  98,  88,  98,  98,  98,  98,  98,  98,  98,  98, 126,  98, 126,  98,  98,
126, 126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
  2,   2,   2,   3,   3,   3,   5,  18,   5,   5,   5,   8,   8,   8,   8,  10,
 10,  11,  10,  10,  12,  13,  14,  14,  14,  14,  14,  20,  20,  20,  20,  20,
 28,  20,  19,  20,  19,  19,  19,  28,  19,  19,  19,  28,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,
 19,  19,  66,  66,  66,  19,  19,  19,  19,  66,  19,  19,  19,  66,  19,  66,
 62,  19,  19,  19,  66,  66,  66,  66,  66,  66,  66,  88,  66,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88, 126, 126, 126, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158,
  2,   2,   2,   2,   3,   5,   5,  18,   5,   8,   8,   8,   8,  10,  10,  10,
 11,  12,  12,  12,  12,  13,  14,  14,  14,  14,  14,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  19,  28,  19,  19,  19,  28,  28,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  28,  19,  19,  19,  28,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  38,  19,  19,  19,  19,  19,  19,  66,  19,
 66,  19,  66,  66,  66,  66,  62,  19,  19,  66,  66,  19,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  66,  66,  88,  88,  66,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88, 126, 126, 126, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
  2,   2,   2,   2,   3,   5,   5,   9,   7,   8,   7,  11,  11,  11,  11,  11,
 12,   7,  12,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  20,
 28,  28,  20,  20,  19,  20,  20,  28,  19,  28,  20,  28,  28,  28,  28,  19,
 28,  19,  28,  28,  19,  28,  19,  28,  19,  28,  19,  19,  28,  19,  28,  28,
 28,  19,  38,  19,  19,  28,  38,  19,  28,  38,  28,  38,  28,  38,  28,  19,
 38,  19,  38,  28,  38,  38,  38,  66,  19,  41,  66,  66,  66,  41,  66,  19,
 66,  66,  66,  66,  66,  66,  66,  62,  19,  66,  66,  62,  66,  66,  66,  66,
 66,  66,  62,  62,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  88,
 88,  98,  98,  66,  66,  66,  88,  88,  88,  88,  88,  66,  66,  88,  66,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88, 100,
 88,  98,  88,  88,  88,  88, 100,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88, 100, 100, 126, 126, 100,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 181,
  2,   2,   2,   2,   2,   5,   9,  18,   9,   9,  11,   9,  10,  10,  10,  10,
 11,  12,  13,  12,  14,  18,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  28,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  38,
 28,  19,  19,  19,  19,  38,  19,  19,  38,  19,  38,  19,  38,  19,  28,  19,
 41,  19,  19,  28,  41,  41,  41,  38,  19,  41,  41,  41,  41,  41,  66,  19,
 62,  62,  66,  66,  66,  62,  62,  62,  41,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  62,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
  2,   2,   2,   2,   2,   5,   9,  18,   8,   8,  11,  10,  10,  10,  11,  11,
 12,  12,  13,  12,  14,  18,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  28,  19,  19,  19,
 19,  19,  38,  28,  19,  19,  19,  38,  19,  19,  19,  19,  38,  19,  38,  38,
 28,  19,  19,  19,  19,  38,  38,  19,  38,  38,  38,  41,  38,  41,  28,  19,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  41,  41,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  98,  88,  98, 100,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 181,
  2,   2,   2,   2,   2,   5,   9,  18,   8,  10,  11,  10,  10,  11,  11,  12,
 12,  12,  13,  12,  14,  15,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  28,  38,  38,  27,
 19,  27,  38,  28,  19,  38,  19,  38,  19,  38,  19,  19,  38,  19,  38,  38,
 28,  19,  38,  19,  19,  38,  38,  19,  38,  38,  38,  41,  38,  41,  28,  19,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  41,  41,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 100,  88,  88,
 88,  88,  88,  88,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  10,  11,  10,  11,  11,  12,  13,
 12,  14,  13,  14,  14,  15,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  27,  38,  27,  38,  38,  41,  38,  27,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  28,  41,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  66,  41,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 100,  88, 100,
 88, 126,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  10,  11,  10,  11,  11,  13,  13,
 12,  14,  15,  14,  14,  18,  14,  20,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  27,  38,  27,  38,  38,  41,  38,  27,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  28,  41,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  62,  62,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 126,  88, 100,
 88, 126,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  11,  11,  13,  11,  13,  12,  13,
 12,  14,  15,  14,  14,  15,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  29,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  27,  38,  27,  38,  38,  41,  38,  27,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  28,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  41,  41,  66,  62,  62,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 100,  88, 100,
 88, 126,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   8,   9,  18,  11,  11,   7,  13,  12,  12,  12,  12,
 12,  17,  14,  14,  17,  15,  17,  14,  14,  20,  14,  20,  20,  20,  20,  20,
 28,  28,  20,  20,  27,  20,  29,  28,  27,  29,  29,  28,  28,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  38,  38,  41,  38,  38,  41,  38,  41,  38,  38,
 28,  38,  38,  41,  38,  38,  38,  41,  38,  38,  38,  38,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  66,  66,  66,  62,  66,  62,
 66,  66,  66,  66,  66,  66,  66,  62,  62,  66,  66,  62,  66,  66,  62,  66,
 66,  62,  62,  62,  66,  66,  66,  88,  66,  66,  88,  88,  66,  88,  88,  88,
 88,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88, 100,
 88,  98,  88,  88,  88, 100, 100, 100,  98, 100,  88, 100,  88, 100, 100, 100,
 88, 100,  88, 100, 100, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  13,  11,  13,  13,  13,  13,  13,
 15,  15,  15,  15,  15,  18,  15,  20,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  27,  20,  27,  29,  27,  29,  27,  29,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  27,  38,  41,  41,  38,  27,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  38,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  62,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88,  88,  88, 100,  98,  88,  98, 126,  88,  88,  88, 126, 126, 126,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  13,  12,  13,  13,  13,  13,  13,
 15,  14,  15,  15,  15,  24,  14,  20,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  29,  27,  28,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  27,  38,  41,  41,  38,  27,  38,  38,
 28,  41,  41,  41,  41,  38,  41,  41,  38,  41,  38,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88,  88,  88, 100, 100, 100,  98, 126,  88, 100,  88, 126, 100, 126,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  11,  13,  12,  13,  13,  13,  13,  15,
 15,  17,  15,  15,  17,  24,  17,  21,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  29,  29,  29,  27,  29,  27,  28,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  41,  38,  38,  41,  38,  41,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  62,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88,  88,  88, 100, 100, 100,  98, 100,  88, 100,  88, 126, 100, 100,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,   4,   9,  16,   9,  16,  16,  16,  16,  16,
 16,  16,  24,  16,  16,  18,  16,  24,  24,  24,  24,  24,  24,  24,  24,  24,
 29,  29,  27,  24,  18,  27,  27,  29,  27,  27,  27,  29,  29,  27,  27,  27,
 27,  27,  27,  28,  27,  41,  27,  41,  27,  41,  41,  27,  41,  35,  41,  41,
 38,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  63,
 41,  41,  41,  66,  41,  41,  41,  62,  63,  62,  62,  62,  62,  63,  62,  63,
 62,  62,  66,  62,  62,  62,  62,  77,  77,  62,  62,  77,  77,  62,  77,  62,
 77,  77,  77,  77,  77,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98,  98,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  98,
 88,  98,  88, 126, 126, 126,  98, 126,  98,  98,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  13,  17,  13,  13,  13,  17,  15,
 17,  17,  15,  17,  17,  24,  17,  21,  22,  22,  21,  22,  22,  22,  22,  29,
 28,  29,  29,  29,  27,  29,  29,  28,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100,  88, 100, 100, 100,  98, 100,  88, 100,  88, 126, 100, 100,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  13,  17,  16,  16,  16,  15,  16,
 15,  17,  16,  21,  21,  24,  21,  21,  22,  22,  22,  22,  22,  22,  22,  29,
 28,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 100,  88, 126, 100, 126,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  21,  22,  22,  21,  24,  22,  26,  25,  29,
 29,  29,  29,  29,  27,  29,  27,  29,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  41,  38,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  62,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  21,  22,  22,  22,  25,  22,  26,  26,  26,
 32,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  41,
 38,  27,  38,  28,  41,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 41,  41,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 100,  88, 126, 126, 126,
 88, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  21,  21,  24,  21,  22,  22,  22,  22,  25,  22,  26,  26,  26,
 32,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  41,
 38,  27,  38,  28,  41,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 62,  41,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 100,  88, 126, 126, 126,
 88, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  16,  16,  16,  16,  24,  16,  25,  24,  25,  25,  24,  25,  25,  25,  25,
 29,  29,  24,  29,  35,  29,  37,  29,  27,  29,  37,  38,  29,  29,  38,  27,
 41,  27,  38,  28,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 38,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  66,  63,
 62,  41,  62,  66,  62,  62,  62,  62,  63,  62,  62,  62,  62,  62,  66,  63,
 62,  62,  66,  62,  66,  62,  62,  77,  77,  66,  62,  77,  62,  66,  62,  88,
 62,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  98,
 88,  98,  88, 126, 100, 126, 126, 126,  98, 126,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  22,  25,  22,  22,  24,  25,  26,  26,  26,
 32,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  38,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  62,  62,  66,  62,  88,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88, 100, 100,  88, 100,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  21,  21,  24,  21,  22,  25,  25,  25,  25,  25,  26,  26,  30,
 32,  30,  30,  30,  37,  29,  29,  32,  37,  29,  29,  28,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  38,  41,  38,  41,  41,  41,  41,  41,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  66,  41,  66,  41,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  88,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98, 100,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88, 100,  88,  88, 100, 100,  88, 100,  98,
100,  98,  88, 100, 100, 100, 126, 100,  98, 126, 100, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  25,  25,  25,  25,  25,  25,  26,  25,  30,
 32,  30,  30,  30,  37,  29,  37,  29,  37,  29,  29,  28,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  41,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  41,  41,  41,  38,  41,  41,  41,  62,  41,  66,  41,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  88,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98, 100,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88, 100,  88,  88, 100, 100,  88, 100,  98,
100,  98,  88, 100, 100, 100, 126, 100,  98, 126, 100, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  25,  21,  24,  25,  25,  25,  25,  25,  25,  25,  30,  30,  30,
 32,  30,  34,  34,  37,  34,  34,  32,  37,  34,  36,  42,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  41,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  62,  62,  66,  62,  88,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88, 100, 100,  88,  88, 100, 100,  88, 100,  98,
100,  98,  88, 100, 100, 100, 126, 100,  98, 126, 100, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  17,  17,  18,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  33,  17,  17,  32,  25,  32,  32,  32,  32,  32,  31,  32,  32,  32,  32,
 33,  32,  32,  32,  34,  32,  36,  33,  36,  32,  32,  33,  42,  42,  42,  41,
 42,  41,  42,  48,  38,  38,  41,  38,  41,  38,  38,  41,  38,  41,  38,  38,
 42,  41,  38,  41,  41,  38,  38,  41,  66,  62,  66,  62,  66,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  66,  66,  62,  66,  62,
 66,  66,  66,  66,  66,  66,  66,  62,  62,  66,  66,  62,  66,  66,  66,  66,
 66,  62,  71,  62,  66,  88,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 88,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100, 100, 100,  88,  88, 100,
 88, 100, 100,  88, 100,  88, 125, 100, 100, 100,  88, 100, 100, 100, 100, 100,
100,  98,  88, 100, 100, 100, 100, 100, 126, 100, 100, 100, 100, 100, 100, 100,
125, 100, 100, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  17,  17,  16,  17,  17,  17,  17,
 17,  17,  22,  22,  17,  24,  32,  31,  31,  31,  30,  31,  30,  32,  30,  32,
 32,  32,  34,  32,  37,  36,  34,  32,  36,  36,  36,  33,  42,  38,  38,  41,
 38,  41,  38,  28,  38,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  66,  62,  62,  62,  66,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 88,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88, 100,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 100,
100,  98,  88, 100, 100, 100, 126, 100, 126, 126, 100, 100, 100, 126, 100, 126,
100, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  21,  16,  16,  25,  24,  25,  25,  25,  25,  25,  24,  25,  31,  31,  31,
 32,  34,  37,  34,  37,  34,  37,  36,  37,  36,  40,  42,  39,  40,  40,  37,
 40,  37,  38,  28,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 38,  41,  41,  41,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  66,  63,
 62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  66,  77,
 62,  62,  66,  66,  66,  62,  62,  77,  77,  66,  62,  77,  62,  66,  62,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98,  98,  98, 100,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88, 100, 100, 100,  88, 100, 126,  88, 100,  98,
100,  98,  88, 126, 100, 126, 126, 126,  98, 126, 100, 126, 100, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  25,  25,  25,  24,  25,  25,  25,  31,  31,  31,  31,  31,  31,  31,
 32,  34,  34,  34,  37,  34,  37,  32,  37,  36,  36,  42,  39,  39,  39,  40,
 40,  37,  38,  28,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  88,
 88,  62,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98,  88, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  16,  24,  24,  24,  35,  25,  24,  24,  24,  24,  24,  24,  37,  37,  37,
 34,  34,  37,  37,  35,  37,  37,  39,  35,  37,  37,  39,  40,  37,  37,  35,
 37,  35,  40,  42,  37,  41,  37,  41,  35,  41,  41,  41,  41,  63,  41,  41,
 45,  41,  41,  63,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  62,  63,
 62,  63,  62,  66,  62,  62,  62,  62,  63,  62,  62,  62,  62,  77,  69,  63,
 69,  69,  66,  69,  69,  69,  77,  77,  77,  69,  69,  77,  77,  69,  77,  69,
 77,  77,  77,  77,  88,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98,  98,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88, 100, 100,  88,  88, 126, 126,  88, 126,  98,
126,  98,  88, 126, 126, 126, 126, 126,  98, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  25,  25,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 32,  32,  34,  34,  37,  36,  40,  42,  37,  36,  40,  42,  39,  39,  39,  40,
 40,  40,  44,  28,  41,  45,  41,  45,  41,  41,  41,  41,  41,  41,  41,  41,
 42,  41,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98,  88, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  25,  24,  25,  25,  24,  25,  31,  24,  31,  31,  24,  31,  31,  31,  31,
 36,  34,  37,  34,  35,  34,  37,  39,  37,  40,  40,  42,  39,  40,  40,  37,
 40,  37,  40,  42,  40,  40,  41,  45,  41,  41,  41,  41,  41,  63,  41,  41,
 45,  41,  41,  63,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  66,  63,
 62,  62,  62,  66,  62,  62,  62,  62,  63,  62,  62,  62,  62,  62,  66,  77,
 69,  62,  66,  69,  66,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 126, 100, 100,  98,
100,  98,  88, 126, 126, 126, 126, 126,  98, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  17,  16,  18,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  32,  31,  32,  32,  31,  32,  32,  31,  32,  32,  31,  32,  32,  32,  32,
 33,  32,  36,  32,  40,  32,  36,  42,  40,  42,  42,  33,  42,  42,  42,  40,
 42,  40,  42,  48,  44,  42,  44,  42,  41,  44,  44,  41,  42,  41,  42,  42,
 60,  41,  44,  41,  41,  42,  62,  62,  66,  62,  62,  62,  66,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 88,  88,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
100,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88, 100,  98, 100, 100, 100,  88,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100,  88, 100, 100, 100, 100, 100,
100,  98,  88, 100, 100, 100, 100, 100, 126, 126, 100, 100, 100, 126, 100, 126,
125, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  25,  24,  25,  25,  24,  31,  31,  24,  31,  31,  37,  31,  31,  31,  31,
 39,  39,  37,  37,  35,  37,  37,  39,  37,  37,  37,  42,  39,  40,  40,  37,
 40,  35,  40,  42,  40,  40,  41,  45,  37,  45,  41,  41,  41,  63,  41,  45,
 45,  41,  41,  63,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  62,  63,
 62,  62,  62,  66,  62,  62,  62,  62,  63,  62,  62,  69,  62,  62,  69,  77,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 126, 100, 126,  98,
126,  98,  88, 126, 126, 126, 126, 126,  98, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 25,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 32,  36,  31,  36,  37,  39,  40,  42,  40,  39,  40,  42,  42,  39,  44,  40,
 44,  40,  44,  42,  45,  45,  41,  45,  41,  45,  45,  41,  45,  41,  45,  45,
 42,  41,  41,  41,  41,  45,  62,  41,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  66,  66,  66,  69,  69,  77,  77,  66,  69,  77,  69,  66,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98,  88, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 31,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 42,  39,  40,  39,  37,  39,  40,  42,  37,  39,  40,  42,  39,  40,  45,  40,
 45,  40,  45,  42,  45,  45,  40,  45,  40,  45,  45,  41,  45,  63,  45,  45,
 56,  58,  49,  63,  58,  56,  62,  58,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  62,  71,  62,  62,  62,  62,  62,  66,  77,
 69,  69,  66,  69,  66,  69,  69,  77,  77,  66,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100,  88, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  17,  17,  16,  17,  17,  33,  17,  17,  32,  32,  32,
 32,  33,  32,  32,  32,  31,  33,  32,  32,  32,  32,  31,  32,  32,  32,  32,
 33,  33,  32,  32,  40,  32,  36,  33,  44,  42,  42,  33,  42,  42,  42,  44,
 42,  44,  42,  48,  42,  42,  44,  42,  44,  42,  44,  44,  42,  41,  42,  60,
 60,  50,  64,  41,  64,  60,  64,  62,  60,  64,  66,  62,  66,  62,  66,  62,
 66,  62,  62,  66,  66,  62,  66,  66,  62,  62,  66,  66,  66,  62,  66,  71,
 66,  66,  66,  66,  66,  66,  66,  62,  62,  66,  66,  62,  66,  66,  66,  66,
 88,  88,  71,  88,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88, 100,
100,  98, 100,  88,  88,  88,  88,  88,  88,  88, 100,  66,  88,  88,  88, 100,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100, 100, 100,  88,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100, 125, 100, 100, 100, 100, 100,
100, 126, 125, 100, 100, 100, 100, 100, 126, 100, 100, 100, 125, 126, 100, 100,
125, 126, 100, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  31,  31,  31,  31,
 31,  32,  31,  31,  31,  31,  32,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 32,  32,  39,  39,  40,  39,  40,  42,  40,  39,  44,  42,  42,  44,  44,  40,
 44,  40,  44,  60,  44,  44,  45,  44,  40,  45,  45,  49,  45,  58,  50,  56,
 64,  50,  50,  58,  50,  64,  56,  50,  64,  62,  62,  62,  66,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  66,  66,  66,  69,  69,  62,  71,  66,  69,  71,  69,  66,  69,  88,
 88,  88,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
100,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98, 100, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  31,  31,
 31,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 42,  39,  39,  39,  37,  39,  40,  42,  40,  39,  40,  42,  42,  44,  44,  40,
 44,  40,  44,  42,  45,  45,  45,  45,  40,  45,  45,  49,  45,  54,  49,  56,
 64,  50,  50,  58,  50,  56,  50,  58,  64,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  71,  62,  62,  62,  62,  62,  66,  71,
 69,  69,  66,  66,  66,  69,  69,  77,  77,  66,  69,  77,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98,  88,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  31,  31,  31,
 31,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  39,
 42,  42,  39,  39,  37,  39,  40,  42,  40,  39,  44,  42,  42,  44,  44,  40,
 45,  40,  45,  42,  45,  45,  49,  45,  49,  49,  49,  49,  49,  54,  50,  56,
 64,  50,  50,  58,  58,  56,  56,  58,  64,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  71,  62,  62,  69,  69,  62,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  77,  66,  69,  77,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  31,  43,
 43,  31,  43,  43,  43,  35,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 39,  43,  43,  43,  35,  43,  43,  39,  43,  43,  40,  42,  45,  45,  45,  54,
 45,  54,  45,  42,  45,  45,  54,  45,  54,  49,  54,  54,  49,  63,  49,  49,
 56,  58,  58,  63,  58,  58,  58,  58,  56,  58,  58,  58,  62,  58,  69,  63,
 62,  62,  62,  66,  69,  69,  69,  69,  63,  69,  69,  69,  69,  69,  69,  77,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88, 100,  98,  98,  98,  88,  88, 100, 100,  98,  98,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100,  88, 100, 100, 100,  88, 126, 126, 100, 126, 126,
126,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  31,  31,  31,  31,
 31,  31,  31,  31,  31,  43,  31,  31,  31,  31,  31,  43,  31,  31,  31,  39,
 42,  39,  40,  39,  37,  39,  40,  42,  40,  44,  44,  42,  44,  44,  45,  40,
 45,  40,  45,  42,  45,  45,  49,  49,  54,  49,  49,  58,  49,  54,  50,  56,
 64,  58,  50,  58,  58,  56,  56,  58,  64,  62,  62,  62,  64,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  69,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  43,  43,  43,
 43,  43,  43,  43,  43,  35,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  35,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  54,
 54,  54,  45,  42,  54,  54,  54,  54,  54,  54,  54,  54,  54,  57,  58,  58,
 56,  54,  58,  63,  54,  58,  58,  54,  58,  58,  58,  58,  69,  58,  69,  63,
 69,  63,  69,  66,  69,  69,  69,  69,  63,  69,  69,  69,  69,  77,  69,  77,
 69,  69,  66,  69,  69,  69,  77,  77,  77,  69,  69,  77,  77,  69,  77,  69,
 77,  77,  77,  77,  88,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88, 100,  98,  98,  98,  88,  88, 100, 100,  98,  98,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100,  88, 126, 126, 126,  88, 126, 126, 126, 126,  98,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  32,  31,  31,  31,  31,  31,
 31,  31,  31,  31,  31,  43,  31,  31,  31,  31,  31,  31,  31,  31,  31,  39,
 42,  42,  39,  39,  40,  39,  40,  42,  40,  44,  44,  42,  42,  44,  44,  45,
 44,  40,  44,  60,  49,  49,  49,  49,  49,  49,  50,  50,  50,  54,  56,  56,
 64,  50,  50,  58,  50,  56,  56,  58,  64,  56,  64,  62,  64,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  71,  62,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  66,  66,  69,  69,  71,  71,  66,  69,  71,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,
100,  98,  98,  88,  88,  88, 100,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  33,  33,  16,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  33,  33,  31,  33,  33,  33,  33,  33,  32,  33,  33,  33,  33,
 33,  33,  33,  33,  47,  33,  42,  48,  47,  33,  42,  48,  60,  60,  60,  42,
 60,  52,  60,  48,  60,  60,  52,  60,  52,  60,  60,  52,  60,  52,  60,  60,
 60,  60,  60,  52,  60,  60,  60,  60,  60,  60,  60,  60,  60,  60,  60,  62,
 60,  64,  60,  81,  60,  60,  60,  75,  62,  66,  66,  66,  66,  66,  66,  71,
 66,  66,  81,  66,  66,  66,  66,  62,  71,  66,  66,  62,  66,  66,  66,  66,
 66,  66,  71,  88,  66,  66,  66,  88,  88,  66,  88,  88,  88, 100,  88, 100,
100,  98, 100,  88,  88, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113, 100,
100, 100, 100, 100,  98, 100, 113, 100, 100, 100, 100, 100, 100, 113, 113, 100,
113, 100, 100, 113, 100, 113, 125, 100, 100, 100, 125, 100, 100, 113, 100, 100,
100, 100, 125, 100, 100, 100, 100, 100, 100, 100, 125, 100, 125, 100, 100, 100,
125, 100, 125, 100, 125, 100, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
126, 158, 158, 181, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  31,  31,  31,  31,  31,  31,
 31,  31,  43,  43,  31,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 42,  47,  43,  43,  43,  43,  43,  42,  43,  44,  45,  42,  45,  45,  45,  49,
 49,  54,  49,  42,  49,  49,  49,  49,  54,  49,  49,  58,  50,  54,  50,  56,
 56,  58,  58,  54,  58,  56,  58,  58,  56,  58,  56,  58,  64,  58,  64,  71,
 62,  62,  62,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 98,  98,  98,  88,  88,  88, 100,  88, 100,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  31,  32,  31,  31,  31,  31,  31,
 31,  31,  43,  31,  31,  43,  31,  43,  43,  43,  43,  43,  43,  43,  43,  47,
 42,  47,  43,  47,  43,  47,  43,  42,  43,  47,  44,  42,  44,  45,  49,  49,
 49,  54,  49,  60,  49,  49,  49,  49,  54,  50,  50,  58,  50,  54,  56,  56,
 64,  58,  56,  58,  58,  56,  56,  58,  64,  58,  56,  58,  64,  58,  64,  71,
 62,  62,  62,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  69,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,
 98,  98,  98,  88,  88,  88, 100,  88, 100,  88, 100,  88,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  16,  18,  16,  43,  31,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  43,  43,  43,  43,  43,  43,  47,  43,  43,  43,  42,  45,  49,  49,  54,
 49,  54,  49,  42,  55,  49,  54,  49,  54,  55,  54,  54,  50,  54,  58,  56,
 56,  58,  58,  54,  58,  56,  58,  58,  56,  58,  58,  58,  69,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  77,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88, 100,  88, 100,  88, 100,  88,  88, 100,  88,  98,
100, 100, 100,  98,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 126, 100,  88, 126, 126, 100, 126, 126,
126,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  31,  32,  31,  31,  31,  31,  31,
 31,  31,  43,  31,  31,  43,  31,  43,  43,  43,  43,  43,  43,  47,  47,  47,
 42,  47,  47,  47,  43,  47,  47,  42,  47,  47,  47,  42,  47,  47,  49,  49,
 49,  49,  49,  60,  49,  49,  50,  50,  58,  50,  50,  58,  50,  54,  56,  56,
 64,  50,  56,  58,  58,  56,  56,  58,  64,  56,  64,  65,  64,  58,  64,  71,
 62,  62,  62,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  69,  69,  71,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
 98,  98,  98,  88,  88,  88, 100,  88, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  54,
 54,  54,  55,  56,  54,  54,  54,  54,  54,  54,  54,  54,  54,  57,  58,  58,
 56,  54,  58,  54,  54,  58,  58,  54,  58,  58,  58,  58,  69,  58,  69,  63,
 69,  63,  69,  66,  69,  69,  69,  69,  63,  69,  69,  69,  69,  77,  69,  76,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  77,  69,  77,  69,
 77,  77,  77,  77,  88,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88, 100,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100,  98,  98,  98, 100,  88, 100, 100,  98,  98,  98, 100, 100,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 126, 126, 126,  88, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  46,  32,  43,  31,  31,  43,  43,
 43,  31,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  47,
 42,  47,  43,  47,  43,  47,  43,  47,  43,  47,  47,  42,  47,  47,  49,  49,
 49,  54,  49,  60,  49,  49,  50,  50,  54,  50,  50,  58,  50,  54,  56,  56,
 64,  58,  56,  58,  58,  56,  56,  58,  64,  65,  64,  65,  64,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  71,  71,  69,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  46,  46,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  47,  43,  43,  43,  43,  43,  47,  43,  47,  47,  42,  47,  49,  49,  54,
 49,  54,  49,  60,  55,  49,  55,  50,  54,  50,  55,  54,  50,  54,  56,  56,
 64,  58,  58,  54,  58,  56,  58,  58,  56,  58,  65,  58,  64,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  77,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 100, 100, 100, 126, 126, 100, 126, 126,
126,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  46,  46,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  47,  43,  43,  43,  47,  49,  55,  55,  54,
 55,  54,  55,  64,  55,  55,  54,  55,  54,  55,  54,  54,  55,  57,  55,  56,
 56,  58,  58,  54,  58,  65,  58,  58,  56,  58,  58,  58,  65,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  71,  69,  76,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  69,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100, 100,  98,  98, 100, 100, 100, 100,  98,  98,  98, 100, 100, 100, 100,
 88, 100,  98, 100, 100, 100, 125, 126, 126, 126, 100, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
158, 126, 126, 126, 158, 158, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  43,  43,
 43,  31,  43,  43,  43,  43,  47,  43,  43,  43,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  42,  47,  47,  47,  55,
 49,  55,  52,  60,  50,  50,  55,  52,  55,  50,  50,  58,  56,  54,  56,  56,
 64,  65,  56,  58,  65,  64,  56,  58,  64,  65,  64,  65,  64,  67,  64,  71,
 69,  71,  69,  75,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  69,  69,  71,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
100,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  51,  43,  51,  51,  51,  43,  51,  51,  51,  43,  51,  51,  51,  51,
 51,  51,  51,  56,  51,  51,  51,  51,  57,  51,  51,  51,  51,  57,  54,  54,
 55,  54,  54,  57,  54,  54,  54,  54,  58,  54,  54,  54,  58,  54,  69,  76,
 58,  63,  63,  69,  63,  76,  69,  69,  76,  77,  69,  69,  77,  76,  69,  76,
 77,  77,  69,  69,  69,  77,  77,  76,  76,  69,  77,  76,  77,  69,  77,  77,
 77,  77,  76,  77,  77,  77,  88,  77,  77,  88,  77,  77,  88,  77,  77,  77,
 98,  98,  98,  88,  88,  88,  77,  88, 100,  88,  98,  88,  88, 100,  88,  98,
100,  98,  98,  98,  98, 100,  88, 100, 100,  98,  98,  98, 126, 100,  88, 126,
 88, 126,  98, 100, 126, 126, 125, 126, 126, 126,  88, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181,
 23,   2,   2,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  47,  43,  43,  47,  43,  47,  47,  47,  47,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  55,
 52,  55,  52,  60,  52,  52,  55,  52,  55,  52,  50,  67,  52,  54,  56,  64,
 64,  65,  65,  58,  65,  64,  65,  67,  64,  65,  64,  65,  64,  65,  64,  71,
 73,  71,  73,  75,  73,  69,  69,  64,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  92,  69,  71,  69,  88,  69,  88,
 92,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
100,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
 23,   2,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  47,
 52,  55,  52,  60,  52,  52,  52,  52,  55,  52,  52,  67,  52,  54,  64,  64,
 64,  65,  56,  67,  65,  64,  64,  65,  64,  64,  64,  64,  64,  65,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  64,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  75,  87,  66,  69,  69,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  71,  71,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
100,  98,  98,  88, 100, 113, 100, 100, 100, 100, 100, 125,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100, 100, 100, 100, 113, 100,
113, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,   2,   2,  46,  46,  46,  46,  46,  46,  33,  46,  46,  46,  46,  46,
 46,  33,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  60,  61,  61,  61,  47,
 52,  47,  61,  48,  52,  52,  52,  52,  52,  52,  52,  52,  64,  67,  64,  60,
 60,  64,  64,  67,  64,  60,  64,  64,  60,  64,  70,  64,  60,  64,  75,  71,
 64,  73,  64,  75,  64,  64,  70,  75,  71,  87,  70,  70,  87,  87,  75,  71,
 87,  87,  75,  75,  75,  92,  92,  71,  71,  75,  92,  71,  92,  66,  92,  92,
 92,  92,  71,  92,  92,  88, 113,  88,  88, 113,  88, 100,  88, 100, 100, 100,
100,  98, 100, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113, 100,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 100, 113, 100, 113, 125, 100, 100, 100, 125, 100, 100, 100, 100, 126,
100, 126, 125, 100, 100, 100, 126, 100, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  47,  43,  47,  43,  47,  43,  47,  43,  47,  47,  47,  47,  47,  55,  55,
 55,  54,  55,  60,  55,  55,  55,  55,  54,  55,  55,  54,  55,  54,  65,  56,
 64,  67,  65,  54,  67,  65,  65,  67,  64,  67,  65,  67,  64,  67,  64,  71,
 73,  71,  67,  75,  69,  69,  69,  69,  71,  69,  69,  69,  69,  71,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  71,  71,  69,  69,  77,  69,  92,  69,  92,
 92,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100, 100, 100,
 98,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100,  98, 100, 100, 100, 125, 100, 126, 100, 125, 126, 126, 100, 126, 126,
126,  98, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  43,  43,  43,  43,  47,  43,  43,  43,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  55,
 52,  55,  52,  60,  55,  52,  55,  52,  55,  52,  55,  55,  65,  54,  65,  56,
 64,  67,  65,  67,  67,  64,  65,  67,  64,  65,  68,  65,  64,  67,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  87,  71,  69,  87,  87,  69,  71,  87,  71,
 87,  69,  75,  87,  92,  87,  69,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  77,  77,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
 98,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 126, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  18,  46,  46,  46,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  51,  43,  51,  43,  51,  51,  51,  43,  51,  51,  51,  51,
 51,  51,  51,  56,  51,  51,  51,  51,  51,  54,  54,  54,  54,  57,  54,  55,
 56,  54,  54,  57,  54,  55,  54,  54,  65,  58,  67,  58,  67,  58,  68,  76,
 58,  79,  80,  64,  80,  69,  69,  69,  76,  69,  69,  69,  69,  77,  69,  76,
 69,  77,  69,  69,  69,  69,  77,  76,  76,  69,  77,  76,  77,  69,  77,  77,
 77,  77,  76,  77,  77,  77,  88,  77,  77,  88,  88,  77,  88,  77,  77,  77,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100,  98,  98,  98, 100, 100, 100, 100,  98,  98,  98, 126, 100, 100, 100,
 88, 126,  98, 100, 126, 126, 125, 126, 126, 126, 100, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  47,
 47,  47,  43,  47,  43,  47,  43,  47,  43,  47,  47,  47,  47,  47,  55,  55,
 55,  54,  55,  60,  55,  55,  55,  55,  54,  55,  55,  55,  65,  54,  65,  65,
 64,  67,  65,  54,  67,  65,  65,  67,  64,  65,  68,  67,  64,  67,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  87,  71,  69,  87,  87,  69,  71,  87,  71,
 87,  69,  75,  87,  92,  87,  69,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  77,  77,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
 98,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 126, 100, 100, 100, 125, 100, 100, 100, 125, 126, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  47,
 52,  55,  52,  60,  52,  52,  52,  52,  55,  52,  52,  67,  52,  67,  64,  64,
 64,  65,  65,  67,  65,  64,  64,  65,  64,  64,  64,  73,  64,  73,  70,  71,
 73,  73,  73,  75,  73,  73,  73,  70,  71,  87,  87,  87,  87,  87,  75,  71,
 87,  87,  75,  87,  92,  92,  92,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  71,  92,  92,  92, 113,  88,  88,  88,  88, 100,  88, 100, 100, 100,
100,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100, 100, 100, 100, 113, 100,
125, 100, 100, 113, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  47,  43,  47,  47,  43,  47,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  55,
 52,  55,  52,  60,  55,  52,  55,  52,  55,  52,  55,  67,  65,  54,  65,  64,
 64,  65,  65,  67,  65,  64,  68,  67,  64,  68,  68,  73,  64,  73,  70,  71,
 73,  73,  73,  75,  73,  73,  73,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  87,  92,  92,  92,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  77,  92,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
100,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 100, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
125, 100, 126, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  47,  43,  43,  43,  47,  43,  47,  43,  47,  47,  47,  47,  55,  55,  55,
 55,  54,  55,  60,  55,  55,  55,  55,  54,  55,  55,  54,  55,  54,  65,  65,
 64,  67,  67,  54,  67,  68,  65,  67,  68,  67,  68,  67,  73,  67,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  87,  71,  87,  87,  87,  87,  71,  87,  71,
 87,  87,  75,  87,  92,  87,  87,  71,  71,  92,  92,  77,  92,  92,  92,  92,
 92,  92,  76,  77,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
 98,  98,  98, 100, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 126, 100, 100, 100, 125, 126, 126, 100, 125, 126, 126, 126, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  61,  47,  47,  47,  47,  47,  61,  47,  47,  47,  61,  61,  61,  61,  47,
 61,  47,  61,  60,  52,  52,  52,  52,  52,  52,  52,  65,  52,  67,  64,  64,
 60,  68,  64,  67,  68,  70,  64,  68,  70,  64,  70,  73,  70,  73,  75,  71,
 73,  73,  73,  75,  73,  73,  73,  70,  71,  87,  87,  87,  87,  87,  75,  71,
 87,  87,  75,  92,  75,  92,  92,  87,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  71,  92,  92,  92, 113,  92, 109, 109, 109, 100, 109, 100, 100, 100,
100,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 100, 113, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  43,  47,  47,  47,  47,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  59,  47,  59,  61,  59,  59,  59,  55,
 59,  55,  59,  60,  55,  52,  55,  52,  55,  65,  55,  67,  68,  54,  68,  68,
 64,  67,  68,  67,  68,  68,  68,  67,  68,  68,  73,  73,  73,  73,  70,  71,
 73,  73,  73,  75,  73,  73,  73,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92,  92,  92, 100,  92, 100, 100, 100,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 113, 100, 100, 125, 100, 100, 100, 125, 126, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  47,  47,  47,  47,  47,  47,  61,  59,  47,  59,  61,  61,  59,  59,  59,
 59,  59,  61,  60,  59,  52,  55,  52,  55,  52,  68,  67,  68,  67,  68,  68,
 70,  68,  68,  67,  68,  68,  68,  68,  70,  73,  73,  73,  70,  73,  70,  71,
 73,  73,  73,  75,  73,  87,  87,  70,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92,  87,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92, 104,  92,  92,  92, 113,  92,  92, 109,  92,  92, 109, 100, 100, 100,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 126, 113, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  59,
 61,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  55,  59,  60,  59,  59,  55,  59,  55,  68,  55,  67,  68,  54,  68,  68,
 70,  68,  68,  67,  68,  68,  68,  68,  68,  73,  73,  73,  73,  73,  70,  71,
 73,  78,  73,  75,  73,  87,  87,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92, 104,  71,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92, 109,  92,  92,  92, 100, 100, 104,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 113, 100, 100, 125, 100, 100, 100, 125, 126, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  61,  47,  61,  59,  61,  59,  61,  59,  61,  61,  61,  61,  61,  61,  59,
 61,  59,  61,  60,  61,  61,  59,  61,  59,  61,  61,  68,  61,  67,  70,  70,
 70,  68,  68,  67,  68,  70,  70,  68,  70,  70,  70,  73,  70,  73,  75,  71,
 73,  73,  73,  75,  85,  85,  85,  70,  87,  87,  87,  87,  87,  87,  75,  71,
 87,  87,  75,  92,  97,  92,  92,  92,  71,  92,  92,  92,  92,  92,  92,  92,
 92,  92, 104,  92,  92,  92, 113, 109, 109, 109, 109, 109, 109, 100, 109, 100,
100,  98, 104, 109, 109, 113, 100, 109, 100, 109, 100, 125, 113, 100, 113, 100,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 100, 125, 100, 113, 125, 100, 100, 100, 125, 100, 126, 125, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  43,  59,  59,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  55,  59,  61,  59,  59,  55,  59,  55,  68,  55,  55,  68,  54,  68,  68,
 70,  68,  68,  67,  68,  68,  68,  78,  68,  73,  73,  73,  73,  78,  70,  80,
 73,  80,  78,  75,  84,  84,  84,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92,  92,  92,  92,  92, 104, 100, 104,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 113, 100, 100, 125, 126, 126, 100, 125, 126, 126, 126, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  61,  61,  61,  61,  61,  47,  61,  61,  61,  61,
 61,  61,  61,  61,  59,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  60,  61,  61,  61,  61,  61,  61,  61,  61,  61,  67,  70,  70,
 60,  70,  70,  68,  70,  70,  70,  70,  70,  70,  70,  70,  75,  70,  75,  73,
 70,  85,  70,  81,  70,  70,  70,  75,  87,  90,  70,  90,  90,  87,  75,  87,
 97,  90,  75,  75,  75,  97,  92,  92,  92,  97,  92,  92,  92, 109,  92, 109,
 92,  92, 104,  92, 109, 109, 113, 109, 109, 109, 109, 109, 109, 109, 109, 100,
100,  98, 100, 109, 109, 113, 109, 109, 109, 113, 109, 125, 113, 113, 113, 100,
113, 100, 100, 100,  98, 113, 113, 113, 113, 100, 100, 100, 100, 113, 113, 113,
125, 113, 100, 125, 113, 113, 125, 113, 113, 113, 125, 113, 100, 125, 133, 126,
125, 126, 125, 133, 125, 126, 126, 140, 126, 126, 125, 140, 125, 126, 125, 140,
125, 140, 125, 140, 125, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  51,  46,  46,  43,  43,  43,  51,  43,  43,  43,  51,
 59,  59,  51,  51,  51,  51,  51,  59,  51,  51,  51,  59,  59,  51,  51,  51,
 51,  51,  51,  59,  51,  51,  51,  74,  51,  74,  51,  51,  74,  57,  74,  78,
 68,  80,  80,  79,  80,  78,  80,  80,  78,  80,  80,  80,  78,  80,  84,  79,
 80,  79,  80,  75,  80,  80,  80,  84,  79,  80,  80,  80,  80,  79,  87,  79,
 87,  80,  92,  92,  92,  92,  92, 104,  76,  92,  92, 105, 104,  92, 104,  92,
104, 104, 102, 104,  92, 104,  92, 104, 104,  92, 104, 104,  92, 104, 104, 104,
104,  98,  98, 104, 104, 109, 104, 100, 104, 100, 104, 125, 100, 100, 100,  98,
100, 100,  98,  98,  98, 100, 100, 100, 100,  98, 126,  98, 126, 100, 100, 126,
125, 126, 126, 140, 126, 126, 125, 126, 126, 126, 140, 126, 126, 126, 126, 126,
126, 126, 140, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
158, 126, 158, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  67,  68,  79,  68,  68,
 70,  68,  68,  80,  68,  68,  68,  78,  73,  73,  73,  73,  73,  78,  70,  80,
 85,  78,  84,  75,  85,  84,  85,  85,  80,  87,  87,  87,  87,  87,  90, 104,
 87,  87,  75,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92, 109, 112,  92, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 100, 100, 100, 100, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 126, 100, 113, 113, 100,
125, 100, 126, 125, 100, 140, 125, 140, 140, 140, 125, 126, 126, 140, 126, 126,
140, 126, 125, 126, 126, 126, 126, 126, 126, 126, 140, 126, 125, 126, 126, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158,
158, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,
 59,  59,  59,  59,  51,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,
 59,  51,  59,  61,  59,  59,  55,  59,  51,  59,  55,  55,  68,  79,  68,  68,
 68,  78,  78,  79,  78,  68,  78,  78,  73,  78,  78,  78,  84,  78,  85,  79,
 78,  80,  80,  75,  84,  84,  84,  84,  80,  84,  87,  87,  87,  80,  87,  79,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92, 104, 104, 104,  92,  92, 109,  92,  92,  92,  92, 104,  92, 104, 104, 104,
104,  98,  98, 112, 112, 113, 104, 100, 100, 100, 100, 125, 109, 100, 109,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 140, 126, 140, 125, 126, 126, 140, 125, 126, 126, 140, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 140, 126, 140, 126, 126, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  55,  59,  59,  67,  68,  79,  68,  68,
 70,  78,  68,  80,  78,  68,  78,  78,  73,  78,  73,  78,  73,  78,  70,  80,
 84,  80,  78,  75,  84,  84,  84,  85,  80,  87,  87,  87,  87,  87,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92,  92, 112,  92, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 100, 100, 100, 100, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100, 126, 100, 113, 113, 100,
125, 100, 126, 125, 100, 140, 125, 140, 126, 140, 125, 126, 126, 140, 126, 126,
140, 126, 125, 126, 126, 126, 126, 126, 126, 126, 140, 126, 125, 126, 126, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 48,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  48,  61,  61,  61,  61,
 61,  61,  61,  48,  61,  61,  61,  82,  61,  82,  61,  61,  82,  61,  82,  82,
 75,  70,  82,  70,  70,  75,  75,  70,  75,  75,  75,  75,  75,  75,  75,  70,
 75,  75,  75,  81,  75,  75,  75,  75,  70,  75,  75,  75,  75,  97,  95,  90,
 75,  75,  95,  95,  95,  95,  97,  97,  97,  95,  97,  97,  97,  95,  97,  95,
109, 109, 112, 109, 109, 109,  95, 109, 109, 113, 109, 109, 113, 109, 109, 109,
109, 104, 109, 113, 113,  95, 109, 113, 113, 113, 113,  95, 113, 113, 113, 100,
113, 113, 113, 109, 100, 113, 113, 113, 113, 100, 113, 100, 113, 125, 125, 113,
125, 113, 133, 125, 113, 125, 125, 113, 113, 125, 125, 125, 133, 125, 125, 133,
125, 100, 125, 125, 125, 133, 133, 125, 133, 133, 125, 125, 125, 133, 125, 125,
125, 125, 125, 125, 125, 125, 125, 125, 140, 163, 163, 125, 163, 163, 163, 163,
163, 163, 126, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163,
163, 158, 163, 163, 163, 163, 163, 158, 163, 163, 163, 181, 163, 181, 197, 181,
181, 181, 181, 197, 197, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  78,  68,  79,  68,  68,
 70,  78,  68,  80,  78,  68,  78,  78,  73,  78,  73,  78,  85,  78,  70,  80,
 84,  78,  84,  75,  84,  84,  85,  85,  80,  87,  87,  87,  87,  89,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109, 112, 112, 109, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 112, 112, 112, 112, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 126, 100, 113, 113, 100,
125, 100, 126, 125, 140, 140, 125, 140, 140, 140, 125, 140, 126, 140, 140, 126,
140, 126, 125, 140, 140, 126, 126, 126, 126, 126, 140, 126, 125, 126, 140, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  78,  68,  79,  68,  68,
 70,  78,  78,  80,  78,  68,  78,  78,  73,  78,  85,  78,  85,  78,  70,  80,
 84,  80,  84,  75,  84,  84,  84,  90,  80,  89,  87,  87,  89,  89,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92, 104, 104, 104,  92,  92, 109, 112, 112, 112, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 109,  98,
100, 100, 100, 100,  98, 100, 109, 100, 100,  98, 100, 126, 100, 113, 113, 140,
125, 140, 126, 125, 140, 140, 125, 140, 140, 140, 125, 140, 126, 140, 140, 126,
140, 126, 125, 140, 140, 126, 126, 140, 126, 126, 140, 140, 140, 126, 140, 126,
125, 126, 140, 126, 140, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  78,  68,  79,  68,  68,
 70,  78,  78,  80,  78,  68,  78,  78,  70,  78,  85,  78,  85,  78,  70,  80,
 85,  78,  84,  75,  85,  85,  85,  90,  80,  89,  90,  90,  87,  89,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109, 112, 112, 109, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 126, 100, 113, 113, 140,
125, 140, 126, 125, 140, 140, 125, 140, 140, 140, 125, 140, 126, 140, 140, 126,
140, 126, 125, 140, 140, 126, 126, 140, 126, 126, 140, 140, 125, 126, 140, 126,
125, 126, 140, 126, 140, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  61,  59,  61,
 61,  61,  59,  61,  59,  61,  59,  61,  59,  61,  61,  61,  61,  61,  61,  59,
 61,  59,  61,  82,  61,  61,  59,  61,  59,  61,  61,  59,  61,  78,  70,  70,
 70,  68,  70,  78,  73,  70,  70,  73,  70,  70,  70,  85,  70,  85,  75,  78,
 85,  85,  85,  75,  90,  90,  90,  97,  89,  90,  90,  90,  90,  90,  97, 104,
 90,  90,  75,  97,  97,  90,  92,  92, 104,  97,  92, 104,  92,  97,  92,  92,
 92,  92, 104, 104, 109, 112, 109, 109, 109, 109, 109, 112, 109, 112, 109, 112,
104, 104, 104, 109, 109, 113, 112, 109, 109, 109, 109, 125, 113, 109, 113, 104,
109, 109, 100, 100,  98, 109, 113, 113, 109,  98, 100, 100, 133, 113, 125, 133,
125, 133, 100, 125, 133, 133, 125, 133, 133, 133, 125, 140, 140, 125, 140, 126,
133, 126, 125, 140, 140, 140, 140, 140, 126, 140, 125, 140, 125, 140, 140, 140,
125, 140, 125, 140, 140, 140, 140, 140, 126, 126, 140, 125, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 158, 181, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  53,  59,  59,
 59,  59,  74,  59,  51,  59,  74,  59,  74,  74,  74,  59,  59,  74,  74,  74,
 74,  74,  74,  59,  74,  74,  74,  74,  74,  74,  74,  74,  74,  79,  74,  74,
 83,  74,  74,  79,  74,  83,  83,  80,  83,  83,  83,  80,  83,  80,  84,  79,
 80,  80,  80,  75,  80,  80,  80,  84,  79,  80,  89,  89,  80,  80,  89, 102,
 89,  89,  92,  91,  92,  91, 104, 105, 102,  92, 104, 105, 104,  92, 104,  92,
104, 104, 102, 104, 104, 104, 112, 104, 104, 112, 104, 104, 117, 104, 104, 104,
104, 122, 122, 117, 117, 112, 104, 117, 117, 117, 117, 125, 117, 117, 117,  98,
117, 117, 104, 104,  98, 117, 117, 117, 117,  98, 126,  98, 126, 140, 140, 140,
125, 140, 126, 140, 140, 140, 125, 140, 140, 140, 140, 140, 126, 140, 140, 126,
140, 126, 140, 126, 126, 126, 126, 126, 126, 126, 140, 158, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  53,  46,  53,  53,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  79,  83,  83,
 70,  83,  83,  80,  83,  83,  83,  83,  85,  83,  83,  83,  85,  83,  85,  80,
 84,  83,  83,  75,  84,  89,  84,  90,  80,  89,  89,  91,  89,  89,  90, 104,
 91,  91,  97,  90,  97,  96,  96, 104, 104,  92,  96, 104,  96,  92,  96,  92,
 92, 104, 104, 104,  92, 112, 109, 112, 112, 112, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 117, 112, 117, 112, 117, 125, 109, 112, 109, 104,
117, 117, 117, 117,  98, 117, 133, 140, 140,  98, 140, 126, 140, 133, 133, 140,
125, 140, 126, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 125, 140, 140, 140, 126, 140, 126, 126, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  53,  46,  53,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  80,  68,  68,
 82,  83,  83,  83,  83,  85,  83,  83,  70,  83,  85,  85,  85,  83,  70,  80,
 85,  83,  85,  75,  85,  85,  85,  90,  89,  89,  90,  90,  90,  89,  97, 104,
 90,  91,  97,  97,  97,  96,  96, 104, 104,  97,  92, 104,  92,  97,  92,  92,
 92,  92, 104, 104, 112, 112, 109, 112, 112, 109, 112, 112, 112, 112, 112, 104,
104, 104, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 113, 104,
112, 112, 117, 117,  98, 112, 113, 133, 133,  98, 140, 126, 140, 133, 125, 140,
125, 140, 126, 125, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 158, 181, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  46,  46,  53,  53,  46,  53,  53,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  80,  83,  68,
 82,  83,  83,  83,  83,  85,  83,  83,  70,  83,  85,  85,  85,  83,  70,  80,
 85,  83,  85,  75,  85,  85,  90,  90,  89,  91,  90,  90,  90,  91,  97, 104,
 90,  96,  97,  97,  97,  96,  96, 104, 104,  97,  96, 104,  96,  97,  96,  92,
101, 101, 104, 104, 112, 112, 109, 112, 112, 112, 112, 112, 112, 112, 112, 104,
104, 104, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 109, 104,
112, 112, 117, 117,  98, 112, 133, 133, 133,  98, 140, 140, 140, 133, 125, 140,
125, 140, 140, 125, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
158, 158, 158, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  46,  46,  53,  53,  46,  53,  53,  53,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  79,  83,  83,
 82,  83,  83,  80,  83,  83,  83,  83,  85,  83,  83,  83,  85,  83,  90,  80,
 83,  83,  83,  75,  89,  89,  89,  90,  80,  89,  91,  91,  91,  91,  90, 104,
 96,  96,  97,  90,  97,  96,  96, 104, 104,  99,  96, 104,  96,  99, 101, 101,
101, 104, 104, 104, 112, 112, 109, 112, 112, 112, 112, 112, 112, 104, 112, 104,
104, 104, 104, 112, 112, 113, 117, 112, 117, 112, 117, 125, 109, 112, 109, 104,
117, 117, 117, 117,  98, 117, 133, 140, 140,  98, 140, 119, 140, 133, 133, 140,
125, 140, 140, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
158, 158, 158, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  53,  46,  53,  53,  46,  53,  53,  53,  53,
 53,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  74,
 59,  74,  59,  82,  59,  59,  74,  59,  74,  59,  74,  74,  83,  79,  83,  83,
 83,  83,  83,  79,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  85,  79,
 83,  83,  83,  75,  83,  83,  89,  90,  80,  89,  89,  91,  91,  89,  90, 105,
 91,  91,  97,  96,  99,  96,  96, 104, 104,  96,  96, 104, 101,  99, 104, 101,
104, 104, 105, 104, 101, 110, 112, 117, 117, 112, 117, 117, 112, 104, 117, 104,
104, 122, 104, 117, 117, 109, 117, 117, 117, 117, 117, 125, 112, 117, 112, 104,
117, 117, 119, 119,  98, 117, 140, 140, 140, 146, 140, 146, 140, 140, 133, 140,
125, 140, 126, 140, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 140, 140, 140, 140, 126, 140, 126, 140, 140, 140, 140, 158, 140, 158,
140, 158, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 158, 181, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  53,  46,  53,  53,  46,  53,  61,  61,  61,
 61,  61,  61,  61,  59,  61,  59,  61,  59,  61,  61,  61,  61,  61,  61,  59,
 61,  59,  61,  82,  61,  61,  61,  61,  59,  61,  61,  61,  82,  83,  82,  82,
 82,  70,  82,  83,  70,  82,  82,  85,  82,  70,  82,  90,  82,  85,  82,  83,
 90,  90,  90,  95,  90,  90,  90,  97,  89,  90,  97,  97,  90,  90,  97,  91,
 97,  97,  95,  97,  97,  97,  97,  96, 104,  97,  97, 104,  97,  97,  99,  97,
112, 112, 104, 112, 109, 112, 109, 109, 109, 109, 109, 112, 109, 112, 112, 112,
104, 104, 104, 109, 109, 113, 112, 109, 109, 109, 112, 125, 113, 109, 113, 104,
109, 109, 112, 112, 104, 133, 113, 133, 133, 119, 133, 140, 133, 133, 125, 133,
125, 133, 140, 125, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 126, 125, 140, 133, 140, 140, 140, 140, 140, 125, 140, 125, 140, 140, 140,
125, 140, 125, 140, 140, 140, 140, 140, 158, 140, 140, 125, 158, 140, 158, 158,
158, 140, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  46,  53,  53,  74,  53,  53,  74,  74,
 53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  83,  74,  83,  94,
 94,  94,  94, 103,  94,  94,  94,  83,  94,  94,  94,  94,  94,  94,  91, 102,
 94,  94,  99,  96,  96, 110, 105, 102, 102, 101, 110, 102, 105, 110, 105, 110,
105, 105, 102, 105, 110, 105, 112, 104, 110, 117, 117, 105, 117, 105, 119, 105,
105, 122, 122, 117, 117, 117, 119, 117, 119, 117, 119, 125, 117, 117, 117, 122,
119, 119, 119, 122, 122, 117, 117, 117, 117, 122, 146, 122, 140, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 126, 140, 140, 146,
140, 146, 140, 158, 158, 158, 158, 158, 165, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  46,  53,  53,  46,  53,  53,  53,  53,
 53,  53,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  83,  83,  82,
 82,  83,  83,  83,  83,  83,  83,  83,  82,  83,  85,  83,  90,  83,  82,  83,
 85,  83,  89,  75,  90,  91,  90,  90,  89,  91,  90,  90,  91,  91,  97, 104,
 99,  96,  97,  97,  97,  99,  96, 104, 104,  97,  99, 104, 101,  97, 101,  99,
101, 101, 104, 104, 112, 112, 109, 112, 112, 112, 112, 112, 112, 117, 112, 104,
104, 104, 104, 112, 112, 113, 117, 112, 112, 112, 117, 125, 109, 112, 109, 119,
117, 117, 117, 117, 146, 133, 133, 133, 133, 146, 140, 140, 140, 133, 133, 140,
125, 140, 140, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 140, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  46,  53,  53,  53,  53,
 53,  53,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  83,  83,  83,  79,  83,  83,
 82,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  85,  83,  90,  83,
 83,  83,  83,  75,  89,  89,  91,  90,  89,  91,  91,  91,  91,  91,  97, 104,
 96,  96,  97,  99,  97,  96, 101, 104, 104,  99, 101, 104, 101,  99, 101, 101,
101, 110, 104, 104, 112, 112, 109, 112, 112, 112, 112, 117, 112, 117, 117, 104,
104, 122, 104, 112, 112, 109, 117, 117, 117, 117, 117, 125, 112, 117, 109, 119,
117, 117, 117, 119, 146, 117, 133, 140, 140, 146, 140, 146, 140, 133, 133, 140,
125, 140, 140, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  61,  61,  61,  61,  61,  61,  61,
 82,  61,  61,  61,  61,  61,  61,  82,  61,  61,  61,  82,  82,  82,  82,  61,
 82,  61,  82,  82,  82,  82,  82,  82,  61,  82,  82,  82,  82,  61,  82,  82,
 82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  95,  90,
 82,  97,  82,  95,  97,  97,  97,  95,  97,  97,  97,  97,  97,  97,  95,  90,
106,  97,  95, 106,  95, 106, 106,  97,  99,  95, 106,  97, 106, 106, 106, 106,
106, 106, 104, 112, 106, 106,  95, 109, 109, 109, 109, 109, 109, 109, 109, 109,
112, 104, 112, 109, 109, 125, 109, 109, 109, 109, 109, 125, 113, 113, 113, 133,
133, 133, 133, 133, 119, 133, 113, 133, 133, 133, 133, 133, 133, 125, 125, 133,
125, 133, 133, 125, 133, 125, 125, 133, 133, 133, 125, 133, 133, 125, 133, 133,
133, 140, 125, 133, 133, 133, 133, 133, 140, 133, 125, 133, 125, 133, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 140, 163, 163, 163, 163, 163, 163, 163,
163, 163, 158, 163, 163, 163, 163, 163, 163, 163, 181, 163, 163, 163, 163, 163,
163, 181, 181, 181, 163, 181, 197, 181, 181, 197, 197, 181, 197, 197, 197, 181,
181, 181, 181, 197, 197, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  46,  53,  53,  53,  53,
 61,  61,  59,  59,  59,  59,  59,  61,  59,  59,  59,  82,  61,  61,  61,  59,
 61,  59,  61,  82,  59,  61,  59,  82,  59,  61,  59,  83,  82,  83,  82,  82,
 82,  83,  82,  83,  83,  82,  82,  83,  82,  85,  82,  90,  82,  85,  82,  83,
 90,  90,  90,  95,  90,  90,  90,  97,  91,  90,  97,  97,  90,  96,  97, 104,
 97,  99, 106,  97,  97,  97,  99, 101, 104,  97,  99, 104,  99,  97,  99,  99,
112, 112, 104, 104, 112, 112, 109, 112, 112, 109, 112, 112, 112, 112, 112, 112,
104, 104, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 133, 113, 119,
133, 133, 117, 117, 146, 133, 133, 133, 133, 146, 140, 140, 133, 133, 125, 133,
125, 133, 140, 125, 133, 133, 125, 133, 133, 133, 125, 140, 140, 133, 140, 140,
133, 140, 125, 140, 140, 140, 140, 140, 140, 140, 133, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 140, 140, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 61,  61,  59,  61,  59,  61,  59,  82,  59,  61,  61,  82,  82,  61,  61,  86,
 61,  86,  82,  82,  82,  82,  86,  82,  86,  82,  82,  86,  82,  83,  82,  82,
 82,  82,  82,  83,  82,  82,  82,  82,  82,  82,  82,  82,  82,  90,  82,  83,
 97,  90,  90,  95,  97,  97,  97,  97,  91,  97,  97,  97,  97,  99,  97,  96,
 97,  97,  95,  97, 106,  97,  97, 101, 101, 106,  97, 101,  99, 106,  99, 106,
114, 114, 104, 114, 106, 112, 106, 112, 112, 109, 112, 112, 109, 112, 112, 112,
119, 104, 119, 109, 109, 113, 112, 109, 112, 133, 112, 125, 109, 133, 113, 119,
133, 133, 133, 133, 146, 133, 133, 133, 133, 146, 133, 140, 133, 133, 125, 133,
125, 133, 140, 125, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 140, 125, 133, 133, 140, 140, 140, 140, 140, 133, 140, 125, 140, 140, 140,
125, 140, 163, 140, 140, 140, 140, 140, 158, 140, 140, 163, 158, 140, 158, 158,
158, 163, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  59,  59,  59,  86,  59,  59,  82,  59,  59,  59,  86,
 86,  86,  59,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  83,  83,  82,
 82,  83,  83,  83,  83,  83,  83,  83,  82,  83,  83,  83, 103,  83,  82,  83,
 90,  83,  91,  82,  91,  91,  91,  97,  91,  91,  99,  99,  96,  96,  97, 104,
 99,  96, 106,  99,  97,  99, 101, 104, 104,  97,  99, 104, 101,  99, 101,  99,
101, 107, 104, 104, 114, 112, 109, 112, 112, 112, 112, 117, 112, 117, 112, 119,
119, 104, 119, 112, 112, 109, 117, 117, 117, 112, 117, 125, 133, 117, 133, 119,
117, 117, 117, 119, 146, 133, 133, 133, 133, 146, 140, 146, 140, 133, 133, 140,
125, 140, 140, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 125, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 140, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  59,  86,  59,  86,  86,  86,  61,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  79,  83,  83,
 82,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 103,  83, 103,  83,
 83,  83,  83,  82,  91,  91,  91, 103,  91,  91,  96,  96,  96,  96,  97, 104,
 99, 101, 106,  99,  97, 101, 101, 104, 104,  99, 101, 104, 101,  99, 107, 101,
110, 110, 105, 104, 114, 110, 109, 117, 117, 112, 117, 117, 112, 117, 117, 119,
119, 122, 119, 117, 117, 109, 117, 117, 117, 117, 117, 125, 112, 117, 133, 146,
117, 117, 119, 119, 146, 117, 133, 140, 140, 146, 140, 146, 140, 133, 133, 140,
125, 140, 146, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 158, 181, 158, 181, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  74,  74,  74,  74,  74,  53,  74,  74,  74,  59,  74,  74,  74,  74,
 74,  74,  74,  82,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 83,  74,  74,  74,  74,  83,  74,  74,  83,  83,  83,  83,  83,  83, 103,  94,
 83,  94,  83,  97,  83,  83,  83,  91,  94,  94,  91,  91,  91,  94,  96, 102,
101, 110,  97, 101, 101, 110, 110, 105, 105, 101, 110, 105, 110, 110, 110, 110,
110, 105, 102, 105, 110, 110, 112, 117, 117, 117, 117, 119, 117, 119, 117, 119,
105, 122, 122, 117, 117, 112, 119, 117, 117, 117, 119, 125, 117, 117, 117, 122,
117, 119, 119, 119, 122, 117, 117, 117, 117, 122, 146, 146, 140, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 140, 158, 140, 165, 158, 140, 158, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  74,  53,  53,  53,  74,
 53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  83,  94,  83,  94,
 94,  94,  94, 103,  94,  94,  94,  91,  94,  94,  94,  94,  94,  94,  96, 102,
110,  94, 103, 110, 101, 110, 110, 102, 102, 110, 110, 102, 105, 110, 105, 110,
105, 105, 102, 105, 110, 110, 117, 119, 119, 117, 119, 119, 117, 105, 119, 105,
122, 122, 122, 117, 117, 117, 119, 117, 119, 117, 119, 125, 117, 117, 117, 122,
119, 119, 119, 146, 122, 117, 117, 117, 117, 122, 146, 146, 146, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 146, 140, 140, 146,
140, 146, 140, 158, 140, 158, 158, 158, 165, 158, 158, 158, 140, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
181, 158, 181, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 61,  53,  53,  53,  86,  61,  86,  61,  86,  61,  86,  82,  82,  61,  61,  86,
 61,  86,  82,  82,  86,  82,  86,  82,  86,  82,  86,  86,  82,  86,  82,  82,
 82,  82,  82,  83,  82,  82,  82,  83,  82,  82,  82,  90,  82,  90,  82,  83,
 90,  90,  90,  95,  90,  90,  97,  97,  91,  99,  97,  97,  97,  99,  97, 101,
 97,  99, 106,  97, 106,  97,  99, 101, 104, 106,  99, 101,  99, 106, 114, 114,
114, 114, 104, 114, 114, 112, 106, 112, 112, 109, 112, 112, 112, 112, 112, 117,
119, 104, 119, 112, 112, 113, 112, 112, 112, 133, 112, 125, 133, 133, 133, 119,
133, 133, 117, 117, 146, 133, 133, 133, 133, 146, 133, 140, 133, 133, 133, 133,
125, 133, 140, 133, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 140, 125, 140, 140, 140, 140, 140, 140, 140, 133, 140, 125, 140, 140, 140,
125, 140, 133, 140, 140, 140, 140, 140, 158, 140, 140, 163, 158, 158, 158, 158,
158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 82,  83,  83,  83,  83,  83,  83,  83,  82,  83,  83,  83, 103,  83, 103,  83,
103,  83,  83,  82, 103, 103, 103, 103,  91,  96, 103, 103,  96,  96,  97, 104,
 99, 101, 106,  99,  97,  99, 101, 107, 104,  99, 101, 104, 107,  99, 107, 114,
107, 110, 104, 104, 114, 114, 106, 117, 117, 112, 117, 117, 112, 117, 117, 119,
119, 122, 119, 117, 117, 109, 117, 117, 117, 117, 117, 125, 133, 117, 133, 146,
117, 117, 117, 119, 146, 117, 133, 133, 140, 146, 140, 146, 140, 133, 133, 140,
125, 140, 146, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  86,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  83,  74,  83,  83,  83,  94, 103,  94,
 94,  94,  94, 103,  94,  94,  94, 103,  94,  94,  94, 107,  94,  94, 103, 102,
110, 110, 103, 110, 101, 110, 110, 105, 102, 110, 110, 105, 110, 110, 105, 110,
110, 105, 102, 105, 110, 110, 117, 119, 119, 117, 117, 119, 117, 119, 119, 119,
105, 122, 122, 117, 117, 117, 119, 117, 119, 117, 119, 125, 117, 117, 117, 122,
119, 119, 119, 146, 122, 117, 117, 117, 117, 122, 146, 146, 140, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 158, 158, 158, 165, 158, 140, 158, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  74,  86,  93,
 82,  93,  93,  93,  93,  83,  83,  83, 103,  83,  83,  83, 103,  83, 103,  94,
 83,  83,  83,  82, 103,  91, 103, 103,  94,  96, 103, 103,  96, 107, 103, 105,
 99, 101, 106,  99,  99, 101, 107, 104, 105,  99, 107, 104, 107,  99, 107, 107,
110, 110, 105, 104, 114, 116, 112, 117, 117, 112, 117, 117, 117, 119, 117, 119,
119, 122, 119, 117, 117, 109, 117, 117, 117, 117, 117, 125, 117, 117, 133, 146,
117, 117, 119, 119, 146, 117, 133, 132, 140, 146, 140, 146, 140, 133, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
140, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  82,  86,  86,  86,  82,  82,  86,  86,  86,
 86,  86,  82,  82,  86,  86,  86,  82,  86,  82,  86,  86,  82,  86,  82,  82,
 82,  86,  82,  93,  82,  82,  82,  93,  82,  82,  82, 103,  82, 103,  82,  83,
103, 103, 103,  95, 103, 103, 103,  97,  96, 103, 103,  97, 103,  99, 106, 107,
 97,  99, 106, 106, 106,  97,  99, 107, 107, 106, 114, 107, 114, 106, 114, 114,
114, 114, 104, 114, 114, 114, 106, 114, 114, 106, 112, 112, 112, 117, 112, 117,
119, 119, 119, 112, 112, 125, 117, 112, 112, 133, 117, 125, 133, 133, 133, 119,
133, 133, 132, 117, 146, 133, 133, 133, 133, 146, 133, 140, 133, 133, 133, 133,
125, 133, 140, 133, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 146, 125, 140, 140, 140, 140, 140, 140, 140, 133, 140, 163, 140, 140, 140,
163, 140, 163, 140, 140, 140, 140, 140, 158, 140, 140, 163, 158, 181, 158, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  74,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  93,  83,  83,  83, 103,  83, 103,  94,
103,  83,  83, 106, 103, 103, 103, 103,  94,  96, 103, 103, 101, 107, 103, 105,
101, 107, 106, 103, 103, 107, 107, 110, 105,  99, 107, 105, 107,  99, 110, 107,
110, 110, 105, 119, 110, 110, 114, 117, 117, 116, 117, 117, 117, 119, 117, 119,
119, 122, 119, 117, 117, 112, 117, 117, 117, 117, 117, 125, 132, 117, 132, 146,
117, 117, 119, 119, 146, 132, 132, 132, 132, 146, 119, 146, 140, 133, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 133, 140, 140, 140, 140, 140,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
140, 140, 140, 158, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 181, 158, 158, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  86,  86,
 82,  93,  93,  93,  93,  93,  93,  93,  82,  93, 103, 103, 103, 103, 103,  83,
103, 103, 103,  82, 103, 103, 103, 103, 107, 103, 103, 103, 103, 107, 103, 104,
103, 103, 106, 103, 106,  99, 107, 107, 104, 106, 114, 107, 107, 114, 107, 114,
114, 107, 104, 119, 114, 114, 106, 116, 116, 114, 116, 117, 114, 117, 117, 119,
119, 119, 119, 117, 117, 109, 117, 117, 117, 132, 117, 125, 133, 132, 133, 146,
132, 132, 117, 119, 146, 132, 133, 133, 132, 146, 132, 146, 140, 133, 133, 133,
133, 133, 146, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103,  94,
103,  93, 103, 106, 103, 103, 103, 103,  94, 103, 103, 103, 103, 107, 103, 105,
103, 107, 106, 103, 103, 107, 107, 110, 105, 103, 107, 105, 107, 114, 110, 116,
110, 110, 105, 119, 116, 116, 127, 116, 116, 116, 117, 117, 117, 119, 117, 119,
119, 122, 119, 117, 117, 127, 117, 117, 117, 117, 117, 125, 132, 132, 132, 146,
132, 132, 119, 119, 146, 132, 132, 132, 132, 146, 146, 146, 140, 133, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 133, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  74,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103,  94,
103,  93,  93, 106, 103, 103, 103, 103,  94, 107, 103, 103, 107, 107, 103, 105,
107, 107, 106, 103, 103, 107, 107, 105, 105, 103, 107, 105, 110, 114, 110, 110,
110, 110, 105, 119, 110, 110, 127, 117, 117, 116, 117, 119, 117, 119, 117, 119,
119, 122, 119, 117, 117, 127, 119, 117, 117, 117, 119, 125, 132, 132, 132, 146,
117, 117, 119, 119, 146, 132, 132, 132, 132, 146, 146, 146, 140, 140, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 133, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 158, 140, 140,
140, 158, 140, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  74,  74,  53,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  94,  74,  94,
 94,  94,  94, 103,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 110, 102,
 94,  94, 103, 110, 110,  94,  94, 102, 102, 110,  94, 102, 105, 110, 105, 105,
105, 105, 122, 102, 105, 105, 110, 105, 119, 110, 119, 105, 119, 122, 119, 122,
122, 122, 122, 119, 119, 117, 122, 119, 119, 119, 122, 132, 117, 119, 117, 122,
119, 122, 122, 122, 122, 137, 137, 137, 146, 122, 146, 122, 146, 150, 140, 146,
140, 146, 146, 140, 146, 140, 125, 146, 146, 140, 140, 146, 146, 140, 171, 146,
158, 165, 140, 158, 158, 165, 165, 158, 165, 165, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 165, 158, 158, 158, 158, 158, 158, 158,
158, 158, 165, 158, 158, 181, 158, 158, 158, 181, 158, 158, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  74,  86,  74,  86,  74,  86,  86,  86,  86,  86,  86,  74,
 86,  74,  86,  86,  74,  74,  74,  86,  74,  74,  74,  74,  74,  74,  93,  93,
 93,  74,  93,  74,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  94,
 93,  94,  94, 103,  94,  94, 103, 103,  94,  94, 103, 107, 107,  94, 103,  94,
107, 110, 103, 107, 103, 110, 110, 105, 105, 107, 110, 105, 110, 110, 110, 110,
110, 110, 102, 105, 110, 110, 123, 119, 119, 123, 117, 119, 117, 119, 119, 119,
119, 122, 122, 117, 117, 123, 119, 117, 119, 117, 119, 125, 132, 117, 132, 146,
119, 119, 119, 146, 122, 132, 132, 132, 137, 146, 146, 146, 150, 140, 140, 150,
133, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 146, 140, 140, 146,
140, 146, 140, 140, 140, 140, 146, 140, 165, 158, 140, 140, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  53,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103, 103, 103,  93, 103,  93,
103, 108, 103,  82, 103, 103, 103, 103, 107, 103, 103, 103, 103, 107, 103, 107,
103, 103, 106, 103, 106, 103, 107, 107, 107, 103, 114, 107, 107, 114, 107, 114,
116, 116, 105, 119, 114, 116, 106, 116, 116, 127, 116, 116, 127, 119, 117, 119,
119, 146, 119, 123, 117, 127, 117, 132, 132, 132, 132, 125, 132, 132, 133, 146,
132, 132, 132, 119, 146, 132, 133, 132, 132, 146, 132, 146, 140, 133, 133, 133,
133, 133, 146, 133, 140, 133, 125, 140, 140, 140, 133, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
163, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 181, 158, 181, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103,  93,
103, 108, 108, 106, 103, 103, 103, 103, 108, 103, 103, 103, 103, 107, 103, 105,
103, 115, 106, 103, 103, 115, 115, 107, 105, 103, 115, 110, 107, 114, 107, 118,
118, 118, 105, 119, 118, 118, 127, 118, 123, 127, 123, 118, 123, 119, 123, 119,
119, 122, 119, 123, 132, 127, 117, 132, 132, 132, 132, 125, 132, 132, 132, 146,
132, 132, 119, 119, 146, 132, 132, 132, 132, 146, 150, 146, 150, 133, 133, 150,
133, 150, 146, 133, 150, 133, 125, 140, 140, 140, 133, 140, 150, 140, 140, 146,
140, 146, 133, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
163, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 181, 158, 181, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 82,  82,  86,  86,  86,  86,  86,  82,  86,  86,  86,  82,  82,  86,  82,  86,
 82,  86,  82,  82,  86,  82,  86,  82,  86,  82,  86,  86,  82,  86,  82,  82,
 82,  82,  82,  93,  82,  82,  82, 111,  82,  82,  82, 111,  82, 108,  82, 108,
103, 108, 103,  95, 103, 103, 103, 106, 108, 103, 106, 106, 106, 103, 106, 108,
106, 106,  95, 106, 106, 106, 106, 115, 115, 106, 106, 115, 106, 106, 114, 106,
127, 114, 119, 114, 106, 127, 128, 127, 127, 128, 127, 127, 129, 127, 127, 127,
118, 119, 119, 127, 127, 128, 127, 127, 127, 133, 127, 128, 128, 133, 128, 132,
133, 133, 132, 132, 146, 133, 133, 133, 133, 146, 133, 132, 133, 151, 151, 133,
151, 133, 150, 151, 133, 133, 143, 133, 133, 133, 163, 133, 133, 163, 133, 150,
163, 150, 163, 163, 163, 133, 140, 163, 150, 140, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 140, 163, 163, 163, 163, 163, 163, 163,
163, 163, 181, 163, 197, 163, 181, 197, 197, 197, 181, 197, 197, 197, 197, 197,
197, 181, 197, 181, 197, 181, 197, 181, 197, 197, 197, 181, 197, 197, 197, 197,
197, 197, 181, 197, 197, 197, 197, 211, 197, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 115, 103, 120,
115, 115, 106, 103, 103, 115, 115, 120, 120, 115, 115, 120, 115, 115, 120, 115,
120, 120, 119, 120, 118, 118, 127, 123, 123, 127, 123, 123, 123, 119, 123, 119,
119, 146, 119, 130, 132, 127, 132, 132, 132, 132, 132, 128, 132, 132, 132, 146,
132, 132, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 133, 133, 150,
133, 150, 146, 133, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 133, 150, 150, 150, 150, 150, 146, 150, 140, 150, 140, 150, 140, 150,
163, 150, 140, 140, 140, 140, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103, 108, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 115, 103, 120,
115, 115, 106, 103, 103, 115, 115, 120, 120, 115, 115, 120, 115, 115, 115, 115,
120, 120, 119, 120, 118, 118, 127, 123, 123, 127, 123, 123, 127, 119, 123, 119,
119, 146, 119, 130, 132, 127, 132, 132, 132, 132, 132, 128, 132, 132, 132, 146,
132, 132, 137, 137, 146, 132, 132, 132, 132, 146, 150, 146, 150, 133, 133, 150,
151, 150, 146, 133, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 133, 150, 150, 150, 150, 150, 146, 150, 140, 150, 140, 150, 140, 150,
163, 150, 140, 140, 140, 140, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  82, 108, 108, 108, 103, 108,  82, 108,
108, 108, 108, 121, 108, 108, 103, 103, 108, 103, 103, 103, 103, 108, 106, 108,
103, 115, 121, 106, 106, 115, 115, 115, 115, 106, 115, 115, 115, 106, 115, 127,
115, 118, 119, 118, 127, 127, 128, 127, 127, 127, 127, 127, 127, 123, 127, 123,
119, 146, 119, 127, 127, 128, 132, 132, 132, 132, 132, 128, 127, 132, 151, 146,
132, 132, 132, 132, 146, 132, 133, 132, 132, 146, 132, 146, 150, 133, 151, 133,
151, 133, 150, 151, 133, 133, 125, 150, 150, 133, 151, 150, 150, 133, 150, 150,
133, 146, 163, 150, 150, 150, 150, 150, 150, 150, 163, 150, 163, 150, 140, 140,
163, 140, 163, 140, 163, 140, 140, 140, 158, 181, 181, 163, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 103, 108, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 108, 103, 120,
115, 115, 121, 103, 103, 115, 115, 120, 120, 115, 115, 120, 115, 115, 115, 115,
120, 120, 119, 120, 118, 123, 127, 123, 123, 127, 123, 123, 127, 123, 123, 119,
119, 146, 119, 130, 130, 127, 132, 132, 132, 132, 132, 128, 132, 132, 132, 146,
132, 132, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 133, 133, 150,
151, 150, 146, 133, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 150, 150, 150, 150, 146, 150, 150, 150, 140, 150, 150, 150,
163, 150, 140, 150, 150, 150, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 103,  93,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 115, 115, 103, 105,
115, 115, 106, 115, 103, 115, 115, 120, 120, 115, 115, 120, 120, 115, 120, 120,
120, 120, 105, 120, 120, 120, 127, 123, 123, 123, 123, 123, 123, 119, 123, 119,
119, 122, 119, 123, 132, 127, 137, 132, 132, 132, 137, 128, 132, 132, 132, 146,
132, 137, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 150, 132, 150,
151, 150, 146, 150, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 146,
150, 146, 150, 150, 150, 150, 150, 150, 146, 150, 150, 150, 150, 150, 150, 150,
163, 150, 161, 150, 150, 150, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93, 108,  93, 108, 108, 103, 108, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 108, 103, 108,
115, 115, 121, 103, 106, 115, 115, 115, 120, 115, 115, 120, 115, 115, 115, 115,
115, 115, 119, 120, 127, 118, 129, 127, 127, 127, 127, 123, 127, 123, 127, 119,
119, 146, 119, 130, 130, 129, 132, 132, 132, 132, 132, 128, 130, 132, 130, 146,
132, 132, 132, 137, 146, 132, 132, 132, 132, 146, 150, 146, 150, 133, 151, 150,
151, 150, 146, 151, 150, 133, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 150, 150, 150, 150, 146, 150, 150, 150, 163, 150, 150, 150,
163, 150, 163, 150, 161, 150, 161, 161, 158, 181, 181, 163, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  94,
 93,  93,  93, 121, 108, 108, 108, 103,  94, 108, 108, 115, 115, 120, 103,  94,
115, 120, 103, 115, 115, 115, 120, 120, 105, 115, 120, 105, 120, 115, 120, 120,
120, 120, 105, 119, 120, 120, 127, 120, 120, 123, 123, 120, 123, 119, 123, 119,
119, 122, 146, 123, 137, 130, 137, 137, 137, 137, 137, 151, 132, 137, 132, 146,
137, 137, 137, 146, 146, 137, 132, 137, 137, 146, 146, 146, 150, 150, 150, 150,
132, 150, 146, 150, 150, 150, 125, 150, 150, 150, 150, 150, 150, 150, 150, 146,
150, 146, 150, 150, 150, 150, 150, 150, 146, 150, 150, 150, 150, 171, 150, 150,
161, 171, 161, 171, 150, 171, 158, 181, 165, 181, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 108, 108, 108, 108, 103, 131,
115, 115, 121, 115, 115, 115, 115, 120, 120, 115, 115, 120, 115, 115, 120, 115,
120, 120, 131, 120, 120, 120, 127, 123, 123, 127, 123, 123, 123, 120, 123, 119,
119, 146, 119, 130, 130, 127, 137, 132, 132, 132, 137, 128, 132, 132, 132, 146,
132, 144, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 150, 151, 150,
151, 150, 146, 151, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 146,
150, 146, 151, 150, 150, 150, 150, 150, 146, 150, 150, 150, 161, 150, 161, 150,
163, 161, 161, 161, 161, 161, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  94,
 93,  93,  93, 121,  93, 108, 108, 103,  94, 108, 108, 108, 120, 120, 103,  94,
120, 120, 103, 115, 115, 120, 120, 131, 131, 115, 120, 131, 120, 120, 120, 120,
120, 120, 131, 119, 120, 120, 123, 120, 120, 123, 120, 137, 123, 119, 137, 119,
119, 135, 122, 137, 137, 130, 137, 137, 137, 137, 137, 130, 132, 137, 132, 146,
137, 137, 137, 146, 146, 137, 132, 137, 137, 146, 146, 146, 137, 150, 150, 150,
150, 150, 146, 150, 150, 150, 151, 150, 150, 150, 150, 150, 146, 150, 150, 146,
150, 146, 150, 150, 150, 171, 171, 171, 165, 171, 150, 171, 161, 171, 171, 171,
161, 171, 171, 171, 171, 171, 171, 171, 165, 171, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220
};

UInt8 hvqelut_2x2_1b[] = {
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  74,  86,  74,  86,  74,  86,  86,  86,  86,  86,  86,  74,
 74,  74,  86,  86,  74,  74,  74,  93,  74,  93,  74,  74,  93,  74,  93,  93,
 93,  93,  93,  74,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  94,
 93,  94,  94, 103,  93,  94,  93, 108,  94,  94, 120, 120,  94,  94, 115,  94,
120, 120, 103, 120, 120, 120, 120, 131, 102, 120, 120, 131, 120, 120, 120, 120,
120, 120, 122, 131, 120, 120, 123, 120, 120, 120, 137, 137, 137, 147, 137, 147,
122, 135, 122, 137, 137, 130, 137, 137, 137, 137, 137, 130, 137, 137, 137, 135,
137, 137, 146, 146, 135, 137, 137, 137, 137, 135, 146, 146, 146, 150, 150, 137,
150, 150, 146, 150, 150, 150, 151, 150, 171, 150, 150, 171, 146, 150, 171, 146,
171, 146, 150, 171, 171, 171, 171, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 171, 171, 181, 165, 181, 181, 165,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  74,  74,  53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  94,  74,  94,
 94,  94,  94, 103,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 135,
 94,  94, 120,  94, 120,  94,  94, 135, 135,  94,  94, 135,  94, 120, 135, 131,
135, 135, 135, 135, 122, 135, 120, 135, 135, 147, 135, 135, 147, 135, 135, 135,
135, 141, 135, 147, 135, 137, 135, 135, 135, 157, 135, 137, 147, 157, 147, 135,
157, 157, 135, 135, 141, 157, 147, 157, 157, 135, 135, 135, 157, 171, 171, 157,
171, 157, 164, 171, 157, 171, 171, 171, 171, 171, 171, 171, 164, 171, 171, 164,
171, 164, 171, 171, 171, 164, 164, 171, 164, 164, 171, 171, 171, 165, 171, 171,
171, 171, 171, 171, 171, 171, 165, 171, 165, 165, 165, 171, 165, 165, 165, 165,
165, 171, 165, 165, 165, 181, 165, 165, 165, 165, 165, 165, 181, 181, 181, 181,
181, 165, 181, 165, 181, 165, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  53,  53,  53,  74,  74,  74,  74,  74,
 86,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  86,  74,  74,  74,  74,
 74,  74,  74,  86,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 93,  74,  74,  74,  74,  93,  74,  74,  93,  93,  93,  93,  93,  94,  93,  94,
 94,  94,  94, 103,  94,  94,  94,  93,  94,  94,  94,  94,  94,  94, 120, 102,
 94,  94, 115, 120, 120, 120, 131, 131, 102, 120, 120, 131, 131, 120, 131, 120,
131, 131, 135, 131, 120, 131, 120, 137, 137, 137, 137, 147, 137, 147, 147, 135,
135, 135, 135, 137, 147, 137, 147, 147, 147, 147, 147, 130, 137, 147, 137, 135,
147, 147, 157, 157, 135, 147, 137, 147, 147, 135, 157, 157, 146, 137, 149, 154,
149, 154, 157, 150, 171, 171, 150, 171, 171, 171, 171, 171, 171, 171, 171, 165,
171, 164, 171, 171, 171, 171, 165, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 165, 171, 181, 165, 171, 171, 165,
171, 181, 165, 181, 181, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  53,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 108, 108, 108, 108, 103, 108,
115, 115, 121, 115, 121, 115, 115, 120, 120, 115, 115, 120, 115, 115, 115, 115,
115, 120, 131, 120, 115, 123, 129, 130, 127, 127, 130, 130, 127, 123, 130, 137,
119, 146, 119, 130, 130, 129, 134, 134, 134, 134, 134, 128, 130, 134, 130, 146,
134, 134, 144, 137, 146, 132, 132, 132, 132, 146, 144, 146, 150, 151, 151, 150,
151, 150, 146, 151, 150, 150, 159, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 161, 150, 150, 161, 146, 150, 161, 161, 163, 161, 161, 161,
163, 161, 163, 161, 161, 161, 161, 161, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  53,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 103, 131,
115, 115, 121, 115, 115, 115, 115, 120, 131, 115, 115, 120, 115, 115, 115, 115,
120, 120, 131, 120, 115, 123, 129, 123, 130, 127, 130, 123, 130, 123, 130, 137,
119, 146, 147, 130, 130, 129, 134, 134, 134, 134, 134, 138, 130, 134, 130, 146,
134, 144, 137, 137, 146, 134, 142, 132, 144, 146, 144, 146, 150, 151, 151, 150,
151, 150, 146, 151, 150, 150, 159, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 161, 150, 150, 161, 146, 150, 161, 161, 161, 161, 161, 161,
163, 161, 161, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 82,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  82, 111,  86, 111,  86,
111,  86, 111,  82, 111, 111, 111, 111, 111, 111, 111, 111, 111,  93, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 108,
111, 111, 111, 121, 111, 111, 111, 121, 108, 111, 121, 121, 121, 108, 121, 108,
121, 121, 128, 121, 121, 121, 129, 115, 115, 121, 129, 115, 129, 128, 129, 129,
129, 129, 115, 129, 129, 129, 128, 129, 129, 129, 129, 129, 129, 129, 129, 127,
136, 119, 134, 129, 129, 128, 129, 129, 129, 129, 129, 143, 151, 151, 151, 144,
151, 151, 142, 142, 146, 151, 151, 151, 151, 146, 142, 156, 151, 151, 151, 151,
151, 151, 150, 151, 151, 151, 143, 151, 151, 151, 163, 151, 151, 163, 151, 150,
163, 150, 163, 163, 163, 163, 161, 163, 161, 163, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 197, 163, 163, 163, 197, 163, 197, 197,
197, 163, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 211, 197, 197, 197, 197, 211, 197, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 108, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 103, 131,
115, 115, 121, 115, 115, 115, 120, 131, 131, 115, 120, 131, 120, 115, 120, 120,
120, 120, 131, 131, 120, 120, 127, 120, 120, 130, 136, 137, 130, 137, 137, 137,
147, 135, 147, 134, 137, 130, 137, 137, 137, 144, 137, 138, 142, 144, 142, 146,
137, 137, 137, 147, 146, 144, 149, 149, 144, 146, 137, 146, 149, 149, 156, 149,
151, 150, 146, 156, 150, 150, 159, 150, 150, 150, 151, 150, 150, 161, 150, 146,
161, 146, 161, 161, 161, 161, 171, 161, 146, 171, 161, 161, 161, 171, 161, 161,
161, 161, 161, 161, 161, 171, 171, 171, 165, 171, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 111, 108, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 121, 131,
115, 115, 121, 115, 121, 115, 115, 120, 131, 115, 115, 131, 115, 115, 120, 115,
120, 120, 131, 120, 115, 120, 129, 136, 136, 130, 136, 136, 130, 136, 136, 137,
137, 146, 147, 136, 136, 129, 144, 134, 134, 142, 144, 138, 142, 142, 142, 146,
144, 144, 144, 137, 146, 142, 142, 148, 144, 146, 144, 146, 149, 156, 151, 156,
151, 156, 146, 151, 150, 156, 159, 150, 161, 161, 151, 161, 161, 161, 161, 150,
161, 146, 151, 161, 161, 161, 161, 161, 146, 161, 161, 161, 161, 161, 161, 161,
163, 161, 161, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 131,
115, 115, 121, 115, 115, 115, 115, 131, 131, 115, 115, 131, 120, 115, 120, 115,
120, 120, 131, 131, 120, 120, 129, 136, 136, 130, 136, 136, 136, 137, 136, 137,
147, 135, 147, 136, 136, 129, 137, 134, 144, 142, 144, 138, 142, 144, 142, 146,
144, 144, 137, 137, 146, 144, 148, 149, 149, 146, 137, 146, 149, 156, 156, 149,
151, 156, 146, 151, 150, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 146,
161, 146, 151, 161, 161, 161, 161, 161, 146, 161, 161, 161, 161, 161, 161, 161,
170, 161, 161, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93, 111,  93,  93, 111, 108, 108, 108, 111, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 121, 131,
115, 115, 121, 115, 121, 115, 115, 120, 131, 115, 115, 131, 115, 129, 115, 115,
120, 120, 131, 120, 115, 136, 129, 136, 136, 130, 136, 136, 136, 136, 136, 137,
137, 146, 147, 136, 136, 129, 144, 142, 142, 142, 144, 138, 142, 142, 142, 146,
144, 144, 144, 137, 146, 142, 142, 148, 148, 146, 144, 146, 149, 156, 151, 156,
151, 156, 146, 151, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 161,
161, 146, 151, 161, 161, 161, 161, 161, 146, 161, 161, 161, 170, 161, 161, 161,
163, 161, 178, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 108, 131,
115, 115, 121, 115, 115, 115, 115, 131, 131, 115, 120, 131, 120, 115, 120, 120,
120, 120, 131, 131, 120, 120, 129, 136, 136, 136, 136, 137, 136, 137, 136, 137,
147, 135, 147, 136, 136, 130, 137, 144, 144, 144, 137, 138, 142, 144, 142, 146,
144, 137, 137, 147, 146, 149, 148, 149, 149, 146, 154, 146, 149, 156, 156, 149,
151, 149, 146, 156, 150, 161, 159, 161, 161, 161, 151, 161, 161, 161, 161, 146,
161, 146, 161, 161, 161, 161, 161, 161, 146, 161, 161, 161, 161, 161, 161, 161,
170, 161, 161, 161, 161, 161, 171, 171, 171, 171, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86, 111,
 82,  82, 111, 111,  86, 111, 111,  82, 111, 111, 111,  82, 111, 111, 111, 111,
111, 111, 111,  82, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111, 121, 111,
111, 111, 111,  95, 121, 121, 121, 121, 111, 121, 121, 121, 121, 121, 121, 111,
121, 121, 128, 121, 128, 121, 121, 129, 129, 128, 121, 129, 121, 128, 129, 128,
129, 129, 129, 129, 128, 128, 128, 128, 128, 128, 128, 129, 128, 129, 128, 129,
129, 136, 129, 128, 128, 143, 129, 128, 128, 128, 151, 143, 128, 151, 128, 142,
151, 151, 151, 151, 144, 151, 151, 151, 151, 156, 151, 151, 151, 163, 163, 151,
143, 151, 151, 163, 163, 163, 166, 163, 163, 163, 163, 163, 163, 163, 163, 163,
163, 161, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 197,
163, 163, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86,  86,
 86,  86,  86, 111,  86, 111,  86, 111,  86, 111, 111,  93, 111,  93, 111, 111,
111, 111, 111,  93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 108,
111, 108, 108, 121, 111, 108, 111, 121, 108, 108, 108, 108, 108, 108, 121, 108,
121, 108, 121, 121, 121, 129, 115, 115, 115, 121, 129, 115, 115, 129, 115, 129,
129, 115, 131, 115, 129, 129, 138, 129, 129, 129, 129, 136, 129, 136, 136, 136,
136, 131, 137, 129, 136, 138, 142, 142, 142, 142, 142, 128, 151, 142, 151, 146,
142, 142, 144, 144, 146, 142, 151, 142, 142, 146, 156, 144, 156, 151, 151, 156,
151, 151, 150, 151, 151, 151, 159, 151, 161, 151, 151, 161, 161, 151, 161, 161,
151, 146, 163, 161, 161, 161, 161, 161, 161, 161, 163, 161, 163, 161, 163, 161,
163, 178, 163, 178, 163, 178, 178, 178, 183, 178, 178, 163, 178, 197, 197, 197,
197, 197, 181, 197, 197, 197, 181, 197, 197, 197, 181, 197, 197, 197, 197, 197,
197, 181, 197, 181, 197, 181, 197, 181, 197, 197, 197, 211, 197, 197, 197, 211,
211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93, 111,
111,  93,  93,  93,  93, 111,  93,  93, 111, 108, 111, 108, 111, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 115, 121, 115, 115, 131, 131, 129, 115, 131, 115, 129, 115, 115,
120, 120, 131, 131, 136, 136, 129, 136, 136, 136, 136, 136, 136, 136, 136, 137,
147, 131, 147, 136, 136, 138, 144, 142, 142, 142, 144, 138, 142, 142, 142, 154,
145, 144, 144, 144, 146, 148, 148, 148, 148, 146, 149, 154, 149, 156, 151, 156,
151, 156, 154, 151, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 146, 161, 161, 161, 170, 161, 161, 161,
163, 161, 178, 161, 178, 161, 178, 178, 171, 178, 178, 178, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86,  86,
 86,  86, 111, 111, 111, 111, 111, 111,  86, 111, 111, 111, 111,  93, 111, 111,
111, 111, 111,  93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 108,
111, 111, 111, 121, 111, 111, 111, 121, 108, 108, 111, 121, 108, 108, 121, 108,
121, 108, 121, 121, 121, 129, 129, 115, 108, 121, 129, 115, 129, 129, 129, 129,
129, 129, 131, 115, 129, 129, 138, 129, 129, 129, 129, 129, 129, 136, 129, 136,
136, 131, 137, 129, 129, 138, 136, 142, 142, 142, 142, 128, 151, 142, 151, 144,
142, 142, 142, 144, 146, 151, 151, 151, 152, 146, 156, 144, 156, 151, 151, 151,
159, 151, 156, 151, 151, 151, 172, 151, 151, 151, 159, 151, 161, 151, 151, 161,
151, 146, 163, 161, 170, 161, 161, 161, 161, 161, 163, 161, 163, 161, 163, 178,
163, 178, 163, 178, 163, 178, 178, 178, 183, 178, 197, 163, 197, 197, 197, 197,
197, 197, 181, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 181, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 211,
197, 211, 211, 197, 197, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  53,  53,  53,  74,  86,  86,  86,  86,
 86,  86,  74,  86,  74,  86,  74,  86,  74,  86,  74,  86,  86,  86,  74,  74,
 74,  74,  93,  93,  74,  93,  74,  93, 124,  93,  93, 124,  93, 124,  93,  93,
 93, 124,  93, 124, 124,  93,  93, 124,  93, 124, 124, 124,  93, 124,  93, 124,
124, 124, 124, 103, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 124,
124, 124, 139, 139, 139, 124, 124, 124, 124, 139, 131, 131, 131, 139, 131, 131,
131, 131, 135, 131, 131, 131, 145, 147, 147, 137, 147, 147, 147, 147, 147, 135,
135, 141, 135, 147, 147, 145, 147, 147, 147, 147, 147, 145, 137, 147, 137, 135,
147, 147, 157, 157, 135, 147, 147, 147, 147, 135, 157, 157, 157, 149, 149, 154,
149, 154, 157, 171, 171, 171, 161, 171, 171, 171, 171, 171, 171, 171, 171, 164,
171, 164, 171, 171, 171, 171, 171, 171, 164, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 165, 171, 171, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 211, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 111, 108, 108, 108, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 115, 121, 115, 115, 131, 131, 115, 115, 131, 120, 129, 120, 115,
120, 120, 131, 131, 136, 136, 129, 136, 136, 136, 136, 136, 136, 137, 136, 137,
147, 135, 147, 136, 136, 138, 144, 145, 145, 145, 144, 138, 142, 145, 142, 154,
145, 144, 147, 147, 146, 149, 148, 149, 149, 146, 154, 154, 149, 156, 156, 156,
151, 156, 154, 156, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 146, 161, 161, 161, 170, 161, 161, 161,
170, 161, 178, 161, 178, 161, 178, 178, 171, 171, 178, 178, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 181, 181, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 111,  93, 108, 108, 108, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 108, 131,
108, 108, 121, 115, 115, 115, 115, 131, 131, 115, 115, 131, 120, 115, 120, 120,
120, 131, 131, 131, 136, 136, 129, 136, 136, 136, 136, 136, 136, 137, 136, 147,
147, 135, 147, 136, 136, 129, 137, 145, 145, 145, 144, 138, 145, 145, 148, 154,
145, 144, 147, 147, 146, 149, 148, 149, 149, 146, 154, 154, 149, 156, 156, 149,
151, 149, 154, 156, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 146,
161, 146, 170, 161, 161, 161, 161, 161, 146, 161, 161, 161, 178, 161, 161, 161,
170, 161, 178, 161, 161, 161, 171, 171, 171, 171, 171, 181, 171, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 181, 181, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124,  93,  93,
 93,  93,  93, 124,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 108, 124,
108, 124, 108, 121, 108, 108, 108, 108, 124, 124, 108, 108, 124, 124, 108, 124,
108, 124, 121, 115, 115, 120, 131, 131, 131, 115, 120, 131, 131, 120, 131, 120,
131, 131, 131, 131, 120, 120, 136, 137, 137, 136, 137, 137, 136, 147, 137, 147,
147, 135, 147, 137, 137, 136, 147, 137, 137, 145, 147, 138, 145, 145, 145, 157,
137, 147, 147, 147, 157, 149, 149, 149, 149, 157, 154, 154, 154, 149, 149, 149,
156, 149, 154, 156, 149, 161, 159, 161, 161, 161, 161, 161, 171, 161, 161, 146,
161, 146, 161, 171, 161, 171, 171, 171, 171, 171, 161, 171, 161, 171, 171, 171,
178, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 181, 171, 181, 171, 171,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124,  93,  93,
 93,  93,  93, 124,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 124,
108, 124, 124, 121, 124, 124, 124, 108, 124, 124, 108, 108, 124, 124, 108, 124,
139, 124, 121, 139, 139, 139, 131, 131, 131, 139, 131, 131, 131, 120, 131, 120,
131, 131, 131, 131, 120, 131, 136, 137, 137, 136, 137, 147, 137, 147, 137, 147,
131, 135, 135, 137, 137, 145, 147, 137, 147, 137, 147, 138, 145, 137, 145, 157,
147, 147, 147, 154, 135, 149, 149, 149, 147, 157, 154, 157, 154, 149, 149, 149,
156, 149, 154, 149, 149, 161, 159, 161, 161, 161, 161, 171, 171, 161, 171, 171,
171, 146, 161, 171, 171, 171, 171, 171, 171, 171, 171, 171, 161, 171, 171, 171,
178, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 181, 171, 171, 171, 171,
171, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  93,  74,  74,  74,  74, 124,  74,  74, 124,  74, 124,  74,  74,
 93, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124,
124, 124, 124, 139, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 135,
124, 124, 139, 124, 139, 124, 124, 135, 135, 139, 124, 135, 124, 139, 131, 131,
131, 135, 135, 135, 131, 131, 139, 147, 147, 147, 147, 135, 147, 135, 135, 135,
135, 141, 135, 147, 147, 137, 157, 157, 157, 157, 157, 145, 147, 157, 147, 135,
157, 157, 157, 157, 141, 157, 147, 157, 157, 135, 157, 164, 157, 171, 171, 157,
171, 157, 164, 171, 157, 171, 171, 171, 171, 171, 171, 171, 164, 171, 171, 164,
171, 164, 171, 171, 171, 171, 164, 171, 164, 164, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 164, 171, 171, 171, 165, 171, 171, 165,
171, 171, 165, 171, 171, 171, 165, 171, 171, 171, 165, 165, 181, 181, 181, 181,
181, 165, 181, 165, 181, 165, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181,
181, 181, 211, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93, 111, 111,
111,  93,  93,  93,  93, 111, 111,  93, 111, 111, 111, 108, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 111, 124, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 121, 121, 115, 115, 131, 131, 129, 115, 131, 115, 129, 120, 136,
136, 120, 131, 131, 136, 136, 138, 136, 136, 136, 136, 136, 136, 136, 136, 137,
131, 131, 147, 136, 136, 138, 145, 145, 145, 145, 145, 138, 142, 148, 148, 154,
145, 145, 153, 153, 146, 148, 148, 152, 152, 146, 149, 154, 156, 156, 151, 156,
159, 156, 154, 151, 156, 156, 159, 161, 161, 161, 159, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 179, 161, 178, 161, 170, 161, 178, 161,
170, 178, 178, 178, 178, 178, 178, 178, 171, 183, 178, 178, 183, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 197, 181,
181, 181, 181, 181, 197, 181, 181, 211, 181, 181, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86,  86,  86,
111,  86, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111, 111,  93, 111, 111,
111, 111, 111,  93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 108,
111, 108, 111, 121, 111, 111, 111, 121, 108, 108, 111, 111, 108, 108, 121, 131,
121, 108, 121, 121, 121, 129, 115, 108, 131, 121, 129, 131, 129, 129, 129, 129,
129, 136, 131, 136, 129, 129, 138, 136, 136, 129, 136, 136, 129, 136, 136, 136,
136, 131, 147, 136, 136, 138, 136, 136, 136, 142, 148, 138, 151, 148, 151, 154,
148, 148, 152, 153, 146, 152, 151, 152, 152, 154, 152, 154, 156, 151, 151, 156,
159, 156, 156, 151, 156, 151, 172, 156, 156, 170, 159, 161, 161, 170, 161, 161,
170, 146, 170, 161, 178, 161, 161, 178, 161, 161, 170, 178, 170, 178, 178, 178,
163, 178, 170, 178, 178, 178, 178, 178, 183, 178, 178, 197, 183, 197, 197, 183,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 181, 197, 197, 197, 197, 197,
197, 211, 197, 211, 197, 211, 197, 211, 211, 197, 197, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93, 111,  93,  93,  93,  93, 111,  93, 111, 111,
111,  93, 111,  93, 111, 111, 111,  93, 111, 111, 111, 111, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 111, 124, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 121, 121, 115, 115, 131, 131, 121, 115, 131, 115, 129, 115, 136,
136, 136, 131, 131, 136, 136, 138, 136, 136, 136, 136, 136, 136, 136, 136, 153,
131, 131, 131, 136, 136, 138, 145, 145, 145, 148, 145, 138, 148, 148, 148, 154,
148, 148, 153, 153, 146, 152, 152, 152, 152, 154, 153, 154, 156, 156, 151, 156,
159, 156, 154, 151, 156, 156, 159, 161, 161, 161, 159, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 179, 161, 178, 178, 170, 178, 178, 178,
170, 178, 178, 178, 178, 178, 178, 178, 183, 183, 178, 178, 183, 178, 183, 183,
178, 197, 200, 181, 181, 197, 181, 181, 181, 181, 181, 181, 181, 181, 197, 197,
181, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93, 111, 111,
111,  93,  93,  93,  93, 111, 111,  93, 111, 111, 111, 108, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 111, 124, 108, 108, 108, 108, 108, 121, 124,
108, 108, 121, 121, 121, 115, 115, 131, 131, 129, 115, 131, 115, 129, 120, 136,
136, 131, 131, 131, 136, 136, 138, 136, 136, 136, 136, 136, 136, 136, 136, 147,
131, 131, 131, 136, 136, 138, 153, 145, 145, 145, 145, 138, 148, 145, 148, 154,
145, 145, 153, 147, 157, 148, 152, 152, 152, 154, 153, 154, 149, 156, 156, 156,
159, 156, 154, 156, 156, 156, 159, 161, 161, 161, 170, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 179, 161, 178, 161, 170, 161, 178, 178,
170, 178, 178, 178, 178, 178, 178, 178, 171, 183, 178, 178, 183, 178, 183, 181,
181, 181, 171, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 197, 181,
181, 211, 181, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  86,  86,  86,  74,  86,  86,  86,  86,
 86,  86,  74,  86,  74,  86,  74,  86,  74,  74,  74,  86,  86,  74,  74,  74,
 74, 124,  93,  93, 124,  93, 124,  93, 124, 124, 124, 124, 124, 124, 124, 124,
 93, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 124,
124, 124, 124, 139, 124, 124, 124, 139, 124, 124, 124, 124, 124, 124, 139, 124,
124, 124, 139, 139, 139, 124, 124, 124, 124, 139, 124, 124, 131, 139, 131, 131,
131, 131, 135, 131, 131, 131, 139, 147, 147, 147, 147, 147, 147, 135, 147, 135,
135, 141, 135, 147, 147, 145, 157, 147, 147, 147, 157, 145, 147, 147, 147, 135,
157, 157, 157, 157, 141, 147, 147, 154, 157, 135, 157, 157, 157, 171, 171, 157,
149, 157, 157, 171, 171, 171, 162, 171, 171, 171, 171, 171, 157, 171, 171, 164,
171, 164, 171, 171, 171, 171, 164, 171, 164, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 165, 171, 171, 181, 165, 171, 171, 171, 165, 181, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124,  93,  93,
 93,  93,  93, 124,  93,  93,  93,  93,  93,  93,  93,  93, 108, 124, 111, 124,
124, 124, 124, 121, 124, 124, 124, 139, 124, 124, 139, 139, 139, 124, 139, 124,
139, 139, 121, 139, 139, 139, 139, 131, 131, 139, 139, 131, 131, 139, 131, 139,
131, 131, 131, 131, 139, 131, 136, 153, 136, 136, 153, 147, 136, 147, 153, 147,
131, 135, 157, 153, 153, 145, 147, 153, 153, 153, 147, 138, 145, 153, 145, 157,
153, 147, 147, 154, 157, 153, 149, 153, 153, 157, 154, 154, 154, 149, 156, 149,
156, 149, 154, 156, 149, 160, 159, 161, 161, 161, 170, 161, 171, 161, 161, 179,
161, 157, 177, 171, 171, 171, 171, 171, 171, 171, 177, 171, 177, 171, 171, 171,
178, 171, 177, 171, 171, 171, 171, 171, 171, 171, 171, 178, 171, 171, 171, 171,
171, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,
 93, 124,  93,  93,  93,  93, 124,  93, 124,  93,  93, 124,  93, 124,  93,  93,
 93, 124, 124, 124, 124,  93, 124, 124,  93, 124, 124, 124, 139, 124, 139, 124,
124, 124, 124, 121, 124, 124, 124, 139, 124, 124, 139, 139, 124, 124, 139, 124,
139, 124, 139, 139, 139, 139, 124, 124, 124, 139, 139, 131, 131, 139, 131, 139,
131, 131, 131, 131, 139, 131, 139, 131, 147, 139, 147, 147, 147, 131, 147, 147,
157, 135, 135, 147, 147, 145, 147, 147, 147, 147, 147, 138, 153, 147, 153, 157,
147, 147, 154, 157, 135, 147, 153, 147, 154, 157, 157, 157, 154, 149, 149, 154,
149, 154, 157, 149, 154, 171, 170, 171, 171, 171, 161, 171, 171, 171, 171, 157,
171, 164, 171, 171, 171, 171, 171, 171, 164, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171,
171, 171, 165, 171, 171, 181, 171, 181, 181, 181, 200, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 211, 181, 181, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124, 111, 111,
111,  93,  93, 124,  93, 111, 111,  93, 111, 111, 111, 108, 111, 108, 111, 124,
108, 124, 108, 121, 108, 108, 108, 111, 124, 139, 139, 139, 139, 124, 139, 124,
139, 139, 138, 139, 139, 139, 139, 131, 131, 139, 139, 131, 139, 139, 139, 139,
139, 131, 131, 131, 139, 139, 138, 155, 155, 136, 155, 155, 155, 153, 155, 131,
131, 135, 131, 155, 155, 138, 153, 153, 153, 153, 153, 138, 148, 153, 148, 154,
153, 153, 153, 154, 157, 153, 152, 153, 153, 157, 154, 154, 153, 162, 162, 160,
159, 160, 154, 162, 160, 162, 159, 160, 168, 173, 170, 173, 179, 173, 173, 179,
177, 179, 170, 177, 177, 177, 179, 177, 179, 179, 178, 177, 178, 177, 177, 177,
170, 177, 178, 177, 178, 177, 183, 183, 171, 183, 183, 178, 200, 183, 183, 200,
183, 183, 200, 200, 181, 181, 200, 181, 181, 181, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
111,  86,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 121, 108, 111, 111, 111, 111, 111, 121, 131,
121, 111, 121, 121, 121, 121, 129, 131, 131, 121, 129, 131, 129, 138, 129, 129,
129, 136, 131, 136, 129, 129, 138, 129, 129, 129, 129, 136, 129, 155, 136, 155,
153, 131, 131, 136, 155, 138, 155, 155, 155, 152, 155, 138, 159, 152, 159, 154,
152, 152, 152, 153, 154, 152, 159, 152, 152, 154, 160, 153, 160, 159, 159, 162,
159, 162, 160, 159, 162, 170, 172, 170, 170, 170, 159, 170, 173, 170, 170, 168,
170, 179, 170, 178, 170, 178, 178, 178, 179, 178, 170, 178, 170, 178, 178, 178,
163, 178, 170, 178, 178, 178, 178, 178, 183, 178, 178, 197, 183, 197, 197, 197,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 211, 197, 211, 197, 211, 211, 197, 197, 211, 211, 211, 197, 211,
211, 211, 211, 220, 220, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 121, 108,
121, 121, 121, 121, 121, 121, 129, 108, 131, 121, 129, 131, 129, 138, 129, 129,
129, 129, 131, 136, 129, 129, 138, 129, 129, 129, 129, 129, 129, 136, 129, 155,
155, 131, 153, 129, 129, 138, 155, 152, 152, 152, 152, 138, 159, 152, 159, 153,
152, 152, 152, 152, 154, 152, 159, 152, 152, 154, 160, 160, 160, 159, 159, 162,
159, 170, 160, 159, 170, 159, 172, 170, 170, 170, 159, 170, 178, 170, 170, 168,
170, 179, 172, 170, 170, 178, 178, 170, 183, 178, 170, 170, 163, 178, 170, 178,
163, 178, 163, 178, 170, 178, 178, 178, 183, 178, 197, 197, 197, 197, 197, 197,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 211,
211, 211, 211, 197, 220, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86,  86,
 86,  86, 111, 111, 111, 111,  93, 111,  93, 111, 111,  93, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 108, 108, 121, 111, 108, 111, 111, 124, 108, 108, 108, 108, 139, 121, 124,
139, 139, 138, 121, 121, 139, 139, 131, 131, 121, 139, 131, 139, 129, 139, 136,
139, 139, 131, 131, 136, 136, 138, 155, 155, 136, 155, 155, 136, 155, 155, 153,
131, 131, 131, 155, 155, 138, 153, 155, 155, 155, 153, 138, 148, 152, 152, 154,
153, 153, 153, 153, 157, 152, 152, 152, 160, 154, 153, 154, 160, 162, 162, 160,
159, 160, 154, 170, 160, 162, 159, 162, 162, 162, 170, 173, 161, 170, 173, 179,
173, 179, 170, 177, 178, 177, 177, 178, 179, 177, 178, 178, 170, 183, 178, 178,
170, 178, 178, 178, 178, 178, 183, 178, 183, 183, 183, 178, 183, 183, 183, 183,
183, 197, 200, 183, 197, 197, 211, 197, 211, 197, 211, 211, 211, 211, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 121, 121, 111, 111, 121, 111,
121, 121, 121, 121, 121, 121, 121, 129, 111, 121, 121, 129, 129, 138, 129, 129,
129, 129, 131, 129, 129, 129, 138, 129, 129, 138, 129, 129, 129, 129, 129, 155,
155, 131, 155, 129, 129, 138, 129, 129, 129, 159, 167, 143, 159, 159, 159, 153,
151, 167, 152, 152, 154, 159, 159, 159, 151, 153, 160, 160, 151, 159, 159, 159,
172, 159, 160, 159, 159, 159, 172, 170, 170, 170, 172, 170, 170, 159, 170, 178,
170, 183, 172, 170, 170, 170, 178, 170, 183, 178, 163, 170, 163, 170, 163, 170,
163, 170, 163, 163, 163, 197, 197, 197, 183, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 211, 197, 197, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 108, 111, 121, 111, 111, 111, 111, 124, 108, 111, 111, 139, 139, 121, 124,
139, 139, 138, 121, 121, 139, 139, 131, 131, 121, 139, 131, 139, 138, 139, 139,
139, 139, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 153,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 153, 138, 152, 155, 152, 154,
152, 153, 153, 153, 154, 152, 152, 160, 160, 154, 153, 154, 160, 162, 170, 160,
159, 162, 154, 170, 162, 162, 159, 162, 168, 162, 170, 173, 173, 170, 173, 179,
173, 179, 170, 178, 178, 177, 177, 178, 179, 183, 178, 178, 170, 183, 178, 178,
170, 178, 178, 178, 178, 178, 183, 178, 183, 183, 183, 178, 183, 183, 183, 183,
183, 197, 200, 183, 197, 197, 211, 197, 197, 197, 211, 211, 211, 197, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 220, 220, 211, 211, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,
 93, 124,  93, 111,  93,  93, 124,  93, 124,  93, 124, 124,  93, 124,  93,  93,
 93, 124, 124, 124, 124,  93, 124, 124, 139, 124, 124, 124, 139, 124, 139, 124,
124, 124, 124, 121, 124, 124, 139, 139, 124, 124, 139, 139, 139, 124, 139, 124,
139, 139, 139, 139, 139, 139, 139, 124, 124, 139, 139, 131, 139, 139, 139, 139,
139, 131, 131, 131, 139, 139, 139, 139, 139, 139, 139, 131, 139, 131, 147, 131,
131, 135, 157, 153, 153, 155, 147, 153, 147, 153, 147, 138, 153, 153, 153, 157,
147, 147, 154, 157, 157, 153, 153, 153, 153, 157, 154, 157, 154, 162, 162, 153,
162, 153, 157, 162, 154, 168, 170, 171, 171, 171, 173, 171, 179, 177, 171, 184,
171, 164, 177, 171, 171, 171, 171, 171, 184, 171, 171, 171, 177, 171, 171, 171,
177, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 121, 108,
121, 111, 138, 121, 121, 121, 121, 139, 131, 121, 129, 131, 129, 138, 129, 129,
129, 129, 131, 155, 129, 129, 138, 129, 129, 138, 129, 155, 129, 155, 155, 155,
155, 131, 153, 129, 155, 138, 155, 155, 155, 167, 155, 138, 159, 167, 159, 153,
152, 155, 155, 155, 154, 167, 159, 167, 162, 154, 160, 160, 162, 159, 159, 170,
159, 170, 160, 159, 170, 170, 172, 170, 170, 170, 172, 170, 173, 170, 170, 168,
170, 179, 172, 170, 170, 178, 178, 170, 183, 178, 170, 170, 170, 178, 170, 178,
172, 178, 170, 178, 170, 178, 178, 178, 183, 178, 197, 197, 197, 197, 197, 197,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 111, 111, 121, 111, 111, 111, 111, 124, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 121, 139, 139, 131, 131, 138, 139, 131, 139, 138, 139, 139,
139, 139, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 153, 153, 153, 154, 160, 162, 160, 160, 154, 153, 154, 160, 162, 170, 162,
159, 162, 154, 170, 162, 162, 159, 168, 168, 173, 170, 173, 173, 170, 173, 179,
173, 179, 170, 177, 178, 177, 179, 178, 179, 183, 178, 178, 170, 183, 178, 178,
170, 178, 178, 178, 178, 183, 183, 183, 183, 183, 183, 191, 183, 183, 183, 183,
183, 197, 200, 183, 183, 197, 211, 197, 211, 211, 211, 211, 211, 211, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 124,
111, 111, 138, 121, 121, 121, 139, 139, 131, 138, 129, 131, 139, 138, 139, 129,
155, 155, 131, 155, 129, 155, 138, 155, 155, 138, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 159, 155, 159, 154,
155, 155, 155, 153, 154, 162, 162, 162, 162, 154, 160, 153, 162, 170, 159, 162,
159, 162, 168, 159, 162, 170, 172, 175, 175, 170, 159, 175, 173, 170, 170, 168,
170, 179, 170, 178, 170, 178, 183, 178, 179, 183, 170, 178, 170, 178, 178, 178,
170, 178, 170, 178, 178, 178, 178, 178, 183, 183, 183, 197, 183, 197, 183, 183,
197, 197, 200, 197, 197, 197, 197, 197, 197, 197, 211, 197, 197, 197, 197, 197,
197, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111, 121, 111,
111, 111, 111, 121, 111, 111, 121, 121, 111, 121, 121, 121, 121, 121, 121, 111,
121, 121, 143, 121, 121, 121, 121, 121, 111, 121, 121, 129, 121, 138, 121, 138,
129, 129, 129, 129, 138, 138, 143, 138, 138, 138, 138, 129, 138, 167, 167, 167,
167, 155, 167, 138, 167, 143, 167, 167, 167, 167, 167, 166, 172, 159, 172, 167,
167, 167, 167, 167, 167, 159, 172, 172, 159, 167, 167, 167, 167, 172, 172, 172,
172, 172, 167, 172, 172, 172, 166, 172, 172, 172, 172, 172, 163, 172, 172, 170,
172, 175, 172, 172, 172, 163, 163, 163, 170, 163, 172, 163, 172, 163, 163, 163,
195, 163, 195, 163, 163, 163, 163, 163, 197, 197, 197, 195, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 111, 121, 111, 139, 139, 111, 124, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 131, 139, 139, 139, 139,
139, 139, 131, 131, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 155, 153, 153, 157, 155, 162, 162, 162, 154, 153, 154, 168, 162, 170, 162,
159, 162, 179, 170, 168, 175, 172, 168, 168, 174, 170, 173, 173, 175, 173, 179,
173, 179, 170, 177, 177, 177, 179, 177, 179, 183, 178, 178, 170, 183, 178, 183,
170, 183, 191, 183, 178, 183, 183, 183, 200, 183, 183, 191, 183, 183, 183, 200,
183, 191, 200, 200, 200, 197, 200, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 139, 121, 139, 139, 139, 111, 124, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 131, 139, 139, 139, 139,
139, 139, 131, 131, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 155, 153, 153, 157, 155, 162, 162, 162, 154, 153, 154, 168, 162, 175, 162,
159, 162, 179, 170, 168, 174, 172, 168, 168, 174, 170, 173, 173, 175, 173, 179,
173, 184, 170, 177, 177, 177, 179, 177, 179, 183, 178, 177, 191, 183, 178, 183,
191, 183, 191, 183, 178, 183, 183, 183, 200, 183, 183, 191, 200, 183, 183, 200,
183, 191, 200, 200, 200, 197, 200, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 111, 111, 121, 111, 111, 111, 111, 124, 139, 111, 139, 139, 139, 121, 124,
139, 139, 138, 121, 138, 139, 139, 139, 131, 138, 139, 139, 139, 138, 139, 139,
139, 139, 131, 139, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 167, 154,
155, 155, 155, 153, 154, 155, 162, 162, 162, 154, 153, 153, 168, 175, 170, 162,
159, 162, 179, 170, 174, 175, 172, 174, 174, 175, 170, 174, 173, 170, 175, 179,
175, 179, 170, 178, 178, 183, 183, 178, 179, 183, 170, 178, 170, 183, 178, 183,
198, 183, 191, 183, 191, 183, 183, 183, 183, 183, 183, 191, 183, 183, 183, 183,
183, 197, 200, 197, 197, 197, 211, 197, 197, 197, 211, 211, 211, 197, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86, 111, 111,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 121, 111,
121, 121, 138, 121, 138, 121, 121, 111, 111, 138, 121, 155, 129, 138, 129, 138,
129, 129, 131, 155, 138, 129, 138, 167, 138, 138, 167, 167, 138, 167, 167, 155,
155, 131, 155, 167, 167, 138, 167, 167, 167, 167, 167, 143, 159, 167, 159, 155,
167, 167, 167, 167, 153, 167, 159, 167, 167, 153, 167, 168, 167, 159, 172, 167,
172, 167, 168, 172, 167, 159, 172, 170, 170, 170, 172, 170, 175, 172, 170, 180,
170, 183, 172, 170, 170, 170, 178, 170, 183, 178, 172, 170, 172, 170, 170, 170,
195, 191, 195, 191, 198, 191, 197, 197, 183, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 197,
197, 220, 211, 197, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111,  86,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 139, 121, 139, 139, 139, 111, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 155, 153, 153, 157, 155, 162, 162, 162, 154, 153, 154, 168, 175, 175, 162,
170, 174, 179, 175, 174, 175, 172, 174, 174, 174, 170, 173, 186, 175, 173, 179,
173, 184, 170, 177, 177, 177, 186, 177, 179, 183, 191, 183, 191, 183, 178, 183,
191, 183, 191, 183, 191, 183, 183, 183, 200, 183, 183, 191, 200, 183, 183, 200,
183, 191, 200, 200, 200, 197, 200, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111,  93,
111, 124, 111, 111, 111, 111, 124, 111, 124, 111, 124, 124, 111, 124, 111, 111,
111, 124, 111, 124, 124, 111, 139, 124, 111, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 121, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 124, 139, 139, 131, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 155, 155, 155, 155, 155, 155, 155, 155, 155, 153,
131, 157, 131, 155, 155, 155, 155, 155, 155, 155, 153, 138, 155, 155, 155, 157,
153, 153, 153, 154, 157, 155, 155, 153, 153, 157, 153, 184, 168, 174, 174, 168,
175, 168, 184, 174, 168, 174, 188, 168, 168, 173, 175, 186, 179, 173, 186, 179,
173, 184, 175, 186, 177, 186, 179, 186, 184, 179, 177, 177, 191, 189, 177, 186,
191, 183, 191, 183, 183, 183, 200, 200, 200, 200, 200, 191, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 200, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 111, 139, 111, 111, 111, 111, 139, 121, 139,
139, 139, 138, 121, 138, 139, 139, 139, 139, 138, 139, 139, 139, 138, 139, 155,
155, 155, 131, 155, 155, 155, 138, 155, 155, 138, 155, 155, 155, 155, 155, 155,
155, 131, 155, 155, 155, 138, 155, 155, 155, 155, 155, 138, 167, 167, 167, 153,
155, 155, 155, 155, 154, 167, 167, 167, 167, 154, 168, 168, 174, 167, 167, 175,
159, 175, 168, 170, 175, 175, 172, 175, 175, 175, 188, 175, 180, 170, 175, 182,
175, 179, 188, 175, 175, 182, 182, 191, 179, 183, 170, 191, 170, 183, 191, 191,
188, 191, 191, 191, 191, 191, 191, 191, 183, 183, 191, 198, 183, 191, 191, 183,
197, 197, 200, 197, 197, 197, 211, 197, 197, 197, 211, 211, 197, 197, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 139, 121, 139, 139, 139, 111, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 167, 154,
155, 155, 155, 153, 157, 155, 162, 162, 162, 154, 153, 179, 168, 175, 175, 174,
170, 174, 179, 175, 174, 175, 172, 174, 174, 175, 170, 174, 186, 175, 174, 179,
175, 184, 170, 182, 182, 182, 186, 182, 179, 183, 191, 183, 191, 183, 191, 183,
191, 183, 191, 183, 191, 183, 183, 183, 200, 183, 183, 191, 200, 183, 183, 200,
183, 191, 200, 200, 200, 197, 211, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 220, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  93, 124,
 93, 124,  93, 111, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 139,
139, 124, 124, 124, 124, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 124,
139, 124, 139, 121, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 139, 139, 139, 139, 124, 124, 139, 139, 124, 139, 139, 139, 139,
139, 139, 131, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 131,
131, 135, 157, 155, 155, 155, 153, 153, 153, 153, 153, 138, 155, 153, 155, 157,
153, 153, 154, 154, 157, 153, 153, 153, 153, 157, 154, 157, 179, 174, 174, 153,
174, 168, 184, 174, 186, 168, 170, 186, 186, 186, 174, 186, 179, 186, 186, 184,
186, 187, 177, 186, 186, 179, 179, 189, 184, 179, 177, 189, 177, 189, 186, 189,
191, 189, 177, 189, 189, 189, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 111, 121, 111, 139, 111, 111, 139, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 138, 139, 139, 139, 139, 138, 139, 139, 139, 138, 139, 139,
139, 139, 131, 139, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 167, 155, 167, 154,
155, 155, 155, 155, 154, 155, 167, 162, 162, 184, 168, 179, 168, 175, 175, 174,
159, 174, 179, 175, 174, 175, 172, 174, 174, 175, 170, 180, 182, 175, 180, 179,
175, 184, 170, 182, 182, 182, 182, 182, 179, 183, 191, 191, 191, 183, 191, 183,
198, 191, 191, 191, 191, 191, 183, 191, 183, 183, 183, 191, 183, 191, 183, 183,
191, 191, 200, 202, 197, 197, 211, 197, 211, 211, 211, 211, 211, 211, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86, 124,  86, 124,  86, 124,  86, 124,  86,  93, 124, 124, 124,
124, 124, 124, 139, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124,
139, 124, 124, 124, 124, 139, 124, 124, 139, 124, 139, 124, 139, 124, 139, 124,
139, 124, 124, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 124,
139, 139, 139, 139, 139, 139, 139, 124, 124, 139, 139, 124, 139, 139, 139, 139,
139, 139, 135, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 131, 139, 157,
157, 141, 135, 139, 139, 139, 157, 147, 147, 153, 157, 155, 153, 153, 153, 157,
157, 157, 157, 157, 141, 154, 153, 154, 157, 157, 157, 157, 157, 153, 168, 184,
174, 184, 187, 186, 184, 186, 174, 184, 184, 179, 173, 184, 187, 186, 184, 187,
189, 187, 186, 184, 189, 184, 187, 189, 187, 187, 171, 189, 171, 184, 171, 171,
177, 200, 200, 200, 200, 200, 200, 200, 187, 200, 200, 200, 200, 200, 200, 200,
200, 200, 204, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 225, 200, 200, 211, 225, 211, 225, 211, 211, 211, 225, 211, 211, 220, 211,
211, 211, 225, 220, 220, 211, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 121, 139,
121, 111, 138, 121, 138, 121, 121, 139, 139, 138, 138, 155, 138, 138, 155, 138,
167, 155, 155, 155, 138, 167, 138, 167, 167, 138, 167, 167, 167, 167, 167, 155,
155, 185, 176, 167, 167, 138, 167, 167, 167, 167, 167, 172, 167, 167, 167, 176,
167, 167, 167, 167, 185, 167, 167, 167, 167, 176, 167, 167, 167, 167, 172, 167,
172, 167, 180, 172, 167, 167, 172, 167, 167, 170, 172, 175, 175, 188, 175, 180,
170, 179, 188, 170, 170, 175, 182, 191, 182, 191, 188, 191, 188, 191, 198, 191,
195, 191, 198, 198, 198, 198, 198, 198, 183, 191, 197, 198, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86, 111,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 185, 185, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 167, 185,
155, 155, 155, 155, 185, 155, 167, 155, 155, 184, 168, 184, 168, 175, 175, 174,
175, 174, 179, 175, 174, 175, 188, 180, 180, 180, 170, 180, 186, 175, 180, 179,
180, 184, 170, 182, 182, 182, 186, 182, 179, 186, 191, 190, 191, 192, 191, 192,
198, 192, 191, 192, 191, 192, 192, 192, 200, 192, 192, 191, 200, 202, 202, 200,
202, 202, 200, 202, 202, 197, 200, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
176, 185, 185, 155, 155, 138, 155, 155, 155, 155, 155, 138, 167, 155, 167, 185,
155, 155, 155, 155, 185, 155, 167, 174, 155, 184, 168, 184, 174, 175, 175, 174,
167, 174, 179, 175, 174, 175, 188, 180, 180, 175, 188, 180, 182, 175, 180, 179,
180, 184, 170, 182, 182, 182, 186, 190, 179, 190, 191, 190, 191, 192, 191, 192,
198, 192, 191, 192, 191, 192, 192, 192, 200, 192, 192, 199, 202, 202, 202, 200,
202, 199, 200, 202, 202, 197, 211, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 111, 111, 124, 111, 111, 124, 111, 124, 111, 111,
111, 111, 111, 124, 139, 111, 111, 139, 111, 139, 139, 139, 139, 139, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 157, 185, 155, 155, 155, 155, 155, 155, 155, 155, 138, 155, 155, 155, 185,
155, 155, 153, 153, 157, 155, 155, 155, 155, 184, 153, 184, 168, 174, 175, 174,
175, 174, 184, 175, 174, 174, 188, 174, 174, 180, 175, 180, 186, 180, 180, 179,
180, 184, 191, 186, 182, 186, 189, 186, 184, 189, 191, 192, 191, 186, 192, 192,
191, 192, 191, 192, 192, 192, 192, 192, 200, 200, 200, 191, 200, 200, 200, 200,
200, 202, 200, 200, 200, 202, 200, 200, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111, 124,
111, 124, 111, 111, 124, 111, 124, 111, 124, 111, 124, 124, 139, 124, 139, 139,
111, 124, 139, 124, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 121, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 155, 139, 155, 139,
131, 157, 157, 155, 155, 155, 155, 155, 155, 155, 155, 138, 155, 155, 155, 157,
155, 155, 153, 184, 157, 155, 155, 155, 155, 187, 184, 184, 186, 174, 174, 168,
175, 174, 184, 174, 186, 174, 188, 186, 186, 186, 175, 186, 179, 180, 186, 184,
186, 187, 191, 186, 186, 189, 189, 186, 184, 189, 192, 186, 191, 189, 192, 189,
191, 189, 191, 189, 192, 189, 200, 200, 200, 200, 200, 202, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 211, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
176, 185, 185, 155, 155, 167, 155, 155, 155, 155, 155, 138, 167, 155, 167, 185,
155, 155, 176, 176, 185, 155, 167, 174, 155, 184, 176, 184, 174, 175, 175, 174,
175, 174, 184, 175, 180, 175, 188, 180, 180, 180, 188, 180, 186, 175, 180, 179,
180, 184, 191, 190, 190, 190, 186, 190, 184, 186, 191, 190, 191, 192, 191, 192,
198, 192, 191, 192, 191, 192, 192, 192, 200, 202, 202, 199, 200, 202, 202, 200,
202, 202, 200, 202, 202, 202, 200, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86, 124,  86, 124,  86, 124,  86, 124, 111,  93, 124, 124, 124,
124, 124, 124, 111, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 139,
139, 124, 124, 124, 124, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 124,
139, 124, 139, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139, 124, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 131,
157, 141, 157, 139, 139, 155, 153, 153, 153, 153, 153, 155, 155, 153, 155, 157,
153, 153, 157, 157, 157, 153, 155, 153, 153, 187, 184, 187, 184, 174, 174, 184,
174, 186, 187, 174, 186, 186, 175, 186, 189, 186, 174, 189, 184, 186, 189, 187,
186, 187, 186, 189, 189, 184, 184, 189, 187, 184, 186, 189, 192, 189, 189, 189,
191, 189, 192, 200, 200, 200, 200, 200, 204, 200, 200, 200, 200, 200, 200, 200,
200, 200, 204, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211,
211, 225, 211, 211, 220, 211, 211, 225, 211, 211, 211, 225, 211, 211, 220, 211,
211, 220, 225, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 124,
111, 124, 111, 111, 111, 111, 124, 111, 124, 111, 124, 124, 111, 124, 139, 111,
111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 155, 139, 139, 155, 155, 139, 155, 155, 155, 176,
185, 185, 185, 155, 155, 155, 155, 155, 155, 155, 155, 138, 155, 155, 155, 185,
155, 155, 176, 176, 187, 155, 155, 155, 155, 187, 184, 184, 186, 174, 174, 174,
175, 174, 184, 175, 174, 174, 188, 186, 186, 180, 175, 186, 186, 180, 186, 184,
186, 184, 191, 186, 186, 186, 189, 186, 184, 189, 191, 193, 191, 189, 192, 193,
191, 193, 191, 193, 192, 193, 193, 192, 200, 200, 200, 202, 200, 200, 200, 200,
200, 202, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 211, 220, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 111, 111, 121, 111, 111, 111, 111, 139, 139, 111, 139, 139, 139, 121, 139,
139, 139, 138, 138, 138, 139, 139, 139, 139, 138, 139, 139, 139, 138, 139, 169,
169, 155, 176, 155, 169, 155, 138, 167, 167, 167, 167, 155, 167, 155, 167, 176,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 138, 167, 167, 167, 176,
167, 167, 176, 176, 185, 167, 167, 167, 167, 185, 176, 176, 167, 167, 167, 167,
188, 167, 180, 167, 167, 167, 188, 175, 175, 175, 188, 175, 180, 175, 175, 180,
175, 184, 188, 180, 191, 190, 190, 191, 193, 190, 198, 191, 198, 190, 191, 191,
188, 191, 198, 191, 199, 191, 199, 199, 192, 202, 199, 198, 202, 199, 202, 202,
199, 207, 202, 202, 199, 197, 211, 197, 197, 197, 211, 211, 197, 197, 197, 197,
211, 211, 211, 211, 197, 211, 220, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 139,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 176,
176, 185, 185, 155, 155, 167, 155, 155, 155, 155, 155, 138, 167, 155, 167, 185,
155, 176, 176, 176, 185, 167, 167, 167, 174, 185, 176, 185, 180, 167, 167, 180,
167, 180, 184, 175, 180, 175, 188, 180, 180, 180, 188, 180, 186, 175, 180, 186,
180, 184, 188, 190, 190, 190, 193, 190, 184, 193, 191, 190, 191, 192, 191, 192,
198, 192, 199, 192, 191, 192, 202, 202, 200, 202, 202, 199, 202, 202, 202, 202,
202, 199, 200, 202, 202, 202, 200, 202, 211, 211, 211, 211, 211, 211, 220, 220,
211, 211, 211, 211, 220, 211, 211, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  23,  23,  53,  53,  23,  53,  53,  53,  53,  53,  53,  53,  53,
 53, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 111, 139, 111, 111, 111, 111, 139, 138, 139,
169, 169, 138, 138, 138, 169, 169, 169, 169, 138, 169, 169, 169, 138, 169, 167,
169, 169, 176, 169, 167, 167, 138, 167, 167, 167, 167, 167, 167, 167, 167, 176,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 172, 167, 167, 167, 176,
167, 167, 167, 167, 185, 167, 167, 167, 167, 185, 167, 176, 167, 167, 167, 167,
188, 167, 180, 188, 167, 167, 188, 167, 167, 167, 188, 167, 180, 188, 175, 180,
175, 193, 188, 191, 198, 190, 190, 191, 190, 190, 198, 198, 188, 191, 198, 198,
195, 198, 198, 198, 198, 198, 199, 198, 202, 199, 199, 198, 199, 207, 207, 202,
207, 207, 206, 207, 207, 207, 197, 207, 197, 197, 211, 197, 197, 197, 197, 197,
197, 211, 197, 211, 197, 211, 197, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  53,  53,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 111, 111, 124, 111, 111, 124, 111, 124, 111, 111,
111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 169, 155, 155, 169, 155, 176, 155, 176, 176, 176,
185, 185, 185, 155, 155, 167, 176, 176, 176, 155, 176, 138, 155, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 175, 175, 180,
175, 180, 184, 175, 180, 180, 188, 180, 180, 180, 175, 180, 186, 180, 180, 184,
190, 184, 191, 190, 190, 193, 189, 193, 184, 193, 191, 192, 199, 193, 192, 193,
199, 193, 199, 192, 196, 192, 202, 202, 200, 205, 202, 199, 200, 202, 202, 200,
202, 202, 200, 205, 206, 214, 200, 214, 214, 214, 211, 211, 211, 211, 220, 220,
211, 211, 211, 211, 220, 211, 211, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  53,  53,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86, 111,  86,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 139, 139, 139, 169, 139, 169,
169, 169, 185, 139, 169, 169, 138, 169, 169, 167, 169, 176, 169, 176, 176, 176,
176, 185, 185, 167, 167, 167, 176, 167, 176, 167, 176, 138, 167, 167, 167, 185,
176, 176, 176, 176, 185, 167, 167, 167, 167, 185, 176, 176, 180, 167, 167, 167,
188, 180, 176, 167, 180, 175, 188, 180, 180, 180, 188, 180, 190, 175, 180, 186,
180, 184, 188, 190, 190, 190, 193, 190, 189, 190, 199, 190, 198, 196, 199, 196,
198, 196, 198, 196, 199, 196, 202, 202, 193, 202, 202, 199, 202, 202, 202, 202,
202, 199, 200, 202, 206, 207, 214, 214, 214, 214, 211, 211, 211, 220, 220, 220,
220, 211, 211, 211, 220, 211, 220, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  53,  53,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 139, 111, 111, 139, 111, 139, 139, 139, 139, 139, 111, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 185, 139, 169, 169, 138, 169, 169, 169, 169, 176, 169, 176, 176, 176,
176, 185, 185, 155, 155, 167, 176, 176, 176, 176, 176, 138, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 180, 175, 167, 180,
167, 180, 184, 175, 180, 180, 188, 180, 180, 180, 188, 180, 186, 180, 180, 189,
180, 184, 191, 190, 190, 193, 193, 190, 184, 193, 191, 190, 199, 193, 196, 196,
198, 196, 199, 196, 196, 196, 202, 202, 200, 202, 202, 199, 205, 202, 202, 205,
202, 202, 200, 206, 206, 214, 200, 214, 214, 214, 211, 211, 211, 220, 220, 220,
211, 211, 211, 211, 220, 211, 220, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 169, 138, 169,
169, 169, 138, 138, 138, 169, 169, 169, 169, 138, 169, 169, 169, 138, 169, 167,
169, 169, 176, 169, 167, 167, 138, 167, 167, 167, 167, 167, 167, 167, 167, 167,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 172, 167, 167, 167, 176,
167, 167, 167, 167, 185, 167, 167, 167, 167, 176, 167, 176, 167, 167, 188, 167,
188, 167, 167, 188, 167, 188, 188, 167, 167, 188, 188, 167, 167, 188, 167, 194,
188, 194, 188, 198, 198, 198, 194, 198, 194, 199, 188, 198, 195, 198, 198, 198,
195, 198, 195, 198, 198, 198, 198, 198, 202, 207, 207, 207, 207, 207, 207, 207,
207, 207, 206, 207, 207, 207, 207, 207, 207, 207, 212, 207, 207, 207, 207, 207,
197, 211, 197, 197, 207, 197, 197, 211, 197, 197, 220, 220, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 235, 235, 235, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 111, 111, 124, 111, 111,
111, 139, 111, 124, 139, 111, 139, 139, 111, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 139, 139, 139, 169, 139, 169,
169, 169, 185, 139, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176, 176, 176,
176, 185, 185, 176, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 180,
167, 180, 185, 175, 180, 180, 188, 180, 180, 180, 188, 194, 194, 180, 194, 189,
194, 184, 199, 194, 194, 194, 193, 194, 184, 193, 199, 196, 199, 193, 196, 196,
198, 196, 199, 196, 199, 196, 202, 202, 205, 202, 202, 199, 205, 202, 202, 205,
202, 202, 200, 206, 206, 214, 214, 214, 214, 214, 211, 214, 211, 220, 220, 220,
220, 211, 211, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 111, 111, 138, 111, 111, 111, 111, 139, 169, 169, 169, 169, 169, 138, 139,
169, 169, 138, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 176, 169, 169, 169, 138, 169, 167, 167, 167, 169, 167, 176, 167, 176,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 172, 167, 167, 167, 185,
167, 167, 176, 176, 185, 167, 167, 167, 167, 185, 176, 176, 167, 167, 167, 167,
188, 167, 176, 188, 167, 167, 188, 167, 167, 167, 188, 180, 194, 188, 180, 194,
198, 184, 188, 194, 199, 194, 194, 199, 194, 194, 198, 199, 198, 196, 198, 199,
195, 199, 198, 199, 198, 199, 199, 199, 202, 199, 199, 207, 202, 207, 199, 206,
207, 207, 206, 207, 207, 207, 214, 212, 212, 212, 214, 214, 212, 207, 207, 207,
220, 211, 220, 211, 207, 220, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 235, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 139, 111, 139, 139, 111, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 139, 139, 139, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176, 176, 176,
176, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 180,
167, 180, 185, 175, 180, 180, 188, 180, 194, 180, 188, 194, 194, 180, 194, 189,
194, 184, 198, 194, 194, 194, 193, 194, 184, 193, 199, 196, 199, 193, 196, 196,
198, 196, 199, 196, 199, 196, 202, 202, 205, 202, 202, 199, 205, 202, 206, 205,
206, 202, 205, 206, 206, 214, 214, 214, 214, 214, 214, 214, 214, 220, 220, 220,
220, 211, 211, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 139, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 138, 169, 169, 169, 169, 139, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 167, 169, 169, 169, 169, 169, 169, 176, 169, 176,
176, 185, 185, 169, 176, 167, 176, 176, 176, 167, 176, 188, 167, 167, 167, 185,
176, 176, 176, 176, 185, 167, 167, 167, 167, 185, 176, 185, 176, 167, 167, 167,
188, 167, 176, 167, 180, 167, 188, 180, 194, 180, 188, 194, 194, 180, 194, 194,
194, 184, 188, 194, 194, 194, 194, 194, 193, 194, 199, 196, 198, 196, 199, 196,
198, 196, 198, 196, 199, 196, 202, 202, 205, 202, 202, 199, 206, 202, 206, 206,
206, 199, 205, 206, 206, 212, 214, 214, 214, 214, 214, 214, 214, 214, 212, 220,
220, 211, 220, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 111, 111, 124, 111, 111,
111, 139, 111, 124, 139, 111, 139, 139, 111, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 169, 139, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176, 176, 176,
185, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 180,
167, 180, 185, 175, 180, 180, 188, 194, 194, 194, 188, 194, 194, 194, 194, 189,
194, 184, 199, 194, 194, 194, 193, 194, 184, 193, 199, 196, 199, 193, 196, 196,
198, 196, 199, 196, 199, 196, 202, 202, 205, 202, 202, 199, 205, 206, 206, 205,
206, 202, 204, 206, 206, 214, 214, 214, 214, 214, 214, 214, 214, 214, 220, 220,
220, 211, 220, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86, 111, 111,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 111, 111, 124, 111, 111, 139, 111, 124, 111, 111,
111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
139, 139, 138, 169, 169, 169, 169, 139, 139, 169, 169, 139, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 194, 185, 167, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 193,
194, 184, 199, 194, 194, 194, 193, 194, 184, 193, 199, 194, 199, 201, 196, 201,
198, 201, 199, 201, 196, 201, 201, 202, 205, 205, 206, 199, 205, 206, 206, 205,
206, 206, 204, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 220,
220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 139, 111, 124, 111, 111,
111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 138, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 194, 185, 167, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 193,
194, 184, 199, 194, 194, 194, 194, 194, 184, 194, 199, 194, 199, 201, 196, 201,
198, 201, 199, 201, 199, 201, 201, 202, 205, 206, 206, 199, 205, 206, 206, 206,
206, 210, 205, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 212, 220,
220, 211, 220, 220, 220, 220, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 124, 111, 124, 111, 124, 111, 124, 139, 124, 111, 139, 139, 139, 124,
139, 124, 139, 111, 139, 139, 124, 139, 124, 139, 139, 124, 139, 124, 139, 139,
139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 169, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 139,
139, 139, 185, 139, 169, 169, 169, 169, 169, 169, 169, 176, 169, 185, 176, 185,
185, 185, 185, 176, 176, 169, 176, 176, 176, 176, 176, 169, 176, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 185, 176, 194, 176,
194, 176, 187, 194, 176, 194, 188, 194, 193, 194, 194, 193, 184, 194, 193, 187,
194, 187, 194, 193, 193, 189, 184, 193, 187, 189, 201, 193, 201, 205, 205, 205,
199, 205, 201, 205, 205, 205, 205, 205, 204, 205, 205, 205, 204, 205, 205, 204,
205, 205, 204, 205, 205, 214, 204, 205, 214, 214, 225, 225, 214, 214, 214, 214,
220, 225, 225, 225, 220, 225, 220, 225, 225, 220, 220, 225, 220, 220, 220, 220,
220, 220, 225, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  86,
 86,  86,  86,  86,  86,  86, 111, 111,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 124, 111, 111, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 176, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 194, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 194, 194, 194, 194, 194, 184,
194, 187, 199, 194, 194, 194, 193, 194, 184, 193, 194, 194, 199, 201, 201, 201,
199, 201, 199, 201, 201, 201, 205, 206, 204, 205, 205, 210, 205, 206, 205, 205,
209, 210, 204, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214,
214, 225, 214, 214, 220, 220, 220, 225, 220, 220, 220, 225, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  86,
 86, 111,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 139, 111, 139, 111, 139, 139, 139, 124, 139, 139,
111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 169, 139, 169, 169, 169, 169, 169, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 194,
194, 203, 199, 194, 194, 194, 194, 194, 184, 194, 199, 194, 199, 201, 201, 201,
198, 201, 199, 201, 201, 201, 206, 206, 205, 205, 206, 199, 205, 206, 206, 209,
206, 210, 204, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214,
214, 214, 214, 214, 220, 220, 220, 225, 220, 220, 220, 220, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169, 169,
169, 169, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176,
176, 185, 185, 169, 169, 167, 176, 167, 176, 167, 176, 188, 167, 167, 167, 185,
176, 176, 176, 176, 185, 167, 167, 167, 167, 185, 176, 185, 176, 167, 167, 167,
188, 167, 176, 188, 167, 167, 188, 194, 194, 194, 188, 194, 194, 198, 194, 194,
194, 185, 188, 194, 194, 194, 194, 194, 194, 194, 198, 199, 198, 194, 199, 199,
198, 199, 198, 199, 207, 199, 212, 212, 208, 212, 212, 207, 210, 212, 212, 210,
212, 207, 209, 212, 212, 212, 214, 212, 212, 212, 214, 212, 212, 212, 207, 212,
212, 214, 224, 214, 228, 220, 220, 214, 220, 220, 220, 220, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,  86,
 86,  86,  86,  86,  86,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 124, 111, 111, 111, 124, 111, 111, 111, 111, 111, 139, 139,
139, 124, 139, 111, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 169, 139, 139, 139, 169, 139, 139, 169, 169, 169, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 185,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
194, 176, 185, 194, 194, 194, 188, 194, 194, 194, 194, 194, 194, 194, 194, 203,
194, 203, 194, 194, 194, 194, 193, 194, 203, 193, 194, 194, 199, 205, 201, 208,
199, 208, 199, 208, 208, 205, 205, 205, 204, 205, 205, 210, 205, 209, 205, 205,
209, 210, 204, 214, 214, 214, 214, 214, 214, 214, 223, 214, 214, 214, 214, 214,
214, 225, 214, 214, 220, 214, 220, 225, 220, 220, 220, 225, 220, 220, 220, 220,
220, 220, 225, 220, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,  86,
111, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 139, 111, 111, 111, 111, 139, 111, 139, 139, 139, 139, 139, 124, 139, 139,
111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 203,
194, 203, 199, 194, 194, 194, 194, 194, 203, 194, 199, 194, 199, 208, 208, 208,
198, 208, 199, 208, 208, 208, 208, 208, 205, 208, 208, 212, 209, 210, 210, 209,
210, 210, 209, 214, 214, 212, 214, 214, 214, 214, 214, 214, 214, 214, 212, 224,
221, 214, 221, 221, 224, 221, 221, 223, 220, 220, 220, 220, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,  86,
 86, 111,  86, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 124, 111, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 139,
169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 194, 194, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 203,
194, 203, 199, 194, 194, 194, 194, 194, 203, 194, 194, 194, 199, 208, 208, 208,
199, 208, 199, 208, 208, 208, 208, 208, 205, 209, 209, 210, 209, 210, 209, 209,
209, 210, 204, 214, 214, 216, 214, 214, 214, 214, 214, 214, 214, 214, 224, 221,
221, 223, 221, 221, 224, 221, 221, 225, 220, 220, 220, 225, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,
 86, 111,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 124, 111, 111, 111, 124, 111, 111, 111, 111, 139, 139, 139,
139, 124, 139, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
139, 139, 139, 169, 139, 139, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 185,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
194, 176, 185, 194, 194, 194, 188, 194, 194, 194, 194, 194, 203, 194, 194, 203,
194, 203, 194, 194, 194, 194, 203, 194, 203, 194, 194, 194, 199, 208, 208, 208,
199, 208, 208, 208, 208, 208, 208, 208, 204, 205, 209, 210, 205, 209, 209, 209,
209, 210, 213, 214, 214, 216, 223, 214, 214, 214, 223, 214, 214, 214, 216, 221,
221, 225, 221, 223, 221, 221, 221, 225, 221, 220, 220, 225, 220, 220, 220, 220,
220, 220, 233, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,
 86, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 139, 111, 111, 139, 111, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 194, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 203,
194, 203, 199, 194, 194, 194, 194, 194, 203, 194, 194, 194, 199, 208, 208, 208,
198, 208, 199, 208, 208, 208, 208, 208, 205, 208, 208, 212, 209, 210, 209, 209,
210, 210, 218, 214, 214, 216, 214, 214, 214, 214, 214, 214, 214, 214, 224, 224,
221, 221, 221, 221, 224, 221, 221, 225, 221, 220, 220, 220, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 111,
111, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 188, 169, 176, 169, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 176,
188, 176, 185, 167, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 194,
194, 203, 198, 194, 194, 194, 194, 194, 203, 194, 199, 194, 198, 208, 208, 208,
207, 208, 207, 208, 212, 208, 208, 208, 208, 208, 210, 212, 209, 212, 210, 210,
210, 212, 209, 210, 212, 212, 214, 216, 216, 216, 214, 224, 224, 224, 228, 224,
224, 221, 224, 221, 228, 224, 224, 221, 224, 224, 220, 230, 220, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  86,  86,  86,  86, 124,  86,  86,  86,  86,  86, 124, 124, 139, 124, 139,
111, 139, 124, 139, 124, 139, 124, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 124, 139, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 169, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185, 169, 185,
185, 185, 185, 169, 176, 169, 185, 176, 185, 176, 185, 169, 169, 176, 169, 185,
185, 185, 185, 185, 185, 176, 176, 176, 185, 203, 185, 203, 185, 176, 176, 185,
194, 185, 203, 194, 203, 194, 215, 203, 203, 194, 194, 203, 203, 194, 203, 203,
194, 203, 194, 203, 194, 203, 203, 205, 203, 204, 208, 205, 208, 204, 205, 205,
208, 205, 208, 205, 205, 205, 205, 205, 213, 204, 205, 205, 213, 205, 205, 213,
205, 205, 213, 223, 223, 216, 213, 223, 223, 223, 225, 223, 223, 223, 221, 221,
223, 225, 225, 225, 221, 225, 225, 225, 225, 225, 225, 225, 225, 233, 220, 233,
233, 233, 225, 235, 235, 235, 243, 233, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 139, 111, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
169, 139, 139, 139, 139, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 215, 194, 194, 194, 194, 203,
194, 203, 215, 194, 194, 194, 208, 208, 203, 208, 208, 208, 215, 208, 208, 208,
215, 208, 212, 208, 208, 208, 208, 208, 218, 208, 208, 212, 209, 210, 209, 209,
216, 219, 218, 216, 216, 219, 214, 216, 216, 221, 221, 221, 221, 224, 224, 224,
221, 223, 221, 221, 224, 227, 227, 231, 227, 227, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 139, 111, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169,
169, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 215, 194, 194, 194, 194, 203,
194, 203, 215, 194, 194, 194, 208, 208, 203, 208, 208, 208, 215, 208, 208, 208,
215, 208, 212, 208, 208, 208, 208, 208, 218, 208, 208, 212, 209, 210, 209, 209,
216, 219, 218, 216, 216, 219, 221, 216, 221, 221, 221, 221, 221, 224, 224, 224,
221, 223, 221, 221, 224, 227, 227, 231, 227, 227, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176,
185, 185, 185, 169, 169, 169, 176, 169, 169, 169, 176, 188, 169, 169, 169, 185,
176, 176, 176, 185, 185, 176, 169, 176, 176, 185, 176, 185, 176, 167, 215, 176,
215, 176, 185, 215, 194, 194, 215, 194, 194, 194, 215, 194, 194, 215, 194, 203,
194, 203, 215, 194, 194, 208, 208, 208, 203, 208, 215, 208, 215, 208, 208, 208,
215, 208, 215, 208, 212, 208, 208, 208, 218, 208, 212, 212, 219, 212, 219, 219,
219, 212, 218, 219, 219, 226, 224, 224, 224, 224, 224, 224, 224, 224, 228, 228,
224, 227, 224, 227, 228, 229, 229, 230, 229, 229, 229, 230, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 139, 111, 124, 139, 139, 111, 139, 139, 139, 111, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
169, 139, 139, 139, 139, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 176, 176, 176, 185, 169, 169, 176, 169, 185,
176, 185, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 185, 176, 176, 176,
194, 176, 203, 194, 176, 194, 215, 203, 203, 194, 215, 203, 203, 194, 194, 203,
194, 203, 217, 208, 208, 203, 203, 208, 203, 203, 208, 208, 208, 208, 208, 208,
215, 208, 208, 208, 208, 208, 208, 208, 213, 218, 218, 219, 218, 218, 218, 218,
218, 219, 213, 221, 221, 221, 223, 221, 221, 221, 223, 223, 221, 221, 221, 227,
230, 223, 230, 223, 227, 231, 230, 233, 230, 230, 230, 233, 230, 230, 235, 235,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
139, 139, 139, 111, 139, 139, 139, 169, 139, 169, 169, 139, 169, 139, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 176, 194, 176,
215, 176, 185, 215, 176, 194, 215, 194, 194, 194, 215, 194, 203, 194, 194, 203,
194, 203, 215, 208, 208, 208, 208, 208, 203, 208, 217, 208, 215, 208, 208, 208,
215, 208, 215, 208, 208, 208, 208, 208, 218, 208, 208, 212, 218, 219, 219, 218,
219, 219, 218, 219, 219, 224, 221, 221, 221, 224, 221, 221, 224, 224, 226, 224,
227, 230, 227, 227, 226, 230, 227, 231, 230, 229, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 139,
139, 139, 139, 111, 139, 139, 139, 169, 139, 169, 169, 169, 169, 139, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 176, 169, 176,
215, 176, 203, 215, 176, 194, 215, 194, 194, 194, 215, 194, 203, 217, 194, 203,
194, 203, 215, 208, 208, 208, 203, 208, 203, 208, 217, 208, 215, 208, 208, 208,
215, 208, 215, 208, 208, 208, 208, 208, 218, 218, 208, 212, 218, 219, 219, 218,
219, 219, 218, 219, 219, 224, 218, 221, 221, 224, 221, 221, 227, 224, 226, 224,
227, 231, 227, 230, 229, 230, 229, 231, 230, 229, 229, 231, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
139, 139, 169, 111, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 169, 169, 176, 169, 169, 169, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 176, 215, 176,
215, 176, 203, 215, 176, 194, 215, 194, 194, 194, 215, 194, 203, 217, 194, 203,
217, 203, 215, 208, 208, 208, 203, 208, 203, 208, 217, 208, 215, 208, 208, 208,
215, 208, 215, 208, 208, 208, 208, 208, 218, 218, 208, 212, 218, 219, 219, 218,
219, 219, 218, 219, 219, 226, 218, 224, 224, 224, 221, 221, 227, 224, 226, 224,
227, 230, 227, 230, 228, 230, 229, 231, 230, 229, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 124, 111, 111, 111, 111, 111, 139, 111, 111, 111, 139,
111, 111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 169, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 169,
169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 185, 169, 185, 169, 169, 176, 169, 185,
185, 185, 185, 185, 203, 176, 176, 176, 185, 203, 185, 203, 203, 176, 169, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 203, 215, 203, 203, 217, 203, 203,
217, 203, 217, 208, 208, 203, 203, 208, 203, 203, 217, 208, 217, 218, 208, 208,
215, 208, 217, 208, 208, 218, 218, 218, 218, 218, 218, 219, 218, 218, 218, 218,
218, 219, 223, 223, 223, 221, 223, 221, 223, 221, 223, 223, 230, 227, 227, 227,
230, 223, 230, 231, 227, 231, 230, 233, 230, 230, 230, 233, 230, 230, 235, 233,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 139, 111, 139, 111, 139, 139, 139, 111, 139, 139, 139, 139,
139, 139, 169, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 169, 169, 169, 169, 185,
176, 185, 185, 185, 185, 176, 169, 176, 176, 203, 185, 203, 185, 176, 217, 176,
215, 176, 203, 217, 203, 217, 215, 203, 203, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 203, 203, 217, 203, 203, 217, 217, 215, 208, 217, 208,
215, 208, 217, 208, 217, 208, 218, 218, 218, 218, 218, 219, 218, 219, 218, 218,
218, 219, 218, 221, 221, 224, 223, 221, 221, 221, 223, 227, 227, 227, 227, 227,
227, 231, 230, 230, 229, 230, 230, 231, 230, 230, 230, 233, 230, 230, 235, 235,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 139, 111, 111, 111, 139, 111, 139, 111, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 176, 169, 169, 169, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 185, 217, 215, 176,
215, 176, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 203, 217, 203, 208, 217, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 222, 217, 218, 218, 218, 226, 218, 219, 218, 218,
219, 219, 218, 219, 219, 226, 218, 224, 224, 224, 230, 227, 227, 227, 226, 229,
229, 231, 230, 230, 229, 230, 229, 231, 230, 229, 229, 231, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 176, 169, 169, 169, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 217, 215, 176,
215, 176, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 203, 217, 203, 208, 215, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 218, 218, 219, 226, 218, 219, 219, 218,
219, 226, 218, 219, 219, 226, 218, 224, 224, 224, 227, 227, 227, 229, 226, 229,
229, 230, 229, 230, 228, 230, 229, 231, 229, 229, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 215, 169, 169, 169, 185,
169, 176, 176, 185, 185, 169, 169, 176, 176, 185, 185, 185, 176, 215, 215, 176,
215, 217, 185, 215, 217, 215, 215, 217, 217, 215, 215, 217, 217, 215, 217, 203,
215, 203, 215, 217, 217, 217, 217, 217, 203, 217, 215, 217, 215, 217, 215, 217,
215, 217, 215, 217, 215, 217, 217, 217, 218, 219, 212, 215, 219, 226, 219, 219,
226, 226, 218, 226, 226, 226, 224, 226, 226, 226, 224, 224, 226, 228, 228, 228,
229, 229, 229, 229, 228, 229, 229, 230, 229, 229, 229, 232, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 215, 169, 169, 169, 185,
176, 176, 185, 185, 185, 169, 169, 176, 176, 185, 185, 185, 176, 215, 215, 176,
215, 217, 203, 215, 217, 215, 215, 217, 217, 217, 215, 217, 217, 215, 217, 203,
217, 203, 215, 217, 217, 217, 217, 217, 203, 217, 215, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 218, 218, 217, 215, 218, 219, 219, 218,
219, 226, 218, 219, 224, 226, 224, 224, 224, 224, 227, 227, 229, 226, 228, 226,
229, 230, 229, 229, 228, 229, 229, 231, 229, 229, 229, 230, 232, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 139, 111, 169, 111, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 185,
176, 185, 185, 185, 185, 176, 169, 176, 176, 203, 185, 203, 185, 217, 215, 176,
215, 217, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 203, 217, 203, 222, 217, 217, 215, 217, 217, 217,
215, 217, 217, 217, 217, 217, 222, 217, 218, 218, 222, 226, 218, 219, 218, 218,
219, 226, 218, 219, 224, 226, 218, 227, 227, 227, 231, 227, 229, 229, 226, 229,
229, 231, 230, 230, 229, 230, 229, 231, 230, 232, 232, 231, 232, 238, 235, 235,
235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 169, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 139, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 185, 185, 185, 185, 169, 169, 185, 169, 203,
185, 185, 185, 203, 203, 185, 169, 203, 203, 203, 203, 203, 203, 217, 217, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 203, 217, 203, 203, 217, 203, 203,
217, 203, 217, 222, 222, 203, 203, 222, 203, 203, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 218, 218, 218, 222, 223, 218, 218, 223,
218, 222, 223, 223, 223, 227, 223, 223, 223, 223, 223, 223, 231, 230, 227, 230,
231, 233, 231, 231, 230, 233, 231, 233, 231, 230, 230, 233, 233, 233, 235, 233,
233, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 139, 111, 139, 139, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 169, 169, 169, 169, 185,
185, 185, 185, 185, 203, 176, 169, 176, 185, 203, 185, 203, 203, 217, 217, 203,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 222, 203, 217, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 218, 218, 222, 217, 218, 222, 218, 218,
218, 219, 218, 218, 221, 226, 218, 227, 227, 227, 231, 230, 227, 229, 226, 229,
230, 231, 230, 231, 229, 231, 230, 231, 230, 230, 230, 233, 230, 238, 235, 235,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 139, 111, 111, 139, 139,
111, 139, 139, 139, 139, 139, 139, 169, 139, 139, 139, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 185, 169, 185, 169, 169, 169, 169, 185,
185, 185, 185, 185, 203, 185, 169, 185, 185, 203, 203, 203, 203, 217, 217, 203,
215, 203, 203, 217, 203, 217, 215, 203, 203, 217, 215, 217, 203, 217, 217, 203,
217, 203, 217, 217, 217, 203, 203, 222, 203, 203, 217, 222, 217, 222, 217, 222,
215, 222, 217, 222, 222, 222, 222, 222, 218, 218, 222, 217, 218, 218, 218, 218,
218, 219, 223, 218, 218, 227, 223, 227, 227, 227, 231, 231, 230, 230, 229, 229,
230, 231, 230, 231, 229, 231, 230, 233, 231, 230, 230, 233, 230, 230, 235, 235,
235, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 215, 169, 169, 169, 185,
169, 169, 185, 185, 185, 169, 169, 169, 176, 185, 185, 185, 217, 215, 215, 217,
215, 217, 203, 215, 217, 215, 215, 217, 217, 217, 215, 217, 217, 215, 217, 203,
217, 203, 215, 217, 217, 217, 217, 217, 203, 217, 215, 217, 215, 217, 215, 217,
215, 217, 215, 217, 215, 217, 217, 217, 218, 217, 217, 215, 222, 226, 226, 218,
226, 226, 218, 226, 226, 226, 224, 226, 226, 226, 229, 229, 226, 226, 228, 228,
232, 232, 232, 232, 228, 232, 232, 232, 232, 232, 232, 232, 234, 235, 240, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 139, 111, 111, 139, 139,
169, 139, 139, 139, 139, 139, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 185, 169, 185, 169, 169, 169, 169, 203,
185, 185, 185, 185, 203, 185, 169, 185, 185, 203, 203, 203, 203, 217, 217, 203,
215, 203, 203, 217, 203, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 217, 217, 217, 222, 203, 222, 203, 222, 217, 222, 217, 222, 217, 222,
215, 222, 217, 222, 222, 222, 222, 222, 218, 222, 222, 217, 218, 222, 218, 218,
222, 222, 223, 218, 218, 227, 223, 227, 230, 227, 231, 231, 230, 230, 229, 229,
230, 231, 231, 231, 229, 231, 230, 233, 231, 230, 230, 233, 230, 238, 235, 238,
238, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 215, 169, 169, 169, 185,
185, 185, 185, 185, 203, 169, 169, 176, 176, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 215, 222, 217, 217,
215, 217, 217, 217, 217, 217, 222, 222, 218, 222, 222, 217, 218, 222, 222, 218,
222, 226, 218, 227, 227, 226, 218, 227, 227, 227, 231, 230, 232, 229, 226, 229,
232, 231, 232, 230, 232, 230, 232, 231, 232, 232, 234, 231, 234, 238, 235, 235,
235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 169, 169, 169, 139,
169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 185, 185, 185, 185, 169, 169, 185, 169, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 217, 217, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 203, 217, 203, 203, 217, 203, 203,
222, 203, 217, 222, 222, 203, 203, 222, 203, 203, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 213, 218, 222, 222, 223, 223, 223, 223,
223, 222, 223, 223, 223, 230, 223, 223, 223, 223, 223, 231, 231, 231, 230, 230,
231, 233, 231, 233, 230, 233, 231, 233, 233, 231, 233, 236, 233, 233, 239, 233,
233, 233, 236, 235, 243, 243, 243, 245, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 139, 111, 111, 111, 169,
169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 169, 169, 169, 169, 203,
185, 185, 185, 185, 203, 185, 169, 185, 185, 203, 203, 203, 203, 217, 217, 203,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 217, 217, 217, 222, 203, 217, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 218, 222, 222, 217, 218, 222, 222, 218,
222, 222, 218, 222, 222, 226, 231, 227, 227, 227, 231, 231, 230, 232, 229, 232,
232, 231, 230, 231, 232, 231, 232, 231, 230, 234, 234, 233, 234, 238, 235, 238,
238, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 215, 169, 169, 169, 185,
169, 185, 185, 185, 203, 169, 169, 169, 185, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 215, 222, 217, 217,
215, 217, 217, 217, 217, 217, 222, 222, 218, 222, 222, 217, 222, 222, 222, 222,
222, 226, 218, 222, 222, 226, 231, 227, 232, 232, 231, 232, 232, 232, 226, 232,
232, 231, 232, 232, 234, 232, 232, 231, 232, 234, 234, 231, 234, 238, 235, 238,
238, 235, 238, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 215, 169, 169, 169, 203,
169, 185, 185, 185, 203, 169, 217, 217, 185, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 215, 222, 217, 217,
215, 217, 217, 217, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 218, 222, 222, 226, 231, 232, 232, 232, 231, 232, 232, 232, 226, 232,
232, 231, 232, 232, 234, 232, 234, 231, 234, 234, 234, 231, 238, 238, 238, 238,
238, 238, 238, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 139, 139, 139, 139, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 203, 185, 169, 169, 169, 185, 185, 185, 185, 185, 169, 169, 203, 169, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 217, 217, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 217, 217, 222, 203, 217, 222, 203,
222, 203, 217, 222, 222, 222, 203, 222, 203, 222, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 218, 222, 222, 222, 222, 222, 222, 222,
222, 222, 223, 222, 222, 222, 231, 231, 231, 231, 231, 231, 231, 231, 234, 230,
231, 236, 231, 231, 234, 231, 231, 236, 231, 231, 231, 236, 239, 239, 239, 236,
239, 239, 236, 241, 243, 245, 243, 245, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 169, 169, 169, 203,
185, 185, 185, 203, 203, 169, 217, 217, 217, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 217, 222, 217, 217,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 218, 222, 222, 226, 231, 232, 232, 232, 231, 232, 232, 232, 226, 234,
234, 231, 234, 237, 234, 237, 234, 231, 234, 234, 234, 237, 238, 238, 238, 238,
238, 241, 241, 241, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 169, 169, 169, 203,
185, 185, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 203,
217, 203, 215, 217, 217, 222, 222, 217, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 218, 222, 222, 226, 237, 232, 232, 232, 237, 237, 234, 234, 234, 234,
234, 237, 237, 237, 234, 237, 234, 237, 237, 234, 239, 237, 239, 239, 240, 239,
239, 241, 241, 241, 242, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 215, 169, 169, 169, 169, 169, 215, 215, 217, 215, 203,
217, 217, 185, 203, 203, 217, 217, 217, 217, 203, 217, 203, 217, 217, 215, 217,
215, 217, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 217,
217, 203, 215, 217, 217, 217, 217, 217, 222, 217, 215, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 222, 222, 217, 215, 222, 217, 222, 222,
217, 217, 237, 222, 222, 226, 237, 237, 237, 237, 237, 237, 237, 234, 228, 234,
237, 237, 237, 237, 240, 237, 237, 237, 237, 234, 238, 237, 238, 241, 240, 241,
241, 244, 242, 240, 244, 244, 244, 242, 244, 244, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 203, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 169, 217, 217, 203,
203, 203, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 203,
217, 203, 217, 217, 217, 222, 222, 222, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 222, 222, 222, 234, 237, 237, 237, 237, 237, 237, 237, 237, 234, 234,
237, 237, 237, 237, 234, 237, 237, 237, 237, 237, 237, 237, 239, 241, 241, 241,
241, 242, 241, 242, 242, 242, 242, 245, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 203, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 217, 217, 217, 203,
217, 203, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 222,
217, 203, 217, 217, 217, 222, 222, 217, 222, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 237, 222, 222, 234, 237, 237, 237, 237, 237, 237, 237, 237, 234, 234,
237, 237, 237, 237, 234, 237, 237, 237, 237, 237, 237, 237, 239, 241, 241, 241,
241, 242, 242, 242, 242, 242, 242, 246, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 203, 203, 169, 169, 169, 185, 169, 169, 217, 203, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 222,
217, 203, 217, 217, 217, 222, 222, 217, 222, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 234, 237, 237, 237, 237, 237, 237, 237, 241, 241, 242, 241,
242, 242, 242, 242, 244, 242, 246, 246, 246, 246, 248, 243, 243, 243, 243, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 203,
203, 203, 203, 169, 203, 169, 203, 203, 203, 203, 203, 215, 217, 203, 217, 203,
203, 203, 203, 203, 203, 203, 217, 203, 203, 203, 203, 203, 203, 217, 217, 222,
217, 222, 203, 217, 222, 217, 215, 222, 222, 222, 217, 222, 222, 222, 222, 203,
222, 203, 217, 222, 222, 222, 222, 222, 203, 222, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 236, 237, 237, 237, 236, 237, 241, 242, 241,
241, 242, 245, 242, 242, 245, 245, 245, 245, 245, 245, 245, 245, 243, 251, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 203, 185, 169, 169, 215, 169, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 217, 203, 203, 217, 217, 217, 217, 203, 217, 203, 217, 217, 215, 217,
215, 217, 217, 215, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 222,
217, 203, 215, 217, 217, 217, 222, 217, 222, 217, 217, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 222, 222, 222, 217, 222, 222, 222, 222,
222, 217, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 240, 237,
237, 237, 237, 237, 240, 237, 237, 237, 237, 237, 241, 237, 241, 241, 240, 242,
242, 242, 242, 244, 244, 244, 244, 246, 244, 248, 248, 248, 248, 249, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 203, 185, 169, 169, 215, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 217, 203, 203, 217, 217, 217, 217, 203, 217, 203, 217, 217, 217, 217,
215, 217, 222, 217, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 222,
217, 222, 215, 217, 217, 217, 222, 217, 222, 222, 217, 217, 215, 217, 217, 217,
215, 217, 217, 217, 217, 217, 217, 217, 222, 222, 222, 217, 222, 222, 222, 222,
222, 217, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 240, 237,
237, 237, 237, 237, 240, 237, 237, 237, 237, 237, 241, 237, 241, 241, 244, 242,
242, 242, 242, 244, 244, 246, 244, 246, 248, 248, 248, 248, 249, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
203, 203, 203, 169, 169, 217, 203, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
217, 217, 203, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 203, 217, 222, 217, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 237,
222, 222, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 241, 241, 242, 242,
242, 242, 246, 246, 246, 246, 246, 246, 248, 248, 249, 249, 249, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 222, 203, 217, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 222, 217, 217, 217, 222, 222, 222, 222, 222, 217, 222, 217, 222, 217, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 217, 222, 222, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 242, 242, 244, 242,
242, 246, 246, 244, 246, 246, 248, 248, 248, 248, 249, 249, 251, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 203, 169, 203, 203, 203,
203, 203, 203, 217, 217, 217, 203, 217, 203, 217, 203, 215, 217, 217, 217, 203,
217, 203, 203, 203, 203, 217, 217, 217, 222, 203, 203, 203, 222, 217, 217, 222,
217, 222, 203, 217, 222, 217, 215, 222, 222, 222, 217, 222, 222, 222, 222, 222,
222, 203, 217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 247, 247, 242, 246,
246, 246, 245, 246, 246, 246, 246, 245, 249, 249, 249, 251, 251, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 222, 203, 217, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 222, 217, 222, 217, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 247, 237, 237, 237, 237, 247, 247, 247, 247, 247, 244, 246,
246, 246, 246, 246, 246, 246, 248, 248, 248, 249, 249, 251, 251, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 217, 203, 217, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 203, 203, 217, 217, 217, 217, 203, 222, 203, 217, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 247, 247, 247, 247,
247, 237, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 246, 246, 246, 248, 248, 248, 249, 249, 249, 251, 251, 251, 252, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 203, 169, 169, 169, 217, 217, 217, 217, 217, 217, 217, 203, 217, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 222, 203, 217, 217, 217, 217, 203, 222, 222, 222, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 222, 222, 217, 217, 222, 222, 217, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 237, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 249, 250, 251, 251, 251, 252, 252, 253, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 203, 203, 169, 169, 217, 217, 217, 217, 217, 217, 217, 217, 217, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 222, 203, 217, 217, 217, 217, 203, 222, 222, 222, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 222, 222, 217, 217, 222, 222, 217, 222, 222,
222, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 250, 250, 251, 251, 252, 252, 252, 253, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 222, 203, 217, 217, 217, 217, 203, 222, 222, 222, 217, 217, 217,
217, 217, 222, 217, 222, 217, 215, 222, 222, 217, 217, 222, 222, 217, 222, 222,
222, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 250, 250, 250, 252, 252, 252, 253, 253, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 203, 169, 169, 203, 169, 217, 169, 217,
217, 217, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 222,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 222,
217, 222, 222, 222, 203, 217, 217, 217, 217, 222, 222, 222, 222, 217, 217, 222,
217, 222, 222, 217, 222, 217, 215, 222, 222, 222, 217, 222, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 250, 250, 250, 252, 252, 252, 253, 254, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
169, 169, 217, 217, 217, 217, 217, 217, 203, 217, 217, 203, 217, 217, 217, 217,
217, 217, 203, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 222,
222, 203, 222, 217, 217, 217, 222, 217, 217, 217, 222, 217, 217, 217, 217, 222,
222, 222, 222, 222, 203, 217, 217, 222, 222, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 250, 247, 250, 250, 250, 250, 250, 250, 250, 253, 253, 253, 254, 254, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 217, 217, 217, 217, 217, 217, 203,
217, 217, 217, 217, 217, 217, 217, 217, 222, 217, 217, 222, 217, 217, 217, 217,
217, 217, 222, 222, 217, 217, 217, 217, 217, 217, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 250, 247, 250, 250, 250, 250, 250, 253, 253, 254, 254, 254, 254, 254, 255
};

UInt8 *hvqelut_2x2_1[] = {hvqelut_2x2_1a, hvqelut_2x2_1b};

UInt8 hvqelut_4x2_1a[] = {
  0,   1,   1,   1,   4,   1,   1,   1,   1,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   3,   4,   4,   4,   4,  14,  14,  14,  14,
 14,  14,  14,   4,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  25,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  46,  58,  46,  14,  46,  14,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  46,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  46,  46,  58,  46,  46,  46,  46,  58,  58,  46,  58,  46,  58,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  58,  58,  46,  46,
 58,  58, 129, 129, 129,  58, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   1,   3,   1,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,  10,
  4,  10,   4,  11,  10,  13,  13,   3,   4,  13,  13,   4,  11,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  25,  14,  14,  14,  14,  14,  14,  14,
 14,  46,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  46,
 14,  46,  39,  46,  39,  46,  14,  46,  14,  14,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  39,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  46,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  46,  46,  58,  46,  46,  46,  46,  58,  58,  46,  58,  46,  58,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  58, 129, 129, 129,
129, 129, 129, 129, 129,  58, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   3,   5,   4,   5,   5,   6,   6,   6,   6,   6,  10,  10,  13,  13,
 13,  13,  13,  11,  13,  13,  13,   3,  13,  13,  13,  13,  13,  13,  13,  13,
 13,  13,  13,  24,  13,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 30,  14,  14,  14,  14,  30,  14,  14,  14,  33,  14,  14,  14,  14,  14,  39,
 14,  14,  14,  14,  14,  39,  46,  39,  25,  14,  14,  46,  39,  39,  14,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  39,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  46,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  39,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  69,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  46,  46,  58,  46,  69,  46,  46,  58,  58,  69,  58,  46,  58,  46,  46,
 69,  69,  69,  46, 129,  69,  46, 129, 129, 129, 129,  58, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   1,   3,   5,   4,   5,   7,   6,   6,   6,   6,   6,  10,  10,  10,  10,
 13,  13,  13,  11,  13,  13,  13,   3,  13,  13,  13,  17,  17,  17,  13,  13,
 13,  13,  13,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 24,  24,  14,  33,  14,  30,  14,  14,  14,  33,  14,  14,  14,  14,  39,  39,
 14,  14,  14,  14,  14,  39,  46,  39,  25,  14,  33,  46,  39,  39,  14,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  39,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  46,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  39,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  69,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  69,  69,  58,  69,  69,  69,  69,  58,  58,  69,  58,  46,  69,  69,  69,
 69,  69,  69,  46,  69,  69,  69, 129, 129, 129, 129,  58, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   5,   5,   5,   4,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  25,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  46,  46,  46,
 46,  46,  39,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  69,  46,  46,  46,  69,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  69,  58,  46,  46,
 46,  46,  69,  69,  46,  46,  69,  46,  46,  69,  69,  46,  46,  69,  69,  46,
 69,  69,  69,  46,  58,  69,  46,  46,  69,  46,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   6,   6,   4,   6,   7,   8,   8,   8,   8,   8,  10,  10,  10,  10,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  17,  17,  13,  13,
 13,  13,  24,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  39,  39,
 24,  24,  45,  33,  43,  39,  46,  39,  25,  39,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  39,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  69,  46,  46,  69,  46,  46,  46,  58,  46,  46,  58,  69,  46,
 69,  69,  69,  46,  58,  58,  46,  46,  69,  46,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  69,  69,  69,
 69,  69,  69,  69, 129,  69,  69, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   5,   5,   4,   6,   7,   8,   8,   8,   8,   8,  10,  10,  10,  10,
 10,  10,  17,  11,  17,  10,  17,  30,  17,  17,  17,  17,  11,  17,  17,  17,
 17,  13,  17,  17,  17,  17,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  24,  24,  24,  45,  39,
 24,  24,  45,  33,  43,  45,  46,  39,  30,  39,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  69,  46,  46,  69,  58,  46,  46,
 69,  69,  58,  69,  69,  69,  69,  46,  69,  69,  69,  69,  69,  58,  69,  46,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  69,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  69,  69,  69,
 69,  69,  69,  69,  69,  69,  69,  69, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   6,   4,   6,   7,   8,   8,   8,   9,   9,   9,  10,  10,  10,
 13,  10,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  13,  13,
 13,  20,  24,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  33,  24,  33,  33,  30,  24,  30,  39,  39,
 24,  33,  45,  33,  33,  39,  43,  39,  25,  39,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  39,  39,  39,  46,  39,  39,  39,  46,  39,  39,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  58,  46,  61,  46,
 46,  46,  46,  58,  46,  46,  46,  58,  46,  46,  46,  46,  69,  58,  46,  46,
 46,  46,  58,  58,  46,  69,  69,  46,  46,  69,  58,  46,  69,  58,  69,  46,
 69,  69,  69,  46,  58,  58,  46,  46,  69,  46,  69,  58,  46,  69,  69,  69,
 58,  69,  69,  58,  69,  81,  69,  69,  58,  58,  69,  58,  69,  58,  69,  69,
 69,  69,  69,  69, 129,  69,  69, 129, 104, 129, 129,  58, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   6,   6,   6,   8,   7,   8,   8,   8,   8,   8,  10,  10,  10,  10,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  13,  24,
 13,  20,  24,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  39,  39,
 43,  43,  45,  33,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  69,  58,  46,  46,
 46,  46,  58,  69,  69,  69,  69,  46,  69,  69,  69,  46,  69,  58,  69,  46,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  46,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  69,  69,  69,
 69,  69, 129,  69, 129,  81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   6,   6,  10,   8,   8,   8,   8,   8,   9,   9,  10,  10,  10,  13,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  13,  24,
 20,  20,  24,  24,  24,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  39,  39,
 43,  43,  43,  43,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  43,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  46,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  69,  46,  46,  69,  58,  46,  46,
 69,  69,  69,  69,  69,  69,  69,  46,  69,  69,  69,  69,  69,  58,  81,  46,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  69,  69,  81,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  81,  69,  69,
 69, 129, 129,  69, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   6,  10,   8,   7,   8,   8,   9,   9,   9,   9,  10,  12,  13,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  24,  24,
 20,  20,  24,  24,  24,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  43,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  69,  46,  46,  46,  58,  46,  69,  46,  46,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  69,  69,  81,  69,  81,  69,  69,  58,  58,  69,  58,  69,  81,  69,  69,
 81, 129, 129,  69, 129,  81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   6,  10,   8,   7,   9,   9,   9,   9,   9,   9,  12,  12,  13,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  24,  24,
 20,  20,  24,  24,  24,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 34,  24,  24,  33,  24,  30,  33,  30,  24,  33,  24,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  43,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  69,  46,  46,  69,  58,  46,  69,  46,  46,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58, 104,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  69,  69,  81,  69,  81,  69,  69,  58,  58,  81,  58,  69,  81,  69,  69,
 81, 129, 129,  69, 129,  81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   8,  10,   9,   7,   9,   9,   9,   9,   9,  12,  12,  12,  12,
 13,  16,  17,  11,  20,  20,  20,  30,  24,  20,  20,  17,  21,  20,  20,  24,
 20,  20,  24,  24,  24,  24,  24,  24,  24,  24,  24,  30,  24,  24,  30,  30,
 34,  24,  24,  33,  30,  30,  33,  30,  43,  33,  43,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  45,  43,  39,  50,  43,  33,  43,  39,  39,  43,  39,
 43,  46,  46,  43,  43,  43,  46,  43,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  61,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  69,  46,  46,  58,  46,  58,  46,  61,  46,
 46,  46,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58, 104,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  81,  81,  81,  69,  81,  81,  81, 104,  89,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   8,  10,   9,   9,   9,   9,   9,   9,  12,  12,  12,  12,  12,
 13,  20,  17,  11,  20,  20,  20,  30,  24,  20,  20,  17,  21,  20,  20,  24,
 20,  20,  24,  24,  24,  24,  24,  24,  24,  24,  24,  30,  24,  24,  30,  30,
 34,  24,  24,  33,  43,  30,  33,  30,  43,  33,  43,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  45,  43,  39,  25,  43,  33,  43,  39,  39,  43,  39,
 43,  46,  46,  43,  43,  43,  46,  43,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  61,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  69,  46,  46,  58,  46,  69,  46,  61,  46,
 46,  46,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58, 104,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  81,  81,  81,  69,  81,  81,  81, 104,  89,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   8,   8,  10,   9,  15,   9,  15,  15,  15,  15,  15,  15,  15,  16,
 20,  16,  17,  17,  21,  20,  20,  30,  20,  20,  20,  17,  21,  20,  20,  20,
 20,  20,  24,  24,  24,  24,  27,  24,  24,  24,  34,  30,  24,  24,  30,  30,
 34,  34,  34,  33,  43,  30,  33,  43,  43,  33,  43,  30,  43,  43,  45,  33,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  33,  43,  39,  45,  43,  39,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  46,  46,  46,  46,  39,  46,
 46,  46,  61,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  69,  69,  69,  69,  69,  46,  58,  69,  89,  69,  61,  69,
 46,  46,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  81,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69, 104, 104,  69,  69,  69,  89,  69,  81,  69,  81,  69,  69,
 89,  81,  81,  81,  81,  81,  81,  81, 104,  89,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   8,   9,  10,   9,  15,   9,  15,  12,  15,  15,  15,  16,  16,  16,
 20,  16,  17,  17,  20,  20,  20,  30,  20,  20,  20,  17,  21,  27,  20,  20,
 20,  20,  27,  24,  24,  24,  27,  24,  24,  24,  34,  30,  34,  34,  30,  30,
 34,  34,  43,  33,  43,  30,  33,  43,  43,  33,  43,  30,  43,  43,  45,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  33,  43,  39,  45,  43,  39,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  46,  46,  46,  46,  65,  46,
 46,  46,  61,  46,  45,  46,  65,  46,  39,  65,  46,  46,  46,  46,  69,  46,
 46,  46,  46,  46,  69,  69,  69,  69,  69,  46,  58,  69,  89,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  81,  69,  69,  69,  69,  69,  69,  69,  81,  69,  69,  58,  81,  69,
 69,  81,  69,  69, 104, 104,  69,  69,  81,  89,  69,  81,  69,  81,  81,  69,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  10,   9,  15,  12,  12,  12,  12,  12,  16,  16,  16,  16,
 20,  20,  17,  17,  20,  20,  20,  50,  20,  20,  20,  17,  27,  27,  26,  26,
 26,  26,  26,  24,  34,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  43,  30,  43,  30,  43,  43,  43,  33,  43,  30,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  45,  50,  43,  43,  43,  39,  45,  43,  43,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  46,  65,  46,
 46,  46,  61,  46,  45,  46,  65,  46,  69,  65,  46,  69,  46,  46,  69,  46,
 69,  46,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  89,  69,  58,  69,  46,
 69,  69,  81,  69,  69,  69,  81,  69,  69,  69,  81,  69,  69,  81,  81,  69,
 69,  81,  69,  69, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  69,  81,  81,  81,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  10,  15,  15,  15,  15,  15,  15,  15,  15,  15,  16,  16,
 20,  16,  17,  17,  21,  20,  20,  50,  26,  26,  26,  17,  27,  27,  26,  26,
 26,  26,  26,  24,  27,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  34,  33,  43,  30,  33,  43,  43,  33,  43,  30,  43,  43,  45,  33,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  33,  43,  39,  45,  43,  39,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  65,  46,
 46,  46,  61,  46,  45,  46,  65,  46,  65,  65,  46,  69,  46,  46,  69,  46,
 69,  46,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  89,  69,  69,  69,  58,  69,  69,  69,  89,  69,  58,  69,  46,
 69,  69,  83,  69,  69,  69,  81,  69,  69,  69,  81,  69,  69,  58,  81,  69,
 69,  81,  69,  69, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81, 104,  81,  81,  81,  81, 104, 114,  81, 104,  69, 104,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   6,   9,   9,  10,  12,  15,  12,  12,  12,  12,  16,  16,  16,  16,  20,
 20,  20,  17,  17,  20,  20,  20,  30,  20,  20,  27,  17,  27,  27,  27,  34,
 34,  34,  34,  24,  34,  34,  34,  34,  34,  34,  34,  30,  34,  34,  30,  43,
 34,  43,  43,  43,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  43,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  46,  46,  46,  46,  69,  46,
 46,  46,  61,  46,  45,  69,  69,  46,  69,  69,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  69,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  69,  81,  58,  69,  46,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  69,  81,  81,  69,
 81,  81,  81,  69, 104,  81,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81,  81,  81,  81,  81,  81,  81, 114,  81, 104,  81,  81,  81,  81,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   7,   9,  15,  15,  15,   7,  15,  15,  15,  15,  21,  21,  21,  21,  21,
 21,  21,  21,  11,  21,  21,  21,  30,  21,  21,  27,  21,  32,  27,  27,  27,
 27,  27,  27,  24,  27,  27,  32,  27,  27,  32,  34,  34,  34,  34,  30,  34,
 34,  34,  43,  33,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  45,  45,
 43,  43,  56,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  45,
 43,  46,  43,  43,  43,  43,  43,  56,  45,  43,  43,  43,  45,  46,  67,  46,
 69,  46,  61,  69,  45,  69,  45,  69,  45,  69,  46,  69,  69,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  69,  69,  61,  69,
 69,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  69,  81,  58,  69,  69,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  69,  81,  81,  69,
 81,  81,  81,  69, 104, 104,  69,  69,  81,  69,  81,  81,  69,  81,  81,  81,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  81,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  15,  15,  15,  15,  15,  15,  15,  15,  15,  15,  21,  21,
 20,  21,  17,  17,  21,  21,  21,  30,  26,  27,  27,  27,  27,  27,  27,  27,
 27,  27,  27,  24,  27,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  34,
 34,  34,  34,  33,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  45,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  45,  67,  67,  46,
 46,  46,  61,  46,  45,  69,  65,  46,  65,  65,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  89,  81,  58,  69,  46,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  69, 104,  81,  69,
 81,  81,  81,  69, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  81,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  15,  15,  15,  15,  15,  15,  15,  15,  16,  16,  16,  16,
 23,  23,  20,  17,  21,  23,  23,  50,  26,  26,  26,  27,  27,  27,  26,  26,
 26,  26,  27,  24,  34,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  30,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 46,  46,  61,  46,  45,  69,  65,  46,  65,  65,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  89,  69,  69,  69,  58,  69,  69,  69,  89,  81,  58,  69,  46,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  81, 104,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  15,  15,  15,  15,  22,  15,  15,  15,  15,  16,  16,  23,  23,
 23,  23,  26,  21,  21,  23,  23,  50,  26,  26,  26,  27,  27,  27,  26,  26,
 26,  28,  27,  24,  34,  34,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 43,  46,  61,  69,  61,  69,  65,  46,  65,  65,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  58,  69,  69,  69,  89,  81,  58,  69,  46,
 69,  69,  83,  81,  69,  81,  81,  69,  81,  81,  81,  69,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114,  81, 104,  81, 104, 114,  81,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,  25,   3,   3,   3,  22,   3,   3,   3,   3,   3,   3,   3,  50,  50,
 50,  50,  50,  26,  50,  50,  50,  25,  50,  50,  50,  50,  31,  50,  50,  50,
 50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  25,  50,
 50,  50,  50,  50,  50,  25,  50,  50,  50,  75,  75,  50,  50,  50,  75,  75,
 75,  75,  47,  75,  75,  75,  75,  75,  77,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  61,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  61,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  81,  75,
 75,  75,  75,  75, 104, 104,  75,  75,  75,  75,  75, 114,  75, 114,  75, 114,
 75, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   8,  12,  15,  15,  15,  15,  16,  16,  16,  16,  16,  16,  16,  23,  23,
 23,  23,  26,  21,  23,  23,  26,  50,  26,  26,  26,  27,  27,  27,  27,  34,
 34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  30,  34,  34,  30,  34,
 34,  34,  43,  43,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  43,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 69,  46,  61,  69,  61,  69,  65,  69,  69,  65,  46,  69,  69,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  81,  81,  81,  81,  81,  69,  81,  81,  81,  69,  81,  81,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81,  81,  81,  81,  81,  81, 114, 114,  81, 104,  81, 114, 114, 114,
114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  15,  22,  22,  22,  22,  22,  16,  16,  23,  23,
 23,  23,  26,  21,  23,  23,  26,  50,  26,  26,  26,  27,  27,  27,  26,  31,
 31,  28,  31,  38,  34,  34,  27,  34,  34,  34,  34,  30,  34,  34,  30,  34,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  43,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 67,  46,  61,  69,  61,  69,  65,  69,  65,  65,  46,  69,  67,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  83,  81,  81,  81,  81,  69,  81,  81,  81,  81,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  15,  22,  22,  22,  22,  22,  22,  22,  23,  23,
 23,  23,  26,  21,  23,  23,  26,  50,  26,  26,  28,  27,  27,  27,  28,  31,
 28,  28,  31,  38,  34,  38,  27,  34,  34,  38,  34,  30,  34,  34,  30,  34,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  49,  43,  43,  48,  45,
 43,  43,  56,  43,  43,  45,  43,  45,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  67,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 67,  46,  61,  69,  61,  67,  65,  67,  65,  65,  69,  69,  67,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  83,  81,  81,  81,  81,  69,  81,  81,  81,  81,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114, 114, 104,  81, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   8,  22,  15,  15,  15,  21,  15,  15,  15,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  27,  27,  50,  27,  27,  27,  27,  32,  27,  27,  27,
 27,  27,  27,  38,  34,  34,  27,  34,  34,  34,  34,  34,  34,  34,  30,  34,
 34,  34,  43,  43,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  56,  45,
 43,  43,  56,  43,  43,  56,  43,  45,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  56,  43,  43,  43,  56,  67,  67,  46,
 69,  69,  61,  69,  61,  69,  65,  69,  69,  65,  69,  69,  69,  69,  69,  69,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  69,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81,  81,  81,  81,  81,  81,
114,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  81,  81,  81,  81,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 21,  21,  21,  32,  32,  32,  32,  50,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  38,  38,  38,  30,  38,
 32,  38,  38,  33,  38,  30,  48,  38,  48,  33,  48,  49,  48,  49,  56,  45,
 48,  48,  56,  48,  48,  56,  48,  45,  50,  48,  67,  56,  45,  45,  48,  67,
 67,  56,  49,  67,  56,  56,  67,  56,  56,  67,  56,  67,  56,  67,  67,  46,
 67,  56,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  56,  67,  67,
 65,  56,  67,  67,  67,  65,  67,  65,  67,  69,  83,  69,  67,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  83,  83,  81,  81,  81,  69,  81,  81,  83,  81,  81, 104,  83,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
 89,  81,  81, 104,  81, 104,  81,  81, 104, 114, 104, 104,  81, 104,  81,  81,
104, 104, 114, 129, 129, 120, 129, 129, 104, 129, 129, 129, 104, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  22,  22,  22,  22,  22,  22,  22,  22,  21,  23,
 23,  23,  21,  32,  21,  28,  28,  50,  28,  28,  28,  27,  32,  27,  28,  28,
 28,  28,  27,  38,  36,  38,  32,  34,  38,  38,  34,  38,  34,  38,  30,  34,
 34,  38,  38,  49,  43,  30,  48,  43,  43,  33,  48,  49,  43,  49,  56,  45,
 43,  43,  56,  43,  43,  56,  43,  45,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  67,  43,  56,  43,  43,  67,  56,  67,  67,  46,
 67,  43,  61,  69,  61,  67,  65,  67,  65,  65,  69,  69,  67,  69,  69,  89,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  81,  81,  83,  69,  81,  69,  89,  81,  58,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114, 114, 104,  81, 104, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  23,
 23,  23,  26,  21,  28,  28,  28,  50,  26,  28,  28,  27,  28,  28,  28,  31,
 28,  28,  31,  38,  31,  38,  27,  34,  38,  38,  34,  38,  38,  38,  30,  38,
 34,  38,  38,  49,  49,  30,  48,  49,  48,  33,  48,  49,  43,  49,  48,  45,
 43,  43,  56,  43,  43,  56,  43,  45,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  67,  43,  56,  43,  43,  67,  43,  67,  67,  46,
 67,  43,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  65,  89,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  69,  81,  69,  89,  81,  58,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
114,  81,  81, 104, 114,  81, 114,  81, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 129, 114, 129, 129, 129, 129, 129, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  23,
 23,  28,  26,  21,  28,  28,  28,  50,  28,  28,  28,  27,  28,  28,  28,  31,
 31,  31,  31,  38,  31,  38,  36,  31,  38,  38,  34,  38,  38,  38,  30,  38,
 34,  38,  38,  49,  49,  30,  49,  49,  49,  33,  48,  49,  49,  49,  48,  48,
 49,  49,  56,  49,  49,  48,  43,  48,  50,  43,  67,  43,  65,  45,  43,  65,
 43,  43,  49,  43,  43,  43,  49,  43,  56,  43,  43,  67,  43,  67,  67,  46,
 67,  43,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  65,  89,
 69,  69,  69,  69,  69,  69,  69,  65,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69, 114,  81,  89,  81, 104,  81,  81,  81, 114,
114,  81,  81, 104, 114, 104, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 114, 114, 129, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 22,  22,  26,  32,  28,  28,  28,  50,  28,  28,  28,  28,  32,  28,  28,  36,
 36,  36,  36,  38,  36,  38,  36,  36,  38,  38,  36,  38,  38,  38,  30,  38,
 44,  38,  38,  49,  49,  30,  48,  49,  48,  33,  48,  49,  44,  49,  48,  48,
 48,  49,  56,  48,  49,  48,  49,  48,  50,  49,  67,  49,  65,  45,  49,  65,
 49,  53,  49,  49,  49,  49,  67,  48,  56,  67,  67,  67,  65,  67,  67,  70,
 67,  70,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  65,  67,
 65,  69,  67,  67,  67,  65,  67,  65,  67,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  89,  81,  81,  81,  81,  81,  89,  83,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104,  69, 114,  81,  89,  81, 104,  81,  81,  81, 114,
114,  81,  81, 104, 114, 104, 114, 114, 104, 114, 114, 104, 114, 104, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 22,  22,  22,  32,  22,  22,  29,  50,  28,  28,  28,  28,  32,  28,  36,  36,
 36,  36,  36,  38,  36,  36,  36,  36,  38,  38,  36,  38,  38,  38,  30,  38,
 42,  38,  38,  49,  38,  47,  48,  49,  48,  33,  48,  49,  44,  49,  48,  48,
 48,  48,  48,  48,  49,  48,  49,  63,  50,  49,  67,  49,  65,  45,  49,  65,
 67,  53,  49,  67,  49,  49,  67,  48,  56,  67,  67,  67,  65,  67,  67,  70,
 67,  67,  61,  67,  61,  65,  65,  67,  65,  65,  67,  67,  67,  65,  65,  67,
 65,  56,  67,  67,  65,  65,  67,  65,  67,  89,  83,  65,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  89,  83,  69,  89,  83, 104,  81,  69,
 81,  81,  83,  83,  81,  81,  81,  81,  81,  89,  83,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104,  69,  89,  81,  89,  81, 104,  81,  81,  81, 114,
 89, 104,  81, 104, 114, 104, 114, 104, 104, 114, 104, 104, 114, 104, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 114, 114, 104, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 28,  28,  26,  32,  28,  28,  28,  50,  28,  28,  28,  27,  32,  28,  36,  36,
 36,  36,  36,  38,  36,  38,  36,  36,  38,  38,  37,  38,  38,  38,  30,  38,
 44,  38,  48,  49,  49,  49,  48,  49,  48,  33,  48,  49,  49,  49,  48,  48,
 48,  49,  56,  48,  49,  56,  49,  48,  50,  49,  67,  43,  65,  45,  49,  65,
 49,  43,  49,  49,  43,  43,  49,  43,  56,  67,  43,  67,  56,  67,  67,  70,
 67,  70,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  67,  89,
 69,  69,  69,  69,  69,  69,  69,  65,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69, 114,  81,  89,  81, 104,  81,  81,  81, 114,
114,  81,  81, 104, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 114, 114, 129, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  15,  22,  21,  22,  22,  22,  23,  23,  23,  23,  23,  23,
 28,  28,  26,  27,  28,  28,  28,  50,  31,  31,  28,  27,  27,  34,  34,  34,
 34,  34,  34,  38,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  30,  49,
 34,  43,  43,  49,  43,  49,  43,  43,  43,  43,  43,  49,  43,  43,  43,  48,
 43,  43,  56,  43,  43,  56,  43,  43,  50,  43,  49,  43,  45,  45,  43,  43,
 43,  84,  43,  43,  43,  43,  49,  43,  56,  43,  43,  43,  43,  67,  67,  84,
 69,  84,  61,  69,  61,  69,  65,  69,  65,  65,  84,  69,  89,  69,  69,  89,
 69,  69,  69,  69,  69,  81,  69,  81,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  84,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,
 81,  81,  81,  81, 104, 104, 107, 114,  81, 114,  81,  81, 107,  81, 114, 114,
114,  81,  81, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,
 29,  29,  28,  32,  28,  28,  28,  50,  28,  28,  28,  28,  32,  36,  36,  36,
 36,  36,  36,  38,  36,  38,  36,  37,  38,  38,  37,  38,  38,  38,  30,  38,
 44,  38,  48,  49,  49,  47,  48,  49,  48,  48,  48,  49,  53,  49,  48,  48,
 48,  49,  56,  48,  49,  56,  49,  48,  50,  49,  67,  49,  65,  45,  49,  65,
 49,  70,  49,  49,  49,  49,  49,  48,  56,  67,  70,  67,  56,  67,  67,  70,
 67,  70,  61,  67,  61,  67,  65,  67,  65,  65,  80,  67,  67,  69,  67,  89,
 69,  69,  69,  67,  69,  81,  69,  65,  67,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104, 107, 114,  81,  89,  81, 104,  81,  81, 114, 114,
114, 114,  81, 104, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  28,
 28,  28,  28,  32,  28,  28,  28,  50,  28,  28,  28,  27,  32,  36,  36,  31,
 37,  37,  37,  38,  37,  38,  37,  34,  38,  38,  34,  38,  38,  38,  30,  49,
 44,  48,  48,  49,  49,  49,  48,  49,  48,  48,  48,  49,  49,  49,  48,  48,
 48,  49,  56,  48,  49,  56,  43,  48,  50,  43,  49,  43,  45,  45,  43,  67,
 43,  84,  49,  43,  43,  43,  49,  43,  56,  43,  43,  67,  56,  67,  67,  84,
 67,  70,  61,  69,  61,  67,  65,  67,  65,  65,  69,  69,  67,  69,  69,  89,
 69,  69,  69,  69,  69,  81,  69,  81,  69,  69,  83,  81,  89,  81,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  84,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104, 107, 114,  81, 114,  81,  81, 107,  81, 114, 114,
114, 114,  81, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,
 28,  29,  32,  32,  32,  32,  32,  50,  32,  32,  32,  32,  32,  32,  32,  36,
 32,  32,  32,  38,  32,  32,  32,  36,  38,  32,  36,  38,  38,  38,  30,  44,
 44,  48,  48,  49,  48,  49,  48,  48,  48,  48,  48,  49,  44,  49,  56,  56,
 48,  48,  56,  48,  48,  56,  48,  56,  50,  48,  67,  56,  45,  56,  48,  67,
 56,  56,  49,  67,  56,  56,  67,  56,  56,  56,  56,  67,  56,  67,  67,  80,
 67,  80,  61,  67,  61,  67,  65,  67,  65,  65,  80,  67,  67,  56,  67,  67,
 69,  56,  67,  67,  69,  81,  69,  65,  67,  69,  83,  81,  89,  81,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  83,  81,
 81,  81,  81, 107, 104, 104, 107,  81,  81,  89,  81, 104, 107,  81,  81,  81,
114,  81,  81, 104, 114, 120, 114, 120, 104, 114, 114, 104, 107, 104, 114, 114,
114, 114, 114, 107, 114, 120, 129, 129, 104, 129, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,
 29,  29,  28,  32,  29,  29,  29,  50,  36,  36,  36,  36,  32,  36,  36,  37,
 37,  37,  37,  38,  37,  38,  37,  37,  38,  38,  37,  38,  44,  44,  47,  44,
 44,  44,  48,  49,  49,  47,  48,  49,  48,  48,  48,  49,  53,  49,  48,  48,
 48,  48,  56,  48,  49,  56,  49,  48,  50,  49,  67,  49,  65,  56,  49,  67,
 49,  70,  49,  49,  70,  70,  49,  70,  56,  70,  70,  67,  56,  67,  67,  70,
 67,  80,  61,  80,  61,  67,  65,  67,  65,  65,  80,  67,  67,  80,  67,  89,
 80,  80,  67,  67,  67,  81,  67,  65,  67,  89,  83,  81,  89,  81,  61,  81,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  89,  81,  81,  81,  81,  81,  89,  81,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104, 107, 114, 114, 114,  81, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,
 29,  29,  28,  32,  29,  29,  29,  50,  37,  37,  37,  37,  32,  37,  37,  37,
 37,  37,  37,  38,  37,  37,  37,  37,  44,  44,  44,  38,  44,  44,  47,  44,
 44,  44,  48,  49,  49,  47,  48,  49,  48,  48,  48,  49,  53,  49,  48,  48,
 48,  48,  56,  48,  49,  56,  49,  48,  50,  49,  49,  70,  65,  56,  49,  67,
 70,  84,  70,  70,  70,  70,  49,  70,  56,  70,  70,  70,  80,  67,  67,  84,
 80,  80,  61,  80,  61,  80,  65,  80,  65,  65,  80,  67,  67,  80,  67,  89,
 80,  80,  80,  67,  81,  81,  81,  65,  89,  89,  83,  81,  89,  81,  61,  81,
 69,  81,  81,  89,  81,  81,  81,  83,  81,  81,  89,  89,  81, 104,  81,  84,
 81,  81,  83,  89,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  83, 107,
 81,  81,  81, 107, 104, 104, 107, 114, 114, 114, 107, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,
 29,  29,  32,  32,  32,  32,  32,  50,  32,  32,  32,  32,  32,  32,  32,  37,
 32,  32,  32,  38,  32,  32,  32,  37,  44,  32,  44,  44,  44,  44,  47,  44,
 44,  44,  48,  49,  48,  49,  48,  48,  48,  48,  48,  49,  53,  49,  56,  56,
 48,  48,  56,  48,  48,  56,  48,  56,  50,  56,  67,  56,  56,  56,  56,  67,
 56,  84,  70,  70,  56,  56,  67,  56,  56,  56,  56,  56,  56,  67,  67,  84,
 80,  80,  61,  80,  56,  80,  67,  80,  65,  65,  80,  67,  67,  56,  67,  89,
 80,  56,  80,  67,  81,  81,  81,  81,  81,  69,  83,  81,  89,  81,  61,  81,
 69,  81,  81,  89,  81,  81,  81,  83,  81,  81, 107,  89,  81, 104,  81, 107,
 81,  81,  83,  81,  81,  81,  81, 107,  81,  81,  81, 107, 107, 104, 120, 107,
107, 107, 107, 107, 104, 104, 107, 107, 107, 114, 107, 120, 107, 107, 107, 107,
114, 107, 107, 120, 107, 120, 107, 120, 104, 114, 114, 104, 107, 120, 114, 120,
120, 114, 114, 107, 114, 120, 107, 114, 120, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  36,  29,  29,  32,  32,  37,  37,  37,
 42,  42,  37,  38,  42,  37,  37,  42,  42,  44,  42,  42,  44,  44,  47,  44,
 44,  44,  53,  49,  53,  59,  48,  49,  53,  48,  48,  49,  53,  47,  48,  63,
 53,  48,  56,  48,  49,  63,  53,  63,  50,  48,  67,  53,  63,  63,  49,  67,
 70,  64,  70,  70,  70,  70,  49,  70,  56,  70,  70,  70,  80,  67,  67,  80,
 80,  80,  61,  80,  61,  80,  65,  80,  65,  65,  80,  67,  67,  80,  67,  89,
 80,  80,  80,  67,  67,  65,  67,  65,  67,  80,  83,  67,  89,  81,  61,  81,
 80,  89,  81,  89,  81,  81,  81,  83,  89,  89,  89,  89,  81, 104,  81,  84,
 81,  89,  83,  89,  81,  81,  81,  81,  81,  89, 104,  89,  81, 104,  83,  81,
 81,  81,  81, 107, 104, 104, 107, 114, 114, 114, 114, 104, 107, 114, 114, 114,
114, 114, 114, 104, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 114, 114, 114, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,
 29,  29,  28,  32,  29,  29,  29,  50,  37,  37,  37,  37,  37,  37,  37,  37,
 37,  42,  37,  38,  42,  37,  37,  42,  42,  44,  44,  47,  44,  44,  47,  47,
 47,  49,  49,  49,  49,  59,  49,  49,  49,  49,  48,  49,  47,  47,  48,  48,
 49,  49,  48,  49,  49,  48,  49,  63,  50,  70,  49,  70,  63,  63,  70,  65,
 70,  84,  70,  70,  70,  70,  75,  70,  56,  70,  70,  70,  70,  75,  67,  84,
 70,  70,  61,  80,  61,  80,  65,  70,  65,  65,  84,  67,  89,  80,  67,  75,
 80,  84,  80,  89,  89,  81,  89,  89,  89,  84,  83,  89,  89,  81,  61,  89,
 84,  89,  81,  89,  81,  81,  81,  83,  89,  89,  89,  89,  81, 104,  81,  84,
 81,  89,  83,  89,  81,  81,  81,  81,  81,  89,  89,  89,  81, 104,  81,  81,
114,  81, 114, 107, 104, 104, 112, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  37,  37,  37,  37,  32,  37,  37,  42,
 42,  42,  42,  38,  42,  42,  42,  42,  42,  44,  44,  42,  44,  44,  47,  44,
 44,  44,  53,  49,  53,  59,  48,  49,  53,  48,  48,  49,  53,  47,  48,  63,
 53,  48,  56,  48,  49,  56,  53,  63,  50,  70,  67,  70,  63,  63,  70,  67,
 70,  64,  70,  70,  70,  70,  70,  70,  56,  70,  70,  80,  80,  67,  67,  80,
 80,  80,  61,  80,  61,  80,  65,  80,  65,  65,  80,  80,  67,  80,  67,  89,
 80,  80,  80,  80,  80,  80,  80,  65,  89,  80,  83,  81,  89,  81,  61,  81,
 84,  89,  81,  89,  81,  81,  81,  83,  89,  81,  89,  89,  81, 104,  81,  84,
 81,  81,  83,  89,  81,  81,  81, 107,  81,  89,  89,  89,  81, 104, 120, 107,
 81,  81, 114, 107, 104, 104, 107, 114, 114, 114, 107, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  29,  22,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  37,  37,  37,  37,  32,  37,  42,  42,
 42,  42,  42,  42,  42,  42,  42,  42,  44,  44,  44,  42,  44,  44,  47,  44,
 44,  53,  53,  49,  53,  59,  48,  53,  53,  48,  48,  49,  53,  47,  48,  63,
 53,  53,  56,  48,  49,  56,  53,  63,  50,  70,  49,  70,  63,  63,  70,  67,
 70,  64,  70,  70,  70,  70,  70,  70,  56,  70,  70,  80,  80,  67,  67,  84,
 80,  80,  61,  80,  56,  80,  65,  80,  65,  65,  80,  80,  67,  80,  80,  89,
 80,  80,  80,  80,  80,  80,  80,  65,  89,  80,  83,  80,  89,  81,  61,  81,
 84,  89,  81,  89,  81,  81,  81,  83,  89,  81,  89,  89,  81, 104,  81,  84,
 81,  81,  83,  89,  81,  81,  81, 107,  81,  89,  89,  89,  81, 104, 120, 107,
107, 107, 114, 107, 104, 104, 107, 114, 114, 114, 107, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  29,  29,  29,  29,  50,  31,  47,  47,  42,  29,  47,  47,  47,
 47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  59,  47,  47,  50,  59,
 47,  47,  59,  59,  59,  50,  59,  59,  59,  59,  59,  59,  47,  59,  63,  63,
 59,  59,  47,  59,  59,  63,  59,  63,  25,  59,  75,  59,  63,  63,  59,  59,
 59,  59,  75,  75,  59,  59,  75,  59,  63,  75,  75,  75,  70,  75,  75,  75,
 75,  75,  61,  75,  63,  75,  65,  75,  65,  75,  75,  75,  75,  80,  75,  75,
 75,  80,  75,  75,  75,  75,  75,  89,  75,  75,  83,  75,  75,  84,  61,  75,
 75,  75,  89,  89,  89, 101,  89,  89,  89,  89,  75,  75,  81,  89,  89,  75,
 89,  89,  89,  89,  89,  89, 114, 114,  89,  89,  89,  89, 114,  89,  83, 114,
114, 114, 114, 114, 104, 104, 112, 114, 114, 126, 114, 114, 114, 114, 114, 114,
126, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
114, 114, 114, 129, 114, 114, 129, 126, 129, 126, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  29,  22,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  29,  29,  29,  29,  50,  42,  29,  42,  42,  29,  42,  42,  42,
 42,  42,  42,  42,  42,  42,  42,  42,  42,  44,  42,  47,  44,  44,  59,  47,
 47,  53,  53,  49,  47,  59,  53,  53,  53,  63,  53,  59,  47,  47,  63,  63,
 53,  53,  55,  53,  70,  63,  70,  63,  50,  70,  59,  70,  63,  63,  70,  63,
 70,  64,  59,  70,  70,  70,  59,  70,  63,  70,  70,  70,  80,  70,  67,  80,
 80,  80,  61,  80,  63,  80,  65,  80,  65,  65,  80,  80,  80,  80,  80,  75,
 80,  80,  80,  80,  80,  80,  80, 101,  89, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101,  89,  83,  89,  89, 103,  89,  81, 104,  89,  84,
 89,  89,  83,  89,  89,  89,  81, 112,  89,  89,  89,  89, 114, 104, 120, 112,
114, 114, 114, 112, 104, 104, 112, 114, 114, 114, 114, 104, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  35,  35,  35,  35,  50,  35,  35,  35,  35,  35,  35,  35,  51,
 51,  35,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  51,
 51,  51,  51,  82,  51,  59,  82,  82,  51,  82,  82,  59,  55,  47,  63,  82,
 55,  82,  63,  82,  82,  63,  55,  82,  50,  82,  82,  64,  82,  82,  82,  82,
 82,  64,  59,  82,  82,  82,  82,  82,  63,  82,  82,  82,  82,  82,  82,  80,
 82,  82,  61,  82,  63,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,
 82,  80,  82,  82,  82,  82,  82,  82,  82,  80,  83,  82,  82,  80,  61, 101,
 80, 101, 101,  82, 101, 101, 101,  83, 101, 101, 101,  89, 101, 104, 101, 103,
101, 101,  83,  83, 101, 101, 101, 101, 101, 101, 104,  89, 101, 104,  83, 101,
101, 101, 101, 120, 104, 104, 103, 114, 134,  89, 134, 104, 101, 134, 134, 134,
114, 134, 134, 104, 134, 120, 134, 134, 104, 134, 134, 104, 134, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 129, 134,
129, 169, 129, 129, 129, 129, 129, 129, 129, 169, 129, 129, 169, 129, 129, 129,
129, 129, 129, 169, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  22,  22,  22,  22,  35,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  29,  42,  42,  42,
 42,  42,  42,  42,  42,  42,  42,  42,  44,  44,  44,  42,  44,  44,  47,  47,
 54,  53,  53,  49,  53,  59,  53,  53,  53,  48,  53,  47,  55,  47,  63,  63,
 53,  53,  68,  53,  62,  63,  62,  63,  50,  70,  70,  62,  63,  63,  70,  70,
 70,  64,  70,  70,  70,  70,  70,  70,  56,  80,  80,  80,  80,  70,  67,  84,
 80,  80,  61,  80,  56,  80,  65,  80,  80,  65,  80,  80,  80,  80,  80,  80,
 80,  80,  80,  80,  80,  80,  80, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 107, 101,  83,  89, 101, 103,  89,  81, 104, 101,  84,
101, 107,  83,  89, 107, 107, 107, 107, 107,  89,  89,  89, 107, 104, 120, 107,
107, 107, 107, 107, 104, 104, 112, 114, 114, 114, 107, 120, 107, 114, 114, 114,
114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 129,
114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  35,  35,  22,  35,  35,  35,  35,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  29,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  42,  42,  44,  44,  44,  42,  44,  44,  59,  47,
 54,  53,  53,  53,  53,  59,  53,  53,  53,  63,  53,  47,  55,  47,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  70,  70,  62,  63,  63,  70,  70,
 70,  73,  70,  70,  70,  70,  70,  80,  68,  80,  80,  80,  80,  70,  67,  80,
 80,  80,  61,  80,  63,  80,  65,  80,  80,  65,  80,  80,  80,  80,  80,  80,
 80,  80,  80,  80,  80, 101,  80, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101, 101,  83, 101, 101, 103,  89, 107, 104, 101,  84,
101, 107,  83,  89, 107, 107, 107, 107, 107,  89,  89,  89, 107, 104, 120, 107,
107, 107, 107, 107, 104, 104, 112, 114, 114, 114, 107, 120, 107, 114, 114, 114,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 114, 150,
114, 129, 150, 150, 129, 129, 129, 129, 129, 129, 129, 129, 150, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  37,  29,  29,  29,  42,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  44,  44,  44,  44,  47,  47,  47,  53,  59,  47,
 54,  53,  53,  49,  47,  59,  53,  53,  53,  49,  53,  59,  47,  47,  63,  63,
 70,  70,  62,  70,  70,  70,  70,  63,  50,  70,  70,  70,  63,  63,  70,  70,
 70,  84,  70,  70,  70,  70,  75,  70,  63,  70,  70,  70,  80,  70,  67,  84,
 80,  84,  61,  84,  80,  80,  65,  84,  80,  80,  84,  80,  84,  84,  80,  75,
 84,  84,  84,  84,  84, 101,  84, 101, 103,  84,  83, 103,  89,  84,  61,  84,
 84,  84, 112,  89, 112, 112, 112,  89, 112, 112, 112,  89, 107, 104, 112,  84,
112, 112, 112,  89, 112, 112, 112, 112, 112, 114, 114, 114, 112, 114, 120, 112,
112, 112, 114, 112, 104, 104, 112, 114, 114, 126, 112, 114, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 129,
114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  29,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  42,  42,  42,  44,  42,  47,  55,  55,  59,  47,
 54,  55,  55,  53,  55,  59,  53,  53,  55,  63,  62,  59,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  70,  70,  64,  63,  63,  70,  63,
 70,  73,  70,  70,  70,  70,  59,  80,  63,  80,  80,  80,  80,  70,  67,  80,
 80,  80,  61,  80,  63,  80,  65,  80,  80,  65,  80,  80,  80,  80,  80,  98,
 80,  80,  80,  80, 101, 101, 101, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101, 101,  83, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101,  83,  89, 101, 101, 107, 112, 112,  89,  89,  89, 112, 104, 120, 112,
112, 120, 114, 107, 104, 104, 112, 114, 114, 126, 112, 120, 112, 114, 114, 114,
114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114,
114, 114, 150, 150, 150, 129, 150, 129, 150, 129, 129, 129, 150, 129, 129, 129,
129, 169, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  47,  47,  47,  47,  47,  52,  47,  47,  47,  47,  59,  47,  59,  50,  59,
 47,  59,  59,  59,  59,  50,  59,  59,  59,  59,  59,  59,  59,  59,  63,  63,
 59,  59,  63,  59,  59,  63,  59,  63,  25,  59,  87,  59,  63,  63,  59,  59,
 59,  59,  75,  87,  59,  59,  75,  59,  63,  87,  87,  75,  63,  75,  75,  75,
 75,  75,  63,  75,  63,  75,  75,  75,  98,  75,  75,  75,  75,  98,  75,  75,
 98,  98,  75,  75,  75,  98,  75, 101,  75,  75,  83,  75,  75,  98, 108,  75,
105,  75,  75,  75, 101, 101,  89,  89,  89,  89,  75,  75, 101, 104,  89, 105,
 89,  89,  89,  89,  89, 114, 114, 112, 114, 114, 114, 126, 114, 114, 104, 114,
114, 114, 114, 112, 104, 104, 112, 126, 114, 126, 114, 114, 114, 114, 114, 114,
126, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 126, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
126, 114, 114, 114, 114, 114, 114, 126, 114, 126, 126, 129, 129, 129, 126, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  22,  29,  29,  22,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  42,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  44,  44,  44,  44,  44,  44,  47,  44,  53,  59,  47,
 54,  53,  53,  49,  53,  59,  53,  53,  53,  48,  62,  47,  64,  64,  62,  63,
 62,  62,  68,  62,  70,  63,  70,  63,  50,  70,  70,  70,  63,  63,  70,  70,
 70,  84,  70,  70,  70,  70,  70,  80,  68,  80,  80,  80,  80,  70,  67,  84,
 80,  80,  61,  80,  80,  80,  67,  80,  80,  80,  84,  80,  80,  84,  80, 103,
 80,  84,  80, 103, 103, 101, 103, 101, 103,  84,  83, 103,  89,  84,  61, 103,
 84, 103, 112,  89, 107, 107, 112,  83, 112, 107, 112,  89, 107, 104, 112,  84,
112, 112, 107, 107, 112, 107, 107, 112, 112, 112, 107, 112, 107, 104, 120, 112,
112, 107, 112, 107, 104, 120, 112, 114, 114, 126, 107, 120, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 150, 150,
114, 150, 150, 150, 150, 150, 150, 150, 150, 129, 129, 150, 150, 150, 129, 129,
150, 150, 150, 150, 150, 150, 129, 129, 129, 129, 129, 150, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  44,  42,  44,  44,  44,  47,  55,  55,  59,  47,
 54,  55,  55,  53,  55,  59,  53,  62,  55,  63,  62,  59,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  70,  70,  64,  63,  63,  70,  70,
 70,  73,  70,  70,  70,  70,  59,  80,  63,  80,  80,  80,  80,  70,  67,  84,
 80,  80,  61,  80,  80,  80,  65,  80,  80,  80,  80,  80,  80,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89,  84,  61, 103,
103, 103, 101,  89, 101, 101, 101, 104, 103, 101, 103,  89, 107, 104, 112,  84,
101, 112,  83,  89, 112, 112, 107, 112, 112, 112, 114, 112, 112, 104, 120, 112,
112, 107, 112, 112, 104, 104, 112, 114, 114, 126, 112, 120, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 150, 150, 150, 150, 129, 150, 129, 150, 129, 129, 150, 150, 150, 129, 129,
150, 150, 150, 129, 150, 129, 129, 129, 129, 129, 129, 150, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  51,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  42,  42,  44,  44,  55,  42,  55,  55,  59,  55,
 54,  55,  55,  53,  55,  59,  62,  55,  55,  63,  62,  64,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  62,  70,  62,  63,  63,  70,  63,
 70,  73,  70,  70,  70,  70,  59,  80,  68,  80,  80,  80,  80,  80,  67,  80,
 80,  80,  61,  80,  80,  80,  67,  80,  80,  80,  80,  80,  80,  80,  80,  98,
 80,  80,  80,  80, 101, 101, 101, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101, 101,  83, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101,  83, 101, 101, 101, 107, 107, 112, 112, 101, 112, 107, 104, 120, 112,
107, 120, 112, 107, 104, 104, 112, 114, 114, 126, 107, 120, 112, 114, 114, 114,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 120, 114, 114, 114, 134, 114, 114, 150,
114, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 129, 129, 150, 150,
150, 129, 129, 150, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218, 218,
 22,  22,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  54,  37,  32,  42,  42,  42,  50,  42,  42,  42,  44,  54,  42,  42,  42,
 54,  54,  44,  44,  44,  44,  44,  44,  44,  44,  44,  47,  53,  53,  47,  47,
 54,  53,  53,  49,  53,  59,  70,  70,  62,  70,  70,  70,  84,  70,  62,  48,
 70,  70,  68,  70,  70,  70,  84,  70,  50,  84,  70,  84,  70,  56,  84,  70,
 70,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,
 84,  84,  61,  84,  84,  84,  80,  84,  84,  84,  84,  84,  84,  84,  84,  84,
 84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  83,  84,  89,  84, 107,  84,
 84,  84, 112,  89, 112, 107, 112,  89, 112, 112,  84,  89, 107, 104, 112,  84,
112, 112, 107, 112, 112, 112, 107, 112, 112, 112, 112, 112, 112, 114, 120, 112,
112, 107, 112, 107, 104, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
114, 114, 107, 114, 114, 120, 114, 114, 114, 114, 114, 114, 112, 114, 114, 114,
114, 114, 114, 112, 114, 120, 114, 114, 114, 114, 114, 114, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 129, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 129, 129, 150, 150,
150, 129, 129, 150, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 54,  54,  42,  42,  42,  42,  44,  44,  44,  44,  55,  55,  55,  55,  59,  55,
 54,  55,  55,  62,  55,  59,  62,  62,  62,  63,  62,  64,  64,  64,  68,  63,
 62,  62,  68,  62,  62,  68,  62,  63,  50,  70,  70,  62,  63,  63,  70,  70,
 70,  73,  70,  70,  80,  80,  70,  80,  68,  80,  80,  80,  80,  80,  80,  84,
 80,  80,  61,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89, 107,  61, 103,
103, 103, 101,  89, 101, 107, 101, 104, 103, 101, 103,  89, 107, 104, 107,  84,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 107, 112, 107, 104, 120, 107,
107, 107, 107, 107, 104, 120, 112, 112, 107, 126, 107, 120, 112, 107, 107, 107,
114, 120, 120, 120, 114, 120, 114, 120, 114, 114, 114, 114, 112, 114, 114, 120,
114, 114, 114, 107, 114, 120, 114, 114, 120, 114, 114, 114, 114, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 129, 150, 150, 129, 129, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  29,  29,  29,  29,  29,  50,  51,  51,  51,  51,  54,  51,  51,  42,
 54,  54,  42,  51,  42,  51,  51,  47,  47,  55,  47,  47,  47,  47,  50,  47,
 54,  47,  47,  59,  47,  59,  59,  59,  64,  63,  62,  59,  64,  59,  63,  63,
 64,  64,  55,  62,  59,  63,  64,  63,  50,  70,  59,  64,  63,  63,  70,  63,
 70,  73,  59,  70,  70,  70,  87,  70,  63,  80,  80,  80,  80,  87,  80,  80,
 80,  80,  61,  80,  63,  80,  65,  98,  80, 101,  80,  80,  98,  80,  80,  75,
 80,  80,  98,  98, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101, 108, 103,
103, 103, 101,  89, 101, 101, 101,  89, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101,  89, 112, 112, 112, 112, 112, 114, 114, 114, 112, 104, 120, 112,
114, 112, 114, 112, 104, 104, 112, 114, 114, 126, 114, 120, 112, 114, 114, 114,
126, 114, 114, 114, 114, 120, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
114, 114, 114, 169, 114, 114, 129, 126, 129, 126, 129, 129, 150, 129, 129, 129,
129, 169, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 210, 218, 218,
 18,  18,  18,  18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  40,  35,  35,  35,  50,  51,  51,  51,  51,  35,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  51,
 54,  51,  60,  82,  60,  59,  55,  55,  60,  82,  55,  64,  60,  64,  63,  63,
 60,  62,  68,  62,  72,  63,  72,  63,  50,  72,  82,  72,  82,  63,  82,  82,
 82,  73,  64,  82,  82,  72,  59,  63,  63,  82,  80,  82,  80,  82,  82,  86,
 80,  80,  61,  80,  63,  80,  82,  80,  82,  82,  80,  80,  80,  80,  80,  98,
 80,  80,  80, 101, 101, 101, 101, 101, 101,  98,  83, 101,  89, 101,  61, 101,
103, 101, 101, 101, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 104, 120, 101,
101, 120, 134, 120, 104, 104, 112, 114, 134, 126, 134, 120, 112, 134, 134, 134,
114, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 150, 134, 150, 134, 134, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 169, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 129, 150, 129, 129, 129, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  35,  35,  35,  52,  50,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  54,  51,  51,  51,  51,  51,  51,  51,  51,  51,  47,  51,  51,  59,  47,
 54,  60,  60,  59,  60,  59,  59,  59,  60,  63,  62,  59,  64,  59,  63,  63,
 64,  64,  60,  62,  64,  63,  64,  63,  50,  72,  59,  64,  63,  63,  70,  63,
 63,  73,  59,  70,  70,  70,  87,  63,  63,  80,  80,  80,  80,  87,  82,  80,
 80,  80,  61,  80,  63,  80,  82,  80,  80, 101,  80,  80,  98,  80,  80,  87,
 80,  80,  98,  98, 101, 101, 101, 101, 101,  98,  83, 101,  89, 101, 108, 101,
103, 103, 101,  89, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101,  89, 101, 104, 120, 112,
114, 101, 114, 112, 104, 104, 112, 114, 114, 126, 114, 134, 112, 114, 114, 114,
126, 114, 114, 134, 114, 120, 114, 134, 134, 126, 114, 134, 114, 134, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 134, 114, 134, 126, 134, 134, 134, 114,
114, 134, 134, 134, 114, 134, 134, 126, 134, 126, 129, 129, 169, 129, 129, 129,
129, 169, 129, 129, 129, 129, 129, 129, 129, 169, 129, 129, 169, 129, 129, 129,
129, 129, 129, 169, 129, 169, 129, 129, 129, 129, 129, 129, 210, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  40,  35,  35,  35,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  50,  40,  40,  40,  40,  40,  40,  40,  42,
 54,  54,  42,  44,  44,  44,  40,  44,  55,  68,  55,  55,  55,  55,  47,  55,
 54,  55,  55,  62,  55,  64,  62,  62,  62,  62,  68,  62,  71,  64,  68,  68,
 68,  68,  68,  68,  62,  68,  62,  68,  50,  68,  70,  68,  68,  68,  68,  80,
 80,  73,  78,  80,  80,  80,  70,  68,  68,  80,  80,  80,  80,  80,  80,  84,
 80,  80,  61,  80,  68,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80, 103,
 80,  80,  80,  80, 101, 101, 101, 101, 101, 103,  83, 101,  89, 107,  61, 101,
103, 103, 107, 101, 107, 107, 107, 104, 107, 107, 107, 103, 107, 104, 107, 107,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 120, 120, 107,
107, 120, 107, 107, 104, 120, 107, 107, 107, 114, 107, 120, 107, 120, 107, 107,
114, 120, 120, 120, 120, 120, 120, 120, 120, 114, 120, 120, 107, 120, 120, 120,
120, 120, 120, 107, 120, 120, 120, 120, 120, 120, 120, 114, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 218, 218, 218,
 18,  35,  29,  29,  29,  29,  40,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  54,  32,  32,  32,  54,  54,  50,  42,  42,  42,  32,  54,  44,  44,  44,
 54,  54,  44,  44,  44,  44,  44,  44,  44,  44,  44,  53,  55,  55,  47,  55,
 54,  55,  62,  62,  62,  59,  62,  62,  62,  48,  68,  62,  62,  62,  68,  68,
 62,  62,  68,  62,  70,  68,  70,  68,  50,  70,  70,  84,  56,  68,  70,  80,
 70,  84,  84,  80,  80,  80,  70,  80,  68,  80,  84,  80,  80,  84,  80,  84,
 84,  84,  61,  84,  68,  84,  80,  84,  80,  80,  84,  84,  84,  84,  84,  84,
 84,  84,  84,  84,  84, 107,  84, 107, 107,  84,  83, 107,  89,  84, 107, 107,
 84, 107, 107, 107, 107, 107, 107, 104, 107, 107, 107, 107, 107, 104, 107,  84,
107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 120, 107,
107, 107, 107, 107, 104, 120, 107, 107, 107, 114, 107, 120, 107, 107, 107, 107,
114, 107, 107, 120, 107, 120, 107, 120, 120, 114, 120, 120, 107, 120, 107, 107,
120, 120, 114, 107, 150, 120, 150, 150, 120, 150, 150, 114, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  40,  35,  35,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 51,  54,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  55,  55,  59,  60,
 54,  55,  55,  62,  60,  59,  62,  62,  55,  63,  62,  64,  60,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  64,  63,  50,  62,  70,  64,  63,  63,  78,  82,
 80,  73,  64,  80,  80,  80,  59,  80,  68,  80,  80,  80,  80,  80,  80,  80,
 80,  80,  61,  80,  63,  80,  82,  80,  80, 101,  80,  80,  98,  80,  80,  98,
 80,  80,  80, 101, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101,  61, 101,
103, 103, 101, 101, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 112, 101, 101, 101, 101, 101, 104, 120, 112,
112, 120, 112, 107, 104, 104, 112, 112, 120, 126, 112, 120, 112, 120, 134, 114,
114, 120, 120, 134, 134, 120, 134, 120, 134, 114, 134, 134, 112, 134, 134, 134,
134, 134, 134, 112, 134, 120, 134, 134, 134, 134, 134, 114, 134, 134, 134, 150,
134, 134, 150, 120, 150, 134, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 129, 150, 150, 150, 150, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 29,  29,  51,  40,  29,  29,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  55,  55,  60,  55,  55,  55,  59,  60,
 54,  55,  55,  62,  55,  59,  62,  62,  62,  63,  62,  64,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  64,  63,  50,  62,  70,  78,  63,  63,  70,  70,
 70,  73,  64,  70,  80,  80,  59,  80,  68,  80,  80,  80,  80,  80,  80,  80,
 80,  80,  61,  80,  80,  80, 101,  80,  80, 101,  80,  80,  98,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101,  61, 103,
103, 103, 101, 101, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 112,
101, 101, 101, 101, 112, 112, 107, 112, 112, 112, 101, 112, 112, 104, 120, 112,
112, 120, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 114, 114, 114,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 134, 112, 114, 114, 114,
114, 114, 114, 112, 114, 120, 114, 114, 134, 114, 114, 114, 134, 134, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 129, 150, 150, 129, 150, 210, 218, 218, 218,
 18,  18,  41,  41,  18,  41,  40,  41,  40,  40,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  50,  40,  40,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  51,  51,  51,  64,  55,
 71,  55,  55,  55,  55,  64,  68,  55,  68,  82,  68,  72,  71,  60,  68,  68,
 68,  68,  68,  68,  68,  68,  68,  68,  50,  68,  82,  68,  82,  68,  68,  82,
 68,  73,  72,  68,  68,  68,  72,  68,  68,  68,  68,  80,  68,  80,  82,  90,
 80,  90,  61,  80,  68,  80,  82,  80,  80,  82,  80,  80,  80,  90,  80,  80,
 90,  90,  80, 101, 101, 101, 101, 101, 101, 103,  83, 101, 101, 100, 128, 101,
103, 101, 101, 101, 101, 101, 101, 104, 101, 101, 103, 101, 120, 104, 101, 103,
101, 101, 120, 101, 107, 107, 120, 107, 107, 107, 120, 107, 107, 104, 128, 107,
120, 120, 120, 120, 104, 120, 107, 107, 120, 134, 120, 120, 107, 120, 120, 120,
134, 120, 120, 120, 120, 120, 120, 120, 134, 134, 120, 134, 120, 120, 120, 120,
120, 120, 134, 120, 120, 120, 120, 120, 120, 134, 120, 134, 134, 134, 134, 150,
134, 150, 150, 120, 150, 134, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  51,  40,  29,  29,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  55,  55,  55,  55,  55,  55,  55,  59,  60,
 54,  55,  55,  62,  64,  59,  62,  62,  62,  63,  62,  64,  64,  64,  62,  63,
 62,  62,  68,  62,  62,  68,  64,  63,  50,  78,  70,  78,  63,  63,  70,  70,
 70,  73,  70,  70,  80,  80,  70,  80,  68,  80,  80,  80,  80,  80,  80,  84,
 80,  80,  61,  80,  80,  80, 101,  80,  80, 101,  80,  80,  98,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101,  61, 103,
103, 103, 103, 101, 101, 101, 101, 104, 103, 101, 103,  89, 107, 104, 112, 112,
101, 112, 101, 101, 112, 112, 107, 112, 112, 112, 112, 112, 112, 104, 120, 112,
112, 120, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 134, 112, 114, 114, 120,
114, 114, 114, 112, 114, 120, 114, 114, 120, 114, 114, 114, 134, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  51,  51,  35,  51,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  51,  60,  60,  60,  60,  59,  60,
 54,  60,  60,  62,  60,  59,  62,  64,  60,  63,  62,  64,  73,  64,  62,  63,
 64,  62,  73,  62,  72,  63,  64,  63,  50,  78,  70,  73,  63,  63,  78,  80,
 78,  73,  64,  78,  78,  78,  59,  80,  68,  80,  80,  80,  80,  98,  80,  91,
 80,  80,  61,  80,  90,  80, 101,  98,  80, 101,  80,  80,  98,  80, 101,  98,
 80,  90, 101, 103, 101, 101, 101, 101, 101, 103, 101, 101, 103, 101, 108, 103,
103, 103, 101, 101, 101, 101, 101, 104, 101, 101, 103, 103, 101, 104, 101, 103,
101, 101, 101, 101, 112, 112, 101, 112, 112, 112, 101, 112, 112, 104, 120, 112,
112, 112, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
126, 120, 120, 134, 114, 120, 134, 134, 134, 126, 134, 134, 112, 134, 134, 134,
134, 134, 134, 141, 134, 120, 134, 134, 134, 134, 134, 126, 134, 134, 134, 150,
134, 150, 150, 169, 150, 134, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  41,  40,  41,  41,  41,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  50,  40,  40,  40,  40,  40,  40,  51,  51,
 54,  54,  51,  51,  51,  51,  40,  51,  71,  71,  71,  55,  71,  71,  64,  60,
 54,  71,  71,  62,  71,  64,  62,  62,  71,  62,  68,  64,  71,  64,  68,  68,
 71,  62,  68,  62,  78,  68,  78,  68,  50,  78,  78,  73,  68,  68,  78,  80,
 78,  73,  78,  80,  90,  90,  70,  90,  68,  90,  90,  80,  90,  80,  80,  90,
 80,  90,  61,  80,  68,  80, 101,  80,  80, 101,  80,  80, 103,  90, 101, 103,
 90,  90, 101, 103, 101, 101, 101, 101, 101, 103, 101, 101, 103, 107, 128, 103,
103, 103, 101, 101, 101, 107, 107, 101, 107, 101, 103, 103, 107, 104, 107, 107,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 120, 107, 107, 120, 120, 107,
107, 120, 107, 107, 104, 120, 107, 107, 107, 126, 107, 120, 107, 120, 107, 107,
114, 120, 120, 120, 120, 120, 120, 120, 120, 134, 120, 134, 107, 120, 120, 120,
120, 120, 134, 141, 120, 120, 120, 120, 120, 120, 120, 134, 134, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  51,  35,  35,  35,  51,  50,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  54,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  60,
 54,  60,  60,  72,  60,  59,  72,  60,  60,  82,  72,  64,  73,  64,  63,  63,
 60,  72,  71,  72,  72,  63,  72,  63,  50,  72,  82,  73,  82,  63,  72,  82,
 82,  73,  72,  86,  86,  86,  59,  86,  90,  86,  86,  86,  90,  98,  82,  86,
 91,  91, 108,  91,  90,  80,  82,  98,  82,  82,  91,  98,  98,  90, 101, 105,
101,  90,  98,  98, 101, 101, 101, 101, 101, 103, 101, 101, 101, 101, 108, 101,
103, 103, 101, 101, 101, 101, 101, 101, 101, 101, 103, 103, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 134, 120, 112,
101, 134, 134, 112, 104, 120, 112, 112, 134, 126, 134, 134, 112, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 169, 134, 134, 134, 150, 134, 150, 134, 134, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 169, 150, 169, 169, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  40,  35,  35,  35,  35,  35,  35,  35,  54,  54,
 54,  54,  51,  40,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  55,  71,  60,  55,  71,  71,  55,  71,  71,  59,  60,
 54,  71,  62,  62,  62,  59,  62,  62,  62,  62,  62,  64,  73,  64,  68,  68,
 71,  62,  68,  62,  78,  68,  78,  68,  50,  78,  70,  73,  68,  68,  78,  80,
 80,  73,  78,  80,  80,  80,  70,  90,  68,  80,  80,  80,  90,  80,  80,  84,
 80,  80,  61,  80,  90,  80, 101,  80,  80, 101,  84, 103, 103,  90, 101, 103,
 80,  90, 103, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 107, 128, 103,
103, 103, 103, 103, 107, 107, 107, 101, 107, 107, 112, 103, 107, 104, 107,  84,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 107, 112, 107, 120, 120, 107,
107, 107, 107, 107, 120, 120, 112, 112, 107, 126, 107, 120, 107, 120, 107, 107,
114, 120, 120, 120, 120, 120, 120, 120, 120, 114, 120, 134, 107, 120, 120, 120,
120, 120, 120, 141, 120, 120, 150, 150, 120, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218, 218,
 25,  25,  25,  25,  25,  25,  52,  25,  25,  25,  25,  25,  25,  25,  25,  25,
 25,  25,  25,  50,  25,  25,  25,  25,  25,  25,  25,  50,  50,  50,  25,  25,
 25,  25,  25,  25,  50,  50,  50,  50,  50,  50,  50,  25,  50,  50,  25,  50,
 50,  50,  50,  50,  50,  25,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,
 50,  50,  50,  50,  50,  75,  50,  75,  77,  50,  50,  50,  75,  75,  75,  75,
 75,  50,  50,  75,  75,  75,  25,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75, 152,  75,
 75, 152,  75, 152, 152, 152,  75, 152, 152,  75, 152, 152, 152, 152, 152, 152,
152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152,
152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152,
152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 181, 152, 152, 152,
152, 152, 152, 152, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 199, 199,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 51,  54,  51,  40,  51,  51,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  51,  60,  60,  60,  60,  59,  60,
 54,  60,  60,  72,  60,  59,  72,  72,  60,  63,  72,  64,  73,  64,  71,  63,
 73,  72,  73,  72,  72,  78,  73,  63,  50,  78,  72,  73,  63,  63,  78,  78,
 78,  73,  78,  86,  86,  86,  59,  86,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  91, 108,  91,  90,  98, 101,  98, 101, 101,  98,  98,  98,  90, 101,  98,
101,  90,  98, 103, 101, 101, 101, 101, 101, 103, 101, 101, 103, 101, 108, 103,
103, 103, 103, 101, 101, 101, 101, 101, 103, 101, 103, 103, 101, 104, 101, 103,
101, 101, 101, 101, 112, 112, 112, 112, 112, 112, 101, 112, 112, 134, 120, 112,
112, 112, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 134, 134, 112,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 112, 134, 134, 134,
134, 134, 134, 141, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 150,
134, 134, 150, 169, 150, 169, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 150, 150, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  54,  35,  35,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  54,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  60,  54,  54,  60,  60,  54,  59,  60,  60,  50,  59,
 54,  64,  64,  59,  64,  50,  59,  59,  64,  59,  64,  59,  73,  59,  78,  63,
 64,  64,  73,  64,  64,  78,  64,  63,  50,  78,  87,  73,  63,  63,  70,  70,
 70,  84,  59,  70,  91,  91,  87,  91,  90,  98,  98,  98,  91,  87,  98,  84,
 98,  98, 108,  98, 108,  98,  98,  98,  98,  98,  84,  98, 105,  84,  98, 105,
 98,  84,  98, 103, 103, 103, 103, 101, 103, 105, 101, 103, 105,  84, 108, 103,
 84, 103, 112, 103, 112, 112, 112, 101, 112, 112, 112, 126, 112, 104, 112,  84,
112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 114, 120, 112,
112, 112, 112, 112, 114, 120, 112, 126, 112, 126, 112, 112, 112, 112, 112, 112,
126, 114, 112, 114, 114, 120, 114, 114, 114, 126, 114, 114, 141, 114, 114, 114,
114, 114, 126, 141, 114, 141, 141, 114, 114, 114, 114, 126, 114, 114, 114, 141,
126, 114, 114, 169, 150, 169, 150, 126, 150, 126, 150, 150, 169, 150, 126, 169,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 199, 199, 210, 199, 210, 210, 210, 218, 218,
 18,  18,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  41,  57,  41,  41,  41,  41,  50,  51,  51,  51,  51,  41,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  51,
 54,  51,  51,  82,  60,  59,  82,  72,  60,  82,  72,  72,  73,  72,  71,  82,
 71,  72,  71,  82,  72,  82,  72,  82,  50,  82,  82,  73,  82,  82,  82,  82,
 82,  73,  72,  82,  82,  82,  82,  82,  90,  82,  86,  82,  82,  82,  82,  86,
 82,  86,  82,  82,  90,  82,  82,  86,  82,  82,  96,  82,  98,  90,  82,  98,
102,  90, 102,  98, 101, 101, 101, 101, 101,  98,  82, 101, 101, 102, 108, 101,
103, 103, 101, 101, 101, 108, 101, 101, 101, 101, 103, 103, 108, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 134, 101, 101, 134, 120, 124,
134, 134, 134, 124, 134, 134, 124, 134, 134, 134, 134, 134, 124, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 169, 169, 134, 169,
169, 169, 169, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  40,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  40,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  55,  54,  71,  54,  54,  71,  71,  54,  60,  71,  71,  64,  71,
 54,  71,  71,  62,  71,  64,  62,  62,  71,  62,  68,  64,  73,  64,  68,  68,
 73,  78,  68,  78,  78,  68,  78,  68,  50,  78,  70,  84,  68,  68,  90,  80,
 80,  84,  84,  80,  90,  84,  84,  90,  68,  84,  84,  84,  84,  84,  80,  84,
 84,  84,  61,  84,  90,  84, 101,  84, 101, 101,  84, 103, 103,  84, 103,  84,
 84,  84,  84, 103, 103, 103, 103, 103, 103,  84, 101, 103, 103,  84, 128, 112,
 84, 112, 112, 112, 107, 107, 107, 107, 112, 107, 112, 112, 107, 104, 112,  84,
107, 107, 107, 107, 107, 107, 107, 107, 107, 112, 107, 112, 107, 107, 120, 112,
107, 107, 107, 107, 120, 120, 145, 112, 107, 126, 107, 120, 141, 107, 107, 112,
112, 120, 107, 120, 107, 120, 107, 120, 120, 126, 120, 120, 141, 120, 141, 141,
120, 120, 150, 141, 150, 120, 141, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  40,  40,  40,  54,  40,  40,  40,  40,  40,  40,  40,  40,
 54,  54,  40,  40,  40,  54,  54,  50,  40,  54,  54,  40,  54,  54,  54,  54,
 54,  54,  54,  55,  54,  71,  71,  71,  71,  68,  71,  71,  71,  71,  64,  71,
 54,  71,  71,  62,  71,  64,  68,  71,  71,  68,  68,  64,  71,  71,  68,  68,
 68,  68,  68,  68,  68,  68,  78,  68,  50,  68,  78,  90,  68,  68,  90,  90,
 90,  84,  84,  90,  90,  90,  86,  90,  68,  90,  90,  90,  90, 103,  80,  84,
 90,  90, 100,  90, 100,  90, 101, 103,  90, 101,  84, 103, 103,  90, 103, 103,
 90,  90, 103, 103, 103, 101, 103, 101, 103, 103, 101, 107, 103, 107, 128, 107,
 84, 107, 107, 103, 107, 107, 107, 107, 107, 107, 107, 103, 107, 104, 107, 107,
107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 120, 128, 107,
107, 107, 107, 107, 120, 120, 141, 107, 107, 112, 107, 120, 107, 107, 107, 107,
107, 120, 120, 120, 107, 120, 120, 120, 120, 114, 120, 120, 141, 120, 120, 120,
120, 120, 150, 141, 150, 120, 141, 150, 120, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  54,  54,
 51,  54,  51,  51,  54,  54,  54,  50,  51,  51,  54,  51,  54,  51,  54,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  60,  60,  60,  60,  60,  60,  59,  60,
 54,  60,  60,  72,  64,  59,  72,  72,  73,  72,  72,  64,  73,  64,  73,  63,
 73,  72,  73,  72,  78,  78,  73,  78,  50,  78,  72,  73,  63,  63,  78,  86,
 86,  73,  86,  86,  86,  86,  87,  91,  90,  91,  91,  91,  91,  98,  98,  96,
 91,  91, 108,  98, 108,  98, 101,  98, 101, 101,  98,  98,  98,  90,  98, 105,
101,  90,  98, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 103, 108, 103,
103, 103, 103, 101, 101, 101, 103, 101, 103, 101, 103, 103, 101, 104, 103, 103,
101, 112, 101, 101, 112, 112, 112, 112, 112, 112, 112, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 126, 134, 134, 134, 150,
134, 134, 150, 169, 150, 169, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 169, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  54,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  60,  54,  60,  54,  54,  60,  71,  54,  60,  60,  60,  59,  64,
 54,  73,  73,  64,  73,  59,  78,  64,  73,  78,  78,  64,  73,  64,  73,  78,
 73,  78,  73,  78,  78,  90,  73,  78,  50,  78,  70,  73,  90,  90,  91,  91,
 91,  84,  84,  91,  91,  91,  98,  91,  90,  91,  91,  91,  91,  98,  98,  84,
 98,  84, 108,  98,  90,  98, 101, 103, 101, 101,  84, 103, 103,  84, 103, 103,
103,  84, 103, 103, 103, 103, 103, 103, 103, 103, 101, 103, 103,  84, 108, 103,
 84, 112, 112, 103, 112, 112, 112, 101, 112, 112, 112, 112, 112, 104, 112, 145,
112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 120, 112,
112, 112, 112, 112, 120, 120, 145, 112, 112, 126, 112, 120, 141, 112, 112, 112,
126, 112, 112, 134, 141, 120, 141, 141, 134, 126, 141, 134, 141, 134, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 126, 150, 150, 150, 141,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 150,
150, 150, 150, 150, 150, 169, 150, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  54,  35,  35,  35,  35,  54,  54,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  51,  54,  54,  60,  71,  54,  60,  60,  60,  59,  64,
 54,  60,  73,  72,  73,  59,  72,  72,  73,  72,  78,  64,  73,  64,  73,  63,
 73,  78,  73,  78,  78,  78,  73,  78,  50,  78,  78,  73,  63,  90,  86,  91,
 91,  73,  86,  91,  91,  91,  87,  91,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  96, 108,  98, 108,  98, 101,  98, 101, 101,  98,  98,  98,  96,  98, 105,
 98,  90, 103, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 103, 108, 103,
103, 103, 103, 103, 103, 112, 103, 101, 103, 101, 103, 103, 112, 104, 112, 112,
112, 112, 101, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 112, 126, 112, 120, 112, 112, 112, 112,
126, 134, 112, 134, 112, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 141,
134, 134, 134, 141, 134, 153, 141, 141, 134, 134, 134, 126, 134, 134, 134, 141,
150, 150, 150, 169, 150, 169, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  18,  18,  18,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  57,
 57,  57,  57,  57,  57,  57,  57,  50,  57,  57,  57,  57,  41,  57,  57,  57,
 57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,
 52,  57,  57,  57,  57,  57,  82,  82,  82,  82,  82,  82,  74,  74,  82,  82,
 82,  82,  74,  82,  82,  82,  82,  82,  50,  82,  82,  82,  82,  82,  82,  82,
 82,  93,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  94,
 82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,
 82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82, 106, 108,  82,
102,  82,  82,  82, 117, 108, 117, 117, 117, 117, 116,  82, 108, 117, 117, 113,
117, 117, 117, 117, 117, 117, 117, 124, 117, 137, 117, 137, 137, 134, 108, 124,
134, 134, 134, 124, 134, 134, 124, 134, 134, 134, 134, 134, 124, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 169, 134, 134, 134, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 210, 210, 218, 218, 218, 218,
 18,  18,  35,  35,  57,  35,  35,  35,  35,  35,  35,  35,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  50,  52,
 54,  51,  60,  82,  60,  59,  82,  72,  60,  82,  72,  59,  73,  88,  73,  82,
 73,  72,  73,  72,  72,  72,  73,  82,  50,  72,  82,  73,  82,  82,  82,  82,
 82,  93,  97,  82,  86,  86,  87,  86,  90,  82,  86,  86,  86,  87,  82,  97,
 91,  97, 108,  98, 108,  98,  82,  98,  82,  82,  98,  98, 105,  96,  98, 105,
108, 102,  98,  98,  98, 108,  98, 108,  98, 105, 108,  98, 105, 108, 108,  98,
105, 105, 101, 101, 101, 108, 101, 101, 101, 101, 105, 105, 108, 104, 101, 116,
101, 101, 108, 101, 101, 101, 108, 124, 101, 101, 134, 132, 101, 134, 108, 124,
134, 134, 134, 124, 134, 134, 124, 132, 134, 126, 134, 134, 124, 134, 134, 134,
126, 134, 134, 134, 134, 134, 134, 134, 134, 126, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 169, 169, 134, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  51,  54,  54,  60,  71,  54,  60,  60,  60,  59,  60,
 54,  73,  73,  72,  73,  59,  72,  72,  73,  72,  72,  64,  73,  73,  73,  63,
 73,  72,  73,  72,  78,  78,  73,  78,  50,  78,  86,  73,  63,  90,  86,  91,
 86,  93,  86,  91,  91,  86,  87,  91,  90,  91,  91,  91,  91,  98,  98,  96,
 91,  96, 108,  98, 108,  98, 101,  98,  98, 101,  98,  98,  98,  96,  98, 105,
 98,  96,  98, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 103, 103, 101, 103, 101, 103, 101, 103, 103, 108, 104, 103, 103,
103, 112, 101, 101, 112, 112, 112, 112, 112, 112, 112, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 112, 126, 112, 134, 141, 134, 112, 112,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 126, 134, 134, 134, 141,
134, 134, 134, 169, 150, 169, 169, 150, 169, 150, 169, 150, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  18,  41,  41,  35,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 51,  54,  51,  51,  54,  54,  54,  50,  51,  51,  54,  51,  54,  51,  54,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  71,  71,  60,  71,  71,  59,  60,
 54,  71,  71,  72,  73,  59,  72,  72,  73,  72,  72,  72,  73,  73,  71,  78,
 73,  72,  73,  72,  78,  90,  73,  78,  50,  78,  86,  73,  90,  90,  86,  86,
 86,  93,  86,  86,  86,  86,  86,  86,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  96, 108,  96, 108,  98, 101,  98, 108, 101,  96,  98,  98,  96,  98, 105,
102,  90,  98, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 101, 101, 108, 103, 101, 103, 101, 103, 103, 108, 104, 103, 103,
101, 103, 101, 101, 112, 112, 112, 112, 112, 112, 134, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 134, 126, 112, 134, 141, 134, 134, 134,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 169, 150, 169, 169, 150, 169, 150, 169, 150, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  18,  41,  41,  35,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 51,  54,  51,  51,  51,  54,  54,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  71,  71,  51,  71,  71,  59,  60,
 54,  71,  71,  72,  73,  59,  72,  72,  73,  82,  72,  72,  73,  73,  71,  63,
 73,  72,  73,  72,  72,  90,  73,  78,  50,  78,  86,  73,  82,  90,  86,  86,
 86,  93,  86,  86,  86,  86,  97,  86,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  96, 108,  96, 108,  98, 101,  98, 108, 101,  96,  98,  98,  96,  98, 105,
102,  90,  98,  98, 101, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 101, 101, 108, 101, 101, 103, 101, 103, 103, 108, 104, 103, 103,
101, 103, 101, 101, 124, 124, 124, 124, 124, 124, 134, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 134, 126, 112, 134, 141, 134, 134, 134,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 169, 150, 169, 169, 150, 169, 150, 169, 169, 169, 169, 150, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  52,  52,  35,  52,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  54,  52,  52,  52,
 52,  54,  52,  52,  52,  52,  52,  52,  52,  52,  52,  59,  52,  52,  50,  59,
 54,  59,  59,  59,  59,  50,  59,  59,  59,  59,  59,  59,  73,  59,  73,  63,
 73,  59,  73,  59,  59,  78,  73,  63,  50,  97,  87,  73,  63,  63,  97,  87,
 91,  93,  87,  87,  97,  97,  87,  91,  91, 105, 105, 105,  98,  87, 105, 105,
105, 105, 108, 105, 108, 105,  98, 105,  98,  98, 105, 105, 105,  98, 105, 105,
 98,  98, 105, 105, 105,  98, 105, 108, 105, 105, 108, 105, 105, 108, 108, 105,
105, 105, 105, 105, 103, 108, 105, 101, 105, 101, 105, 105, 108, 104, 103, 105,
103, 103, 108, 101, 112, 112, 112, 112, 112, 112, 134, 126, 112, 134, 108, 112,
112, 112, 112, 112, 134, 134, 141, 126, 126, 126, 112, 134, 141, 134, 126, 152,
126, 134, 134, 134, 126, 134, 126, 134, 134, 126, 134, 134, 152, 134, 126, 134,
134, 134, 126, 141, 126, 141, 152, 126, 134, 126, 134, 126, 134, 134, 134, 152,
126, 134, 126, 169, 181, 169, 169, 126, 181, 126, 126, 181, 169, 169, 126, 169,
181, 169, 181, 169, 181, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
181, 169, 169, 169, 199, 169, 169, 199, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  54,  51,  40,  54,  54,  54,  50,  51,  51,  54,  51,  54,  51,  54,  51,
 54,  54,  51,  51,  51,  51,  71,  71,  71,  71,  71,  71,  71,  71,  88,  71,
 54,  71,  71,  72,  71,  88,  72,  71,  71,  82,  71,  72,  73,  73,  71,  78,
 73,  71,  71,  72,  78,  90,  73,  90,  50,  86,  86,  73,  90,  90,  86,  86,
 86,  93,  86,  86,  86,  86,  86,  90,  90,  90,  90,  91,  90,  98,  98,  96,
 96,  96, 108,  96,  90,  96, 101,  96, 108, 101,  96, 102,  98,  90, 102,  98,
102,  90, 102, 103, 101, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 101, 101, 108, 101, 101, 103, 101, 103, 103, 108, 104, 103, 124,
101, 124, 101, 101, 124, 124, 124, 124, 124, 124, 134, 124, 124, 134, 128, 124,
124, 120, 112, 112, 134, 120, 141, 112, 134, 126, 112, 120, 141, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 150, 169, 169, 150, 150, 150, 169, 150, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 210, 169, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  54,  40,  40,  40,  40,  66,  40,  40,  40,
 79,  79,  79,  40,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  71,  71,
 79,  71,  71,  71,  71,  71,  71,  71,  71,  68,  68,  71,  79,  71,  68,  68,
 71,  71, 100,  71,  71, 100,  71,  68,  50,  90,  86,  90,  68, 100,  90,  90,
 90,  93,  90,  90,  90,  90,  86,  90, 100,  90,  90,  90, 100,  96,  90, 106,
 90,  90, 100,  90, 100,  90,  90,  90,  90,  90, 106,  90, 102, 100,  90, 103,
100, 100, 106, 102, 102, 106, 102, 101, 101, 103, 101, 125, 103, 100, 128, 125,
113, 125, 125, 101, 125, 125, 125, 101, 125, 125, 124, 103, 128, 137, 125, 125,
125, 125, 128, 125, 125, 125, 128, 125, 125, 124, 120, 124, 125, 120, 128, 125,
120, 120, 120, 128, 120, 128, 141, 124, 120, 134, 120, 120, 107, 120, 120, 120,
134, 120, 120, 120, 120, 128, 153, 153, 134, 134, 153, 134, 141, 153, 153, 153,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 134, 153, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 150, 150, 150, 150, 150, 153, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  74,  71,  71,  71,  71,  71,  74,  71,  71,  88,  71,
 54,  71,  71,  72,  73,  88,  72,  73,  73,  72,  73,  73,  73,  73,  71,  78,
 73,  73,  73,  73,  73,  90,  73,  90,  50,  86,  86,  73,  90,  90,  86,  86,
 86,  93,  97,  86,  86,  86,  97,  90,  90,  96,  96,  96,  90,  98,  98,  96,
 96,  96, 108,  96, 108, 102, 108,  96, 108, 108,  96, 102,  98, 102, 102, 105,
102, 102, 102, 103, 103, 108, 103, 108, 103, 103, 108, 103, 103, 113, 108, 103,
113, 103, 103, 103, 124, 108, 124, 101, 124, 124, 103, 103, 108, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 134, 124, 124, 134, 128, 124,
124, 124, 124, 141, 134, 134, 145, 132, 134, 126, 141, 134, 141, 134, 134, 134,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 153, 169, 169, 150, 169, 150, 169, 169, 169, 169, 150, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 210, 169, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  54,  51,  51,  41,  54,  54,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  74,  51,  74,  51,  74,  74,  74,  71,  74,  71,  71,  88,  71,
 54,  71,  71,  74,  73,  88,  72,  71,  73,  82,  71,  88,  73,  73,  71,  78,
 73,  73,  73,  73,  73,  90,  73,  90,  50,  86,  86,  73,  82,  90,  86,  86,
 86,  93,  97,  86,  86,  86,  97,  90,  90,  96,  96,  96,  90,  98,  98,  96,
 96,  96, 108,  96, 108, 102, 108, 102, 108, 108,  96, 102,  98, 102, 102, 105,
102, 102, 102,  98, 102, 108, 102, 108, 103, 103, 108, 113, 103, 113, 108, 113,
113, 103, 103, 101, 124, 108, 124, 137, 124, 124, 103, 103, 108, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 134, 124, 124, 134, 128, 124,
124, 124, 124, 124, 134, 134, 141, 132, 134, 126, 124, 134, 141, 134, 134, 134,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 134, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 134, 169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 210, 169, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  74,  71,  74,  74,  74,  71,  74,  71,  71,  88,  71,
 93,  71,  71,  72,  73,  88,  71,  73,  73,  82,  73,  88,  73,  88,  71,  78,
 73,  73,  73,  73,  73,  90,  73,  90,  50,  86,  86,  73,  90,  90,  86,  86,
 86,  93,  97,  86,  86,  86,  97,  90,  90,  96,  96,  96,  96,  98,  98,  96,
 96,  96, 108, 102, 108, 102, 108, 102, 108, 108,  96, 102,  98, 102, 102, 105,
102, 102, 102,  98, 102, 108, 113, 108, 103, 103, 108, 113, 103, 113, 108, 113,
113, 103, 124, 103, 124, 125, 124, 137, 124, 124, 124, 103, 108, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 134, 128, 124,
124, 124, 124, 124, 134, 134, 145, 132, 134, 126, 141, 134, 141, 134, 134, 141,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 153, 169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  54,  51,  40,  41,  54,  54,  50,  51,  51,  54,  74,  66,  79,  54,  74,
 54,  54,  74,  74,  74,  74,  79,  74,  74,  71,  71,  74,  71,  71,  88,  71,
 93,  71,  71,  74,  71,  88,  71,  71,  71,  82,  71,  71,  73,  73,  71,  90,
 71,  71,  71,  71,  71,  90,  73,  90,  50,  94,  86,  73,  90,  90,  86,  86,
 90,  93,  94,  86,  90,  90,  97,  90, 100,  90,  90,  96,  90,  96, 102,  96,
102,  96, 108, 102, 106, 102, 108, 102, 102, 108, 102, 102, 102, 106, 102,  98,
102, 106, 102, 102, 102, 102, 113, 108, 113, 113, 108, 113, 103, 125, 128, 113,
113, 113, 124, 101, 124, 125, 124, 137, 124, 124, 124, 103, 125, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 134, 128, 124,
124, 124, 124, 125, 134, 120, 145, 132, 134, 132, 124, 134, 141, 134, 134, 134,
134, 134, 134, 134, 134, 128, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 153, 153, 153, 134, 153, 134, 134, 134, 153, 153,
134, 153, 153, 153, 153, 169, 153, 150, 169, 150, 169, 169, 169, 169, 150, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  35,  52,  35,  57,  52,  35,  54,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  54,  52,  52,  52,
 54,  54,  52,  52,  52,  52,  52,  52,  52,  74,  88,  88,  88,  88,  50,  88,
 88,  88,  88,  88,  88,  87,  73,  88,  88,  72,  73,  88,  88,  88,  73,  78,
 88,  88,  73,  97,  97,  94,  88,  97,  50,  97,  87,  97,  91,  91,  97,  97,
 97,  93,  97,  97,  97,  97,  87,  97,  96,  97,  97,  97,  97, 105, 105,  97,
105, 105, 108, 105, 108, 105, 108, 105, 108, 108, 105, 105, 105, 102, 105, 105,
108, 108, 105, 105, 105, 108, 105, 108, 105, 105, 108, 105, 105, 113, 108, 105,
105, 105, 105, 105, 124, 108, 124, 137, 124, 124, 105, 105, 108, 137, 124, 145,
124, 132, 108, 132, 132, 132, 124, 124, 132, 132, 132, 132, 132, 134, 108, 132,
132, 132, 132, 141, 134, 134, 145, 152, 132, 152, 141, 134, 141, 132, 152, 152,
152, 134, 134, 134, 152, 134, 152, 134, 134, 126, 134, 134, 141, 134, 152, 141,
134, 134, 152, 141, 152, 141, 141, 152, 134, 152, 134, 126, 134, 134, 134, 181,
152, 181, 181, 169, 181, 169, 181, 181, 181, 181, 181, 181, 169, 181, 181, 169,
181, 169, 181, 181, 181, 181, 169, 169, 181, 169, 181, 169, 169, 181, 169, 169,
181, 169, 169, 169, 199, 169, 210, 199, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  41,  54,  41,  35,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  54,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  54,  54,  54,  73,  71,  54,  73,  73,  73,  88,  88,
 93,  73,  73,  72,  73,  88,  73,  73,  73,  78,  73,  88,  73,  88,  73,  78,
 73,  73,  73,  73,  73,  90,  73,  91,  50,  91,  91,  93,  91,  90,  91,  91,
 91,  93,  88,  91,  96,  96, 105,  96,  90,  96,  96,  96,  96, 105,  98,  84,
 96,  96, 108,  96, 108,  98, 108,  98, 108, 108,  96,  98, 105, 113, 103, 105,
113, 113, 103, 103, 103, 103, 103, 103, 103, 105, 108, 103, 103, 113, 108, 103,
103, 103, 112, 103, 112, 112, 112, 101, 112, 112, 112, 103, 112, 137, 112, 145,
112, 112, 112, 112, 112, 112, 112, 141, 112, 112, 112, 112, 112, 134, 120, 141,
141, 141, 141, 141, 134, 120, 145, 141, 141, 126, 141, 141, 141, 141, 141, 141,
126, 141, 141, 141, 141, 153, 141, 141, 134, 126, 141, 134, 141, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 126, 169, 153, 141, 141,
175, 175, 175, 153, 175, 169, 175, 175, 175, 175, 169, 175, 169, 175, 181, 169,
175, 169, 175, 175, 175, 175, 169, 169, 175, 169, 175, 169, 169, 199, 169, 169,
199, 199, 199, 210, 199, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  18,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  57,  57,  57,  57,
 57,  57,  57,  57,  57,  57,  57,  50,  57,  57,  57,  57,  66,  57,  57,  57,
 57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  74,  57,  74,  74,  57,  74,
 79,  74,  74,  74,  74,  88,  74,  74,  74,  82,  74,  74,  74,  74,  74,  82,
 74,  74,  79,  74,  74,  82,  74,  82,  50,  82,  82,  94,  82,  82,  82,  82,
 82,  93,  97,  82,  82,  82,  82,  82, 106,  82,  82,  82,  82,  82,  82, 109,
117, 109, 117, 117, 117, 117, 117, 117, 117, 117, 109, 117, 117, 106, 117, 116,
117, 106, 117, 117, 117, 117, 117, 117, 117, 116, 117, 117, 117, 106, 117, 117,
110, 116, 117, 117, 117, 108, 117, 117, 117, 117, 116, 117, 117, 117, 117, 122,
117, 137, 117, 137, 137, 137, 137, 124, 137, 137, 137, 137, 137, 137, 137, 124,
137, 137, 137, 125, 134, 134, 124, 132, 137, 132, 137, 134, 124, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 132, 134, 134, 134,
134, 134, 134, 161, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 187, 134, 187, 134, 134, 169, 134, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
187, 169, 169, 169, 187, 169, 169, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  74,  74,  54,  74,  54,  74,  54,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  71,  74,  74,  74,  88,  88,
 93,  71,  71,  74,  73,  88,  74,  73,  73,  74,  73,  88,  73,  88,  71,  74,
 73,  73,  73,  94,  94,  90,  94,  94,  50,  94,  97,  93,  90,  90,  94,  94,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  96,  96,  96,  96,  97, 102,  93,
102,  96, 108, 102, 108, 102, 108, 102, 108, 108, 102, 102, 116, 102, 102, 105,
102, 106, 102, 113, 113, 113, 113, 108, 113, 116, 108, 113, 103, 125, 108, 113,
113, 113, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 124, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 124, 124, 134, 134, 145, 132, 132, 132, 141, 134, 141, 134, 132, 132,
132, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 153, 153,
134, 153, 153, 153, 153, 169, 169, 175, 169, 187, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  41,  57,  66,  41,  52,  52,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 74,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,
 93,  74,  74,  74,  74,  88,  74,  74,  74,  82,  74,  88,  93,  88,  74,  74,
 73,  74,  73,  74,  94,  94,  94,  94,  50,  94,  82,  93,  82,  82,  94,  82,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94,  94,  94,  97,  82,  93,
102, 102, 108, 102, 106, 102, 108, 102, 108, 108, 110, 102, 116, 106, 102, 105,
102, 106, 102, 102, 113, 108, 113, 108, 113, 116, 108, 113, 116, 125, 108, 113,
113, 113, 113, 137, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 132, 124, 134, 134, 124, 132, 134, 132, 124, 134, 124, 134, 134, 132,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 132, 134, 134, 134,
134, 134, 134, 141, 134, 153, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 153, 134, 134, 134, 187, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  40,  40,  40,  66,  66,  40,  40,  40,  40,  66,  40,  66,  66,
 79,  54,  40,  66,  79,  79,  79,  54,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  88,  71,
 93,  71,  71,  71,  71,  88,  71,  71,  71,  68,  68,  71,  79,  71, 100, 100,
 71,  71, 100,  90,  90, 100,  90, 100,  87,  90,  90, 100, 100, 100,  90,  90,
 90,  93,  90,  90,  90,  90,  96, 100, 100, 106, 106, 106, 100,  96,  90,  84,
106, 106, 100, 106, 100, 106, 106, 106, 100, 106, 106, 106, 103, 100, 125, 103,
100, 100, 125, 125, 125, 125, 125, 125, 125, 103, 128, 125, 103, 100, 128, 125,
125, 125, 125, 107, 125, 128, 107, 107, 107, 107, 141, 107, 128, 120, 107, 145,
107, 107, 128, 107, 107, 107, 128, 141, 107, 107, 107, 141, 107, 120, 128, 141,
141, 128, 141, 156, 120, 128, 145, 141, 141, 141, 141, 128, 141, 141, 141, 141,
141, 153, 153, 153, 141, 156, 153, 153, 153, 141, 153, 153, 141, 153, 153, 153,
153, 153, 153, 141, 153, 156, 141, 153, 153, 153, 153, 150, 153, 153, 153, 175,
150, 150, 150, 153, 150, 150, 150, 175, 150, 150, 150, 150, 153, 150, 150, 150,
150, 150, 150, 150, 175, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 52,  54,  74,  66,  74,  54,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,
 93,  74,  74,  74,  73,  88,  74,  74,  73,  74,  74,  88,  93,  88,  71,  74,
 73,  94,  93,  94,  94,  94,  94,  94,  50,  94,  97,  93,  94,  90,  94,  94,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94, 102, 106,  97, 102,  93,
102, 110, 108, 102, 106, 102, 108, 102, 108, 108, 110, 102, 116, 106, 102, 105,
102, 106, 113, 113, 113, 113, 113, 108, 113, 116, 108, 113, 116, 125, 108, 113,
113, 113, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 132, 124, 134, 134, 145, 132, 132, 132, 132, 134, 141, 132, 132, 132,
132, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 153, 153, 153, 169, 169, 187, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  41,  41,  66,  66,  41,  41,  66,  66,  66,  66,  66,  66,
 66,  66,  40,  66,  66,  66,  66,  88,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  88,  79,
 79,  79,  79,  92,  79,  88,  79,  79,  79,  92,  79,  79,  79,  79, 100, 100,
 79,  79, 100,  79,  79, 100,  79, 100,  87, 106,  94, 106, 100, 100, 106, 106,
106,  93, 106, 106, 106, 106,  94, 106, 100, 106, 106, 106, 100, 102, 106, 106,
106, 106, 100, 106, 100, 106, 106, 106, 106, 106, 106, 106, 102, 100, 106, 110,
106, 100, 106, 113, 125, 125, 125, 125, 125, 113, 125, 125, 113, 100, 128, 125,
125, 125, 125, 125, 125, 140, 125, 137, 125, 125, 125, 124, 128, 137, 125, 125,
125, 125, 128, 125, 125, 125, 128, 125, 125, 125, 125, 124, 125, 137, 128, 125,
125, 128, 125, 140, 134, 128, 145, 124, 153, 132, 153, 128, 141, 153, 153, 153,
134, 153, 153, 153, 153, 128, 153, 153, 153, 134, 153, 153, 141, 153, 153, 153,
153, 153, 153, 153, 153, 156, 153, 153, 153, 153, 153, 134, 153, 153, 153, 153,
153, 153, 153, 153, 153, 153, 153, 153, 153, 150, 153, 153, 153, 153, 150, 169,
153, 169, 150, 150, 150, 150, 169, 169, 150, 169, 150, 169, 169, 169, 169, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  73,  74,  73,  88,  74,  74,  73,  74,  94,  88,  93,  88,  73,  74,
 73,  94,  93,  94,  94,  94,  94,  94,  50,  94,  97,  93,  94,  90,  94,  94,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94, 102, 106,  97, 102,  93,
102, 110, 108, 102, 106, 102, 108, 102, 108, 108, 110, 102, 116, 106, 102, 105,
113, 106, 113, 113, 113, 113, 113, 108, 113, 116, 108, 113, 116, 125, 108, 113,
113, 113, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 124, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 132, 124, 134, 134, 145, 132, 132, 132, 141, 134, 141, 132, 132, 132,
132, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 141,
134, 134, 134, 141, 134, 153, 141, 153, 153, 134, 153, 134, 134, 153, 153, 153,
134, 153, 153, 153, 153, 169, 153, 178, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  54,  54,  41,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  54,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  71,  54,  54,  71,  71,  54,  88,  73,  73,  88,  88,
 93,  73,  73,  73,  73,  88,  73,  73,  73,  78,  73,  88,  93,  88,  73,  90,
 73,  73,  93,  73,  94,  90,  93,  90,  50,  94,  91,  93,  90,  90,  96,  91,
 96,  93,  88,  96,  96,  96, 105,  96, 106,  96,  96,  96,  96, 105,  98,  93,
 96,  96, 108, 102, 108, 102, 108, 113, 108, 108, 113, 113, 103, 113, 113, 105,
113, 113, 113, 113, 113, 113, 113, 113, 103, 103, 108, 113, 103, 125, 108, 124,
145, 124, 124, 124, 124, 125, 124, 137, 124, 124, 141, 132, 125, 137, 124, 145,
124, 141, 124, 124, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 128, 141,
141, 141, 141, 141, 134, 153, 145, 141, 141, 141, 141, 141, 141, 141, 141, 141,
141, 141, 141, 141, 141, 153, 141, 141, 141, 126, 141, 134, 141, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 126, 153, 153, 175, 175,
175, 175, 175, 153, 175, 169, 175, 175, 175, 175, 175, 175, 175, 175, 175, 169,
175, 169, 175, 175, 175, 175, 175, 169, 175, 169, 175, 175, 169, 199, 175, 175,
175, 199, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  52,  52,  52,  52,
 52,  52,  57,  74,  52,  52,  52,  50,  74,  52,  74,  74,  54,  74,  74,  74,
 74,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  74,  88,  74,  74,  88,  93,  88,  73,  74,
 88,  94,  93,  94,  97,  94,  88,  94,  50,  97,  97,  93,  94,  94,  97,  94,
 97,  93,  97,  97,  97,  97,  97,  94, 106,  97,  97,  97,  94, 105, 102,  93,
102,  97, 108, 110, 108, 102, 108, 116, 108, 108, 110, 102, 105, 110, 102, 105,
110, 110, 113, 116, 113, 108, 113, 108, 116, 116, 108, 113, 105, 113, 108, 113,
116, 116, 124, 132, 124, 125, 124, 137, 124, 124, 116, 132, 108, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 132, 137, 132, 124, 137, 125, 124,
132, 124, 132, 124, 134, 134, 145, 132, 132, 152, 132, 134, 132, 132, 132, 132,
152, 134, 134, 134, 132, 153, 134, 134, 134, 152, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 178,
134, 134, 134, 169, 187, 169, 169, 187, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 187, 169, 187, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
202, 169, 210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  41,  41,  66,  54,  41,  41,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  74,  54,  54,  74,  54,  79,  54,  54,
 54,  54,  54,  74,  79,  74,  79,  71,  71,  71,  71,  74,  71,  71,  88,  71,
 93,  71,  71,  71,  73,  88,  71,  71,  73,  94,  71,  88,  93,  88,  71,  90,
 73,  94,  93,  94,  94,  90,  93,  90,  50,  94,  94,  93,  90,  90,  94,  94,
 94,  93,  94,  94,  94,  94,  97,  96, 106,  96,  96,  96, 106, 102, 102,  93,
102, 102, 108, 102, 106, 102, 108, 102, 102, 108, 113, 113, 113, 106, 113, 116,
113, 106, 113, 113, 113, 113, 113, 113, 113, 113, 108, 113, 103, 125, 128, 113,
113, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 137, 128, 141,
124, 141, 141, 141, 134, 153, 145, 141, 141, 132, 141, 153, 141, 141, 141, 141,
141, 141, 141, 153, 141, 153, 141, 153, 134, 134, 153, 134, 141, 153, 141, 141,
153, 153, 141, 141, 153, 153, 141, 141, 153, 153, 153, 134, 153, 153, 153, 141,
153, 153, 153, 153, 153, 169, 153, 175, 153, 175, 169, 169, 153, 169, 175, 169,
169, 169, 175, 169, 175, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  41,  54,  66,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  54,  54,  54,  74,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  74,  54,  54,  71,  71,  71,  88,  71,  71,  88,  88,
 93,  73,  73,  94,  73,  88,  73,  73,  73,  94,  73,  88,  93,  88,  73,  90,
 73,  73,  93,  94,  94,  90,  93,  90,  50,  94,  94,  93,  90,  90,  94,  96,
 96,  93,  88,  96,  96,  96,  97,  96, 106,  96,  96,  96,  96, 105, 102,  93,
102,  96, 108, 102, 106, 102, 108, 113, 102, 108, 113, 113, 116, 113, 113, 105,
113, 113, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 103, 125, 128, 113,
113, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 124, 124, 124, 124, 124, 141, 141, 124, 124, 141, 141, 137, 128, 141,
141, 141, 141, 141, 134, 153, 145, 141, 141, 141, 141, 153, 141, 141, 141, 141,
141, 141, 141, 141, 141, 153, 141, 141, 134, 141, 141, 134, 141, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 134, 153, 153, 153, 175,
175, 153, 175, 153, 175, 169, 175, 175, 175, 175, 175, 175, 169, 175, 175, 169,
175, 169, 175, 175, 175, 175, 169, 169, 175, 169, 175, 175, 169, 199, 175, 175,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 57,  41,  57,  66,  74,  52,  74,  50,  57,  74,  74,  74,  66,  74,  74,  74,
 74,  79,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,
 93,  74,  74,  74,  74,  88,  74,  74,  74,  74,  74,  88,  93,  88,  74,  74,
 74,  74,  93,  74,  94,  94,  94,  94,  50,  94,  97,  93,  82, 106,  94,  82,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94,  94, 106,  97, 117, 109,
110, 109, 108, 110, 106, 110, 117, 110, 108, 117, 110, 110, 116, 106, 110, 116,
110, 106, 110, 116, 110, 113, 119, 108, 119, 116, 117, 119, 116, 125, 108, 119,
116, 119, 119, 137, 119, 125, 124, 137, 124, 124, 116, 132, 125, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 137, 137, 132, 124, 137, 128, 124,
132, 137, 132, 125, 134, 137, 139, 132, 132, 132, 132, 134, 132, 137, 132, 132,
132, 161, 161, 134, 161, 153, 161, 161, 134, 134, 134, 134, 132, 134, 134, 161,
134, 134, 134, 154, 134, 153, 161, 161, 134, 134, 134, 134, 134, 134, 134, 161,
134, 134, 134, 153, 187, 134, 187, 187, 187, 187, 187, 187, 169, 187, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
202, 169, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 74,  54,  74,  66,  54,  54,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  88,  73,  74,  94,  88,  93,  88,  94,  94,
 93,  94,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  94,  94,  94,  97,  94, 106,  94,  94, 110, 106,  97, 102,  93,
110, 110, 108, 110, 106, 110, 108, 110, 108, 108, 110, 113, 116, 110, 113, 116,
113, 106, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 116, 125, 108, 113,
113, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 124, 124, 124, 132, 137, 132, 124, 137, 128, 124,
132, 124, 132, 141, 134, 134, 145, 132, 132, 132, 141, 134, 141, 132, 132, 132,
132, 161, 141, 134, 132, 153, 141, 161, 134, 134, 134, 134, 141, 134, 161, 141,
134, 134, 134, 141, 153, 153, 141, 153, 153, 153, 153, 134, 134, 153, 153, 178,
153, 153, 153, 153, 178, 169, 153, 178, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 187, 169, 175, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  76,  76,  57,  76,  41,  76,  76,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  74,  54,  52,  52,  52,
 85,  54,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,  74,  74,  88,  88,
 93,  88,  88,  74,  88,  88,  74,  88,  88,  74,  97,  88,  88,  88,  94,  74,
 88,  88,  93,  97,  97,  94,  88,  97,  50,  97,  97,  93,  94,  94,  97,  97,
 97,  93,  88,  97,  97,  97, 105,  97, 106,  97,  97,  97,  97, 105, 105,  97,
 97,  97, 108, 116, 108, 116, 108, 105, 108, 108, 116, 116, 105, 110, 116, 105,
116, 110, 116, 116, 116, 116, 116, 108, 116, 105, 108, 116, 105, 113, 108, 116,
116, 116, 116, 132, 124, 124, 124, 137, 132, 132, 116, 105, 108, 137, 132, 145,
132, 132, 137, 132, 132, 132, 124, 124, 132, 132, 132, 132, 132, 137, 137, 132,
132, 132, 132, 124, 134, 134, 145, 152, 132, 152, 132, 134, 132, 132, 132, 132,
152, 132, 132, 134, 152, 153, 152, 161, 134, 152, 134, 134, 141, 134, 152, 161,
161, 134, 152, 141, 152, 141, 141, 152, 134, 152, 134, 152, 134, 134, 134, 178,
152, 181, 181, 169, 181, 169, 181, 181, 181, 181, 181, 181, 169, 181, 181, 169,
181, 169, 181, 181, 181, 181, 169, 169, 181, 169, 181, 169, 169, 202, 169, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  66,  41,  41,  41,  41,  41,  41,  41,  66,  66,
 41,  66,  57,  66,  66,  66,  66,  88,  74,  79,  79,  74,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  79,  79,  79,  74,  79,  79,  88,  79,
 79,  79,  79,  74,  79,  88,  74,  74,  79,  74,  74,  74,  79,  79,  79,  74,
 79,  79,  79,  74,  94, 106,  94, 106,  50,  94,  94,  93, 106, 106,  94, 106,
106,  93,  94,  94, 106, 106,  97, 106, 100, 106, 106, 106, 106, 110, 106, 106,
106, 106, 100, 106, 100, 106, 117, 110, 106, 106, 106, 106, 110, 106, 106, 116,
106, 106, 110, 110, 113, 125, 113, 125, 113, 119, 117, 125, 119, 125, 128, 125,
122, 122, 125, 137, 125, 125, 125, 137, 125, 125, 122, 132, 125, 137, 125, 125,
125, 125, 137, 137, 125, 125, 125, 125, 125, 137, 137, 124, 125, 137, 128, 125,
124, 125, 137, 125, 137, 128, 145, 132, 137, 132, 124, 137, 154, 137, 137, 161,
132, 161, 161, 134, 161, 128, 161, 161, 134, 134, 134, 134, 154, 134, 161, 153,
153, 134, 161, 154, 153, 153, 153, 153, 153, 153, 153, 134, 134, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 187, 153, 187, 187, 187, 153, 187, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  41,  66,  54,  41,  41,  41,  41,  54,  54,  54,  54,
 74,  54,  74,  66,  54,  54,  74,  50,  74,  74,  74,  74,  79,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  79,  74,  74,  74,  79,  74,  74,  74,  88,  88,
 93,  74,  88,  74,  88,  88,  74,  88,  88,  74,  94,  88,  93,  88,  94,  94,
 93,  94,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  94,  94,  94,  97,  94, 106,  94,  94, 110, 106, 116, 102,  93,
110, 110, 108, 110, 106, 110, 108, 110, 102, 108, 110, 113, 116, 113, 113, 116,
113, 106, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 116, 125, 108, 113,
122, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 124, 124, 124, 124, 124, 124, 132, 137, 132, 124, 137, 128, 124,
132, 124, 132, 141, 134, 137, 145, 132, 132, 132, 141, 153, 141, 132, 132, 141,
132, 141, 141, 134, 141, 153, 141, 153, 134, 152, 161, 134, 141, 134, 141, 141,
153, 153, 141, 141, 153, 153, 141, 141, 153, 153, 153, 134, 153, 153, 153, 178,
153, 153, 153, 153, 178, 169, 153, 178, 169, 187, 187, 187, 169, 169, 187, 169,
169, 169, 187, 169, 175, 169, 169, 169, 169, 169, 169, 169, 169, 202, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  52,
 52,  76,  52,  52,  52,  52,  52,  50,  52,  52,  85,  52,  52,  52,  85,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  74,  85,  85,  85,  85,  85,  74,
 85,  85,  93,  85,  97,  97,  88,  97,  50,  97,  97,  97,  97,  97,  97,  97,
 97,  93,  88,  97,  97,  97,  87,  97, 109,  97,  97,  97,  97, 105, 105,  97,
 97,  97, 108, 116, 108, 116, 117, 105, 108, 108, 116, 116, 105, 116, 116, 105,
116, 116, 116, 105, 116, 116, 116, 116, 116, 105, 108, 116, 105, 122, 108, 116,
116, 116, 116, 105, 116, 122, 116, 137, 116, 132, 116, 105, 108, 137, 132, 116,
132, 132, 137, 132, 132, 132, 132, 132, 132, 132, 137, 132, 132, 137, 137, 132,
132, 132, 132, 132, 137, 137, 145, 152, 152, 152, 132, 161, 132, 152, 152, 152,
152, 152, 161, 152, 152, 161, 152, 161, 152, 152, 152, 134, 152, 152, 152, 152,
152, 152, 152, 152, 152, 161, 152, 152, 134, 152, 152, 152, 134, 152, 152, 152,
152, 152, 152, 169, 181, 169, 181, 152, 181, 152, 187, 181, 169, 187, 181, 187,
181, 169, 181, 187, 181, 187, 187, 187, 187, 169, 187, 169, 169, 187, 202, 202,
202, 202, 202, 202, 202, 210, 202, 202, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  41,  66,  41,  41,  41,  41,  41,  41,  41,  66,  66,
 74,  66,  74,  66,  66,  79,  79,  50,  74,  74,  79,  74,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  74,  79,  79,  74,  79,  79,  88,  74,
 93,  74,  79,  74,  79,  88,  74,  74,  79,  74,  74,  88,  93,  88,  79,  74,
 93,  94,  79,  94,  94, 106,  93, 106,  50,  94,  94,  93, 106, 106,  94,  94,
 94,  93,  93,  94,  94,  94,  97, 106, 106, 106, 106, 106, 106, 110, 102,  93,
106, 106, 108, 110, 106, 110, 108, 110, 106, 110, 110, 110, 110, 106, 110, 116,
106, 106, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 116, 125, 128, 113,
122, 122, 125, 137, 125, 125, 125, 137, 124, 125, 124, 132, 125, 137, 125, 145,
125, 124, 137, 137, 124, 124, 125, 125, 124, 124, 137, 132, 124, 137, 128, 124,
124, 125, 132, 125, 137, 137, 145, 132, 132, 132, 154, 153, 154, 132, 132, 132,
132, 161, 161, 134, 161, 153, 161, 161, 134, 134, 161, 134, 154, 134, 161, 153,
153, 153, 161, 141, 153, 153, 153, 153, 153, 153, 153, 134, 153, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 187, 153, 187, 187, 187, 153, 187, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  66,  66,  41,  41,  41,  41,  66,  66,  66,  66,
 66,  66,  57,  66,  66,  66,  66,  88,  57,  66,  66,  66,  66,  66,  79,  79,
 79,  79,  79,  74,  79,  79,  79,  79,  79,  79,  79,  74,  79,  79,  88,  79,
 79,  92,  92,  92,  92,  88,  92,  92,  92,  92,  92,  92,  79,  92,  92,  92,
 92,  92,  79,  92,  92,  92,  92,  92,  87,  92,  92,  93, 106, 106, 106, 106,
106,  93,  94, 106, 106, 106,  94, 106, 100, 106, 106, 106, 106, 110, 117, 106,
106, 106, 100, 106, 100, 106, 117, 106, 106, 106, 106, 106, 110, 106, 106, 110,
106, 106, 106, 110, 106, 106, 106, 125, 119, 110, 117, 125, 119, 140, 128, 125,
121, 125, 125, 137, 125, 125, 125, 137, 125, 125, 122, 137, 140, 137, 125, 125,
125, 125, 137, 137, 125, 125, 125, 125, 125, 137, 137, 137, 125, 137, 128, 125,
125, 125, 137, 140, 137, 128, 138, 132, 137, 132, 125, 137, 125, 137, 137, 161,
137, 161, 161, 161, 161, 128, 161, 161, 134, 134, 161, 134, 154, 161, 161, 161,
161, 161, 161, 154, 161, 153, 153, 153, 153, 153, 153, 134, 134, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 187, 153, 187, 187, 187, 153, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 187, 169, 169, 187, 187, 187,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  66,  41,  41,  41,  41,  41,  76,  76,  76,  76,
 74,  76,  74,  66,  74,  74,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 74,  79,  74,  74,  74,  74,  79,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  74,  74,  74,  74,  88,  93,  88,  94,  74,
 93,  94,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  94,  94,  94,  97,  94, 106, 109, 109, 110, 106,  97, 110,  93,
110, 110, 108, 110, 106, 110, 108, 110, 110, 108, 110, 110, 116, 106, 110, 116,
110, 106, 110, 119, 119, 113, 119, 113, 119, 116, 108, 119, 116, 125, 108, 119,
122, 122, 122, 137, 125, 125, 124, 137, 124, 124, 122, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 125, 124, 124, 132, 137, 132, 124, 137, 128, 124,
132, 124, 132, 125, 137, 137, 145, 132, 132, 132, 132, 161, 154, 132, 132, 132,
132, 161, 161, 161, 161, 153, 161, 161, 134, 134, 161, 134, 154, 161, 161, 161,
161, 161, 161, 141, 161, 153, 178, 161, 153, 161, 161, 134, 134, 153, 153, 178,
187, 187, 177, 153, 178, 169, 187, 187, 187, 187, 187, 187, 169, 187, 187, 169,
187, 169, 187, 187, 187, 187, 187, 169, 187, 169, 187, 169, 169, 187, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  74,  76,  76,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 74,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  88,  74,  88,  88,  74,  88,  88,  74,  74,  88,  93,  88,  94,  74,
 93,  88,  93,  94,  97,  94,  93,  94,  50,  94,  97,  93,  94, 106,  97,  94,
 97,  93,  88,  97,  97,  97,  97, 109, 106, 109, 109, 109, 109, 116, 110,  93,
110, 109, 108, 110, 106, 110, 108, 116, 110, 108, 116, 116, 116, 110, 116, 116,
110, 121, 116, 116, 119, 119, 119, 119, 116, 116, 108, 119, 116, 125, 108, 122,
116, 122, 122, 132, 122, 125, 124, 137, 124, 124, 139, 132, 125, 137, 124, 145,
124, 132, 137, 137, 132, 132, 124, 124, 132, 132, 137, 132, 132, 137, 125, 132,
132, 132, 132, 154, 137, 137, 145, 132, 132, 163, 132, 161, 154, 132, 132, 132,
152, 161, 161, 161, 161, 153, 161, 161, 161, 152, 161, 134, 154, 161, 161, 161,
161, 161, 161, 178, 161, 153, 178, 161, 161, 161, 161, 152, 134, 161, 177, 178,
187, 187, 187, 153, 178, 169, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  76,  41,  57,  41,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 74,  76,  74,  66,  74,  74,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  79,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  74,  93,  74,  94,  88,  93,  88,  94,  74,
 93,  94,  93,  94,  94, 106,  93,  94,  50,  94,  97,  93, 106, 106,  94,  94,
 94,  93,  88,  94,  94, 109,  97, 109, 106, 109, 109, 110, 106, 116, 110,  93,
110, 110, 108, 110, 106, 110, 110, 110, 110, 110, 110, 110, 116, 106, 119, 116,
110, 106, 119, 119, 119, 119, 119, 119, 119, 116, 137, 119, 116, 125, 125, 122,
122, 122, 122, 132, 125, 125, 124, 137, 124, 124, 122, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 125, 124, 132, 132, 137, 132, 132, 137, 128, 124,
132, 124, 132, 154, 137, 137, 145, 132, 132, 132, 154, 161, 154, 132, 132, 154,
132, 161, 161, 161, 161, 153, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 153, 178, 178, 153, 161, 161, 134, 177, 177, 177, 178,
177, 177, 177, 153, 178, 169, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  41,  66,  66,  41,  41,  66,  66,  66,  66,  66,  66,
 74,  66,  74,  66,  66,  79,  79,  88,  74,  79,  79,  74,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  74,  79,  79,  74,  79,  79,  88,  88,
 93,  79,  79,  74,  93,  88,  74,  74,  93,  74,  94,  88,  93,  88, 106,  74,
 93,  94,  93,  94,  94, 106,  93, 106,  87,  94,  94,  93, 106, 106,  94,  94,
 94,  93,  93,  94,  94,  94,  97, 106, 106, 106, 106, 110, 106, 118, 110,  93,
110, 110, 108, 110, 106, 110, 110, 110, 110, 110, 110, 110, 116, 106, 113, 116,
113, 106, 113, 119, 119, 125, 119, 125, 119, 116, 137, 122, 116, 125, 140, 122,
122, 122, 125, 137, 125, 125, 125, 137, 124, 125, 122, 132, 125, 137, 125, 145,
125, 124, 137, 137, 124, 124, 125, 125, 124, 132, 137, 132, 124, 137, 128, 154,
132, 125, 132, 159, 137, 137, 145, 132, 154, 132, 154, 161, 154, 154, 154, 154,
132, 161, 154, 161, 154, 153, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 141, 153, 153, 178, 178, 153, 153, 153, 187, 153, 153, 153, 178,
177, 177, 177, 153, 178, 169, 177, 178, 187, 187, 187, 187, 153, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  41,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  74,  74,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  88,  93,  74,  94,  88,  93,  88,  94,  74,
 93,  94,  93,  94,  94, 106,  93,  94,  50,  94,  97,  93, 106, 106,  94,  94,
 94,  93,  88, 109, 109, 109,  97, 109, 106, 109, 109, 109, 106, 118, 110,  93,
110, 110, 108, 110, 106, 110, 110, 110, 110, 110, 110, 110, 116, 121, 119, 116,
110, 106, 119, 119, 119, 119, 119, 119, 119, 116, 137, 122, 116, 125, 125, 122,
122, 122, 122, 132, 125, 125, 124, 137, 124, 124, 139, 132, 125, 137, 124, 145,
124, 124, 137, 137, 132, 132, 125, 124, 132, 132, 137, 132, 132, 137, 128, 154,
132, 132, 132, 154, 137, 137, 145, 132, 132, 132, 154, 161, 154, 132, 132, 154,
132, 161, 161, 161, 161, 153, 161, 161, 161, 152, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 153, 178, 178, 153, 161, 161, 187, 177, 177, 177, 178,
187, 187, 177, 153, 178, 187, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  41,  57,  76,  66,  66,  76,  76,  76,  76,  66,  76,  66,  54,
 74,  54,  74,  66,  79,  79,  79,  50,  74,  74,  79,  74,  79,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  74,  79,  93,  74,  79,  79,  88,  88,
 93,  93,  93,  74,  93,  88,  94,  88,  93,  74,  94,  88,  93,  88, 106,  94,
 93,  94,  93,  94,  94, 106,  93, 106,  87,  94,  94,  93, 106, 106,  94,  94,
 94,  93,  93,  94,  94,  94,  97, 106, 106, 110, 110, 110, 106, 116, 110,  93,
110, 110, 108, 110, 106, 110, 113, 110, 113, 113, 110, 113, 116, 106, 113, 116,
113, 106, 113, 119, 113, 113, 119, 113, 119, 116, 137, 122, 116, 125, 140, 122,
122, 122, 125, 132, 125, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 125, 124, 124, 132, 137, 132, 124, 137, 128, 154,
132, 154, 154, 141, 137, 153, 145, 154, 154, 132, 141, 153, 141, 154, 154, 154,
132, 154, 141, 161, 141, 153, 141, 141, 161, 132, 161, 161, 141, 161, 141, 141,
153, 153, 178, 141, 178, 153, 178, 178, 153, 178, 178, 187, 153, 153, 178, 178,
178, 178, 178, 153, 178, 169, 178, 178, 187, 187, 187, 187, 153, 187, 187, 187,
187, 169, 175, 187, 175, 187, 187, 187, 202, 169, 202, 202, 169, 202, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  74,  50,  74,  74,  74,  74,  79,  74,  74,  74,
 74,  93,  74,  74,  74,  74,  74,  74,  74,  74,  93,  74,  74,  74,  88,  88,
 93,  88,  88,  74,  88,  88,  74,  88,  93,  74,  94,  88,  93,  88,  94,  94,
 93,  88,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  97, 109, 109,  97, 109, 106, 109, 109, 110, 109, 118, 110,  93,
110, 110, 108, 110, 106, 110, 110, 116, 110, 119, 110, 119, 116, 121, 119, 116,
119, 121, 119, 116, 119, 119, 119, 119, 119, 116, 137, 122, 116, 125, 108, 122,
122, 122, 122, 132, 122, 125, 124, 137, 124, 124, 139, 132, 125, 137, 124, 145,
124, 132, 137, 137, 132, 132, 124, 124, 132, 132, 137, 132, 132, 137, 125, 154,
132, 132, 132, 154, 137, 137, 145, 132, 132, 163, 154, 161, 154, 154, 132, 154,
152, 161, 161, 161, 154, 153, 161, 161, 161, 152, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 178, 178, 178, 161, 178, 178, 152, 177, 177, 178, 178,
178, 187, 178, 153, 178, 187, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 202, 187, 187, 187, 202, 169, 202, 202, 169, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  57,  76,  76,  76,  76,  50,  76,  76,  76,  76,  76,  76,  76,  85,
 85,  76,  85,  74,  85,  74,  74,  85,  85,  74,  85,  85,  85,  85,  85,  85,
 85,  85,  85,  85,  85,  85,  74,  85,  85,  74,  85,  85,  85,  85,  74,  74,
 85,  85,  93,  85,  85, 109,  85, 109,  50, 109,  97,  93, 117, 117, 109, 117,
109,  93,  88, 109, 109, 109,  97, 109, 109, 109, 109, 109, 109, 118, 117, 118,
109, 109, 117, 109, 117, 109, 117, 118, 117, 117, 118, 116, 116, 109, 117, 118,
109, 109, 116, 116, 116, 117, 116, 117, 116, 118, 117, 116, 116, 121, 108, 116,
116, 116, 116, 117, 122, 122, 139, 137, 139, 137, 139, 116, 138, 137, 139, 139,
139, 139, 137, 137, 139, 137, 137, 139, 139, 137, 137, 132, 132, 137, 137, 139,
132, 137, 132, 138, 137, 137, 139, 158, 161, 163, 132, 161, 139, 161, 161, 161,
163, 161, 161, 161, 161, 161, 161, 161, 161, 163, 161, 161, 158, 161, 161, 161,
161, 161, 161, 154, 161, 161, 161, 161, 161, 161, 161, 152, 161, 161, 161, 161,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
202, 202, 202, 202, 202, 202, 202, 202, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  54,  54,  41,  54,  66,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  79,  54,  54,  54,  88,  54,  54,  54,  79,  54,  79,  54,  54,
 93,  93,  93,  74,  93,  79,  93,  93,  93,  93,  93,  88,  93,  93,  88,  93,
 93,  93,  93,  88,  93,  88,  94,  93,  93,  94,  93,  88,  93,  93,  93, 106,
 93,  93,  93,  93,  93, 106,  93, 106,  87,  94,  94,  93, 106, 106,  94, 102,
110, 145,  93, 110, 110, 110, 118, 106, 106, 110, 110, 110, 106, 116, 113, 145,
113, 113, 108, 113, 125, 113, 113, 113, 113, 113, 113, 113, 113, 125, 113, 116,
113, 125, 113, 113, 113, 125, 113, 125, 124, 145, 125, 125, 132, 145, 128, 124,
145, 141, 141, 124, 141, 125, 141, 137, 141, 141, 145, 132, 125, 137, 141, 145,
141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 128, 141,
141, 141, 141, 141, 153, 153, 145, 141, 141, 141, 141, 141, 145, 141, 141, 141,
141, 141, 141, 141, 141, 153, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141,
141, 141, 141, 141, 175, 175, 175, 175, 153, 175, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 199, 199, 199, 199,
199, 199, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  76,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  93,  74,  74,  74,  88,  88,
 93,  74,  93,  74,  93,  88,  74,  88,  93,  74,  74,  88,  93,  88,  93,  74,
 93,  93,  93,  94, 109, 106,  93, 109,  87, 109,  97,  93, 106, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
110, 109, 108, 110, 106, 110, 110, 118, 110, 119, 121, 119, 116, 121, 119, 118,
121, 121, 121, 119, 119, 122, 119, 119, 119, 118, 137, 122, 116, 138, 140, 122,
121, 122, 122, 137, 122, 125, 122, 137, 133, 133, 139, 132, 125, 137, 133, 145,
133, 132, 137, 137, 132, 132, 125, 133, 132, 132, 137, 132, 132, 137, 140, 154,
132, 154, 132, 154, 137, 137, 145, 154, 154, 163, 154, 161, 154, 154, 154, 154,
132, 161, 161, 161, 161, 153, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 177, 178, 178, 177, 161, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  50,  85,  85,  85,  74,  54,  85,  85,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  88,  88,  88,  88,  88,  88,
 93,  88,  88,  88,  88,  88,  88,  88,  88,  97,  88,  88,  93,  88,  93,  97,
 88,  88,  93,  88,  88,  97,  88,  97,  50,  97, 105,  93,  97, 109,  97,  97,
 97,  93,  88,  97,  97,  97, 105,  97, 109, 116, 116, 116, 116, 105, 116, 118,
116, 116, 108, 116, 108, 116, 116, 116, 116, 116, 116, 116, 105, 116, 116, 105,
116, 121, 116, 116, 116, 116, 116, 116, 116, 105, 108, 116, 105, 138, 108, 116,
145, 116, 139, 132, 132, 122, 132, 137, 132, 132, 139, 152, 124, 137, 132, 145,
132, 132, 132, 132, 132, 132, 132, 132, 132, 152, 132, 152, 132, 152, 161, 141,
152, 132, 152, 141, 137, 161, 145, 152, 152, 152, 141, 161, 141, 152, 152, 152,
152, 152, 141, 152, 152, 141, 152, 152, 152, 152, 152, 152, 141, 152, 152, 152,
152, 152, 152, 178, 181, 178, 181, 181, 181, 181, 181, 152, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 199, 199, 199, 199, 199,
199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  57,  66,  66,  66,  66,  57,  92,  66,  66,  66,  66,  66,  92,  92,
 92,  66,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
 79,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
 92,  92,  92,  92,  92,  92,  92,  92,  87,  92,  92,  92,  92,  92,  92,  92,
 92,  93,  92,  92,  92,  92,  92,  92, 100,  92,  92, 106, 106, 109, 117, 127,
106, 106, 100, 106, 100, 106, 117, 106, 117, 117, 106, 106, 121, 106, 106, 118,
106, 106, 121, 121, 121, 106, 121, 117, 121, 121, 117, 121, 117, 140, 140, 121,
121, 121, 125, 137, 125, 140, 125, 137, 125, 125, 133, 137, 140, 137, 125, 127,
125, 125, 137, 137, 125, 125, 140, 140, 144, 137, 137, 137, 159, 137, 140, 159,
159, 140, 159, 140, 137, 140, 151, 154, 159, 132, 159, 159, 159, 159, 159, 159,
161, 159, 159, 161, 161, 156, 161, 161, 161, 161, 161, 161, 159, 161, 161, 161,
161, 161, 161, 172, 161, 159, 172, 177, 177, 161, 177, 161, 177, 177, 177, 177,
177, 177, 177, 177, 177, 187, 177, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
202, 187, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 41,  66,  41,  66,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  79,  66,  66,  66,  79,  88,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  79,  79,  92,  79,  79,  79,  79,  79,  79,  79,  92,  79,  79,  92,  79,
 79,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  79,  92, 100, 100,
 92,  92, 100,  92,  92, 100,  92, 100,  87, 100,  92, 100, 100, 100, 106, 106,
106,  93, 106, 106, 106, 106, 106, 100, 100, 106, 106, 106, 100, 106, 106, 127,
106, 106, 100, 106, 100, 106, 106, 106, 100, 140, 106, 140, 106, 100, 140, 127,
140, 100, 140, 125, 140, 140, 140, 140, 140, 127, 140, 140, 125, 140, 128, 140,
140, 140, 140, 125, 140, 140, 140, 137, 140, 140, 140, 125, 140, 137, 140, 145,
140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 156, 140,
140, 140, 140, 140, 156, 156, 145, 159, 159, 154, 156, 156, 140, 156, 159, 159,
154, 156, 156, 156, 156, 156, 156, 156, 153, 154, 156, 153, 159, 156, 156, 156,
156, 153, 153, 156, 156, 156, 156, 156, 156, 153, 156, 153, 153, 153, 153, 156,
153, 153, 153, 156, 153, 153, 153, 209, 153, 209, 209, 209, 156, 209, 209, 209,
209, 153, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 210, 209, 209, 209,
209, 209, 210, 210, 210, 218, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 41,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  76,  85,  74,  76,  76,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  93,  88,  74,  74,  93,  74,  74,  88,  93,  88,  93,  74,
 93, 109,  93, 109, 109, 109,  93, 109,  87, 109,  97,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
109, 109, 108, 121, 106, 121, 117, 118, 110, 117, 121, 121, 118, 121, 121, 118,
121, 121, 121, 121, 121, 121, 121, 122, 122, 118, 137, 122, 116, 138, 140, 122,
121, 122, 122, 137, 133, 138, 133, 137, 139, 133, 139, 132, 125, 137, 133, 127,
133, 133, 137, 137, 146, 146, 144, 138, 146, 137, 137, 132, 146, 137, 140, 146,
132, 137, 154, 138, 137, 161, 145, 154, 161, 163, 154, 161, 154, 161, 161, 154,
132, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 177, 178, 161, 161, 161, 177, 187, 177, 177, 177, 178,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218
};

UInt8 hvqelut_4x2_1b[] = {
 18,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  57,  57,  76,  76,  76,  85,  57,  76,  76,  57,  76,  76,  76,  76,
 76,  76,  76,  57,  76,  74,  74,  74,  74,  74,  74,  74,  74,  74,  85,  74,
 93,  74,  74,  74, 111,  85,  74,  74, 111,  74,  74, 111, 111, 111, 111,  74,
111, 111, 111, 111, 111, 111, 111, 117, 143, 111, 117, 111, 117, 117, 109, 117,
117,  93, 118, 109, 109, 109, 118, 109, 109, 109, 109, 117, 109, 118, 117, 123,
117, 109, 117, 109, 117, 117, 117, 109, 117, 117, 109, 117, 118, 109, 117, 118,
117, 121, 117, 117, 117, 117, 117, 117, 117, 118, 117, 117, 117, 135, 117, 121,
121, 121, 121, 117, 117, 138, 139, 117, 139, 117, 139, 139, 138, 167, 139, 127,
139, 139, 137, 137, 139, 137, 137, 138, 139, 137, 137, 139, 146, 137, 137, 146,
137, 137, 137, 138, 167, 137, 138, 158, 161, 158, 161, 161, 149, 161, 161, 161,
161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 168, 161, 161, 161,
161, 161, 161, 168, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 177,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
202, 202, 202, 202, 202, 210, 202, 202, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  74,  76,  74,  74,  74,  74,  74,  74,  74,  74,  74,  85,  85,
 93,  74,  74,  74, 111,  88,  74, 111, 111,  74, 111,  88,  93,  88, 111,  74,
111, 111,  93, 111, 111, 109,  93, 109, 143, 109, 109,  93, 117, 117, 109, 117,
109,  93, 118, 109, 109, 109, 118, 109, 109, 109, 109, 109, 109, 118, 117, 123,
109, 109, 117, 109, 106, 109, 117, 118, 117, 117, 118, 121, 118, 121, 121, 118,
121, 121, 121, 121, 121, 121, 121, 121, 121, 118, 117, 121, 116, 135, 125, 121,
127, 139, 139, 137, 138, 138, 139, 137, 139, 139, 139, 158, 138, 137, 139, 127,
139, 139, 137, 137, 139, 139, 144, 138, 139, 137, 137, 139, 146, 137, 159, 139,
139, 161, 149, 138, 137, 161, 149, 158, 161, 163, 154, 161, 155, 161, 161, 161,
158, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 168, 161, 177, 161, 161, 161, 161, 161, 187, 161, 177, 177, 178,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  76,  85,  76,  76,  76,  74,  66,  76,  76,  74,
 95,  95,  74,  74,  74,  74,  79,  74,  74,  74,  93,  74,  74,  74,  88,  88,
 93,  74,  93,  74,  93,  88,  74, 111,  93,  74, 111,  88,  93,  93, 111,  74,
 93, 111,  93, 111, 109, 109,  93, 109, 143, 109, 109,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
109, 118, 108, 121, 106, 121, 117, 118, 121, 121, 121, 121, 118, 121, 121, 118,
121, 121, 121, 121, 121, 121, 121, 122, 122, 118, 137, 122, 116, 135, 140, 122,
127, 139, 133, 137, 133, 138, 133, 137, 139, 133, 139, 139, 125, 137, 133, 145,
133, 146, 137, 137, 146, 146, 144, 138, 146, 132, 137, 139, 146, 137, 140, 146,
154, 154, 154, 159, 137, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 161, 161, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 177, 177, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  50,  76,  76,  76,  74,  95,  76,  76,  85,
 93,  93,  85,  74,  88,  74,  93,  88,  88,  93,  93,  88,  93,  93,  88,  88,
 93,  88,  93,  88,  93,  88,  88,  88,  93,  97,  93,  88,  93,  88,  93, 109,
 93,  93,  93,  88,  93, 109,  93, 109,  87, 109,  97,  93, 109, 109, 109, 109,
109,  93, 118, 118, 118, 118, 118, 109, 109, 118, 118, 118, 109, 118, 116, 127,
116, 118, 108, 116, 121, 116, 116, 118, 119, 116, 118, 116, 116, 121, 116, 118,
121, 121, 116, 116, 122, 122, 122, 122, 116, 118, 137, 122, 116, 138, 125, 139,
145, 139, 139, 132, 139, 138, 139, 137, 139, 132, 139, 158, 138, 137, 139, 145,
132, 132, 137, 132, 132, 132, 154, 154, 154, 132, 132, 132, 154, 137, 159, 154,
154, 154, 154, 154, 161, 161, 145, 152, 154, 163, 154, 161, 154, 154, 154, 154,
152, 154, 154, 161, 178, 177, 178, 178, 161, 152, 178, 161, 178, 178, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 178, 178, 178, 152, 181, 178, 178, 178,
181, 181, 181, 178, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 202, 199, 199, 202, 199, 199, 199,
199, 199, 199, 210, 199, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  76,  88,  74,  76,  79,  74,  66,  79,  79,  79,
 95,  95,  79,  74,  79,  74,  79,  79,  74,  79,  79,  74,  79,  79,  88,  93,
 93, 111, 111,  74,  93,  88, 111, 111, 111,  74, 111,  88,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 106,  93, 109, 143, 109, 109,  93, 106, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
121, 127, 106, 121, 106, 121, 117, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 122, 121, 127, 137, 122, 139, 135, 140, 138,
127, 138, 133, 137, 133, 138, 133, 137, 133, 133, 139, 139, 140, 137, 133, 145,
133, 133, 137, 137, 144, 144, 144, 138, 146, 146, 137, 139, 144, 137, 140, 154,
154, 159, 154, 159, 137, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
154, 161, 154, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 172,
161, 161, 177, 178, 177, 177, 178, 177, 177, 177, 177, 187, 177, 177, 177, 178,
177, 177, 177, 177, 178, 187, 177, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 187, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  76,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  57,  66,  66,  66,  66,  88,  79,  79,  66,  66,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  79,  79,  79,  79,  79,  79,  92,  79,  92,  88,  92,
 93,  92,  92,  92,  92,  88,  92,  92,  92,  92,  92, 111,  93, 111,  92,  92,
111, 111, 111,  92, 111, 111, 111,  92, 143, 111, 111, 111, 106, 106, 111, 106,
109,  93, 111, 109, 109, 111, 118, 106, 100, 106, 106, 106, 106, 118, 117, 127,
106, 121, 100, 121, 106, 121, 117, 121, 106, 117, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 127, 117, 121, 137, 151, 140, 121,
127, 138, 144, 137, 144, 140, 144, 137, 144, 144, 138, 139, 140, 137, 144, 127,
144, 144, 137, 137, 144, 144, 140, 159, 144, 144, 137, 144, 159, 137, 140, 159,
159, 159, 159, 159, 137, 159, 145, 154, 159, 158, 159, 159, 159, 159, 159, 159,
161, 159, 159, 161, 172, 156, 161, 159, 161, 161, 161, 161, 172, 161, 161, 172,
177, 177, 177, 172, 177, 172, 172, 177, 177, 177, 177, 187, 177, 177, 177, 177,
177, 177, 177, 177, 177, 187, 177, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 187, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  76,  88,  76,  76,  76,  74,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  79,  74,  74,  74,  93,  74,  93,  93,  88,  93,
 93, 111, 111,  74,  93,  88, 111, 111, 111,  74, 111,  88,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 111,  93, 109, 143, 109, 118,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 121, 127,
121, 127, 108, 121, 135, 121, 117, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 127, 137, 133, 139, 135, 140, 138,
127, 139, 133, 139, 138, 138, 133, 137, 146, 133, 139, 139, 138, 137, 146, 145,
144, 146, 137, 137, 146, 146, 144, 138, 146, 146, 137, 139, 146, 137, 159, 154,
154, 154, 154, 159, 137, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 161, 154, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 154,
161, 161, 178, 178, 177, 177, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
177, 177, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 187, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  76,  76,  95,  95,  95,  95,
 95,  95,  74,  79,  95,  95,  95,  88,  95,  95,  95,  95,  93,  93,  93,  93,
 93,  93,  93,  74,  93,  93,  93,  93,  93,  93,  93,  88,  93,  93,  88,  93,
 93,  93,  93,  88,  93,  88,  93,  93,  93,  94,  93,  88,  93,  93,  93,  94,
 93,  93,  93,  93,  93,  93,  93, 109,  87,  93, 118,  93, 106, 106, 118, 110,
118, 145, 118, 118, 118, 127, 118, 127, 106, 127, 127, 127, 127, 118, 119, 145,
127, 127, 108, 127, 125, 127, 119, 127, 122, 122, 127, 122, 116, 127, 122, 118,
122, 145, 122, 122, 122, 122, 122, 122, 122, 145, 137, 133, 132, 145, 140, 133,
145, 145, 133, 132, 154, 145, 154, 137, 141, 154, 145, 132, 141, 137, 141, 145,
141, 141, 154, 154, 141, 141, 141, 145, 141, 141, 141, 141, 141, 154, 159, 145,
141, 141, 141, 145, 161, 141, 145, 141, 141, 163, 141, 141, 145, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 178, 152, 178, 178, 141, 178, 178, 178,
178, 178, 178, 197, 178, 175, 175, 178, 178, 178, 175, 181, 175, 175, 175, 175,
175, 175, 175, 175, 175, 181, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175,
175, 199, 175, 175, 175, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199,
199, 199, 199, 214, 214, 210, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  95,  76,  76,  76,
 95,  95,  76,  74,  95,  74,  95,  95,  74,  74,  93,  74,  93, 111,  88,  88,
 93, 111, 111, 111, 111,  88, 111, 111, 111,  74, 111,  88,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 111,  93, 109, 143, 109, 118,  93, 109, 109, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 135, 109, 109, 109, 109, 118, 121, 123,
121, 118, 117, 121, 135, 121, 117, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 118, 137, 138, 139, 135, 140, 138,
127, 139, 138, 139, 138, 138, 146, 137, 139, 146, 139, 158, 138, 137, 146, 145,
146, 146, 137, 137, 146, 146, 144, 138, 146, 139, 137, 158, 149, 137, 159, 149,
154, 154, 154, 157, 161, 161, 145, 158, 154, 163, 154, 161, 154, 154, 154, 154,
158, 161, 154, 161, 154, 159, 161, 161, 161, 163, 161, 161, 154, 161, 161, 161,
161, 161, 178, 178, 178, 177, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
187, 187, 187, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 202, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  95,  88,  76,  95,  95,  74,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  95,  95,  74,  79,  93,  74,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111, 111,  93,  74, 111,  88,  93,  93, 111, 111,
 93,  93,  93, 111,  93, 109,  93, 109, 143, 109, 118,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 121, 121, 118, 121, 127,
121, 127, 108, 121, 135, 121, 121, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 122, 122, 127, 137, 133, 139, 135, 140, 138,
127, 139, 133, 139, 133, 138, 133, 137, 146, 133, 139, 158, 138, 137, 133, 145,
133, 146, 137, 137, 146, 154, 144, 138, 154, 154, 137, 154, 154, 137, 159, 154,
154, 154, 154, 159, 161, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
154, 154, 154, 161, 154, 159, 154, 154, 161, 161, 161, 161, 178, 161, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 187, 177, 177, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  76,  85,  76,  85,  85,  85,  85,  85,  85,
 93,  85,  85,  85,  85,  85,  85,  85, 111, 117, 111,  85, 111,  85, 111, 117,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 117, 111, 117, 117, 109, 117,
109, 123, 118, 109, 109, 109, 118, 109, 109, 109, 109, 109, 109, 118, 117, 123,
109, 118, 117, 118, 117, 117, 117, 118, 117, 117, 118, 117, 118, 121, 117, 118,
121, 135, 121, 118, 121, 117, 121, 117, 117, 118, 117, 121, 117, 135, 117, 142,
142, 139, 139, 117, 139, 138, 139, 167, 139, 139, 139, 158, 138, 167, 139, 127,
139, 139, 137, 137, 139, 139, 149, 149, 139, 158, 137, 158, 149, 167, 161, 149,
158, 149, 158, 157, 167, 161, 174, 158, 158, 163, 155, 161, 158, 161, 158, 158,
158, 161, 161, 161, 161, 161, 161, 161, 161, 163, 161, 161, 168, 161, 161, 161,
161, 161, 161, 168, 161, 177, 168, 161, 161, 161, 161, 187, 187, 187, 187, 183,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 187, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 202, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  50,  76,  76,  76,  76,  76,  76,  76,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,
 93,  85,  85,  85,  85,  88,  85,  85,  85,  85,  85,  85,  93,  88,  93, 109,
 93,  85,  93,  85,  88, 109,  93, 109, 143, 118, 118,  93, 109, 109, 118, 109,
118,  93, 118, 118, 118, 118, 118, 118, 109, 118, 118, 118, 118, 118, 116, 123,
118, 118, 108, 118, 121, 118, 116, 118, 116, 116, 118, 116, 118, 121, 116, 143,
121, 127, 116, 116, 116, 116, 116, 139, 116, 143, 137, 139, 158, 138, 138, 139,
127, 139, 139, 158, 139, 138, 139, 137, 158, 139, 158, 163, 138, 137, 139, 145,
139, 158, 137, 158, 158, 158, 139, 158, 158, 158, 158, 158, 158, 137, 161, 158,
158, 158, 158, 154, 161, 161, 145, 163, 158, 163, 158, 161, 158, 158, 163, 163,
163, 154, 154, 152, 163, 161, 152, 161, 152, 163, 152, 152, 163, 152, 152, 178,
178, 152, 152, 178, 178, 178, 178, 178, 178, 178, 178, 152, 187, 178, 178, 178,
181, 181, 181, 177, 181, 187, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 187, 181, 181, 181, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 210, 202, 199, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  66,  76,  66,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  79,  66,  66,  66,  66,  88,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  95,  79,  92,  79,  79,  79,  79,  79,  79,  79,  92,  79,  92,  92,  92,
 93,  92,  92,  92,  92,  88,  92,  92,  92,  92,  92, 111,  93, 111,  92,  92,
111, 111, 111, 111, 111, 111, 111, 106, 143, 111, 111,  93, 106, 106, 111, 106,
106,  93, 127, 111, 106, 106, 118, 106, 100, 106, 106, 106, 106, 118, 121, 127,
121, 127, 140, 121, 140, 121, 121, 127, 106, 121, 127, 121, 121, 135, 121, 127,
140, 151, 121, 121, 121, 140, 121, 125, 121, 127, 137, 133, 133, 140, 140, 138,
127, 138, 144, 133, 140, 140, 144, 137, 144, 144, 142, 133, 140, 137, 144, 145,
159, 159, 140, 159, 159, 159, 140, 159, 159, 159, 159, 154, 159, 137, 140, 159,
159, 159, 159, 159, 137, 159, 145, 154, 159, 154, 159, 159, 159, 159, 159, 159,
154, 159, 159, 159, 172, 156, 172, 159, 161, 161, 172, 161, 172, 177, 172, 172,
172, 177, 172, 172, 177, 172, 172, 172, 177, 177, 177, 187, 177, 177, 177, 172,
177, 177, 177, 177, 177, 177, 177, 178, 177, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 209, 187, 187, 187, 202, 187, 202, 209, 210, 202, 209, 209,
209, 210, 210, 210, 210, 218, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  74,  95,  95,  95,  95,  88,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  88,  93,  93,  93,  93,  93,  93,  93,  88,  93,  93,  88,  93,
 93,  93,  93,  88,  93,  88,  93,  93,  93,  94,  93,  88,  93,  93,  93,  94,
 93,  93,  93,  93,  93,  93,  93,  93,  87,  93, 118, 145, 110, 106, 118, 110,
118, 145, 145, 118, 127, 127, 118, 127, 135, 127, 127, 127, 127, 118, 119, 145,
127, 145, 108, 145, 125, 127, 119, 145, 122, 122, 145, 122, 116, 145, 122, 145,
145, 145, 145, 145, 145, 133, 145, 133, 141, 145, 124, 145, 132, 145, 140, 145,
145, 145, 145, 141, 141, 145, 141, 141, 141, 141, 145, 141, 141, 137, 141, 145,
141, 141, 141, 141, 141, 141, 141, 145, 141, 141, 141, 141, 141, 141, 141, 145,
141, 141, 141, 145, 141, 141, 145, 141, 141, 141, 141, 141, 145, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 141, 181, 141, 178, 145, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 181, 175, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175,
175, 199, 175, 175, 175, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199,
214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  76,  85,  76,  76,  76,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  95,  95,  74,  74,  95,  74, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
111, 111,  93, 111, 111, 111, 111, 109, 143, 111, 118,  93, 109, 109, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 135, 109, 109, 109, 109, 118, 121, 127,
121, 127, 117, 121, 135, 121, 117, 118, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 127, 137, 138, 139, 135, 140, 138,
127, 142, 138, 139, 138, 138, 144, 137, 146, 144, 139, 158, 138, 137, 146, 145,
146, 146, 137, 137, 146, 146, 144, 138, 149, 149, 137, 158, 149, 137, 159, 149,
155, 157, 154, 159, 161, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 161, 154, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 172,
177, 177, 178, 178, 177, 172, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 202, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  99,  99,
 99,  99,  57,  99,  99,  99,  99,  76,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99, 115,  99,  99, 115, 111, 117, 143, 111, 117, 111, 117, 117, 117, 117,
117, 111, 111, 117, 117, 117, 117, 117, 115, 117, 117, 117, 117, 117, 117, 123,
117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 118,
117, 117, 117, 117, 117, 117, 117, 117, 117, 118, 117, 117, 117, 135, 117, 117,
148, 117, 117, 117, 117, 117, 117, 167, 117, 117, 142, 117, 117, 167, 117, 142,
117, 167, 167, 167, 167, 167, 167, 157, 167, 167, 167, 167, 167, 167, 167, 157,
167, 167, 167, 157, 167, 167, 164, 155, 167, 167, 167, 167, 157, 167, 167, 167,
167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 165, 167, 167, 167,
167, 167, 167, 168, 167, 161, 168, 206, 167, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
187, 206, 206, 206, 202, 206, 202, 202, 202, 202, 202, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  95,  88,  76,  95,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  95,  95,  95,  79,  95,  74,  93, 111,  88,  93,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 111,  93, 109, 143, 109, 118,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 135, 109, 118, 118, 121, 118, 121, 127,
121, 127, 106, 121, 135, 121, 121, 118, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 121, 121, 121, 121, 121, 133, 121, 127, 137, 138, 139, 135, 140, 138,
127, 142, 138, 139, 138, 138, 144, 137, 146, 144, 139, 158, 138, 137, 146, 145,
144, 146, 137, 137, 146, 149, 144, 138, 149, 154, 137, 154, 154, 137, 159, 154,
154, 154, 154, 159, 161, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 154, 154, 161, 154, 159, 154, 172, 161, 161, 161, 161, 154, 161, 178, 172,
177, 177, 178, 178, 178, 172, 178, 178, 177, 178, 178, 187, 177, 177, 177, 178,
178, 177, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
111, 111,  93, 111, 111, 111, 123, 111, 143, 111, 118, 123, 109, 109, 109, 109,
109, 123, 118, 118, 109, 123, 118, 123, 135, 118, 123, 118, 123, 118, 121, 123,
121, 127, 117, 127, 135, 121, 121, 118, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 121, 142, 142, 142, 142, 138, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 138, 139, 138, 138, 146, 137, 146, 144, 142, 158, 138, 137, 146, 145,
146, 149, 137, 149, 149, 149, 157, 149, 149, 155, 137, 158, 155, 137, 159, 155,
155, 157, 154, 159, 161, 161, 145, 158, 154, 158, 154, 161, 154, 154, 154, 154,
158, 168, 172, 161, 168, 159, 168, 172, 161, 163, 161, 161, 168, 161, 168, 172,
177, 177, 178, 178, 178, 172, 178, 178, 177, 178, 177, 187, 177, 177, 177, 178,
178, 187, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  95,  66,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  66,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  79,  95,  79,  95,  95,  93,  79,  93,  93,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111, 111,  93, 111, 111,  93,  93,  93,  93, 106,
 93,  93,  93, 111,  93, 106,  93, 106, 143, 123, 118,  93, 106, 106, 123, 109,
127, 136, 127, 127, 127, 127, 118, 127, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 140, 127, 135, 127, 121, 127, 121, 121, 127, 127, 127, 135, 121, 127,
127, 135, 127, 127, 138, 138, 138, 133, 133, 127, 137, 133, 139, 151, 140, 138,
145, 138, 133, 133, 138, 151, 133, 137, 133, 144, 138, 139, 140, 137, 133, 145,
154, 154, 159, 154, 154, 154, 159, 159, 154, 154, 154, 154, 154, 154, 140, 154,
154, 159, 154, 159, 161, 159, 145, 154, 154, 154, 154, 159, 145, 154, 154, 154,
154, 172, 172, 172, 154, 159, 178, 172, 177, 178, 178, 177, 178, 178, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 178, 177, 178, 178, 178,
178, 178, 178, 177, 178, 177, 178, 178, 178, 178, 187, 178, 177, 202, 202, 202,
202, 202, 202, 202, 209, 202, 202, 202, 202, 202, 209, 209, 210, 202, 209, 210,
209, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  76,  76,  95,  95,
 76,  95,  76,  95,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  93,  88,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111, 111,  93, 111, 111,  88,  93,  93,  93, 111,
 93,  93,  93, 111, 123, 123, 123, 109, 143, 123, 118, 123, 109, 109, 123, 109,
118, 136, 118, 118, 123, 123, 118, 123, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 108, 127, 135, 127, 121, 127, 121, 121, 127, 121, 118, 127, 121, 118,
127, 135, 127, 127, 142, 138, 142, 133, 142, 127, 137, 138, 139, 135, 140, 138,
127, 142, 138, 139, 138, 138, 146, 137, 146, 146, 139, 158, 138, 137, 146, 145,
146, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 137, 159, 154,
154, 154, 154, 154, 161, 161, 145, 154, 154, 163, 154, 154, 174, 154, 154, 154,
158, 154, 154, 154, 154, 159, 178, 178, 161, 163, 178, 161, 178, 178, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 178, 177, 178, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 178, 178, 187, 178, 177, 202, 202, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  95,  76,  76,  95,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 118, 123, 109, 111, 111, 109,
109, 136, 123, 118, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 123,
127, 127, 117, 127, 135, 121, 117, 127, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 142, 139, 138, 138, 144, 137, 149, 144, 142, 158, 138, 137, 149, 145,
149, 149, 137, 149, 149, 149, 157, 157, 155, 155, 155, 158, 155, 137, 159, 155,
155, 157, 165, 159, 161, 161, 174, 158, 168, 158, 168, 161, 165, 168, 168, 168,
158, 168, 172, 161, 168, 159, 168, 172, 161, 158, 168, 161, 168, 161, 168, 172,
177, 177, 183, 178, 177, 172, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
178, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  95,  76,
 76,  95,  76,  95,  95,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 111, 118, 123, 109, 111, 111, 109,
109, 136, 123, 118, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 127,
127, 127, 117, 127, 135, 127, 121, 127, 121, 121, 127, 121, 118, 135, 121, 118,
127, 135, 127, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 142, 139, 138, 138, 144, 137, 149, 144, 142, 158, 159, 137, 149, 145,
149, 149, 157, 149, 149, 155, 157, 157, 155, 155, 155, 155, 157, 137, 159, 155,
155, 157, 165, 159, 161, 161, 145, 154, 168, 158, 168, 172, 174, 168, 168, 168,
158, 172, 172, 161, 168, 159, 168, 172, 161, 158, 172, 161, 172, 177, 172, 172,
172, 177, 178, 178, 178, 172, 178, 178, 177, 178, 177, 187, 177, 177, 177, 178,
178, 177, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  95,  95,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  66,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95, 111,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 123, 111, 111, 111, 111,
111, 136, 123, 111, 111, 123, 118, 123, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 140, 127, 135, 127, 121, 127, 121, 121, 127, 127, 127, 135, 121, 127,
127, 135, 127, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 151, 140, 142,
127, 142, 142, 144, 144, 151, 144, 137, 144, 144, 142, 158, 140, 137, 144, 145,
144, 157, 159, 157, 157, 157, 159, 159, 157, 157, 159, 155, 159, 137, 140, 157,
159, 159, 159, 159, 161, 159, 174, 154, 172, 158, 172, 159, 172, 172, 172, 172,
154, 172, 172, 172, 172, 159, 172, 172, 177, 161, 172, 177, 172, 172, 172, 172,
172, 172, 172, 172, 172, 172, 172, 172, 177, 177, 177, 187, 177, 177, 177, 178,
177, 177, 177, 177, 178, 187, 177, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 218, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  95,  76,  76,  95,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95, 111,  95, 111, 111, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 115,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 111, 117, 115, 111, 111,
111, 123, 111, 111, 111, 111, 118, 111, 135, 111, 111, 111, 123, 118, 117, 123,
123, 123, 117, 123, 135, 148, 117, 127, 117, 117, 127, 121, 118, 135, 121, 118,
148, 135, 142, 142, 142, 142, 142, 142, 142, 127, 117, 142, 139, 135, 140, 142,
127, 142, 142, 139, 142, 151, 142, 167, 142, 144, 142, 158, 151, 167, 149, 127,
157, 157, 167, 157, 157, 157, 157, 157, 157, 155, 157, 155, 157, 167, 159, 157,
157, 157, 157, 151, 167, 167, 174, 165, 165, 158, 165, 161, 165, 168, 168, 168,
158, 172, 172, 161, 168, 159, 168, 172, 161, 161, 168, 161, 168, 161, 168, 172,
172, 183, 183, 172, 183, 172, 172, 183, 177, 183, 177, 187, 177, 177, 177, 183,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  76,  95,  95,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  95, 111,  88, 111,
 95, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 118, 123, 111, 111, 111, 111,
111, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 123,
127, 127, 117, 127, 135, 127, 117, 127, 121, 121, 127, 121, 118, 135, 142, 118,
142, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 151, 142,
127, 142, 142, 139, 142, 151, 149, 137, 149, 149, 142, 158, 151, 167, 149, 174,
149, 149, 157, 155, 149, 155, 157, 157, 155, 155, 155, 155, 157, 137, 159, 155,
165, 157, 165, 157, 161, 161, 174, 158, 168, 158, 168, 161, 174, 168, 168, 168,
158, 168, 172, 161, 168, 159, 168, 172, 161, 158, 168, 161, 168, 177, 168, 172,
183, 183, 183, 172, 183, 172, 178, 183, 177, 183, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  76,  95,  95,  95,  95,  85,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111,  93, 111, 111, 111, 123, 111, 143, 123, 118, 123, 109, 109, 123, 109,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 118, 123,
127, 127, 135, 127, 135, 127, 121, 127, 121, 121, 127, 127, 118, 135, 142, 118,
127, 135, 127, 142, 142, 142, 142, 142, 142, 127, 137, 142, 158, 135, 151, 142,
127, 142, 142, 158, 138, 138, 149, 137, 149, 149, 158, 158, 138, 137, 149, 145,
149, 149, 157, 155, 155, 155, 157, 155, 155, 155, 155, 158, 155, 137, 159, 155,
165, 165, 165, 174, 161, 161, 145, 158, 168, 158, 168, 168, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 168, 161, 163, 168, 161, 168, 183, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 187, 177, 178, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 187, 187, 187, 187, 177, 202, 187, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  93,  88,  93,
 93, 111, 111, 111,  93,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
 93, 111,  93, 111, 123, 123, 123, 123, 143, 123, 118, 123, 109, 109, 123, 109,
123, 136, 123, 123, 123, 123, 118, 123, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 135, 127, 135, 127, 121, 127, 121, 121, 127, 127, 127, 135, 127, 118,
127, 135, 127, 127, 142, 142, 142, 138, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 138, 139, 138, 138, 149, 137, 149, 149, 142, 158, 159, 137, 149, 145,
149, 149, 159, 154, 154, 154, 159, 157, 154, 154, 154, 154, 154, 154, 159, 174,
154, 154, 154, 174, 161, 159, 145, 154, 154, 158, 154, 172, 174, 154, 154, 154,
158, 172, 172, 178, 178, 159, 178, 178, 178, 178, 178, 177, 178, 178, 178, 178,
178, 178, 178, 197, 178, 178, 178, 178, 177, 178, 178, 178, 177, 178, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 178, 178, 187, 178, 202, 202, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  76,  95,  95,  95,  95,  95,  85,  95, 111,  85, 111,
 95, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 123, 118, 123, 109, 111, 123, 109,
123, 136, 123, 118, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 118, 123,
123, 123, 117, 123, 135, 127, 117, 118, 121, 121, 127, 142, 118, 135, 142, 143,
142, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 158, 135, 151, 142,
127, 142, 142, 158, 142, 138, 149, 137, 149, 149, 158, 158, 138, 167, 149, 174,
149, 149, 149, 158, 149, 155, 157, 149, 155, 158, 155, 158, 155, 137, 159, 165,
165, 165, 165, 165, 161, 161, 174, 158, 168, 163, 168, 168, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 168, 161, 163, 168, 161, 168, 183, 183, 168,
183, 183, 183, 178, 183, 172, 178, 183, 177, 183, 183, 187, 177, 183, 183, 178,
183, 187, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 202, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  76,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  95, 111,  88, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 123, 111, 111, 111, 111,
111, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 123,
127, 127, 117, 127, 135, 127, 121, 127, 121, 121, 127, 127, 118, 135, 142, 118,
135, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 142, 139, 142, 151, 142, 137, 149, 149, 142, 158, 151, 167, 149, 174,
149, 149, 157, 155, 157, 157, 157, 157, 157, 155, 155, 155, 157, 137, 159, 157,
165, 157, 165, 159, 161, 159, 174, 165, 168, 158, 168, 172, 174, 168, 168, 168,
158, 172, 172, 168, 168, 159, 168, 172, 161, 183, 168, 161, 168, 183, 172, 172,
172, 183, 183, 172, 183, 172, 172, 183, 177, 183, 183, 187, 177, 177, 177, 178,
183, 177, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111,  93,  93, 111, 123,  93,  93,  93, 123, 111,
 93, 123,  93, 123, 123, 123, 123, 123, 143, 123, 118, 123, 109, 123, 123, 118,
123, 136, 127, 127, 127, 123, 118, 127, 135, 127, 127, 127, 127, 118, 121, 145,
127, 127, 135, 127, 135, 127, 121, 127, 127, 121, 127, 127, 127, 135, 127, 127,
127, 135, 127, 127, 127, 138, 142, 138, 142, 127, 133, 142, 158, 135, 140, 142,
145, 142, 138, 158, 138, 151, 149, 137, 154, 154, 145, 158, 159, 137, 154, 145,
154, 154, 154, 154, 154, 154, 154, 174, 154, 154, 154, 154, 154, 154, 159, 174,
154, 154, 154, 174, 161, 159, 145, 154, 154, 163, 154, 172, 145, 154, 154, 178,
178, 178, 178, 178, 178, 172, 178, 178, 178, 178, 178, 178, 197, 178, 178, 178,
178, 178, 178, 197, 178, 197, 197, 178, 178, 178, 178, 178, 178, 178, 178, 197,
178, 178, 178, 178, 178, 178, 178, 197, 178, 178, 178, 178, 178, 202, 202, 202,
202, 202, 202, 202, 197, 202, 202, 202, 202, 202, 202, 202, 202, 199, 199, 199,
199, 199, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 66,  66,  95,  95,  57,  95,  66,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  92,  66,  95,  95,  95,  95,  95,  95,  95,  92,  95,  95,  95,  95,
 95,  95,  95,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
 95,  92,  92,  92,  92, 111,  92,  92,  92,  92,  92,  92, 111, 111, 115, 115,
111,  92, 115,  92, 111, 115, 111, 115, 143, 111, 111, 111, 115, 100, 111, 115,
115, 136, 127, 111, 111, 127, 127, 115, 100, 127, 127, 127, 135, 127, 148, 127,
127, 127, 140, 127, 140, 127, 140, 127, 140, 140, 127, 140, 127, 151, 140, 127,
140, 151, 151, 151, 140, 140, 140, 140, 140, 127, 140, 140, 144, 151, 140, 151,
151, 151, 140, 159, 140, 140, 140, 159, 159, 140, 151, 155, 140, 137, 140, 145,
140, 159, 140, 159, 159, 159, 140, 159, 159, 159, 159, 159, 159, 159, 156, 159,
159, 159, 159, 140, 159, 156, 145, 172, 159, 172, 159, 159, 159, 159, 159, 159,
172, 159, 159, 159, 172, 156, 172, 159, 172, 172, 172, 172, 172, 172, 172, 172,
172, 172, 172, 172, 172, 156, 172, 172, 177, 172, 172, 177, 177, 177, 177, 172,
209, 209, 209, 156, 209, 177, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 115,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 111, 117, 115, 111, 117,
111, 136, 123, 111, 111, 111, 118, 111, 135, 111, 123, 147, 123, 118, 117, 123,
147, 123, 117, 148, 135, 148, 117, 148, 147, 117, 148, 148, 118, 135, 148, 118,
148, 135, 148, 148, 148, 148, 148, 148, 148, 148, 167, 142, 117, 135, 151, 142,
148, 142, 142, 167, 142, 151, 164, 167, 164, 164, 164, 158, 151, 167, 164, 162,
164, 164, 167, 167, 157, 157, 157, 164, 157, 155, 167, 155, 157, 167, 159, 164,
165, 157, 165, 151, 167, 167, 174, 170, 165, 158, 165, 167, 170, 168, 168, 168,
158, 168, 168, 168, 168, 159, 168, 168, 167, 183, 168, 167, 176, 183, 168, 176,
183, 183, 183, 184, 183, 182, 183, 183, 177, 183, 183, 187, 206, 183, 183, 183,
183, 187, 183, 177, 183, 206, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 206, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  76,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 111, 111, 123, 111, 111, 123, 111,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 118, 123,
123, 123, 135, 127, 135, 127, 121, 127, 142, 142, 127, 142, 118, 135, 142, 118,
135, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 158, 135, 151, 142,
127, 142, 142, 149, 142, 151, 142, 167, 149, 149, 142, 158, 151, 167, 149, 174,
149, 155, 157, 155, 155, 157, 157, 157, 155, 155, 165, 155, 157, 165, 159, 165,
165, 165, 165, 174, 161, 159, 174, 170, 168, 158, 168, 172, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 172, 183, 183, 168, 161, 176, 183, 183, 172,
183, 183, 183, 172, 183, 172, 183, 183, 177, 183, 183, 187, 177, 183, 183, 183,
183, 183, 198, 177, 198, 187, 198, 198, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  95, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 123, 111, 111, 111, 111,
111, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 135, 118, 148, 123,
127, 127, 135, 127, 135, 127, 148, 127, 148, 142, 127, 148, 127, 135, 148, 127,
135, 135, 127, 142, 142, 142, 142, 142, 142, 127, 144, 142, 142, 151, 140, 142,
127, 142, 142, 149, 142, 151, 157, 167, 157, 157, 142, 158, 151, 167, 157, 174,
157, 157, 159, 157, 157, 157, 159, 157, 157, 165, 157, 165, 157, 165, 159, 157,
165, 159, 165, 151, 161, 159, 174, 170, 172, 158, 172, 172, 174, 172, 172, 172,
168, 172, 172, 172, 172, 159, 172, 172, 172, 183, 172, 177, 172, 172, 172, 172,
172, 172, 183, 172, 183, 172, 172, 172, 177, 183, 183, 183, 177, 177, 177, 198,
198, 198, 198, 177, 198, 187, 198, 198, 198, 187, 187, 198, 177, 187, 187, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 218, 210, 218, 218, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  95,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 111, 111, 123, 111, 111, 123, 111,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
123, 123, 135, 127, 135, 127, 147, 127, 148, 142, 127, 142, 118, 135, 142, 118,
135, 135, 142, 142, 142, 142, 142, 142, 142, 127, 167, 142, 158, 135, 151, 142,
127, 142, 142, 158, 142, 151, 164, 167, 164, 149, 164, 158, 151, 167, 164, 174,
157, 155, 157, 155, 155, 157, 157, 157, 165, 165, 165, 165, 165, 165, 159, 170,
165, 165, 165, 174, 167, 159, 174, 170, 168, 158, 168, 172, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 168, 183, 183, 183, 183, 176, 183, 183, 183,
183, 183, 183, 184, 183, 182, 183, 183, 183, 183, 183, 183, 177, 183, 183, 198,
183, 198, 198, 177, 198, 187, 198, 198, 198, 187, 187, 198, 198, 187, 187, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  99,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 115,  95, 115, 115, 115, 115, 115, 115, 115, 115, 115, 111, 115,
 95, 115, 115, 115, 115, 111, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 115, 115, 143, 115, 115, 115, 115, 115, 115, 115,
115, 136, 111, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 147, 147, 123,
148, 148, 117, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 148,
148, 135, 148, 148, 148, 148, 148, 148, 148, 148, 167, 148, 167, 151, 151, 148,
148, 148, 148, 167, 148, 151, 148, 167, 148, 148, 148, 164, 151, 167, 148, 151,
164, 164, 167, 167, 164, 157, 151, 151, 157, 167, 167, 164, 157, 167, 140, 164,
157, 159, 157, 151, 167, 167, 174, 170, 176, 170, 182, 167, 182, 176, 176, 176,
180, 182, 182, 167, 176, 159, 182, 182, 167, 167, 172, 167, 182, 167, 182, 182,
182, 172, 184, 182, 182, 182, 182, 182, 206, 183, 190, 206, 206, 206, 206, 190,
206, 206, 206, 206, 190, 206, 206, 198, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 198, 206, 206, 206, 206, 206, 206, 206, 206, 206, 202, 202,
202, 202, 202, 218, 202, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  88,  93,
136,  93,  93, 111, 123, 118, 123, 123, 123, 111, 123, 123, 123, 123, 123, 123,
123, 123, 123, 123, 123, 123, 123, 123, 143, 123, 127, 123, 123, 135, 127, 127,
127, 136, 127, 127, 127, 127, 127, 127, 135, 127, 127, 127, 127, 127, 127, 145,
127, 127, 140, 127, 135, 127, 142, 127, 127, 142, 127, 127, 127, 135, 127, 162,
127, 135, 127, 127, 127, 142, 127, 142, 142, 145, 144, 142, 158, 145, 140, 174,
145, 174, 174, 154, 174, 151, 174, 154, 174, 154, 145, 158, 159, 137, 174, 145,
154, 154, 159, 154, 174, 154, 159, 174, 174, 154, 154, 154, 174, 154, 159, 174,
154, 172, 154, 174, 172, 159, 145, 174, 178, 178, 197, 172, 145, 178, 178, 197,
178, 178, 178, 178, 178, 172, 178, 178, 178, 178, 178, 178, 197, 178, 178, 197,
178, 178, 178, 197, 197, 197, 197, 197, 178, 197, 197, 178, 178, 178, 197, 197,
197, 197, 197, 197, 197, 178, 197, 197, 197, 197, 209, 197, 209, 209, 209, 209,
209, 209, 197, 209, 197, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 214, 214, 214, 218, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218,
 95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,
136, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 123, 111, 111, 111,
111, 111, 135, 111, 111, 135, 123, 111, 143, 123, 127, 123, 111, 135, 127, 127,
127, 136, 127, 127, 127, 127, 127, 127, 135, 127, 127, 127, 135, 127, 127, 127,
127, 127, 140, 127, 151, 127, 142, 127, 151, 151, 127, 127, 127, 151, 127, 127,
151, 151, 151, 127, 151, 151, 151, 151, 142, 127, 140, 151, 142, 151, 140, 151,
145, 174, 151, 155, 151, 151, 159, 159, 159, 159, 174, 155, 140, 137, 159, 145,
159, 159, 159, 159, 159, 159, 159, 174, 159, 159, 159, 172, 159, 159, 140, 174,
159, 159, 172, 174, 159, 159, 145, 174, 172, 154, 172, 159, 174, 172, 172, 172,
172, 172, 172, 172, 172, 156, 172, 172, 172, 178, 172, 172, 197, 172, 172, 172,
172, 172, 178, 197, 172, 197, 197, 178, 177, 178, 178, 178, 177, 178, 178, 197,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99, 115,  99,  99, 143,  99, 147, 115, 147, 115, 147, 147,
147, 130, 147, 147, 147, 147, 147, 147, 115, 147, 147, 147, 147, 147, 147, 147,
147, 147, 117, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 167, 147, 167, 147, 147, 147,
148, 147, 147, 167, 147, 147, 167, 167, 167, 167, 148, 167, 167, 167, 167, 148,
167, 167, 167, 167, 167, 167, 167, 164, 167, 167, 167, 167, 167, 167, 167, 164,
167, 167, 167, 164, 167, 167, 171, 167, 167, 167, 167, 167, 185, 167, 167, 167,
167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 185, 167, 167, 206,
206, 206, 206, 185, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  85,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 111, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 130, 111, 143, 111, 147, 123, 147, 147, 123, 147,
147, 136, 123, 147, 123, 123, 143, 123, 135, 147, 123, 147, 123, 143, 147, 123,
147, 123, 147, 123, 135, 147, 147, 123, 147, 147, 123, 147, 143, 135, 147, 143,
148, 135, 148, 148, 148, 164, 164, 147, 164, 162, 167, 164, 143, 135, 135, 164,
162, 164, 164, 158, 164, 164, 164, 167, 164, 164, 164, 158, 164, 167, 164, 162,
164, 164, 167, 164, 164, 164, 164, 164, 164, 170, 170, 158, 164, 167, 157, 164,
170, 170, 170, 174, 167, 167, 174, 170, 180, 173, 180, 168, 174, 180, 180, 180,
158, 180, 180, 183, 180, 182, 180, 180, 183, 173, 183, 183, 180, 183, 183, 184,
183, 183, 183, 193, 183, 182, 193, 183, 183, 183, 183, 183, 183, 183, 183, 193,
183, 183, 183, 198, 193, 206, 198, 193, 198, 193, 187, 198, 198, 198, 187, 187,
198, 206, 198, 202, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 202, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 111, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 123, 111, 123, 111, 111, 123, 147,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
123, 123, 135, 123, 135, 148, 147, 127, 148, 148, 127, 148, 127, 135, 148, 162,
135, 135, 148, 148, 148, 142, 142, 142, 142, 162, 167, 142, 158, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 157, 165, 164, 165, 157, 164, 170, 170, 165, 170, 170, 165, 159, 174,
170, 165, 170, 174, 167, 159, 174, 170, 176, 158, 176, 172, 174, 176, 176, 176,
180, 176, 176, 183, 176, 182, 176, 176, 183, 183, 183, 183, 174, 183, 183, 184,
183, 183, 183, 174, 183, 182, 186, 183, 183, 183, 183, 183, 183, 183, 198, 198,
198, 198, 198, 198, 198, 187, 198, 198, 198, 198, 198, 198, 198, 198, 198, 187,
198, 187, 198, 202, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 218, 218, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  95,  76,  76,  76,
 76,  95,  76,  76,  76,  76,  76,  76,  85,  76,  95,  85,  85,  85,  85,  85,
 95,  85,  85,  85,  85, 143,  85,  85, 130,  85, 130,  85, 130, 130, 123, 111,
130, 130, 123, 130, 123, 123, 123, 123, 143, 123, 143, 123, 147, 147, 123, 147,
123, 136, 143, 143, 123, 123, 143, 123, 135, 143, 123, 143, 123, 143, 143, 123,
143, 143, 147, 143, 135, 143, 147, 143, 147, 147, 143, 143, 143, 123, 143, 143,
123, 135, 143, 143, 143, 164, 143, 164, 143, 143, 167, 143, 143, 135, 135, 143,
143, 143, 164, 158, 164, 164, 158, 167, 158, 158, 143, 173, 164, 167, 158, 162,
158, 158, 158, 158, 158, 158, 164, 164, 158, 158, 158, 173, 158, 158, 168, 158,
158, 170, 158, 174, 167, 168, 174, 173, 158, 173, 180, 168, 174, 158, 158, 158,
173, 180, 180, 183, 173, 183, 193, 183, 183, 173, 183, 183, 193, 183, 193, 193,
193, 193, 193, 193, 193, 193, 193, 193, 183, 193, 193, 173, 183, 193, 193, 193,
193, 193, 193, 198, 193, 187, 193, 193, 193, 193, 193, 193, 198, 198, 224, 202,
198, 187, 202, 202, 224, 202, 202, 202, 224, 202, 224, 202, 202, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 218, 218, 218, 245,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 115, 111, 111, 111, 111, 111, 115,
111, 111, 111, 111, 111, 111, 111, 115, 143, 111, 111, 130, 147, 115, 111, 147,
111, 136, 130, 111, 111, 123, 118, 123, 135, 147, 123, 148, 148, 147, 147, 123,
148, 148, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
148, 164, 164, 164, 164, 151, 164, 167, 164, 164, 164, 164, 151, 167, 164, 162,
164, 164, 167, 164, 164, 164, 164, 164, 164, 170, 167, 170, 164, 167, 159, 164,
170, 170, 170, 182, 167, 167, 174, 170, 176, 158, 176, 176, 174, 176, 176, 176,
180, 176, 176, 176, 176, 182, 176, 184, 183, 183, 184, 167, 184, 183, 184, 184,
184, 183, 183, 182, 183, 182, 184, 183, 183, 183, 183, 183, 183, 183, 183, 192,
183, 198, 198, 198, 198, 206, 198, 198, 198, 198, 198, 198, 198, 198, 198, 187,
198, 206, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 218, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 111, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 123, 111, 123, 111, 135, 123, 111,
123, 136, 123, 123, 123, 123, 127, 123, 135, 127, 127, 127, 135, 127, 148, 136,
127, 127, 151, 127, 135, 127, 148, 127, 148, 148, 127, 148, 127, 135, 148, 162,
151, 135, 127, 127, 148, 151, 142, 151, 142, 162, 144, 142, 142, 151, 151, 151,
174, 174, 151, 155, 151, 151, 157, 157, 157, 157, 174, 158, 151, 167, 157, 174,
157, 157, 159, 157, 157, 159, 159, 174, 165, 165, 159, 170, 159, 172, 159, 174,
172, 159, 172, 174, 172, 159, 174, 174, 172, 170, 172, 172, 174, 172, 172, 172,
176, 172, 172, 172, 172, 159, 172, 172, 172, 183, 172, 183, 174, 172, 172, 172,
172, 172, 183, 197, 172, 182, 197, 172, 177, 198, 198, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 197, 198, 198, 198, 198, 209, 198, 198, 198,
198, 202, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  99,  99,  95,  95,  95,  76,  99,  95,  95,  99,  95,  95,  95,  95,
 95,  95,  95,  99,  95,  99,  95,  99,  99,  99,  95,  99,  99, 115,  99, 111,
 95, 115, 115, 115, 111, 111, 115, 115, 115, 115, 115, 111, 111, 111, 115, 115,
111, 115, 115, 115, 115, 115, 111, 115, 143, 115, 147, 111, 147, 115, 147, 147,
147, 136, 130, 147, 147, 147, 147, 147, 115, 147, 147, 147, 147, 147, 147, 123,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 148, 147, 147, 148, 147, 147,
147, 135, 147, 147, 147, 147, 147, 147, 147, 148, 167, 147, 147, 135, 151, 148,
148, 148, 148, 167, 164, 148, 164, 167, 164, 167, 164, 167, 151, 167, 164, 171,
164, 164, 167, 167, 164, 164, 164, 164, 164, 167, 167, 164, 164, 167, 167, 164,
164, 167, 170, 164, 167, 167, 174, 180, 180, 180, 185, 167, 185, 180, 180, 180,
167, 180, 180, 167, 180, 182, 180, 184, 167, 167, 167, 167, 180, 167, 184, 184,
184, 206, 184, 184, 184, 182, 184, 184, 206, 206, 206, 206, 206, 206, 206, 192,
206, 206, 206, 206, 206, 206, 206, 193, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
202, 206, 202, 202, 202, 206, 202, 202, 202, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 130, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 130, 111, 143, 123, 111, 123, 147, 111, 123, 147,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
148, 123, 135, 148, 135, 148, 147, 148, 148, 148, 127, 148, 148, 135, 148, 162,
135, 135, 148, 148, 148, 148, 148, 142, 148, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 157, 165, 164, 170, 157, 164, 170, 170, 165, 170, 170, 167, 159, 174,
170, 176, 170, 174, 167, 159, 174, 170, 176, 158, 176, 172, 174, 176, 176, 176,
180, 176, 176, 183, 176, 182, 176, 176, 183, 183, 183, 183, 174, 183, 184, 184,
183, 183, 183, 174, 183, 182, 186, 183, 183, 183, 183, 183, 183, 198, 198, 198,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 187, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 218, 227, 218, 218, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 130, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 130, 111, 143, 123, 111, 123, 147, 111, 123, 147,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
148, 123, 135, 148, 135, 148, 147, 148, 148, 147, 123, 148, 148, 135, 148, 162,
135, 135, 148, 148, 148, 148, 148, 164, 164, 162, 167, 164, 158, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 157, 165, 164, 170, 157, 164, 170, 170, 170, 170, 170, 167, 159, 174,
170, 170, 170, 174, 167, 172, 174, 170, 176, 158, 176, 176, 174, 176, 176, 176,
180, 176, 176, 183, 176, 182, 176, 184, 183, 183, 183, 183, 174, 183, 183, 184,
183, 183, 183, 174, 183, 182, 186, 183, 183, 183, 183, 183, 183, 183, 198, 198,
198, 198, 198, 198, 198, 187, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 187, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 227, 218, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 130, 130, 130, 111, 111,
130, 111, 111, 111, 130, 111, 130, 111, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 123, 123, 123, 130, 123, 135, 123, 123, 123, 123, 147, 147, 123,
148, 123, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 164, 164, 170, 170, 170, 170, 167, 159, 174,
170, 170, 170, 174, 167, 167, 174, 180, 180, 158, 180, 176, 174, 180, 180, 180,
180, 176, 184, 184, 180, 182, 184, 184, 183, 183, 184, 183, 184, 183, 184, 184,
184, 183, 183, 186, 183, 182, 186, 186, 183, 183, 183, 183, 183, 183, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 187, 198, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 227, 218, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  76,  95,  95,  95,  95,  85,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  85, 130,
 95, 130, 130, 130, 130, 143, 130, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 123, 130, 123, 143, 123, 143, 123, 147, 123, 123, 147,
123, 136, 123, 123, 123, 123, 143, 123, 135, 123, 123, 123, 123, 143, 147, 136,
123, 123, 135, 123, 135, 123, 147, 143, 147, 147, 123, 164, 143, 135, 164, 143,
135, 135, 164, 143, 164, 164, 164, 164, 164, 143, 164, 164, 143, 135, 135, 164,
162, 164, 164, 158, 164, 164, 164, 167, 164, 164, 162, 173, 164, 167, 164, 174,
164, 164, 170, 158, 170, 170, 170, 174, 170, 158, 158, 158, 170, 158, 168, 174,
170, 170, 170, 174, 167, 168, 174, 158, 180, 173, 180, 180, 174, 180, 180, 180,
173, 180, 180, 183, 193, 182, 193, 193, 183, 173, 183, 183, 193, 183, 193, 193,
193, 193, 193, 197, 193, 193, 193, 193, 183, 193, 193, 193, 183, 193, 193, 193,
193, 193, 193, 198, 193, 198, 198, 193, 198, 193, 198, 198, 198, 198, 198, 198,
198, 202, 198, 198, 198, 202, 202, 202, 224, 202, 224, 224, 202, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 111, 111, 111, 130, 130, 111, 111, 130, 111, 111, 130, 130, 130, 111, 115,
130, 130, 130, 111, 130, 111, 130, 111, 143, 130, 111, 130, 147, 115, 130, 147,
123, 136, 130, 123, 123, 123, 130, 123, 135, 148, 123, 148, 135, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 148, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 157, 170, 164, 170, 157, 174, 170, 170, 170, 170, 170, 167, 159, 174,
170, 182, 170, 174, 167, 182, 174, 180, 176, 180, 182, 182, 174, 176, 176, 176,
180, 182, 182, 184, 184, 182, 184, 182, 183, 183, 184, 183, 174, 183, 184, 182,
190, 183, 186, 195, 190, 182, 190, 190, 183, 192, 190, 183, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
227, 202, 227, 227, 227, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 111, 111, 111, 130, 130, 111, 111, 111, 115, 111, 130, 130, 130, 115, 115,
130, 111, 111, 111, 130, 115, 130, 115, 143, 130, 111, 130, 115, 115, 130, 147,
111, 136, 130, 130, 123, 123, 130, 123, 135, 148, 148, 148, 148, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 148, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 157, 164, 164, 164, 164, 174, 170, 170, 170, 170, 170, 167, 159, 174,
170, 182, 170, 174, 167, 182, 174, 180, 176, 180, 182, 182, 174, 176, 176, 176,
180, 182, 182, 184, 184, 182, 184, 182, 183, 183, 184, 183, 174, 184, 184, 182,
190, 190, 186, 195, 190, 182, 190, 190, 190, 190, 190, 183, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 198, 202, 217, 202, 202, 217, 202, 202, 202, 202,
227, 202, 227, 227, 227, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
136, 130, 130, 111, 130, 130, 111, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 123, 130, 123, 143, 130, 130, 123, 123, 135, 123, 123,
123, 136, 130, 123, 123, 123, 130, 123, 135, 123, 123, 123, 135, 162, 148, 136,
123, 123, 135, 127, 135, 148, 148, 127, 148, 148, 127, 148, 162, 135, 148, 162,
135, 135, 148, 148, 148, 148, 164, 164, 164, 162, 164, 164, 164, 135, 151, 164,
162, 174, 164, 164, 164, 151, 164, 165, 164, 164, 174, 158, 151, 167, 164, 174,
164, 170, 157, 170, 170, 170, 170, 174, 170, 170, 170, 170, 170, 176, 159, 174,
170, 182, 176, 174, 183, 182, 174, 174, 176, 180, 174, 182, 174, 176, 176, 176,
180, 182, 182, 183, 184, 182, 184, 182, 183, 183, 183, 183, 174, 183, 186, 186,
183, 183, 183, 197, 183, 197, 197, 198, 198, 198, 198, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 197, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 197, 198, 202, 202, 202, 202, 202, 227, 202, 202, 227, 227,
227, 227, 227, 227, 227, 218, 227, 227, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 111, 130, 130, 111, 130, 130, 111, 130, 130, 130, 130, 111, 111,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 130, 123, 130, 130, 123, 135, 123, 123, 123, 123, 148, 147, 136,
148, 123, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 164, 164, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 164, 170, 170, 170, 170, 170, 167, 182, 174,
170, 170, 170, 174, 167, 182, 174, 180, 180, 180, 180, 182, 174, 180, 180, 180,
180, 184, 184, 184, 184, 182, 184, 184, 183, 183, 184, 183, 174, 183, 184, 184,
184, 183, 186, 195, 192, 182, 186, 192, 183, 192, 192, 183, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 217, 202, 217, 202, 217, 217, 202, 202, 202, 202,
227, 202, 227, 227, 227, 218, 227, 224, 218, 218, 218, 218, 218, 218, 218, 245,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 115,  95, 115,  95,  95, 115, 115,  95, 115, 115, 115, 130, 115,
 95, 115, 115, 115, 115, 130, 115, 115, 115, 115, 115, 115, 115, 130, 115, 115,
115, 115, 115, 115, 115, 115, 115, 115, 143, 115, 115, 130, 115, 115, 115, 115,
115, 136, 130, 115, 115, 115, 148, 115, 160, 148, 148, 148, 160, 148, 148, 136,
148, 148, 140, 148, 160, 148, 148, 148, 148, 148, 148, 148, 148, 160, 148, 162,
151, 160, 148, 148, 151, 151, 151, 151, 148, 162, 140, 151, 148, 160, 140, 151,
151, 151, 151, 148, 151, 151, 151, 159, 151, 151, 174, 164, 151, 167, 151, 174,
151, 151, 159, 159, 159, 159, 151, 151, 159, 159, 159, 182, 159, 159, 140, 174,
182, 159, 182, 151, 159, 159, 174, 182, 182, 176, 182, 159, 174, 182, 182, 182,
172, 182, 182, 182, 182, 156, 182, 182, 172, 172, 182, 172, 182, 182, 182, 182,
182, 182, 182, 195, 182, 182, 182, 182, 182, 182, 182, 198, 198, 198, 198, 195,
198, 198, 198, 215, 198, 198, 215, 198, 209, 209, 209, 209, 215, 209, 209, 209,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 209, 209, 218, 218, 218, 218, 218, 218, 218, 243,
 76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 111, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 123, 135, 148, 123, 148, 148, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 164, 148, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 174, 170, 170, 170, 170, 170, 167, 182, 174,
170, 176, 170, 174, 167, 182, 174, 180, 180, 180, 180, 182, 174, 180, 180, 180,
180, 184, 182, 184, 184, 182, 184, 184, 183, 183, 184, 183, 174, 184, 184, 186,
186, 186, 186, 195, 192, 182, 186, 192, 190, 192, 192, 183, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 217, 217, 217, 217, 202, 217, 217, 202, 217, 217, 217,
227, 227, 227, 227, 227, 218, 227, 227, 227, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 111, 130, 130, 111, 130, 130, 115, 130, 130, 130, 130, 115, 115,
130, 130, 130, 130, 130, 115, 130, 115, 143, 130, 130, 130, 147, 115, 130, 147,
130, 136, 130, 130, 130, 130, 130, 123, 135, 148, 148, 148, 148, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 148, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 157, 170, 164, 170, 182, 174, 170, 170, 170, 170, 170, 167, 159, 174,
170, 182, 170, 174, 167, 182, 174, 180, 176, 180, 182, 182, 174, 182, 176, 184,
180, 182, 182, 184, 184, 182, 184, 182, 184, 186, 184, 183, 174, 190, 190, 190,
190, 190, 192, 195, 190, 182, 195, 190, 190, 192, 190, 198, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 217, 217, 217, 217, 217, 217, 217, 202, 217, 217, 217,
227, 227, 227, 227, 227, 218, 227, 227, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 123, 130, 130, 143, 130, 130, 130, 123, 135, 123, 123,
123, 136, 130, 123, 123, 123, 162, 123, 135, 123, 123, 123, 135, 162, 148, 136,
123, 123, 135, 127, 135, 127, 148, 162, 148, 148, 162, 148, 162, 135, 148, 162,
135, 135, 127, 162, 164, 164, 164, 164, 164, 162, 164, 164, 158, 135, 151, 164,
174, 174, 164, 164, 164, 174, 164, 165, 174, 164, 174, 158, 151, 167, 174, 174,
170, 170, 165, 170, 174, 170, 170, 174, 174, 170, 170, 170, 174, 176, 182, 174,
170, 176, 174, 174, 183, 182, 174, 174, 176, 180, 174, 182, 174, 176, 176, 174,
180, 184, 182, 183, 186, 182, 186, 184, 183, 183, 183, 183, 197, 183, 186, 186,
186, 183, 193, 197, 198, 197, 197, 197, 198, 198, 198, 198, 198, 198, 198, 197,
198, 198, 198, 198, 197, 198, 198, 197, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 197, 198, 197, 217, 217, 202, 227, 202, 227, 227, 202, 227, 227, 227,
227, 227, 227, 227, 227, 218, 227, 227, 227, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  95,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  85,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
136, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 123, 130, 123, 143, 130, 143, 130, 147, 123, 123, 123,
123, 136, 143, 123, 123, 123, 143, 123, 135, 123, 123, 123, 123, 143, 143, 136,
123, 123, 135, 123, 135, 123, 147, 143, 164, 164, 162, 164, 143, 135, 164, 143,
164, 135, 164, 143, 164, 164, 164, 164, 164, 162, 164, 164, 143, 135, 135, 164,
162, 162, 164, 158, 164, 164, 164, 158, 164, 164, 162, 173, 164, 167, 164, 174,
164, 170, 170, 158, 170, 170, 170, 174, 170, 158, 170, 158, 170, 180, 182, 174,
170, 180, 180, 174, 183, 183, 174, 173, 180, 173, 174, 180, 174, 180, 193, 193,
173, 193, 193, 193, 193, 182, 193, 193, 183, 173, 193, 183, 193, 193, 193, 193,
193, 193, 193, 197, 193, 197, 193, 193, 193, 193, 193, 193, 198, 193, 193, 197,
193, 193, 193, 198, 197, 198, 198, 197, 198, 224, 198, 198, 198, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 218, 218, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 135, 130, 147,
130, 136, 130, 130, 130, 130, 130, 123, 135, 123, 123, 123, 135, 162, 147, 136,
148, 123, 135, 148, 135, 148, 147, 148, 148, 148, 162, 148, 162, 135, 148, 162,
135, 135, 148, 148, 148, 148, 148, 164, 164, 162, 164, 164, 164, 135, 151, 164,
162, 162, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 170, 170, 170, 170, 170, 174, 170, 170, 170, 170, 170, 170, 182, 174,
170, 182, 170, 174, 167, 182, 174, 180, 180, 180, 174, 182, 174, 184, 180, 184,
180, 184, 182, 184, 184, 182, 184, 184, 183, 183, 184, 183, 174, 183, 186, 186,
186, 186, 192, 197, 192, 182, 186, 192, 190, 192, 192, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 217, 217, 217, 217, 202, 217, 227, 202, 217, 227, 227,
227, 227, 227, 227, 227, 218, 227, 227, 227, 218, 218, 218, 218, 218, 218, 245,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 123, 135, 130, 123,
123, 136, 162, 123, 123, 123, 162, 123, 135, 123, 123, 123, 135, 162, 148, 136,
127, 162, 135, 127, 135, 127, 142, 162, 135, 142, 162, 127, 162, 135, 127, 162,
135, 135, 162, 162, 164, 164, 164, 164, 164, 162, 164, 174, 158, 174, 151, 174,
174, 174, 174, 164, 174, 174, 174, 170, 174, 174, 174, 158, 174, 165, 174, 174,
174, 174, 170, 170, 174, 174, 174, 174, 174, 170, 170, 174, 174, 176, 182, 174,
174, 174, 174, 174, 183, 182, 174, 174, 174, 193, 174, 182, 174, 174, 174, 174,
193, 186, 197, 183, 197, 182, 197, 197, 183, 193, 186, 183, 197, 183, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 198, 197, 197, 198, 198, 198, 197, 197,
197, 198, 197, 197, 197, 198, 197, 197, 197, 197, 198, 197, 197, 197, 198, 198,
197, 198, 197, 227, 197, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 218, 245, 245,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  95,  76,  95,  95,
 95,  95,  99,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  99,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 115, 130, 130, 115, 130, 130, 147, 115, 130, 130, 130, 115, 115,
130, 130, 130, 130, 130, 115, 130, 147, 143, 147, 147, 130, 147, 147, 147, 147,
147, 136, 130, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 130,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 162,
147, 135, 147, 147, 147, 147, 147, 147, 147, 162, 167, 147, 147, 135, 151, 147,
171, 171, 164, 167, 164, 164, 164, 167, 164, 164, 171, 164, 164, 167, 164, 171,
164, 164, 167, 167, 164, 164, 164, 164, 164, 185, 167, 185, 185, 167, 167, 185,
185, 185, 185, 185, 167, 167, 174, 185, 185, 180, 185, 167, 185, 185, 185, 185,
180, 185, 185, 167, 185, 182, 185, 185, 167, 167, 185, 167, 185, 185, 185, 185,
185, 191, 191, 195, 196, 190, 196, 196, 206, 192, 192, 206, 206, 206, 206, 196,
206, 206, 206, 206, 200, 206, 206, 193, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 208, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
217, 217, 217, 217, 217, 206, 217, 217, 227, 227, 227, 218, 218, 218, 243, 245,
 76,  76,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 135, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 135, 123, 123, 148, 135, 162, 148, 136,
148, 162, 135, 148, 135, 148, 148, 162, 148, 148, 162, 148, 162, 135, 148, 162,
135, 135, 148, 162, 148, 148, 164, 164, 164, 162, 164, 164, 164, 135, 151, 164,
162, 162, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 170, 170, 170, 170, 182, 174, 170, 170, 170, 170, 170, 176, 182, 174,
170, 182, 180, 174, 183, 182, 174, 174, 180, 180, 174, 182, 174, 184, 184, 186,
180, 182, 182, 184, 186, 182, 186, 190, 183, 193, 186, 183, 174, 186, 186, 186,
190, 192, 192, 197, 192, 182, 197, 192, 198, 192, 192, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 197, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 217, 217, 217, 217, 217, 217, 217, 217, 227, 217, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 218, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 115,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 148, 148, 162, 147, 136,
148, 148, 147, 148, 135, 148, 147, 148, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 164, 148, 162, 167, 164, 164, 135, 151, 164,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 174, 170, 170, 170, 170, 170, 167, 182, 174,
180, 182, 180, 174, 167, 182, 174, 180, 180, 180, 180, 182, 174, 180, 180, 180,
180, 184, 182, 184, 186, 182, 186, 190, 184, 193, 184, 183, 174, 186, 186, 186,
190, 192, 192, 195, 192, 190, 195, 192, 190, 192, 192, 193, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 193, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 218, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 115, 130, 130, 130, 130, 130, 115,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 130, 130, 130, 130, 130, 135, 147, 130, 148, 148, 147, 147, 136,
148, 148, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 171, 164, 151, 167, 164, 162,
164, 164, 164, 164, 164, 164, 185, 164, 185, 185, 185, 170, 185, 167, 182, 174,
185, 185, 185, 174, 167, 182, 174, 180, 185, 180, 185, 182, 174, 185, 185, 185,
180, 182, 182, 184, 184, 182, 184, 190, 184, 186, 184, 183, 195, 190, 186, 190,
190, 190, 192, 195, 192, 195, 195, 192, 190, 192, 192, 192, 192, 192, 192, 192,
192, 198, 198, 198, 208, 206, 198, 200, 198, 198, 198, 198, 198, 198, 198, 198,
198, 206, 198, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 217, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 148, 148, 162, 147, 136,
148, 148, 147, 148, 135, 148, 147, 148, 148, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 164, 164, 135, 151, 171,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 185, 174, 185, 170, 185, 170, 185, 185, 182, 174,
185, 182, 185, 174, 167, 182, 174, 180, 180, 180, 182, 182, 174, 184, 180, 186,
180, 182, 182, 184, 186, 182, 186, 190, 186, 186, 186, 183, 195, 190, 186, 190,
190, 192, 192, 195, 192, 195, 195, 192, 190, 192, 192, 200, 198, 192, 192, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 243, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 148, 162, 147, 136,
148, 162, 135, 148, 135, 148, 147, 162, 148, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 162, 148, 148, 148, 164, 164, 162, 164, 164, 164, 135, 151, 171,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 185, 170, 164, 170, 185, 174, 170, 170, 170, 170, 185, 180, 182, 174,
185, 182, 180, 174, 167, 182, 174, 174, 180, 180, 174, 182, 174, 184, 186, 186,
193, 186, 182, 186, 186, 182, 186, 190, 186, 193, 186, 183, 174, 190, 186, 186,
192, 192, 192, 195, 192, 195, 195, 192, 190, 192, 192, 200, 198, 198, 198, 200,
198, 198, 198, 198, 198, 198, 198, 193, 198, 198, 198, 198, 198, 198, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 243, 243, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 131,  95, 131,  95,  95, 131, 131,  95, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 130, 162, 147, 136,
147, 162, 147, 148, 135, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 171, 171, 164, 171, 164, 164, 162, 194, 164, 164, 135, 151, 171,
162, 171, 164, 164, 164, 164, 164, 167, 164, 164, 162, 164, 164, 167, 164, 162,
164, 164, 185, 164, 164, 185, 185, 174, 185, 185, 185, 185, 185, 185, 182, 174,
185, 185, 185, 174, 167, 182, 174, 180, 185, 180, 185, 185, 174, 185, 185, 191,
193, 191, 191, 191, 191, 182, 191, 191, 186, 193, 191, 192, 195, 191, 191, 191,
191, 192, 193, 195, 193, 195, 193, 193, 192, 200, 200, 193, 200, 200, 200, 193,
200, 200, 208, 208, 208, 198, 208, 193, 198, 193, 198, 198, 208, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 224, 227, 227, 227, 227, 243, 243, 245, 245,
 76,  76,  76,  76,  99,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 99,  95,  99,  99,  95,  95,  95,  76,  99,  99,  95,  99,  95,  95,  95,  99,
 95,  95,  99,  99,  99,  99,  95,  99,  99, 115, 131,  99, 131, 115, 130, 130,
130, 115, 115, 115, 130, 130, 115, 115, 130, 147, 115, 130, 130, 130, 115, 115,
130, 130, 115, 115, 130, 115, 130, 147, 143, 147, 147, 130, 147, 147, 147, 147,
147, 136, 130, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 130,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147,
147, 160, 147, 147, 147, 147, 147, 147, 147, 171, 167, 147, 147, 160, 160, 147,
171, 171, 147, 167, 147, 148, 147, 167, 171, 147, 171, 171, 164, 167, 171, 171,
164, 185, 167, 167, 185, 185, 185, 171, 185, 185, 167, 185, 185, 167, 167, 185,
185, 185, 185, 185, 167, 167, 171, 185, 185, 185, 185, 167, 185, 185, 185, 185,
185, 185, 185, 167, 185, 185, 185, 185, 207, 207, 185, 207, 185, 207, 185, 185,
185, 207, 207, 195, 196, 195, 196, 196, 207, 207, 206, 207, 207, 206, 206, 205,
206, 206, 206, 206, 206, 207, 206, 208, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 213, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
217, 206, 217, 217, 217, 206, 217, 217, 235, 235, 235, 243, 243, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 131,  95, 131,  95, 131, 131, 131,  95, 131, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 130, 162, 147, 136,
148, 130, 147, 148, 135, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 171, 171, 148, 171, 164, 171, 162, 194, 171, 164, 135, 151, 171,
162, 171, 171, 164, 164, 171, 164, 194, 164, 164, 171, 171, 151, 167, 164, 162,
164, 164, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 185, 182, 174,
185, 185, 185, 174, 167, 182, 174, 185, 185, 180, 185, 185, 174, 185, 185, 185,
191, 191, 191, 191, 191, 182, 191, 191, 191, 193, 191, 192, 195, 191, 191, 191,
191, 192, 200, 195, 200, 195, 195, 196, 192, 200, 200, 200, 200, 200, 200, 208,
200, 208, 208, 208, 208, 198, 208, 208, 208, 213, 198, 208, 208, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 115,  95, 115,  95, 115, 115, 115, 115, 115, 115, 115, 130, 115,
130, 115, 115, 115, 115, 130, 115, 115, 115, 115, 115, 130, 130, 130, 115, 115,
115, 115, 115, 115, 115, 115, 130, 115, 143, 115, 115, 130, 115, 115, 115, 115,
115, 136, 130, 115, 115, 115, 130, 115, 160, 147, 148, 148, 160, 147, 147, 160,
148, 148, 160, 148, 160, 148, 147, 148, 147, 147, 148, 148, 148, 160, 148, 162,
160, 160, 148, 148, 148, 160, 148, 148, 148, 171, 167, 148, 148, 160, 160, 148,
171, 171, 148, 148, 148, 160, 171, 167, 171, 185, 171, 171, 160, 167, 171, 171,
185, 185, 167, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 167, 151, 185,
185, 185, 185, 182, 167, 167, 174, 185, 185, 185, 185, 182, 195, 185, 185, 185,
185, 182, 182, 185, 185, 182, 185, 182, 185, 185, 185, 207, 195, 190, 195, 195,
195, 190, 195, 195, 195, 195, 195, 195, 190, 195, 195, 207, 207, 208, 208, 195,
208, 208, 208, 215, 208, 207, 208, 208, 208, 208, 206, 208, 215, 216, 213, 206,
216, 206, 216, 216, 216, 217, 217, 217, 217, 206, 217, 215, 206, 217, 217, 217,
217, 217, 217, 215, 227, 217, 227, 227, 227, 243, 243, 243, 243, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95, 131, 131,  95,  95, 131,  95,  95,  95, 131,
 95,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 147, 130, 130, 130, 130, 130, 115,
130, 130, 130, 130, 130, 130, 130, 147, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 147, 147, 130, 130, 147, 160, 147, 147, 147, 147, 147, 147, 136,
147, 147, 147, 147, 160, 147, 147, 147, 147, 147, 148, 147, 147, 148, 147, 162,
147, 160, 147, 147, 147, 147, 147, 147, 147, 162, 167, 171, 147, 160, 160, 171,
171, 171, 171, 147, 171, 171, 171, 167, 171, 164, 171, 171, 164, 167, 171, 171,
164, 185, 167, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 167, 185, 185,
185, 185, 185, 185, 167, 167, 174, 185, 185, 185, 185, 185, 185, 185, 185, 185,
185, 185, 185, 185, 185, 182, 185, 185, 185, 185, 185, 207, 195, 185, 185, 196,
196, 196, 196, 195, 196, 195, 195, 196, 196, 196, 196, 207, 207, 200, 200, 205,
200, 208, 208, 208, 208, 206, 208, 208, 208, 213, 206, 208, 208, 213, 213, 206,
213, 206, 213, 213, 213, 217, 217, 206, 217, 206, 217, 217, 206, 217, 217, 217,
217, 217, 217, 217, 227, 217, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95, 131, 131,  95,  95, 131,  95, 131, 131, 131,
 95,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 147, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 147, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 147, 130, 147, 147, 147, 147, 136,
147, 130, 147, 148, 135, 147, 147, 148, 147, 147, 171, 147, 162, 135, 147, 162,
148, 135, 148, 171, 148, 148, 171, 147, 171, 162, 194, 171, 147, 160, 151, 171,
171, 171, 171, 164, 171, 171, 171, 194, 171, 164, 171, 171, 164, 167, 171, 171,
164, 185, 185, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 167, 182, 185,
185, 185, 185, 174, 167, 185, 204, 185, 185, 185, 185, 185, 174, 185, 185, 185,
185, 185, 185, 185, 185, 182, 191, 191, 191, 191, 191, 192, 195, 196, 191, 196,
196, 196, 196, 195, 196, 195, 195, 196, 190, 196, 196, 200, 200, 200, 208, 208,
200, 208, 208, 208, 208, 206, 208, 208, 208, 213, 213, 208, 216, 213, 213, 217,
213, 206, 213, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
217, 217, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 95,  95,  95,  95, 131,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95,  95, 131,  95,  95, 131,  95,  95,  95,  95,
 95,  95,  95, 131, 131, 131,  95, 131, 131, 131, 130, 131, 130, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 148, 162, 148, 136,
148, 162, 160, 148, 160, 148, 148, 162, 148, 148, 162, 148, 162, 135, 148, 162,
148, 160, 171, 171, 171, 148, 171, 148, 171, 162, 194, 171, 171, 160, 151, 171,
162, 171, 171, 164, 171, 151, 171, 194, 171, 164, 162, 171, 151, 194, 174, 174,
164, 174, 182, 185, 174, 185, 182, 174, 174, 185, 185, 185, 174, 185, 182, 174,
185, 182, 185, 174, 194, 182, 204, 174, 195, 186, 174, 182, 174, 195, 195, 195,
186, 195, 195, 190, 195, 182, 195, 195, 190, 186, 190, 190, 195, 190, 195, 195,
195, 190, 192, 197, 195, 195, 195, 195, 190, 192, 195, 198, 198, 198, 208, 197,
208, 198, 208, 215, 208, 198, 198, 208, 198, 217, 217, 217, 215, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 227, 217, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 243, 245,
 76,  76,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131, 131,  95,  95,  95, 131, 131, 131,  95, 131,  95, 131, 131, 131,
 95,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 130, 162, 147, 136,
148, 130, 147, 148, 135, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 171, 171, 171, 171, 171, 164, 171, 162, 194, 171, 164, 135, 151, 171,
162, 171, 171, 164, 171, 171, 171, 194, 171, 164, 171, 171, 164, 194, 171, 174,
164, 185, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 185, 182, 174,
185, 185, 185, 174, 194, 182, 204, 185, 185, 180, 185, 185, 174, 185, 185, 191,
191, 191, 191, 191, 191, 182, 191, 191, 191, 193, 191, 192, 195, 191, 191, 195,
196, 196, 200, 195, 200, 195, 195, 196, 200, 200, 200, 200, 200, 200, 208, 208,
208, 208, 208, 208, 208, 198, 208, 208, 208, 213, 213, 213, 216, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
131,  95, 131, 131,  95,  95, 131, 131, 131, 131, 131, 131,  95, 131, 131, 131,
131,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
148, 130, 147, 148, 160, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 171, 171, 171, 171, 171, 148, 171, 162, 194, 171, 171, 160, 151, 171,
171, 171, 171, 164, 171, 171, 171, 194, 171, 164, 171, 171, 151, 194, 171, 162,
185, 185, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 194, 182, 174,
185, 185, 185, 174, 194, 182, 204, 185, 185, 203, 185, 185, 174, 185, 185, 185,
191, 191, 195, 191, 191, 182, 191, 195, 191, 191, 191, 192, 195, 196, 191, 195,
196, 196, 196, 195, 196, 195, 195, 196, 200, 200, 200, 200, 208, 208, 208, 208,
208, 208, 208, 208, 208, 208, 208, 208, 208, 213, 213, 213, 216, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 143, 130, 135, 130, 130, 130, 130, 143, 147, 136,
162, 162, 135, 162, 135, 162, 147, 162, 179, 179, 162, 162, 162, 162, 162, 162,
162, 135, 162, 162, 162, 171, 162, 164, 179, 162, 194, 179, 179, 174, 135, 162,
162, 162, 179, 179, 174, 174, 174, 194, 179, 164, 162, 173, 174, 194, 174, 174,
174, 174, 180, 180, 174, 174, 174, 174, 174, 180, 180, 174, 174, 180, 182, 174,
174, 174, 193, 174, 194, 190, 204, 193, 193, 173, 174, 191, 174, 193, 193, 193,
193, 193, 193, 193, 193, 190, 193, 193, 193, 193, 193, 193, 197, 193, 193, 193,
193, 193, 193, 197, 193, 197, 197, 193, 193, 193, 193, 193, 193, 193, 193, 197,
193, 193, 193, 208, 197, 198, 193, 219, 224, 219, 224, 224, 217, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224,
224, 224, 224, 227, 224, 224, 224, 224, 224, 224, 224, 224, 245, 245, 245, 245,
 95,  95,  95,  95, 131,  95,  95,  95,  95, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 162, 130, 135, 130, 130, 130, 130, 162, 148, 136,
162, 162, 135, 162, 135, 162, 148, 162, 148, 148, 162, 171, 162, 135, 171, 162,
171, 135, 171, 162, 171, 171, 171, 171, 171, 162, 194, 171, 162, 174, 151, 171,
162, 162, 171, 171, 174, 174, 174, 194, 174, 174, 174, 171, 174, 194, 174, 204,
174, 174, 185, 185, 174, 174, 174, 174, 174, 185, 185, 174, 174, 185, 182, 174,
174, 174, 174, 174, 194, 182, 204, 174, 195, 203, 174, 190, 174, 195, 195, 195,
193, 195, 195, 191, 195, 182, 195, 195, 191, 193, 191, 200, 197, 200, 195, 195,
195, 200, 200, 197, 200, 197, 197, 195, 208, 200, 208, 200, 208, 208, 208, 197,
208, 208, 208, 215, 197, 217, 208, 197, 217, 217, 217, 217, 217, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 227, 227, 227, 227, 227, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 243, 245, 245,
 76,  95,  95,  95, 131, 131,  95,  95, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
130, 162, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 171, 160, 151, 171,
162, 171, 171, 171, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 194, 182, 174,
185, 185, 185, 174, 194, 182, 204, 191, 185, 203, 195, 185, 174, 191, 191, 195,
191, 195, 195, 191, 191, 182, 195, 195, 191, 193, 191, 200, 195, 196, 196, 195,
196, 196, 200, 195, 200, 195, 195, 205, 208, 200, 208, 211, 208, 208, 208, 208,
208, 208, 208, 208, 208, 213, 208, 213, 213, 213, 213, 213, 216, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 227, 217, 217, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 240, 243, 243, 243, 245, 245,
 76,  95, 131,  95, 131, 131, 131,  95, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
130, 130, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 171, 160, 160, 171,
171, 171, 171, 171, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 194, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 194, 182, 174,
185, 185, 185, 174, 194, 194, 204, 203, 185, 203, 195, 185, 174, 185, 185, 195,
191, 195, 195, 191, 191, 182, 191, 195, 196, 191, 196, 196, 195, 196, 196, 195,
196, 196, 205, 195, 205, 195, 195, 205, 208, 205, 208, 211, 208, 208, 208, 208,
208, 208, 208, 208, 208, 213, 213, 213, 213, 213, 213, 213, 216, 213, 213, 217,
213, 217, 213, 217, 216, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 240, 240, 243, 243, 243, 245, 245,
 76,  76, 131, 131, 131, 131, 131,  95, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
130, 131, 131, 131, 130, 130, 131, 130, 130, 147, 130, 130, 130, 130, 130, 147,
130, 130, 130, 130, 130, 130, 130, 147, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 147, 130, 130, 130, 147, 160, 147, 147, 147, 147, 147, 147, 166,
147, 130, 147, 147, 160, 147, 147, 147, 147, 147, 171, 147, 147, 160, 147, 162,
147, 160, 147, 171, 147, 147, 171, 147, 147, 171, 194, 171, 194, 160, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 171,
171, 185, 194, 194, 185, 185, 185, 171, 185, 185, 194, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 185, 185, 203, 185, 185, 201, 185, 185, 185,
185, 185, 185, 185, 185, 185, 185, 185, 185, 185, 185, 207, 201, 196, 205, 205,
205, 205, 205, 195, 205, 195, 205, 205, 205, 205, 205, 207, 207, 205, 205, 205,
211, 208, 208, 212, 212, 207, 213, 211, 213, 211, 213, 213, 216, 213, 213, 206,
213, 206, 213, 213, 213, 216, 216, 217, 217, 206, 217, 226, 217, 217, 217, 217,
231, 217, 235, 235, 235, 235, 235, 235, 235, 240, 240, 243, 243, 243, 245, 245,
 76,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 130, 131, 130, 130, 130, 130, 130, 131, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
130, 162, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 171, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 171, 160, 171,
171, 171, 171, 179, 171, 171, 171, 194, 171, 171, 171, 179, 185, 194, 171, 204,
171, 185, 194, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 185, 191,
203, 191, 195, 191, 191, 195, 191, 196, 196, 193, 196, 200, 195, 196, 196, 205,
205, 205, 205, 195, 205, 195, 205, 205, 208, 205, 205, 211, 208, 208, 208, 205,
208, 208, 208, 208, 213, 213, 213, 219, 213, 219, 213, 213, 216, 213, 213, 217,
213, 217, 213, 217, 213, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 224, 227, 240, 240, 243, 243, 245, 245, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 131, 131, 130, 130, 131, 130, 130, 131, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
171, 162, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 194, 185, 185, 185, 185, 201, 185, 185, 185, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 185, 201,
203, 195, 195, 196, 205, 195, 205, 195, 196, 200, 196, 196, 201, 205, 205, 205,
205, 205, 205, 195, 205, 195, 205, 205, 208, 205, 205, 211, 208, 208, 208, 212,
208, 213, 213, 216, 212, 213, 213, 213, 213, 213, 213, 213, 216, 216, 213, 217,
216, 217, 216, 217, 216, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 130, 131, 131, 130, 131, 130, 130, 130, 130, 130, 131,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
130, 130, 147, 171, 160, 171, 147, 171, 147, 147, 171, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 194, 194, 185, 185, 185, 201, 185, 185, 194, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 185, 201,
203, 195, 195, 196, 205, 195, 205, 195, 196, 211, 205, 196, 201, 205, 205, 205,
205, 205, 205, 195, 205, 195, 205, 205, 205, 205, 205, 211, 211, 208, 208, 212,
211, 213, 213, 216, 212, 213, 213, 213, 213, 213, 213, 213, 216, 216, 213, 213,
216, 217, 213, 216, 226, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 228, 227, 227, 227, 227, 227, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 130, 131, 131, 131, 131, 130, 130, 130, 130, 130, 131,
130, 130, 160, 130, 130, 160, 130, 130, 143, 130, 130, 130, 160, 160, 130, 130,
130, 136, 130, 130, 130, 130, 130, 160, 160, 160, 160, 160, 160, 162, 148, 166,
160, 160, 160, 160, 160, 160, 194, 171, 160, 160, 160, 160, 171, 160, 160, 162,
160, 160, 160, 171, 171, 160, 171, 160, 171, 171, 194, 171, 194, 160, 160, 171,
171, 171, 171, 194, 171, 160, 171, 194, 171, 171, 171, 171, 160, 194, 171, 204,
171, 171, 194, 194, 201, 185, 185, 201, 201, 185, 194, 185, 201, 194, 182, 201,
201, 195, 201, 201, 194, 194, 204, 201, 195, 203, 195, 195, 201, 195, 195, 195,
195, 195, 195, 195, 195, 215, 195, 195, 195, 196, 195, 196, 195, 195, 195, 195,
195, 195, 195, 195, 195, 215, 195, 195, 215, 195, 195, 211, 208, 208, 212, 212,
212, 216, 216, 215, 216, 216, 215, 212, 215, 216, 216, 216, 215, 215, 216, 216,
215, 215, 216, 215, 215, 215, 215, 217, 217, 215, 217, 215, 217, 217, 217, 217,
227, 227, 227, 227, 227, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 130, 131, 131, 131, 131, 131, 130, 130, 130, 131, 131,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 147, 147, 147, 147, 166,
147, 130, 147, 171, 160, 147, 147, 171, 147, 147, 171, 171, 171, 171, 147, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 171, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 179, 185, 194, 171, 204,
171, 185, 194, 194, 185, 185, 185, 201, 185, 185, 194, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 201, 201,
203, 185, 201, 185, 205, 195, 205, 205, 205, 211, 205, 194, 201, 205, 205, 205,
205, 205, 205, 201, 205, 205, 205, 205, 205, 205, 205, 211, 211, 211, 212, 212,
211, 211, 212, 212, 212, 211, 212, 211, 213, 211, 213, 213, 216, 213, 211, 213,
213, 216, 221, 226, 221, 226, 226, 226, 226, 217, 226, 226, 217, 231, 231, 231,
235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 131, 131, 130, 130, 131, 130, 130, 131, 130, 130, 130, 130, 130, 130,
130, 130, 166, 130, 130, 130, 130, 130, 143, 130, 130, 166, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 162, 130, 160, 130, 130, 130, 130, 162, 171, 136,
162, 162, 160, 162, 160, 162, 171, 162, 171, 171, 162, 171, 162, 171, 171, 162,
171, 171, 171, 162, 171, 171, 171, 171, 171, 162, 194, 171, 171, 174, 151, 171,
162, 162, 171, 171, 174, 174, 174, 194, 174, 174, 174, 203, 174, 194, 174, 204,
174, 174, 185, 185, 174, 174, 174, 174, 174, 185, 185, 174, 174, 194, 182, 174,
174, 195, 174, 174, 194, 190, 204, 174, 195, 203, 174, 195, 174, 195, 195, 195,
203, 195, 195, 191, 195, 195, 195, 195, 200, 193, 195, 200, 197, 200, 195, 195,
205, 205, 205, 197, 208, 197, 197, 208, 208, 208, 208, 211, 208, 208, 208, 197,
213, 213, 213, 216, 197, 217, 216, 197, 216, 219, 217, 217, 216, 217, 228, 217,
217, 217, 228, 217, 228, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 130, 131, 131, 131, 131, 131, 130, 130, 130, 131, 131,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 171, 160, 171, 160, 171, 147, 171, 147, 147, 171, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 201, 194, 171, 204,
171, 171, 194, 194, 201, 185, 201, 201, 201, 185, 194, 203, 201, 194, 185, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 185, 201, 201, 201, 201,
203, 195, 201, 205, 205, 195, 205, 205, 205, 211, 205, 205, 201, 205, 205, 205,
205, 205, 205, 201, 205, 195, 205, 205, 205, 205, 205, 211, 211, 212, 212, 212,
211, 213, 212, 216, 212, 213, 216, 213, 216, 213, 213, 216, 216, 216, 213, 216,
216, 216, 216, 226, 226, 226, 226, 217, 226, 217, 217, 226, 217, 228, 228, 228,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 130, 130, 130, 147, 143, 130, 147, 130, 147, 147, 130, 147,
147, 166, 130, 147, 130, 130, 130, 147, 147, 147, 147, 147, 147, 179, 147, 166,
147, 179, 147, 179, 147, 179, 147, 179, 147, 147, 179, 179, 179, 179, 179, 179,
179, 188, 179, 179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 188, 194, 179,
179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 179, 179, 179, 194, 179, 179,
179, 179, 194, 194, 179, 179, 179, 179, 179, 179, 194, 179, 179, 194, 194, 179,
179, 201, 203, 201, 194, 194, 204, 203, 203, 203, 201, 194, 203, 201, 203, 203,
203, 201, 201, 185, 203, 201, 205, 205, 194, 203, 205, 194, 203, 205, 205, 205,
205, 211, 211, 201, 211, 205, 205, 205, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 212, 211, 207, 211, 219, 211, 219, 211, 211, 221, 211, 219, 211,
221, 206, 221, 221, 221, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
228, 231, 235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 131, 131,
131, 131, 166, 131, 130, 130, 130, 130, 143, 130, 130, 166, 147, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 171, 194, 171, 160, 171, 194, 171, 147, 147, 171, 171, 171, 171, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 203, 201, 194, 171, 204,
171, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 185, 201, 201, 201, 201,
203, 201, 201, 205, 201, 195, 205, 205, 205, 211, 205, 205, 201, 205, 205, 205,
205, 205, 205, 201, 205, 205, 205, 205, 205, 205, 205, 211, 211, 211, 212, 212,
211, 212, 212, 216, 212, 213, 212, 222, 216, 219, 213, 216, 216, 216, 221, 216,
216, 216, 221, 226, 226, 226, 226, 226, 226, 217, 231, 226, 217, 228, 228, 228,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 130, 130, 130, 179, 130, 179, 147, 166,
179, 179, 147, 179, 188, 179, 147, 179, 179, 179, 179, 179, 179, 179, 179, 179,
179, 188, 179, 179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 188, 188, 179,
179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 179, 179, 179, 194, 179, 204,
179, 179, 194, 194, 179, 179, 201, 179, 179, 179, 194, 179, 179, 194, 194, 203,
203, 201, 203, 201, 194, 194, 204, 203, 203, 203, 201, 194, 203, 203, 203, 203,
203, 201, 201, 205, 203, 201, 205, 205, 211, 203, 205, 211, 203, 211, 205, 205,
205, 211, 211, 201, 211, 205, 205, 211, 211, 211, 211, 219, 211, 211, 211, 222,
211, 211, 211, 212, 211, 211, 211, 219, 211, 219, 219, 211, 221, 221, 219, 221,
221, 228, 219, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 235, 235, 235, 235, 224, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 130, 130, 130, 130, 143, 130, 130, 166, 130, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 162, 194, 171, 188, 171, 194, 162, 171, 194, 162, 171, 179, 171, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 188, 188, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 179, 201, 194, 171, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 195, 205, 205, 205, 203, 205, 211, 201, 205, 205, 205,
205, 205, 211, 201, 205, 205, 205, 205, 211, 211, 211, 211, 211, 211, 211, 222,
211, 211, 212, 216, 212, 211, 213, 219, 221, 219, 221, 221, 216, 221, 219, 228,
221, 226, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 235, 235, 240, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 130, 130, 130, 130, 143, 130, 130, 166, 147, 130, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 171, 194, 171, 188, 171, 194, 171, 147, 194, 171, 171, 179, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 194, 171, 179, 201, 194, 171, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 194, 201, 205, 205, 205,
205, 205, 205, 201, 205, 205, 205, 205, 205, 205, 205, 211, 211, 211, 212, 222,
211, 211, 212, 212, 212, 211, 212, 219, 221, 219, 221, 221, 216, 221, 221, 226,
221, 226, 221, 226, 225, 226, 226, 231, 231, 231, 231, 235, 231, 231, 231, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 160, 130, 131, 143, 130, 130, 166, 160, 160, 130, 130,
130, 166, 130, 130, 130, 130, 130, 160, 160, 160, 160, 160, 160, 171, 194, 166,
160, 160, 160, 160, 160, 160, 194, 171, 160, 194, 171, 171, 171, 160, 171, 162,
160, 160, 171, 171, 171, 160, 171, 194, 171, 171, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 188, 171, 194, 171, 194, 171, 171, 160, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 201, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 201, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 215, 201, 201, 205, 205, 205, 194, 201, 205, 205, 201,
205, 205, 205, 220, 205, 215, 212, 212, 223, 212, 212, 211, 223, 223, 212, 212,
212, 223, 212, 215, 212, 223, 223, 222, 216, 221, 216, 216, 215, 216, 226, 226,
226, 215, 226, 226, 226, 226, 226, 226, 226, 226, 226, 236, 235, 235, 235, 235,
235, 235, 235, 236, 235, 243, 243, 240, 243, 243, 243, 243, 243, 243, 243, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 147, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 162, 147, 166,
171, 171, 194, 171, 188, 171, 194, 171, 171, 194, 171, 171, 171, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 194, 171, 162, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 188, 171, 194, 171, 194, 171, 203, 201, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 194, 201, 205, 205, 205,
205, 205, 205, 220, 205, 212, 205, 205, 212, 211, 212, 211, 211, 211, 212, 222,
211, 212, 212, 223, 222, 211, 221, 222, 221, 219, 221, 221, 216, 221, 221, 226,
221, 226, 225, 226, 225, 226, 226, 231, 231, 231, 231, 235, 235, 231, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 147, 130, 130, 130,
130, 166, 130, 130, 130, 130, 179, 130, 188, 130, 130, 179, 130, 179, 179, 166,
179, 179, 194, 179, 188, 179, 194, 179, 179, 179, 179, 179, 179, 179, 179, 179,
179, 188, 179, 179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 188, 188, 179,
179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 179, 179, 201, 194, 179, 204,
179, 179, 194, 194, 179, 179, 201, 201, 203, 203, 194, 203, 201, 194, 201, 203,
203, 201, 203, 201, 194, 194, 204, 203, 203, 203, 201, 201, 203, 201, 203, 203,
203, 201, 201, 205, 203, 201, 203, 201, 211, 203, 205, 211, 203, 211, 205, 205,
205, 211, 211, 220, 211, 222, 222, 211, 211, 211, 211, 219, 211, 211, 211, 222,
211, 211, 211, 212, 222, 211, 211, 219, 221, 219, 219, 221, 225, 221, 219, 228,
228, 228, 219, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 235, 235, 235, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 130, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 162, 194, 166,
171, 162, 194, 171, 188, 171, 194, 162, 171, 194, 162, 171, 162, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 201, 201, 194, 201, 201, 203, 203, 201, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 211, 201, 205, 205, 205,
205, 205, 211, 220, 205, 222, 222, 212, 212, 211, 212, 211, 211, 212, 212, 222,
211, 221, 221, 216, 222, 216, 221, 219, 221, 219, 221, 221, 216, 226, 219, 226,
226, 226, 228, 228, 228, 228, 228, 228, 228, 228, 228, 235, 235, 228, 228, 235,
235, 235, 240, 240, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 147, 131, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 179, 147, 166,
171, 171, 194, 171, 188, 171, 194, 171, 147, 194, 171, 171, 179, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 194, 171, 171, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 188, 171, 194, 171, 194, 171, 203, 201, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 194, 201, 205, 205, 201,
205, 205, 211, 220, 205, 201, 222, 205, 223, 211, 212, 211, 211, 211, 212, 222,
211, 212, 212, 223, 222, 211, 221, 222, 221, 219, 221, 221, 223, 225, 221, 226,
225, 226, 225, 226, 225, 226, 231, 231, 231, 231, 231, 235, 235, 231, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 130, 130, 166, 130, 130, 130, 130,
130, 166, 166, 130, 130, 130, 162, 130, 160, 130, 166, 130, 166, 162, 171, 166,
171, 166, 160, 171, 160, 171, 194, 162, 171, 194, 162, 171, 162, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 188, 171,
204, 171, 171, 194, 201, 188, 201, 194, 201, 201, 171, 203, 201, 194, 201, 204,
201, 201, 194, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 194, 201, 201,
201, 201, 201, 204, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 205, 201, 215, 201, 201, 205, 211, 205, 211, 204, 205, 205, 195,
205, 212, 212, 204, 212, 215, 222, 212, 223, 212, 212, 211, 216, 216, 216, 222,
216, 216, 216, 215, 222, 216, 216, 222, 216, 221, 226, 226, 215, 226, 226, 226,
226, 226, 226, 226, 226, 226, 226, 228, 227, 235, 227, 227, 235, 227, 227, 227,
227, 240, 240, 240, 240, 240, 240, 240, 240, 243, 243, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 143, 131, 131, 166, 147, 131, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 179, 147, 166,
189, 189, 194, 179, 188, 179, 194, 179, 147, 194, 189, 179, 179, 188, 179, 179,
188, 188, 179, 179, 179, 179, 179, 194, 179, 179, 194, 179, 194, 188, 188, 179,
171, 179, 179, 194, 179, 188, 179, 194, 179, 194, 203, 179, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 194, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 194, 201, 201, 201, 201, 194, 203, 201, 194, 201, 205, 201, 201,
205, 211, 211, 220, 211, 220, 220, 205, 223, 211, 211, 211, 211, 211, 211, 222,
211, 211, 211, 223, 222, 211, 223, 222, 221, 219, 221, 221, 223, 225, 219, 225,
225, 226, 225, 225, 230, 230, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 130, 131,
130, 166, 166, 130, 130, 130, 130, 130, 188, 130, 189, 189, 188, 179, 194, 166,
189, 189, 194, 189, 188, 171, 194, 171, 194, 194, 189, 171, 179, 188, 171, 179,
188, 188, 171, 171, 171, 171, 171, 194, 171, 171, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 205, 203, 201, 194, 201, 205, 201, 201,
205, 211, 211, 220, 211, 220, 220, 222, 223, 211, 223, 211, 223, 223, 223, 222,
211, 223, 223, 223, 222, 223, 223, 222, 221, 219, 221, 225, 223, 225, 221, 225,
225, 226, 225, 230, 230, 230, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 143, 131, 131, 166, 147, 131, 131, 147,
131, 166, 189, 130, 130, 130, 130, 130, 188, 189, 189, 189, 188, 179, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 179, 179,
188, 188, 189, 179, 179, 188, 179, 194, 179, 179, 194, 179, 194, 188, 188, 179,
189, 179, 179, 194, 194, 188, 194, 194, 179, 194, 203, 203, 188, 194, 201, 204,
194, 194, 194, 194, 201, 194, 201, 201, 201, 194, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 194, 201, 201, 201, 201, 194, 203, 201, 194, 201, 205, 201, 201,
201, 211, 211, 220, 211, 220, 220, 223, 223, 223, 223, 211, 223, 223, 223, 222,
211, 223, 223, 223, 222, 223, 223, 222, 223, 221, 225, 225, 223, 225, 225, 225,
225, 223, 230, 230, 230, 230, 230, 231, 230, 231, 231, 233, 231, 231, 231, 235,
235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 130, 189, 189, 189, 189, 188, 189, 189, 189, 188, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 171, 179,
188, 188, 189, 171, 171, 188, 171, 194, 171, 189, 194, 171, 194, 188, 188, 171,
189, 171, 201, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 220, 223, 201, 201,
223, 223, 211, 220, 223, 220, 220, 222, 223, 223, 223, 211, 223, 223, 223, 222,
223, 223, 223, 223, 222, 223, 223, 222, 223, 219, 225, 225, 223, 230, 225, 230,
230, 223, 230, 230, 230, 230, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 189, 189, 189, 189, 189, 188, 189, 189, 189, 188, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 189, 179,
188, 188, 189, 171, 171, 188, 171, 194, 171, 189, 194, 171, 194, 188, 188, 171,
189, 203, 201, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 211, 203, 201, 194, 220, 223, 201, 220,
223, 223, 211, 220, 223, 220, 220, 222, 223, 223, 223, 211, 223, 223, 223, 222,
223, 223, 222, 223, 222, 223, 223, 222, 225, 222, 225, 225, 223, 230, 230, 230,
230, 223, 230, 230, 230, 230, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 189, 179,
188, 188, 189, 171, 171, 188, 171, 194, 171, 189, 194, 171, 194, 188, 188, 171,
189, 203, 201, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 211, 203, 201, 194, 220, 223, 220, 220,
223, 223, 222, 220, 222, 220, 220, 222, 223, 222, 222, 211, 223, 223, 223, 222,
222, 223, 222, 223, 222, 223, 223, 222, 225, 219, 225, 225, 223, 230, 231, 230,
230, 226, 230, 230, 222, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235, 235,
235, 235, 240, 240, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 179, 189, 194, 189, 194, 188, 188, 189,
189, 203, 201, 194, 201, 188, 201, 194, 203, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 220, 223, 220, 220,
220, 223, 222, 220, 223, 220, 220, 220, 223, 223, 223, 211, 223, 223, 223, 222,
223, 223, 223, 223, 222, 223, 223, 222, 223, 219, 230, 230, 223, 230, 230, 230,
230, 223, 230, 230, 230, 230, 233, 233, 233, 233, 233, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 189, 189, 189, 189, 166, 188, 189, 189, 189, 188, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 188, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 171, 189, 194, 171, 194, 188, 188, 201,
204, 203, 201, 194, 201, 188, 201, 194, 201, 201, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 204, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 201, 201, 223, 220, 220, 223, 203, 201, 223, 220, 223, 220, 220,
220, 223, 222, 220, 222, 220, 220, 222, 223, 222, 222, 211, 223, 223, 223, 222,
222, 223, 222, 223, 222, 223, 223, 222, 222, 222, 230, 230, 236, 230, 231, 230,
230, 230, 230, 230, 222, 231, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 131, 131,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 201, 194, 188, 188, 201, 194, 203, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 220, 201, 201, 201,
203, 201, 201, 201, 220, 223, 220, 220, 194, 203, 201, 194, 220, 223, 220, 220,
220, 223, 220, 220, 220, 220, 220, 220, 223, 223, 223, 211, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 222, 223, 222, 230, 230, 223, 230, 230, 230,
230, 223, 230, 233, 234, 233, 233, 233, 233, 233, 233, 237, 235, 237, 237, 237,
237, 237, 239, 237, 239, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 188, 194, 188, 188, 188, 194, 201, 194, 189, 203, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 194, 194, 203, 201, 194, 188, 201,
201, 201, 201, 229, 194, 194, 204, 203, 201, 203, 201, 194, 220, 201, 201, 220,
203, 220, 220, 223, 220, 229, 220, 220, 194, 203, 223, 194, 220, 223, 220, 220,
220, 223, 220, 220, 223, 229, 220, 220, 223, 223, 223, 223, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 234, 223, 234, 223, 223, 236, 223, 230, 223,
230, 223, 234, 230, 234, 233, 233, 233, 233, 236, 237, 236, 237, 237, 237, 237,
237, 237, 239, 242, 239, 242, 239, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 189, 131,
189, 166, 166, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
204, 203, 201, 194, 201, 188, 201, 194, 201, 201, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 201, 201,
201, 201, 201, 204, 194, 194, 204, 203, 201, 203, 220, 201, 204, 220, 220, 220,
203, 220, 220, 223, 220, 229, 220, 220, 223, 203, 220, 223, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 222, 222, 223, 223, 223, 222, 220,
222, 223, 222, 223, 222, 223, 223, 234, 222, 234, 230, 230, 236, 230, 233, 233,
233, 233, 234, 233, 234, 233, 233, 235, 233, 235, 235, 236, 235, 235, 235, 235,
240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 189, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 203, 194, 203, 194, 203, 203, 188, 194, 203, 204,
203, 203, 194, 194, 203, 201, 201, 201, 203, 203, 194, 203, 201, 194, 194, 203,
203, 201, 203, 220, 194, 194, 204, 203, 203, 203, 220, 194, 220, 220, 203, 220,
203, 220, 220, 220, 220, 229, 220, 220, 223, 203, 220, 194, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 220, 220, 219, 223, 223, 222, 220,
222, 223, 222, 223, 222, 223, 223, 234, 222, 234, 233, 234, 223, 233, 233, 233,
233, 233, 234, 233, 234, 233, 233, 233, 233, 233, 233, 237, 237, 237, 237, 237,
237, 239, 239, 239, 239, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 189, 131, 143, 189, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 201, 194, 203, 194, 189, 203, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 194, 194, 203, 201, 194, 194, 201,
201, 201, 201, 229, 194, 194, 204, 203, 201, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 223, 220, 229, 220, 220, 194, 203, 220, 194, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 220, 220, 223, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 234, 223, 234, 230, 234, 223, 233, 234, 233,
233, 223, 234, 233, 234, 233, 233, 233, 233, 233, 237, 236, 237, 237, 237, 237,
237, 239, 239, 242, 239, 239, 239, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 189, 131, 143, 189, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 189, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 201, 194, 203, 194, 189, 203, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 194, 201,
201, 201, 201, 229, 194, 194, 204, 203, 201, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 223, 220, 229, 220, 220, 223, 203, 220, 194, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 220, 220, 223, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 234, 223, 234, 233, 234, 236, 233, 234, 233,
233, 233, 234, 233, 234, 233, 233, 233, 233, 237, 237, 237, 237, 237, 237, 237,
237, 239, 239, 242, 239, 239, 239, 240, 240, 240, 240, 245, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 189, 131, 143, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 194, 188, 194, 189, 189,
194, 194, 194, 194, 194, 194, 194, 188, 201, 194, 194, 203, 201, 194, 194, 220,
201, 201, 220, 229, 194, 194, 232, 203, 220, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 194, 220, 229, 220, 220, 194, 203, 220, 194, 220, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 223, 220, 220, 223, 223, 223, 223, 220,
234, 223, 234, 223, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 233,
234, 233, 234, 234, 234, 234, 233, 233, 237, 237, 237, 237, 237, 237, 237, 237,
239, 239, 241, 242, 241, 241, 241, 244, 244, 244, 244, 244, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 189, 131, 143, 189, 189, 189, 131, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 203, 188, 194, 189, 204,
194, 203, 194, 194, 203, 201, 201, 201, 201, 194, 194, 203, 201, 194, 229, 220,
201, 220, 220, 229, 194, 194, 204, 220, 220, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 220, 220, 229, 220, 220, 223, 203, 220, 194, 220, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 223, 220, 220, 223, 223, 223, 220, 220,
234, 234, 234, 223, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 233,
234, 233, 234, 234, 234, 234, 233, 237, 237, 237, 237, 237, 237, 239, 237, 239,
239, 239, 239, 242, 241, 241, 241, 244, 244, 244, 244, 244, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 194, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 203, 188, 194, 189, 204,
189, 189, 194, 194, 203, 201, 229, 229, 220, 194, 194, 203, 220, 194, 229, 220,
220, 220, 220, 229, 194, 194, 232, 220, 220, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 220, 220, 229, 220, 220, 220, 203, 220, 194, 220, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 223, 220, 220, 234, 223, 234, 234, 220,
234, 234, 234, 223, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 234,
234, 233, 234, 234, 234, 234, 237, 237, 237, 237, 237, 237, 239, 239, 239, 239,
241, 241, 241, 242, 241, 244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 131, 131, 131,
131, 131, 166, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 194, 189, 189, 189, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 189, 194, 189, 194, 189, 189, 188, 194, 189, 204,
189, 189, 194, 194, 229, 229, 229, 229, 229, 194, 194, 220, 229, 194, 229, 229,
229, 229, 229, 229, 194, 194, 232, 220, 220, 203, 229, 229, 229, 229, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 223, 220, 220, 194, 229, 220, 220, 229,
220, 220, 220, 229, 220, 229, 229, 220, 223, 220, 220, 223, 223, 223, 234, 229,
234, 234, 234, 236, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 234,
234, 236, 234, 234, 234, 236, 236, 236, 236, 236, 236, 236, 239, 239, 236, 236,
241, 241, 241, 242, 241, 242, 244, 244, 244, 244, 244, 246, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 131, 131,
189, 131, 189, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 194, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 194, 229, 229, 189, 194, 194, 203, 229, 194, 229, 229,
220, 229, 220, 229, 194, 194, 232, 220, 220, 203, 229, 194, 229, 220, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 194, 220, 220, 194, 220, 220, 220, 220,
220, 220, 220, 229, 220, 229, 220, 220, 223, 220, 220, 234, 223, 234, 234, 220,
234, 234, 234, 229, 234, 223, 234, 234, 234, 234, 234, 234, 234, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 237, 234, 237, 239, 239, 239, 239, 241, 241,
241, 241, 241, 242, 241, 244, 244, 244, 244, 244, 244, 246, 249, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 189, 131, 131,
189, 189, 166, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 189, 189, 203, 188, 194, 189, 232,
189, 220, 194, 194, 220, 220, 229, 229, 220, 220, 194, 220, 229, 194, 229, 229,
220, 229, 220, 229, 194, 194, 232, 220, 220, 203, 229, 229, 232, 220, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 220, 220, 220, 223, 220, 220, 220, 220,
220, 220, 220, 229, 220, 229, 220, 220, 220, 220, 220, 234, 234, 234, 234, 234,
234, 234, 234, 229, 234, 234, 234, 234, 234, 234, 234, 234, 236, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 239, 234, 239, 239, 236, 239, 241, 241, 241,
241, 241, 241, 242, 244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 131, 131,
189, 189, 166, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 189, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 229, 229, 229, 220, 220, 194, 220, 229, 194, 229, 229,
220, 229, 220, 229, 194, 194, 232, 220, 220, 203, 229, 229, 232, 220, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 220, 220, 220, 194, 220, 220, 220, 220,
220, 220, 220, 229, 220, 229, 220, 220, 220, 220, 220, 234, 234, 234, 234, 234,
234, 234, 234, 229, 234, 234, 234, 238, 234, 234, 234, 234, 234, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 239, 234, 239, 241, 241, 239, 241, 241, 241,
241, 241, 241, 242, 244, 244, 244, 244, 244, 244, 249, 249, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 189, 131, 131,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 189, 188, 189,
189, 189, 189, 194, 189, 189, 189, 194, 189, 189, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 220, 229, 232, 220, 220, 194, 203, 220, 194, 229, 232,
220, 229, 220, 232, 194, 194, 232, 232, 220, 203, 220, 220, 232, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 220, 220, 220, 194, 232, 220, 220, 220,
220, 220, 220, 232, 220, 229, 238, 220, 234, 234, 234, 234, 234, 234, 234, 238,
234, 234, 234, 234, 234, 234, 234, 238, 234, 238, 234, 234, 234, 234, 234, 234,
234, 239, 234, 234, 238, 234, 234, 239, 234, 239, 241, 241, 241, 241, 241, 241,
241, 241, 244, 244, 244, 244, 244, 248, 248, 248, 248, 248, 248, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 189, 131, 131, 189, 131, 189, 189, 189, 189, 189, 131,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 188, 188, 189,
189, 189, 189, 194, 189, 189, 189, 194, 189, 189, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 229, 229, 229, 229, 220, 194, 220, 229, 194, 229, 232,
229, 229, 229, 229, 194, 194, 232, 232, 229, 238, 229, 229, 232, 229, 229, 229,
220, 229, 229, 229, 229, 229, 229, 229, 220, 220, 229, 194, 232, 220, 229, 229,
229, 220, 220, 232, 220, 229, 229, 229, 229, 234, 234, 234, 234, 234, 234, 238,
234, 234, 234, 229, 234, 234, 234, 238, 234, 238, 234, 234, 234, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 241, 234, 241, 241, 241, 241, 241, 241, 241,
247, 241, 244, 244, 247, 244, 244, 244, 246, 246, 249, 249, 251, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 189, 189, 131, 189, 189, 131, 189, 189, 189, 189, 189, 131,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 188, 188, 189,
189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 189, 229, 194, 189, 232,
189, 189, 194, 194, 229, 229, 229, 232, 229, 229, 194, 220, 229, 194, 229, 232,
229, 229, 229, 229, 194, 229, 232, 232, 229, 238, 229, 229, 232, 229, 229, 229,
238, 229, 229, 229, 229, 229, 229, 229, 220, 238, 229, 220, 232, 229, 229, 229,
229, 229, 238, 232, 229, 229, 229, 229, 229, 238, 229, 234, 234, 234, 234, 238,
234, 234, 234, 229, 238, 234, 234, 238, 234, 238, 234, 234, 234, 234, 238, 234,
234, 239, 238, 234, 238, 234, 234, 241, 241, 241, 241, 241, 241, 241, 241, 241,
247, 244, 244, 246, 247, 246, 246, 246, 246, 249, 249, 251, 251, 252, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
189, 131, 131, 131, 189, 189, 131, 189, 189, 131, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 189, 188, 189,
189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 189, 229, 194, 189, 232,
189, 189, 194, 194, 189, 229, 229, 232, 232, 189, 194, 232, 229, 194, 229, 232,
229, 229, 229, 232, 194, 229, 232, 232, 229, 238, 232, 229, 232, 229, 229, 232,
238, 229, 229, 229, 238, 229, 229, 229, 220, 238, 229, 220, 232, 220, 238, 229,
238, 238, 238, 232, 238, 229, 238, 238, 229, 238, 238, 238, 234, 238, 238, 238,
238, 238, 238, 229, 238, 234, 238, 238, 238, 238, 238, 238, 234, 238, 238, 234,
238, 239, 238, 238, 238, 238, 234, 241, 238, 241, 241, 247, 241, 241, 247, 247,
247, 247, 246, 246, 247, 246, 246, 248, 249, 249, 248, 251, 251, 252, 252, 253,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
189, 131, 189, 131, 189, 189, 189, 189, 189, 131, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 189, 188, 189,
232, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 189, 229, 194, 189, 232,
189, 189, 194, 194, 232, 229, 229, 232, 229, 229, 229, 232, 229, 194, 229, 232,
229, 229, 229, 232, 194, 229, 232, 232, 229, 238, 232, 229, 232, 229, 229, 229,
238, 229, 229, 229, 229, 229, 229, 229, 229, 238, 229, 234, 232, 229, 229, 229,
229, 238, 238, 232, 238, 229, 238, 238, 229, 238, 238, 238, 234, 238, 238, 238,
238, 238, 238, 229, 238, 234, 238, 238, 238, 238, 238, 238, 234, 238, 238, 234,
238, 241, 238, 238, 238, 238, 247, 241, 247, 241, 247, 247, 241, 247, 247, 247,
247, 247, 247, 246, 247, 246, 246, 249, 249, 249, 251, 251, 252, 252, 253, 253,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 229, 189,
232, 232, 189, 189, 189, 232, 189, 194, 232, 189, 232, 189, 229, 194, 232, 232,
232, 232, 229, 229, 232, 232, 229, 232, 232, 232, 229, 232, 232, 194, 229, 232,
232, 229, 232, 232, 194, 229, 232, 232, 232, 238, 232, 229, 232, 229, 232, 232,
238, 229, 229, 229, 238, 229, 238, 229, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 229, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 229, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 247, 238, 238, 238, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 249, 247, 251, 251, 251, 251, 252, 252, 253, 253, 254,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 131, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 232, 194, 189, 189, 232, 229, 232,
232, 232, 232, 189, 232, 232, 232, 194, 232, 232, 232, 232, 229, 194, 232, 232,
232, 232, 229, 232, 232, 232, 229, 232, 232, 232, 229, 232, 232, 229, 229, 232,
232, 232, 232, 232, 229, 229, 232, 232, 232, 238, 232, 229, 232, 232, 232, 232,
238, 232, 232, 238, 238, 229, 238, 238, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 229, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 247, 238, 238, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 251, 247, 251, 251, 252, 252, 252, 252, 253, 253, 254,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 232,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 232, 189, 189, 189, 189, 232, 189, 189, 232, 189, 232, 189, 232, 229, 232,
232, 232, 232, 232, 232, 232, 232, 194, 232, 232, 232, 232, 232, 194, 232, 232,
232, 232, 229, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 238, 229, 232,
232, 232, 232, 232, 229, 229, 232, 232, 232, 238, 232, 229, 232, 232, 232, 232,
238, 238, 232, 238, 238, 229, 238, 238, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 232, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 247, 238, 238, 238,
238, 247, 238, 238, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 252, 247, 252, 252, 252, 252, 253, 253, 254, 254, 255,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 232, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 232,
189, 232, 189, 232, 232, 232, 189, 232, 189, 189, 232, 232, 232, 232, 232, 232,
232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 189, 232, 232, 232, 229, 232,
232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 238, 232, 232,
232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 238, 229, 232,
232, 232, 232, 232, 238, 229, 232, 232, 232, 238, 232, 238, 232, 232, 232, 232,
238, 238, 232, 238, 238, 229, 238, 238, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 232, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 247, 238, 238, 247,
238, 247, 238, 247, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 253, 253, 253, 253, 253, 253, 254, 254, 254, 255, 255
};

UInt8 *hvqelut_4x2_1[] = {hvqelut_4x2_1a, hvqelut_4x2_1b};

#else /* macintosh */

UInt8 hvqelut_2x1_1[] = {
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   0,   0,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   4,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  0,   1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  1,   1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,
  1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   6,   6,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,
  1,   1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   4,   6,   6,   6,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,
  1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,
  1,   1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   2,   2,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,
  6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,
  1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   2,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,
  6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,
  1,   1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   2,   3,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  2,   3,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  1,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,
  2,   2,   2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,
  2,   2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,
  2,   2,   2,   2,   2,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,
  2,   2,   2,   2,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,
  2,   2,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,   2,
  2,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,   7,
  7,   7,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,   2,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   2,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   2,   2,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   1,   2,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   2,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  4,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,
  5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,
  5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  3,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,  11,  11,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   5,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   6,   6,   6,
  6,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 36,  36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,
  4,   4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,
 36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,
  4,   4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,
  4,   4,   4,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,
 21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,   4,   4,   4,
  4,   4,  10,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,
 18,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   3,   4,   4,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,   5,   5,   5,   5,   5,   5,   5,   5,   5,
  5,   5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,  11,
 11,  11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,  18,
 18,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,   3,   3,   3,   3,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   5,   5,   5,   5,
  5,   8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,   9,  12,
 11,  11,  11,  11,  11,  11,  11,  11,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,   3,   3,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
  8,   8,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,   9,  12,  12,
 12,  11,  11,  11,  11,  11,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  27,  27,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,   8,   8,   8,   8,   8,   8,   9,   9,   9,   9,   9,   9,  12,  12,  12,
 12,  12,  12,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  27,  27,  27,  27,  27,  21,  21,  21,  21,  21,  21,  21,  21,  21,
 21,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,   8,   8,   8,   9,   9,   9,   9,   9,  13,  13,  13,  13,  13,
 13,  13,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  18,  27,  27,  27,  27,  27,  27,  27,  27,  21,  21,  21,  21,  21,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,   8,   9,   9,   9,   9,   9,  13,  13,  13,  13,  13,  13,
 13,  14,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  36,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,   9,   9,   9,   9,  13,  13,  13,  13,  13,  13,  13,
 14,  14,  15,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 18,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  36,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,   9,  13,  13,  13,  13,  13,  13,  13,  14,  14,
 14,  14,  14,  15,  15,  15,  15,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 36,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  13,  13,  13,  13,  13,  13,  14,  14,  14,
 14,  14,  16,  16,  16,  15,  19,  19,  18,  18,  18,  18,  18,  18,  18,  24,
 24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  13,  13,  13,  14,  14,  14,  14,  14,
 14,  16,  16,  16,  16,  19,  19,  19,  19,  18,  18,  18,  18,  18,  24,  24,
 24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  14,  14,  14,  14,  14,
 16,  16,  16,  16,  16,  19,  19,  19,  19,  19,  18,  18,  18,  24,  24,  24,
 24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  14,  16,
 16,  16,  16,  16,  19,  19,  19,  19,  19,  19,  19,  23,  24,  24,  24,  24,
 24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,
 16,  16,  20,  20,  20,  20,  19,  19,  19,  19,  23,  23,  24,  24,  24,  24,
 24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  27,  27,  36,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  20,  20,  20,  20,  20,  20,  20,  19,  23,  23,  23,  23,  24,  24,  24,
 24,  24,  24,  24,  27,  27,  27,  27,  27,  27,  27,  27,  38,  38,  36,  36,
 36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  20,  20,  20,  20,  20,  20,  20,  23,  23,  23,  23,  25,  24,  24,
 24,  24,  24,  24,  27,  27,  27,  27,  27,  27,  34,  38,  38,  38,  40,  40,
 40,  36,  36,  36,  36,  36,  36,  36,  36,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  20,  20,  20,  20,  20,  20,  22,  23,  23,  23,  23,  25,  25,  28,
 28,  28,  28,  28,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  36,  36,  36,  36,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  20,  20,  20,  22,  22,  22,  22,  23,  23,  23,  25,  25,  25,  28,
 28,  28,  28,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  40,  40,  40,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  23,  26,  26,  26,  25,  28,  28,
 28,  28,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  40,  40,  40,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  26,  26,  28,  28,
 28,  30,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  40,
 40,  40,  40,  40,  40,  40,  40,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  26,  26,  29,  29,
 30,  30,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  40,  40,  40,  47,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  49,  49,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  26,  29,  29,  29,
 29,  30,  30,  30,  30,  34,  34,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  40,  40,  47,  47,  49,  49,  49,  49,  49,  49,  49,  49,  49,
 49,  56,  56,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  26,  29,  29,  29,  29,
 29,  31,  31,  31,  35,  35,  34,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  40,  47,  47,  47,  47,  49,  49,  49,  49,  49,  49,  49,  49,
 56,  56,  56,  56,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  26,  29,  29,  29,  29,  29,
 31,  31,  31,  31,  35,  35,  35,  34,  34,  34,  34,  38,  38,  38,  38,  38,
 40,  40,  40,  47,  47,  47,  47,  47,  47,  49,  49,  49,  49,  49,  56,  56,
 56,  56,  56,  56,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  31,
 31,  31,  31,  35,  35,  35,  35,  35,  34,  34,  34,  42,  42,  38,  38,  38,
 38,  40,  47,  47,  47,  47,  47,  47,  47,  47,  49,  49,  56,  56,  56,  56,
 56,  56,  56,  56,  67,  67,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  17,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  31,  31,
 31,  31,  35,  35,  35,  35,  35,  37,  37,  41,  42,  42,  42,  42,  42,  42,
 42,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  56,  56,  56,  56,  56,
 56,  56,  56,  56,  67,  67,  67,  67,  67,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  22,  22,  22,  22,  22,  22,  33,  33,  33,  33,  33,  33,  31,  31,  31,
 31,  31,  35,  35,  35,  37,  37,  37,  41,  41,  42,  42,  42,  42,  42,  42,
 42,  47,  47,  47,  47,  47,  47,  47,  47,  47,  56,  56,  56,  56,  56,  56,
 56,  56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  61,  61,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  79,  79,  79,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  22,  22,  22,  22,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,  31,
 31,  35,  35,  37,  37,  37,  37,  37,  41,  41,  42,  42,  42,  42,  42,  42,
 42,  42,  47,  47,  47,  47,  47,  47,  47,  47,  54,  56,  56,  56,  56,  56,
 56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  61,  61,
 61,  61,  61,  61,  61,  61,  61,  61,  79,  79,  79,  79,  79,  95,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  37,  37,  37,  37,  37,  37,  41,  41,  41,  42,  42,  42,  42,  42,  42,
 42,  42,  47,  47,  47,  47,  47,  47,  54,  54,  54,  54,  56,  56,  56,  56,
 56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,
 67,  61,  61,  61,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  17,  32,
 32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  37,  37,  37,  37,  41,  41,  41,  41,  41,  42,  42,  42,  42,  42,
 42,  42,  52,  47,  47,  47,  54,  54,  54,  54,  54,  54,  59,  59,  56,  56,
 56,  56,  56,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,
 67,  67,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,
 95,  95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  17,  17,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  37,  37,  37,  37,  41,  41,  41,  41,  41,  42,  42,  42,  42,  42,
 42,  52,  52,  52,  52,  54,  54,  54,  54,  54,  54,  54,  59,  59,  59,  59,
 59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,
 67,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  17,  17,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  37,  37,  41,  41,  41,  41,  41,  45,  45,  45,  45,  48,  48,
 48,  52,  52,  52,  52,  52,  54,  54,  54,  54,  54,  54,  59,  59,  59,  59,
 59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  17,  17,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  37,  41,  41,  41,  41,  41,  45,  45,  45,  45,  45,  48,  48,
 48,  52,  52,  52,  52,  52,  54,  54,  54,  54,  54,  59,  59,  59,  59,  59,
 59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  17,  17,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  44,  44,  44,  44,  45,  45,  45,  45,  45,  45,  46,  48,  48,
 48,  52,  52,  52,  52,  52,  52,  54,  54,  54,  54,  59,  59,  59,  59,  59,
 59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  67,  67,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  33,  33,  33,  33,  33,
 33,  33,  44,  44,  44,  44,  44,  44,  45,  45,  45,  45,  46,  46,  48,  48,
 48,  52,  52,  52,  52,  52,  58,  58,  58,  58,  54,  59,  59,  59,  59,  59,
 59,  59,  59,  59,  67,  67,  67,  67,  67,  67,  67,  67,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  44,  44,  44,  44,  44,  44,  44,  45,  45,  46,  46,  46,  48,  48,
 48,  53,  52,  52,  52,  52,  58,  58,  58,  58,  58,  59,  59,  59,  59,  59,
 59,  59,  59,  59,  67,  67,  67,  67,  67,  67,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  44,  44,  44,  44,  44,  44,  44,  44,  46,  46,  46,  46,  48,  48,
 53,  53,  53,  52,  52,  58,  58,  58,  58,  58,  58,  58,  59,  59,  59,  59,
 59,  59,  59,  71,  67,  67,  67,  67,  67,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  44,  44,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  53,
 53,  53,  53,  53,  57,  58,  58,  58,  58,  58,  58,  65,  65,  65,  71,  71,
 71,  71,  71,  71,  71,  71,  67,  67,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  50,  53,
 53,  53,  53,  57,  57,  57,  58,  58,  58,  58,  65,  65,  65,  65,  71,  71,
 71,  71,  71,  71,  71,  71,  71,  79,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  50,  55,
 55,  55,  57,  57,  57,  57,  57,  58,  58,  65,  65,  65,  65,  65,  71,  71,
 71,  71,  71,  71,  71,  71,  71,  79,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  55,  55,
 55,  55,  57,  57,  57,  57,  57,  58,  65,  65,  65,  65,  65,  71,  71,  71,
 71,  71,  71,  71,  71,  71,  71,  81,  79,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  79,  79,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  39,  39,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  50,  55,  55,
 55,  55,  60,  60,  60,  60,  60,  66,  66,  65,  65,  65,  65,  71,  71,  71,
 71,  71,  71,  71,  71,  71,  81,  81,  81,  79,  79,  79,  79,  79,  79,  79,
 79,  79,  79,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,  39,  39,  39,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  55,  55,  55,
 55,  60,  60,  60,  60,  60,  66,  66,  66,  68,  68,  68,  68,  71,  71,  71,
 71,  71,  71,  71,  71,  81,  81,  81,  81,  81,  79,  79,  79,  79,  79,  79,
 79,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 39,  39,  39,  44,  44,  44,  44,  44,  44,  50,  50,  50,  50,  55,  55,  55,
 55,  60,  60,  60,  60,  60,  66,  66,  66,  66,  68,  68,  68,  68,  71,  71,
 71,  71,  71,  71,  81,  81,  81,  81,  81,  81,  81,  79,  79,  79,  79,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  39,  44,  44,  44,  44,  44,  50,  50,  50,  50,  55,  55,  55,  55,
 62,  62,  62,  62,  62,  62,  66,  66,  66,  66,  66,  68,  68,  68,  71,  71,
 71,  71,  71,  81,  81,  81,  81,  81,  81,  81,  81,  81,  79,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  44,  44,  44,  44,  50,  50,  50,  63,  63,  63,  63,  63,
 62,  62,  62,  62,  62,  62,  66,  66,  66,  66,  66,  68,  68,  68,  71,  71,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95,  95,  95,
104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  44,  44,  44,  50,  63,  63,  63,  63,  63,  63,  63,
 63,  63,  62,  62,  62,  62,  70,  70,  70,  70,  70,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95,  95, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 130, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  44,  44,  63,  63,  63,  63,  63,  63,  63,  63,
 63,  63,  63,  62,  62,  62,  70,  70,  70,  70,  70,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95,  95, 104, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 130, 130, 130, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  64,  64,  64,  63,  63,  63,  63,  63,  63,  63,  63,
 63,  63,  63,  63,  63,  70,  70,  70,  70,  70,  73,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  95,  95,  95,  95,  95, 104, 104, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 130, 130, 130, 130, 130, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  10,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  64,  64,  64,  64,  64,  64,  63,  63,  63,  63,  63,  63,
 63,  63,  63,  69,  69,  69,  70,  70,  70,  73,  73,  73,  73,  73,  77,  77,
 77,  77,  77,  77,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  88,  88,
 88,  88,  88,  88,  88,  88,  88, 103,  95,  95, 104, 104, 104, 104, 104, 104,
104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 130, 130, 130, 130, 130, 130, 130, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  64,  64,  64,  64,  64,  64,  64,  63,  63,  63,  63,  63,
 63,  63,  69,  69,  69,  69,  69,  70,  70,  73,  73,  73,  73,  75,  75,  77,
 77,  77,  77,  82,  82,  81,  81,  81,  81,  81,  81,  81,  81,  93,  93,  93,
 88,  88,  88,  88,  88, 103, 103, 103, 103, 103, 103, 104, 104, 104, 104, 104,
104, 104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 130, 130, 130, 130, 130, 130, 130, 130, 130, 129, 129, 129, 129, 129,
129, 129, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  63,  63,  63,  63,
 69,  69,  69,  69,  69,  69,  69,  74,  74,  73,  73,  73,  75,  75,  75,  75,
 77,  77,  82,  82,  82,  82,  81,  81,  81,  81,  81,  81,  93,  93,  93,  93,
 93,  93,  93,  88, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 104, 104,
104, 104, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 129, 129, 129, 129,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  63,  63,  69,
 69,  69,  69,  69,  69,  69,  74,  74,  74,  74,  74,  75,  75,  75,  75,  75,
 80,  82,  82,  82,  82,  82,  82,  81,  81,  81,  81,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107, 107,
107, 107, 104, 104, 104, 104, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 129, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 69,  69,  69,  69,  69,  69,  74,  74,  74,  74,  74,  75,  75,  75,  75,  80,
 80,  80,  82,  82,  82,  82,  85,  85,  89,  89,  89,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107, 107,
107, 107, 107, 107, 107, 107, 114, 114, 114, 114, 114, 114, 114, 114, 114, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,  43,  43,  43,  43,
 43,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  74,  74,  74,  74,  74,  74,  74,  75,  75,  80,  80,
 80,  80,  84,  84,  85,  85,  85,  85,  89,  89,  89,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107,
107, 107, 107, 107, 107, 107, 107, 114, 114, 128, 128, 128, 128, 128, 128, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  43,  43,  43,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  72,  74,  74,  74,  74,  74,  74,  74,  80,  80,  80,
 80,  84,  84,  84,  85,  85,  85,  89,  89,  89,  89,  93,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107,
107, 107, 107, 107, 107, 107, 107, 128, 128, 128, 128, 128, 128, 128, 128, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  72,  74,  74,  74,  74,  74,  74,  74,  80,  80,  80,
 80,  84,  84,  84,  85,  85,  85,  89,  89,  89,  89,  89,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 107, 107, 107, 107,
107, 107, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  72,  76,  76,  74,  74,  74,  74,  74,  74,  80,  80,  86,
 86,  86,  86,  86,  85,  85,  89,  89,  89,  89,  89,  89,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 103, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143,
153, 153, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  72,  76,  76,  76,  76,  76,  74,  74,  74,  74,  80,  86,  86,
 86,  86,  86,  86,  86,  85,  89,  89,  89,  89,  89,  89,  93,  93,  93,  93,
 93,  93,  93,  93, 103, 103, 103, 103, 103, 103, 103, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 130, 130, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 10,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  72,  72,  76,  76,  76,  76,  76,  76,  76,  76,  74,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  92,  92,  92,  92,  92,  92,  92,  92,  93,  93,  93,
 93,  93,  93, 110, 110, 110, 103, 103, 103, 103, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 130, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,  72,
 72,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  86,  86,  86,  86,
 86,  90,  90,  90,  90,  90,  92,  92,  92,  92,  92,  92,  97,  97,  97,  97,
 93,  93, 110, 110, 110, 110, 110, 113, 113, 115, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 127, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 130, 130, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 148, 148, 148, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148,
148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  72,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  87,  90,  90,  90,
 90,  90,  90,  90,  90,  90,  92,  92,  92,  92,  92,  97,  97,  97,  97, 102,
102, 102, 110, 110, 110, 110, 110, 113, 113, 113, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 127, 127, 128, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 128, 130, 130, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 148, 148, 148,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  78,  78,  78,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  87,  87,  87,  87,  90,  90,
 90,  90,  90,  90,  90,  91,  91,  92,  92,  92,  97,  97,  97,  97, 102, 102,
102, 108, 110, 110, 110, 110, 110, 113, 113, 113, 113, 115, 115, 115, 115, 115,
115, 115, 115, 115, 127, 127, 127, 127, 128, 128, 128, 128, 128, 128, 128, 128,
128, 128, 128, 128, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  78,  78,  78,  78,
 78,  76,  76,  76,  76,  76,  76,  76,  76,  87,  87,  87,  87,  87,  90,  90,
 90,  90,  90,  90,  91,  91,  91,  91,  92,  97,  97,  97,  97,  97, 102, 102,
102, 108, 110, 110, 110, 110, 110, 113, 113, 113, 113, 113, 115, 115, 115, 115,
115, 115, 115, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128, 128, 128, 128,
128, 128, 128, 128, 130, 130, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
153, 153, 148, 148, 148, 148, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  64,  64,  64,  64,  64,  64,  64,  64,  78,  78,  78,  78,  78,  78,
 78,  78,  76,  76,  76,  76,  76,  87,  87,  87,  87,  87,  87,  87,  87,  90,
 90,  90,  90,  91,  91,  91,  91,  96,  96,  97,  97,  97,  97, 102, 102, 102,
102, 108, 108, 110, 110, 110, 110, 113, 113, 113, 113, 113, 113, 115, 115, 115,
115, 115, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128, 128, 128,
128, 128, 128, 128, 128, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
153, 153, 153, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  64,  64,  64,  64,  64,  64,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  76,  76,  87,  87,  87,  87,  87,  87,  87,  87,  87,  90,
 90,  90,  91,  91,  91,  91,  96,  96,  96,  96,  97,  97, 102, 102, 102, 102,
108, 108, 108, 110, 110, 110, 110, 113, 113, 113, 113, 113, 113, 113, 115, 115,
125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128, 128,
128, 128, 128, 128, 128, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153,
153, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  64,  64,  64,  64,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,
 90,  91,  91,  91,  91,  96,  96,  96,  96,  96, 101, 101, 102, 102, 102, 102,
108, 108, 108, 110, 110, 110, 110, 113, 113, 113, 113, 113, 113, 113, 125, 125,
125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128, 128,
128, 128, 128, 128, 128, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  64,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,
 91,  91,  91,  91,  96,  96,  96,  96,  96, 101, 101, 101, 101, 106, 106, 106,
108, 108, 108, 108, 112, 112, 112, 112, 113, 113, 113, 113, 113, 125, 125, 125,
125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128,
128, 128, 128, 147, 147, 155, 143, 143, 143, 143, 143, 143, 143, 143, 143, 143,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,
 99,  99,  99,  96,  96,  96,  96,  96, 101, 101, 101, 101, 101, 106, 106, 106,
106, 108, 108, 112, 112, 112, 112, 112, 112, 113, 113, 113, 113, 125, 125, 125,
125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 128, 128, 128,
147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  99,
 99,  99,  99,  99,  96,  96,  96,  96, 101, 101, 101, 101, 101, 106, 106, 106,
106, 108, 108, 112, 112, 112, 112, 112, 112, 112, 113, 113, 123, 125, 125, 125,
125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 127, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 153, 153, 153, 153, 153, 153, 153, 153, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  87,  87,  87,  87,  87,  87,  87,  99,
 99,  99,  99,  99,  99,  99,  96, 101, 101, 101, 101, 101, 101, 106, 106, 106,
106, 106, 112, 112, 112, 112, 112, 112, 112, 112, 123, 123, 123, 125, 125, 125,
125, 125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 127, 127, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 153, 153, 153, 153, 153, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  87,  87,  87,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99, 101, 101, 101, 101, 101, 101, 111, 111, 111,
111, 111, 116, 117, 117, 117, 117, 117, 117, 123, 123, 123, 123, 123, 125, 125,
125, 125, 125, 125, 125, 125, 127, 127, 127, 127, 127, 127, 146, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 153, 153, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99, 101, 101, 101, 101, 101, 111, 111, 111, 111,
111, 116, 116, 117, 117, 117, 117, 117, 117, 123, 123, 123, 123, 123, 123, 125,
125, 125, 125, 125, 125, 125, 127, 127, 127, 127, 127, 146, 146, 147, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 155, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99,  99, 101, 101, 101, 111, 111, 111, 111, 111,
111, 116, 116, 117, 117, 117, 117, 117, 117, 119, 123, 123, 123, 123, 123, 123,
125, 125, 125, 125, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 147, 147,
147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 155, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,
 83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99,  99,  99,  99,  99, 105, 109, 109, 111, 111, 111, 111, 111, 111,
116, 116, 116, 116, 117, 117, 117, 117, 119, 119, 123, 123, 123, 123, 123, 123,
123, 125, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 147,
147, 147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 155, 155, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,
 83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  99,
 99,  99,  99, 105, 105, 105, 105, 109, 109, 109, 111, 111, 111, 111, 111, 111,
116, 116, 116, 116, 117, 117, 117, 119, 119, 119, 119, 123, 123, 123, 123, 123,
123, 134, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 147,
147, 147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 155, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100,
100, 105, 105, 105, 105, 105, 109, 109, 109, 109, 109, 111, 111, 111, 111, 116,
116, 116, 116, 116, 117, 120, 120, 119, 119, 119, 119, 126, 126, 126, 126, 126,
126, 134, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 146,
147, 147, 147, 147, 147, 147, 147, 155, 155, 155, 155, 155, 162, 162, 162, 162,
162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100, 100,
100, 105, 105, 105, 105, 105, 109, 109, 109, 109, 109, 109, 111, 111, 111, 116,
116, 116, 116, 116, 120, 120, 120, 120, 119, 119, 126, 126, 126, 126, 126, 126,
126, 134, 134, 134, 134, 134, 134, 134, 134, 134, 146, 146, 146, 146, 146, 146,
146, 147, 147, 147, 147, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,  78,  78,
 78,  78,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100, 100, 100,
100, 100, 105, 105, 105, 109, 109, 109, 109, 109, 109, 109, 111, 111, 116, 116,
116, 116, 116, 120, 120, 120, 120, 120, 122, 122, 122, 126, 126, 126, 126, 126,
126, 134, 134, 134, 134, 134, 134, 138, 138, 138, 146, 146, 146, 146, 146, 146,
146, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  78,  78,  78,  78,  78,  78,
 78,  98,  94,  94,  94,  94,  94,  94,  94,  94, 100, 100, 100, 100, 100, 100,
100, 100, 105, 105, 109, 109, 109, 109, 109, 109, 109, 109, 109, 111, 116, 116,
116, 116, 124, 124, 124, 120, 120, 122, 122, 122, 122, 126, 126, 126, 126, 126,
136, 136, 134, 134, 138, 138, 138, 138, 138, 138, 146, 146, 146, 146, 146, 146,
154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,
 98,  98,  98,  94,  94,  94,  94,  94,  94, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 105, 109, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121,
121, 124, 124, 124, 124, 124, 124, 122, 122, 122, 122, 132, 132, 132, 132, 132,
136, 136, 136, 138, 138, 138, 138, 138, 138, 145, 145, 146, 146, 146, 146, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 162, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  94,  94,  94, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121,
121, 121, 124, 124, 124, 124, 124, 124, 131, 131, 131, 132, 132, 132, 132, 135,
136, 136, 136, 136, 138, 138, 138, 145, 145, 145, 145, 145, 146, 146, 146, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 162, 162, 175, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  94, 100, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121,
121, 121, 124, 124, 124, 124, 124, 124, 131, 131, 131, 132, 132, 132, 132, 135,
136, 136, 136, 136, 136, 138, 145, 145, 145, 145, 145, 145, 145, 146, 154, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
162, 162, 175, 175, 175, 184, 184, 184, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121,
121, 121, 121, 124, 124, 124, 124, 124, 131, 131, 131, 131, 132, 132, 135, 135,
135, 136, 136, 136, 136, 144, 145, 145, 145, 145, 145, 145, 145, 154, 154, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 162, 162, 162,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121, 121,
121, 121, 121, 124, 124, 124, 124, 124, 131, 131, 131, 131, 132, 135, 135, 135,
135, 135, 136, 136, 144, 144, 144, 145, 145, 145, 145, 145, 145, 156, 156, 154,
154, 154, 154, 154, 154, 154, 154, 154, 162, 162, 162, 162, 162, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 177, 177,
177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 124, 124, 124, 124, 131, 131, 131, 131, 131, 135, 135, 135,
135, 141, 141, 144, 144, 144, 144, 144, 145, 145, 145, 145, 156, 156, 156, 156,
156, 156, 154, 154, 154, 154, 154, 154, 162, 162, 162, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 177, 177, 177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100,
100, 100, 100, 109, 109, 109, 109, 109, 109, 121, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 124, 124, 131, 131, 131, 131, 131, 137, 137, 137, 137,
137, 141, 141, 141, 144, 144, 144, 144, 144, 145, 145, 156, 156, 156, 156, 156,
156, 156, 156, 156, 154, 154, 154, 154, 162, 175, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177, 177,
177, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 100, 100,
100, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 124, 124, 131, 131, 131, 131, 131, 137, 137, 137, 137,
141, 141, 141, 141, 149, 144, 144, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 156, 172, 172, 172, 172, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 177, 177, 177, 177, 177, 177, 177, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 100, 100, 100, 100, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 121, 124, 131, 131, 131, 131, 137, 137, 137, 137, 137,
141, 141, 141, 149, 149, 149, 152, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 156, 172, 172, 172, 172, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121,
121, 121, 121, 121, 121, 140, 140, 140, 140, 131, 137, 137, 137, 137, 137, 141,
141, 141, 149, 149, 149, 149, 152, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121, 121,
121, 121, 121, 121, 140, 140, 140, 140, 140, 140, 140, 137, 137, 137, 137, 141,
141, 141, 149, 149, 149, 151, 151, 152, 152, 152, 152, 156, 156, 156, 156, 156,
156, 156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 175, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121, 121,
121, 121, 121, 140, 140, 140, 140, 140, 140, 140, 140, 140, 137, 137, 141, 141,
141, 149, 149, 151, 151, 151, 151, 151, 152, 152, 159, 156, 156, 156, 156, 156,
156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 172, 172, 175, 175, 175,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121, 121,
121, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150,
149, 151, 151, 151, 151, 151, 151, 151, 159, 159, 159, 159, 156, 156, 156, 156,
156, 156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182,
175, 175, 175, 175, 175, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 184, 184, 184, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 121, 121,
140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150,
150, 151, 151, 151, 151, 151, 151, 159, 159, 159, 159, 159, 159, 156, 156, 156,
156, 156, 156, 172, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182,
182, 182, 182, 182, 182, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 184, 184, 184, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 140,
140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150,
150, 150, 151, 151, 151, 151, 159, 159, 159, 159, 159, 159, 159, 164, 164, 164,
168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182,
182, 182, 182, 182, 182, 182, 184, 184, 184, 184, 184, 184, 184, 184, 184, 184,
184, 200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 142,
142, 142, 140, 140, 140, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150, 150,
150, 150, 150, 151, 151, 151, 159, 159, 159, 159, 159, 164, 164, 164, 164, 168,
168, 168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182,
182, 182, 182, 182, 182, 182, 182, 184, 184, 184, 184, 184, 184, 184, 200, 200,
200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
 51,  51,  51,  51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 142,
142, 142, 142, 142, 142, 140, 140, 140, 140, 140, 140, 150, 150, 150, 150, 150,
150, 150, 150, 150, 161, 161, 161, 161, 161, 161, 161, 164, 164, 164, 167, 168,
168, 168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182, 182,
182, 182, 182, 182, 182, 182, 182, 182, 184, 184, 184, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242,
 51,  51,  51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133,
142, 142, 142, 142, 142, 142, 142, 142, 140, 140, 140, 150, 150, 150, 150, 150,
150, 150, 150, 150, 161, 161, 161, 161, 161, 161, 164, 164, 164, 164, 167, 168,
168, 168, 168, 168, 168, 172, 172, 172, 172, 172, 172, 172, 182, 182, 182, 182,
182, 182, 182, 182, 182, 182, 182, 182, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242,
 51,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133,
142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 150, 150, 150,
150, 150, 150, 150, 161, 161, 161, 161, 161, 161, 164, 164, 164, 167, 167, 168,
168, 168, 168, 168, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 182,
182, 182, 182, 182, 182, 182, 182, 182, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 150, 150, 150,
150, 150, 150, 157, 157, 161, 161, 161, 161, 164, 164, 164, 167, 167, 167, 168,
168, 168, 171, 171, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 182, 182, 182, 182, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 150, 150, 150,
157, 157, 157, 157, 157, 165, 161, 161, 161, 164, 164, 164, 167, 167, 167, 168,
171, 171, 171, 171, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 142, 142, 142, 142, 142, 142, 142, 142, 142, 142, 150, 150, 157, 157, 157,
157, 157, 157, 157, 165, 165, 165, 165, 169, 169, 169, 169, 167, 167, 167, 171,
171, 171, 171, 171, 171, 181, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118,
118, 118, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 142, 142, 142, 142, 142, 142, 142, 142, 142, 158, 157, 157, 157, 157, 157,
157, 157, 157, 157, 165, 165, 165, 165, 169, 169, 169, 169, 169, 169, 171, 171,
171, 171, 171, 171, 179, 179, 181, 181, 181, 181, 181, 181, 185, 185, 185, 185,
185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98, 118, 118, 118, 118, 118, 118, 118,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 142, 142, 142, 142, 142, 142, 142, 158, 158, 158, 157, 157, 157, 157,
157, 157, 157, 165, 165, 165, 165, 165, 169, 169, 169, 169, 169, 169, 174, 174,
174, 174, 174, 179, 179, 179, 179, 181, 181, 181, 181, 181, 189, 189, 185, 185,
185, 185, 185, 185, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98,  98,  98, 139, 139, 118, 118, 118, 133, 133,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 142, 142, 142, 142, 142, 158, 158, 158, 158, 158, 158, 157, 157, 157,
157, 157, 157, 165, 165, 165, 165, 165, 169, 169, 169, 169, 169, 169, 174, 174,
174, 174, 174, 179, 179, 179, 179, 179, 181, 181, 181, 189, 189, 189, 189, 189,
189, 189, 189, 189, 185, 185, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98,  98,  98, 139, 139, 139, 139, 139, 139, 139, 133, 133,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 142, 142, 142, 142, 158, 158, 158, 158, 158, 158, 158, 158, 157, 157,
157, 157, 157, 165, 165, 165, 165, 165, 165, 169, 169, 169, 169, 169, 176, 174,
174, 174, 179, 179, 179, 179, 179, 183, 183, 183, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 201, 201, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98,  98, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 133, 142, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 157,
157, 157, 165, 165, 165, 165, 165, 165, 165, 169, 169, 169, 169, 176, 176, 176,
176, 180, 180, 179, 179, 179, 183, 183, 183, 183, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 201, 201, 201, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98,  98,  98, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 133, 160, 160, 160, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
163, 157, 165, 165, 165, 165, 165, 165, 173, 173, 169, 169, 176, 176, 176, 176,
176, 180, 180, 180, 179, 183, 183, 183, 183, 183, 191, 189, 189, 189, 189, 189,
189, 189, 189, 189, 201, 201, 201, 201, 204, 204, 200, 200, 200, 200, 200, 200,
200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
 98,  98, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
133, 160, 160, 160, 160, 160, 160, 158, 158, 158, 158, 158, 158, 158, 163, 163,
163, 163, 165, 165, 165, 165, 165, 173, 173, 173, 173, 173, 176, 176, 176, 176,
180, 180, 180, 180, 180, 183, 183, 183, 183, 191, 191, 191, 189, 189, 189, 189,
189, 189, 189, 201, 201, 201, 201, 201, 204, 204, 204, 204, 200, 200, 200, 200,
200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98,  98,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133, 133,
160, 160, 160, 160, 160, 160, 160, 160, 158, 158, 158, 158, 158, 163, 163, 163,
163, 163, 163, 165, 165, 165, 173, 173, 173, 173, 173, 173, 176, 176, 176, 176,
180, 180, 180, 180, 180, 187, 187, 187, 187, 191, 191, 191, 191, 189, 189, 189,
189, 189, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 200,
200, 200, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98,  98,  98, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 133, 133, 133, 133, 133, 133, 133, 133, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 158, 158, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 176, 176, 176,
180, 180, 180, 180, 187, 187, 187, 187, 187, 191, 191, 191, 191, 193, 193, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 204,
204, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98,  98,  98, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 133, 133, 133, 133, 133, 133, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 173, 176, 176,
180, 180, 180, 180, 187, 187, 187, 187, 187, 191, 191, 193, 193, 193, 197, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 204,
204, 207, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
210, 210, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98,  98,  98, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 133, 133, 133, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 173, 176, 180,
180, 180, 180, 187, 187, 187, 187, 187, 187, 193, 193, 193, 193, 197, 197, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 204, 204, 207,
207, 207, 214, 214, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  98,  98, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 173, 173, 186, 186,
180, 190, 190, 190, 190, 190, 190, 190, 195, 195, 195, 195, 197, 197, 198, 198,
198, 198, 201, 201, 201, 201, 201, 201, 204, 204, 204, 204, 204, 207, 207, 207,
207, 207, 214, 214, 214, 214, 214, 210, 210, 210, 210, 210, 210, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  98,  98, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 163, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 173, 173, 186, 186, 186, 186,
186, 190, 190, 190, 190, 190, 190, 190, 190, 195, 195, 195, 197, 197, 198, 198,
198, 198, 198, 201, 201, 201, 201, 201, 204, 204, 204, 207, 207, 207, 207, 207,
207, 214, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 163, 163, 163,
163, 163, 163, 163, 173, 173, 173, 173, 173, 173, 186, 186, 186, 186, 186, 186,
186, 190, 190, 190, 190, 190, 190, 190, 190, 195, 195, 195, 197, 199, 199, 198,
198, 198, 202, 202, 201, 201, 201, 201, 204, 207, 207, 207, 207, 207, 207, 207,
207, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170,
163, 178, 178, 178, 178, 178, 173, 173, 186, 186, 186, 186, 186, 186, 186, 186,
186, 190, 190, 190, 190, 190, 190, 196, 196, 196, 195, 195, 199, 199, 199, 199,
199, 202, 202, 202, 202, 201, 206, 206, 207, 207, 207, 207, 207, 207, 207, 207,
214, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170,
178, 178, 178, 178, 178, 178, 178, 186, 186, 186, 186, 186, 186, 186, 186, 186,
186, 186, 190, 190, 190, 190, 196, 196, 196, 196, 196, 199, 199, 199, 199, 199,
202, 202, 202, 202, 202, 206, 206, 206, 206, 207, 207, 207, 207, 207, 207, 207,
214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170,
178, 178, 178, 178, 178, 178, 178, 186, 186, 186, 186, 186, 186, 186, 186, 186,
186, 186, 190, 190, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 199, 199,
202, 202, 202, 202, 202, 206, 206, 206, 206, 206, 207, 207, 207, 207, 207, 214,
214, 214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160,
160, 160, 160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170,
178, 178, 178, 178, 178, 178, 178, 178, 186, 186, 186, 186, 186, 186, 186, 186,
186, 186, 190, 196, 196, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 199,
202, 202, 202, 202, 206, 206, 206, 206, 206, 206, 206, 207, 207, 207, 207, 214,
214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160,
160, 160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178,
178, 178, 178, 178, 178, 178, 178, 178, 188, 186, 186, 186, 186, 186, 186, 186,
186, 186, 186, 196, 196, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 199,
202, 205, 205, 205, 208, 208, 206, 206, 206, 206, 206, 207, 207, 207, 214, 214,
214, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 235, 235, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 160, 160, 160,
160, 160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178,
178, 178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 186, 186, 186, 186, 186,
194, 194, 194, 196, 196, 196, 196, 196, 196, 196, 196, 196, 199, 199, 199, 205,
205, 205, 205, 205, 208, 208, 208, 208, 206, 211, 211, 211, 211, 211, 214, 214,
214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 160, 160,
160, 160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178,
178, 178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 186, 194, 194, 194,
194, 194, 194, 194, 196, 196, 196, 196, 196, 196, 196, 196, 199, 205, 205, 205,
205, 205, 205, 205, 205, 208, 208, 208, 211, 211, 211, 211, 211, 211, 214, 214,
214, 214, 214, 214, 214, 218, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
231, 231, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
160, 160, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 196, 196, 196, 196, 196, 196, 196, 209, 205, 205, 205,
205, 205, 205, 205, 205, 208, 208, 211, 211, 211, 211, 211, 211, 211, 216, 219,
219, 219, 219, 214, 218, 218, 218, 218, 218, 218, 218, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 194, 196, 196, 196, 196, 196, 209, 209, 209, 209, 205,
205, 205, 205, 205, 205, 205, 211, 211, 211, 211, 211, 211, 211, 216, 216, 219,
219, 219, 219, 219, 219, 218, 218, 218, 218, 218, 227, 225, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 194, 203, 203, 203, 203, 209, 209, 209, 209, 209, 209,
209, 205, 205, 205, 205, 212, 212, 212, 212, 212, 212, 212, 216, 216, 216, 219,
219, 219, 219, 219, 219, 219, 218, 227, 227, 227, 227, 227, 225, 225, 225, 225,
225, 225, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178,
178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 194, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209, 209,
209, 209, 205, 205, 205, 212, 212, 212, 212, 212, 215, 215, 216, 216, 216, 219,
219, 219, 219, 219, 219, 219, 227, 227, 227, 227, 227, 227, 227, 225, 225, 225,
225, 225, 231, 231, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178, 178,
178, 178, 178, 178, 178, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 194, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 212, 212, 212, 212, 212, 215, 215, 215, 216, 216, 216, 219,
219, 219, 219, 219, 219, 219, 227, 227, 227, 227, 227, 227, 227, 227, 225, 225,
225, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 170, 178, 178, 178,
178, 178, 178, 192, 192, 188, 188, 188, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 194, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 209, 212, 212, 212, 215, 215, 215, 215, 215, 216, 216, 216, 216,
219, 219, 219, 219, 219, 219, 227, 227, 227, 227, 227, 227, 229, 229, 229, 229,
235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 170, 178, 178, 178,
192, 192, 192, 192, 192, 192, 192, 192, 188, 188, 188, 188, 188, 194, 194, 194,
194, 194, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 212, 215, 215, 215, 215, 215, 217, 216, 216, 216, 220,
219, 219, 219, 219, 219, 226, 226, 227, 227, 227, 229, 229, 229, 229, 229, 229,
235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 235, 235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 170, 178, 178, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 188, 188, 194, 194, 194,
194, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 213, 215, 215, 215, 217, 217, 217, 217, 217, 220, 220,
220, 220, 219, 226, 226, 226, 226, 226, 229, 229, 229, 229, 229, 229, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 170, 170, 170, 170, 170, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 194, 194, 194,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 209, 213, 213, 213, 213, 217, 217, 217, 217, 217, 217, 217, 220, 220,
220, 220, 220, 226, 226, 226, 226, 226, 229, 229, 229, 229, 229, 229, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 170, 170, 170, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 194, 194,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209, 209,
209, 209, 213, 213, 213, 213, 213, 217, 217, 217, 217, 217, 217, 220, 220, 220,
220, 220, 220, 226, 226, 226, 226, 226, 232, 232, 229, 229, 229, 229, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 209,
213, 213, 213, 213, 213, 213, 213, 213, 217, 217, 221, 221, 221, 220, 220, 220,
220, 224, 224, 226, 226, 226, 226, 226, 232, 232, 232, 232, 232, 232, 229, 229,
229, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 209, 209, 213,
213, 213, 213, 213, 213, 213, 213, 213, 221, 221, 221, 221, 221, 221, 220, 220,
224, 224, 224, 224, 226, 226, 226, 232, 232, 232, 232, 232, 232, 232, 232, 232,
232, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 209, 213, 213, 213,
213, 213, 213, 213, 213, 213, 213, 213, 221, 221, 221, 221, 221, 221, 221, 224,
224, 224, 224, 224, 230, 230, 230, 232, 232, 232, 232, 232, 232, 232, 232, 232,
232, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213,
213, 213, 213, 213, 213, 213, 213, 213, 223, 221, 221, 221, 221, 221, 221, 224,
224, 224, 224, 230, 230, 230, 230, 232, 232, 232, 232, 232, 232, 232, 232, 232,
232, 232, 235, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213,
213, 213, 213, 213, 213, 213, 213, 223, 223, 223, 223, 221, 221, 221, 221, 224,
224, 224, 230, 230, 230, 230, 230, 233, 232, 232, 232, 232, 232, 232, 232, 232,
232, 232, 235, 235, 235, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213, 213,
213, 213, 213, 213, 213, 213, 223, 223, 223, 223, 223, 223, 223, 221, 221, 224,
224, 224, 230, 230, 230, 233, 233, 233, 233, 234, 232, 232, 232, 232, 232, 232,
237, 237, 239, 239, 235, 235, 235, 235, 235, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 213, 213, 213, 213,
213, 213, 213, 213, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223, 223, 224,
224, 230, 230, 233, 233, 233, 233, 233, 234, 234, 236, 236, 236, 236, 236, 237,
237, 237, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 213, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223, 223,
230, 233, 233, 233, 233, 233, 233, 234, 234, 236, 236, 236, 236, 236, 237, 237,
237, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223,
233, 233, 233, 233, 233, 233, 234, 234, 234, 236, 236, 236, 236, 237, 237, 237,
237, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223, 223,
233, 233, 233, 233, 233, 234, 234, 234, 236, 236, 236, 236, 237, 237, 237, 237,
239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 223, 223, 223, 223, 223, 223, 223,
233, 233, 233, 233, 234, 234, 234, 234, 236, 236, 236, 237, 237, 237, 237, 237,
239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 223, 223, 223,
233, 233, 233, 234, 234, 234, 234, 236, 236, 236, 237, 237, 237, 237, 237, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228,
233, 233, 234, 234, 234, 234, 234, 236, 236, 237, 237, 237, 237, 237, 237, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 234, 234, 234, 234, 234, 236, 236, 237, 237, 237, 237, 237, 237, 239, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242, 242,
242, 242, 242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
203, 203, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 234, 234, 234, 234, 234, 236, 237, 237, 237, 237, 237, 237, 237, 240, 239,
239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 239, 242, 242, 242, 242, 242,
242, 242, 242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 234, 234, 234, 236, 237, 237, 237, 237, 237, 237, 237, 240, 240, 240,
240, 239, 239, 239, 239, 239, 239, 239, 239, 241, 241, 242, 242, 242, 242, 242,
242, 242, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 234, 234, 234, 237, 237, 237, 237, 237, 237, 237, 240, 240, 240, 240,
240, 240, 240, 239, 239, 239, 241, 241, 241, 241, 241, 241, 245, 242, 242, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 238, 238, 238, 237, 237, 237, 237, 237, 237, 240, 240, 240, 240, 240,
240, 240, 240, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 203, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 237, 237, 237, 240, 240, 240, 240, 240, 240,
240, 240, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 240, 240, 240, 240, 240, 240,
240, 241, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
192, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 240, 240, 240, 240, 241,
241, 241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 240, 240, 241, 241,
241, 241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 240, 241, 241, 241,
241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 241, 241, 241,
241, 241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245,
245, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 252, 252, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 241,
241, 241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245,
245, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 252, 252, 252, 252, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243,
241, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245,
245, 248, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222,
222, 222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243,
243, 241, 241, 241, 241, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245,
248, 248, 248, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222,
222, 222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243,
243, 244, 244, 244, 245, 245, 245, 245, 245, 245, 245, 245, 245, 245, 248, 248,
248, 248, 248, 249, 249, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 251, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222,
222, 222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243,
244, 244, 244, 244, 244, 245, 245, 245, 245, 246, 246, 246, 246, 246, 248, 248,
248, 248, 248, 249, 249, 249, 249, 249, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 251, 251, 251, 251, 251, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222,
222, 222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 246, 246, 248, 248,
248, 248, 249, 249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 252, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222,
222, 222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 246, 248, 248, 248,
248, 249, 249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 252, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222,
222, 222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 248, 248, 248,
248, 249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222,
222, 222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 246, 248, 248, 248,
249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252,
252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222,
222, 222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 248, 248, 248, 249,
249, 249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252,
252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222,
222, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 248, 248, 248, 249,
249, 249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250,
250, 250, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252,
252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 246, 248, 248, 249, 249,
249, 249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250,
251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252,
252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 222, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 246, 248, 248, 249, 249, 249,
249, 249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251,
251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 222, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 248, 248, 249, 249, 249,
249, 249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251,
251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 246, 248, 249, 249, 249, 249,
249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251,
251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 222, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 248, 249, 249, 249, 249, 249,
249, 249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251,
251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83,  83, 139, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 222, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 248, 249, 249, 249, 249, 249,
249, 250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251,
251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
 83, 139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 246, 249, 249, 249, 249, 249, 249,
250, 250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251,
251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,
139, 139, 139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 246, 246, 249, 249, 249, 249, 249, 249, 250,
250, 250, 250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251,
252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139,
139, 139, 139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 246, 249, 249, 249, 249, 249, 250, 250,
250, 250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139,
139, 139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 249, 249, 250, 250, 250,
250, 250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139,
139, 139, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 249, 249, 250, 250, 250,
250, 250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 249, 250, 250, 250, 250,
250, 250, 250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 139, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 249, 250, 250, 250, 250, 250,
250, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 139, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 249, 250, 250, 250, 250, 250, 250,
251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252,
252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 139, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243,
243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 249, 250, 250, 250, 250, 250, 250, 251,
251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252,
252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83,  83, 139, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250, 250, 250, 251, 251,
251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252,
252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 249, 250, 250, 250, 250, 251, 251, 251, 251,
251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252,
252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250, 251, 251, 251, 251, 251,
251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 251, 251, 251, 251, 251, 251,
251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 250, 250, 251, 251, 251, 251, 251, 251, 251,
251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251,
251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83,  83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251,
251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
 83, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 243, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251,
251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251,
252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 192, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 228, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
192, 228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
228, 228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
228, 228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 251, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252,
252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 192,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252,
252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 228,
228, 228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 251, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252,
252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 192, 228,
228, 228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 251, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252,
252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 228, 228,
228, 228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 228, 228,
228, 228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 251, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 192, 228, 228,
228, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 228, 228, 228,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
251, 251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 192, 228, 228, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
243, 243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
251, 251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 228, 228, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
251, 252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 228, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 251,
252, 252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 192, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
243, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252,
252, 252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252,
252, 252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 192, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252,
252, 252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 192, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 243, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252, 252,
252, 252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166,
166, 166, 166, 166, 166, 166, 166, 166, 166, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 243, 243, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244,
244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 244, 252, 252, 252,
252, 252, 252, 252, 252, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253, 253,
253, 253, 253, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254,
254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 254, 255, 255, 255,
255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255
};


UInt8 hvqelut_2x2_1[] = {
  0,   0,   0,   0,   0,   1,   1,   1,   1,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,
  6,  19,  19,   6,  19,  19,  19,   6,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,   6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  88,  19,  19,  19,  19,  19,  19,  19,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  98,  88,  88,  88,  98, 126,  88,  88,  88,  88,
126, 126, 126, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   0,   0,   0,   1,   1,   1,   1,   1,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,   6,   6,
  6,  19,   6,  19,  19,   6,   6,  19,   6,  19,  19,  19,  19,  19,   6,  19,
 19,  19,  19,   6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 66,  19,  19,  88,  19,  88,  66,  19,  88,  88,  88,  88,  88,  88,  88,  19,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88, 126,  88, 126, 126, 126, 126, 126, 126,  88, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   0,   0,   1,   1,   1,   1,   1,   1,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,  19,   6,   6,  19,   6,  19,   6,   6,
  6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  88,  88,  19,
 66,  19,  19,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88, 126, 126, 126, 126, 126, 126, 126, 126,  88, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   0,   1,   1,   1,   1,   1,   1,   3,   3,   3,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,
  6,  19,   6,   6,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  66,  66,  19,  66,  19,
 19,  19,  19,  19,  19,  19,  88,  88,  88,  98,  19,  19,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88, 126,
 88,  88,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  0,   1,   1,   1,   1,   3,   3,   3,   3,   3,   3,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,
  6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,   6,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  66,  19,  19,  19,  19,  19,  66,  66,  19,  66,  19,
 19,  19,  19,  19,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88, 126,  88,  88, 126,
 88,  88,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
  2,   1,   1,   1,   3,   3,   3,   3,   3,   5,   5,   5,   5,   5,   8,   8,
  8,   8,   8,   8,  10,  10,  11,   6,   6,   6,   6,  19,   6,   6,   6,   6,
 28,   6,  19,  19,  19,  19,  19,  28,  19,  19,  19,  28,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  66,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  66,  66,  66,  66,  19,  66,  19,  88,  19,
 19,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158,
  2,   2,   2,   3,   3,   3,   3,   4,   5,   5,   5,   5,   5,   5,   8,   8,
  8,   8,  10,  10,  10,  18,  10,  14,  14,  14,  14,  19,  20,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  66,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,  19,
 19,  19,  19,  19,  19,  19,  66,  19,  66,  66,  88,  88,  66,  19,  88,  19,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  88,  88,  98, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158,
  2,   2,   2,   3,   3,   9,   4,   4,   9,   9,   9,  18,  18,  18,  18,  18,
 18,   9,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  18,
 19,  19,  18,  19,  18,  19,  18,  19,  18,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  63,  19,  19,  19,  88,  77,  77,  77,  77,  77,  77,  77,  77,  77,
 77,  98,  98,  77,  77,  88,  77,  77,  77,  77,  77,  88,  88,  77,  88,  98,
 77,  98,  98,  98,  98,  77,  88,  98,  98,  98,  98,  98,  98,  88,  88,  98,
 88,  98,  98,  88,  98,  88,  88,  98,  98,  98,  88,  98,  98,  88,  98,  98,
 98,  98,  88,  98,  98,  98,  98,  98,  98,  98,  88,  98,  88,  98,  98,  98,
 88,  98,  88,  98,  98,  98,  98,  98,  98,  98,  98, 126,  98, 126,  98,  98,
126, 126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
  2,   2,   2,   3,   3,   3,   5,  18,   5,   5,   5,   8,   8,   8,   8,  10,
 10,  11,  10,  10,  12,  13,  14,  14,  14,  14,  14,  20,  20,  20,  20,  20,
 28,  20,  19,  20,  19,  19,  19,  28,  19,  19,  19,  28,  19,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  66,  19,
 19,  19,  66,  66,  66,  19,  19,  19,  19,  66,  19,  19,  19,  66,  19,  66,
 62,  19,  19,  19,  66,  66,  66,  66,  66,  66,  66,  88,  66,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88, 126, 126, 126, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158,
  2,   2,   2,   2,   3,   5,   5,  18,   5,   8,   8,   8,   8,  10,  10,  10,
 11,  12,  12,  12,  12,  13,  14,  14,  14,  14,  14,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  19,  28,  19,  19,  19,  28,  28,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 28,  19,  19,  19,  19,  19,  19,  19,  28,  19,  19,  19,  28,  19,  28,  19,
 19,  19,  19,  28,  19,  19,  19,  38,  19,  19,  19,  19,  19,  19,  66,  19,
 66,  19,  66,  66,  66,  66,  62,  19,  19,  66,  66,  19,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  66,  66,  88,  88,  66,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88, 126, 126, 126, 126, 126,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
  2,   2,   2,   2,   3,   5,   5,   9,   7,   8,   7,  11,  11,  11,  11,  11,
 12,   7,  12,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  20,
 28,  28,  20,  20,  19,  20,  20,  28,  19,  28,  20,  28,  28,  28,  28,  19,
 28,  19,  28,  28,  19,  28,  19,  28,  19,  28,  19,  19,  28,  19,  28,  28,
 28,  19,  38,  19,  19,  28,  38,  19,  28,  38,  28,  38,  28,  38,  28,  19,
 38,  19,  38,  28,  38,  38,  38,  66,  19,  41,  66,  66,  66,  41,  66,  19,
 66,  66,  66,  66,  66,  66,  66,  62,  19,  66,  66,  62,  66,  66,  66,  66,
 66,  66,  62,  62,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  88,
 88,  98,  98,  66,  66,  66,  88,  88,  88,  88,  88,  66,  66,  88,  66,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88, 100,
 88,  98,  88,  88,  88,  88, 100,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88,  88, 100, 100, 126, 126, 100,  88, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 181,
  2,   2,   2,   2,   2,   5,   9,  18,   9,   9,  11,   9,  10,  10,  10,  10,
 11,  12,  13,  12,  14,  18,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  28,  19,  19,  19,
 19,  19,  19,  28,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  38,
 28,  19,  19,  19,  19,  38,  19,  19,  38,  19,  38,  19,  38,  19,  28,  19,
 41,  19,  19,  28,  41,  41,  41,  38,  19,  41,  41,  41,  41,  41,  66,  19,
 62,  62,  66,  66,  66,  62,  62,  62,  41,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  62,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,  88,  88,  88,
 88,  88,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
  2,   2,   2,   2,   2,   5,   9,  18,   8,   8,  11,  10,  10,  10,  11,  11,
 12,  12,  13,  12,  14,  18,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  28,  19,  19,  19,
 19,  19,  38,  28,  19,  19,  19,  38,  19,  19,  19,  19,  38,  19,  38,  38,
 28,  19,  19,  19,  19,  38,  38,  19,  38,  38,  38,  41,  38,  41,  28,  19,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  41,  41,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88,  98,  88,  98, 100,  88,  88,  88,  88,  88,  88,
 88,  88,  88,  88,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 181,
  2,   2,   2,   2,   2,   5,   9,  18,   8,  10,  11,  10,  10,  11,  11,  12,
 12,  12,  13,  12,  14,  15,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  28,  38,  38,  27,
 19,  27,  38,  28,  19,  38,  19,  38,  19,  38,  19,  19,  38,  19,  38,  38,
 28,  19,  38,  19,  19,  38,  38,  19,  38,  38,  38,  41,  38,  41,  28,  19,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  41,  41,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 100,  88,  88,
 88,  88,  88,  88,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  10,  11,  10,  11,  11,  12,  13,
 12,  14,  13,  14,  14,  15,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  27,  38,  27,  38,  38,  41,  38,  27,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  28,  41,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  66,  41,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 100,  88, 100,
 88, 126,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  10,  11,  10,  11,  11,  13,  13,
 12,  14,  15,  14,  14,  18,  14,  20,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  20,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  27,  38,  27,  38,  38,  41,  38,  27,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  28,  41,
 41,  41,  41,  28,  41,  41,  41,  66,  41,  41,  41,  62,  62,  41,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 126,  88, 100,
 88, 126,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  11,  11,  13,  11,  13,  12,  13,
 12,  14,  15,  14,  14,  15,  14,  14,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  20,  27,  28,  27,  29,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  27,  38,  27,  38,  38,  41,  38,  27,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  28,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  41,  41,  66,  62,  62,  66,  41,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  66,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  98,  88,  88,  88,  88, 100,  88,  98, 100,  88,  88,  88, 100,  88, 100,
 88, 126,  88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   8,   9,  18,  11,  11,   7,  13,  12,  12,  12,  12,
 12,  17,  14,  14,  17,  15,  17,  14,  14,  20,  14,  20,  20,  20,  20,  20,
 28,  28,  20,  20,  27,  20,  29,  28,  27,  29,  29,  28,  28,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  38,  38,  41,  38,  38,  41,  38,  41,  38,  38,
 28,  38,  38,  41,  38,  38,  38,  41,  38,  38,  38,  38,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  66,  66,  66,  62,  66,  62,
 66,  66,  66,  66,  66,  66,  66,  62,  62,  66,  66,  62,  66,  66,  62,  66,
 66,  62,  62,  62,  66,  66,  66,  88,  66,  66,  88,  88,  66,  88,  88,  88,
 88,  98,  98,  88,  88,  66,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88, 100,
 88,  98,  88,  88,  88, 100, 100, 100,  98, 100,  88, 100,  88, 100, 100, 100,
 88, 100,  88, 100, 100, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  13,  11,  13,  13,  13,  13,  13,
 15,  15,  15,  15,  15,  18,  15,  20,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  27,  20,  27,  29,  27,  29,  27,  29,  27,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  27,  38,  41,  41,  38,  27,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  38,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  62,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88,  88,  88, 100,  98,  88,  98, 126,  88,  88,  88, 126, 126, 126,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,   9,  13,  12,  13,  13,  13,  13,  13,
 15,  14,  15,  15,  15,  24,  14,  20,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  20,  20,  20,  27,  29,  27,  28,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  27,  38,  41,  41,  38,  27,  38,  38,
 28,  41,  41,  41,  41,  38,  41,  41,  38,  41,  38,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88,  88,  88, 100, 100, 100,  98, 126,  88, 100,  88, 126, 100, 126,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  11,  13,  12,  13,  13,  13,  13,  15,
 15,  17,  15,  15,  17,  24,  17,  21,  20,  20,  20,  20,  20,  20,  20,  20,
 28,  29,  29,  29,  27,  29,  27,  28,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  41,  38,  38,  41,  38,  41,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  41,  41,  66,  41,  62,  62,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88,  88,  88, 100, 100, 100,  98, 100,  88, 100,  88, 126, 100, 100,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,   4,   9,  16,   9,  16,  16,  16,  16,  16,
 16,  16,  24,  16,  16,  18,  16,  24,  24,  24,  24,  24,  24,  24,  24,  24,
 29,  29,  27,  24,  18,  27,  27,  29,  27,  27,  27,  29,  29,  27,  27,  27,
 27,  27,  27,  28,  27,  41,  27,  41,  27,  41,  41,  27,  41,  35,  41,  41,
 38,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  63,
 41,  41,  41,  66,  41,  41,  41,  62,  63,  62,  62,  62,  62,  63,  62,  63,
 62,  62,  66,  62,  62,  62,  62,  77,  77,  62,  62,  77,  77,  62,  77,  62,
 77,  77,  77,  77,  77,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98,  98,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  98,
 88,  98,  88, 126, 126, 126,  98, 126,  98,  98,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  13,  17,  13,  13,  13,  17,  15,
 17,  17,  15,  17,  17,  24,  17,  21,  22,  22,  21,  22,  22,  22,  22,  29,
 28,  29,  29,  29,  27,  29,  29,  28,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 28,  41,  38,  41,  41,  38,  38,  41,  38,  41,  38,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  41,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100,  88, 100, 100, 100,  98, 100,  88, 100,  88, 126, 100, 100,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  13,  17,  16,  16,  16,  15,  16,
 15,  17,  16,  21,  21,  24,  21,  21,  22,  22,  22,  22,  22,  22,  22,  29,
 28,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  38,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 100,  88, 126, 100, 126,
 88, 126,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  21,  22,  22,  21,  24,  22,  26,  25,  29,
 29,  29,  29,  29,  27,  29,  27,  29,  27,  29,  29,  28,  38,  38,  38,  27,
 38,  27,  38,  28,  41,  38,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 41,  41,  41,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  62,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  21,  22,  22,  22,  25,  22,  26,  26,  26,
 32,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  41,
 38,  27,  38,  28,  41,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 41,  41,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 100,  88, 126, 126, 126,
 88, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,   9,  18,  13,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  21,  21,  24,  21,  22,  22,  22,  22,  25,  22,  26,  26,  26,
 32,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  41,
 38,  27,  38,  28,  41,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 62,  41,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  66,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 100,  88, 126, 126, 126,
 88, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  16,  16,  16,  16,  24,  16,  25,  24,  25,  25,  24,  25,  25,  25,  25,
 29,  29,  24,  29,  35,  29,  37,  29,  27,  29,  37,  38,  29,  29,  38,  27,
 41,  27,  38,  28,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 38,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  66,  63,
 62,  41,  62,  66,  62,  62,  62,  62,  63,  62,  62,  62,  62,  62,  66,  63,
 62,  62,  66,  62,  66,  62,  62,  77,  77,  66,  62,  77,  62,  66,  62,  88,
 62,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,  88,  88,  98,
 88,  98,  88, 126, 100, 126, 126, 126,  98, 126,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,   9,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  22,  25,  22,  22,  24,  25,  26,  26,  26,
 32,  29,  29,  29,  27,  29,  29,  29,  27,  29,  29,  28,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  38,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  38,  41,  66,  41,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  62,  62,  66,  62,  88,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98,  88,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88,  88,  88,  88, 100, 100,  88, 100,  98,
 88,  98,  88, 100, 100, 100, 126, 100,  98, 126,  88, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  21,  21,  24,  21,  22,  25,  25,  25,  25,  25,  26,  26,  30,
 32,  30,  30,  30,  37,  29,  29,  32,  37,  29,  29,  28,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  38,  41,  38,  41,  41,  41,  41,  41,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  41,  41,  66,  41,  66,  41,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  62,  66,  62,  62,  62,  66,  62,  88,
 62,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  88,  98,  88,  88,  88,  88,  98, 100,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88, 100,  88,  88, 100, 100,  88, 100,  98,
100,  98,  88, 100, 100, 100, 126, 100,  98, 126, 100, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  16,  21,  24,  21,  25,  25,  25,  25,  25,  25,  26,  25,  30,
 32,  30,  30,  30,  37,  29,  37,  29,  37,  29,  29,  28,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  41,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  41,  41,  41,  38,  41,  41,  41,  62,  41,  66,  41,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  88,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98, 100,  98,  88,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88,  88, 100,  88,  88, 100, 100,  88, 100,  98,
100,  98,  88, 100, 100, 100, 126, 100,  98, 126, 100, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  16,  25,  21,  24,  25,  25,  25,  25,  25,  25,  25,  30,  30,  30,
 32,  30,  34,  34,  37,  34,  34,  32,  37,  34,  36,  42,  38,  38,  38,  41,
 38,  41,  38,  28,  41,  41,  41,  38,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  38,  41,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  62,  62,  66,  62,  88,
 62,  62,  77,  77,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88, 100, 100,  88,  88, 100, 100,  88, 100,  98,
100,  98,  88, 100, 100, 100, 126, 100,  98, 126, 100, 126,  88, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  17,  17,  18,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  33,  17,  17,  32,  25,  32,  32,  32,  32,  32,  31,  32,  32,  32,  32,
 33,  32,  32,  32,  34,  32,  36,  33,  36,  32,  32,  33,  42,  42,  42,  41,
 42,  41,  42,  48,  38,  38,  41,  38,  41,  38,  38,  41,  38,  41,  38,  38,
 42,  41,  38,  41,  41,  38,  38,  41,  66,  62,  66,  62,  66,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  66,  66,  62,  66,  62,
 66,  66,  66,  66,  66,  66,  66,  62,  62,  66,  66,  62,  66,  66,  66,  66,
 66,  62,  71,  62,  66,  88,  66,  88,  88,  66,  88,  88,  88,  88,  88,  88,
 88,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  66,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100, 100, 100,  88,  88, 100,
 88, 100, 100,  88, 100,  88, 125, 100, 100, 100,  88, 100, 100, 100, 100, 100,
100,  98,  88, 100, 100, 100, 100, 100, 126, 100, 100, 100, 100, 100, 100, 100,
125, 100, 100, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  17,  17,  16,  17,  17,  17,  17,
 17,  17,  22,  22,  17,  24,  32,  31,  31,  31,  30,  31,  30,  32,  30,  32,
 32,  32,  34,  32,  37,  36,  34,  32,  36,  36,  36,  33,  42,  38,  38,  41,
 38,  41,  38,  28,  38,  38,  41,  38,  41,  38,  41,  41,  38,  41,  38,  38,
 38,  41,  41,  41,  41,  38,  41,  41,  66,  62,  62,  62,  66,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 88,  62,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88, 100,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 100,
100,  98,  88, 100, 100, 100, 126, 100, 126, 126, 100, 100, 100, 126, 100, 126,
100, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  21,  16,  16,  25,  24,  25,  25,  25,  25,  25,  24,  25,  31,  31,  31,
 32,  34,  37,  34,  37,  34,  37,  36,  37,  36,  40,  42,  39,  40,  40,  37,
 40,  37,  38,  28,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 38,  41,  41,  41,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  66,  63,
 62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  62,  62,  62,  62,  66,  77,
 62,  62,  66,  66,  66,  62,  62,  77,  77,  66,  62,  77,  62,  66,  62,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  88,  98,  98,  88,  88,  88,  88,  98,  98,  98, 100,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88, 100, 100, 100,  88, 100, 126,  88, 100,  98,
100,  98,  88, 126, 100, 126, 126, 126,  98, 126, 100, 126, 100, 126, 126, 126,
 88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  25,  25,  25,  24,  25,  25,  25,  31,  31,  31,  31,  31,  31,  31,
 32,  34,  34,  34,  37,  34,  37,  32,  37,  36,  36,  42,  39,  39,  39,  40,
 40,  37,  38,  28,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  38,
 38,  41,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  88,
 88,  62,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98,  88, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  16,  24,  24,  24,  35,  25,  24,  24,  24,  24,  24,  24,  37,  37,  37,
 34,  34,  37,  37,  35,  37,  37,  39,  35,  37,  37,  39,  40,  37,  37,  35,
 37,  35,  40,  42,  37,  41,  37,  41,  35,  41,  41,  41,  41,  63,  41,  41,
 45,  41,  41,  63,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  62,  63,
 62,  63,  62,  66,  62,  62,  62,  62,  63,  62,  62,  62,  62,  77,  69,  63,
 69,  69,  66,  69,  69,  69,  77,  77,  77,  69,  69,  77,  77,  69,  77,  69,
 77,  77,  77,  77,  88,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98,  98,  88,  88,  88,
 88,  88,  98,  88,  88,  88,  88, 100, 100,  88,  88, 126, 126,  88, 126,  98,
126,  98,  88, 126, 126, 126, 126, 126,  98, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 16,  17,  25,  25,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 32,  32,  34,  34,  37,  36,  40,  42,  37,  36,  40,  42,  39,  39,  39,  40,
 40,  40,  44,  28,  41,  45,  41,  45,  41,  41,  41,  41,  41,  41,  41,  41,
 42,  41,  41,  41,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  66,  66,  66,  62,  62,  62,  77,  66,  62,  77,  62,  66,  62,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98,  88, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  25,  24,  25,  25,  24,  25,  31,  24,  31,  31,  24,  31,  31,  31,  31,
 36,  34,  37,  34,  35,  34,  37,  39,  37,  40,  40,  42,  39,  40,  40,  37,
 40,  37,  40,  42,  40,  40,  41,  45,  41,  41,  41,  41,  41,  63,  41,  41,
 45,  41,  41,  63,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  66,  63,
 62,  62,  62,  66,  62,  62,  62,  62,  63,  62,  62,  62,  62,  62,  66,  77,
 69,  62,  66,  69,  66,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 126, 100, 100,  98,
100,  98,  88, 126, 126, 126, 126, 126,  98, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  17,  16,  18,  17,  17,  17,  17,  17,  17,  17,  17,
 17,  32,  31,  32,  32,  31,  32,  32,  31,  32,  32,  31,  32,  32,  32,  32,
 33,  32,  36,  32,  40,  32,  36,  42,  40,  42,  42,  33,  42,  42,  42,  40,
 42,  40,  42,  48,  44,  42,  44,  42,  41,  44,  44,  41,  42,  41,  42,  42,
 60,  41,  44,  41,  41,  42,  62,  62,  66,  62,  62,  62,  66,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  66,  66,  62,  62,  66,  62,
 66,  62,  66,  66,  66,  66,  62,  62,  62,  66,  66,  62,  62,  66,  62,  66,
 88,  88,  77,  62,  88,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88,  88,
100,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88, 100,  98, 100, 100, 100,  88,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100,  88, 100, 100, 100, 100, 100,
100,  98,  88, 100, 100, 100, 100, 100, 126, 126, 100, 100, 100, 126, 100, 126,
125, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  16,  16,
 16,  25,  24,  25,  25,  24,  31,  31,  24,  31,  31,  37,  31,  31,  31,  31,
 39,  39,  37,  37,  35,  37,  37,  39,  37,  37,  37,  42,  39,  40,  40,  37,
 40,  35,  40,  42,  40,  40,  41,  45,  37,  45,  41,  41,  41,  63,  41,  45,
 45,  41,  41,  63,  41,  41,  41,  41,  62,  62,  62,  62,  62,  62,  62,  63,
 62,  62,  62,  66,  62,  62,  62,  62,  63,  62,  62,  69,  62,  62,  69,  77,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88,  98,  98,  98,  88,  88,  88,  88,  98,  98,  98, 100,  88,  88,  88,
 88,  88,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 126, 100, 126,  98,
126,  98,  88, 126, 126, 126, 126, 126,  98, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 25,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 32,  36,  31,  36,  37,  39,  40,  42,  40,  39,  40,  42,  42,  39,  44,  40,
 44,  40,  44,  42,  45,  45,  41,  45,  41,  45,  45,  41,  45,  41,  45,  45,
 42,  41,  41,  41,  41,  45,  62,  41,  62,  62,  62,  62,  62,  62,  66,  62,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  66,  66,  66,  69,  69,  77,  77,  66,  69,  77,  69,  66,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88,  88,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100,  88,  88, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98,  88, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  16,  16,
 31,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 42,  39,  40,  39,  37,  39,  40,  42,  37,  39,  40,  42,  39,  40,  45,  40,
 45,  40,  45,  42,  45,  45,  40,  45,  40,  45,  45,  41,  45,  63,  45,  45,
 56,  58,  49,  63,  58,  56,  62,  58,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  62,  71,  62,  62,  62,  62,  62,  66,  77,
 69,  69,  66,  69,  66,  69,  69,  77,  77,  66,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88,  88, 100, 100,  98,  88,  88,  88, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100,  88, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98,  88, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  17,  17,  16,  17,  17,  33,  17,  17,  32,  32,  32,
 32,  33,  32,  32,  32,  31,  33,  32,  32,  32,  32,  31,  32,  32,  32,  32,
 33,  33,  32,  32,  40,  32,  36,  33,  44,  42,  42,  33,  42,  42,  42,  44,
 42,  44,  42,  48,  42,  42,  44,  42,  44,  42,  44,  44,  42,  41,  42,  60,
 60,  50,  64,  41,  64,  60,  64,  62,  60,  64,  66,  62,  66,  62,  66,  62,
 66,  62,  62,  66,  66,  62,  66,  66,  62,  62,  66,  66,  66,  62,  66,  71,
 66,  66,  66,  66,  66,  66,  66,  62,  62,  66,  66,  62,  66,  66,  66,  66,
 88,  88,  71,  88,  66,  88,  66,  88,  88,  88,  88,  88,  88,  88,  88, 100,
100,  98, 100,  88,  88,  88,  88,  88,  88,  88, 100,  66,  88,  88,  88, 100,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100, 100, 100,  88,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100, 125, 100, 100, 100, 100, 100,
100, 126, 125, 100, 100, 100, 100, 100, 126, 100, 100, 100, 125, 126, 100, 100,
125, 126, 100, 126, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  31,  31,  31,  31,
 31,  32,  31,  31,  31,  31,  32,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 32,  32,  39,  39,  40,  39,  40,  42,  40,  39,  44,  42,  42,  44,  44,  40,
 44,  40,  44,  60,  44,  44,  45,  44,  40,  45,  45,  49,  45,  58,  50,  56,
 64,  50,  50,  58,  50,  64,  56,  50,  64,  62,  62,  62,  66,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  62,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  66,  66,  66,  69,  69,  62,  71,  66,  69,  71,  69,  66,  69,  88,
 88,  88,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
100,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100,  88, 100, 100, 100, 100, 126,
100,  98, 100, 100, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  16,  31,  31,
 31,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  31,
 42,  39,  39,  39,  37,  39,  40,  42,  40,  39,  40,  42,  42,  44,  44,  40,
 44,  40,  44,  42,  45,  45,  45,  45,  40,  45,  45,  49,  45,  54,  49,  56,
 64,  50,  50,  58,  50,  56,  50,  58,  64,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  71,  62,  62,  62,  62,  62,  66,  71,
 69,  69,  66,  66,  66,  69,  69,  77,  77,  66,  69,  77,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98,  88,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  16,  31,  31,  31,
 31,  31,  31,  31,  31,  24,  31,  31,  31,  31,  31,  31,  31,  31,  31,  39,
 42,  42,  39,  39,  37,  39,  40,  42,  40,  39,  44,  42,  42,  44,  44,  40,
 45,  40,  45,  42,  45,  45,  49,  45,  49,  49,  49,  49,  49,  54,  50,  56,
 64,  50,  50,  58,  58,  56,  56,  58,  64,  62,  62,  62,  62,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  71,  62,  62,  69,  69,  62,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  77,  66,  69,  77,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,
 77,  98,  98,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  16,  31,  43,
 43,  31,  43,  43,  43,  35,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 39,  43,  43,  43,  35,  43,  43,  39,  43,  43,  40,  42,  45,  45,  45,  54,
 45,  54,  45,  42,  45,  45,  54,  45,  54,  49,  54,  54,  49,  63,  49,  49,
 56,  58,  58,  63,  58,  58,  58,  58,  56,  58,  58,  58,  62,  58,  69,  63,
 62,  62,  62,  66,  69,  69,  69,  69,  63,  69,  69,  69,  69,  69,  69,  77,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88, 100,  98,  98,  98,  88,  88, 100, 100,  98,  98,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100,  88, 100, 100, 100,  88, 126, 126, 100, 126, 126,
126,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  17,  16,  31,  31,  31,  31,
 31,  31,  31,  31,  31,  43,  31,  31,  31,  31,  31,  43,  31,  31,  31,  39,
 42,  39,  40,  39,  37,  39,  40,  42,  40,  44,  44,  42,  44,  44,  45,  40,
 45,  40,  45,  42,  45,  45,  49,  49,  54,  49,  49,  58,  49,  54,  50,  56,
 64,  58,  50,  58,  58,  56,  56,  58,  64,  62,  62,  62,  64,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  69,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  16,  16,  16,  43,  43,  43,
 43,  43,  43,  43,  43,  35,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  35,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  54,
 54,  54,  45,  42,  54,  54,  54,  54,  54,  54,  54,  54,  54,  57,  58,  58,
 56,  54,  58,  63,  54,  58,  58,  54,  58,  58,  58,  58,  69,  58,  69,  63,
 69,  63,  69,  66,  69,  69,  69,  69,  63,  69,  69,  69,  69,  77,  69,  77,
 69,  69,  66,  69,  69,  69,  77,  77,  77,  69,  69,  77,  77,  69,  77,  69,
 77,  77,  77,  77,  88,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  98,
 88, 100,  98,  98,  98,  88,  88, 100, 100,  98,  98,  98, 100,  88,  88, 100,
 88, 100,  98,  88, 100, 100,  88, 126, 126, 126,  88, 126, 126, 126, 126,  98,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  32,  31,  31,  31,  31,  31,
 31,  31,  31,  31,  31,  43,  31,  31,  31,  31,  31,  31,  31,  31,  31,  39,
 42,  42,  39,  39,  40,  39,  40,  42,  40,  44,  44,  42,  42,  44,  44,  45,
 44,  40,  44,  60,  49,  49,  49,  49,  49,  49,  50,  50,  50,  54,  56,  56,
 64,  50,  50,  58,  50,  56,  56,  58,  64,  56,  64,  62,  64,  62,  66,  71,
 62,  62,  62,  66,  62,  62,  62,  66,  71,  62,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  66,  66,  69,  69,  71,  71,  66,  69,  71,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,
100,  98,  98,  88,  88,  88, 100,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100, 100,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 100, 126, 126, 126, 126, 126, 100, 126, 100, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  33,  33,  16,  33,  33,  33,  33,  33,  33,  33,  33,
 33,  33,  33,  33,  33,  31,  33,  33,  33,  33,  33,  32,  33,  33,  33,  33,
 33,  33,  33,  33,  47,  33,  42,  48,  47,  33,  42,  48,  60,  60,  60,  42,
 60,  52,  60,  48,  60,  60,  52,  60,  52,  60,  60,  52,  60,  52,  60,  60,
 60,  60,  60,  52,  60,  60,  60,  60,  60,  60,  60,  60,  60,  60,  60,  62,
 60,  64,  60,  81,  60,  60,  60,  75,  62,  66,  66,  66,  66,  66,  66,  71,
 66,  66,  81,  66,  66,  66,  66,  62,  71,  66,  66,  62,  66,  66,  66,  66,
 66,  66,  71,  88,  66,  66,  66,  88,  88,  66,  88,  88,  88, 100,  88, 100,
100,  98, 100,  88,  88, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113, 100,
100, 100, 100, 100,  98, 100, 113, 100, 100, 100, 100, 100, 100, 113, 113, 100,
113, 100, 100, 113, 100, 113, 125, 100, 100, 100, 125, 100, 100, 113, 100, 100,
100, 100, 125, 100, 100, 100, 100, 100, 100, 100, 125, 100, 125, 100, 100, 100,
125, 100, 125, 100, 125, 100, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
126, 158, 158, 181, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  16,  31,  31,  31,  31,  31,  31,
 31,  31,  43,  43,  31,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 42,  47,  43,  43,  43,  43,  43,  42,  43,  44,  45,  42,  45,  45,  45,  49,
 49,  54,  49,  42,  49,  49,  49,  49,  54,  49,  49,  58,  50,  54,  50,  56,
 56,  58,  58,  54,  58,  56,  58,  58,  56,  58,  56,  58,  64,  58,  64,  71,
 62,  62,  62,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,
 98,  98,  98,  88,  88,  88, 100,  88, 100,  88, 100,  88,  88,  88,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  31,  32,  31,  31,  31,  31,  31,
 31,  31,  43,  31,  31,  43,  31,  43,  43,  43,  43,  43,  43,  43,  43,  47,
 42,  47,  43,  47,  43,  47,  43,  42,  43,  47,  44,  42,  44,  45,  49,  49,
 49,  54,  49,  60,  49,  49,  49,  49,  54,  50,  50,  58,  50,  54,  56,  56,
 64,  58,  56,  58,  58,  56,  56,  58,  64,  58,  56,  58,  64,  58,  64,  71,
 62,  62,  62,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  69,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,
 98,  98,  98,  88,  88,  88, 100,  88, 100,  88, 100,  88,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 100, 100,  88, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  16,  18,  16,  43,  31,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  43,  43,  43,  43,  43,  43,  47,  43,  43,  43,  42,  45,  49,  49,  54,
 49,  54,  49,  42,  55,  49,  54,  49,  54,  55,  54,  54,  50,  54,  58,  56,
 56,  58,  58,  54,  58,  56,  58,  58,  56,  58,  58,  58,  69,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  77,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88, 100,  88, 100,  88, 100,  88,  88, 100,  88,  98,
100, 100, 100,  98,  98, 100,  88, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 126, 100,  88, 126, 126, 100, 126, 126,
126,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  31,  32,  31,  31,  31,  31,  31,
 31,  31,  43,  31,  31,  43,  31,  43,  43,  43,  43,  43,  43,  47,  47,  47,
 42,  47,  47,  47,  43,  47,  47,  42,  47,  47,  47,  42,  47,  47,  49,  49,
 49,  49,  49,  60,  49,  49,  50,  50,  58,  50,  50,  58,  50,  54,  56,  56,
 64,  50,  56,  58,  58,  56,  56,  58,  64,  56,  64,  65,  64,  58,  64,  71,
 62,  62,  62,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  69,  69,  71,  69,  88,  69,  88,
 88,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
 98,  98,  98,  88,  88,  88, 100,  88, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100,  88, 100,
 88, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  16,  16,  18,  16,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  54,
 54,  54,  55,  56,  54,  54,  54,  54,  54,  54,  54,  54,  54,  57,  58,  58,
 56,  54,  58,  54,  54,  58,  58,  54,  58,  58,  58,  58,  69,  58,  69,  63,
 69,  63,  69,  66,  69,  69,  69,  69,  63,  69,  69,  69,  69,  77,  69,  76,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  77,  69,  77,  69,
 77,  77,  77,  77,  88,  77,  88,  88,  88,  88,  88,  77,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88, 100,  88,  88,  88, 100,  88,  88,  88,  88,  98,
100, 100,  98,  98,  98, 100,  88, 100, 100,  98,  98,  98, 100, 100,  88, 100,
 88, 100,  98,  88, 100, 100, 125, 126, 126, 126,  88, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  46,  32,  43,  31,  31,  43,  43,
 43,  31,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  47,
 42,  47,  43,  47,  43,  47,  43,  47,  43,  47,  47,  42,  47,  47,  49,  49,
 49,  54,  49,  60,  49,  49,  50,  50,  54,  50,  50,  58,  50,  54,  56,  56,
 64,  58,  56,  58,  58,  56,  56,  58,  64,  65,  64,  65,  64,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  71,  71,  69,  69,  77,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  46,  46,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  47,  43,  43,  43,  43,  43,  47,  43,  47,  47,  42,  47,  49,  49,  54,
 49,  54,  49,  60,  55,  49,  55,  50,  54,  50,  55,  54,  50,  54,  56,  56,
 64,  58,  58,  54,  58,  56,  58,  58,  56,  58,  65,  58,  64,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  88,  69,  88,
 69,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88,  77,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
 88, 100,  98, 100, 100, 100, 125, 100, 100, 100, 100, 126, 126, 100, 126, 126,
126,  98, 100, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  46,  46,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  47,  43,  43,  43,  47,  49,  55,  55,  54,
 55,  54,  55,  64,  55,  55,  54,  55,  54,  55,  54,  54,  55,  57,  55,  56,
 56,  58,  58,  54,  58,  65,  58,  58,  56,  58,  58,  58,  65,  58,  64,  71,
 69,  71,  69,  66,  69,  69,  69,  69,  71,  69,  69,  69,  69,  71,  69,  76,
 69,  69,  66,  69,  69,  69,  69,  77,  77,  69,  69,  77,  69,  69,  77,  69,
 77,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88,  77,  88,  77,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100, 100,  98,  98, 100, 100, 100, 100,  98,  98,  98, 100, 100, 100, 100,
 88, 100,  98, 100, 100, 100, 125, 126, 126, 126, 100, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126,
158, 126, 126, 126, 158, 158, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  43,  43,
 43,  31,  43,  43,  43,  43,  47,  43,  43,  43,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  42,  47,  47,  47,  55,
 49,  55,  52,  60,  50,  50,  55,  52,  55,  50,  50,  58,  56,  54,  56,  56,
 64,  65,  56,  58,  65,  64,  56,  58,  64,  65,  64,  65,  64,  67,  64,  71,
 69,  71,  69,  75,  69,  69,  69,  69,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  69,  69,  71,  69,  88,  69,  88,
 69,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
100,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
  2,   2,   2,   2,   2,  46,  46,  18,  46,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  51,  43,  51,  51,  51,  43,  51,  51,  51,  43,  51,  51,  51,  51,
 51,  51,  51,  56,  51,  51,  51,  51,  57,  51,  51,  51,  51,  57,  54,  54,
 55,  54,  54,  57,  54,  54,  54,  54,  58,  54,  54,  54,  58,  54,  69,  76,
 58,  63,  63,  69,  63,  76,  69,  69,  76,  77,  69,  69,  77,  76,  69,  76,
 77,  77,  69,  69,  69,  77,  77,  76,  76,  69,  77,  76,  77,  69,  77,  77,
 77,  77,  76,  77,  77,  77,  88,  77,  77,  88,  77,  77,  88,  77,  77,  77,
 98,  98,  98,  88,  88,  88,  77,  88, 100,  88,  98,  88,  88, 100,  88,  98,
100,  98,  98,  98,  98, 100,  88, 100, 100,  98,  98,  98, 126, 100,  88, 126,
 88, 126,  98, 100, 126, 126, 125, 126, 126, 126,  88, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181, 181, 181, 181,
 23,   2,   2,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  47,  43,  43,  47,  43,  47,  47,  47,  47,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  55,
 52,  55,  52,  60,  52,  52,  55,  52,  55,  52,  50,  67,  52,  54,  56,  64,
 64,  65,  65,  58,  65,  64,  65,  67,  64,  65,  64,  65,  64,  65,  64,  71,
 73,  71,  73,  75,  73,  69,  69,  64,  71,  69,  69,  69,  69,  69,  69,  71,
 69,  69,  66,  69,  66,  69,  69,  71,  71,  92,  69,  71,  69,  88,  69,  88,
 92,  69,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100,
100,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
 23,   2,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  47,
 52,  55,  52,  60,  52,  52,  52,  52,  55,  52,  52,  67,  52,  54,  64,  64,
 64,  65,  56,  67,  65,  64,  64,  65,  64,  64,  64,  64,  64,  65,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  64,  71,  69,  69,  69,  69,  69,  66,  71,
 69,  69,  75,  87,  66,  69,  69,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  71,  71,  88,  88,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
100,  98,  98,  88, 100, 113, 100, 100, 100, 100, 100, 125,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100, 100, 100, 100, 113, 100,
113, 100, 100, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,   2,   2,  46,  46,  46,  46,  46,  46,  33,  46,  46,  46,  46,  46,
 46,  33,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  60,  61,  61,  61,  47,
 52,  47,  61,  48,  52,  52,  52,  52,  52,  52,  52,  52,  64,  67,  64,  60,
 60,  64,  64,  67,  64,  60,  64,  64,  60,  64,  70,  64,  60,  64,  75,  71,
 64,  73,  64,  75,  64,  64,  70,  75,  71,  87,  70,  70,  87,  87,  75,  71,
 87,  87,  75,  75,  75,  92,  92,  71,  71,  75,  92,  71,  92,  66,  92,  92,
 92,  92,  71,  92,  92,  88, 113,  88,  88, 113,  88, 100,  88, 100, 100, 100,
100,  98, 100, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113, 100,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 100, 113, 100, 113, 125, 100, 100, 100, 125, 100, 100, 100, 100, 126,
100, 126, 125, 100, 100, 100, 126, 100, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 158, 126, 126, 126, 126, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,   2,   2,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  47,  43,  47,  43,  47,  43,  47,  43,  47,  47,  47,  47,  47,  55,  55,
 55,  54,  55,  60,  55,  55,  55,  55,  54,  55,  55,  54,  55,  54,  65,  56,
 64,  67,  65,  54,  67,  65,  65,  67,  64,  67,  65,  67,  64,  67,  64,  71,
 73,  71,  67,  75,  69,  69,  69,  69,  71,  69,  69,  69,  69,  71,  69,  71,
 69,  69,  66,  69,  69,  69,  69,  71,  71,  69,  69,  77,  69,  92,  69,  92,
 92,  77,  77,  77,  88,  88,  88,  88,  88,  88,  88,  88,  88, 100, 100, 100,
 98,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100,  98, 100, 100, 100, 125, 100, 126, 100, 125, 126, 126, 100, 126, 126,
126,  98, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  43,  43,  43,  43,  47,  43,  43,  43,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  55,
 52,  55,  52,  60,  55,  52,  55,  52,  55,  52,  55,  55,  65,  54,  65,  56,
 64,  67,  65,  67,  67,  64,  65,  67,  64,  65,  68,  65,  64,  67,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  87,  71,  69,  87,  87,  69,  71,  87,  71,
 87,  69,  75,  87,  92,  87,  69,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  77,  77,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
 98,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 126, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  18,  46,  46,  46,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 43,  43,  43,  43,  51,  43,  51,  43,  51,  51,  51,  43,  51,  51,  51,  51,
 51,  51,  51,  56,  51,  51,  51,  51,  51,  54,  54,  54,  54,  57,  54,  55,
 56,  54,  54,  57,  54,  55,  54,  54,  65,  58,  67,  58,  67,  58,  68,  76,
 58,  79,  80,  64,  80,  69,  69,  69,  76,  69,  69,  69,  69,  77,  69,  76,
 69,  77,  69,  69,  69,  69,  77,  76,  76,  69,  77,  76,  77,  69,  77,  77,
 77,  77,  76,  77,  77,  77,  88,  77,  77,  88,  88,  77,  88,  77,  77,  77,
 98,  98,  98,  88,  88,  88, 100, 100, 100, 100, 100,  88,  88, 100,  88,  98,
100, 100,  98,  98,  98, 100, 100, 100, 100,  98,  98,  98, 126, 100, 100, 100,
 88, 126,  98, 100, 126, 126, 125, 126, 126, 126, 100, 126, 126, 126, 126, 126,
126,  98, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  47,
 47,  47,  43,  47,  43,  47,  43,  47,  43,  47,  47,  47,  47,  47,  55,  55,
 55,  54,  55,  60,  55,  55,  55,  55,  54,  55,  55,  55,  65,  54,  65,  65,
 64,  67,  65,  54,  67,  65,  65,  67,  64,  65,  68,  67,  64,  67,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  87,  71,  69,  87,  87,  69,  71,  87,  71,
 87,  69,  75,  87,  92,  87,  69,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  77,  77,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
 98,  98,  98,  88, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 126, 100, 100, 100, 125, 100, 100, 100, 125, 126, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  47,  47,  43,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  47,
 52,  55,  52,  60,  52,  52,  52,  52,  55,  52,  52,  67,  52,  67,  64,  64,
 64,  65,  65,  67,  65,  64,  64,  65,  64,  64,  64,  73,  64,  73,  70,  71,
 73,  73,  73,  75,  73,  73,  73,  70,  71,  87,  87,  87,  87,  87,  75,  71,
 87,  87,  75,  87,  92,  92,  92,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  71,  92,  92,  92, 113,  88,  88,  88,  88, 100,  88, 100, 100, 100,
100,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100, 100, 100, 100, 113, 100,
125, 100, 100, 113, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158,
158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  47,  43,  47,  47,  43,  47,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  47,  47,  47,  61,  47,  47,  47,  55,
 52,  55,  52,  60,  55,  52,  55,  52,  55,  52,  55,  67,  65,  54,  65,  64,
 64,  65,  65,  67,  65,  64,  68,  67,  64,  68,  68,  73,  64,  73,  70,  71,
 73,  73,  73,  75,  73,  73,  73,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  87,  92,  92,  92,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  77,  92,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
100,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 100, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
125, 100, 126, 100, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,  43,
 47,  47,  43,  43,  43,  47,  43,  47,  43,  47,  47,  47,  47,  55,  55,  55,
 55,  54,  55,  60,  55,  55,  55,  55,  54,  55,  55,  54,  55,  54,  65,  65,
 64,  67,  67,  54,  67,  68,  65,  67,  68,  67,  68,  67,  73,  67,  64,  71,
 73,  71,  73,  75,  73,  73,  73,  87,  71,  87,  87,  87,  87,  71,  87,  71,
 87,  87,  75,  87,  92,  87,  87,  71,  71,  92,  92,  77,  92,  92,  92,  92,
 92,  92,  76,  77,  92,  92,  88,  88,  88,  88,  88, 100,  88, 100, 100, 100,
 98,  98,  98, 100, 100,  88, 100, 100, 100, 100, 100, 113,  88, 100,  88,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 100, 100,
113, 100, 126, 100, 100, 100, 125, 126, 126, 100, 125, 126, 126, 126, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  61,  47,  47,  47,  47,  47,  61,  47,  47,  47,  61,  61,  61,  61,  47,
 61,  47,  61,  60,  52,  52,  52,  52,  52,  52,  52,  65,  52,  67,  64,  64,
 60,  68,  64,  67,  68,  70,  64,  68,  70,  64,  70,  73,  70,  73,  75,  71,
 73,  73,  73,  75,  73,  73,  73,  70,  71,  87,  87,  87,  87,  87,  75,  71,
 87,  87,  75,  92,  75,  92,  92,  87,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92,  71,  92,  92,  92, 113,  92, 109, 109, 109, 100, 109, 100, 100, 100,
100,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 100, 113, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  43,  47,  47,  47,  47,  47,  43,  47,  47,  47,  47,
 47,  47,  47,  47,  43,  47,  47,  47,  59,  47,  59,  61,  59,  59,  59,  55,
 59,  55,  59,  60,  55,  52,  55,  52,  55,  65,  55,  67,  68,  54,  68,  68,
 64,  67,  68,  67,  68,  68,  68,  67,  68,  68,  73,  73,  73,  73,  70,  71,
 73,  73,  73,  75,  73,  73,  73,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92,  71,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92,  92,  92, 100,  92, 100, 100, 100,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 113, 100, 100, 125, 100, 100, 100, 125, 126, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  47,  47,  47,  47,  47,  47,  61,  59,  47,  59,  61,  61,  59,  59,  59,
 59,  59,  61,  60,  59,  52,  55,  52,  55,  52,  68,  67,  68,  67,  68,  68,
 70,  68,  68,  67,  68,  68,  68,  68,  70,  73,  73,  73,  70,  73,  70,  71,
 73,  73,  73,  75,  73,  87,  87,  70,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92,  87,  71,  92,  92,  71,  92,  92,  92,  92,
 92,  92, 104,  92,  92,  92, 113,  92,  92, 109,  92,  92, 109, 100, 100, 100,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 126, 113, 100, 100, 125, 100, 100, 100, 125, 100, 126, 100, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  59,
 61,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  55,  59,  60,  59,  59,  55,  59,  55,  68,  55,  67,  68,  54,  68,  68,
 70,  68,  68,  67,  68,  68,  68,  68,  68,  73,  73,  73,  73,  73,  70,  71,
 73,  78,  73,  75,  73,  87,  87,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92, 104,  71,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92, 109,  92,  92,  92, 100, 100, 104,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 113, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 113, 100, 100, 125, 100, 100, 100, 125, 126, 126, 100, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  47,  47,  47,  47,  47,  47,  47,  47,  47,
 61,  61,  47,  61,  59,  61,  59,  61,  59,  61,  61,  61,  61,  61,  61,  59,
 61,  59,  61,  60,  61,  61,  59,  61,  59,  61,  61,  68,  61,  67,  70,  70,
 70,  68,  68,  67,  68,  70,  70,  68,  70,  70,  70,  73,  70,  73,  75,  71,
 73,  73,  73,  75,  85,  85,  85,  70,  87,  87,  87,  87,  87,  87,  75,  71,
 87,  87,  75,  92,  97,  92,  92,  92,  71,  92,  92,  92,  92,  92,  92,  92,
 92,  92, 104,  92,  92,  92, 113, 109, 109, 109, 109, 109, 109, 100, 109, 100,
100,  98, 104, 109, 109, 113, 100, 109, 100, 109, 100, 125, 113, 100, 113, 100,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 100, 100, 113, 113, 100,
125, 100, 100, 125, 100, 113, 125, 100, 100, 100, 125, 100, 126, 125, 100, 126,
100, 126, 125, 126, 126, 126, 126, 126, 126, 126, 125, 126, 125, 126, 126, 126,
125, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  43,  59,  59,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  55,  59,  61,  59,  59,  55,  59,  55,  68,  55,  55,  68,  54,  68,  68,
 70,  68,  68,  67,  68,  68,  68,  78,  68,  73,  73,  73,  73,  78,  70,  80,
 73,  80,  78,  75,  84,  84,  84,  87,  71,  87,  87,  87,  87,  87,  87,  71,
 87,  87,  75,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92,  92,  92,  92,  92, 104, 100, 104,
104,  98,  98, 100, 100, 113, 100, 100, 100, 100, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 113, 100, 100, 125, 126, 126, 100, 125, 126, 126, 126, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126,
125, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  61,  61,  61,  61,  61,  47,  61,  61,  61,  61,
 61,  61,  61,  61,  59,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 61,  61,  61,  60,  61,  61,  61,  61,  61,  61,  61,  61,  61,  67,  70,  70,
 60,  70,  70,  68,  70,  70,  70,  70,  70,  70,  70,  70,  75,  70,  75,  73,
 70,  85,  70,  81,  70,  70,  70,  75,  87,  90,  70,  90,  90,  87,  75,  87,
 97,  90,  75,  75,  75,  97,  92,  92,  92,  97,  92,  92,  92, 109,  92, 109,
 92,  92, 104,  92, 109, 109, 113, 109, 109, 109, 109, 109, 109, 109, 109, 100,
100,  98, 100, 109, 109, 113, 109, 109, 109, 113, 109, 125, 113, 113, 113, 100,
113, 100, 100, 100,  98, 113, 113, 113, 113, 100, 100, 100, 100, 113, 113, 113,
125, 113, 100, 125, 113, 113, 125, 113, 113, 113, 125, 113, 100, 125, 133, 126,
125, 126, 125, 133, 125, 126, 126, 140, 126, 126, 125, 140, 125, 126, 125, 140,
125, 140, 125, 140, 125, 126, 126, 126, 126, 126, 126, 125, 126, 126, 126, 126,
126, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  51,  46,  46,  43,  43,  43,  51,  43,  43,  43,  51,
 59,  59,  51,  51,  51,  51,  51,  59,  51,  51,  51,  59,  59,  51,  51,  51,
 51,  51,  51,  59,  51,  51,  51,  74,  51,  74,  51,  51,  74,  57,  74,  78,
 68,  80,  80,  79,  80,  78,  80,  80,  78,  80,  80,  80,  78,  80,  84,  79,
 80,  79,  80,  75,  80,  80,  80,  84,  79,  80,  80,  80,  80,  79,  87,  79,
 87,  80,  92,  92,  92,  92,  92, 104,  76,  92,  92, 105, 104,  92, 104,  92,
104, 104, 102, 104,  92, 104,  92, 104, 104,  92, 104, 104,  92, 104, 104, 104,
104,  98,  98, 104, 104, 109, 104, 100, 104, 100, 104, 125, 100, 100, 100,  98,
100, 100,  98,  98,  98, 100, 100, 100, 100,  98, 126,  98, 126, 100, 100, 126,
125, 126, 126, 140, 126, 126, 125, 126, 126, 126, 140, 126, 126, 126, 126, 126,
126, 126, 140, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126, 126,
158, 126, 158, 126, 126, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  67,  68,  79,  68,  68,
 70,  68,  68,  80,  68,  68,  68,  78,  73,  73,  73,  73,  73,  78,  70,  80,
 85,  78,  84,  75,  85,  84,  85,  85,  80,  87,  87,  87,  87,  87,  90, 104,
 87,  87,  75,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92, 109, 112,  92, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 100, 100, 100, 100, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 126, 100, 113, 113, 100,
125, 100, 126, 125, 100, 140, 125, 140, 140, 140, 125, 126, 126, 140, 126, 126,
140, 126, 125, 126, 126, 126, 126, 126, 126, 126, 140, 126, 125, 126, 126, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 126, 158, 126, 158, 158, 158,
158, 158, 126, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,
 59,  59,  59,  59,  51,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,
 59,  51,  59,  61,  59,  59,  55,  59,  51,  59,  55,  55,  68,  79,  68,  68,
 68,  78,  78,  79,  78,  68,  78,  78,  73,  78,  78,  78,  84,  78,  85,  79,
 78,  80,  80,  75,  84,  84,  84,  84,  80,  84,  87,  87,  87,  80,  87,  79,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92, 104, 104, 104,  92,  92, 109,  92,  92,  92,  92, 104,  92, 104, 104, 104,
104,  98,  98, 112, 112, 113, 104, 100, 100, 100, 100, 125, 109, 100, 109,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100,  98, 100, 100, 113, 100,
125, 100, 126, 140, 126, 140, 125, 126, 126, 140, 125, 126, 126, 140, 126, 126,
126, 126, 125, 126, 126, 126, 126, 126, 126, 126, 140, 126, 140, 126, 126, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  55,  59,  59,  67,  68,  79,  68,  68,
 70,  78,  68,  80,  78,  68,  78,  78,  73,  78,  73,  78,  73,  78,  70,  80,
 84,  80,  78,  75,  84,  84,  84,  85,  80,  87,  87,  87,  87,  87,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109,  92,  92,  92, 112,  92, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 100, 100, 100, 100, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 100, 100, 100,  98, 100, 126, 100, 113, 113, 100,
125, 100, 126, 125, 100, 140, 125, 140, 126, 140, 125, 126, 126, 140, 126, 126,
140, 126, 125, 126, 126, 126, 126, 126, 126, 126, 140, 126, 125, 126, 126, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,
 48,  61,  61,  61,  61,  61,  61,  61,  61,  61,  61,  48,  61,  61,  61,  61,
 61,  61,  61,  48,  61,  61,  61,  82,  61,  82,  61,  61,  82,  61,  82,  82,
 75,  70,  82,  70,  70,  75,  75,  70,  75,  75,  75,  75,  75,  75,  75,  70,
 75,  75,  75,  81,  75,  75,  75,  75,  70,  75,  75,  75,  75,  97,  95,  90,
 75,  75,  95,  95,  95,  95,  97,  97,  97,  95,  97,  97,  97,  95,  97,  95,
109, 109, 112, 109, 109, 109,  95, 109, 109, 113, 109, 109, 113, 109, 109, 109,
109, 104, 109, 113, 113,  95, 109, 113, 113, 113, 113,  95, 113, 113, 113, 100,
113, 113, 113, 109, 100, 113, 113, 113, 113, 100, 113, 100, 113, 125, 125, 113,
125, 113, 133, 125, 113, 125, 125, 113, 113, 125, 125, 125, 133, 125, 125, 133,
125, 100, 125, 125, 125, 133, 133, 125, 133, 133, 125, 125, 125, 133, 125, 125,
125, 125, 125, 125, 125, 125, 125, 125, 140, 163, 163, 125, 163, 163, 163, 163,
163, 163, 126, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163,
163, 158, 163, 163, 163, 163, 163, 158, 163, 163, 163, 181, 163, 181, 197, 181,
181, 181, 181, 197, 197, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  78,  68,  79,  68,  68,
 70,  78,  68,  80,  78,  68,  78,  78,  73,  78,  73,  78,  85,  78,  70,  80,
 84,  78,  84,  75,  84,  84,  85,  85,  80,  87,  87,  87,  87,  89,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109, 112, 112, 109, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 112, 112, 112, 112, 100, 125, 109, 100, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 126, 100, 113, 113, 100,
125, 100, 126, 125, 140, 140, 125, 140, 140, 140, 125, 140, 126, 140, 140, 126,
140, 126, 125, 140, 140, 126, 126, 126, 126, 126, 140, 126, 125, 126, 140, 126,
125, 126, 140, 126, 126, 126, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  78,  68,  79,  68,  68,
 70,  78,  78,  80,  78,  68,  78,  78,  73,  78,  85,  78,  85,  78,  70,  80,
 84,  80,  84,  75,  84,  84,  84,  90,  80,  89,  87,  87,  89,  89,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92, 104, 104, 104,  92,  92, 109, 112, 112, 112, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 109,  98,
100, 100, 100, 100,  98, 100, 109, 100, 100,  98, 100, 126, 100, 113, 113, 140,
125, 140, 126, 125, 140, 140, 125, 140, 140, 140, 125, 140, 126, 140, 140, 126,
140, 126, 125, 140, 140, 126, 126, 140, 126, 126, 140, 140, 140, 126, 140, 126,
125, 126, 140, 126, 140, 126, 126, 158, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  61,  59,  59,  59,  59,  59,  59,  59,  78,  68,  79,  68,  68,
 70,  78,  78,  80,  78,  68,  78,  78,  70,  78,  85,  78,  85,  78,  70,  80,
 85,  78,  84,  75,  85,  85,  85,  90,  80,  89,  90,  90,  87,  89,  90, 104,
 87,  87,  97,  92,  92,  92,  92, 104, 104,  92,  92, 104,  92,  92,  92,  92,
 92,  92, 104, 104,  92,  92, 109, 112, 112, 109, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 113,  98,
100, 100, 100, 100,  98, 100, 113, 100, 100,  98, 100, 126, 100, 113, 113, 140,
125, 140, 126, 125, 140, 140, 125, 140, 140, 140, 125, 140, 126, 140, 140, 126,
140, 126, 125, 140, 140, 126, 126, 140, 126, 126, 140, 140, 125, 126, 140, 126,
125, 126, 140, 126, 140, 126, 126, 126, 126, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  59,  61,  59,  61,
 61,  61,  59,  61,  59,  61,  59,  61,  59,  61,  61,  61,  61,  61,  61,  59,
 61,  59,  61,  82,  61,  61,  59,  61,  59,  61,  61,  59,  61,  78,  70,  70,
 70,  68,  70,  78,  73,  70,  70,  73,  70,  70,  70,  85,  70,  85,  75,  78,
 85,  85,  85,  75,  90,  90,  90,  97,  89,  90,  90,  90,  90,  90,  97, 104,
 90,  90,  75,  97,  97,  90,  92,  92, 104,  97,  92, 104,  92,  97,  92,  92,
 92,  92, 104, 104, 109, 112, 109, 109, 109, 109, 109, 112, 109, 112, 109, 112,
104, 104, 104, 109, 109, 113, 112, 109, 109, 109, 109, 125, 113, 109, 113, 104,
109, 109, 100, 100,  98, 109, 113, 113, 109,  98, 100, 100, 133, 113, 125, 133,
125, 133, 100, 125, 133, 133, 125, 133, 133, 133, 125, 140, 140, 125, 140, 126,
133, 126, 125, 140, 140, 140, 140, 140, 126, 140, 125, 140, 125, 140, 140, 140,
125, 140, 125, 140, 140, 140, 140, 140, 126, 126, 140, 125, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 158, 181, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  53,  59,  59,
 59,  59,  74,  59,  51,  59,  74,  59,  74,  74,  74,  59,  59,  74,  74,  74,
 74,  74,  74,  59,  74,  74,  74,  74,  74,  74,  74,  74,  74,  79,  74,  74,
 83,  74,  74,  79,  74,  83,  83,  80,  83,  83,  83,  80,  83,  80,  84,  79,
 80,  80,  80,  75,  80,  80,  80,  84,  79,  80,  89,  89,  80,  80,  89, 102,
 89,  89,  92,  91,  92,  91, 104, 105, 102,  92, 104, 105, 104,  92, 104,  92,
104, 104, 102, 104, 104, 104, 112, 104, 104, 112, 104, 104, 117, 104, 104, 104,
104, 122, 122, 117, 117, 112, 104, 117, 117, 117, 117, 125, 117, 117, 117,  98,
117, 117, 104, 104,  98, 117, 117, 117, 117,  98, 126,  98, 126, 140, 140, 140,
125, 140, 126, 140, 140, 140, 125, 140, 140, 140, 140, 140, 126, 140, 140, 126,
140, 126, 140, 126, 126, 126, 126, 126, 126, 126, 140, 158, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  53,  46,  53,  53,  59,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  79,  83,  83,
 70,  83,  83,  80,  83,  83,  83,  83,  85,  83,  83,  83,  85,  83,  85,  80,
 84,  83,  83,  75,  84,  89,  84,  90,  80,  89,  89,  91,  89,  89,  90, 104,
 91,  91,  97,  90,  97,  96,  96, 104, 104,  92,  96, 104,  96,  92,  96,  92,
 92, 104, 104, 104,  92, 112, 109, 112, 112, 112, 112, 112, 112, 104, 112, 104,
104,  98, 104, 112, 112, 113, 117, 112, 117, 112, 117, 125, 109, 112, 109, 104,
117, 117, 117, 117,  98, 117, 133, 140, 140,  98, 140, 126, 140, 133, 133, 140,
125, 140, 126, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 125, 140, 140, 140, 126, 140, 126, 126, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  53,  46,  53,  59,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  80,  68,  68,
 82,  83,  83,  83,  83,  85,  83,  83,  70,  83,  85,  85,  85,  83,  70,  80,
 85,  83,  85,  75,  85,  85,  85,  90,  89,  89,  90,  90,  90,  89,  97, 104,
 90,  91,  97,  97,  97,  96,  96, 104, 104,  97,  92, 104,  92,  97,  92,  92,
 92,  92, 104, 104, 112, 112, 109, 112, 112, 109, 112, 112, 112, 112, 112, 104,
104, 104, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 113, 104,
112, 112, 117, 117,  98, 112, 113, 133, 133,  98, 140, 126, 140, 133, 125, 140,
125, 140, 126, 125, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 158, 181, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  46,  46,  53,  53,  46,  53,  53,  59,  59,
 61,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  80,  83,  68,
 82,  83,  83,  83,  83,  85,  83,  83,  70,  83,  85,  85,  85,  83,  70,  80,
 85,  83,  85,  75,  85,  85,  90,  90,  89,  91,  90,  90,  90,  91,  97, 104,
 90,  96,  97,  97,  97,  96,  96, 104, 104,  97,  96, 104,  96,  97,  96,  92,
101, 101, 104, 104, 112, 112, 109, 112, 112, 112, 112, 112, 112, 112, 112, 104,
104, 104, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 112, 109, 104,
112, 112, 117, 117,  98, 112, 133, 133, 133,  98, 140, 140, 140, 133, 125, 140,
125, 140, 140, 125, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
158, 158, 158, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  46,  46,  53,  53,  46,  53,  53,  53,  59,
 59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  79,  83,  83,
 82,  83,  83,  80,  83,  83,  83,  83,  85,  83,  83,  83,  85,  83,  90,  80,
 83,  83,  83,  75,  89,  89,  89,  90,  80,  89,  91,  91,  91,  91,  90, 104,
 96,  96,  97,  90,  97,  96,  96, 104, 104,  99,  96, 104,  96,  99, 101, 101,
101, 104, 104, 104, 112, 112, 109, 112, 112, 112, 112, 112, 112, 104, 112, 104,
104, 104, 104, 112, 112, 113, 117, 112, 117, 112, 117, 125, 109, 112, 109, 104,
117, 117, 117, 117,  98, 117, 133, 140, 140,  98, 140, 119, 140, 133, 133, 140,
125, 140, 140, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181,
158, 158, 158, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  53,  46,  53,  53,  46,  53,  53,  53,  53,
 53,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  59,  74,
 59,  74,  59,  82,  59,  59,  74,  59,  74,  59,  74,  74,  83,  79,  83,  83,
 83,  83,  83,  79,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  85,  79,
 83,  83,  83,  75,  83,  83,  89,  90,  80,  89,  89,  91,  91,  89,  90, 105,
 91,  91,  97,  96,  99,  96,  96, 104, 104,  96,  96, 104, 101,  99, 104, 101,
104, 104, 105, 104, 101, 110, 112, 117, 117, 112, 117, 117, 112, 104, 117, 104,
104, 122, 104, 117, 117, 109, 117, 117, 117, 117, 117, 125, 112, 117, 112, 104,
117, 117, 119, 119,  98, 117, 140, 140, 140, 146, 140, 146, 140, 140, 133, 140,
125, 140, 126, 140, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 126,
140, 126, 140, 140, 140, 140, 126, 140, 126, 140, 140, 140, 140, 158, 140, 158,
140, 158, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158,
158, 158, 158, 158, 181, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  53,  53,  46,  53,  53,  46,  53,  61,  61,  61,
 61,  61,  61,  61,  59,  61,  59,  61,  59,  61,  61,  61,  61,  61,  61,  59,
 61,  59,  61,  82,  61,  61,  61,  61,  59,  61,  61,  61,  82,  83,  82,  82,
 82,  70,  82,  83,  70,  82,  82,  85,  82,  70,  82,  90,  82,  85,  82,  83,
 90,  90,  90,  95,  90,  90,  90,  97,  89,  90,  97,  97,  90,  90,  97,  91,
 97,  97,  95,  97,  97,  97,  97,  96, 104,  97,  97, 104,  97,  97,  99,  97,
112, 112, 104, 112, 109, 112, 109, 109, 109, 109, 109, 112, 109, 112, 112, 112,
104, 104, 104, 109, 109, 113, 112, 109, 109, 109, 112, 125, 113, 109, 113, 104,
109, 109, 112, 112, 104, 133, 113, 133, 133, 119, 133, 140, 133, 133, 125, 133,
125, 133, 140, 125, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 126, 125, 140, 133, 140, 140, 140, 140, 140, 125, 140, 125, 140, 140, 140,
125, 140, 125, 140, 140, 140, 140, 140, 158, 140, 140, 125, 158, 140, 158, 158,
158, 140, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  46,  53,  53,  74,  53,  53,  74,  74,
 53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  83,  74,  83,  94,
 94,  94,  94, 103,  94,  94,  94,  83,  94,  94,  94,  94,  94,  94,  91, 102,
 94,  94,  99,  96,  96, 110, 105, 102, 102, 101, 110, 102, 105, 110, 105, 110,
105, 105, 102, 105, 110, 105, 112, 104, 110, 117, 117, 105, 117, 105, 119, 105,
105, 122, 122, 117, 117, 117, 119, 117, 119, 117, 119, 125, 117, 117, 117, 122,
119, 119, 119, 122, 122, 117, 117, 117, 117, 122, 146, 122, 140, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 126, 140, 140, 146,
140, 146, 140, 158, 158, 158, 158, 158, 165, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 181, 158, 158, 158, 158, 181, 181, 158, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  46,  53,  53,  46,  53,  53,  53,  53,
 53,  53,  59,  59,  59,  59,  59,  61,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  59,  83,  59,  83,  83,  82,
 82,  83,  83,  83,  83,  83,  83,  83,  82,  83,  85,  83,  90,  83,  82,  83,
 85,  83,  89,  75,  90,  91,  90,  90,  89,  91,  90,  90,  91,  91,  97, 104,
 99,  96,  97,  97,  97,  99,  96, 104, 104,  97,  99, 104, 101,  97, 101,  99,
101, 101, 104, 104, 112, 112, 109, 112, 112, 112, 112, 112, 112, 117, 112, 104,
104, 104, 104, 112, 112, 113, 117, 112, 112, 112, 117, 125, 109, 112, 109, 119,
117, 117, 117, 117, 146, 133, 133, 133, 133, 146, 140, 140, 140, 133, 133, 140,
125, 140, 140, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 126, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 140, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  46,  53,  53,  53,  53,
 53,  53,  59,  59,  59,  59,  59,  59,  59,  59,  59,  61,  59,  59,  59,  59,
 59,  59,  59,  82,  59,  59,  59,  59,  59,  59,  83,  83,  83,  79,  83,  83,
 82,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  85,  83,  90,  83,
 83,  83,  83,  75,  89,  89,  91,  90,  89,  91,  91,  91,  91,  91,  97, 104,
 96,  96,  97,  99,  97,  96, 101, 104, 104,  99, 101, 104, 101,  99, 101, 101,
101, 110, 104, 104, 112, 112, 109, 112, 112, 112, 112, 117, 112, 117, 117, 104,
104, 122, 104, 112, 112, 109, 117, 117, 117, 117, 117, 125, 112, 117, 109, 119,
117, 117, 117, 119, 146, 117, 133, 140, 140, 146, 140, 146, 140, 133, 133, 140,
125, 140, 140, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 125, 140, 140, 140, 140, 140, 126, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  61,  61,  61,  61,  61,  61,  61,
 82,  61,  61,  61,  61,  61,  61,  82,  61,  61,  61,  82,  82,  82,  82,  61,
 82,  61,  82,  82,  82,  82,  82,  82,  61,  82,  82,  82,  82,  61,  82,  82,
 82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  95,  90,
 82,  97,  82,  95,  97,  97,  97,  95,  97,  97,  97,  97,  97,  97,  95,  90,
106,  97,  95, 106,  95, 106, 106,  97,  99,  95, 106,  97, 106, 106, 106, 106,
106, 106, 104, 112, 106, 106,  95, 109, 109, 109, 109, 109, 109, 109, 109, 109,
112, 104, 112, 109, 109, 125, 109, 109, 109, 109, 109, 125, 113, 113, 113, 133,
133, 133, 133, 133, 119, 133, 113, 133, 133, 133, 133, 133, 133, 125, 125, 133,
125, 133, 133, 125, 133, 125, 125, 133, 133, 133, 125, 133, 133, 125, 133, 133,
133, 140, 125, 133, 133, 133, 133, 133, 140, 133, 125, 133, 125, 133, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 140, 163, 163, 163, 163, 163, 163, 163,
163, 163, 158, 163, 163, 163, 163, 163, 163, 163, 181, 163, 163, 163, 163, 163,
163, 181, 181, 181, 163, 181, 197, 181, 181, 197, 197, 181, 197, 197, 197, 181,
181, 181, 181, 197, 197, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  46,  53,  53,  53,  53,
 61,  61,  59,  59,  59,  59,  59,  61,  59,  59,  59,  82,  61,  61,  61,  59,
 61,  59,  61,  82,  59,  61,  59,  82,  59,  61,  59,  83,  82,  83,  82,  82,
 82,  83,  82,  83,  83,  82,  82,  83,  82,  85,  82,  90,  82,  85,  82,  83,
 90,  90,  90,  95,  90,  90,  90,  97,  91,  90,  97,  97,  90,  96,  97, 104,
 97,  99, 106,  97,  97,  97,  99, 101, 104,  97,  99, 104,  99,  97,  99,  99,
112, 112, 104, 104, 112, 112, 109, 112, 112, 109, 112, 112, 112, 112, 112, 112,
104, 104, 104, 112, 112, 113, 112, 112, 112, 112, 112, 125, 109, 133, 113, 119,
133, 133, 117, 117, 146, 133, 133, 133, 133, 146, 140, 140, 133, 133, 125, 133,
125, 133, 140, 125, 133, 133, 125, 133, 133, 133, 125, 140, 140, 133, 140, 140,
133, 140, 125, 140, 140, 140, 140, 140, 140, 140, 133, 140, 125, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 140, 140, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 61,  61,  59,  61,  59,  61,  59,  82,  59,  61,  61,  82,  82,  61,  61,  86,
 61,  86,  82,  82,  82,  82,  86,  82,  86,  82,  82,  86,  82,  83,  82,  82,
 82,  82,  82,  83,  82,  82,  82,  82,  82,  82,  82,  82,  82,  90,  82,  83,
 97,  90,  90,  95,  97,  97,  97,  97,  91,  97,  97,  97,  97,  99,  97,  96,
 97,  97,  95,  97, 106,  97,  97, 101, 101, 106,  97, 101,  99, 106,  99, 106,
114, 114, 104, 114, 106, 112, 106, 112, 112, 109, 112, 112, 109, 112, 112, 112,
119, 104, 119, 109, 109, 113, 112, 109, 112, 133, 112, 125, 109, 133, 113, 119,
133, 133, 133, 133, 146, 133, 133, 133, 133, 146, 133, 140, 133, 133, 125, 133,
125, 133, 140, 125, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 140, 125, 133, 133, 140, 140, 140, 140, 140, 133, 140, 125, 140, 140, 140,
125, 140, 163, 140, 140, 140, 140, 140, 158, 140, 140, 163, 158, 140, 158, 158,
158, 163, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  46,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  59,  59,  59,  86,  59,  59,  82,  59,  59,  59,  86,
 86,  86,  59,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  83,  83,  82,
 82,  83,  83,  83,  83,  83,  83,  83,  82,  83,  83,  83, 103,  83,  82,  83,
 90,  83,  91,  82,  91,  91,  91,  97,  91,  91,  99,  99,  96,  96,  97, 104,
 99,  96, 106,  99,  97,  99, 101, 104, 104,  97,  99, 104, 101,  99, 101,  99,
101, 107, 104, 104, 114, 112, 109, 112, 112, 112, 112, 117, 112, 117, 112, 119,
119, 104, 119, 112, 112, 109, 117, 117, 117, 112, 117, 125, 133, 117, 133, 119,
117, 117, 117, 119, 146, 133, 133, 133, 133, 146, 140, 146, 140, 133, 133, 140,
125, 140, 140, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 125, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 140, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  59,  86,  59,  86,  86,  86,  61,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  79,  83,  83,
 82,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83,  83, 103,  83, 103,  83,
 83,  83,  83,  82,  91,  91,  91, 103,  91,  91,  96,  96,  96,  96,  97, 104,
 99, 101, 106,  99,  97, 101, 101, 104, 104,  99, 101, 104, 101,  99, 107, 101,
110, 110, 105, 104, 114, 110, 109, 117, 117, 112, 117, 117, 112, 117, 117, 119,
119, 122, 119, 117, 117, 109, 117, 117, 117, 117, 117, 125, 112, 117, 133, 146,
117, 117, 119, 119, 146, 117, 133, 140, 140, 146, 140, 146, 140, 133, 133, 140,
125, 140, 146, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 158, 181, 158, 181, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  74,  74,  74,  74,  74,  53,  74,  74,  74,  59,  74,  74,  74,  74,
 74,  74,  74,  82,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 83,  74,  74,  74,  74,  83,  74,  74,  83,  83,  83,  83,  83,  83, 103,  94,
 83,  94,  83,  97,  83,  83,  83,  91,  94,  94,  91,  91,  91,  94,  96, 102,
101, 110,  97, 101, 101, 110, 110, 105, 105, 101, 110, 105, 110, 110, 110, 110,
110, 105, 102, 105, 110, 110, 112, 117, 117, 117, 117, 119, 117, 119, 117, 119,
105, 122, 122, 117, 117, 112, 119, 117, 117, 117, 119, 125, 117, 117, 117, 122,
117, 119, 119, 119, 122, 117, 117, 117, 117, 122, 146, 146, 140, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 140, 158, 140, 165, 158, 140, 158, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  74,  53,  53,  53,  74,
 53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  83,  94,  83,  94,
 94,  94,  94, 103,  94,  94,  94,  91,  94,  94,  94,  94,  94,  94,  96, 102,
110,  94, 103, 110, 101, 110, 110, 102, 102, 110, 110, 102, 105, 110, 105, 110,
105, 105, 102, 105, 110, 110, 117, 119, 119, 117, 119, 119, 117, 105, 119, 105,
122, 122, 122, 117, 117, 117, 119, 117, 119, 117, 119, 125, 117, 117, 117, 122,
119, 119, 119, 146, 122, 117, 117, 117, 117, 122, 146, 146, 146, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 146, 140, 140, 146,
140, 146, 140, 158, 140, 158, 158, 158, 165, 158, 158, 158, 140, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 181, 181,
181, 158, 181, 158, 181, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 61,  53,  53,  53,  86,  61,  86,  61,  86,  61,  86,  82,  82,  61,  61,  86,
 61,  86,  82,  82,  86,  82,  86,  82,  86,  82,  86,  86,  82,  86,  82,  82,
 82,  82,  82,  83,  82,  82,  82,  83,  82,  82,  82,  90,  82,  90,  82,  83,
 90,  90,  90,  95,  90,  90,  97,  97,  91,  99,  97,  97,  97,  99,  97, 101,
 97,  99, 106,  97, 106,  97,  99, 101, 104, 106,  99, 101,  99, 106, 114, 114,
114, 114, 104, 114, 114, 112, 106, 112, 112, 109, 112, 112, 112, 112, 112, 117,
119, 104, 119, 112, 112, 113, 112, 112, 112, 133, 112, 125, 133, 133, 133, 119,
133, 133, 117, 117, 146, 133, 133, 133, 133, 146, 133, 140, 133, 133, 133, 133,
125, 133, 140, 133, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 140, 125, 140, 140, 140, 140, 140, 140, 140, 133, 140, 125, 140, 140, 140,
125, 140, 133, 140, 140, 140, 140, 140, 158, 140, 140, 163, 158, 158, 158, 158,
158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 82,  83,  83,  83,  83,  83,  83,  83,  82,  83,  83,  83, 103,  83, 103,  83,
103,  83,  83,  82, 103, 103, 103, 103,  91,  96, 103, 103,  96,  96,  97, 104,
 99, 101, 106,  99,  97,  99, 101, 107, 104,  99, 101, 104, 107,  99, 107, 114,
107, 110, 104, 104, 114, 114, 106, 117, 117, 112, 117, 117, 112, 117, 117, 119,
119, 122, 119, 117, 117, 109, 117, 117, 117, 117, 117, 125, 133, 117, 133, 146,
117, 117, 117, 119, 146, 117, 133, 133, 140, 146, 140, 146, 140, 133, 133, 140,
125, 140, 146, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  86,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  83,  74,  83,  83,  83,  94, 103,  94,
 94,  94,  94, 103,  94,  94,  94, 103,  94,  94,  94, 107,  94,  94, 103, 102,
110, 110, 103, 110, 101, 110, 110, 105, 102, 110, 110, 105, 110, 110, 105, 110,
110, 105, 102, 105, 110, 110, 117, 119, 119, 117, 117, 119, 117, 119, 119, 119,
105, 122, 122, 117, 117, 117, 119, 117, 119, 117, 119, 125, 117, 117, 117, 122,
119, 119, 119, 146, 122, 117, 117, 117, 117, 122, 146, 146, 140, 140, 140, 140,
140, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 158, 158, 158, 165, 158, 140, 158, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 158, 158, 158, 158, 158, 181, 181, 181, 181,
181, 158, 181, 181, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 46,  53,  46,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  74,  86,  93,
 82,  93,  93,  93,  93,  83,  83,  83, 103,  83,  83,  83, 103,  83, 103,  94,
 83,  83,  83,  82, 103,  91, 103, 103,  94,  96, 103, 103,  96, 107, 103, 105,
 99, 101, 106,  99,  99, 101, 107, 104, 105,  99, 107, 104, 107,  99, 107, 107,
110, 110, 105, 104, 114, 116, 112, 117, 117, 112, 117, 117, 117, 119, 117, 119,
119, 122, 119, 117, 117, 109, 117, 117, 117, 117, 117, 125, 117, 117, 133, 146,
117, 117, 119, 119, 146, 117, 133, 132, 140, 146, 140, 146, 140, 133, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
140, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  82,  86,  86,  86,  82,  82,  86,  86,  86,
 86,  86,  82,  82,  86,  86,  86,  82,  86,  82,  86,  86,  82,  86,  82,  82,
 82,  86,  82,  93,  82,  82,  82,  93,  82,  82,  82, 103,  82, 103,  82,  83,
103, 103, 103,  95, 103, 103, 103,  97,  96, 103, 103,  97, 103,  99, 106, 107,
 97,  99, 106, 106, 106,  97,  99, 107, 107, 106, 114, 107, 114, 106, 114, 114,
114, 114, 104, 114, 114, 114, 106, 114, 114, 106, 112, 112, 112, 117, 112, 117,
119, 119, 119, 112, 112, 125, 117, 112, 112, 133, 117, 125, 133, 133, 133, 119,
133, 133, 132, 117, 146, 133, 133, 133, 133, 146, 133, 140, 133, 133, 133, 133,
125, 133, 140, 133, 133, 133, 125, 133, 133, 133, 125, 133, 140, 133, 133, 140,
133, 146, 125, 140, 140, 140, 140, 140, 140, 140, 133, 140, 163, 140, 140, 140,
163, 140, 163, 140, 140, 140, 140, 140, 158, 140, 140, 163, 158, 181, 158, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  46,  46,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  74,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  93,  83,  83,  83, 103,  83, 103,  94,
103,  83,  83, 106, 103, 103, 103, 103,  94,  96, 103, 103, 101, 107, 103, 105,
101, 107, 106, 103, 103, 107, 107, 110, 105,  99, 107, 105, 107,  99, 110, 107,
110, 110, 105, 119, 110, 110, 114, 117, 117, 116, 117, 117, 117, 119, 117, 119,
119, 122, 119, 117, 117, 112, 117, 117, 117, 117, 117, 125, 132, 117, 132, 146,
117, 117, 119, 119, 146, 132, 132, 132, 132, 146, 119, 146, 140, 133, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 133, 140, 140, 140, 140, 140,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
140, 140, 140, 158, 140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158,
158, 181, 158, 158, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  86,  86,
 82,  93,  93,  93,  93,  93,  93,  93,  82,  93, 103, 103, 103, 103, 103,  83,
103, 103, 103,  82, 103, 103, 103, 103, 107, 103, 103, 103, 103, 107, 103, 104,
103, 103, 106, 103, 106,  99, 107, 107, 104, 106, 114, 107, 107, 114, 107, 114,
114, 107, 104, 119, 114, 114, 106, 116, 116, 114, 116, 117, 114, 117, 117, 119,
119, 119, 119, 117, 117, 109, 117, 117, 117, 132, 117, 125, 133, 132, 133, 146,
132, 132, 117, 119, 146, 132, 133, 133, 132, 146, 132, 146, 140, 133, 133, 133,
133, 133, 146, 133, 140, 133, 125, 140, 140, 140, 125, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140,
125, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103,  94,
103,  93, 103, 106, 103, 103, 103, 103,  94, 103, 103, 103, 103, 107, 103, 105,
103, 107, 106, 103, 103, 107, 107, 110, 105, 103, 107, 105, 107, 114, 110, 116,
110, 110, 105, 119, 116, 116, 127, 116, 116, 116, 117, 117, 117, 119, 117, 119,
119, 122, 119, 117, 117, 127, 117, 117, 117, 117, 117, 125, 132, 132, 132, 146,
132, 132, 119, 119, 146, 132, 132, 132, 132, 146, 146, 146, 140, 133, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 133, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  74,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103,  94,
103,  93,  93, 106, 103, 103, 103, 103,  94, 107, 103, 103, 107, 107, 103, 105,
107, 107, 106, 103, 103, 107, 107, 105, 105, 103, 107, 105, 110, 114, 110, 110,
110, 110, 105, 119, 110, 110, 127, 117, 117, 116, 117, 119, 117, 119, 117, 119,
119, 122, 119, 117, 117, 127, 119, 117, 117, 117, 119, 125, 132, 132, 132, 146,
117, 117, 119, 119, 146, 132, 132, 132, 132, 146, 146, 146, 140, 140, 133, 140,
133, 140, 146, 133, 140, 140, 125, 140, 140, 140, 133, 140, 140, 140, 140, 146,
140, 146, 140, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 158, 140, 140,
140, 158, 140, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 181, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  74,  74,  53,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  94,  74,  94,
 94,  94,  94, 103,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 110, 102,
 94,  94, 103, 110, 110,  94,  94, 102, 102, 110,  94, 102, 105, 110, 105, 105,
105, 105, 122, 102, 105, 105, 110, 105, 119, 110, 119, 105, 119, 122, 119, 122,
122, 122, 122, 119, 119, 117, 122, 119, 119, 119, 122, 132, 117, 119, 117, 122,
119, 122, 122, 122, 122, 137, 137, 137, 146, 122, 146, 122, 146, 150, 140, 146,
140, 146, 146, 140, 146, 140, 125, 146, 146, 140, 140, 146, 146, 140, 171, 146,
158, 165, 140, 158, 158, 165, 165, 158, 165, 165, 158, 158, 158, 158, 158, 158,
158, 158, 158, 158, 158, 158, 158, 158, 165, 158, 158, 158, 158, 158, 158, 158,
158, 158, 165, 158, 158, 181, 158, 158, 158, 181, 158, 158, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  46,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  74,  86,  74,  86,  74,  86,  86,  86,  86,  86,  86,  74,
 86,  74,  86,  86,  74,  74,  74,  86,  74,  74,  74,  74,  74,  74,  93,  93,
 93,  74,  93,  74,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  94,
 93,  94,  94, 103,  94,  94, 103, 103,  94,  94, 103, 107, 107,  94, 103,  94,
107, 110, 103, 107, 103, 110, 110, 105, 105, 107, 110, 105, 110, 110, 110, 110,
110, 110, 102, 105, 110, 110, 123, 119, 119, 123, 117, 119, 117, 119, 119, 119,
119, 122, 122, 117, 117, 123, 119, 117, 119, 117, 119, 125, 132, 117, 132, 146,
119, 119, 119, 146, 122, 132, 132, 132, 137, 146, 146, 146, 150, 140, 140, 150,
133, 140, 146, 140, 140, 140, 125, 140, 140, 140, 140, 140, 146, 140, 140, 146,
140, 146, 140, 140, 140, 140, 146, 140, 165, 158, 140, 140, 140, 158, 158, 158,
140, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, 181, 158, 158, 158, 158,
158, 181, 158, 158, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  46,  53,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103, 103, 103,  93, 103,  93,
103, 108, 103,  82, 103, 103, 103, 103, 107, 103, 103, 103, 103, 107, 103, 107,
103, 103, 106, 103, 106, 103, 107, 107, 107, 103, 114, 107, 107, 114, 107, 114,
116, 116, 105, 119, 114, 116, 106, 116, 116, 127, 116, 116, 127, 119, 117, 119,
119, 146, 119, 123, 117, 127, 117, 132, 132, 132, 132, 125, 132, 132, 133, 146,
132, 132, 132, 119, 146, 132, 133, 132, 132, 146, 132, 146, 140, 133, 133, 133,
133, 133, 146, 133, 140, 133, 125, 140, 140, 140, 133, 140, 140, 140, 140, 140,
140, 146, 133, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
163, 140, 140, 140, 140, 140, 140, 140, 158, 158, 158, 181, 158, 181, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  46,  53,  46,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103,  93,
103, 108, 108, 106, 103, 103, 103, 103, 108, 103, 103, 103, 103, 107, 103, 105,
103, 115, 106, 103, 103, 115, 115, 107, 105, 103, 115, 110, 107, 114, 107, 118,
118, 118, 105, 119, 118, 118, 127, 118, 123, 127, 123, 118, 123, 119, 123, 119,
119, 122, 119, 123, 132, 127, 117, 132, 132, 132, 132, 125, 132, 132, 132, 146,
132, 132, 119, 119, 146, 132, 132, 132, 132, 146, 150, 146, 150, 133, 133, 150,
133, 150, 146, 133, 150, 133, 125, 140, 140, 140, 133, 140, 150, 140, 140, 146,
140, 146, 133, 140, 140, 140, 140, 140, 146, 140, 140, 140, 140, 140, 140, 140,
163, 140, 140, 140, 140, 140, 158, 158, 158, 158, 158, 181, 158, 181, 181, 158,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 82,  82,  86,  86,  86,  86,  86,  82,  86,  86,  86,  82,  82,  86,  82,  86,
 82,  86,  82,  82,  86,  82,  86,  82,  86,  82,  86,  86,  82,  86,  82,  82,
 82,  82,  82,  93,  82,  82,  82, 111,  82,  82,  82, 111,  82, 108,  82, 108,
103, 108, 103,  95, 103, 103, 103, 106, 108, 103, 106, 106, 106, 103, 106, 108,
106, 106,  95, 106, 106, 106, 106, 115, 115, 106, 106, 115, 106, 106, 114, 106,
127, 114, 119, 114, 106, 127, 128, 127, 127, 128, 127, 127, 129, 127, 127, 127,
118, 119, 119, 127, 127, 128, 127, 127, 127, 133, 127, 128, 128, 133, 128, 132,
133, 133, 132, 132, 146, 133, 133, 133, 133, 146, 133, 132, 133, 151, 151, 133,
151, 133, 150, 151, 133, 133, 143, 133, 133, 133, 163, 133, 133, 163, 133, 150,
163, 150, 163, 163, 163, 133, 140, 163, 150, 140, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 140, 163, 163, 163, 163, 163, 163, 163,
163, 163, 181, 163, 197, 163, 181, 197, 197, 197, 181, 197, 197, 197, 197, 197,
197, 181, 197, 181, 197, 181, 197, 181, 197, 197, 197, 181, 197, 197, 197, 197,
197, 197, 181, 197, 197, 197, 197, 211, 197, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  93, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 115, 103, 120,
115, 115, 106, 103, 103, 115, 115, 120, 120, 115, 115, 120, 115, 115, 120, 115,
120, 120, 119, 120, 118, 118, 127, 123, 123, 127, 123, 123, 123, 119, 123, 119,
119, 146, 119, 130, 132, 127, 132, 132, 132, 132, 132, 128, 132, 132, 132, 146,
132, 132, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 133, 133, 150,
133, 150, 146, 133, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 133, 150, 150, 150, 150, 150, 146, 150, 140, 150, 140, 150, 140, 150,
163, 150, 140, 140, 140, 140, 158, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 158, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103, 108, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 115, 103, 120,
115, 115, 106, 103, 103, 115, 115, 120, 120, 115, 115, 120, 115, 115, 115, 115,
120, 120, 119, 120, 118, 118, 127, 123, 123, 127, 123, 123, 127, 119, 123, 119,
119, 146, 119, 130, 132, 127, 132, 132, 132, 132, 132, 128, 132, 132, 132, 146,
132, 132, 137, 137, 146, 132, 132, 132, 132, 146, 150, 146, 150, 133, 133, 150,
151, 150, 146, 133, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 133, 150, 150, 150, 150, 150, 146, 150, 140, 150, 140, 150, 140, 150,
163, 150, 140, 140, 140, 140, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93,  82, 108, 108, 108, 103, 108,  82, 108,
108, 108, 108, 121, 108, 108, 103, 103, 108, 103, 103, 103, 103, 108, 106, 108,
103, 115, 121, 106, 106, 115, 115, 115, 115, 106, 115, 115, 115, 106, 115, 127,
115, 118, 119, 118, 127, 127, 128, 127, 127, 127, 127, 127, 127, 123, 127, 123,
119, 146, 119, 127, 127, 128, 132, 132, 132, 132, 132, 128, 127, 132, 151, 146,
132, 132, 132, 132, 146, 132, 133, 132, 132, 146, 132, 146, 150, 133, 151, 133,
151, 133, 150, 151, 133, 133, 125, 150, 150, 133, 151, 150, 150, 133, 150, 150,
133, 146, 163, 150, 150, 150, 150, 150, 150, 150, 163, 150, 163, 150, 140, 140,
163, 140, 163, 140, 163, 140, 140, 140, 158, 181, 181, 163, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 103, 108, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 108, 103, 120,
115, 115, 121, 103, 103, 115, 115, 120, 120, 115, 115, 120, 115, 115, 115, 115,
120, 120, 119, 120, 118, 123, 127, 123, 123, 127, 123, 123, 127, 123, 123, 119,
119, 146, 119, 130, 130, 127, 132, 132, 132, 132, 132, 128, 132, 132, 132, 146,
132, 132, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 133, 133, 150,
151, 150, 146, 133, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 150, 150, 150, 150, 146, 150, 150, 150, 140, 150, 150, 150,
163, 150, 140, 150, 150, 150, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 103,  93,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 115, 115, 103, 105,
115, 115, 106, 115, 103, 115, 115, 120, 120, 115, 115, 120, 120, 115, 120, 120,
120, 120, 105, 120, 120, 120, 127, 123, 123, 123, 123, 123, 123, 119, 123, 119,
119, 122, 119, 123, 132, 127, 137, 132, 132, 132, 137, 128, 132, 132, 132, 146,
132, 137, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 150, 132, 150,
151, 150, 146, 150, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 146,
150, 146, 150, 150, 150, 150, 150, 150, 146, 150, 150, 150, 150, 150, 150, 150,
163, 150, 161, 150, 150, 150, 181, 181, 158, 181, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,
 82,  93,  93,  93,  93,  93,  93,  93, 108,  93, 108, 108, 103, 108, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 103, 103, 103, 108, 103, 108,
115, 115, 121, 103, 106, 115, 115, 115, 120, 115, 115, 120, 115, 115, 115, 115,
115, 115, 119, 120, 127, 118, 129, 127, 127, 127, 127, 123, 127, 123, 127, 119,
119, 146, 119, 130, 130, 129, 132, 132, 132, 132, 132, 128, 130, 132, 130, 146,
132, 132, 132, 137, 146, 132, 132, 132, 132, 146, 150, 146, 150, 133, 151, 150,
151, 150, 146, 151, 150, 133, 125, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 150, 150, 150, 150, 146, 150, 150, 150, 163, 150, 150, 150,
163, 150, 163, 150, 161, 150, 161, 161, 158, 181, 181, 163, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  94,
 93,  93,  93, 121, 108, 108, 108, 103,  94, 108, 108, 115, 115, 120, 103,  94,
115, 120, 103, 115, 115, 115, 120, 120, 105, 115, 120, 105, 120, 115, 120, 120,
120, 120, 105, 119, 120, 120, 127, 120, 120, 123, 123, 120, 123, 119, 123, 119,
119, 122, 146, 123, 137, 130, 137, 137, 137, 137, 137, 151, 132, 137, 132, 146,
137, 137, 137, 146, 146, 137, 132, 137, 137, 146, 146, 146, 150, 150, 150, 150,
132, 150, 146, 150, 150, 150, 125, 150, 150, 150, 150, 150, 150, 150, 150, 146,
150, 146, 150, 150, 150, 150, 150, 150, 146, 150, 150, 150, 150, 171, 150, 150,
161, 171, 161, 171, 150, 171, 158, 181, 165, 181, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 103, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 108, 108, 108, 108, 103, 131,
115, 115, 121, 115, 115, 115, 115, 120, 120, 115, 115, 120, 115, 115, 120, 115,
120, 120, 131, 120, 120, 120, 127, 123, 123, 127, 123, 123, 123, 120, 123, 119,
119, 146, 119, 130, 130, 127, 137, 132, 132, 132, 137, 128, 132, 132, 132, 146,
132, 144, 137, 137, 146, 132, 132, 132, 132, 146, 137, 146, 150, 150, 151, 150,
151, 150, 146, 151, 150, 150, 125, 150, 150, 150, 151, 150, 150, 150, 150, 146,
150, 146, 151, 150, 150, 150, 150, 150, 146, 150, 150, 150, 161, 150, 161, 150,
163, 161, 161, 161, 161, 161, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 103,  94,
 93,  93,  93, 121,  93, 108, 108, 103,  94, 108, 108, 108, 120, 120, 103,  94,
120, 120, 103, 115, 115, 120, 120, 131, 131, 115, 120, 131, 120, 120, 120, 120,
120, 120, 131, 119, 120, 120, 123, 120, 120, 123, 120, 137, 123, 119, 137, 119,
119, 135, 122, 137, 137, 130, 137, 137, 137, 137, 137, 130, 132, 137, 132, 146,
137, 137, 137, 146, 146, 137, 132, 137, 137, 146, 146, 146, 137, 150, 150, 150,
150, 150, 146, 150, 150, 150, 151, 150, 150, 150, 150, 150, 146, 150, 150, 146,
150, 146, 150, 150, 150, 171, 171, 171, 165, 171, 150, 171, 161, 171, 171, 171,
161, 171, 171, 171, 171, 171, 171, 171, 165, 171, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,
 53,  86,  86,  86,  74,  86,  74,  86,  74,  86,  86,  86,  86,  86,  86,  74,
 74,  74,  86,  86,  74,  74,  74,  93,  74,  93,  74,  74,  93,  74,  93,  93,
 93,  93,  93,  74,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  94,
 93,  94,  94, 103,  93,  94,  93, 108,  94,  94, 120, 120,  94,  94, 115,  94,
120, 120, 103, 120, 120, 120, 120, 131, 102, 120, 120, 131, 120, 120, 120, 120,
120, 120, 122, 131, 120, 120, 123, 120, 120, 120, 137, 137, 137, 147, 137, 147,
122, 135, 122, 137, 137, 130, 137, 137, 137, 137, 137, 130, 137, 137, 137, 135,
137, 137, 146, 146, 135, 137, 137, 137, 137, 135, 146, 146, 146, 150, 150, 137,
150, 150, 146, 150, 150, 150, 151, 150, 171, 150, 150, 171, 146, 150, 171, 146,
171, 146, 150, 171, 171, 171, 171, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 171, 171, 181, 165, 181, 181, 165,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 220,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  74,  74,  53,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  94,  74,  94,
 94,  94,  94, 103,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94,  94, 135,
 94,  94, 120,  94, 120,  94,  94, 135, 135,  94,  94, 135,  94, 120, 135, 131,
135, 135, 135, 135, 122, 135, 120, 135, 135, 147, 135, 135, 147, 135, 135, 135,
135, 141, 135, 147, 135, 137, 135, 135, 135, 157, 135, 137, 147, 157, 147, 135,
157, 157, 135, 135, 141, 157, 147, 157, 157, 135, 135, 135, 157, 171, 171, 157,
171, 157, 164, 171, 157, 171, 171, 171, 171, 171, 171, 171, 164, 171, 171, 164,
171, 164, 171, 171, 171, 164, 164, 171, 164, 164, 171, 171, 171, 165, 171, 171,
171, 171, 171, 171, 171, 171, 165, 171, 165, 165, 165, 171, 165, 165, 165, 165,
165, 171, 165, 165, 165, 181, 165, 165, 165, 165, 165, 165, 181, 181, 181, 181,
181, 165, 181, 165, 181, 165, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  53,  53,  53,  74,  74,  74,  74,  74,
 86,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  86,  74,  74,  74,  74,
 74,  74,  74,  86,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 93,  74,  74,  74,  74,  93,  74,  74,  93,  93,  93,  93,  93,  94,  93,  94,
 94,  94,  94, 103,  94,  94,  94,  93,  94,  94,  94,  94,  94,  94, 120, 102,
 94,  94, 115, 120, 120, 120, 131, 131, 102, 120, 120, 131, 131, 120, 131, 120,
131, 131, 135, 131, 120, 131, 120, 137, 137, 137, 137, 147, 137, 147, 147, 135,
135, 135, 135, 137, 147, 137, 147, 147, 147, 147, 147, 130, 137, 147, 137, 135,
147, 147, 157, 157, 135, 147, 137, 147, 147, 135, 157, 157, 146, 137, 149, 154,
149, 154, 157, 150, 171, 171, 150, 171, 171, 171, 171, 171, 171, 171, 171, 165,
171, 164, 171, 171, 171, 171, 165, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 165, 171, 181, 165, 171, 171, 165,
171, 181, 165, 181, 181, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  53,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 103, 108, 108, 108, 108, 108, 108, 103, 108,
115, 115, 121, 115, 121, 115, 115, 120, 120, 115, 115, 120, 115, 115, 115, 115,
115, 120, 131, 120, 115, 123, 129, 130, 127, 127, 130, 130, 127, 123, 130, 137,
119, 146, 119, 130, 130, 129, 134, 134, 134, 134, 134, 128, 130, 134, 130, 146,
134, 134, 144, 137, 146, 132, 132, 132, 132, 146, 144, 146, 150, 151, 151, 150,
151, 150, 146, 151, 150, 150, 159, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 161, 150, 150, 161, 146, 150, 161, 161, 163, 161, 161, 161,
163, 161, 163, 161, 161, 161, 161, 161, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  53,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  82,  86,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 103, 131,
115, 115, 121, 115, 115, 115, 115, 120, 131, 115, 115, 120, 115, 115, 115, 115,
120, 120, 131, 120, 115, 123, 129, 123, 130, 127, 130, 123, 130, 123, 130, 137,
119, 146, 147, 130, 130, 129, 134, 134, 134, 134, 134, 138, 130, 134, 130, 146,
134, 144, 137, 137, 146, 134, 142, 132, 144, 146, 144, 146, 150, 151, 151, 150,
151, 150, 146, 151, 150, 150, 159, 150, 150, 150, 151, 150, 150, 150, 150, 150,
150, 146, 151, 150, 161, 150, 150, 161, 146, 150, 161, 161, 161, 161, 161, 161,
163, 161, 161, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 82,  86,  86,  86,  86,  86,  86,  82,  86,  86,  86,  82, 111,  86, 111,  86,
111,  86, 111,  82, 111, 111, 111, 111, 111, 111, 111, 111, 111,  93, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 108,
111, 111, 111, 121, 111, 111, 111, 121, 108, 111, 121, 121, 121, 108, 121, 108,
121, 121, 128, 121, 121, 121, 129, 115, 115, 121, 129, 115, 129, 128, 129, 129,
129, 129, 115, 129, 129, 129, 128, 129, 129, 129, 129, 129, 129, 129, 129, 127,
136, 119, 134, 129, 129, 128, 129, 129, 129, 129, 129, 143, 151, 151, 151, 144,
151, 151, 142, 142, 146, 151, 151, 151, 151, 146, 142, 156, 151, 151, 151, 151,
151, 151, 150, 151, 151, 151, 143, 151, 151, 151, 163, 151, 151, 163, 151, 150,
163, 150, 163, 163, 163, 163, 161, 163, 161, 163, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 197, 163, 163, 163, 197, 163, 197, 197,
197, 163, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 211, 197, 197, 197, 197, 211, 197, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  46,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 108, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 103, 131,
115, 115, 121, 115, 115, 115, 120, 131, 131, 115, 120, 131, 120, 115, 120, 120,
120, 120, 131, 131, 120, 120, 127, 120, 120, 130, 136, 137, 130, 137, 137, 137,
147, 135, 147, 134, 137, 130, 137, 137, 137, 144, 137, 138, 142, 144, 142, 146,
137, 137, 137, 147, 146, 144, 149, 149, 144, 146, 137, 146, 149, 149, 156, 149,
151, 150, 146, 156, 150, 150, 159, 150, 150, 150, 151, 150, 150, 161, 150, 146,
161, 146, 161, 161, 161, 161, 171, 161, 146, 171, 161, 161, 161, 171, 161, 161,
161, 161, 161, 161, 161, 171, 171, 171, 165, 171, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 111, 108, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 121, 131,
115, 115, 121, 115, 121, 115, 115, 120, 131, 115, 115, 131, 115, 115, 120, 115,
120, 120, 131, 120, 115, 120, 129, 136, 136, 130, 136, 136, 130, 136, 136, 137,
137, 146, 147, 136, 136, 129, 144, 134, 134, 142, 144, 138, 142, 142, 142, 146,
144, 144, 144, 137, 146, 142, 142, 148, 144, 146, 144, 146, 149, 156, 151, 156,
151, 156, 146, 151, 150, 156, 159, 150, 161, 161, 151, 161, 161, 161, 161, 150,
161, 146, 151, 161, 161, 161, 161, 161, 146, 161, 161, 161, 161, 161, 161, 161,
163, 161, 161, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 131,
115, 115, 121, 115, 115, 115, 115, 131, 131, 115, 115, 131, 120, 115, 120, 115,
120, 120, 131, 131, 120, 120, 129, 136, 136, 130, 136, 136, 136, 137, 136, 137,
147, 135, 147, 136, 136, 129, 137, 134, 144, 142, 144, 138, 142, 144, 142, 146,
144, 144, 137, 137, 146, 144, 148, 149, 149, 146, 137, 146, 149, 156, 156, 149,
151, 156, 146, 151, 150, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 146,
161, 146, 151, 161, 161, 161, 161, 161, 146, 161, 161, 161, 161, 161, 161, 161,
170, 161, 161, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93, 111,  93,  93, 111, 108, 108, 108, 111, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 121, 131,
115, 115, 121, 115, 121, 115, 115, 120, 131, 115, 115, 131, 115, 129, 115, 115,
120, 120, 131, 120, 115, 136, 129, 136, 136, 130, 136, 136, 136, 136, 136, 137,
137, 146, 147, 136, 136, 129, 144, 142, 142, 142, 144, 138, 142, 142, 142, 146,
144, 144, 144, 137, 146, 142, 142, 148, 148, 146, 144, 146, 149, 156, 151, 156,
151, 156, 146, 151, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 161,
161, 146, 151, 161, 161, 161, 161, 161, 146, 161, 161, 161, 170, 161, 161, 161,
163, 161, 178, 161, 161, 161, 161, 161, 171, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  53,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 108, 108, 108, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 108, 131,
115, 115, 121, 115, 115, 115, 115, 131, 131, 115, 120, 131, 120, 115, 120, 120,
120, 120, 131, 131, 120, 120, 129, 136, 136, 136, 136, 137, 136, 137, 136, 137,
147, 135, 147, 136, 136, 130, 137, 144, 144, 144, 137, 138, 142, 144, 142, 146,
144, 137, 137, 147, 146, 149, 148, 149, 149, 146, 154, 146, 149, 156, 156, 149,
151, 149, 146, 156, 150, 161, 159, 161, 161, 161, 151, 161, 161, 161, 161, 146,
161, 146, 161, 161, 161, 161, 161, 161, 146, 161, 161, 161, 161, 161, 161, 161,
170, 161, 161, 161, 161, 161, 171, 171, 171, 171, 181, 181, 181, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86, 111,
 82,  82, 111, 111,  86, 111, 111,  82, 111, 111, 111,  82, 111, 111, 111, 111,
111, 111, 111,  82, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111, 121, 111,
111, 111, 111,  95, 121, 121, 121, 121, 111, 121, 121, 121, 121, 121, 121, 111,
121, 121, 128, 121, 128, 121, 121, 129, 129, 128, 121, 129, 121, 128, 129, 128,
129, 129, 129, 129, 128, 128, 128, 128, 128, 128, 128, 129, 128, 129, 128, 129,
129, 136, 129, 128, 128, 143, 129, 128, 128, 128, 151, 143, 128, 151, 128, 142,
151, 151, 151, 151, 144, 151, 151, 151, 151, 156, 151, 151, 151, 163, 163, 151,
143, 151, 151, 163, 163, 163, 166, 163, 163, 163, 163, 163, 163, 163, 163, 163,
163, 161, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163,
163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 163, 197,
163, 163, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86,  86,
 86,  86,  86, 111,  86, 111,  86, 111,  86, 111, 111,  93, 111,  93, 111, 111,
111, 111, 111,  93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 108,
111, 108, 108, 121, 111, 108, 111, 121, 108, 108, 108, 108, 108, 108, 121, 108,
121, 108, 121, 121, 121, 129, 115, 115, 115, 121, 129, 115, 115, 129, 115, 129,
129, 115, 131, 115, 129, 129, 138, 129, 129, 129, 129, 136, 129, 136, 136, 136,
136, 131, 137, 129, 136, 138, 142, 142, 142, 142, 142, 128, 151, 142, 151, 146,
142, 142, 144, 144, 146, 142, 151, 142, 142, 146, 156, 144, 156, 151, 151, 156,
151, 151, 150, 151, 151, 151, 159, 151, 161, 151, 151, 161, 161, 151, 161, 161,
151, 146, 163, 161, 161, 161, 161, 161, 161, 161, 163, 161, 163, 161, 163, 161,
163, 178, 163, 178, 163, 178, 178, 178, 183, 178, 178, 163, 178, 197, 197, 197,
197, 197, 181, 197, 197, 197, 181, 197, 197, 197, 181, 197, 197, 197, 197, 197,
197, 181, 197, 181, 197, 181, 197, 181, 197, 197, 197, 211, 197, 197, 197, 211,
211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  86,  93,  93,  93,  93,  93,  93,  93, 111,
111,  93,  93,  93,  93, 111,  93,  93, 111, 108, 111, 108, 111, 108, 111, 108,
108, 108, 108, 121, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 115, 121, 115, 115, 131, 131, 129, 115, 131, 115, 129, 115, 115,
120, 120, 131, 131, 136, 136, 129, 136, 136, 136, 136, 136, 136, 136, 136, 137,
147, 131, 147, 136, 136, 138, 144, 142, 142, 142, 144, 138, 142, 142, 142, 154,
145, 144, 144, 144, 146, 148, 148, 148, 148, 146, 149, 154, 149, 156, 151, 156,
151, 156, 154, 151, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 146, 161, 161, 161, 170, 161, 161, 161,
163, 161, 178, 161, 178, 161, 178, 178, 171, 178, 178, 178, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  46,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86,  86,
 86,  86, 111, 111, 111, 111, 111, 111,  86, 111, 111, 111, 111,  93, 111, 111,
111, 111, 111,  93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 108,
111, 111, 111, 121, 111, 111, 111, 121, 108, 108, 111, 121, 108, 108, 121, 108,
121, 108, 121, 121, 121, 129, 129, 115, 108, 121, 129, 115, 129, 129, 129, 129,
129, 129, 131, 115, 129, 129, 138, 129, 129, 129, 129, 129, 129, 136, 129, 136,
136, 131, 137, 129, 129, 138, 136, 142, 142, 142, 142, 128, 151, 142, 151, 144,
142, 142, 142, 144, 146, 151, 151, 151, 152, 146, 156, 144, 156, 151, 151, 151,
159, 151, 156, 151, 151, 151, 172, 151, 151, 151, 159, 151, 161, 151, 151, 161,
151, 146, 163, 161, 170, 161, 161, 161, 161, 161, 163, 161, 163, 161, 163, 178,
163, 178, 163, 178, 163, 178, 178, 178, 183, 178, 197, 163, 197, 197, 197, 197,
197, 197, 181, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 181, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 211,
197, 211, 211, 197, 197, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  53,  53,  53,  74,  86,  86,  86,  86,
 86,  86,  74,  86,  74,  86,  74,  86,  74,  86,  74,  86,  86,  86,  74,  74,
 74,  74,  93,  93,  74,  93,  74,  93, 124,  93,  93, 124,  93, 124,  93,  93,
 93, 124,  93, 124, 124,  93,  93, 124,  93, 124, 124, 124,  93, 124,  93, 124,
124, 124, 124, 103, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 124,
124, 124, 139, 139, 139, 124, 124, 124, 124, 139, 131, 131, 131, 139, 131, 131,
131, 131, 135, 131, 131, 131, 145, 147, 147, 137, 147, 147, 147, 147, 147, 135,
135, 141, 135, 147, 147, 145, 147, 147, 147, 147, 147, 145, 137, 147, 137, 135,
147, 147, 157, 157, 135, 147, 147, 147, 147, 135, 157, 157, 157, 149, 149, 154,
149, 154, 157, 171, 171, 171, 161, 171, 171, 171, 171, 171, 171, 171, 171, 164,
171, 164, 171, 171, 171, 171, 171, 171, 164, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 165, 171, 171, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 211, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 111, 108, 108, 108, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 115, 121, 115, 115, 131, 131, 115, 115, 131, 120, 129, 120, 115,
120, 120, 131, 131, 136, 136, 129, 136, 136, 136, 136, 136, 136, 137, 136, 137,
147, 135, 147, 136, 136, 138, 144, 145, 145, 145, 144, 138, 142, 145, 142, 154,
145, 144, 147, 147, 146, 149, 148, 149, 149, 146, 154, 154, 149, 156, 156, 156,
151, 156, 154, 156, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 146, 161, 161, 161, 170, 161, 161, 161,
170, 161, 178, 161, 178, 161, 178, 178, 171, 171, 178, 178, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 181, 181, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93,
111,  93,  93,  93,  93,  93,  93,  93, 111,  93, 108, 108, 108, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 108, 124, 108, 108, 108, 108, 108, 108, 131,
108, 108, 121, 115, 115, 115, 115, 131, 131, 115, 115, 131, 120, 115, 120, 120,
120, 131, 131, 131, 136, 136, 129, 136, 136, 136, 136, 136, 136, 137, 136, 147,
147, 135, 147, 136, 136, 129, 137, 145, 145, 145, 144, 138, 145, 145, 148, 154,
145, 144, 147, 147, 146, 149, 148, 149, 149, 146, 154, 154, 149, 156, 156, 149,
151, 149, 154, 156, 156, 156, 159, 161, 161, 161, 151, 161, 161, 161, 161, 146,
161, 146, 170, 161, 161, 161, 161, 161, 146, 161, 161, 161, 178, 161, 161, 161,
170, 161, 178, 161, 161, 161, 171, 171, 171, 171, 171, 181, 171, 181, 181, 181,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211, 181, 181, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124,  93,  93,
 93,  93,  93, 124,  93,  93,  93,  93,  93,  93,  93,  93, 108,  93, 108, 124,
108, 124, 108, 121, 108, 108, 108, 108, 124, 124, 108, 108, 124, 124, 108, 124,
108, 124, 121, 115, 115, 120, 131, 131, 131, 115, 120, 131, 131, 120, 131, 120,
131, 131, 131, 131, 120, 120, 136, 137, 137, 136, 137, 137, 136, 147, 137, 147,
147, 135, 147, 137, 137, 136, 147, 137, 137, 145, 147, 138, 145, 145, 145, 157,
137, 147, 147, 147, 157, 149, 149, 149, 149, 157, 154, 154, 154, 149, 149, 149,
156, 149, 154, 156, 149, 161, 159, 161, 161, 161, 161, 161, 171, 161, 161, 146,
161, 146, 161, 171, 161, 171, 171, 171, 171, 171, 161, 171, 161, 171, 171, 171,
178, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 181, 171, 181, 171, 171,
181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124,  93,  93,
 93,  93,  93, 124,  93,  93,  93,  93,  93,  93,  93,  93,  93,  93, 108, 124,
108, 124, 124, 121, 124, 124, 124, 108, 124, 124, 108, 108, 124, 124, 108, 124,
139, 124, 121, 139, 139, 139, 131, 131, 131, 139, 131, 131, 131, 120, 131, 120,
131, 131, 131, 131, 120, 131, 136, 137, 137, 136, 137, 147, 137, 147, 137, 147,
131, 135, 135, 137, 137, 145, 147, 137, 147, 137, 147, 138, 145, 137, 145, 157,
147, 147, 147, 154, 135, 149, 149, 149, 147, 157, 154, 157, 154, 149, 149, 149,
156, 149, 154, 149, 149, 161, 159, 161, 161, 161, 161, 171, 171, 161, 171, 171,
171, 146, 161, 171, 171, 171, 171, 171, 171, 171, 171, 171, 161, 171, 171, 171,
178, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 181, 171, 171, 171, 171,
171, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,
 74,  74,  74,  93,  74,  74,  74,  74, 124,  74,  74, 124,  74, 124,  74,  74,
 93, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124,
124, 124, 124, 139, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 135,
124, 124, 139, 124, 139, 124, 124, 135, 135, 139, 124, 135, 124, 139, 131, 131,
131, 135, 135, 135, 131, 131, 139, 147, 147, 147, 147, 135, 147, 135, 135, 135,
135, 141, 135, 147, 147, 137, 157, 157, 157, 157, 157, 145, 147, 157, 147, 135,
157, 157, 157, 157, 141, 157, 147, 157, 157, 135, 157, 164, 157, 171, 171, 157,
171, 157, 164, 171, 157, 171, 171, 171, 171, 171, 171, 171, 164, 171, 171, 164,
171, 164, 171, 171, 171, 171, 164, 171, 164, 164, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 164, 171, 171, 171, 165, 171, 171, 165,
171, 171, 165, 171, 171, 171, 165, 171, 171, 171, 165, 165, 181, 181, 181, 181,
181, 165, 181, 165, 181, 165, 181, 165, 181, 181, 181, 165, 181, 181, 181, 181,
181, 181, 211, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  53,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93,  93,  93,  93,  93,  93,  93,  93, 111, 111,
111,  93,  93,  93,  93, 111, 111,  93, 111, 111, 111, 108, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 111, 124, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 121, 121, 115, 115, 131, 131, 129, 115, 131, 115, 129, 120, 136,
136, 120, 131, 131, 136, 136, 138, 136, 136, 136, 136, 136, 136, 136, 136, 137,
131, 131, 147, 136, 136, 138, 145, 145, 145, 145, 145, 138, 142, 148, 148, 154,
145, 145, 153, 153, 146, 148, 148, 152, 152, 146, 149, 154, 156, 156, 151, 156,
159, 156, 154, 151, 156, 156, 159, 161, 161, 161, 159, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 179, 161, 178, 161, 170, 161, 178, 161,
170, 178, 178, 178, 178, 178, 178, 178, 171, 183, 178, 178, 183, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 197, 181,
181, 181, 181, 181, 197, 181, 181, 211, 181, 181, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86,  86,  86,
111,  86, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111, 111,  93, 111, 111,
111, 111, 111,  93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 108,
111, 108, 111, 121, 111, 111, 111, 121, 108, 108, 111, 111, 108, 108, 121, 131,
121, 108, 121, 121, 121, 129, 115, 108, 131, 121, 129, 131, 129, 129, 129, 129,
129, 136, 131, 136, 129, 129, 138, 136, 136, 129, 136, 136, 129, 136, 136, 136,
136, 131, 147, 136, 136, 138, 136, 136, 136, 142, 148, 138, 151, 148, 151, 154,
148, 148, 152, 153, 146, 152, 151, 152, 152, 154, 152, 154, 156, 151, 151, 156,
159, 156, 156, 151, 156, 151, 172, 156, 156, 170, 159, 161, 161, 170, 161, 161,
170, 146, 170, 161, 178, 161, 161, 178, 161, 161, 170, 178, 170, 178, 178, 178,
163, 178, 170, 178, 178, 178, 178, 178, 183, 178, 178, 197, 183, 197, 197, 183,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 181, 197, 197, 197, 197, 197,
197, 211, 197, 211, 197, 211, 197, 211, 211, 197, 197, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  86,  93, 111,  93,  93,  93,  93, 111,  93, 111, 111,
111,  93, 111,  93, 111, 111, 111,  93, 111, 111, 111, 111, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 111, 124, 108, 108, 108, 108, 108, 121, 131,
108, 108, 121, 121, 121, 115, 115, 131, 131, 121, 115, 131, 115, 129, 115, 136,
136, 136, 131, 131, 136, 136, 138, 136, 136, 136, 136, 136, 136, 136, 136, 153,
131, 131, 131, 136, 136, 138, 145, 145, 145, 148, 145, 138, 148, 148, 148, 154,
148, 148, 153, 153, 146, 152, 152, 152, 152, 154, 153, 154, 156, 156, 151, 156,
159, 156, 154, 151, 156, 156, 159, 161, 161, 161, 159, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 179, 161, 178, 178, 170, 178, 178, 178,
170, 178, 178, 178, 178, 178, 178, 178, 183, 183, 178, 178, 183, 178, 183, 183,
178, 197, 200, 181, 181, 197, 181, 181, 181, 181, 181, 181, 181, 181, 197, 197,
181, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  86,  93,  93,  93,  93,  93,  93,  93,  93,  93, 111, 111,
111,  93,  93,  93,  93, 111, 111,  93, 111, 111, 111, 108, 111, 108, 111, 124,
108, 108, 108, 121, 108, 108, 108, 111, 124, 108, 108, 108, 108, 108, 121, 124,
108, 108, 121, 121, 121, 115, 115, 131, 131, 129, 115, 131, 115, 129, 120, 136,
136, 131, 131, 131, 136, 136, 138, 136, 136, 136, 136, 136, 136, 136, 136, 147,
131, 131, 131, 136, 136, 138, 153, 145, 145, 145, 145, 138, 148, 145, 148, 154,
145, 145, 153, 147, 157, 148, 152, 152, 152, 154, 153, 154, 149, 156, 156, 156,
159, 156, 154, 156, 156, 156, 159, 161, 161, 161, 170, 161, 161, 161, 161, 161,
161, 146, 170, 161, 161, 161, 161, 161, 179, 161, 178, 161, 170, 161, 178, 178,
170, 178, 178, 178, 178, 178, 178, 178, 171, 183, 178, 178, 183, 178, 183, 181,
181, 181, 171, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 197, 181,
181, 211, 181, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  74,  53,  53,  86,  86,  86,  74,  86,  86,  86,  86,
 86,  86,  74,  86,  74,  86,  74,  86,  74,  74,  74,  86,  86,  74,  74,  74,
 74, 124,  93,  93, 124,  93, 124,  93, 124, 124, 124, 124, 124, 124, 124, 124,
 93, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 124,
124, 124, 124, 139, 124, 124, 124, 139, 124, 124, 124, 124, 124, 124, 139, 124,
124, 124, 139, 139, 139, 124, 124, 124, 124, 139, 124, 124, 131, 139, 131, 131,
131, 131, 135, 131, 131, 131, 139, 147, 147, 147, 147, 147, 147, 135, 147, 135,
135, 141, 135, 147, 147, 145, 157, 147, 147, 147, 157, 145, 147, 147, 147, 135,
157, 157, 157, 157, 141, 147, 147, 154, 157, 135, 157, 157, 157, 171, 171, 157,
149, 157, 157, 171, 171, 171, 162, 171, 171, 171, 171, 171, 157, 171, 171, 164,
171, 164, 171, 171, 171, 171, 164, 171, 164, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 165, 171, 171, 171, 171, 171, 171, 171,
171, 171, 165, 171, 171, 181, 165, 171, 171, 171, 165, 181, 181, 181, 181, 181,
181, 165, 181, 181, 181, 181, 181, 165, 181, 181, 181, 181, 181, 181, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124,  93,  93,
 93,  93,  93, 124,  93,  93,  93,  93,  93,  93,  93,  93, 108, 124, 111, 124,
124, 124, 124, 121, 124, 124, 124, 139, 124, 124, 139, 139, 139, 124, 139, 124,
139, 139, 121, 139, 139, 139, 139, 131, 131, 139, 139, 131, 131, 139, 131, 139,
131, 131, 131, 131, 139, 131, 136, 153, 136, 136, 153, 147, 136, 147, 153, 147,
131, 135, 157, 153, 153, 145, 147, 153, 153, 153, 147, 138, 145, 153, 145, 157,
153, 147, 147, 154, 157, 153, 149, 153, 153, 157, 154, 154, 154, 149, 156, 149,
156, 149, 154, 156, 149, 160, 159, 161, 161, 161, 170, 161, 171, 161, 161, 179,
161, 157, 177, 171, 171, 171, 171, 171, 171, 171, 177, 171, 177, 171, 171, 171,
178, 171, 177, 171, 171, 171, 171, 171, 171, 171, 171, 178, 171, 171, 171, 171,
171, 181, 165, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,
 93, 124,  93,  93,  93,  93, 124,  93, 124,  93,  93, 124,  93, 124,  93,  93,
 93, 124, 124, 124, 124,  93, 124, 124,  93, 124, 124, 124, 139, 124, 139, 124,
124, 124, 124, 121, 124, 124, 124, 139, 124, 124, 139, 139, 124, 124, 139, 124,
139, 124, 139, 139, 139, 139, 124, 124, 124, 139, 139, 131, 131, 139, 131, 139,
131, 131, 131, 131, 139, 131, 139, 131, 147, 139, 147, 147, 147, 131, 147, 147,
157, 135, 135, 147, 147, 145, 147, 147, 147, 147, 147, 138, 153, 147, 153, 157,
147, 147, 154, 157, 135, 147, 153, 147, 154, 157, 157, 157, 154, 149, 149, 154,
149, 154, 157, 149, 154, 171, 170, 171, 171, 171, 161, 171, 171, 171, 171, 157,
171, 164, 171, 171, 171, 171, 171, 171, 164, 171, 171, 171, 171, 171, 171, 171,
171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171,
171, 171, 165, 171, 171, 181, 171, 181, 181, 181, 200, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 211, 181, 181, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86, 111,  93,  93,  93,  93,  93,  93,  93,  93,  93, 124, 111, 111,
111,  93,  93, 124,  93, 111, 111,  93, 111, 111, 111, 108, 111, 108, 111, 124,
108, 124, 108, 121, 108, 108, 108, 111, 124, 139, 139, 139, 139, 124, 139, 124,
139, 139, 138, 139, 139, 139, 139, 131, 131, 139, 139, 131, 139, 139, 139, 139,
139, 131, 131, 131, 139, 139, 138, 155, 155, 136, 155, 155, 155, 153, 155, 131,
131, 135, 131, 155, 155, 138, 153, 153, 153, 153, 153, 138, 148, 153, 148, 154,
153, 153, 153, 154, 157, 153, 152, 153, 153, 157, 154, 154, 153, 162, 162, 160,
159, 160, 154, 162, 160, 162, 159, 160, 168, 173, 170, 173, 179, 173, 173, 179,
177, 179, 170, 177, 177, 177, 179, 177, 179, 179, 178, 177, 178, 177, 177, 177,
170, 177, 178, 177, 178, 177, 183, 183, 171, 183, 183, 178, 200, 183, 183, 200,
183, 183, 200, 200, 181, 181, 200, 181, 181, 181, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
111,  86,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 121, 108, 111, 111, 111, 111, 111, 121, 131,
121, 111, 121, 121, 121, 121, 129, 131, 131, 121, 129, 131, 129, 138, 129, 129,
129, 136, 131, 136, 129, 129, 138, 129, 129, 129, 129, 136, 129, 155, 136, 155,
153, 131, 131, 136, 155, 138, 155, 155, 155, 152, 155, 138, 159, 152, 159, 154,
152, 152, 152, 153, 154, 152, 159, 152, 152, 154, 160, 153, 160, 159, 159, 162,
159, 162, 160, 159, 162, 170, 172, 170, 170, 170, 159, 170, 173, 170, 170, 168,
170, 179, 170, 178, 170, 178, 178, 178, 179, 178, 170, 178, 170, 178, 178, 178,
163, 178, 170, 178, 178, 178, 178, 178, 183, 178, 178, 197, 183, 197, 197, 197,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 211, 197, 211, 197, 211, 211, 197, 197, 211, 211, 211, 197, 211,
211, 211, 211, 220, 220, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 121, 108,
121, 121, 121, 121, 121, 121, 129, 108, 131, 121, 129, 131, 129, 138, 129, 129,
129, 129, 131, 136, 129, 129, 138, 129, 129, 129, 129, 129, 129, 136, 129, 155,
155, 131, 153, 129, 129, 138, 155, 152, 152, 152, 152, 138, 159, 152, 159, 153,
152, 152, 152, 152, 154, 152, 159, 152, 152, 154, 160, 160, 160, 159, 159, 162,
159, 170, 160, 159, 170, 159, 172, 170, 170, 170, 159, 170, 178, 170, 170, 168,
170, 179, 172, 170, 170, 178, 178, 170, 183, 178, 170, 170, 163, 178, 170, 178,
163, 178, 163, 178, 170, 178, 178, 178, 183, 178, 197, 197, 197, 197, 197, 197,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 211,
211, 211, 211, 197, 220, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86,  86,
 86,  86, 111, 111, 111, 111,  93, 111,  93, 111, 111,  93, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 108, 108, 121, 111, 108, 111, 111, 124, 108, 108, 108, 108, 139, 121, 124,
139, 139, 138, 121, 121, 139, 139, 131, 131, 121, 139, 131, 139, 129, 139, 136,
139, 139, 131, 131, 136, 136, 138, 155, 155, 136, 155, 155, 136, 155, 155, 153,
131, 131, 131, 155, 155, 138, 153, 155, 155, 155, 153, 138, 148, 152, 152, 154,
153, 153, 153, 153, 157, 152, 152, 152, 160, 154, 153, 154, 160, 162, 162, 160,
159, 160, 154, 170, 160, 162, 159, 162, 162, 162, 170, 173, 161, 170, 173, 179,
173, 179, 170, 177, 178, 177, 177, 178, 179, 177, 178, 178, 170, 183, 178, 178,
170, 178, 178, 178, 178, 178, 183, 178, 183, 183, 183, 178, 183, 183, 183, 183,
183, 197, 200, 183, 197, 197, 211, 197, 211, 197, 211, 211, 211, 211, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 121, 121, 111, 111, 121, 111,
121, 121, 121, 121, 121, 121, 121, 129, 111, 121, 121, 129, 129, 138, 129, 129,
129, 129, 131, 129, 129, 129, 138, 129, 129, 138, 129, 129, 129, 129, 129, 155,
155, 131, 155, 129, 129, 138, 129, 129, 129, 159, 167, 143, 159, 159, 159, 153,
151, 167, 152, 152, 154, 159, 159, 159, 151, 153, 160, 160, 151, 159, 159, 159,
172, 159, 160, 159, 159, 159, 172, 170, 170, 170, 172, 170, 170, 159, 170, 178,
170, 183, 172, 170, 170, 170, 178, 170, 183, 178, 163, 170, 163, 170, 163, 170,
163, 170, 163, 163, 163, 197, 197, 197, 183, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 211, 197, 197, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 108, 111, 121, 111, 111, 111, 111, 124, 108, 111, 111, 139, 139, 121, 124,
139, 139, 138, 121, 121, 139, 139, 131, 131, 121, 139, 131, 139, 138, 139, 139,
139, 139, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 153,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 153, 138, 152, 155, 152, 154,
152, 153, 153, 153, 154, 152, 152, 160, 160, 154, 153, 154, 160, 162, 170, 160,
159, 162, 154, 170, 162, 162, 159, 162, 168, 162, 170, 173, 173, 170, 173, 179,
173, 179, 170, 178, 178, 177, 177, 178, 179, 183, 178, 178, 170, 183, 178, 178,
170, 178, 178, 178, 178, 178, 183, 178, 183, 183, 183, 178, 183, 183, 183, 183,
183, 197, 200, 183, 197, 197, 211, 197, 197, 197, 211, 211, 211, 197, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 220, 220, 211, 211, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  93,
 93, 124,  93, 111,  93,  93, 124,  93, 124,  93, 124, 124,  93, 124,  93,  93,
 93, 124, 124, 124, 124,  93, 124, 124, 139, 124, 124, 124, 139, 124, 139, 124,
124, 124, 124, 121, 124, 124, 139, 139, 124, 124, 139, 139, 139, 124, 139, 124,
139, 139, 139, 139, 139, 139, 139, 124, 124, 139, 139, 131, 139, 139, 139, 139,
139, 131, 131, 131, 139, 139, 139, 139, 139, 139, 139, 131, 139, 131, 147, 131,
131, 135, 157, 153, 153, 155, 147, 153, 147, 153, 147, 138, 153, 153, 153, 157,
147, 147, 154, 157, 157, 153, 153, 153, 153, 157, 154, 157, 154, 162, 162, 153,
162, 153, 157, 162, 154, 168, 170, 171, 171, 171, 173, 171, 179, 177, 171, 184,
171, 164, 177, 171, 171, 171, 171, 171, 184, 171, 171, 171, 177, 171, 171, 171,
177, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 171, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 181, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 121, 108,
121, 111, 138, 121, 121, 121, 121, 139, 131, 121, 129, 131, 129, 138, 129, 129,
129, 129, 131, 155, 129, 129, 138, 129, 129, 138, 129, 155, 129, 155, 155, 155,
155, 131, 153, 129, 155, 138, 155, 155, 155, 167, 155, 138, 159, 167, 159, 153,
152, 155, 155, 155, 154, 167, 159, 167, 162, 154, 160, 160, 162, 159, 159, 170,
159, 170, 160, 159, 170, 170, 172, 170, 170, 170, 172, 170, 173, 170, 170, 168,
170, 179, 172, 170, 170, 178, 178, 170, 183, 178, 170, 170, 170, 178, 170, 178,
172, 178, 170, 178, 170, 178, 178, 178, 183, 178, 197, 197, 197, 197, 197, 197,
197, 197, 183, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 111, 111, 121, 111, 111, 111, 111, 124, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 121, 139, 139, 131, 131, 138, 139, 131, 139, 138, 139, 139,
139, 139, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 153, 153, 153, 154, 160, 162, 160, 160, 154, 153, 154, 160, 162, 170, 162,
159, 162, 154, 170, 162, 162, 159, 168, 168, 173, 170, 173, 173, 170, 173, 179,
173, 179, 170, 177, 178, 177, 179, 178, 179, 183, 178, 178, 170, 183, 178, 178,
170, 178, 178, 178, 178, 183, 183, 183, 183, 183, 183, 191, 183, 183, 183, 183,
183, 197, 200, 183, 183, 197, 211, 197, 211, 211, 211, 211, 211, 211, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 211, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 124,
111, 111, 138, 121, 121, 121, 139, 139, 131, 138, 129, 131, 139, 138, 139, 129,
155, 155, 131, 155, 129, 155, 138, 155, 155, 138, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 159, 155, 159, 154,
155, 155, 155, 153, 154, 162, 162, 162, 162, 154, 160, 153, 162, 170, 159, 162,
159, 162, 168, 159, 162, 170, 172, 175, 175, 170, 159, 175, 173, 170, 170, 168,
170, 179, 170, 178, 170, 178, 183, 178, 179, 183, 170, 178, 170, 178, 178, 178,
170, 178, 170, 178, 178, 178, 178, 178, 183, 183, 183, 197, 183, 197, 183, 183,
197, 197, 200, 197, 197, 197, 197, 197, 197, 197, 211, 197, 197, 197, 197, 197,
197, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111, 121, 111,
111, 111, 111, 121, 111, 111, 121, 121, 111, 121, 121, 121, 121, 121, 121, 111,
121, 121, 143, 121, 121, 121, 121, 121, 111, 121, 121, 129, 121, 138, 121, 138,
129, 129, 129, 129, 138, 138, 143, 138, 138, 138, 138, 129, 138, 167, 167, 167,
167, 155, 167, 138, 167, 143, 167, 167, 167, 167, 167, 166, 172, 159, 172, 167,
167, 167, 167, 167, 167, 159, 172, 172, 159, 167, 167, 167, 167, 172, 172, 172,
172, 172, 167, 172, 172, 172, 166, 172, 172, 172, 172, 172, 163, 172, 172, 170,
172, 175, 172, 172, 172, 163, 163, 163, 170, 163, 172, 163, 172, 163, 163, 163,
195, 163, 195, 163, 163, 163, 163, 163, 197, 197, 197, 195, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 111, 121, 111, 139, 139, 111, 124, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 131, 139, 139, 139, 139,
139, 139, 131, 131, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 155, 153, 153, 157, 155, 162, 162, 162, 154, 153, 154, 168, 162, 170, 162,
159, 162, 179, 170, 168, 175, 172, 168, 168, 174, 170, 173, 173, 175, 173, 179,
173, 179, 170, 177, 177, 177, 179, 177, 179, 183, 178, 178, 170, 183, 178, 183,
170, 183, 191, 183, 178, 183, 183, 183, 200, 183, 183, 191, 183, 183, 183, 200,
183, 191, 200, 200, 200, 197, 200, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111,  86,
111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 139, 121, 139, 139, 139, 111, 124, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 131, 139, 139, 139, 139,
139, 139, 131, 131, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 155, 153, 153, 157, 155, 162, 162, 162, 154, 153, 154, 168, 162, 175, 162,
159, 162, 179, 170, 168, 174, 172, 168, 168, 174, 170, 173, 173, 175, 173, 179,
173, 184, 170, 177, 177, 177, 179, 177, 179, 183, 178, 177, 191, 183, 178, 183,
191, 183, 191, 183, 178, 183, 183, 183, 200, 183, 183, 191, 200, 183, 183, 200,
183, 191, 200, 200, 200, 197, 200, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 220, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 111, 111, 121, 111, 111, 111, 111, 124, 139, 111, 139, 139, 139, 121, 124,
139, 139, 138, 121, 138, 139, 139, 139, 131, 138, 139, 139, 139, 138, 139, 139,
139, 139, 131, 139, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 167, 154,
155, 155, 155, 153, 154, 155, 162, 162, 162, 154, 153, 153, 168, 175, 170, 162,
159, 162, 179, 170, 174, 175, 172, 174, 174, 175, 170, 174, 173, 170, 175, 179,
175, 179, 170, 178, 178, 183, 183, 178, 179, 183, 170, 178, 170, 183, 178, 183,
198, 183, 191, 183, 191, 183, 183, 183, 183, 183, 183, 191, 183, 183, 183, 183,
183, 197, 200, 197, 197, 197, 211, 197, 197, 197, 211, 211, 211, 197, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86, 111, 111,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 121, 111,
121, 121, 138, 121, 138, 121, 121, 111, 111, 138, 121, 155, 129, 138, 129, 138,
129, 129, 131, 155, 138, 129, 138, 167, 138, 138, 167, 167, 138, 167, 167, 155,
155, 131, 155, 167, 167, 138, 167, 167, 167, 167, 167, 143, 159, 167, 159, 155,
167, 167, 167, 167, 153, 167, 159, 167, 167, 153, 167, 168, 167, 159, 172, 167,
172, 167, 168, 172, 167, 159, 172, 170, 170, 170, 172, 170, 175, 172, 170, 180,
170, 183, 172, 170, 170, 170, 178, 170, 183, 178, 172, 170, 172, 170, 170, 170,
195, 191, 195, 191, 198, 191, 197, 197, 183, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 197, 197,
197, 220, 211, 197, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111,  86,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 139, 121, 139, 139, 139, 111, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 155, 154,
155, 155, 153, 153, 157, 155, 162, 162, 162, 154, 153, 154, 168, 175, 175, 162,
170, 174, 179, 175, 174, 175, 172, 174, 174, 174, 170, 173, 186, 175, 173, 179,
173, 184, 170, 177, 177, 177, 186, 177, 179, 183, 191, 183, 191, 183, 178, 183,
191, 183, 191, 183, 191, 183, 183, 183, 200, 183, 183, 191, 200, 183, 183, 200,
183, 191, 200, 200, 200, 197, 200, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111,  93,
111, 124, 111, 111, 111, 111, 124, 111, 124, 111, 124, 124, 111, 124, 111, 111,
111, 124, 111, 124, 124, 111, 139, 124, 111, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 121, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 124, 139, 139, 131, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 155, 155, 155, 155, 155, 155, 155, 155, 155, 153,
131, 157, 131, 155, 155, 155, 155, 155, 155, 155, 153, 138, 155, 155, 155, 157,
153, 153, 153, 154, 157, 155, 155, 153, 153, 157, 153, 184, 168, 174, 174, 168,
175, 168, 184, 174, 168, 174, 188, 168, 168, 173, 175, 186, 179, 173, 186, 179,
173, 184, 175, 186, 177, 186, 179, 186, 184, 179, 177, 177, 191, 189, 177, 186,
191, 183, 191, 183, 183, 183, 200, 200, 200, 200, 200, 191, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 200, 211, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 111, 139, 111, 111, 111, 111, 139, 121, 139,
139, 139, 138, 121, 138, 139, 139, 139, 139, 138, 139, 139, 139, 138, 139, 155,
155, 155, 131, 155, 155, 155, 138, 155, 155, 138, 155, 155, 155, 155, 155, 155,
155, 131, 155, 155, 155, 138, 155, 155, 155, 155, 155, 138, 167, 167, 167, 153,
155, 155, 155, 155, 154, 167, 167, 167, 167, 154, 168, 168, 174, 167, 167, 175,
159, 175, 168, 170, 175, 175, 172, 175, 175, 175, 188, 175, 180, 170, 175, 182,
175, 179, 188, 175, 175, 182, 182, 191, 179, 183, 170, 191, 170, 183, 191, 191,
188, 191, 191, 191, 191, 191, 191, 191, 183, 183, 191, 198, 183, 191, 191, 183,
197, 197, 200, 197, 197, 197, 211, 197, 197, 197, 211, 211, 197, 197, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 139, 121, 139, 139, 139, 111, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 138, 139, 139, 139, 131, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 167, 154,
155, 155, 155, 153, 157, 155, 162, 162, 162, 154, 153, 179, 168, 175, 175, 174,
170, 174, 179, 175, 174, 175, 172, 174, 174, 175, 170, 174, 186, 175, 174, 179,
175, 184, 170, 182, 182, 182, 186, 182, 179, 183, 191, 183, 191, 183, 191, 183,
191, 183, 191, 183, 191, 183, 183, 183, 200, 183, 183, 191, 200, 183, 183, 200,
183, 191, 200, 200, 200, 197, 211, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 220, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  93, 124,
 93, 124,  93, 111, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 139,
139, 124, 124, 124, 124, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 124,
139, 124, 139, 121, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 139, 139, 139, 139, 124, 124, 139, 139, 124, 139, 139, 139, 139,
139, 139, 131, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 131,
131, 135, 157, 155, 155, 155, 153, 153, 153, 153, 153, 138, 155, 153, 155, 157,
153, 153, 154, 154, 157, 153, 153, 153, 153, 157, 154, 157, 179, 174, 174, 153,
174, 168, 184, 174, 186, 168, 170, 186, 186, 186, 174, 186, 179, 186, 186, 184,
186, 187, 177, 186, 186, 179, 179, 189, 184, 179, 177, 189, 177, 189, 186, 189,
191, 189, 177, 189, 189, 189, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 211, 211,
211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 220, 220, 220, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 139, 111, 121, 111, 139, 111, 111, 139, 139, 139, 139, 139, 139, 121, 124,
139, 139, 138, 139, 138, 139, 139, 139, 139, 138, 139, 139, 139, 138, 139, 139,
139, 139, 131, 139, 155, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 131, 131, 155, 155, 138, 155, 155, 155, 155, 155, 138, 167, 155, 167, 154,
155, 155, 155, 155, 154, 155, 167, 162, 162, 184, 168, 179, 168, 175, 175, 174,
159, 174, 179, 175, 174, 175, 172, 174, 174, 175, 170, 180, 182, 175, 180, 179,
175, 184, 170, 182, 182, 182, 182, 182, 179, 183, 191, 191, 191, 183, 191, 183,
198, 191, 191, 191, 191, 191, 183, 191, 183, 183, 183, 191, 183, 191, 183, 183,
191, 191, 200, 202, 197, 197, 211, 197, 211, 211, 211, 211, 211, 211, 197, 197,
211, 211, 211, 211, 197, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  53,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86, 124,  86, 124,  86, 124,  86, 124,  86,  93, 124, 124, 124,
124, 124, 124, 139, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124,
139, 124, 124, 124, 124, 139, 124, 124, 139, 124, 139, 124, 139, 124, 139, 124,
139, 124, 124, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 124,
139, 139, 139, 139, 139, 139, 139, 124, 124, 139, 139, 124, 139, 139, 139, 139,
139, 139, 135, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 131, 139, 157,
157, 141, 135, 139, 139, 139, 157, 147, 147, 153, 157, 155, 153, 153, 153, 157,
157, 157, 157, 157, 141, 154, 153, 154, 157, 157, 157, 157, 157, 153, 168, 184,
174, 184, 187, 186, 184, 186, 174, 184, 184, 179, 173, 184, 187, 186, 184, 187,
189, 187, 186, 184, 189, 184, 187, 189, 187, 187, 171, 189, 171, 184, 171, 171,
177, 200, 200, 200, 200, 200, 200, 200, 187, 200, 200, 200, 200, 200, 200, 200,
200, 200, 204, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200,
200, 225, 200, 200, 211, 225, 211, 225, 211, 211, 211, 225, 211, 211, 220, 211,
211, 211, 225, 220, 220, 211, 220, 211, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 111, 121, 139,
121, 111, 138, 121, 138, 121, 121, 139, 139, 138, 138, 155, 138, 138, 155, 138,
167, 155, 155, 155, 138, 167, 138, 167, 167, 138, 167, 167, 167, 167, 167, 155,
155, 185, 176, 167, 167, 138, 167, 167, 167, 167, 167, 172, 167, 167, 167, 176,
167, 167, 167, 167, 185, 167, 167, 167, 167, 176, 167, 167, 167, 167, 172, 167,
172, 167, 180, 172, 167, 167, 172, 167, 167, 170, 172, 175, 175, 188, 175, 180,
170, 179, 188, 170, 170, 175, 182, 191, 182, 191, 188, 191, 188, 191, 198, 191,
195, 191, 198, 198, 198, 198, 198, 198, 183, 191, 197, 198, 197, 197, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197, 197,
197, 211, 197, 197, 197, 197, 197, 211, 197, 197, 197, 211, 197, 197, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86, 111,  86, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
155, 185, 185, 155, 155, 138, 155, 155, 155, 155, 155, 138, 155, 155, 167, 185,
155, 155, 155, 155, 185, 155, 167, 155, 155, 184, 168, 184, 168, 175, 175, 174,
175, 174, 179, 175, 174, 175, 188, 180, 180, 180, 170, 180, 186, 175, 180, 179,
180, 184, 170, 182, 182, 182, 186, 182, 179, 186, 191, 190, 191, 192, 191, 192,
198, 192, 191, 192, 191, 192, 192, 192, 200, 192, 192, 191, 200, 202, 202, 200,
202, 202, 200, 202, 202, 197, 200, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 155, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
176, 185, 185, 155, 155, 138, 155, 155, 155, 155, 155, 138, 167, 155, 167, 185,
155, 155, 155, 155, 185, 155, 167, 174, 155, 184, 168, 184, 174, 175, 175, 174,
167, 174, 179, 175, 174, 175, 188, 180, 180, 175, 188, 180, 182, 175, 180, 179,
180, 184, 170, 182, 182, 182, 186, 190, 179, 190, 191, 190, 191, 192, 191, 192,
198, 192, 191, 192, 191, 192, 192, 192, 200, 192, 192, 199, 202, 202, 202, 200,
202, 199, 200, 202, 202, 197, 211, 211, 211, 211, 211, 211, 211, 211, 197, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 111, 111, 124, 111, 111, 124, 111, 124, 111, 111,
111, 111, 111, 124, 139, 111, 111, 139, 111, 139, 139, 139, 139, 139, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
131, 157, 185, 155, 155, 155, 155, 155, 155, 155, 155, 138, 155, 155, 155, 185,
155, 155, 153, 153, 157, 155, 155, 155, 155, 184, 153, 184, 168, 174, 175, 174,
175, 174, 184, 175, 174, 174, 188, 174, 174, 180, 175, 180, 186, 180, 180, 179,
180, 184, 191, 186, 182, 186, 189, 186, 184, 189, 191, 192, 191, 186, 192, 192,
191, 192, 191, 192, 192, 192, 192, 192, 200, 200, 200, 191, 200, 200, 200, 200,
200, 202, 200, 200, 200, 202, 200, 200, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86,  86,  86,  86, 111,  86,  86,  86, 111, 111, 111, 111, 124,
111, 124, 111, 111, 124, 111, 124, 111, 124, 111, 124, 124, 139, 124, 139, 139,
111, 124, 139, 124, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 121, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 155, 139, 155, 139,
131, 157, 157, 155, 155, 155, 155, 155, 155, 155, 155, 138, 155, 155, 155, 157,
155, 155, 153, 184, 157, 155, 155, 155, 155, 187, 184, 184, 186, 174, 174, 168,
175, 174, 184, 174, 186, 174, 188, 186, 186, 186, 175, 186, 179, 180, 186, 184,
186, 187, 191, 186, 186, 189, 189, 186, 184, 189, 192, 186, 191, 189, 192, 189,
191, 189, 191, 189, 192, 189, 200, 200, 200, 200, 200, 202, 200, 200, 200, 200,
200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 211, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 211, 220, 211,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 155,
176, 185, 185, 155, 155, 167, 155, 155, 155, 155, 155, 138, 167, 155, 167, 185,
155, 155, 176, 176, 185, 155, 167, 174, 155, 184, 176, 184, 174, 175, 175, 174,
175, 174, 184, 175, 180, 175, 188, 180, 180, 180, 188, 180, 186, 175, 180, 179,
180, 184, 191, 190, 190, 190, 186, 190, 184, 186, 191, 190, 191, 192, 191, 192,
198, 192, 191, 192, 191, 192, 192, 192, 200, 202, 202, 199, 200, 202, 202, 200,
202, 202, 200, 202, 202, 202, 200, 211, 211, 211, 211, 211, 211, 211, 220, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
 86,  86,  86,  86, 124,  86, 124,  86, 124,  86, 124, 111,  93, 124, 124, 124,
124, 124, 124, 111, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 139, 139,
139, 124, 124, 124, 124, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 124,
139, 124, 139, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139, 124, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 131,
157, 141, 157, 139, 139, 155, 153, 153, 153, 153, 153, 155, 155, 153, 155, 157,
153, 153, 157, 157, 157, 153, 155, 153, 153, 187, 184, 187, 184, 174, 174, 184,
174, 186, 187, 174, 186, 186, 175, 186, 189, 186, 174, 189, 184, 186, 189, 187,
186, 187, 186, 189, 189, 184, 184, 189, 187, 184, 186, 189, 192, 189, 189, 189,
191, 189, 192, 200, 200, 200, 200, 200, 204, 200, 200, 200, 200, 200, 200, 200,
200, 200, 204, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211,
211, 225, 211, 211, 220, 211, 211, 225, 211, 211, 211, 225, 211, 211, 220, 211,
211, 220, 225, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,
111, 111,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 124,
111, 124, 111, 111, 111, 111, 124, 111, 124, 111, 124, 124, 111, 124, 139, 111,
111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 155, 139, 139, 155, 155, 139, 155, 155, 155, 176,
185, 185, 185, 155, 155, 155, 155, 155, 155, 155, 155, 138, 155, 155, 155, 185,
155, 155, 176, 176, 187, 155, 155, 155, 155, 187, 184, 184, 186, 174, 174, 174,
175, 174, 184, 175, 174, 174, 188, 186, 186, 180, 175, 186, 186, 180, 186, 184,
186, 184, 191, 186, 186, 186, 189, 186, 184, 189, 191, 193, 191, 189, 192, 193,
191, 193, 191, 193, 192, 193, 193, 192, 200, 200, 200, 202, 200, 200, 200, 200,
200, 202, 200, 200, 200, 200, 200, 200, 200, 200, 200, 211, 211, 211, 220, 211,
211, 211, 211, 211, 220, 211, 211, 211, 211, 211, 211, 211, 211, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 111, 111, 121, 111, 111, 111, 111, 139, 139, 111, 139, 139, 139, 121, 139,
139, 139, 138, 138, 138, 139, 139, 139, 139, 138, 139, 139, 139, 138, 139, 169,
169, 155, 176, 155, 169, 155, 138, 167, 167, 167, 167, 155, 167, 155, 167, 176,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 138, 167, 167, 167, 176,
167, 167, 176, 176, 185, 167, 167, 167, 167, 185, 176, 176, 167, 167, 167, 167,
188, 167, 180, 167, 167, 167, 188, 175, 175, 175, 188, 175, 180, 175, 175, 180,
175, 184, 188, 180, 191, 190, 190, 191, 193, 190, 198, 191, 198, 190, 191, 191,
188, 191, 198, 191, 199, 191, 199, 199, 192, 202, 199, 198, 202, 199, 202, 202,
199, 207, 202, 202, 199, 197, 211, 197, 197, 197, 211, 211, 197, 197, 197, 197,
211, 211, 211, 211, 197, 211, 220, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243,
 23,  23,  23,  23,  23,  53,  53,  46,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 139,
139, 139, 139, 121, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 138, 155, 155, 155, 155, 155, 155, 155, 155, 176,
176, 185, 185, 155, 155, 167, 155, 155, 155, 155, 155, 138, 167, 155, 167, 185,
155, 176, 176, 176, 185, 167, 167, 167, 174, 185, 176, 185, 180, 167, 167, 180,
167, 180, 184, 175, 180, 175, 188, 180, 180, 180, 188, 180, 186, 175, 180, 186,
180, 184, 188, 190, 190, 190, 193, 190, 184, 193, 191, 190, 191, 192, 191, 192,
198, 192, 199, 192, 191, 192, 202, 202, 200, 202, 202, 199, 202, 202, 202, 202,
202, 199, 200, 202, 202, 202, 200, 202, 211, 211, 211, 211, 211, 211, 220, 220,
211, 211, 211, 211, 220, 211, 211, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 211, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  23,  23,  53,  53,  23,  53,  53,  53,  53,  53,  53,  53,  53,
 53, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 121, 111, 111, 111, 111, 139, 111, 111, 111, 111, 139, 138, 139,
169, 169, 138, 138, 138, 169, 169, 169, 169, 138, 169, 169, 169, 138, 169, 167,
169, 169, 176, 169, 167, 167, 138, 167, 167, 167, 167, 167, 167, 167, 167, 176,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 172, 167, 167, 167, 176,
167, 167, 167, 167, 185, 167, 167, 167, 167, 185, 167, 176, 167, 167, 167, 167,
188, 167, 180, 188, 167, 167, 188, 167, 167, 167, 188, 167, 180, 188, 175, 180,
175, 193, 188, 191, 198, 190, 190, 191, 190, 190, 198, 198, 188, 191, 198, 198,
195, 198, 198, 198, 198, 198, 199, 198, 202, 199, 199, 198, 199, 207, 207, 202,
207, 207, 206, 207, 207, 207, 197, 207, 197, 197, 211, 197, 197, 197, 197, 197,
197, 211, 197, 211, 197, 211, 197, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  53,  53,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 111, 111, 124, 111, 111, 124, 111, 124, 111, 111,
111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 131, 139, 139, 139, 169, 155, 155, 169, 155, 176, 155, 176, 176, 176,
185, 185, 185, 155, 155, 167, 176, 176, 176, 155, 176, 138, 155, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 175, 175, 180,
175, 180, 184, 175, 180, 180, 188, 180, 180, 180, 175, 180, 186, 180, 180, 184,
190, 184, 191, 190, 190, 193, 189, 193, 184, 193, 191, 192, 199, 193, 192, 193,
199, 193, 199, 192, 196, 192, 202, 202, 200, 205, 202, 199, 200, 202, 202, 200,
202, 202, 200, 205, 206, 214, 200, 214, 214, 214, 211, 211, 211, 211, 220, 220,
211, 211, 211, 211, 220, 211, 211, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  53,  53,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86, 111,  86,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 139, 139, 139, 169, 139, 169,
169, 169, 185, 139, 169, 169, 138, 169, 169, 167, 169, 176, 169, 176, 176, 176,
176, 185, 185, 167, 167, 167, 176, 167, 176, 167, 176, 138, 167, 167, 167, 185,
176, 176, 176, 176, 185, 167, 167, 167, 167, 185, 176, 176, 180, 167, 167, 167,
188, 180, 176, 167, 180, 175, 188, 180, 180, 180, 188, 180, 190, 175, 180, 186,
180, 184, 188, 190, 190, 190, 193, 190, 189, 190, 199, 190, 198, 196, 199, 196,
198, 196, 198, 196, 199, 196, 202, 202, 193, 202, 202, 199, 202, 202, 202, 202,
202, 199, 200, 202, 206, 207, 214, 214, 214, 214, 211, 211, 211, 220, 220, 220,
220, 211, 211, 211, 220, 211, 220, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  53,  53,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 139, 111, 111, 139, 111, 139, 139, 139, 139, 139, 111, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 185, 139, 169, 169, 138, 169, 169, 169, 169, 176, 169, 176, 176, 176,
176, 185, 185, 155, 155, 167, 176, 176, 176, 176, 176, 138, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 180, 175, 167, 180,
167, 180, 184, 175, 180, 180, 188, 180, 180, 180, 188, 180, 186, 180, 180, 189,
180, 184, 191, 190, 190, 193, 193, 190, 184, 193, 191, 190, 199, 193, 196, 196,
198, 196, 199, 196, 196, 196, 202, 202, 200, 202, 202, 199, 205, 202, 202, 205,
202, 202, 200, 206, 206, 214, 200, 214, 214, 214, 211, 211, 211, 220, 220, 220,
211, 211, 211, 211, 220, 211, 220, 211, 211, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 121, 111,
111, 111, 111, 121, 111, 111, 111, 121, 111, 111, 111, 111, 111, 169, 138, 169,
169, 169, 138, 138, 138, 169, 169, 169, 169, 138, 169, 169, 169, 138, 169, 167,
169, 169, 176, 169, 167, 167, 138, 167, 167, 167, 167, 167, 167, 167, 167, 167,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 172, 167, 167, 167, 176,
167, 167, 167, 167, 185, 167, 167, 167, 167, 176, 167, 176, 167, 167, 188, 167,
188, 167, 167, 188, 167, 188, 188, 167, 167, 188, 188, 167, 167, 188, 167, 194,
188, 194, 188, 198, 198, 198, 194, 198, 194, 199, 188, 198, 195, 198, 198, 198,
195, 198, 195, 198, 198, 198, 198, 198, 202, 207, 207, 207, 207, 207, 207, 207,
207, 207, 206, 207, 207, 207, 207, 207, 207, 207, 212, 207, 207, 207, 207, 207,
197, 211, 197, 197, 207, 197, 197, 211, 197, 197, 220, 220, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 235, 235, 235, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86,  86, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 111, 111, 124, 111, 111,
111, 139, 111, 124, 139, 111, 139, 139, 111, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 139, 139, 139, 169, 139, 169,
169, 169, 185, 139, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176, 176, 176,
176, 185, 185, 176, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 180,
167, 180, 185, 175, 180, 180, 188, 180, 180, 180, 188, 194, 194, 180, 194, 189,
194, 184, 199, 194, 194, 194, 193, 194, 184, 193, 199, 196, 199, 193, 196, 196,
198, 196, 199, 196, 199, 196, 202, 202, 205, 202, 202, 199, 205, 202, 202, 205,
202, 202, 200, 206, 206, 214, 214, 214, 214, 214, 211, 214, 211, 220, 220, 220,
220, 211, 211, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 111, 111, 138, 111, 111, 111, 111, 139, 169, 169, 169, 169, 169, 138, 139,
169, 169, 138, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 176, 169, 169, 169, 138, 169, 167, 167, 167, 169, 167, 176, 167, 176,
176, 185, 176, 167, 167, 167, 167, 167, 167, 167, 167, 172, 167, 167, 167, 185,
167, 167, 176, 176, 185, 167, 167, 167, 167, 185, 176, 176, 167, 167, 167, 167,
188, 167, 176, 188, 167, 167, 188, 167, 167, 167, 188, 180, 194, 188, 180, 194,
198, 184, 188, 194, 199, 194, 194, 199, 194, 194, 198, 199, 198, 196, 198, 199,
195, 199, 198, 199, 198, 199, 199, 199, 202, 199, 199, 207, 202, 207, 199, 206,
207, 207, 206, 207, 207, 207, 214, 212, 212, 212, 214, 214, 212, 207, 207, 207,
220, 211, 220, 211, 207, 220, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 235, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 124, 139, 111, 139, 139, 111, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 139, 139, 139, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176, 176, 176,
176, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 180,
167, 180, 185, 175, 180, 180, 188, 180, 194, 180, 188, 194, 194, 180, 194, 189,
194, 184, 198, 194, 194, 194, 193, 194, 184, 193, 199, 196, 199, 193, 196, 196,
198, 196, 199, 196, 199, 196, 202, 202, 205, 202, 202, 199, 205, 202, 206, 205,
206, 202, 205, 206, 206, 214, 214, 214, 214, 214, 214, 214, 214, 220, 220, 220,
220, 211, 211, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111,
111, 111, 111, 139, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 138, 169, 169, 169, 169, 139, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 167, 169, 169, 169, 169, 169, 169, 176, 169, 176,
176, 185, 185, 169, 176, 167, 176, 176, 176, 167, 176, 188, 167, 167, 167, 185,
176, 176, 176, 176, 185, 167, 167, 167, 167, 185, 176, 185, 176, 167, 167, 167,
188, 167, 176, 167, 180, 167, 188, 180, 194, 180, 188, 194, 194, 180, 194, 194,
194, 184, 188, 194, 194, 194, 194, 194, 193, 194, 199, 196, 198, 196, 199, 196,
198, 196, 198, 196, 199, 196, 202, 202, 205, 202, 202, 199, 206, 202, 206, 206,
206, 199, 205, 206, 206, 212, 214, 214, 214, 214, 214, 214, 214, 214, 212, 220,
220, 211, 220, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86,  86,  86,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 111, 111, 124, 111, 111,
111, 139, 111, 124, 139, 111, 139, 139, 111, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 138, 139, 169, 139, 139, 139, 139, 169, 169, 139, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176, 176, 176,
185, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 180,
167, 180, 185, 175, 180, 180, 188, 194, 194, 194, 188, 194, 194, 194, 194, 189,
194, 184, 199, 194, 194, 194, 193, 194, 184, 193, 199, 196, 199, 193, 196, 196,
198, 196, 199, 196, 199, 196, 202, 202, 205, 202, 202, 199, 205, 206, 206, 205,
206, 202, 204, 206, 206, 214, 214, 214, 214, 214, 214, 214, 214, 214, 220, 220,
220, 211, 220, 211, 220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,
 53,  53,  86,  86,  86,  86, 111, 111,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 111, 111, 124, 111, 111, 139, 111, 124, 111, 111,
111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
139, 139, 138, 169, 169, 169, 169, 139, 139, 169, 169, 139, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 194, 185, 167, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 193,
194, 184, 199, 194, 194, 194, 193, 194, 184, 193, 199, 194, 199, 201, 196, 201,
198, 201, 199, 201, 196, 201, 201, 202, 205, 205, 206, 199, 205, 206, 206, 205,
206, 206, 204, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 220,
220, 211, 220, 211, 220, 220, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  53,  53,
 53,  86,  86,  86,  86,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 124, 111, 111, 139, 111, 124, 111, 111,
111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 138, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 176, 167, 176, 176, 176, 176, 176, 167, 167, 176, 167, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 194, 185, 167, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 193,
194, 184, 199, 194, 194, 194, 194, 194, 184, 194, 199, 194, 199, 201, 196, 201,
198, 201, 199, 201, 199, 201, 201, 202, 205, 206, 206, 199, 205, 206, 206, 206,
206, 210, 205, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 212, 220,
220, 211, 220, 220, 220, 220, 220, 211, 220, 220, 220, 211, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 220, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  86,
 86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86,  86, 111,
111, 111, 124, 111, 124, 111, 124, 111, 124, 139, 124, 111, 139, 139, 139, 124,
139, 124, 139, 111, 139, 139, 124, 139, 124, 139, 139, 124, 139, 124, 139, 139,
139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 169, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 139,
139, 139, 185, 139, 169, 169, 169, 169, 169, 169, 169, 176, 169, 185, 176, 185,
185, 185, 185, 176, 176, 169, 176, 176, 176, 176, 176, 169, 176, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 185, 176, 194, 176,
194, 176, 187, 194, 176, 194, 188, 194, 193, 194, 194, 193, 184, 194, 193, 187,
194, 187, 194, 193, 193, 189, 184, 193, 187, 189, 201, 193, 201, 205, 205, 205,
199, 205, 201, 205, 205, 205, 205, 205, 204, 205, 205, 205, 204, 205, 205, 204,
205, 205, 204, 205, 205, 214, 204, 205, 214, 214, 225, 225, 214, 214, 214, 214,
220, 225, 225, 225, 220, 225, 220, 225, 225, 220, 220, 225, 220, 220, 220, 220,
220, 220, 225, 220, 220, 220, 220, 220, 220, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  53,  86,
 86,  86,  86,  86,  86,  86, 111, 111,  86, 111, 111,  86, 111, 111, 111, 111,
111, 111, 111, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 124,
111, 124, 111, 111, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 176, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 194, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 194, 194, 194, 194, 194, 184,
194, 187, 199, 194, 194, 194, 193, 194, 184, 193, 194, 194, 199, 201, 201, 201,
199, 201, 199, 201, 201, 201, 205, 206, 204, 205, 205, 210, 205, 206, 205, 205,
209, 210, 204, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214,
214, 225, 214, 214, 220, 220, 220, 225, 220, 220, 220, 225, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53,  53,  53,  53,  86,
 86, 111,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 124, 111, 111, 111, 111, 139, 111, 139, 111, 139, 139, 139, 124, 139, 139,
111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 138, 139, 139, 139, 169, 139, 169, 169, 169, 169, 169, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 194,
194, 203, 199, 194, 194, 194, 194, 194, 184, 194, 199, 194, 199, 201, 201, 201,
198, 201, 199, 201, 201, 201, 206, 206, 205, 205, 206, 199, 205, 206, 206, 209,
206, 210, 204, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214,
214, 214, 214, 214, 220, 220, 220, 225, 220, 220, 220, 220, 220, 220, 220, 220,
220, 220, 220, 220, 220, 220, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  53, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169, 169,
169, 169, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176,
176, 185, 185, 169, 169, 167, 176, 167, 176, 167, 176, 188, 167, 167, 167, 185,
176, 176, 176, 176, 185, 167, 167, 167, 167, 185, 176, 185, 176, 167, 167, 167,
188, 167, 176, 188, 167, 167, 188, 194, 194, 194, 188, 194, 194, 198, 194, 194,
194, 185, 188, 194, 194, 194, 194, 194, 194, 194, 198, 199, 198, 194, 199, 199,
198, 199, 198, 199, 207, 199, 212, 212, 208, 212, 212, 207, 210, 212, 212, 210,
212, 207, 209, 212, 212, 212, 214, 212, 212, 212, 214, 212, 212, 212, 207, 212,
212, 214, 224, 214, 228, 220, 220, 214, 220, 220, 220, 220, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,  86,
 86,  86,  86,  86,  86,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 124, 111, 111, 111, 124, 111, 111, 111, 111, 111, 139, 139,
139, 124, 139, 111, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 169, 139, 139, 139, 169, 139, 139, 169, 169, 169, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 185,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
194, 176, 185, 194, 194, 194, 188, 194, 194, 194, 194, 194, 194, 194, 194, 203,
194, 203, 194, 194, 194, 194, 193, 194, 203, 193, 194, 194, 199, 205, 201, 208,
199, 208, 199, 208, 208, 205, 205, 205, 204, 205, 205, 210, 205, 209, 205, 205,
209, 210, 204, 214, 214, 214, 214, 214, 214, 214, 223, 214, 214, 214, 214, 214,
214, 225, 214, 214, 220, 214, 220, 225, 220, 220, 220, 225, 220, 220, 220, 220,
220, 220, 225, 220, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,  86,
111, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 139, 111, 111, 111, 111, 139, 111, 139, 139, 139, 139, 139, 124, 139, 139,
111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 176, 185, 176, 167, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 203,
194, 203, 199, 194, 194, 194, 194, 194, 203, 194, 199, 194, 199, 208, 208, 208,
198, 208, 199, 208, 208, 208, 208, 208, 205, 208, 208, 212, 209, 210, 210, 209,
210, 210, 209, 214, 214, 212, 214, 214, 214, 214, 214, 214, 214, 214, 212, 224,
221, 214, 221, 221, 224, 221, 221, 223, 220, 220, 220, 220, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,  86,
 86, 111,  86, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 124, 111, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 139,
169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 194, 194, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 203,
194, 203, 199, 194, 194, 194, 194, 194, 203, 194, 194, 194, 199, 208, 208, 208,
199, 208, 199, 208, 208, 208, 208, 208, 205, 209, 209, 210, 209, 210, 209, 209,
209, 210, 204, 214, 214, 216, 214, 214, 214, 214, 214, 214, 214, 214, 224, 221,
221, 223, 221, 221, 224, 221, 221, 225, 220, 220, 220, 225, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,
 86, 111,  86,  86, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 124, 111, 111, 111, 124, 111, 111, 111, 111, 139, 139, 139,
139, 124, 139, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
139, 139, 139, 169, 139, 139, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 185,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
194, 176, 185, 194, 194, 194, 188, 194, 194, 194, 194, 194, 203, 194, 194, 203,
194, 203, 194, 194, 194, 194, 203, 194, 203, 194, 194, 194, 199, 208, 208, 208,
199, 208, 208, 208, 208, 208, 208, 208, 204, 205, 209, 210, 205, 209, 209, 209,
209, 210, 213, 214, 214, 216, 223, 214, 214, 214, 223, 214, 214, 214, 216, 221,
221, 225, 221, 223, 221, 221, 221, 225, 221, 220, 220, 225, 220, 220, 220, 220,
220, 220, 233, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  86,
 86, 111, 111, 111, 111,  86, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 139, 111, 111, 139, 111, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176, 169, 176,
185, 185, 185, 169, 169, 169, 176, 176, 176, 176, 176, 167, 169, 176, 169, 185,
176, 176, 176, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 194, 167, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 203,
194, 203, 199, 194, 194, 194, 194, 194, 203, 194, 194, 194, 199, 208, 208, 208,
198, 208, 199, 208, 208, 208, 208, 208, 205, 208, 208, 212, 209, 210, 209, 209,
210, 210, 218, 214, 214, 216, 214, 214, 214, 214, 214, 214, 214, 214, 224, 224,
221, 221, 221, 221, 224, 221, 221, 225, 221, 220, 220, 220, 220, 220, 220, 220,
220, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 111, 139, 111, 111,
111, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 138, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 188, 169, 176, 169, 185,
176, 176, 176, 176, 185, 176, 167, 176, 176, 185, 176, 185, 176, 167, 167, 176,
188, 176, 185, 167, 194, 194, 188, 194, 194, 194, 188, 194, 194, 194, 194, 194,
194, 203, 198, 194, 194, 194, 194, 194, 203, 194, 199, 194, 198, 208, 208, 208,
207, 208, 207, 208, 212, 208, 208, 208, 208, 208, 210, 212, 209, 212, 210, 210,
210, 212, 209, 210, 212, 212, 214, 216, 216, 216, 214, 224, 224, 224, 228, 224,
224, 221, 224, 221, 228, 224, 224, 221, 224, 224, 220, 230, 220, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  86,  86,  86,  86, 124,  86,  86,  86,  86,  86, 124, 124, 139, 124, 139,
111, 139, 124, 139, 124, 139, 124, 139, 124, 139, 139, 139, 139, 139, 139, 124,
139, 124, 139, 139, 139, 139, 139, 139, 124, 139, 139, 139, 139, 124, 139, 139,
139, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 169, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185, 169, 185,
185, 185, 185, 169, 176, 169, 185, 176, 185, 176, 185, 169, 169, 176, 169, 185,
185, 185, 185, 185, 185, 176, 176, 176, 185, 203, 185, 203, 185, 176, 176, 185,
194, 185, 203, 194, 203, 194, 215, 203, 203, 194, 194, 203, 203, 194, 203, 203,
194, 203, 194, 203, 194, 203, 203, 205, 203, 204, 208, 205, 208, 204, 205, 205,
208, 205, 208, 205, 205, 205, 205, 205, 213, 204, 205, 205, 213, 205, 205, 213,
205, 205, 213, 223, 223, 216, 213, 223, 223, 223, 225, 223, 223, 223, 221, 221,
223, 225, 225, 225, 221, 225, 225, 225, 225, 225, 225, 225, 225, 233, 220, 233,
233, 233, 225, 235, 235, 235, 243, 233, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 139, 111, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
169, 139, 139, 139, 139, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 215, 194, 194, 194, 194, 203,
194, 203, 215, 194, 194, 194, 208, 208, 203, 208, 208, 208, 215, 208, 208, 208,
215, 208, 212, 208, 208, 208, 208, 208, 218, 208, 208, 212, 209, 210, 209, 209,
216, 219, 218, 216, 216, 219, 214, 216, 216, 221, 221, 221, 221, 224, 224, 224,
221, 223, 221, 221, 224, 227, 227, 231, 227, 227, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
111, 139, 111, 111, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169,
169, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 176, 176, 194, 176,
167, 176, 185, 194, 194, 194, 188, 194, 194, 194, 215, 194, 194, 194, 194, 203,
194, 203, 215, 194, 194, 194, 208, 208, 203, 208, 208, 208, 215, 208, 208, 208,
215, 208, 212, 208, 208, 208, 208, 208, 218, 208, 208, 212, 209, 210, 209, 209,
216, 219, 218, 216, 216, 219, 221, 216, 221, 221, 221, 221, 221, 224, 224, 224,
221, 223, 221, 221, 224, 227, 227, 231, 227, 227, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 176,
185, 185, 185, 169, 169, 169, 176, 169, 169, 169, 176, 188, 169, 169, 169, 185,
176, 176, 176, 185, 185, 176, 169, 176, 176, 185, 176, 185, 176, 167, 215, 176,
215, 176, 185, 215, 194, 194, 215, 194, 194, 194, 215, 194, 194, 215, 194, 203,
194, 203, 215, 194, 194, 208, 208, 208, 203, 208, 215, 208, 215, 208, 208, 208,
215, 208, 215, 208, 212, 208, 208, 208, 218, 208, 212, 212, 219, 212, 219, 219,
219, 212, 218, 219, 219, 226, 224, 224, 224, 224, 224, 224, 224, 224, 228, 228,
224, 227, 224, 227, 228, 229, 229, 230, 229, 229, 229, 230, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 111, 124, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 139, 111, 124, 139, 139, 111, 139, 139, 139, 111, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 124, 139, 139,
169, 139, 139, 139, 139, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 176, 176, 176, 185, 169, 169, 176, 169, 185,
176, 185, 185, 185, 185, 176, 176, 176, 176, 185, 185, 185, 185, 176, 176, 176,
194, 176, 203, 194, 176, 194, 215, 203, 203, 194, 215, 203, 203, 194, 194, 203,
194, 203, 217, 208, 208, 203, 203, 208, 203, 203, 208, 208, 208, 208, 208, 208,
215, 208, 208, 208, 208, 208, 208, 208, 213, 218, 218, 219, 218, 218, 218, 218,
218, 219, 213, 221, 221, 221, 223, 221, 221, 221, 223, 223, 221, 221, 221, 227,
230, 223, 230, 223, 227, 231, 230, 233, 230, 230, 230, 233, 230, 230, 235, 235,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
139, 139, 139, 111, 139, 139, 139, 169, 139, 169, 169, 139, 169, 139, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 176, 194, 176,
215, 176, 185, 215, 176, 194, 215, 194, 194, 194, 215, 194, 203, 194, 194, 203,
194, 203, 215, 208, 208, 208, 208, 208, 203, 208, 217, 208, 215, 208, 208, 208,
215, 208, 215, 208, 208, 208, 208, 208, 218, 208, 208, 212, 218, 219, 219, 218,
219, 219, 218, 219, 219, 224, 221, 221, 221, 224, 221, 221, 224, 224, 226, 224,
227, 230, 227, 227, 226, 230, 227, 231, 230, 229, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139, 139,
139, 139, 139, 111, 139, 139, 139, 169, 139, 169, 169, 169, 169, 139, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 176, 169, 176, 169, 169, 176, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 176, 169, 176,
215, 176, 203, 215, 176, 194, 215, 194, 194, 194, 215, 194, 203, 217, 194, 203,
194, 203, 215, 208, 208, 208, 203, 208, 203, 208, 217, 208, 215, 208, 208, 208,
215, 208, 215, 208, 208, 208, 208, 208, 218, 218, 208, 212, 218, 219, 219, 218,
219, 219, 218, 219, 219, 224, 218, 221, 221, 224, 221, 221, 227, 224, 226, 224,
227, 231, 227, 230, 229, 230, 229, 231, 230, 229, 229, 231, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 139,
139, 139, 169, 111, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 176, 169, 169, 169, 176, 169, 169, 169, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 176, 215, 176,
215, 176, 203, 215, 176, 194, 215, 194, 194, 194, 215, 194, 203, 217, 194, 203,
217, 203, 215, 208, 208, 208, 203, 208, 203, 208, 217, 208, 215, 208, 208, 208,
215, 208, 215, 208, 208, 208, 208, 208, 218, 218, 208, 212, 218, 219, 219, 218,
219, 219, 218, 219, 219, 226, 218, 224, 224, 224, 221, 221, 227, 224, 226, 224,
227, 230, 227, 230, 228, 230, 229, 231, 230, 229, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 124, 111, 111, 111, 111, 111, 139, 111, 111, 111, 139,
111, 111, 139, 139, 124, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 169, 139, 139, 139, 139, 139, 139, 139, 139, 169, 139, 169, 169,
169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 185, 169, 185, 169, 169, 176, 169, 185,
185, 185, 185, 185, 203, 176, 176, 176, 185, 203, 185, 203, 203, 176, 169, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 203, 215, 203, 203, 217, 203, 203,
217, 203, 217, 208, 208, 203, 203, 208, 203, 203, 217, 208, 217, 218, 208, 208,
215, 208, 217, 208, 208, 218, 218, 218, 218, 218, 218, 219, 218, 218, 218, 218,
218, 219, 223, 223, 223, 221, 223, 221, 223, 221, 223, 223, 230, 227, 227, 227,
230, 223, 230, 231, 227, 231, 230, 233, 230, 230, 230, 233, 230, 230, 235, 233,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 139, 111, 139, 111, 139, 139, 139, 111, 139, 139, 139, 139,
139, 139, 169, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 169, 169, 169, 169, 185,
176, 185, 185, 185, 185, 176, 169, 176, 176, 203, 185, 203, 185, 176, 217, 176,
215, 176, 203, 217, 203, 217, 215, 203, 203, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 203, 203, 217, 203, 203, 217, 217, 215, 208, 217, 208,
215, 208, 217, 208, 217, 208, 218, 218, 218, 218, 218, 219, 218, 219, 218, 218,
218, 219, 218, 221, 221, 224, 223, 221, 221, 221, 223, 227, 227, 227, 227, 227,
227, 231, 230, 230, 229, 230, 230, 231, 230, 230, 230, 233, 230, 230, 235, 235,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 139, 111, 111, 111, 139, 111, 139, 111, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 176, 169, 169, 169, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 185, 217, 215, 176,
215, 176, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 203, 217, 203, 208, 217, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 222, 217, 218, 218, 218, 226, 218, 219, 218, 218,
219, 219, 218, 219, 219, 226, 218, 224, 224, 224, 230, 227, 227, 227, 226, 229,
229, 231, 230, 230, 229, 230, 229, 231, 230, 229, 229, 231, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 176, 169, 169, 169, 169, 185,
176, 176, 185, 185, 185, 176, 169, 176, 176, 185, 185, 185, 176, 217, 215, 176,
215, 176, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 203, 217, 203, 208, 215, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 218, 218, 219, 226, 218, 219, 219, 218,
219, 226, 218, 219, 219, 226, 218, 224, 224, 224, 227, 227, 227, 229, 226, 229,
229, 230, 229, 230, 228, 230, 229, 231, 229, 229, 229, 230, 229, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 215, 169, 169, 169, 185,
169, 176, 176, 185, 185, 169, 169, 176, 176, 185, 185, 185, 176, 215, 215, 176,
215, 217, 185, 215, 217, 215, 215, 217, 217, 215, 215, 217, 217, 215, 217, 203,
215, 203, 215, 217, 217, 217, 217, 217, 203, 217, 215, 217, 215, 217, 215, 217,
215, 217, 215, 217, 215, 217, 217, 217, 218, 219, 212, 215, 219, 226, 219, 219,
226, 226, 218, 226, 226, 226, 224, 226, 226, 226, 224, 224, 226, 228, 228, 228,
229, 229, 229, 229, 228, 229, 229, 230, 229, 229, 229, 232, 235, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 215, 169, 169, 169, 185,
176, 176, 185, 185, 185, 169, 169, 176, 176, 185, 185, 185, 176, 215, 215, 176,
215, 217, 203, 215, 217, 215, 215, 217, 217, 217, 215, 217, 217, 215, 217, 203,
217, 203, 215, 217, 217, 217, 217, 217, 203, 217, 215, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 218, 218, 217, 215, 218, 219, 219, 218,
219, 226, 218, 219, 224, 226, 224, 224, 224, 224, 227, 227, 229, 226, 228, 226,
229, 230, 229, 229, 228, 229, 229, 231, 229, 229, 229, 230, 232, 235, 235, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 139, 111, 169, 111, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 185,
176, 185, 185, 185, 185, 176, 169, 176, 176, 203, 185, 203, 185, 217, 215, 176,
215, 217, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 203, 217, 203, 222, 217, 217, 215, 217, 217, 217,
215, 217, 217, 217, 217, 217, 222, 217, 218, 218, 222, 226, 218, 219, 218, 218,
219, 226, 218, 219, 224, 226, 218, 227, 227, 227, 231, 227, 229, 229, 226, 229,
229, 231, 230, 230, 229, 230, 229, 231, 230, 232, 232, 231, 232, 238, 235, 235,
235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139,
139, 139, 169, 169, 169, 169, 169, 169, 139, 169, 169, 169, 169, 139, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 185, 185, 185, 185, 169, 169, 185, 169, 203,
185, 185, 185, 203, 203, 185, 169, 203, 203, 203, 203, 203, 203, 217, 217, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 203, 217, 203, 203, 217, 203, 203,
217, 203, 217, 222, 222, 203, 203, 222, 203, 203, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 218, 218, 218, 222, 223, 218, 218, 223,
218, 222, 223, 223, 223, 227, 223, 223, 223, 223, 223, 223, 231, 230, 227, 230,
231, 233, 231, 231, 230, 233, 231, 233, 231, 230, 230, 233, 233, 233, 235, 233,
233, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 139, 111, 139, 139, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 169, 169, 169, 169, 185,
185, 185, 185, 185, 203, 176, 169, 176, 185, 203, 185, 203, 203, 217, 217, 203,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 222, 203, 217, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 218, 218, 222, 217, 218, 222, 218, 218,
218, 219, 218, 218, 221, 226, 218, 227, 227, 227, 231, 230, 227, 229, 226, 229,
230, 231, 230, 231, 229, 231, 230, 231, 230, 230, 230, 233, 230, 238, 235, 235,
235, 235, 233, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 139, 111, 111, 139, 139,
111, 139, 139, 139, 139, 139, 139, 169, 139, 139, 139, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 185, 169, 185, 169, 169, 169, 169, 185,
185, 185, 185, 185, 203, 185, 169, 185, 185, 203, 203, 203, 203, 217, 217, 203,
215, 203, 203, 217, 203, 217, 215, 203, 203, 217, 215, 217, 203, 217, 217, 203,
217, 203, 217, 217, 217, 203, 203, 222, 203, 203, 217, 222, 217, 222, 217, 222,
215, 222, 217, 222, 222, 222, 222, 222, 218, 218, 222, 217, 218, 218, 218, 218,
218, 219, 223, 218, 218, 227, 223, 227, 227, 227, 231, 231, 230, 230, 229, 229,
230, 231, 230, 231, 229, 231, 230, 233, 231, 230, 230, 233, 230, 230, 235, 235,
235, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 215, 169, 169, 169, 185,
169, 169, 185, 185, 185, 169, 169, 169, 176, 185, 185, 185, 217, 215, 215, 217,
215, 217, 203, 215, 217, 215, 215, 217, 217, 217, 215, 217, 217, 215, 217, 203,
217, 203, 215, 217, 217, 217, 217, 217, 203, 217, 215, 217, 215, 217, 215, 217,
215, 217, 215, 217, 215, 217, 217, 217, 218, 217, 217, 215, 222, 226, 226, 218,
226, 226, 218, 226, 226, 226, 224, 226, 226, 226, 229, 229, 226, 226, 228, 228,
232, 232, 232, 232, 228, 232, 232, 232, 232, 232, 232, 232, 234, 235, 240, 235,
235, 235, 235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 139, 111, 111, 139, 139,
169, 139, 139, 139, 139, 139, 139, 169, 139, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 185, 169, 185, 169, 169, 169, 169, 203,
185, 185, 185, 185, 203, 185, 169, 185, 185, 203, 203, 203, 203, 217, 217, 203,
215, 203, 203, 217, 203, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 217, 217, 217, 222, 203, 222, 203, 222, 217, 222, 217, 222, 217, 222,
215, 222, 217, 222, 222, 222, 222, 222, 218, 222, 222, 217, 218, 222, 218, 218,
222, 222, 223, 218, 218, 227, 223, 227, 230, 227, 231, 231, 230, 230, 229, 229,
230, 231, 231, 231, 229, 231, 230, 233, 231, 230, 230, 233, 230, 238, 235, 238,
238, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 215, 169, 169, 169, 185,
185, 185, 185, 185, 203, 169, 169, 176, 176, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 215, 222, 217, 217,
215, 217, 217, 217, 217, 217, 222, 222, 218, 222, 222, 217, 218, 222, 222, 218,
222, 226, 218, 227, 227, 226, 218, 227, 227, 227, 231, 230, 232, 229, 226, 229,
232, 231, 232, 230, 232, 230, 232, 231, 232, 232, 234, 231, 234, 238, 235, 235,
235, 235, 235, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 139, 139, 139, 139, 139, 139, 139,
139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 139, 169, 169, 169, 169, 139,
169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185, 169, 185,
185, 185, 185, 169, 169, 169, 185, 185, 185, 185, 185, 169, 169, 185, 169, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 217, 217, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 203, 217, 203, 203, 217, 203, 203,
222, 203, 217, 222, 222, 203, 203, 222, 203, 203, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 213, 218, 222, 222, 223, 223, 223, 223,
223, 222, 223, 223, 223, 230, 223, 223, 223, 223, 223, 231, 231, 231, 230, 230,
231, 233, 231, 233, 230, 233, 231, 233, 233, 231, 233, 236, 233, 233, 239, 233,
233, 233, 236, 235, 243, 243, 243, 245, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 139, 111, 111, 111, 169,
169, 169, 169, 169, 139, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 169, 169, 169, 169, 203,
185, 185, 185, 185, 203, 185, 169, 185, 185, 203, 203, 203, 203, 217, 217, 203,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 217, 217, 217, 222, 203, 217, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 218, 222, 222, 217, 218, 222, 222, 218,
222, 222, 218, 222, 222, 226, 231, 227, 227, 227, 231, 231, 230, 232, 229, 232,
232, 231, 230, 231, 232, 231, 232, 231, 230, 234, 234, 233, 234, 238, 235, 238,
238, 235, 236, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 111, 111, 111, 111, 111,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 215, 169, 169, 169, 185,
169, 185, 185, 185, 203, 169, 169, 169, 185, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 203, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 215, 222, 217, 217,
215, 217, 217, 217, 217, 217, 222, 222, 218, 222, 222, 217, 222, 222, 222, 222,
222, 226, 218, 222, 222, 226, 231, 227, 232, 232, 231, 232, 232, 232, 226, 232,
232, 231, 232, 232, 234, 232, 232, 231, 232, 234, 234, 231, 234, 238, 235, 238,
238, 235, 238, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 111, 111, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 169, 169, 169, 169, 185, 215, 169, 169, 169, 203,
169, 185, 185, 185, 203, 169, 217, 217, 185, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 215, 222, 217, 217,
215, 217, 217, 217, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 218, 222, 222, 226, 231, 232, 232, 232, 231, 232, 232, 232, 226, 232,
232, 231, 232, 232, 234, 232, 234, 231, 234, 234, 234, 231, 238, 238, 238, 238,
238, 238, 238, 235, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 139, 139, 139, 139, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 185,
185, 203, 185, 169, 169, 169, 185, 185, 185, 185, 185, 169, 169, 203, 169, 203,
203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 203, 217, 217, 203,
217, 203, 203, 217, 203, 217, 215, 203, 203, 217, 217, 222, 203, 217, 222, 203,
222, 203, 217, 222, 222, 222, 203, 222, 203, 222, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 218, 222, 222, 222, 222, 222, 222, 222,
222, 222, 223, 222, 222, 222, 231, 231, 231, 231, 231, 231, 231, 231, 234, 230,
231, 236, 231, 231, 234, 231, 231, 236, 231, 231, 231, 236, 239, 239, 239, 236,
239, 239, 236, 241, 243, 245, 243, 245, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 169, 169, 169, 203,
185, 185, 185, 203, 203, 169, 217, 217, 217, 203, 203, 203, 203, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 203,
217, 203, 215, 217, 217, 217, 222, 217, 203, 222, 217, 217, 217, 222, 217, 217,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 218, 222, 222, 226, 231, 232, 232, 232, 231, 232, 232, 232, 226, 234,
234, 231, 234, 237, 234, 237, 234, 231, 234, 234, 234, 237, 238, 238, 238, 238,
238, 241, 241, 241, 235, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 185, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 169, 169, 169, 203,
185, 185, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 203,
217, 203, 215, 217, 217, 222, 222, 217, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 218, 222, 222, 226, 237, 232, 232, 232, 237, 237, 234, 234, 234, 234,
234, 237, 237, 237, 234, 237, 234, 237, 237, 234, 239, 237, 239, 239, 240, 239,
239, 241, 241, 241, 242, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 185, 185, 169, 169, 215, 169, 169, 169, 169, 169, 215, 215, 217, 215, 203,
217, 217, 185, 203, 203, 217, 217, 217, 217, 203, 217, 203, 217, 217, 215, 217,
215, 217, 203, 215, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 217,
217, 203, 215, 217, 217, 217, 217, 217, 222, 217, 215, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 222, 222, 217, 215, 222, 217, 222, 222,
217, 217, 237, 222, 222, 226, 237, 237, 237, 237, 237, 237, 237, 234, 228, 234,
237, 237, 237, 237, 240, 237, 237, 237, 237, 234, 238, 237, 238, 241, 240, 241,
241, 244, 242, 240, 244, 244, 244, 242, 244, 244, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 203, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 169, 217, 217, 203,
203, 203, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 203,
217, 203, 217, 217, 217, 222, 222, 222, 203, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 222, 222, 222, 234, 237, 237, 237, 237, 237, 237, 237, 237, 234, 234,
237, 237, 237, 237, 234, 237, 237, 237, 237, 237, 237, 237, 239, 241, 241, 241,
241, 242, 241, 242, 242, 242, 242, 245, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 203, 185, 169, 169, 169, 185, 169, 169, 169, 185, 215, 217, 217, 217, 203,
217, 203, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 222,
217, 203, 217, 217, 217, 222, 222, 217, 222, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 237, 222, 222, 234, 237, 237, 237, 237, 237, 237, 237, 237, 234, 234,
237, 237, 237, 237, 234, 237, 237, 237, 237, 237, 237, 237, 239, 241, 241, 241,
241, 242, 242, 242, 242, 242, 242, 246, 243, 243, 243, 243, 243, 243, 243, 243,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
185, 203, 203, 169, 169, 169, 185, 169, 169, 217, 203, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
215, 217, 203, 217, 217, 217, 215, 217, 217, 217, 215, 217, 222, 217, 217, 222,
217, 203, 217, 217, 217, 222, 222, 217, 222, 222, 217, 217, 217, 222, 217, 222,
215, 222, 217, 222, 217, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 222,
222, 222, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 234, 237, 237, 237, 237, 237, 237, 237, 241, 241, 242, 241,
242, 242, 242, 242, 244, 242, 246, 246, 246, 246, 248, 243, 243, 243, 243, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 203,
203, 203, 203, 169, 203, 169, 203, 203, 203, 203, 203, 215, 217, 203, 217, 203,
203, 203, 203, 203, 203, 203, 217, 203, 203, 203, 203, 203, 203, 217, 217, 222,
217, 222, 203, 217, 222, 217, 215, 222, 222, 222, 217, 222, 222, 222, 222, 203,
222, 203, 217, 222, 222, 222, 222, 222, 203, 222, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222,
222, 222, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 236, 237, 237, 237, 236, 237, 241, 242, 241,
241, 242, 245, 242, 242, 245, 245, 245, 245, 245, 245, 245, 245, 243, 251, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 203, 185, 169, 169, 215, 169, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 217, 203, 203, 217, 217, 217, 217, 203, 217, 203, 217, 217, 215, 217,
215, 217, 217, 215, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 222,
217, 203, 215, 217, 217, 217, 222, 217, 222, 217, 217, 217, 215, 217, 217, 217,
215, 217, 215, 217, 217, 217, 217, 217, 222, 222, 222, 217, 222, 222, 222, 222,
222, 217, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 240, 237,
237, 237, 237, 237, 240, 237, 237, 237, 237, 237, 241, 237, 241, 241, 240, 242,
242, 242, 242, 244, 244, 244, 244, 246, 244, 248, 248, 248, 248, 249, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
185, 203, 185, 169, 169, 215, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 217, 203, 203, 217, 217, 217, 217, 203, 217, 203, 217, 217, 217, 217,
215, 217, 222, 217, 217, 217, 215, 217, 217, 217, 215, 217, 217, 217, 217, 222,
217, 222, 215, 217, 217, 217, 222, 217, 222, 222, 217, 217, 215, 217, 217, 217,
215, 217, 217, 217, 217, 217, 217, 217, 222, 222, 222, 217, 222, 222, 222, 222,
222, 217, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 240, 237,
237, 237, 237, 237, 240, 237, 237, 237, 237, 237, 241, 237, 241, 241, 244, 242,
242, 242, 242, 244, 244, 246, 244, 246, 248, 248, 248, 248, 249, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
203, 203, 203, 169, 169, 217, 203, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 203, 203, 217, 217, 217, 217,
217, 217, 203, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 203, 217, 222, 217, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222, 237,
222, 222, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 241, 241, 242, 242,
242, 242, 246, 246, 246, 246, 246, 246, 248, 248, 249, 249, 249, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 222, 203, 217, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 222, 217, 217, 217, 222, 222, 222, 222, 222, 217, 222, 217, 222, 217, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 217, 222, 222, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 242, 242, 244, 242,
242, 246, 246, 244, 246, 246, 248, 248, 248, 248, 249, 249, 251, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 185,
169, 169, 169, 169, 169, 169, 169, 169, 185, 169, 169, 185, 169, 169, 169, 169,
169, 169, 185, 185, 169, 169, 169, 169, 169, 169, 169, 203, 169, 203, 203, 203,
203, 203, 203, 217, 217, 217, 203, 217, 203, 217, 203, 215, 217, 217, 217, 203,
217, 203, 203, 203, 203, 217, 217, 217, 222, 203, 203, 203, 222, 217, 217, 222,
217, 222, 203, 217, 222, 217, 215, 222, 222, 222, 217, 222, 222, 222, 222, 222,
222, 203, 217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 217, 222, 222, 222,
217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 222, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 247, 247, 242, 246,
246, 246, 245, 246, 246, 246, 246, 245, 249, 249, 249, 251, 251, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 203, 203, 203, 217, 217, 217, 217, 203, 222, 203, 217, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 222, 217, 222, 217, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237,
237, 237, 237, 237, 247, 237, 237, 237, 237, 247, 247, 247, 247, 247, 244, 246,
246, 246, 246, 246, 246, 246, 248, 248, 248, 249, 249, 251, 251, 251, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 185, 169, 169, 169, 169, 169, 169, 169, 169, 169, 217, 203, 217, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 203, 203, 217, 217, 217, 217, 203, 222, 203, 217, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 217, 217, 217, 217, 217, 222, 217, 217, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 222, 222, 237, 237, 237, 237,
237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 247, 247, 247, 247,
247, 237, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 246, 246, 246, 248, 248, 248, 249, 249, 249, 251, 251, 251, 252, 252, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 203, 169, 169, 169, 217, 217, 217, 217, 217, 217, 217, 203, 217, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 222, 203, 217, 217, 217, 217, 203, 222, 222, 222, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 222, 222, 217, 217, 222, 222, 217, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 222, 222, 222, 222, 222, 237, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 249, 250, 251, 251, 251, 252, 252, 253, 253,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
169,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 203, 203, 169, 169, 217, 217, 217, 217, 217, 217, 217, 217, 217, 203,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 222, 203, 217, 217, 217, 217, 203, 222, 222, 222, 217, 217, 217,
217, 217, 222, 217, 217, 217, 215, 222, 222, 217, 217, 222, 222, 217, 222, 222,
222, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 222, 222, 222,
217, 222, 217, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 250, 250, 251, 251, 252, 252, 252, 253, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 203,
217, 217, 222, 222, 203, 217, 217, 217, 217, 203, 222, 222, 222, 217, 217, 217,
217, 217, 222, 217, 222, 217, 215, 222, 222, 217, 217, 222, 222, 217, 222, 222,
222, 222, 217, 222, 222, 222, 222, 222, 222, 222, 217, 222, 217, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 250, 250, 250, 252, 252, 252, 253, 253, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 203, 169, 169, 203, 169, 217, 169, 217,
217, 217, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 222,
203, 203, 203, 217, 217, 217, 217, 217, 217, 217, 217, 215, 217, 217, 217, 222,
217, 222, 222, 222, 203, 217, 217, 217, 217, 222, 222, 222, 222, 217, 217, 222,
217, 222, 222, 217, 222, 217, 215, 222, 222, 222, 217, 222, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 250, 250, 250, 250, 250, 250, 250, 252, 252, 252, 253, 254, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 203,
169, 169, 217, 217, 217, 217, 217, 217, 203, 217, 217, 203, 217, 217, 217, 217,
217, 217, 203, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 222,
222, 203, 222, 217, 217, 217, 222, 217, 217, 217, 222, 217, 217, 217, 217, 222,
222, 222, 222, 222, 203, 217, 217, 222, 222, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 250, 247, 250, 250, 250, 250, 250, 250, 250, 253, 253, 253, 254, 254, 254,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,  72,
 72,  72,  72,  72,  72,  72,  72,  72,  72,  72, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 217, 217, 217, 217, 217, 217, 203,
217, 217, 217, 217, 217, 217, 217, 217, 222, 217, 217, 222, 217, 217, 217, 217,
217, 217, 222, 222, 217, 217, 217, 217, 217, 217, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 250, 247, 250, 250, 250, 250, 250, 253, 253, 254, 254, 254, 254, 254, 255
};

UInt8 hvqelut_4x2_1[] = {
  0,   1,   1,   1,   4,   1,   1,   1,   1,   4,   4,   4,   4,   4,   4,   4,
  4,   4,   4,   4,   4,   4,   4,   3,   4,   4,   4,   4,  14,  14,  14,  14,
 14,  14,  14,   4,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  25,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  46,  58,  46,  14,  46,  14,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  46,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  46,  46,  58,  46,  46,  46,  46,  58,  58,  46,  58,  46,  58,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  58,  58,  46,  46,
 58,  58, 129, 129, 129,  58, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  0,   1,   3,   1,   4,   5,   5,   5,   5,   5,   5,   5,   5,   5,   5,  10,
  4,  10,   4,  11,  10,  13,  13,   3,   4,  13,  13,   4,  11,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,
 14,  14,  14,  14,  14,  14,  14,  14,  25,  14,  14,  14,  14,  14,  14,  14,
 14,  46,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  14,  46,
 14,  46,  39,  46,  39,  46,  14,  46,  14,  14,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  39,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  46,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  46,  46,  58,  46,  46,  46,  46,  58,  58,  46,  58,  46,  58,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  58, 129, 129, 129,
129, 129, 129, 129, 129,  58, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   3,   5,   4,   5,   5,   6,   6,   6,   6,   6,  10,  10,  13,  13,
 13,  13,  13,  11,  13,  13,  13,   3,  13,  13,  13,  13,  13,  13,  13,  13,
 13,  13,  13,  24,  13,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 30,  14,  14,  14,  14,  30,  14,  14,  14,  33,  14,  14,  14,  14,  14,  39,
 14,  14,  14,  14,  14,  39,  46,  39,  25,  14,  14,  46,  39,  39,  14,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  39,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  46,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  39,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  69,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  46,  46,  58,  46,  69,  46,  46,  58,  58,  69,  58,  46,  58,  46,  46,
 69,  69,  69,  46, 129,  69,  46, 129, 129, 129, 129,  58, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   1,   3,   5,   4,   5,   7,   6,   6,   6,   6,   6,  10,  10,  10,  10,
 13,  13,  13,  11,  13,  13,  13,   3,  13,  13,  13,  17,  17,  17,  13,  13,
 13,  13,  13,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 24,  24,  14,  33,  14,  30,  14,  14,  14,  33,  14,  14,  14,  14,  39,  39,
 14,  14,  14,  14,  14,  39,  46,  39,  25,  14,  33,  46,  39,  39,  14,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  39,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  46,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  39,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  58,  46,  46,  46,  46,  46,  46,  58,  46,  46,  58,  69,  46,
 46,  46,  46,  46,  58,  58,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,
 46,  69,  69,  58,  69,  69,  69,  69,  58,  58,  69,  58,  46,  69,  69,  69,
 69,  69,  69,  46,  69,  69,  69, 129, 129, 129, 129,  58, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  1,   5,   5,   5,   4,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  25,  19,  19,  19,  19,  19,  19,  19,
 19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  19,  46,  46,  46,
 46,  46,  39,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  69,  46,  46,  46,  69,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  69,  58,  46,  46,
 46,  46,  69,  69,  46,  46,  69,  46,  46,  69,  69,  46,  46,  69,  69,  46,
 69,  69,  69,  46,  58,  69,  46,  46,  69,  46,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   6,   6,   4,   6,   7,   8,   8,   8,   8,   8,  10,  10,  10,  10,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  17,  17,  13,  13,
 13,  13,  24,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  39,  39,
 24,  24,  45,  33,  43,  39,  46,  39,  25,  39,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  39,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  46,  58,  46,  46,
 46,  46,  58,  69,  46,  46,  69,  46,  46,  46,  58,  46,  46,  58,  69,  46,
 69,  69,  69,  46,  58,  58,  46,  46,  69,  46,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  69,  69,  69,
 69,  69,  69,  69, 129,  69,  69, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   5,   5,   4,   6,   7,   8,   8,   8,   8,   8,  10,  10,  10,  10,
 10,  10,  17,  11,  17,  10,  17,  30,  17,  17,  17,  17,  11,  17,  17,  17,
 17,  13,  17,  17,  17,  17,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  24,  24,  24,  45,  39,
 24,  24,  45,  33,  43,  45,  46,  39,  30,  39,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  69,  46,  46,  69,  58,  46,  46,
 69,  69,  58,  69,  69,  69,  69,  46,  69,  69,  69,  69,  69,  58,  69,  46,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  69,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  69,  69,  69,
 69,  69,  69,  69,  69,  69,  69,  69, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   6,   4,   6,   7,   8,   8,   8,   9,   9,   9,  10,  10,  10,
 13,  10,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  13,  13,
 13,  20,  24,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  33,  24,  33,  33,  30,  24,  30,  39,  39,
 24,  33,  45,  33,  33,  39,  43,  39,  25,  39,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  39,  39,  39,  46,  39,  39,  39,  46,  39,  39,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  58,  46,  61,  46,
 46,  46,  46,  58,  46,  46,  46,  58,  46,  46,  46,  46,  69,  58,  46,  46,
 46,  46,  58,  58,  46,  69,  69,  46,  46,  69,  58,  46,  69,  58,  69,  46,
 69,  69,  69,  46,  58,  58,  46,  46,  69,  46,  69,  58,  46,  69,  69,  69,
 58,  69,  69,  58,  69,  81,  69,  69,  58,  58,  69,  58,  69,  58,  69,  69,
 69,  69,  69,  69, 129,  69,  69, 129, 104, 129, 129,  58, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   6,   6,   6,   8,   7,   8,   8,   8,   8,   8,  10,  10,  10,  10,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  13,  24,
 13,  20,  24,  24,  24,  24,  17,  24,  24,  17,  24,  24,  24,  24,  30,  24,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  39,  39,
 43,  43,  45,  33,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  39,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  39,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  46,  69,  58,  46,  46,
 46,  46,  58,  69,  69,  69,  69,  46,  69,  69,  69,  46,  69,  58,  69,  46,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  46,  69,  69,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  69,  69,  69,
 69,  69, 129,  69, 129,  81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   5,   6,   6,  10,   8,   8,   8,   8,   8,   9,   9,  10,  10,  10,  13,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  13,  24,
 20,  20,  24,  24,  24,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  39,  39,
 43,  43,  43,  43,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  43,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  46,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  46,  46,  46,  46,  58,  46,  69,  46,  46,  69,  58,  46,  46,
 69,  69,  69,  69,  69,  69,  69,  46,  69,  69,  69,  69,  69,  58,  81,  46,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  69,  69,  81,  46,  69,  69,  69,
 69,  69,  69,  69,  69,  81,  69,  69,  58,  58,  69,  58,  69,  81,  69,  69,
 69, 129, 129,  69, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   6,  10,   8,   7,   8,   8,   9,   9,   9,   9,  10,  12,  13,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  24,  24,
 20,  20,  24,  24,  24,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 34,  24,  24,  33,  24,  30,  33,  24,  24,  33,  24,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  43,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  69,  46,  46,  46,  58,  46,  69,  46,  46,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58,  58,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  69,  69,  81,  69,  81,  69,  69,  58,  58,  69,  58,  69,  81,  69,  69,
 81, 129, 129,  69, 129,  81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   6,  10,   8,   7,   9,   9,   9,   9,   9,   9,  12,  12,  13,
 13,  13,  17,  11,  13,  13,  13,   3,  13,  13,  13,  17,  20,  17,  24,  24,
 20,  20,  24,  24,  24,  24,  17,  24,  24,  24,  24,  24,  24,  24,  30,  30,
 34,  24,  24,  33,  24,  30,  33,  30,  24,  33,  24,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  39,  43,  39,  25,  43,  33,  46,  39,  39,  43,  39,
 39,  46,  46,  46,  46,  46,  46,  46,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  39,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  46,  46,  46,  58,  46,  46,  46,  61,  46,
 46,  46,  46,  69,  46,  46,  69,  58,  46,  69,  46,  46,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58, 104,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  69,  69,  81,  69,  81,  69,  69,  58,  58,  81,  58,  69,  81,  69,  69,
 81, 129, 129,  69, 129,  81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   8,  10,   9,   7,   9,   9,   9,   9,   9,  12,  12,  12,  12,
 13,  16,  17,  11,  20,  20,  20,  30,  24,  20,  20,  17,  21,  20,  20,  24,
 20,  20,  24,  24,  24,  24,  24,  24,  24,  24,  24,  30,  24,  24,  30,  30,
 34,  24,  24,  33,  30,  30,  33,  30,  43,  33,  43,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  45,  43,  39,  50,  43,  33,  43,  39,  39,  43,  39,
 43,  46,  46,  43,  43,  43,  46,  43,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  61,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  69,  46,  46,  58,  46,  58,  46,  61,  46,
 46,  46,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58, 104,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  81,  81,  81,  69,  81,  81,  81, 104,  89,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   6,   8,  10,   9,   9,   9,   9,   9,   9,  12,  12,  12,  12,  12,
 13,  20,  17,  11,  20,  20,  20,  30,  24,  20,  20,  17,  21,  20,  20,  24,
 20,  20,  24,  24,  24,  24,  24,  24,  24,  24,  24,  30,  24,  24,  30,  30,
 34,  24,  24,  33,  43,  30,  33,  30,  43,  33,  43,  30,  43,  30,  45,  39,
 43,  43,  43,  43,  43,  45,  43,  39,  25,  43,  33,  43,  39,  39,  43,  39,
 43,  46,  46,  43,  43,  43,  46,  43,  45,  46,  46,  46,  46,  46,  39,  46,
 46,  46,  61,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  46,  46,  46,  69,  46,  46,  58,  46,  69,  46,  61,  46,
 46,  46,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69,  58, 104,  46,  69,  69,  69,  69,  81,  69,  69,  69,  69,
 69,  81,  81,  81,  69,  81,  81,  81, 104,  89,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   8,   8,  10,   9,  15,   9,  15,  15,  15,  15,  15,  15,  15,  16,
 20,  16,  17,  17,  21,  20,  20,  30,  20,  20,  20,  17,  21,  20,  20,  20,
 20,  20,  24,  24,  24,  24,  27,  24,  24,  24,  34,  30,  24,  24,  30,  30,
 34,  34,  34,  33,  43,  30,  33,  43,  43,  33,  43,  30,  43,  43,  45,  33,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  33,  43,  39,  45,  43,  39,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  46,  46,  46,  46,  39,  46,
 46,  46,  61,  46,  45,  46,  39,  46,  39,  39,  46,  46,  46,  46,  46,  46,
 46,  46,  46,  46,  69,  69,  69,  69,  69,  46,  58,  69,  89,  69,  61,  69,
 46,  46,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  81,  69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  58,  81,  69,
 69,  69,  69,  69, 104, 104,  69,  69,  69,  89,  69,  81,  69,  81,  69,  69,
 89,  81,  81,  81,  81,  81,  81,  81, 104,  89,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   8,   9,  10,   9,  15,   9,  15,  12,  15,  15,  15,  16,  16,  16,
 20,  16,  17,  17,  20,  20,  20,  30,  20,  20,  20,  17,  21,  27,  20,  20,
 20,  20,  27,  24,  24,  24,  27,  24,  24,  24,  34,  30,  34,  34,  30,  30,
 34,  34,  43,  33,  43,  30,  33,  43,  43,  33,  43,  30,  43,  43,  45,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  33,  43,  39,  45,  43,  39,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  46,  46,  46,  46,  65,  46,
 46,  46,  61,  46,  45,  46,  65,  46,  39,  65,  46,  46,  46,  46,  69,  46,
 46,  46,  46,  46,  69,  69,  69,  69,  69,  46,  58,  69,  89,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  46,  69,  69,  58,  69,  46,
 69,  69,  81,  69,  69,  69,  69,  69,  69,  69,  81,  69,  69,  58,  81,  69,
 69,  81,  69,  69, 104, 104,  69,  69,  81,  89,  69,  81,  69,  81,  81,  69,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  69,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  10,   9,  15,  12,  12,  12,  12,  12,  16,  16,  16,  16,
 20,  20,  17,  17,  20,  20,  20,  50,  20,  20,  20,  17,  27,  27,  26,  26,
 26,  26,  26,  24,  34,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  43,  30,  43,  30,  43,  43,  43,  33,  43,  30,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  45,  50,  43,  43,  43,  39,  45,  43,  43,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  46,  65,  46,
 46,  46,  61,  46,  45,  46,  65,  46,  69,  65,  46,  69,  46,  46,  69,  46,
 69,  46,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  89,  69,  58,  69,  46,
 69,  69,  81,  69,  69,  69,  81,  69,  69,  69,  81,  69,  69,  81,  81,  69,
 69,  81,  69,  69, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  69,  81,  81,  81,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  10,  15,  15,  15,  15,  15,  15,  15,  15,  15,  16,  16,
 20,  16,  17,  17,  21,  20,  20,  50,  26,  26,  26,  17,  27,  27,  26,  26,
 26,  26,  26,  24,  27,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  34,  33,  43,  30,  33,  43,  43,  33,  43,  30,  43,  43,  45,  33,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  33,  43,  39,  45,  43,  39,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  65,  46,
 46,  46,  61,  46,  45,  46,  65,  46,  65,  65,  46,  69,  46,  46,  69,  46,
 69,  46,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  89,  69,  69,  69,  58,  69,  69,  69,  89,  69,  58,  69,  46,
 69,  69,  83,  69,  69,  69,  81,  69,  69,  69,  81,  69,  69,  58,  81,  69,
 69,  81,  69,  69, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81, 104,  81,  81,  81,  81, 104, 114,  81, 104,  69, 104,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   6,   9,   9,  10,  12,  15,  12,  12,  12,  12,  16,  16,  16,  16,  20,
 20,  20,  17,  17,  20,  20,  20,  30,  20,  20,  27,  17,  27,  27,  27,  34,
 34,  34,  34,  24,  34,  34,  34,  34,  34,  34,  34,  30,  34,  34,  30,  43,
 34,  43,  43,  43,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  43,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  46,  46,  46,  46,  69,  46,
 46,  46,  61,  46,  45,  69,  69,  46,  69,  69,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  69,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  69,  81,  58,  69,  46,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  69,  81,  81,  69,
 81,  81,  81,  69, 104,  81,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81,  81,  81,  81,  81,  81,  81, 114,  81, 104,  81,  81,  81,  81,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   7,   9,  15,  15,  15,   7,  15,  15,  15,  15,  21,  21,  21,  21,  21,
 21,  21,  21,  11,  21,  21,  21,  30,  21,  21,  27,  21,  32,  27,  27,  27,
 27,  27,  27,  24,  27,  27,  32,  27,  27,  32,  34,  34,  34,  34,  30,  34,
 34,  34,  43,  33,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  45,  45,
 43,  43,  56,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  45,
 43,  46,  43,  43,  43,  43,  43,  56,  45,  43,  43,  43,  45,  46,  67,  46,
 69,  46,  61,  69,  45,  69,  45,  69,  45,  69,  46,  69,  69,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  69,  69,  61,  69,
 69,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  69,  81,  58,  69,  69,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  69,  81,  81,  69,
 81,  81,  81,  69, 104, 104,  69,  69,  81,  69,  81,  81,  69,  81,  81,  81,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  81,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  15,  15,  15,  15,  15,  15,  15,  15,  15,  15,  21,  21,
 20,  21,  17,  17,  21,  21,  21,  30,  26,  27,  27,  27,  27,  27,  27,  27,
 27,  27,  27,  24,  27,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  34,
 34,  34,  34,  33,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  45,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  46,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  45,  67,  67,  46,
 46,  46,  61,  46,  45,  69,  65,  46,  65,  65,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  69,  69,  69,  69,  58,  69,  69,  69,  89,  81,  58,  69,  46,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  69, 104,  81,  69,
 81,  81,  81,  69, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  81,  81,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,   9,   9,  15,  15,  15,  15,  15,  15,  15,  15,  16,  16,  16,  16,
 23,  23,  20,  17,  21,  23,  23,  50,  26,  26,  26,  27,  27,  27,  26,  26,
 26,  26,  27,  24,  34,  24,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  30,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 46,  46,  61,  46,  45,  69,  65,  46,  65,  65,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 46,  69,  69,  89,  69,  69,  69,  58,  69,  69,  69,  89,  81,  58,  69,  46,
 69,  69,  81,  81,  69,  69,  81,  69,  69,  69,  81,  69,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
 89,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  81, 104,  81,  81,
 81, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  15,  15,  15,  15,  22,  15,  15,  15,  15,  16,  16,  23,  23,
 23,  23,  26,  21,  21,  23,  23,  50,  26,  26,  26,  27,  27,  27,  26,  26,
 26,  28,  27,  24,  34,  34,  27,  34,  34,  34,  34,  30,  34,  34,  30,  30,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  45,  43,  45,  50,  43,  43,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 43,  46,  61,  69,  61,  69,  65,  46,  65,  65,  46,  69,  46,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  58,  69,  69,  69,  89,  81,  58,  69,  46,
 69,  69,  83,  81,  69,  81,  81,  69,  81,  81,  81,  69,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  69,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114,  81, 104,  81, 104, 114,  81,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  3,   3,  25,   3,   3,   3,  22,   3,   3,   3,   3,   3,   3,   3,  50,  50,
 50,  50,  50,  26,  50,  50,  50,  25,  50,  50,  50,  50,  31,  50,  50,  50,
 50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,  25,  50,
 50,  50,  50,  50,  50,  25,  50,  50,  50,  75,  75,  50,  50,  50,  75,  75,
 75,  75,  47,  75,  75,  75,  75,  75,  77,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  61,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  61,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  81,  75,
 75,  75,  75,  75, 104, 104,  75,  75,  75,  75,  75, 114,  75, 114,  75, 114,
 75, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   8,  12,  15,  15,  15,  15,  16,  16,  16,  16,  16,  16,  16,  23,  23,
 23,  23,  26,  21,  23,  23,  26,  50,  26,  26,  26,  27,  27,  27,  27,  34,
 34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  30,  34,  34,  30,  34,
 34,  34,  43,  43,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  43,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 69,  46,  61,  69,  61,  69,  65,  69,  69,  65,  46,  69,  69,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  81,  81,  81,  81,  81,  69,  81,  81,  81,  69,  81,  81,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81,  81,  81,  81,  81,  81, 114, 114,  81, 104,  81, 114, 114, 114,
114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  15,  22,  22,  22,  22,  22,  16,  16,  23,  23,
 23,  23,  26,  21,  23,  23,  26,  50,  26,  26,  26,  27,  27,  27,  26,  31,
 31,  28,  31,  38,  34,  34,  27,  34,  34,  34,  34,  30,  34,  34,  30,  34,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  43,  45,
 43,  43,  43,  43,  43,  43,  43,  43,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  43,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 67,  46,  61,  69,  61,  69,  65,  69,  65,  65,  46,  69,  67,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  46,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  83,  81,  81,  81,  81,  69,  81,  81,  81,  81,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81,  81,  69,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  15,  22,  22,  22,  22,  22,  22,  22,  23,  23,
 23,  23,  26,  21,  23,  23,  26,  50,  26,  26,  28,  27,  27,  27,  28,  31,
 28,  28,  31,  38,  34,  38,  27,  34,  34,  38,  34,  30,  34,  34,  30,  34,
 34,  34,  34,  30,  43,  30,  43,  43,  43,  33,  43,  49,  43,  43,  48,  45,
 43,  43,  56,  43,  43,  45,  43,  45,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  67,  43,  45,  43,  43,  43,  43,  67,  67,  46,
 67,  46,  61,  69,  61,  67,  65,  67,  65,  65,  69,  69,  67,  69,  69,  46,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  83,  81,  81,  81,  81,  69,  81,  81,  81,  81,  81, 104,  81,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114, 114, 104,  81, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   8,  22,  15,  15,  15,  21,  15,  15,  15,  21,  21,  21,  21,  21,  21,
 21,  21,  21,  21,  21,  27,  27,  50,  27,  27,  27,  27,  32,  27,  27,  27,
 27,  27,  27,  38,  34,  34,  27,  34,  34,  34,  34,  34,  34,  34,  30,  34,
 34,  34,  43,  43,  43,  30,  43,  43,  43,  33,  43,  43,  43,  43,  56,  45,
 43,  43,  56,  43,  43,  56,  43,  45,  50,  43,  43,  43,  45,  45,  43,  43,
 43,  43,  43,  43,  43,  43,  43,  43,  56,  43,  43,  43,  56,  67,  67,  46,
 69,  69,  61,  69,  61,  69,  65,  69,  69,  65,  69,  69,  69,  69,  69,  69,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  69,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81,  81,  81,  81,  81,  81,
114,  81,  81,  81,  81,  81,  81,  81, 104, 114,  81, 104,  81,  81,  81,  81,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 21,  21,  21,  32,  32,  32,  32,  50,  32,  32,  32,  32,  32,  32,  32,  32,
 32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  38,  38,  38,  30,  38,
 32,  38,  38,  33,  38,  30,  48,  38,  48,  33,  48,  49,  48,  49,  56,  45,
 48,  48,  56,  48,  48,  56,  48,  45,  50,  48,  67,  56,  45,  45,  48,  67,
 67,  56,  49,  67,  56,  56,  67,  56,  56,  67,  56,  67,  56,  67,  67,  46,
 67,  56,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  56,  67,  67,
 65,  56,  67,  67,  67,  65,  67,  65,  67,  69,  83,  69,  67,  69,  61,  69,
 69,  69,  69,  89,  69,  69,  69,  83,  69,  81,  69,  89,  81,  58,  69,  69,
 81,  81,  83,  83,  81,  81,  81,  69,  81,  81,  83,  81,  81, 104,  83,  69,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
 89,  81,  81, 104,  81, 104,  81,  81, 104, 114, 104, 104,  81, 104,  81,  81,
104, 104, 114, 129, 129, 120, 129, 129, 104, 129, 129, 129, 104, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  22,  22,  22,  22,  22,  22,  22,  22,  21,  23,
 23,  23,  21,  32,  21,  28,  28,  50,  28,  28,  28,  27,  32,  27,  28,  28,
 28,  28,  27,  38,  36,  38,  32,  34,  38,  38,  34,  38,  34,  38,  30,  34,
 34,  38,  38,  49,  43,  30,  48,  43,  43,  33,  48,  49,  43,  49,  56,  45,
 43,  43,  56,  43,  43,  56,  43,  45,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  67,  43,  56,  43,  43,  67,  56,  67,  67,  46,
 67,  43,  61,  69,  61,  67,  65,  67,  65,  65,  69,  69,  67,  69,  69,  89,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  69,  81,  81,  83,  69,  81,  69,  89,  81,  58,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
114,  81,  81, 104,  81,  81,  81,  81, 104, 114, 114, 104,  81, 104, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,   2,  22,  22,  15,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  23,
 23,  23,  26,  21,  28,  28,  28,  50,  26,  28,  28,  27,  28,  28,  28,  31,
 28,  28,  31,  38,  31,  38,  27,  34,  38,  38,  34,  38,  38,  38,  30,  38,
 34,  38,  38,  49,  49,  30,  48,  49,  48,  33,  48,  49,  43,  49,  48,  45,
 43,  43,  56,  43,  43,  56,  43,  45,  50,  43,  67,  43,  45,  45,  43,  65,
 43,  43,  43,  43,  43,  43,  67,  43,  56,  43,  43,  67,  43,  67,  67,  46,
 67,  43,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  65,  89,
 69,  69,  69,  69,  69,  69,  69,  69,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  69,  81,  69,  89,  81,  58,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69,  81,  81,  89,  81, 104,  81,  81,  81,  81,
114,  81,  81, 104, 114,  81, 114,  81, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 129, 114, 129, 129, 129, 129, 129, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  23,
 23,  28,  26,  21,  28,  28,  28,  50,  28,  28,  28,  27,  28,  28,  28,  31,
 31,  31,  31,  38,  31,  38,  36,  31,  38,  38,  34,  38,  38,  38,  30,  38,
 34,  38,  38,  49,  49,  30,  49,  49,  49,  33,  48,  49,  49,  49,  48,  48,
 49,  49,  56,  49,  49,  48,  43,  48,  50,  43,  67,  43,  65,  45,  43,  65,
 43,  43,  49,  43,  43,  43,  49,  43,  56,  43,  43,  67,  43,  67,  67,  46,
 67,  43,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  65,  89,
 69,  69,  69,  69,  69,  69,  69,  65,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69, 114,  81,  89,  81, 104,  81,  81,  81, 114,
114,  81,  81, 104, 114, 104, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 114, 114, 129, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 22,  22,  26,  32,  28,  28,  28,  50,  28,  28,  28,  28,  32,  28,  28,  36,
 36,  36,  36,  38,  36,  38,  36,  36,  38,  38,  36,  38,  38,  38,  30,  38,
 44,  38,  38,  49,  49,  30,  48,  49,  48,  33,  48,  49,  44,  49,  48,  48,
 48,  49,  56,  48,  49,  48,  49,  48,  50,  49,  67,  49,  65,  45,  49,  65,
 49,  53,  49,  49,  49,  49,  67,  48,  56,  67,  67,  67,  65,  67,  67,  70,
 67,  70,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  65,  67,
 65,  69,  67,  67,  67,  65,  67,  65,  67,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  89,  81,  81,  81,  81,  81,  89,  83,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104,  69, 114,  81,  89,  81, 104,  81,  81,  81, 114,
114,  81,  81, 104, 114, 104, 114, 114, 104, 114, 114, 104, 114, 104, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 22,  22,  22,  32,  22,  22,  29,  50,  28,  28,  28,  28,  32,  28,  36,  36,
 36,  36,  36,  38,  36,  36,  36,  36,  38,  38,  36,  38,  38,  38,  30,  38,
 42,  38,  38,  49,  38,  47,  48,  49,  48,  33,  48,  49,  44,  49,  48,  48,
 48,  48,  48,  48,  49,  48,  49,  63,  50,  49,  67,  49,  65,  45,  49,  65,
 67,  53,  49,  67,  49,  49,  67,  48,  56,  67,  67,  67,  65,  67,  67,  70,
 67,  67,  61,  67,  61,  65,  65,  67,  65,  65,  67,  67,  67,  65,  65,  67,
 65,  56,  67,  67,  65,  65,  67,  65,  67,  89,  83,  65,  89,  69,  61,  69,
 69,  69,  69,  89,  81,  81,  81,  83,  89,  83,  69,  89,  83, 104,  81,  69,
 81,  81,  83,  83,  81,  81,  81,  81,  81,  89,  83,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104,  69,  89,  81,  89,  81, 104,  81,  81,  81, 114,
 89, 104,  81, 104, 114, 104, 114, 104, 104, 114, 104, 104, 114, 104, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 114, 114, 104, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,
 28,  28,  26,  32,  28,  28,  28,  50,  28,  28,  28,  27,  32,  28,  36,  36,
 36,  36,  36,  38,  36,  38,  36,  36,  38,  38,  37,  38,  38,  38,  30,  38,
 44,  38,  48,  49,  49,  49,  48,  49,  48,  33,  48,  49,  49,  49,  48,  48,
 48,  49,  56,  48,  49,  56,  49,  48,  50,  49,  67,  43,  65,  45,  49,  65,
 49,  43,  49,  49,  43,  43,  49,  43,  56,  67,  43,  67,  56,  67,  67,  70,
 67,  70,  61,  67,  61,  67,  65,  67,  65,  65,  69,  67,  67,  69,  67,  89,
 69,  69,  69,  69,  69,  69,  69,  65,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104,  69, 114,  81,  89,  81, 104,  81,  81,  81, 114,
114,  81,  81, 104, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 114, 114, 129, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  15,  22,  21,  22,  22,  22,  23,  23,  23,  23,  23,  23,
 28,  28,  26,  27,  28,  28,  28,  50,  31,  31,  28,  27,  27,  34,  34,  34,
 34,  34,  34,  38,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  30,  49,
 34,  43,  43,  49,  43,  49,  43,  43,  43,  43,  43,  49,  43,  43,  43,  48,
 43,  43,  56,  43,  43,  56,  43,  43,  50,  43,  49,  43,  45,  45,  43,  43,
 43,  84,  43,  43,  43,  43,  49,  43,  56,  43,  43,  43,  43,  67,  67,  84,
 69,  84,  61,  69,  61,  69,  65,  69,  65,  65,  84,  69,  89,  69,  69,  89,
 69,  69,  69,  69,  69,  81,  69,  81,  69,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  84,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,
 81,  81,  81,  81, 104, 104, 107, 114,  81, 114,  81,  81, 107,  81, 114, 114,
114,  81,  81, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,
 29,  29,  28,  32,  28,  28,  28,  50,  28,  28,  28,  28,  32,  36,  36,  36,
 36,  36,  36,  38,  36,  38,  36,  37,  38,  38,  37,  38,  38,  38,  30,  38,
 44,  38,  48,  49,  49,  47,  48,  49,  48,  48,  48,  49,  53,  49,  48,  48,
 48,  49,  56,  48,  49,  56,  49,  48,  50,  49,  67,  49,  65,  45,  49,  65,
 49,  70,  49,  49,  49,  49,  49,  48,  56,  67,  70,  67,  56,  67,  67,  70,
 67,  70,  61,  67,  61,  67,  65,  67,  65,  65,  80,  67,  67,  69,  67,  89,
 69,  69,  69,  67,  69,  81,  69,  65,  67,  69,  83,  69,  89,  69,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104, 107, 114,  81,  89,  81, 104,  81,  81, 114, 114,
114, 114,  81, 104, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  28,
 28,  28,  28,  32,  28,  28,  28,  50,  28,  28,  28,  27,  32,  36,  36,  31,
 37,  37,  37,  38,  37,  38,  37,  34,  38,  38,  34,  38,  38,  38,  30,  49,
 44,  48,  48,  49,  49,  49,  48,  49,  48,  48,  48,  49,  49,  49,  48,  48,
 48,  49,  56,  48,  49,  56,  43,  48,  50,  43,  49,  43,  45,  45,  43,  67,
 43,  84,  49,  43,  43,  43,  49,  43,  56,  43,  43,  67,  56,  67,  67,  84,
 67,  70,  61,  69,  61,  67,  65,  67,  65,  65,  69,  69,  67,  69,  69,  89,
 69,  69,  69,  69,  69,  81,  69,  81,  69,  69,  83,  81,  89,  81,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  84,
 81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  81,  81,
 81,  81,  81,  81, 104, 104, 107, 114,  81, 114,  81,  81, 107,  81, 114, 114,
114, 114,  81, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 129, 129, 129, 129, 129, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,
 28,  29,  32,  32,  32,  32,  32,  50,  32,  32,  32,  32,  32,  32,  32,  36,
 32,  32,  32,  38,  32,  32,  32,  36,  38,  32,  36,  38,  38,  38,  30,  44,
 44,  48,  48,  49,  48,  49,  48,  48,  48,  48,  48,  49,  44,  49,  56,  56,
 48,  48,  56,  48,  48,  56,  48,  56,  50,  48,  67,  56,  45,  56,  48,  67,
 56,  56,  49,  67,  56,  56,  67,  56,  56,  56,  56,  67,  56,  67,  67,  80,
 67,  80,  61,  67,  61,  67,  65,  67,  65,  65,  80,  67,  67,  56,  67,  67,
 69,  56,  67,  67,  69,  81,  69,  65,  67,  69,  83,  81,  89,  81,  61,  69,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  81,  81,  81,  81,  81,  81,  81,  81,  81,  81, 104,  83,  81,
 81,  81,  81, 107, 104, 104, 107,  81,  81,  89,  81, 104, 107,  81,  81,  81,
114,  81,  81, 104, 114, 120, 114, 120, 104, 114, 114, 104, 107, 104, 114, 114,
114, 114, 114, 107, 114, 120, 129, 129, 104, 129, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,
 29,  29,  28,  32,  29,  29,  29,  50,  36,  36,  36,  36,  32,  36,  36,  37,
 37,  37,  37,  38,  37,  38,  37,  37,  38,  38,  37,  38,  44,  44,  47,  44,
 44,  44,  48,  49,  49,  47,  48,  49,  48,  48,  48,  49,  53,  49,  48,  48,
 48,  48,  56,  48,  49,  56,  49,  48,  50,  49,  67,  49,  65,  56,  49,  67,
 49,  70,  49,  49,  70,  70,  49,  70,  56,  70,  70,  67,  56,  67,  67,  70,
 67,  80,  61,  80,  61,  67,  65,  67,  65,  65,  80,  67,  67,  80,  67,  89,
 80,  80,  67,  67,  67,  81,  67,  65,  67,  89,  83,  81,  89,  81,  61,  81,
 69,  69,  81,  89,  81,  81,  81,  83,  81,  81,  69,  89,  81, 104,  81,  69,
 81,  81,  83,  89,  81,  81,  81,  81,  81,  89,  81,  89,  81, 104,  83,  81,
 81,  81,  81,  81, 104, 104, 107, 114, 114, 114,  81, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,
 29,  29,  28,  32,  29,  29,  29,  50,  37,  37,  37,  37,  32,  37,  37,  37,
 37,  37,  37,  38,  37,  37,  37,  37,  44,  44,  44,  38,  44,  44,  47,  44,
 44,  44,  48,  49,  49,  47,  48,  49,  48,  48,  48,  49,  53,  49,  48,  48,
 48,  48,  56,  48,  49,  56,  49,  48,  50,  49,  49,  70,  65,  56,  49,  67,
 70,  84,  70,  70,  70,  70,  49,  70,  56,  70,  70,  70,  80,  67,  67,  84,
 80,  80,  61,  80,  61,  80,  65,  80,  65,  65,  80,  67,  67,  80,  67,  89,
 80,  80,  80,  67,  81,  81,  81,  65,  89,  89,  83,  81,  89,  81,  61,  81,
 69,  81,  81,  89,  81,  81,  81,  83,  81,  81,  89,  89,  81, 104,  81,  84,
 81,  81,  83,  89,  81,  81,  81,  81,  81,  81,  81,  89,  81, 104,  83, 107,
 81,  81,  81, 107, 104, 104, 107, 114, 114, 114, 107, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,
 29,  29,  32,  32,  32,  32,  32,  50,  32,  32,  32,  32,  32,  32,  32,  37,
 32,  32,  32,  38,  32,  32,  32,  37,  44,  32,  44,  44,  44,  44,  47,  44,
 44,  44,  48,  49,  48,  49,  48,  48,  48,  48,  48,  49,  53,  49,  56,  56,
 48,  48,  56,  48,  48,  56,  48,  56,  50,  56,  67,  56,  56,  56,  56,  67,
 56,  84,  70,  70,  56,  56,  67,  56,  56,  56,  56,  56,  56,  67,  67,  84,
 80,  80,  61,  80,  56,  80,  67,  80,  65,  65,  80,  67,  67,  56,  67,  89,
 80,  56,  80,  67,  81,  81,  81,  81,  81,  69,  83,  81,  89,  81,  61,  81,
 69,  81,  81,  89,  81,  81,  81,  83,  81,  81, 107,  89,  81, 104,  81, 107,
 81,  81,  83,  81,  81,  81,  81, 107,  81,  81,  81, 107, 107, 104, 120, 107,
107, 107, 107, 107, 104, 104, 107, 107, 107, 114, 107, 120, 107, 107, 107, 107,
114, 107, 107, 120, 107, 120, 107, 120, 104, 114, 114, 104, 107, 120, 114, 120,
120, 114, 114, 107, 114, 120, 107, 114, 120, 114, 129, 114, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  36,  29,  29,  32,  32,  37,  37,  37,
 42,  42,  37,  38,  42,  37,  37,  42,  42,  44,  42,  42,  44,  44,  47,  44,
 44,  44,  53,  49,  53,  59,  48,  49,  53,  48,  48,  49,  53,  47,  48,  63,
 53,  48,  56,  48,  49,  63,  53,  63,  50,  48,  67,  53,  63,  63,  49,  67,
 70,  64,  70,  70,  70,  70,  49,  70,  56,  70,  70,  70,  80,  67,  67,  80,
 80,  80,  61,  80,  61,  80,  65,  80,  65,  65,  80,  67,  67,  80,  67,  89,
 80,  80,  80,  67,  67,  65,  67,  65,  67,  80,  83,  67,  89,  81,  61,  81,
 80,  89,  81,  89,  81,  81,  81,  83,  89,  89,  89,  89,  81, 104,  81,  84,
 81,  89,  83,  89,  81,  81,  81,  81,  81,  89, 104,  89,  81, 104,  83,  81,
 81,  81,  81, 107, 104, 104, 107, 114, 114, 114, 114, 104, 107, 114, 114, 114,
114, 114, 114, 104, 114, 120, 114, 114, 104, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 104, 114, 114, 114, 114, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
  2,  22,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,
 29,  29,  28,  32,  29,  29,  29,  50,  37,  37,  37,  37,  37,  37,  37,  37,
 37,  42,  37,  38,  42,  37,  37,  42,  42,  44,  44,  47,  44,  44,  47,  47,
 47,  49,  49,  49,  49,  59,  49,  49,  49,  49,  48,  49,  47,  47,  48,  48,
 49,  49,  48,  49,  49,  48,  49,  63,  50,  70,  49,  70,  63,  63,  70,  65,
 70,  84,  70,  70,  70,  70,  75,  70,  56,  70,  70,  70,  70,  75,  67,  84,
 70,  70,  61,  80,  61,  80,  65,  70,  65,  65,  84,  67,  89,  80,  67,  75,
 80,  84,  80,  89,  89,  81,  89,  89,  89,  84,  83,  89,  89,  81,  61,  89,
 84,  89,  81,  89,  81,  81,  81,  83,  89,  89,  89,  89,  81, 104,  81,  84,
 81,  89,  83,  89,  81,  81,  81,  81,  81,  89,  89,  89,  81, 104,  81,  81,
114,  81, 114, 107, 104, 104, 112, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  37,  37,  37,  37,  32,  37,  37,  42,
 42,  42,  42,  38,  42,  42,  42,  42,  42,  44,  44,  42,  44,  44,  47,  44,
 44,  44,  53,  49,  53,  59,  48,  49,  53,  48,  48,  49,  53,  47,  48,  63,
 53,  48,  56,  48,  49,  56,  53,  63,  50,  70,  67,  70,  63,  63,  70,  67,
 70,  64,  70,  70,  70,  70,  70,  70,  56,  70,  70,  80,  80,  67,  67,  80,
 80,  80,  61,  80,  61,  80,  65,  80,  65,  65,  80,  80,  67,  80,  67,  89,
 80,  80,  80,  80,  80,  80,  80,  65,  89,  80,  83,  81,  89,  81,  61,  81,
 84,  89,  81,  89,  81,  81,  81,  83,  89,  81,  89,  89,  81, 104,  81,  84,
 81,  81,  83,  89,  81,  81,  81, 107,  81,  89,  89,  89,  81, 104, 120, 107,
 81,  81, 114, 107, 104, 104, 107, 114, 114, 114, 107, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  29,  22,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  37,  37,  37,  37,  32,  37,  42,  42,
 42,  42,  42,  42,  42,  42,  42,  42,  44,  44,  44,  42,  44,  44,  47,  44,
 44,  53,  53,  49,  53,  59,  48,  53,  53,  48,  48,  49,  53,  47,  48,  63,
 53,  53,  56,  48,  49,  56,  53,  63,  50,  70,  49,  70,  63,  63,  70,  67,
 70,  64,  70,  70,  70,  70,  70,  70,  56,  70,  70,  80,  80,  67,  67,  84,
 80,  80,  61,  80,  56,  80,  65,  80,  65,  65,  80,  80,  67,  80,  80,  89,
 80,  80,  80,  80,  80,  80,  80,  65,  89,  80,  83,  80,  89,  81,  61,  81,
 84,  89,  81,  89,  81,  81,  81,  83,  89,  81,  89,  89,  81, 104,  81,  84,
 81,  81,  83,  89,  81,  81,  81, 107,  81,  89,  89,  89,  81, 104, 120, 107,
107, 107, 114, 107, 104, 104, 107, 114, 114, 114, 107, 104, 107, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  22,  22,  22,  22,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  29,  29,  29,  29,  50,  31,  47,  47,  42,  29,  47,  47,  47,
 47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  47,  59,  47,  47,  50,  59,
 47,  47,  59,  59,  59,  50,  59,  59,  59,  59,  59,  59,  47,  59,  63,  63,
 59,  59,  47,  59,  59,  63,  59,  63,  25,  59,  75,  59,  63,  63,  59,  59,
 59,  59,  75,  75,  59,  59,  75,  59,  63,  75,  75,  75,  70,  75,  75,  75,
 75,  75,  61,  75,  63,  75,  65,  75,  65,  75,  75,  75,  75,  80,  75,  75,
 75,  80,  75,  75,  75,  75,  75,  89,  75,  75,  83,  75,  75,  84,  61,  75,
 75,  75,  89,  89,  89, 101,  89,  89,  89,  89,  75,  75,  81,  89,  89,  75,
 89,  89,  89,  89,  89,  89, 114, 114,  89,  89,  89,  89, 114,  89,  83, 114,
114, 114, 114, 114, 104, 104, 112, 114, 114, 126, 114, 114, 114, 114, 114, 114,
126, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
114, 114, 114, 129, 114, 114, 129, 126, 129, 126, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218,
 18,  18,  22,  22,  22,  22,  22,  29,  22,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  29,  29,  29,  29,  50,  42,  29,  42,  42,  29,  42,  42,  42,
 42,  42,  42,  42,  42,  42,  42,  42,  42,  44,  42,  47,  44,  44,  59,  47,
 47,  53,  53,  49,  47,  59,  53,  53,  53,  63,  53,  59,  47,  47,  63,  63,
 53,  53,  55,  53,  70,  63,  70,  63,  50,  70,  59,  70,  63,  63,  70,  63,
 70,  64,  59,  70,  70,  70,  59,  70,  63,  70,  70,  70,  80,  70,  67,  80,
 80,  80,  61,  80,  63,  80,  65,  80,  65,  65,  80,  80,  80,  80,  80,  75,
 80,  80,  80,  80,  80,  80,  80, 101,  89, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101,  89,  83,  89,  89, 103,  89,  81, 104,  89,  84,
 89,  89,  83,  89,  89,  89,  81, 112,  89,  89,  89,  89, 114, 104, 120, 112,
114, 114, 114, 112, 104, 104, 112, 114, 114, 114, 114, 104, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  18,  18,  18,  18,  18,  18,  18,  18,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  35,  35,  35,  35,  50,  35,  35,  35,  35,  35,  35,  35,  51,
 51,  35,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  51,
 51,  51,  51,  82,  51,  59,  82,  82,  51,  82,  82,  59,  55,  47,  63,  82,
 55,  82,  63,  82,  82,  63,  55,  82,  50,  82,  82,  64,  82,  82,  82,  82,
 82,  64,  59,  82,  82,  82,  82,  82,  63,  82,  82,  82,  82,  82,  82,  80,
 82,  82,  61,  82,  63,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,
 82,  80,  82,  82,  82,  82,  82,  82,  82,  80,  83,  82,  82,  80,  61, 101,
 80, 101, 101,  82, 101, 101, 101,  83, 101, 101, 101,  89, 101, 104, 101, 103,
101, 101,  83,  83, 101, 101, 101, 101, 101, 101, 104,  89, 101, 104,  83, 101,
101, 101, 101, 120, 104, 104, 103, 114, 134,  89, 134, 104, 101, 134, 134, 134,
114, 134, 134, 104, 134, 120, 134, 134, 104, 134, 134, 104, 134, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 129, 134,
129, 169, 129, 129, 129, 129, 129, 129, 129, 169, 129, 129, 169, 129, 129, 129,
129, 129, 129, 169, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  22,  22,  22,  22,  35,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  29,  42,  42,  42,
 42,  42,  42,  42,  42,  42,  42,  42,  44,  44,  44,  42,  44,  44,  47,  47,
 54,  53,  53,  49,  53,  59,  53,  53,  53,  48,  53,  47,  55,  47,  63,  63,
 53,  53,  68,  53,  62,  63,  62,  63,  50,  70,  70,  62,  63,  63,  70,  70,
 70,  64,  70,  70,  70,  70,  70,  70,  56,  80,  80,  80,  80,  70,  67,  84,
 80,  80,  61,  80,  56,  80,  65,  80,  80,  65,  80,  80,  80,  80,  80,  80,
 80,  80,  80,  80,  80,  80,  80, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 107, 101,  83,  89, 101, 103,  89,  81, 104, 101,  84,
101, 107,  83,  89, 107, 107, 107, 107, 107,  89,  89,  89, 107, 104, 120, 107,
107, 107, 107, 107, 104, 104, 112, 114, 114, 114, 107, 120, 107, 114, 114, 114,
114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 129,
114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  35,  35,  22,  35,  35,  35,  35,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  29,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  42,  42,  44,  44,  44,  42,  44,  44,  59,  47,
 54,  53,  53,  53,  53,  59,  53,  53,  53,  63,  53,  47,  55,  47,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  70,  70,  62,  63,  63,  70,  70,
 70,  73,  70,  70,  70,  70,  70,  80,  68,  80,  80,  80,  80,  70,  67,  80,
 80,  80,  61,  80,  63,  80,  65,  80,  80,  65,  80,  80,  80,  80,  80,  80,
 80,  80,  80,  80,  80, 101,  80, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101, 101,  83, 101, 101, 103,  89, 107, 104, 101,  84,
101, 107,  83,  89, 107, 107, 107, 107, 107,  89,  89,  89, 107, 104, 120, 107,
107, 107, 107, 107, 104, 104, 112, 114, 114, 114, 107, 120, 107, 114, 114, 114,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 114, 150,
114, 129, 150, 150, 129, 129, 129, 129, 129, 129, 129, 129, 150, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  22,  22,  22,  22,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  37,  29,  29,  29,  42,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  44,  44,  44,  44,  47,  47,  47,  53,  59,  47,
 54,  53,  53,  49,  47,  59,  53,  53,  53,  49,  53,  59,  47,  47,  63,  63,
 70,  70,  62,  70,  70,  70,  70,  63,  50,  70,  70,  70,  63,  63,  70,  70,
 70,  84,  70,  70,  70,  70,  75,  70,  63,  70,  70,  70,  80,  70,  67,  84,
 80,  84,  61,  84,  80,  80,  65,  84,  80,  80,  84,  80,  84,  84,  80,  75,
 84,  84,  84,  84,  84, 101,  84, 101, 103,  84,  83, 103,  89,  84,  61,  84,
 84,  84, 112,  89, 112, 112, 112,  89, 112, 112, 112,  89, 107, 104, 112,  84,
112, 112, 112,  89, 112, 112, 112, 112, 112, 114, 114, 114, 112, 114, 120, 112,
112, 112, 114, 112, 104, 104, 112, 114, 114, 126, 112, 114, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 129,
114, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  29,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  42,  42,  42,  44,  42,  47,  55,  55,  59,  47,
 54,  55,  55,  53,  55,  59,  53,  53,  55,  63,  62,  59,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  70,  70,  64,  63,  63,  70,  63,
 70,  73,  70,  70,  70,  70,  59,  80,  63,  80,  80,  80,  80,  70,  67,  80,
 80,  80,  61,  80,  63,  80,  65,  80,  80,  65,  80,  80,  80,  80,  80,  98,
 80,  80,  80,  80, 101, 101, 101, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101, 101,  83, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101,  83,  89, 101, 101, 107, 112, 112,  89,  89,  89, 112, 104, 120, 112,
112, 120, 114, 107, 104, 104, 112, 114, 114, 126, 112, 120, 112, 114, 114, 114,
114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114,
114, 114, 150, 150, 150, 129, 150, 129, 150, 129, 129, 129, 150, 129, 129, 129,
129, 169, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  47,  47,  47,  47,  47,  52,  47,  47,  47,  47,  59,  47,  59,  50,  59,
 47,  59,  59,  59,  59,  50,  59,  59,  59,  59,  59,  59,  59,  59,  63,  63,
 59,  59,  63,  59,  59,  63,  59,  63,  25,  59,  87,  59,  63,  63,  59,  59,
 59,  59,  75,  87,  59,  59,  75,  59,  63,  87,  87,  75,  63,  75,  75,  75,
 75,  75,  63,  75,  63,  75,  75,  75,  98,  75,  75,  75,  75,  98,  75,  75,
 98,  98,  75,  75,  75,  98,  75, 101,  75,  75,  83,  75,  75,  98, 108,  75,
105,  75,  75,  75, 101, 101,  89,  89,  89,  89,  75,  75, 101, 104,  89, 105,
 89,  89,  89,  89,  89, 114, 114, 112, 114, 114, 114, 126, 114, 114, 104, 114,
114, 114, 114, 112, 104, 104, 112, 126, 114, 126, 114, 114, 114, 114, 114, 114,
126, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 126, 114, 114, 114, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
126, 114, 114, 114, 114, 114, 114, 126, 114, 126, 126, 129, 129, 129, 126, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 218, 218,
 18,  22,  29,  29,  22,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  42,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  44,  44,  44,  44,  44,  44,  47,  44,  53,  59,  47,
 54,  53,  53,  49,  53,  59,  53,  53,  53,  48,  62,  47,  64,  64,  62,  63,
 62,  62,  68,  62,  70,  63,  70,  63,  50,  70,  70,  70,  63,  63,  70,  70,
 70,  84,  70,  70,  70,  70,  70,  80,  68,  80,  80,  80,  80,  70,  67,  84,
 80,  80,  61,  80,  80,  80,  67,  80,  80,  80,  84,  80,  80,  84,  80, 103,
 80,  84,  80, 103, 103, 101, 103, 101, 103,  84,  83, 103,  89,  84,  61, 103,
 84, 103, 112,  89, 107, 107, 112,  83, 112, 107, 112,  89, 107, 104, 112,  84,
112, 112, 107, 107, 112, 107, 107, 112, 112, 112, 107, 112, 107, 104, 120, 112,
112, 107, 112, 107, 104, 120, 112, 114, 114, 126, 107, 120, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 150, 150,
114, 150, 150, 150, 150, 150, 150, 150, 150, 129, 129, 150, 150, 150, 129, 129,
150, 150, 150, 150, 150, 150, 129, 129, 129, 129, 129, 150, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  29,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  44,  42,  44,  44,  44,  47,  55,  55,  59,  47,
 54,  55,  55,  53,  55,  59,  53,  62,  55,  63,  62,  59,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  70,  70,  64,  63,  63,  70,  70,
 70,  73,  70,  70,  70,  70,  59,  80,  63,  80,  80,  80,  80,  70,  67,  84,
 80,  80,  61,  80,  80,  80,  65,  80,  80,  80,  80,  80,  80,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89,  84,  61, 103,
103, 103, 101,  89, 101, 101, 101, 104, 103, 101, 103,  89, 107, 104, 112,  84,
101, 112,  83,  89, 112, 112, 107, 112, 112, 112, 114, 112, 112, 104, 120, 112,
112, 107, 112, 112, 104, 104, 112, 114, 114, 126, 112, 120, 112, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 114, 114, 114, 114, 114,
114, 150, 150, 150, 150, 129, 150, 129, 150, 129, 129, 150, 150, 150, 129, 129,
150, 150, 150, 129, 150, 129, 129, 129, 129, 129, 129, 150, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  51,  54,  42,  42,  42,
 42,  54,  42,  42,  42,  42,  42,  42,  44,  44,  55,  42,  55,  55,  59,  55,
 54,  55,  55,  53,  55,  59,  62,  55,  55,  63,  62,  64,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  62,  63,  50,  62,  70,  62,  63,  63,  70,  63,
 70,  73,  70,  70,  70,  70,  59,  80,  68,  80,  80,  80,  80,  80,  67,  80,
 80,  80,  61,  80,  80,  80,  67,  80,  80,  80,  80,  80,  80,  80,  80,  98,
 80,  80,  80,  80, 101, 101, 101, 101, 101, 103,  83, 101,  89,  80,  61, 101,
103, 103, 101,  89, 101, 101, 101,  83, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101,  83, 101, 101, 101, 107, 107, 112, 112, 101, 112, 107, 104, 120, 112,
107, 120, 112, 107, 104, 104, 112, 114, 114, 126, 107, 120, 112, 114, 114, 114,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 104, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 120, 114, 114, 114, 134, 114, 114, 150,
114, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 129, 129, 150, 150,
150, 129, 129, 150, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218, 218,
 22,  22,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  54,  37,  32,  42,  42,  42,  50,  42,  42,  42,  44,  54,  42,  42,  42,
 54,  54,  44,  44,  44,  44,  44,  44,  44,  44,  44,  47,  53,  53,  47,  47,
 54,  53,  53,  49,  53,  59,  70,  70,  62,  70,  70,  70,  84,  70,  62,  48,
 70,  70,  68,  70,  70,  70,  84,  70,  50,  84,  70,  84,  70,  56,  84,  70,
 70,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,
 84,  84,  61,  84,  84,  84,  80,  84,  84,  84,  84,  84,  84,  84,  84,  84,
 84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  83,  84,  89,  84, 107,  84,
 84,  84, 112,  89, 112, 107, 112,  89, 112, 112,  84,  89, 107, 104, 112,  84,
112, 112, 107, 112, 112, 112, 107, 112, 112, 112, 112, 112, 112, 114, 120, 112,
112, 107, 112, 107, 104, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
114, 114, 107, 114, 114, 120, 114, 114, 114, 114, 114, 114, 112, 114, 114, 114,
114, 114, 114, 112, 114, 120, 114, 114, 114, 114, 114, 114, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 129, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 129, 129, 150, 150,
150, 129, 129, 150, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,  29,  29,  29,  29,
 29,  29,  29,  32,  29,  29,  29,  50,  42,  42,  42,  42,  54,  42,  42,  42,
 54,  54,  42,  42,  42,  42,  44,  44,  44,  44,  55,  55,  55,  55,  59,  55,
 54,  55,  55,  62,  55,  59,  62,  62,  62,  63,  62,  64,  64,  64,  68,  63,
 62,  62,  68,  62,  62,  68,  62,  63,  50,  70,  70,  62,  63,  63,  70,  70,
 70,  73,  70,  70,  80,  80,  70,  80,  68,  80,  80,  80,  80,  80,  80,  84,
 80,  80,  61,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89, 107,  61, 103,
103, 103, 101,  89, 101, 107, 101, 104, 103, 101, 103,  89, 107, 104, 107,  84,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 107, 112, 107, 104, 120, 107,
107, 107, 107, 107, 104, 120, 112, 112, 107, 126, 107, 120, 112, 107, 107, 107,
114, 120, 120, 120, 114, 120, 114, 120, 114, 114, 114, 114, 112, 114, 114, 120,
114, 114, 114, 107, 114, 120, 114, 114, 120, 114, 114, 114, 114, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 129, 150, 150, 129, 129, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  29,  29,  29,  29,  29,  50,  51,  51,  51,  51,  54,  51,  51,  42,
 54,  54,  42,  51,  42,  51,  51,  47,  47,  55,  47,  47,  47,  47,  50,  47,
 54,  47,  47,  59,  47,  59,  59,  59,  64,  63,  62,  59,  64,  59,  63,  63,
 64,  64,  55,  62,  59,  63,  64,  63,  50,  70,  59,  64,  63,  63,  70,  63,
 70,  73,  59,  70,  70,  70,  87,  70,  63,  80,  80,  80,  80,  87,  80,  80,
 80,  80,  61,  80,  63,  80,  65,  98,  80, 101,  80,  80,  98,  80,  80,  75,
 80,  80,  98,  98, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101, 108, 103,
103, 103, 101,  89, 101, 101, 101,  89, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101,  89, 112, 112, 112, 112, 112, 114, 114, 114, 112, 104, 120, 112,
114, 112, 114, 112, 104, 104, 112, 114, 114, 126, 114, 120, 112, 114, 114, 114,
126, 114, 114, 114, 114, 120, 114, 114, 114, 126, 114, 114, 114, 114, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 114, 114, 114, 126, 114, 114, 114, 114,
114, 114, 114, 169, 114, 114, 129, 126, 129, 126, 129, 129, 150, 129, 129, 129,
129, 169, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129,
129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 210, 210, 218, 218,
 18,  18,  18,  18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  40,  35,  35,  35,  50,  51,  51,  51,  51,  35,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  51,
 54,  51,  60,  82,  60,  59,  55,  55,  60,  82,  55,  64,  60,  64,  63,  63,
 60,  62,  68,  62,  72,  63,  72,  63,  50,  72,  82,  72,  82,  63,  82,  82,
 82,  73,  64,  82,  82,  72,  59,  63,  63,  82,  80,  82,  80,  82,  82,  86,
 80,  80,  61,  80,  63,  80,  82,  80,  82,  82,  80,  80,  80,  80,  80,  98,
 80,  80,  80, 101, 101, 101, 101, 101, 101,  98,  83, 101,  89, 101,  61, 101,
103, 101, 101, 101, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 104, 120, 101,
101, 120, 134, 120, 104, 104, 112, 114, 134, 126, 134, 120, 112, 134, 134, 134,
114, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 150, 134, 150, 134, 134, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 169, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 129, 150, 129, 129, 129, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  35,  35,  35,  52,  50,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  54,  51,  51,  51,  51,  51,  51,  51,  51,  51,  47,  51,  51,  59,  47,
 54,  60,  60,  59,  60,  59,  59,  59,  60,  63,  62,  59,  64,  59,  63,  63,
 64,  64,  60,  62,  64,  63,  64,  63,  50,  72,  59,  64,  63,  63,  70,  63,
 63,  73,  59,  70,  70,  70,  87,  63,  63,  80,  80,  80,  80,  87,  82,  80,
 80,  80,  61,  80,  63,  80,  82,  80,  80, 101,  80,  80,  98,  80,  80,  87,
 80,  80,  98,  98, 101, 101, 101, 101, 101,  98,  83, 101,  89, 101, 108, 101,
103, 103, 101,  89, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101,  89, 101, 104, 120, 112,
114, 101, 114, 112, 104, 104, 112, 114, 114, 126, 114, 134, 112, 114, 114, 114,
126, 114, 114, 134, 114, 120, 114, 134, 134, 126, 114, 134, 114, 134, 114, 114,
114, 114, 114, 114, 114, 120, 114, 114, 134, 114, 134, 126, 134, 134, 134, 114,
114, 134, 134, 134, 114, 134, 134, 126, 134, 126, 129, 129, 169, 129, 129, 129,
129, 169, 129, 129, 129, 129, 129, 129, 129, 169, 129, 129, 169, 129, 129, 129,
129, 129, 129, 169, 129, 169, 129, 129, 129, 129, 129, 129, 210, 210, 218, 218,
 18,  18,  35,  35,  35,  35,  40,  35,  35,  35,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  50,  40,  40,  40,  40,  40,  40,  40,  42,
 54,  54,  42,  44,  44,  44,  40,  44,  55,  68,  55,  55,  55,  55,  47,  55,
 54,  55,  55,  62,  55,  64,  62,  62,  62,  62,  68,  62,  71,  64,  68,  68,
 68,  68,  68,  68,  62,  68,  62,  68,  50,  68,  70,  68,  68,  68,  68,  80,
 80,  73,  78,  80,  80,  80,  70,  68,  68,  80,  80,  80,  80,  80,  80,  84,
 80,  80,  61,  80,  68,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80, 103,
 80,  80,  80,  80, 101, 101, 101, 101, 101, 103,  83, 101,  89, 107,  61, 101,
103, 103, 107, 101, 107, 107, 107, 104, 107, 107, 107, 103, 107, 104, 107, 107,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 120, 120, 107,
107, 120, 107, 107, 104, 120, 107, 107, 107, 114, 107, 120, 107, 120, 107, 107,
114, 120, 120, 120, 120, 120, 120, 120, 120, 114, 120, 120, 107, 120, 120, 120,
120, 120, 120, 107, 120, 120, 120, 120, 120, 120, 120, 114, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 218, 218, 218,
 18,  35,  29,  29,  29,  29,  40,  29,  29,  29,  29,  29,  29,  29,  29,  29,
 29,  54,  32,  32,  32,  54,  54,  50,  42,  42,  42,  32,  54,  44,  44,  44,
 54,  54,  44,  44,  44,  44,  44,  44,  44,  44,  44,  53,  55,  55,  47,  55,
 54,  55,  62,  62,  62,  59,  62,  62,  62,  48,  68,  62,  62,  62,  68,  68,
 62,  62,  68,  62,  70,  68,  70,  68,  50,  70,  70,  84,  56,  68,  70,  80,
 70,  84,  84,  80,  80,  80,  70,  80,  68,  80,  84,  80,  80,  84,  80,  84,
 84,  84,  61,  84,  68,  84,  80,  84,  80,  80,  84,  84,  84,  84,  84,  84,
 84,  84,  84,  84,  84, 107,  84, 107, 107,  84,  83, 107,  89,  84, 107, 107,
 84, 107, 107, 107, 107, 107, 107, 104, 107, 107, 107, 107, 107, 104, 107,  84,
107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 120, 107,
107, 107, 107, 107, 104, 120, 107, 107, 107, 114, 107, 120, 107, 107, 107, 107,
114, 107, 107, 120, 107, 120, 107, 120, 120, 114, 120, 120, 107, 120, 107, 107,
120, 120, 114, 107, 150, 120, 150, 150, 120, 150, 150, 114, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  35,  40,  35,  35,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 51,  54,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  55,  55,  59,  60,
 54,  55,  55,  62,  60,  59,  62,  62,  55,  63,  62,  64,  60,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  64,  63,  50,  62,  70,  64,  63,  63,  78,  82,
 80,  73,  64,  80,  80,  80,  59,  80,  68,  80,  80,  80,  80,  80,  80,  80,
 80,  80,  61,  80,  63,  80,  82,  80,  80, 101,  80,  80,  98,  80,  80,  98,
 80,  80,  80, 101, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101,  61, 101,
103, 103, 101, 101, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 112, 101, 101, 101, 101, 101, 104, 120, 112,
112, 120, 112, 107, 104, 104, 112, 112, 120, 126, 112, 120, 112, 120, 134, 114,
114, 120, 120, 134, 134, 120, 134, 120, 134, 114, 134, 134, 112, 134, 134, 134,
134, 134, 134, 112, 134, 120, 134, 134, 134, 134, 134, 114, 134, 134, 134, 150,
134, 134, 150, 120, 150, 134, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 129, 150, 150, 150, 150, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 29,  29,  51,  40,  29,  29,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  55,  55,  60,  55,  55,  55,  59,  60,
 54,  55,  55,  62,  55,  59,  62,  62,  62,  63,  62,  64,  64,  64,  63,  63,
 62,  62,  68,  62,  62,  63,  64,  63,  50,  62,  70,  78,  63,  63,  70,  70,
 70,  73,  64,  70,  80,  80,  59,  80,  68,  80,  80,  80,  80,  80,  80,  80,
 80,  80,  61,  80,  80,  80, 101,  80,  80, 101,  80,  80,  98,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101,  61, 103,
103, 103, 101, 101, 101, 101, 101, 104, 101, 101, 103,  89, 101, 104, 101, 112,
101, 101, 101, 101, 112, 112, 107, 112, 112, 112, 101, 112, 112, 104, 120, 112,
112, 120, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 114, 114, 114,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 134, 112, 114, 114, 114,
114, 114, 114, 112, 114, 120, 114, 114, 134, 114, 114, 114, 134, 134, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 129, 150, 150, 129, 150, 210, 218, 218, 218,
 18,  18,  41,  41,  18,  41,  40,  41,  40,  40,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  50,  40,  40,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  51,  51,  51,  64,  55,
 71,  55,  55,  55,  55,  64,  68,  55,  68,  82,  68,  72,  71,  60,  68,  68,
 68,  68,  68,  68,  68,  68,  68,  68,  50,  68,  82,  68,  82,  68,  68,  82,
 68,  73,  72,  68,  68,  68,  72,  68,  68,  68,  68,  80,  68,  80,  82,  90,
 80,  90,  61,  80,  68,  80,  82,  80,  80,  82,  80,  80,  80,  90,  80,  80,
 90,  90,  80, 101, 101, 101, 101, 101, 101, 103,  83, 101, 101, 100, 128, 101,
103, 101, 101, 101, 101, 101, 101, 104, 101, 101, 103, 101, 120, 104, 101, 103,
101, 101, 120, 101, 107, 107, 120, 107, 107, 107, 120, 107, 107, 104, 128, 107,
120, 120, 120, 120, 104, 120, 107, 107, 120, 134, 120, 120, 107, 120, 120, 120,
134, 120, 120, 120, 120, 120, 120, 120, 134, 134, 120, 134, 120, 120, 120, 120,
120, 120, 134, 120, 120, 120, 120, 120, 120, 134, 120, 134, 134, 134, 134, 150,
134, 150, 150, 120, 150, 134, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  29,  29,
 29,  29,  51,  40,  29,  29,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  55,  55,  55,  55,  55,  55,  55,  59,  60,
 54,  55,  55,  62,  64,  59,  62,  62,  62,  63,  62,  64,  64,  64,  62,  63,
 62,  62,  68,  62,  62,  68,  64,  63,  50,  78,  70,  78,  63,  63,  70,  70,
 70,  73,  70,  70,  80,  80,  70,  80,  68,  80,  80,  80,  80,  80,  80,  84,
 80,  80,  61,  80,  80,  80, 101,  80,  80, 101,  80,  80,  98,  80,  80, 103,
 80,  80,  80, 103, 101, 101, 101, 101, 101, 103,  83, 101,  89, 101,  61, 103,
103, 103, 103, 101, 101, 101, 101, 104, 103, 101, 103,  89, 107, 104, 112, 112,
101, 112, 101, 101, 112, 112, 107, 112, 112, 112, 112, 112, 112, 104, 120, 112,
112, 120, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
114, 120, 120, 114, 114, 120, 114, 120, 114, 114, 114, 134, 112, 114, 114, 120,
114, 114, 114, 112, 114, 120, 114, 114, 120, 114, 114, 114, 134, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  51,  51,  35,  51,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  51,  60,  60,  60,  60,  59,  60,
 54,  60,  60,  62,  60,  59,  62,  64,  60,  63,  62,  64,  73,  64,  62,  63,
 64,  62,  73,  62,  72,  63,  64,  63,  50,  78,  70,  73,  63,  63,  78,  80,
 78,  73,  64,  78,  78,  78,  59,  80,  68,  80,  80,  80,  80,  98,  80,  91,
 80,  80,  61,  80,  90,  80, 101,  98,  80, 101,  80,  80,  98,  80, 101,  98,
 80,  90, 101, 103, 101, 101, 101, 101, 101, 103, 101, 101, 103, 101, 108, 103,
103, 103, 101, 101, 101, 101, 101, 104, 101, 101, 103, 103, 101, 104, 101, 103,
101, 101, 101, 101, 112, 112, 101, 112, 112, 112, 101, 112, 112, 104, 120, 112,
112, 112, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
126, 120, 120, 134, 114, 120, 134, 134, 134, 126, 134, 134, 112, 134, 134, 134,
134, 134, 134, 141, 134, 120, 134, 134, 134, 134, 134, 126, 134, 134, 134, 150,
134, 150, 150, 169, 150, 134, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  41,  40,  41,  41,  41,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  50,  40,  40,  40,  40,  40,  40,  51,  51,
 54,  54,  51,  51,  51,  51,  40,  51,  71,  71,  71,  55,  71,  71,  64,  60,
 54,  71,  71,  62,  71,  64,  62,  62,  71,  62,  68,  64,  71,  64,  68,  68,
 71,  62,  68,  62,  78,  68,  78,  68,  50,  78,  78,  73,  68,  68,  78,  80,
 78,  73,  78,  80,  90,  90,  70,  90,  68,  90,  90,  80,  90,  80,  80,  90,
 80,  90,  61,  80,  68,  80, 101,  80,  80, 101,  80,  80, 103,  90, 101, 103,
 90,  90, 101, 103, 101, 101, 101, 101, 101, 103, 101, 101, 103, 107, 128, 103,
103, 103, 101, 101, 101, 107, 107, 101, 107, 101, 103, 103, 107, 104, 107, 107,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 120, 107, 107, 120, 120, 107,
107, 120, 107, 107, 104, 120, 107, 107, 107, 126, 107, 120, 107, 120, 107, 107,
114, 120, 120, 120, 120, 120, 120, 120, 120, 134, 120, 134, 107, 120, 120, 120,
120, 120, 134, 141, 120, 120, 120, 120, 120, 120, 120, 134, 134, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 210, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 35,  35,  51,  35,  35,  35,  51,  50,  51,  51,  51,  51,  51,  51,  51,  51,
 51,  54,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  60,
 54,  60,  60,  72,  60,  59,  72,  60,  60,  82,  72,  64,  73,  64,  63,  63,
 60,  72,  71,  72,  72,  63,  72,  63,  50,  72,  82,  73,  82,  63,  72,  82,
 82,  73,  72,  86,  86,  86,  59,  86,  90,  86,  86,  86,  90,  98,  82,  86,
 91,  91, 108,  91,  90,  80,  82,  98,  82,  82,  91,  98,  98,  90, 101, 105,
101,  90,  98,  98, 101, 101, 101, 101, 101, 103, 101, 101, 101, 101, 108, 101,
103, 103, 101, 101, 101, 101, 101, 101, 101, 101, 103, 103, 101, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 134, 120, 112,
101, 134, 134, 112, 104, 120, 112, 112, 134, 126, 134, 134, 112, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 169, 134, 134, 134, 150, 134, 150, 134, 134, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 169, 150, 169, 169, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  40,  35,  35,  35,  35,  35,  35,  35,  54,  54,
 54,  54,  51,  40,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  55,  71,  60,  55,  71,  71,  55,  71,  71,  59,  60,
 54,  71,  62,  62,  62,  59,  62,  62,  62,  62,  62,  64,  73,  64,  68,  68,
 71,  62,  68,  62,  78,  68,  78,  68,  50,  78,  70,  73,  68,  68,  78,  80,
 80,  73,  78,  80,  80,  80,  70,  90,  68,  80,  80,  80,  90,  80,  80,  84,
 80,  80,  61,  80,  90,  80, 101,  80,  80, 101,  84, 103, 103,  90, 101, 103,
 80,  90, 103, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 107, 128, 103,
103, 103, 103, 103, 107, 107, 107, 101, 107, 107, 112, 103, 107, 104, 107,  84,
107, 107, 120, 107, 107, 107, 107, 107, 107, 107, 107, 112, 107, 120, 120, 107,
107, 107, 107, 107, 120, 120, 112, 112, 107, 126, 107, 120, 107, 120, 107, 107,
114, 120, 120, 120, 120, 120, 120, 120, 120, 114, 120, 134, 107, 120, 120, 120,
120, 120, 120, 141, 120, 120, 150, 150, 120, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 218, 218, 218, 218,
 25,  25,  25,  25,  25,  25,  52,  25,  25,  25,  25,  25,  25,  25,  25,  25,
 25,  25,  25,  50,  25,  25,  25,  25,  25,  25,  25,  50,  50,  50,  25,  25,
 25,  25,  25,  25,  50,  50,  50,  50,  50,  50,  50,  25,  50,  50,  25,  50,
 50,  50,  50,  50,  50,  25,  50,  50,  50,  50,  50,  50,  50,  50,  50,  50,
 50,  50,  50,  50,  50,  75,  50,  75,  77,  50,  50,  50,  75,  75,  75,  75,
 75,  50,  50,  75,  75,  75,  25,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,
 75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75,  75, 152,  75,
 75, 152,  75, 152, 152, 152,  75, 152, 152,  75, 152, 152, 152, 152, 152, 152,
152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152,
152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152,
152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 181, 152, 152, 152,
152, 152, 152, 152, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 199, 199,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,
 51,  54,  51,  40,  51,  51,  51,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  51,  60,  60,  60,  60,  59,  60,
 54,  60,  60,  72,  60,  59,  72,  72,  60,  63,  72,  64,  73,  64,  71,  63,
 73,  72,  73,  72,  72,  78,  73,  63,  50,  78,  72,  73,  63,  63,  78,  78,
 78,  73,  78,  86,  86,  86,  59,  86,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  91, 108,  91,  90,  98, 101,  98, 101, 101,  98,  98,  98,  90, 101,  98,
101,  90,  98, 103, 101, 101, 101, 101, 101, 103, 101, 101, 103, 101, 108, 103,
103, 103, 103, 101, 101, 101, 101, 101, 103, 101, 103, 103, 101, 104, 101, 103,
101, 101, 101, 101, 112, 112, 112, 112, 112, 112, 101, 112, 112, 134, 120, 112,
112, 112, 112, 112, 104, 120, 112, 112, 112, 126, 112, 120, 112, 134, 134, 112,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 112, 134, 134, 134,
134, 134, 134, 141, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 150,
134, 134, 150, 169, 150, 169, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 150, 150, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  54,  35,  35,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  54,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  60,  54,  54,  60,  60,  54,  59,  60,  60,  50,  59,
 54,  64,  64,  59,  64,  50,  59,  59,  64,  59,  64,  59,  73,  59,  78,  63,
 64,  64,  73,  64,  64,  78,  64,  63,  50,  78,  87,  73,  63,  63,  70,  70,
 70,  84,  59,  70,  91,  91,  87,  91,  90,  98,  98,  98,  91,  87,  98,  84,
 98,  98, 108,  98, 108,  98,  98,  98,  98,  98,  84,  98, 105,  84,  98, 105,
 98,  84,  98, 103, 103, 103, 103, 101, 103, 105, 101, 103, 105,  84, 108, 103,
 84, 103, 112, 103, 112, 112, 112, 101, 112, 112, 112, 126, 112, 104, 112,  84,
112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 114, 120, 112,
112, 112, 112, 112, 114, 120, 112, 126, 112, 126, 112, 112, 112, 112, 112, 112,
126, 114, 112, 114, 114, 120, 114, 114, 114, 126, 114, 114, 141, 114, 114, 114,
114, 114, 126, 141, 114, 141, 141, 114, 114, 114, 114, 126, 114, 114, 114, 141,
126, 114, 114, 169, 150, 169, 150, 126, 150, 126, 150, 150, 169, 150, 126, 169,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 199, 199, 210, 199, 210, 210, 210, 218, 218,
 18,  18,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  41,  57,  41,  41,  41,  41,  50,  51,  51,  51,  51,  41,  51,  51,  51,
 51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  59,  51,
 54,  51,  51,  82,  60,  59,  82,  72,  60,  82,  72,  72,  73,  72,  71,  82,
 71,  72,  71,  82,  72,  82,  72,  82,  50,  82,  82,  73,  82,  82,  82,  82,
 82,  73,  72,  82,  82,  82,  82,  82,  90,  82,  86,  82,  82,  82,  82,  86,
 82,  86,  82,  82,  90,  82,  82,  86,  82,  82,  96,  82,  98,  90,  82,  98,
102,  90, 102,  98, 101, 101, 101, 101, 101,  98,  82, 101, 101, 102, 108, 101,
103, 103, 101, 101, 101, 108, 101, 101, 101, 101, 103, 103, 108, 104, 101, 103,
101, 101, 101, 101, 101, 101, 101, 101, 101, 101, 134, 101, 101, 134, 120, 124,
134, 134, 134, 124, 134, 134, 124, 134, 134, 134, 134, 134, 124, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 169, 169, 134, 169,
169, 169, 169, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  40,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  40,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  55,  54,  71,  54,  54,  71,  71,  54,  60,  71,  71,  64,  71,
 54,  71,  71,  62,  71,  64,  62,  62,  71,  62,  68,  64,  73,  64,  68,  68,
 73,  78,  68,  78,  78,  68,  78,  68,  50,  78,  70,  84,  68,  68,  90,  80,
 80,  84,  84,  80,  90,  84,  84,  90,  68,  84,  84,  84,  84,  84,  80,  84,
 84,  84,  61,  84,  90,  84, 101,  84, 101, 101,  84, 103, 103,  84, 103,  84,
 84,  84,  84, 103, 103, 103, 103, 103, 103,  84, 101, 103, 103,  84, 128, 112,
 84, 112, 112, 112, 107, 107, 107, 107, 112, 107, 112, 112, 107, 104, 112,  84,
107, 107, 107, 107, 107, 107, 107, 107, 107, 112, 107, 112, 107, 107, 120, 112,
107, 107, 107, 107, 120, 120, 145, 112, 107, 126, 107, 120, 141, 107, 107, 112,
112, 120, 107, 120, 107, 120, 107, 120, 120, 126, 120, 120, 141, 120, 141, 141,
120, 120, 150, 141, 150, 120, 141, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  40,  40,  40,  54,  40,  40,  40,  40,  40,  40,  40,  40,
 54,  54,  40,  40,  40,  54,  54,  50,  40,  54,  54,  40,  54,  54,  54,  54,
 54,  54,  54,  55,  54,  71,  71,  71,  71,  68,  71,  71,  71,  71,  64,  71,
 54,  71,  71,  62,  71,  64,  68,  71,  71,  68,  68,  64,  71,  71,  68,  68,
 68,  68,  68,  68,  68,  68,  78,  68,  50,  68,  78,  90,  68,  68,  90,  90,
 90,  84,  84,  90,  90,  90,  86,  90,  68,  90,  90,  90,  90, 103,  80,  84,
 90,  90, 100,  90, 100,  90, 101, 103,  90, 101,  84, 103, 103,  90, 103, 103,
 90,  90, 103, 103, 103, 101, 103, 101, 103, 103, 101, 107, 103, 107, 128, 107,
 84, 107, 107, 103, 107, 107, 107, 107, 107, 107, 107, 103, 107, 104, 107, 107,
107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 107, 120, 128, 107,
107, 107, 107, 107, 120, 120, 141, 107, 107, 112, 107, 120, 107, 107, 107, 107,
107, 120, 120, 120, 107, 120, 120, 120, 120, 114, 120, 120, 141, 120, 120, 120,
120, 120, 150, 141, 150, 120, 141, 150, 120, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 150, 150, 150, 150, 150, 150, 150, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  54,  54,
 51,  54,  51,  51,  54,  54,  54,  50,  51,  51,  54,  51,  54,  51,  54,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  60,  60,  60,  60,  60,  60,  59,  60,
 54,  60,  60,  72,  64,  59,  72,  72,  73,  72,  72,  64,  73,  64,  73,  63,
 73,  72,  73,  72,  78,  78,  73,  78,  50,  78,  72,  73,  63,  63,  78,  86,
 86,  73,  86,  86,  86,  86,  87,  91,  90,  91,  91,  91,  91,  98,  98,  96,
 91,  91, 108,  98, 108,  98, 101,  98, 101, 101,  98,  98,  98,  90,  98, 105,
101,  90,  98, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 103, 108, 103,
103, 103, 103, 101, 101, 101, 103, 101, 103, 101, 103, 103, 101, 104, 103, 103,
101, 112, 101, 101, 112, 112, 112, 112, 112, 112, 112, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 112, 112, 112, 126, 112, 120, 112, 112, 112, 112,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 126, 134, 134, 134, 150,
134, 134, 150, 169, 150, 169, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 169, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  54,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  60,  54,  60,  54,  54,  60,  71,  54,  60,  60,  60,  59,  64,
 54,  73,  73,  64,  73,  59,  78,  64,  73,  78,  78,  64,  73,  64,  73,  78,
 73,  78,  73,  78,  78,  90,  73,  78,  50,  78,  70,  73,  90,  90,  91,  91,
 91,  84,  84,  91,  91,  91,  98,  91,  90,  91,  91,  91,  91,  98,  98,  84,
 98,  84, 108,  98,  90,  98, 101, 103, 101, 101,  84, 103, 103,  84, 103, 103,
103,  84, 103, 103, 103, 103, 103, 103, 103, 103, 101, 103, 103,  84, 108, 103,
 84, 112, 112, 103, 112, 112, 112, 101, 112, 112, 112, 112, 112, 104, 112, 145,
112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 120, 112,
112, 112, 112, 112, 120, 120, 145, 112, 112, 126, 112, 120, 141, 112, 112, 112,
126, 112, 112, 134, 141, 120, 141, 141, 134, 126, 141, 134, 141, 134, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 126, 150, 150, 150, 141,
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 150,
150, 150, 150, 150, 150, 169, 150, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  54,  35,  35,  35,  35,  54,  54,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  51,  54,  54,  60,  71,  54,  60,  60,  60,  59,  64,
 54,  60,  73,  72,  73,  59,  72,  72,  73,  72,  78,  64,  73,  64,  73,  63,
 73,  78,  73,  78,  78,  78,  73,  78,  50,  78,  78,  73,  63,  90,  86,  91,
 91,  73,  86,  91,  91,  91,  87,  91,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  96, 108,  98, 108,  98, 101,  98, 101, 101,  98,  98,  98,  96,  98, 105,
 98,  90, 103, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 103, 108, 103,
103, 103, 103, 103, 103, 112, 103, 101, 103, 101, 103, 103, 112, 104, 112, 112,
112, 112, 101, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 112, 126, 112, 120, 112, 112, 112, 112,
126, 134, 112, 134, 112, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 141,
134, 134, 134, 141, 134, 153, 141, 141, 134, 134, 134, 126, 134, 134, 134, 141,
150, 150, 150, 169, 150, 169, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169,
150, 169, 150, 150, 150, 150, 150, 169, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 150, 169, 150, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  18,  18,  18,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  57,
 57,  57,  57,  57,  57,  57,  57,  50,  57,  57,  57,  57,  41,  57,  57,  57,
 57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  57,
 52,  57,  57,  57,  57,  57,  82,  82,  82,  82,  82,  82,  74,  74,  82,  82,
 82,  82,  74,  82,  82,  82,  82,  82,  50,  82,  82,  82,  82,  82,  82,  82,
 82,  93,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  94,
 82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,
 82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82,  82, 106, 108,  82,
102,  82,  82,  82, 117, 108, 117, 117, 117, 117, 116,  82, 108, 117, 117, 113,
117, 117, 117, 117, 117, 117, 117, 124, 117, 137, 117, 137, 137, 134, 108, 124,
134, 134, 134, 124, 134, 134, 124, 134, 134, 134, 134, 134, 124, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 169, 134, 134, 134, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 210, 210, 218, 218, 218, 218,
 18,  18,  35,  35,  57,  35,  35,  35,  35,  35,  35,  35,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  52,  50,  52,
 54,  51,  60,  82,  60,  59,  82,  72,  60,  82,  72,  59,  73,  88,  73,  82,
 73,  72,  73,  72,  72,  72,  73,  82,  50,  72,  82,  73,  82,  82,  82,  82,
 82,  93,  97,  82,  86,  86,  87,  86,  90,  82,  86,  86,  86,  87,  82,  97,
 91,  97, 108,  98, 108,  98,  82,  98,  82,  82,  98,  98, 105,  96,  98, 105,
108, 102,  98,  98,  98, 108,  98, 108,  98, 105, 108,  98, 105, 108, 108,  98,
105, 105, 101, 101, 101, 108, 101, 101, 101, 101, 105, 105, 108, 104, 101, 116,
101, 101, 108, 101, 101, 101, 108, 124, 101, 101, 134, 132, 101, 134, 108, 124,
134, 134, 134, 124, 134, 134, 124, 132, 134, 126, 134, 134, 124, 134, 134, 134,
126, 134, 134, 134, 134, 134, 134, 134, 134, 126, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 169, 169, 134, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  35,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  51,  54,  51,  54,  54,  60,  71,  54,  60,  60,  60,  59,  60,
 54,  73,  73,  72,  73,  59,  72,  72,  73,  72,  72,  64,  73,  73,  73,  63,
 73,  72,  73,  72,  78,  78,  73,  78,  50,  78,  86,  73,  63,  90,  86,  91,
 86,  93,  86,  91,  91,  86,  87,  91,  90,  91,  91,  91,  91,  98,  98,  96,
 91,  96, 108,  98, 108,  98, 101,  98,  98, 101,  98,  98,  98,  96,  98, 105,
 98,  96,  98, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 103, 103, 101, 103, 101, 103, 101, 103, 103, 108, 104, 103, 103,
103, 112, 101, 101, 112, 112, 112, 112, 112, 112, 112, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 112, 126, 112, 134, 141, 134, 112, 112,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 126, 134, 134, 134, 141,
134, 134, 134, 169, 150, 169, 169, 150, 169, 150, 169, 150, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  18,  41,  41,  35,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 51,  54,  51,  51,  54,  54,  54,  50,  51,  51,  54,  51,  54,  51,  54,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  71,  71,  60,  71,  71,  59,  60,
 54,  71,  71,  72,  73,  59,  72,  72,  73,  72,  72,  72,  73,  73,  71,  78,
 73,  72,  73,  72,  78,  90,  73,  78,  50,  78,  86,  73,  90,  90,  86,  86,
 86,  93,  86,  86,  86,  86,  86,  86,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  96, 108,  96, 108,  98, 101,  98, 108, 101,  96,  98,  98,  96,  98, 105,
102,  90,  98, 103, 103, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 101, 101, 108, 103, 101, 103, 101, 103, 103, 108, 104, 103, 103,
101, 103, 101, 101, 112, 112, 112, 112, 112, 112, 134, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 134, 126, 112, 134, 141, 134, 134, 134,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 169, 150, 169, 169, 150, 169, 150, 169, 150, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  18,  41,  41,  35,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 51,  54,  51,  51,  51,  54,  54,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  51,  51,  51,  51,  51,  51,  71,  71,  51,  71,  71,  59,  60,
 54,  71,  71,  72,  73,  59,  72,  72,  73,  82,  72,  72,  73,  73,  71,  63,
 73,  72,  73,  72,  72,  90,  73,  78,  50,  78,  86,  73,  82,  90,  86,  86,
 86,  93,  86,  86,  86,  86,  97,  86,  90,  91,  91,  91,  90,  98,  98,  96,
 91,  96, 108,  96, 108,  98, 101,  98, 108, 101,  96,  98,  98,  96,  98, 105,
102,  90,  98,  98, 101, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 101, 101, 108, 101, 101, 103, 101, 103, 103, 108, 104, 103, 103,
101, 103, 101, 101, 124, 124, 124, 124, 124, 124, 134, 112, 112, 134, 120, 112,
112, 112, 112, 112, 134, 120, 141, 112, 134, 126, 112, 134, 141, 134, 134, 134,
126, 134, 134, 134, 134, 120, 134, 134, 134, 126, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 169, 150, 169, 169, 150, 169, 150, 169, 169, 169, 169, 150, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 150, 169, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  35,  35,  35,  52,  52,  35,  52,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  54,  52,  52,  52,
 52,  54,  52,  52,  52,  52,  52,  52,  52,  52,  52,  59,  52,  52,  50,  59,
 54,  59,  59,  59,  59,  50,  59,  59,  59,  59,  59,  59,  73,  59,  73,  63,
 73,  59,  73,  59,  59,  78,  73,  63,  50,  97,  87,  73,  63,  63,  97,  87,
 91,  93,  87,  87,  97,  97,  87,  91,  91, 105, 105, 105,  98,  87, 105, 105,
105, 105, 108, 105, 108, 105,  98, 105,  98,  98, 105, 105, 105,  98, 105, 105,
 98,  98, 105, 105, 105,  98, 105, 108, 105, 105, 108, 105, 105, 108, 108, 105,
105, 105, 105, 105, 103, 108, 105, 101, 105, 101, 105, 105, 108, 104, 103, 105,
103, 103, 108, 101, 112, 112, 112, 112, 112, 112, 134, 126, 112, 134, 108, 112,
112, 112, 112, 112, 134, 134, 141, 126, 126, 126, 112, 134, 141, 134, 126, 152,
126, 134, 134, 134, 126, 134, 126, 134, 134, 126, 134, 134, 152, 134, 126, 134,
134, 134, 126, 141, 126, 141, 152, 126, 134, 126, 134, 126, 134, 134, 134, 152,
126, 134, 126, 169, 181, 169, 169, 126, 181, 126, 126, 181, 169, 169, 126, 169,
181, 169, 181, 169, 181, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
181, 169, 169, 169, 199, 169, 169, 199, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  54,  51,  40,  54,  54,  54,  50,  51,  51,  54,  51,  54,  51,  54,  51,
 54,  54,  51,  51,  51,  51,  71,  71,  71,  71,  71,  71,  71,  71,  88,  71,
 54,  71,  71,  72,  71,  88,  72,  71,  71,  82,  71,  72,  73,  73,  71,  78,
 73,  71,  71,  72,  78,  90,  73,  90,  50,  86,  86,  73,  90,  90,  86,  86,
 86,  93,  86,  86,  86,  86,  86,  90,  90,  90,  90,  91,  90,  98,  98,  96,
 96,  96, 108,  96,  90,  96, 101,  96, 108, 101,  96, 102,  98,  90, 102,  98,
102,  90, 102, 103, 101, 101, 103, 101, 103, 103, 101, 103, 103, 113, 108, 103,
103, 103, 103, 101, 101, 108, 101, 101, 103, 101, 103, 103, 108, 104, 103, 124,
101, 124, 101, 101, 124, 124, 124, 124, 124, 124, 134, 124, 124, 134, 128, 124,
124, 120, 112, 112, 134, 120, 141, 112, 134, 126, 112, 120, 141, 134, 134, 134,
134, 134, 134, 134, 134, 120, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 150, 169, 169, 150, 150, 150, 169, 150, 169, 169, 150, 169,
150, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 210, 169, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,
 40,  40,  40,  40,  40,  40,  40,  54,  40,  40,  40,  40,  66,  40,  40,  40,
 79,  79,  79,  40,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  71,  71,
 79,  71,  71,  71,  71,  71,  71,  71,  71,  68,  68,  71,  79,  71,  68,  68,
 71,  71, 100,  71,  71, 100,  71,  68,  50,  90,  86,  90,  68, 100,  90,  90,
 90,  93,  90,  90,  90,  90,  86,  90, 100,  90,  90,  90, 100,  96,  90, 106,
 90,  90, 100,  90, 100,  90,  90,  90,  90,  90, 106,  90, 102, 100,  90, 103,
100, 100, 106, 102, 102, 106, 102, 101, 101, 103, 101, 125, 103, 100, 128, 125,
113, 125, 125, 101, 125, 125, 125, 101, 125, 125, 124, 103, 128, 137, 125, 125,
125, 125, 128, 125, 125, 125, 128, 125, 125, 124, 120, 124, 125, 120, 128, 125,
120, 120, 120, 128, 120, 128, 141, 124, 120, 134, 120, 120, 107, 120, 120, 120,
134, 120, 120, 120, 120, 128, 153, 153, 134, 134, 153, 134, 141, 153, 153, 153,
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 134, 153, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 150, 150, 150, 150, 150, 153, 150, 150, 150,
150, 169, 150, 150, 150, 150, 150, 150, 150, 169, 150, 150, 169, 150, 150, 150,
150, 150, 150, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  74,  71,  71,  71,  71,  71,  74,  71,  71,  88,  71,
 54,  71,  71,  72,  73,  88,  72,  73,  73,  72,  73,  73,  73,  73,  71,  78,
 73,  73,  73,  73,  73,  90,  73,  90,  50,  86,  86,  73,  90,  90,  86,  86,
 86,  93,  97,  86,  86,  86,  97,  90,  90,  96,  96,  96,  90,  98,  98,  96,
 96,  96, 108,  96, 108, 102, 108,  96, 108, 108,  96, 102,  98, 102, 102, 105,
102, 102, 102, 103, 103, 108, 103, 108, 103, 103, 108, 103, 103, 113, 108, 103,
113, 103, 103, 103, 124, 108, 124, 101, 124, 124, 103, 103, 108, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 134, 124, 124, 134, 128, 124,
124, 124, 124, 141, 134, 134, 145, 132, 134, 126, 141, 134, 141, 134, 134, 134,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 153, 169, 169, 150, 169, 150, 169, 169, 169, 169, 150, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 169, 169, 210, 169, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  54,  51,  51,  41,  54,  54,  50,  51,  51,  51,  51,  54,  51,  51,  51,
 54,  54,  51,  74,  51,  74,  51,  74,  74,  74,  71,  74,  71,  71,  88,  71,
 54,  71,  71,  74,  73,  88,  72,  71,  73,  82,  71,  88,  73,  73,  71,  78,
 73,  73,  73,  73,  73,  90,  73,  90,  50,  86,  86,  73,  82,  90,  86,  86,
 86,  93,  97,  86,  86,  86,  97,  90,  90,  96,  96,  96,  90,  98,  98,  96,
 96,  96, 108,  96, 108, 102, 108, 102, 108, 108,  96, 102,  98, 102, 102, 105,
102, 102, 102,  98, 102, 108, 102, 108, 103, 103, 108, 113, 103, 113, 108, 113,
113, 103, 103, 101, 124, 108, 124, 137, 124, 124, 103, 103, 108, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 134, 124, 124, 134, 128, 124,
124, 124, 124, 124, 134, 134, 141, 132, 134, 126, 124, 134, 141, 134, 134, 134,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 134, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 134, 169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 210, 169, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 54,  54,  51,  51,  54,  54,  54,  50,  51,  54,  54,  51,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  74,  71,  74,  74,  74,  71,  74,  71,  71,  88,  71,
 93,  71,  71,  72,  73,  88,  71,  73,  73,  82,  73,  88,  73,  88,  71,  78,
 73,  73,  73,  73,  73,  90,  73,  90,  50,  86,  86,  73,  90,  90,  86,  86,
 86,  93,  97,  86,  86,  86,  97,  90,  90,  96,  96,  96,  96,  98,  98,  96,
 96,  96, 108, 102, 108, 102, 108, 102, 108, 108,  96, 102,  98, 102, 102, 105,
102, 102, 102,  98, 102, 108, 113, 108, 103, 103, 108, 113, 103, 113, 108, 113,
113, 103, 124, 103, 124, 125, 124, 137, 124, 124, 124, 103, 108, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 134, 128, 124,
124, 124, 124, 124, 134, 134, 145, 132, 134, 126, 141, 134, 141, 134, 134, 141,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 134, 153, 153, 169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  54,  51,  40,  41,  54,  54,  50,  51,  51,  54,  74,  66,  79,  54,  74,
 54,  54,  74,  74,  74,  74,  79,  74,  74,  71,  71,  74,  71,  71,  88,  71,
 93,  71,  71,  74,  71,  88,  71,  71,  71,  82,  71,  71,  73,  73,  71,  90,
 71,  71,  71,  71,  71,  90,  73,  90,  50,  94,  86,  73,  90,  90,  86,  86,
 90,  93,  94,  86,  90,  90,  97,  90, 100,  90,  90,  96,  90,  96, 102,  96,
102,  96, 108, 102, 106, 102, 108, 102, 102, 108, 102, 102, 102, 106, 102,  98,
102, 106, 102, 102, 102, 102, 113, 108, 113, 113, 108, 113, 103, 125, 128, 113,
113, 113, 124, 101, 124, 125, 124, 137, 124, 124, 124, 103, 125, 137, 124, 124,
124, 124, 108, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 134, 128, 124,
124, 124, 124, 125, 134, 120, 145, 132, 134, 132, 124, 134, 141, 134, 134, 134,
134, 134, 134, 134, 134, 128, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 153, 153, 153, 134, 153, 134, 134, 134, 153, 153,
134, 153, 153, 153, 153, 169, 153, 150, 169, 150, 169, 169, 169, 169, 150, 169,
169, 169, 150, 169, 150, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
150, 169, 210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  35,  52,  35,  57,  52,  35,  54,  52,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  52,  54,  52,  52,  52,
 54,  54,  52,  52,  52,  52,  52,  52,  52,  74,  88,  88,  88,  88,  50,  88,
 88,  88,  88,  88,  88,  87,  73,  88,  88,  72,  73,  88,  88,  88,  73,  78,
 88,  88,  73,  97,  97,  94,  88,  97,  50,  97,  87,  97,  91,  91,  97,  97,
 97,  93,  97,  97,  97,  97,  87,  97,  96,  97,  97,  97,  97, 105, 105,  97,
105, 105, 108, 105, 108, 105, 108, 105, 108, 108, 105, 105, 105, 102, 105, 105,
108, 108, 105, 105, 105, 108, 105, 108, 105, 105, 108, 105, 105, 113, 108, 105,
105, 105, 105, 105, 124, 108, 124, 137, 124, 124, 105, 105, 108, 137, 124, 145,
124, 132, 108, 132, 132, 132, 124, 124, 132, 132, 132, 132, 132, 134, 108, 132,
132, 132, 132, 141, 134, 134, 145, 152, 132, 152, 141, 134, 141, 132, 152, 152,
152, 134, 134, 134, 152, 134, 152, 134, 134, 126, 134, 134, 141, 134, 152, 141,
134, 134, 152, 141, 152, 141, 141, 152, 134, 152, 134, 126, 134, 134, 134, 181,
152, 181, 181, 169, 181, 169, 181, 181, 181, 181, 181, 181, 169, 181, 181, 169,
181, 169, 181, 181, 181, 181, 169, 169, 181, 169, 181, 169, 169, 181, 169, 169,
181, 169, 169, 169, 199, 169, 210, 199, 210, 210, 210, 210, 210, 218, 218, 218,
 18,  41,  54,  41,  35,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  51,  54,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  54,  54,  54,  73,  71,  54,  73,  73,  73,  88,  88,
 93,  73,  73,  72,  73,  88,  73,  73,  73,  78,  73,  88,  73,  88,  73,  78,
 73,  73,  73,  73,  73,  90,  73,  91,  50,  91,  91,  93,  91,  90,  91,  91,
 91,  93,  88,  91,  96,  96, 105,  96,  90,  96,  96,  96,  96, 105,  98,  84,
 96,  96, 108,  96, 108,  98, 108,  98, 108, 108,  96,  98, 105, 113, 103, 105,
113, 113, 103, 103, 103, 103, 103, 103, 103, 105, 108, 103, 103, 113, 108, 103,
103, 103, 112, 103, 112, 112, 112, 101, 112, 112, 112, 103, 112, 137, 112, 145,
112, 112, 112, 112, 112, 112, 112, 141, 112, 112, 112, 112, 112, 134, 120, 141,
141, 141, 141, 141, 134, 120, 145, 141, 141, 126, 141, 141, 141, 141, 141, 141,
126, 141, 141, 141, 141, 153, 141, 141, 134, 126, 141, 134, 141, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 126, 169, 153, 141, 141,
175, 175, 175, 153, 175, 169, 175, 175, 175, 175, 169, 175, 169, 175, 181, 169,
175, 169, 175, 175, 175, 175, 169, 169, 175, 169, 175, 169, 169, 199, 169, 169,
199, 199, 199, 210, 199, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  18,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  57,  57,  57,  57,
 57,  57,  57,  57,  57,  57,  57,  50,  57,  57,  57,  57,  66,  57,  57,  57,
 57,  57,  57,  57,  57,  57,  57,  57,  57,  57,  74,  57,  74,  74,  57,  74,
 79,  74,  74,  74,  74,  88,  74,  74,  74,  82,  74,  74,  74,  74,  74,  82,
 74,  74,  79,  74,  74,  82,  74,  82,  50,  82,  82,  94,  82,  82,  82,  82,
 82,  93,  97,  82,  82,  82,  82,  82, 106,  82,  82,  82,  82,  82,  82, 109,
117, 109, 117, 117, 117, 117, 117, 117, 117, 117, 109, 117, 117, 106, 117, 116,
117, 106, 117, 117, 117, 117, 117, 117, 117, 116, 117, 117, 117, 106, 117, 117,
110, 116, 117, 117, 117, 108, 117, 117, 117, 117, 116, 117, 117, 117, 117, 122,
117, 137, 117, 137, 137, 137, 137, 124, 137, 137, 137, 137, 137, 137, 137, 124,
137, 137, 137, 125, 134, 134, 124, 132, 137, 132, 137, 134, 124, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 132, 134, 134, 134,
134, 134, 134, 161, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 134, 134, 134, 134, 187, 134, 187, 134, 134, 169, 134, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
187, 169, 169, 169, 187, 169, 169, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  74,  74,  54,  74,  54,  74,  54,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  71,  74,  74,  74,  88,  88,
 93,  71,  71,  74,  73,  88,  74,  73,  73,  74,  73,  88,  73,  88,  71,  74,
 73,  73,  73,  94,  94,  90,  94,  94,  50,  94,  97,  93,  90,  90,  94,  94,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  96,  96,  96,  96,  97, 102,  93,
102,  96, 108, 102, 108, 102, 108, 102, 108, 108, 102, 102, 116, 102, 102, 105,
102, 106, 102, 113, 113, 113, 113, 108, 113, 116, 108, 113, 103, 125, 108, 113,
113, 113, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 124, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 124, 124, 134, 134, 145, 132, 132, 132, 141, 134, 141, 134, 132, 132,
132, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 153, 153,
134, 153, 153, 153, 153, 169, 169, 175, 169, 187, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 41,  41,  57,  66,  41,  52,  52,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 74,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,
 93,  74,  74,  74,  74,  88,  74,  74,  74,  82,  74,  88,  93,  88,  74,  74,
 73,  74,  73,  74,  94,  94,  94,  94,  50,  94,  82,  93,  82,  82,  94,  82,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94,  94,  94,  97,  82,  93,
102, 102, 108, 102, 106, 102, 108, 102, 108, 108, 110, 102, 116, 106, 102, 105,
102, 106, 102, 102, 113, 108, 113, 108, 113, 116, 108, 113, 116, 125, 108, 113,
113, 113, 113, 137, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 132, 124, 134, 134, 124, 132, 134, 132, 124, 134, 124, 134, 134, 132,
134, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 132, 134, 134, 134,
134, 134, 134, 141, 134, 153, 134, 134, 134, 134, 134, 134, 134, 134, 134, 134,
134, 134, 134, 153, 134, 134, 134, 187, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
169, 169, 169, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  40,  40,  40,  66,  66,  40,  40,  40,  40,  66,  40,  66,  66,
 79,  54,  40,  66,  79,  79,  79,  54,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  88,  71,
 93,  71,  71,  71,  71,  88,  71,  71,  71,  68,  68,  71,  79,  71, 100, 100,
 71,  71, 100,  90,  90, 100,  90, 100,  87,  90,  90, 100, 100, 100,  90,  90,
 90,  93,  90,  90,  90,  90,  96, 100, 100, 106, 106, 106, 100,  96,  90,  84,
106, 106, 100, 106, 100, 106, 106, 106, 100, 106, 106, 106, 103, 100, 125, 103,
100, 100, 125, 125, 125, 125, 125, 125, 125, 103, 128, 125, 103, 100, 128, 125,
125, 125, 125, 107, 125, 128, 107, 107, 107, 107, 141, 107, 128, 120, 107, 145,
107, 107, 128, 107, 107, 107, 128, 141, 107, 107, 107, 141, 107, 120, 128, 141,
141, 128, 141, 156, 120, 128, 145, 141, 141, 141, 141, 128, 141, 141, 141, 141,
141, 153, 153, 153, 141, 156, 153, 153, 153, 141, 153, 153, 141, 153, 153, 153,
153, 153, 153, 141, 153, 156, 141, 153, 153, 153, 153, 150, 153, 153, 153, 175,
150, 150, 150, 153, 150, 150, 150, 175, 150, 150, 150, 150, 153, 150, 150, 150,
150, 150, 150, 150, 175, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 52,  54,  74,  66,  74,  54,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,
 93,  74,  74,  74,  73,  88,  74,  74,  73,  74,  74,  88,  93,  88,  71,  74,
 73,  94,  93,  94,  94,  94,  94,  94,  50,  94,  97,  93,  94,  90,  94,  94,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94, 102, 106,  97, 102,  93,
102, 110, 108, 102, 106, 102, 108, 102, 108, 108, 110, 102, 116, 106, 102, 105,
102, 106, 113, 113, 113, 113, 113, 108, 113, 116, 108, 113, 116, 125, 108, 113,
113, 113, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 132, 124, 134, 134, 145, 132, 132, 132, 132, 134, 141, 132, 132, 132,
132, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 153,
134, 134, 153, 153, 153, 169, 169, 187, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  41,  41,  66,  66,  41,  41,  66,  66,  66,  66,  66,  66,
 66,  66,  40,  66,  66,  66,  66,  88,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  79,  88,  79,
 79,  79,  79,  92,  79,  88,  79,  79,  79,  92,  79,  79,  79,  79, 100, 100,
 79,  79, 100,  79,  79, 100,  79, 100,  87, 106,  94, 106, 100, 100, 106, 106,
106,  93, 106, 106, 106, 106,  94, 106, 100, 106, 106, 106, 100, 102, 106, 106,
106, 106, 100, 106, 100, 106, 106, 106, 106, 106, 106, 106, 102, 100, 106, 110,
106, 100, 106, 113, 125, 125, 125, 125, 125, 113, 125, 125, 113, 100, 128, 125,
125, 125, 125, 125, 125, 140, 125, 137, 125, 125, 125, 124, 128, 137, 125, 125,
125, 125, 128, 125, 125, 125, 128, 125, 125, 125, 125, 124, 125, 137, 128, 125,
125, 128, 125, 140, 134, 128, 145, 124, 153, 132, 153, 128, 141, 153, 153, 153,
134, 153, 153, 153, 153, 128, 153, 153, 153, 134, 153, 153, 141, 153, 153, 153,
153, 153, 153, 153, 153, 156, 153, 153, 153, 153, 153, 134, 153, 153, 153, 153,
153, 153, 153, 153, 153, 153, 153, 153, 153, 150, 153, 153, 153, 153, 150, 169,
153, 169, 150, 150, 150, 150, 169, 169, 150, 169, 150, 169, 169, 169, 169, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  73,  74,  73,  88,  74,  74,  73,  74,  94,  88,  93,  88,  73,  74,
 73,  94,  93,  94,  94,  94,  94,  94,  50,  94,  97,  93,  94,  90,  94,  94,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94, 102, 106,  97, 102,  93,
102, 110, 108, 102, 106, 102, 108, 102, 108, 108, 110, 102, 116, 106, 102, 105,
113, 106, 113, 113, 113, 113, 113, 108, 113, 116, 108, 113, 116, 125, 108, 113,
113, 113, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 124, 124, 124, 124, 124, 124, 124, 137, 132, 124, 137, 128, 124,
124, 124, 132, 124, 134, 134, 145, 132, 132, 132, 141, 134, 141, 132, 132, 132,
132, 134, 134, 134, 134, 153, 134, 134, 134, 134, 134, 134, 141, 134, 134, 141,
134, 134, 134, 141, 134, 153, 141, 153, 153, 134, 153, 134, 134, 153, 153, 153,
134, 153, 153, 153, 153, 169, 153, 178, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  54,  54,  41,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  54,  54,  54,  54,  50,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  71,  54,  54,  71,  71,  54,  88,  73,  73,  88,  88,
 93,  73,  73,  73,  73,  88,  73,  73,  73,  78,  73,  88,  93,  88,  73,  90,
 73,  73,  93,  73,  94,  90,  93,  90,  50,  94,  91,  93,  90,  90,  96,  91,
 96,  93,  88,  96,  96,  96, 105,  96, 106,  96,  96,  96,  96, 105,  98,  93,
 96,  96, 108, 102, 108, 102, 108, 113, 108, 108, 113, 113, 103, 113, 113, 105,
113, 113, 113, 113, 113, 113, 113, 113, 103, 103, 108, 113, 103, 125, 108, 124,
145, 124, 124, 124, 124, 125, 124, 137, 124, 124, 141, 132, 125, 137, 124, 145,
124, 141, 124, 124, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 128, 141,
141, 141, 141, 141, 134, 153, 145, 141, 141, 141, 141, 141, 141, 141, 141, 141,
141, 141, 141, 141, 141, 153, 141, 141, 141, 126, 141, 134, 141, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 126, 153, 153, 175, 175,
175, 175, 175, 153, 175, 169, 175, 175, 175, 175, 175, 175, 175, 175, 175, 169,
175, 169, 175, 175, 175, 175, 175, 169, 175, 169, 175, 175, 169, 199, 175, 175,
175, 199, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  52,  52,  52,  52,
 52,  52,  57,  74,  52,  52,  52,  50,  74,  52,  74,  74,  54,  74,  74,  74,
 74,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  74,  88,  74,  74,  88,  93,  88,  73,  74,
 88,  94,  93,  94,  97,  94,  88,  94,  50,  97,  97,  93,  94,  94,  97,  94,
 97,  93,  97,  97,  97,  97,  97,  94, 106,  97,  97,  97,  94, 105, 102,  93,
102,  97, 108, 110, 108, 102, 108, 116, 108, 108, 110, 102, 105, 110, 102, 105,
110, 110, 113, 116, 113, 108, 113, 108, 116, 116, 108, 113, 105, 113, 108, 113,
116, 116, 124, 132, 124, 125, 124, 137, 124, 124, 116, 132, 108, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 132, 137, 132, 124, 137, 125, 124,
132, 124, 132, 124, 134, 134, 145, 132, 132, 152, 132, 134, 132, 132, 132, 132,
152, 134, 134, 134, 132, 153, 134, 134, 134, 152, 134, 134, 141, 134, 134, 134,
134, 134, 134, 141, 134, 153, 141, 134, 134, 134, 134, 134, 134, 134, 134, 178,
134, 134, 134, 169, 187, 169, 169, 187, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 187, 169, 187, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
202, 169, 210, 169, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  41,  41,  66,  54,  41,  41,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  74,  54,  54,  74,  54,  79,  54,  54,
 54,  54,  54,  74,  79,  74,  79,  71,  71,  71,  71,  74,  71,  71,  88,  71,
 93,  71,  71,  71,  73,  88,  71,  71,  73,  94,  71,  88,  93,  88,  71,  90,
 73,  94,  93,  94,  94,  90,  93,  90,  50,  94,  94,  93,  90,  90,  94,  94,
 94,  93,  94,  94,  94,  94,  97,  96, 106,  96,  96,  96, 106, 102, 102,  93,
102, 102, 108, 102, 106, 102, 108, 102, 102, 108, 113, 113, 113, 106, 113, 116,
113, 106, 113, 113, 113, 113, 113, 113, 113, 113, 108, 113, 103, 125, 128, 113,
113, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 124, 137, 128, 141,
124, 141, 141, 141, 134, 153, 145, 141, 141, 132, 141, 153, 141, 141, 141, 141,
141, 141, 141, 153, 141, 153, 141, 153, 134, 134, 153, 134, 141, 153, 141, 141,
153, 153, 141, 141, 153, 153, 141, 141, 153, 153, 153, 134, 153, 153, 153, 141,
153, 153, 153, 153, 153, 169, 153, 175, 153, 175, 169, 169, 153, 169, 175, 169,
169, 169, 175, 169, 175, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  41,  54,  66,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  66,  54,  54,  54,  50,  54,  54,  54,  74,  54,  54,  54,  54,
 54,  54,  54,  74,  54,  74,  54,  54,  71,  71,  71,  88,  71,  71,  88,  88,
 93,  73,  73,  94,  73,  88,  73,  73,  73,  94,  73,  88,  93,  88,  73,  90,
 73,  73,  93,  94,  94,  90,  93,  90,  50,  94,  94,  93,  90,  90,  94,  96,
 96,  93,  88,  96,  96,  96,  97,  96, 106,  96,  96,  96,  96, 105, 102,  93,
102,  96, 108, 102, 106, 102, 108, 113, 102, 108, 113, 113, 116, 113, 113, 105,
113, 113, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 103, 125, 128, 113,
113, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 124, 124, 124, 124, 124, 141, 141, 124, 124, 141, 141, 137, 128, 141,
141, 141, 141, 141, 134, 153, 145, 141, 141, 141, 141, 153, 141, 141, 141, 141,
141, 141, 141, 141, 141, 153, 141, 141, 134, 141, 141, 134, 141, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 153, 141, 141, 134, 153, 153, 153, 175,
175, 153, 175, 153, 175, 169, 175, 175, 175, 175, 175, 175, 169, 175, 175, 169,
175, 169, 175, 175, 175, 175, 169, 169, 175, 169, 175, 175, 169, 199, 175, 175,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,  41,
 57,  41,  57,  66,  74,  52,  74,  50,  57,  74,  74,  74,  66,  74,  74,  74,
 74,  79,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,
 93,  74,  74,  74,  74,  88,  74,  74,  74,  74,  74,  88,  93,  88,  74,  74,
 74,  74,  93,  74,  94,  94,  94,  94,  50,  94,  97,  93,  82, 106,  94,  82,
 94,  93,  97,  94,  94,  94,  97,  94, 106,  94,  94,  94, 106,  97, 117, 109,
110, 109, 108, 110, 106, 110, 117, 110, 108, 117, 110, 110, 116, 106, 110, 116,
110, 106, 110, 116, 110, 113, 119, 108, 119, 116, 117, 119, 116, 125, 108, 119,
116, 119, 119, 137, 119, 125, 124, 137, 124, 124, 116, 132, 125, 137, 124, 122,
124, 124, 137, 137, 124, 124, 124, 124, 124, 137, 137, 132, 124, 137, 128, 124,
132, 137, 132, 125, 134, 137, 139, 132, 132, 132, 132, 134, 132, 137, 132, 132,
132, 161, 161, 134, 161, 153, 161, 161, 134, 134, 134, 134, 132, 134, 134, 161,
134, 134, 134, 154, 134, 153, 161, 161, 134, 134, 134, 134, 134, 134, 134, 161,
134, 134, 134, 153, 187, 134, 187, 187, 187, 187, 187, 187, 169, 187, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
202, 169, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  41,  41,  41,  41,  41,  41,  41,  41,  54,  54,
 74,  54,  74,  66,  54,  54,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  88,  73,  74,  94,  88,  93,  88,  94,  94,
 93,  94,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  94,  94,  94,  97,  94, 106,  94,  94, 110, 106,  97, 102,  93,
110, 110, 108, 110, 106, 110, 108, 110, 108, 108, 110, 113, 116, 110, 113, 116,
113, 106, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 116, 125, 108, 113,
113, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 124, 124, 124, 132, 137, 132, 124, 137, 128, 124,
132, 124, 132, 141, 134, 134, 145, 132, 132, 132, 141, 134, 141, 132, 132, 132,
132, 161, 141, 134, 132, 153, 141, 161, 134, 134, 134, 134, 141, 134, 161, 141,
134, 134, 134, 141, 153, 153, 141, 153, 153, 153, 153, 134, 134, 153, 153, 178,
153, 153, 153, 153, 178, 169, 153, 178, 169, 187, 169, 169, 169, 169, 187, 169,
169, 169, 187, 169, 175, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  76,  76,  57,  76,  41,  76,  76,  52,  52,  52,  52,  52,  52,  52,
 52,  52,  52,  52,  52,  52,  52,  50,  52,  52,  52,  74,  54,  52,  52,  52,
 85,  54,  74,  74,  74,  74,  74,  74,  74,  74,  88,  74,  74,  74,  88,  88,
 93,  88,  88,  74,  88,  88,  74,  88,  88,  74,  97,  88,  88,  88,  94,  74,
 88,  88,  93,  97,  97,  94,  88,  97,  50,  97,  97,  93,  94,  94,  97,  97,
 97,  93,  88,  97,  97,  97, 105,  97, 106,  97,  97,  97,  97, 105, 105,  97,
 97,  97, 108, 116, 108, 116, 108, 105, 108, 108, 116, 116, 105, 110, 116, 105,
116, 110, 116, 116, 116, 116, 116, 108, 116, 105, 108, 116, 105, 113, 108, 116,
116, 116, 116, 132, 124, 124, 124, 137, 132, 132, 116, 105, 108, 137, 132, 145,
132, 132, 137, 132, 132, 132, 124, 124, 132, 132, 132, 132, 132, 137, 137, 132,
132, 132, 132, 124, 134, 134, 145, 152, 132, 152, 132, 134, 132, 132, 132, 132,
152, 132, 132, 134, 152, 153, 152, 161, 134, 152, 134, 134, 141, 134, 152, 161,
161, 134, 152, 141, 152, 141, 141, 152, 134, 152, 134, 152, 134, 134, 134, 178,
152, 181, 181, 169, 181, 169, 181, 181, 181, 181, 181, 181, 169, 181, 181, 169,
181, 169, 181, 181, 181, 181, 169, 169, 181, 169, 181, 169, 169, 202, 169, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  66,  41,  41,  41,  41,  41,  41,  41,  66,  66,
 41,  66,  57,  66,  66,  66,  66,  88,  74,  79,  79,  74,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  79,  79,  79,  74,  79,  79,  88,  79,
 79,  79,  79,  74,  79,  88,  74,  74,  79,  74,  74,  74,  79,  79,  79,  74,
 79,  79,  79,  74,  94, 106,  94, 106,  50,  94,  94,  93, 106, 106,  94, 106,
106,  93,  94,  94, 106, 106,  97, 106, 100, 106, 106, 106, 106, 110, 106, 106,
106, 106, 100, 106, 100, 106, 117, 110, 106, 106, 106, 106, 110, 106, 106, 116,
106, 106, 110, 110, 113, 125, 113, 125, 113, 119, 117, 125, 119, 125, 128, 125,
122, 122, 125, 137, 125, 125, 125, 137, 125, 125, 122, 132, 125, 137, 125, 125,
125, 125, 137, 137, 125, 125, 125, 125, 125, 137, 137, 124, 125, 137, 128, 125,
124, 125, 137, 125, 137, 128, 145, 132, 137, 132, 124, 137, 154, 137, 137, 161,
132, 161, 161, 134, 161, 128, 161, 161, 134, 134, 134, 134, 154, 134, 161, 153,
153, 134, 161, 154, 153, 153, 153, 153, 153, 153, 153, 134, 134, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 187, 153, 187, 187, 187, 153, 187, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  41,  66,  54,  41,  41,  41,  41,  54,  54,  54,  54,
 74,  54,  74,  66,  54,  54,  74,  50,  74,  74,  74,  74,  79,  74,  74,  74,
 54,  54,  74,  74,  74,  74,  79,  74,  74,  74,  79,  74,  74,  74,  88,  88,
 93,  74,  88,  74,  88,  88,  74,  88,  88,  74,  94,  88,  93,  88,  94,  94,
 93,  94,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  94,  94,  94,  97,  94, 106,  94,  94, 110, 106, 116, 102,  93,
110, 110, 108, 110, 106, 110, 108, 110, 102, 108, 110, 113, 116, 113, 113, 116,
113, 106, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 116, 125, 108, 113,
122, 124, 124, 124, 124, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 124, 124, 124, 124, 124, 124, 132, 137, 132, 124, 137, 128, 124,
132, 124, 132, 141, 134, 137, 145, 132, 132, 132, 141, 153, 141, 132, 132, 141,
132, 141, 141, 134, 141, 153, 141, 153, 134, 152, 161, 134, 141, 134, 141, 141,
153, 153, 141, 141, 153, 153, 141, 141, 153, 153, 153, 134, 153, 153, 153, 178,
153, 153, 153, 153, 178, 169, 153, 178, 169, 187, 187, 187, 169, 169, 187, 169,
169, 169, 187, 169, 175, 169, 169, 169, 169, 169, 169, 169, 169, 202, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 18,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  52,
 52,  76,  52,  52,  52,  52,  52,  50,  52,  52,  85,  52,  52,  52,  85,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  74,  85,  85,  85,  85,  85,  74,
 85,  85,  93,  85,  97,  97,  88,  97,  50,  97,  97,  97,  97,  97,  97,  97,
 97,  93,  88,  97,  97,  97,  87,  97, 109,  97,  97,  97,  97, 105, 105,  97,
 97,  97, 108, 116, 108, 116, 117, 105, 108, 108, 116, 116, 105, 116, 116, 105,
116, 116, 116, 105, 116, 116, 116, 116, 116, 105, 108, 116, 105, 122, 108, 116,
116, 116, 116, 105, 116, 122, 116, 137, 116, 132, 116, 105, 108, 137, 132, 116,
132, 132, 137, 132, 132, 132, 132, 132, 132, 132, 137, 132, 132, 137, 137, 132,
132, 132, 132, 132, 137, 137, 145, 152, 152, 152, 132, 161, 132, 152, 152, 152,
152, 152, 161, 152, 152, 161, 152, 161, 152, 152, 152, 134, 152, 152, 152, 152,
152, 152, 152, 152, 152, 161, 152, 152, 134, 152, 152, 152, 134, 152, 152, 152,
152, 152, 152, 169, 181, 169, 181, 152, 181, 152, 187, 181, 169, 187, 181, 187,
181, 169, 181, 187, 181, 187, 187, 187, 187, 169, 187, 169, 169, 187, 202, 202,
202, 202, 202, 202, 202, 210, 202, 202, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  41,  66,  41,  41,  41,  41,  41,  41,  41,  66,  66,
 74,  66,  74,  66,  66,  79,  79,  50,  74,  74,  79,  74,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  74,  79,  79,  74,  79,  79,  88,  74,
 93,  74,  79,  74,  79,  88,  74,  74,  79,  74,  74,  88,  93,  88,  79,  74,
 93,  94,  79,  94,  94, 106,  93, 106,  50,  94,  94,  93, 106, 106,  94,  94,
 94,  93,  93,  94,  94,  94,  97, 106, 106, 106, 106, 106, 106, 110, 102,  93,
106, 106, 108, 110, 106, 110, 108, 110, 106, 110, 110, 110, 110, 106, 110, 116,
106, 106, 113, 113, 113, 113, 113, 113, 113, 116, 108, 113, 116, 125, 128, 113,
122, 122, 125, 137, 125, 125, 125, 137, 124, 125, 124, 132, 125, 137, 125, 145,
125, 124, 137, 137, 124, 124, 125, 125, 124, 124, 137, 132, 124, 137, 128, 124,
124, 125, 132, 125, 137, 137, 145, 132, 132, 132, 154, 153, 154, 132, 132, 132,
132, 161, 161, 134, 161, 153, 161, 161, 134, 134, 161, 134, 154, 134, 161, 153,
153, 153, 161, 141, 153, 153, 153, 153, 153, 153, 153, 134, 153, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 187, 153, 187, 187, 187, 153, 187, 187, 169,
187, 169, 187, 187, 187, 187, 169, 169, 187, 169, 187, 169, 169, 187, 169, 169,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  66,  66,  41,  41,  41,  41,  66,  66,  66,  66,
 66,  66,  57,  66,  66,  66,  66,  88,  57,  66,  66,  66,  66,  66,  79,  79,
 79,  79,  79,  74,  79,  79,  79,  79,  79,  79,  79,  74,  79,  79,  88,  79,
 79,  92,  92,  92,  92,  88,  92,  92,  92,  92,  92,  92,  79,  92,  92,  92,
 92,  92,  79,  92,  92,  92,  92,  92,  87,  92,  92,  93, 106, 106, 106, 106,
106,  93,  94, 106, 106, 106,  94, 106, 100, 106, 106, 106, 106, 110, 117, 106,
106, 106, 100, 106, 100, 106, 117, 106, 106, 106, 106, 106, 110, 106, 106, 110,
106, 106, 106, 110, 106, 106, 106, 125, 119, 110, 117, 125, 119, 140, 128, 125,
121, 125, 125, 137, 125, 125, 125, 137, 125, 125, 122, 137, 140, 137, 125, 125,
125, 125, 137, 137, 125, 125, 125, 125, 125, 137, 137, 137, 125, 137, 128, 125,
125, 125, 137, 140, 137, 128, 138, 132, 137, 132, 125, 137, 125, 137, 137, 161,
137, 161, 161, 161, 161, 128, 161, 161, 134, 134, 161, 134, 154, 161, 161, 161,
161, 161, 161, 154, 161, 153, 153, 153, 153, 153, 153, 134, 134, 153, 153, 153,
153, 153, 153, 153, 153, 169, 153, 187, 153, 187, 187, 187, 153, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 187, 169, 169, 187, 187, 187,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  41,  41,  57,  41,  66,  41,  41,  41,  41,  41,  76,  76,  76,  76,
 74,  76,  74,  66,  74,  74,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 74,  79,  74,  74,  74,  74,  79,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  74,  74,  74,  74,  88,  93,  88,  94,  74,
 93,  94,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  94,  94,  94,  97,  94, 106, 109, 109, 110, 106,  97, 110,  93,
110, 110, 108, 110, 106, 110, 108, 110, 110, 108, 110, 110, 116, 106, 110, 116,
110, 106, 110, 119, 119, 113, 119, 113, 119, 116, 108, 119, 116, 125, 108, 119,
122, 122, 122, 137, 125, 125, 124, 137, 124, 124, 122, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 125, 124, 124, 132, 137, 132, 124, 137, 128, 124,
132, 124, 132, 125, 137, 137, 145, 132, 132, 132, 132, 161, 154, 132, 132, 132,
132, 161, 161, 161, 161, 153, 161, 161, 134, 134, 161, 134, 154, 161, 161, 161,
161, 161, 161, 141, 161, 153, 178, 161, 153, 161, 161, 134, 134, 153, 153, 178,
187, 187, 177, 153, 178, 169, 187, 187, 187, 187, 187, 187, 169, 187, 187, 169,
187, 169, 187, 187, 187, 187, 187, 169, 187, 169, 187, 169, 169, 187, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  41,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  74,  76,  76,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 74,  54,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  88,  74,  88,  88,  74,  88,  88,  74,  74,  88,  93,  88,  94,  74,
 93,  88,  93,  94,  97,  94,  93,  94,  50,  94,  97,  93,  94, 106,  97,  94,
 97,  93,  88,  97,  97,  97,  97, 109, 106, 109, 109, 109, 109, 116, 110,  93,
110, 109, 108, 110, 106, 110, 108, 116, 110, 108, 116, 116, 116, 110, 116, 116,
110, 121, 116, 116, 119, 119, 119, 119, 116, 116, 108, 119, 116, 125, 108, 122,
116, 122, 122, 132, 122, 125, 124, 137, 124, 124, 139, 132, 125, 137, 124, 145,
124, 132, 137, 137, 132, 132, 124, 124, 132, 132, 137, 132, 132, 137, 125, 132,
132, 132, 132, 154, 137, 137, 145, 132, 132, 163, 132, 161, 154, 132, 132, 132,
152, 161, 161, 161, 161, 153, 161, 161, 161, 152, 161, 134, 154, 161, 161, 161,
161, 161, 161, 178, 161, 153, 178, 161, 161, 161, 161, 152, 134, 161, 177, 178,
187, 187, 187, 153, 178, 169, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  76,  41,  57,  41,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 74,  76,  74,  66,  74,  74,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  79,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  74,  93,  74,  94,  88,  93,  88,  94,  74,
 93,  94,  93,  94,  94, 106,  93,  94,  50,  94,  97,  93, 106, 106,  94,  94,
 94,  93,  88,  94,  94, 109,  97, 109, 106, 109, 109, 110, 106, 116, 110,  93,
110, 110, 108, 110, 106, 110, 110, 110, 110, 110, 110, 110, 116, 106, 119, 116,
110, 106, 119, 119, 119, 119, 119, 119, 119, 116, 137, 119, 116, 125, 125, 122,
122, 122, 122, 132, 125, 125, 124, 137, 124, 124, 122, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 125, 124, 132, 132, 137, 132, 132, 137, 128, 124,
132, 124, 132, 154, 137, 137, 145, 132, 132, 132, 154, 161, 154, 132, 132, 154,
132, 161, 161, 161, 161, 153, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 153, 178, 178, 153, 161, 161, 134, 177, 177, 177, 178,
177, 177, 177, 153, 178, 169, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  41,  66,  66,  41,  41,  66,  66,  66,  66,  66,  66,
 74,  66,  74,  66,  66,  79,  79,  88,  74,  79,  79,  74,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  74,  79,  79,  74,  79,  79,  88,  88,
 93,  79,  79,  74,  93,  88,  74,  74,  93,  74,  94,  88,  93,  88, 106,  74,
 93,  94,  93,  94,  94, 106,  93, 106,  87,  94,  94,  93, 106, 106,  94,  94,
 94,  93,  93,  94,  94,  94,  97, 106, 106, 106, 106, 110, 106, 118, 110,  93,
110, 110, 108, 110, 106, 110, 110, 110, 110, 110, 110, 110, 116, 106, 113, 116,
113, 106, 113, 119, 119, 125, 119, 125, 119, 116, 137, 122, 116, 125, 140, 122,
122, 122, 125, 137, 125, 125, 125, 137, 124, 125, 122, 132, 125, 137, 125, 145,
125, 124, 137, 137, 124, 124, 125, 125, 124, 132, 137, 132, 124, 137, 128, 154,
132, 125, 132, 159, 137, 137, 145, 132, 154, 132, 154, 161, 154, 154, 154, 154,
132, 161, 154, 161, 154, 153, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 141, 153, 153, 178, 178, 153, 153, 153, 187, 153, 153, 153, 178,
177, 177, 177, 153, 178, 169, 177, 178, 187, 187, 187, 187, 153, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  41,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  74,  74,  74,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  88,  88,  74,  88,  93,  74,  94,  88,  93,  88,  94,  74,
 93,  94,  93,  94,  94, 106,  93,  94,  50,  94,  97,  93, 106, 106,  94,  94,
 94,  93,  88, 109, 109, 109,  97, 109, 106, 109, 109, 109, 106, 118, 110,  93,
110, 110, 108, 110, 106, 110, 110, 110, 110, 110, 110, 110, 116, 121, 119, 116,
110, 106, 119, 119, 119, 119, 119, 119, 119, 116, 137, 122, 116, 125, 125, 122,
122, 122, 122, 132, 125, 125, 124, 137, 124, 124, 139, 132, 125, 137, 124, 145,
124, 124, 137, 137, 132, 132, 125, 124, 132, 132, 137, 132, 132, 137, 128, 154,
132, 132, 132, 154, 137, 137, 145, 132, 132, 132, 154, 161, 154, 132, 132, 154,
132, 161, 161, 161, 161, 153, 161, 161, 161, 152, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 153, 178, 178, 153, 161, 161, 187, 177, 177, 177, 178,
187, 187, 177, 153, 178, 187, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 169, 202, 202, 169, 202, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  41,  57,  76,  66,  66,  76,  76,  76,  76,  66,  76,  66,  54,
 74,  54,  74,  66,  79,  79,  79,  50,  74,  74,  79,  74,  79,  79,  79,  79,
 79,  79,  79,  74,  79,  74,  79,  79,  74,  79,  93,  74,  79,  79,  88,  88,
 93,  93,  93,  74,  93,  88,  94,  88,  93,  74,  94,  88,  93,  88, 106,  94,
 93,  94,  93,  94,  94, 106,  93, 106,  87,  94,  94,  93, 106, 106,  94,  94,
 94,  93,  93,  94,  94,  94,  97, 106, 106, 110, 110, 110, 106, 116, 110,  93,
110, 110, 108, 110, 106, 110, 113, 110, 113, 113, 110, 113, 116, 106, 113, 116,
113, 106, 113, 119, 113, 113, 119, 113, 119, 116, 137, 122, 116, 125, 140, 122,
122, 122, 125, 132, 125, 125, 124, 137, 124, 124, 124, 132, 125, 137, 124, 145,
124, 124, 137, 137, 124, 124, 125, 124, 124, 132, 137, 132, 124, 137, 128, 154,
132, 154, 154, 141, 137, 153, 145, 154, 154, 132, 141, 153, 141, 154, 154, 154,
132, 154, 141, 161, 141, 153, 141, 141, 161, 132, 161, 161, 141, 161, 141, 141,
153, 153, 178, 141, 178, 153, 178, 178, 153, 178, 178, 187, 153, 153, 178, 178,
178, 178, 178, 153, 178, 169, 178, 178, 187, 187, 187, 187, 153, 187, 187, 187,
187, 169, 175, 187, 175, 187, 187, 187, 202, 169, 202, 202, 169, 202, 210, 210,
210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  74,  50,  74,  74,  74,  74,  79,  74,  74,  74,
 74,  93,  74,  74,  74,  74,  74,  74,  74,  74,  93,  74,  74,  74,  88,  88,
 93,  88,  88,  74,  88,  88,  74,  88,  93,  74,  94,  88,  93,  88,  94,  94,
 93,  88,  93,  94,  94,  94,  93,  94,  50,  94,  97,  93,  94, 106,  94,  94,
 94,  93,  88,  97, 109, 109,  97, 109, 106, 109, 109, 110, 109, 118, 110,  93,
110, 110, 108, 110, 106, 110, 110, 116, 110, 119, 110, 119, 116, 121, 119, 116,
119, 121, 119, 116, 119, 119, 119, 119, 119, 116, 137, 122, 116, 125, 108, 122,
122, 122, 122, 132, 122, 125, 124, 137, 124, 124, 139, 132, 125, 137, 124, 145,
124, 132, 137, 137, 132, 132, 124, 124, 132, 132, 137, 132, 132, 137, 125, 154,
132, 132, 132, 154, 137, 137, 145, 132, 132, 163, 154, 161, 154, 154, 132, 154,
152, 161, 161, 161, 154, 153, 161, 161, 161, 152, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 178, 178, 178, 161, 178, 178, 152, 177, 177, 178, 178,
178, 187, 178, 153, 178, 187, 187, 178, 187, 187, 187, 187, 169, 187, 187, 187,
187, 169, 187, 187, 202, 187, 187, 187, 202, 169, 202, 202, 169, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  57,  76,  76,  76,  76,  50,  76,  76,  76,  76,  76,  76,  76,  85,
 85,  76,  85,  74,  85,  74,  74,  85,  85,  74,  85,  85,  85,  85,  85,  85,
 85,  85,  85,  85,  85,  85,  74,  85,  85,  74,  85,  85,  85,  85,  74,  74,
 85,  85,  93,  85,  85, 109,  85, 109,  50, 109,  97,  93, 117, 117, 109, 117,
109,  93,  88, 109, 109, 109,  97, 109, 109, 109, 109, 109, 109, 118, 117, 118,
109, 109, 117, 109, 117, 109, 117, 118, 117, 117, 118, 116, 116, 109, 117, 118,
109, 109, 116, 116, 116, 117, 116, 117, 116, 118, 117, 116, 116, 121, 108, 116,
116, 116, 116, 117, 122, 122, 139, 137, 139, 137, 139, 116, 138, 137, 139, 139,
139, 139, 137, 137, 139, 137, 137, 139, 139, 137, 137, 132, 132, 137, 137, 139,
132, 137, 132, 138, 137, 137, 139, 158, 161, 163, 132, 161, 139, 161, 161, 161,
163, 161, 161, 161, 161, 161, 161, 161, 161, 163, 161, 161, 158, 161, 161, 161,
161, 161, 161, 154, 161, 161, 161, 161, 161, 161, 161, 152, 161, 161, 161, 161,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
202, 202, 202, 202, 202, 202, 202, 202, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  41,  54,  54,  41,  54,  66,  54,  54,  54,  54,  54,  54,  54,  54,  54,
 54,  54,  74,  79,  54,  54,  54,  88,  54,  54,  54,  79,  54,  79,  54,  54,
 93,  93,  93,  74,  93,  79,  93,  93,  93,  93,  93,  88,  93,  93,  88,  93,
 93,  93,  93,  88,  93,  88,  94,  93,  93,  94,  93,  88,  93,  93,  93, 106,
 93,  93,  93,  93,  93, 106,  93, 106,  87,  94,  94,  93, 106, 106,  94, 102,
110, 145,  93, 110, 110, 110, 118, 106, 106, 110, 110, 110, 106, 116, 113, 145,
113, 113, 108, 113, 125, 113, 113, 113, 113, 113, 113, 113, 113, 125, 113, 116,
113, 125, 113, 113, 113, 125, 113, 125, 124, 145, 125, 125, 132, 145, 128, 124,
145, 141, 141, 124, 141, 125, 141, 137, 141, 141, 145, 132, 125, 137, 141, 145,
141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 128, 141,
141, 141, 141, 141, 153, 153, 145, 141, 141, 141, 141, 141, 145, 141, 141, 141,
141, 141, 141, 141, 141, 153, 141, 141, 141, 141, 141, 141, 141, 141, 141, 141,
141, 141, 141, 141, 175, 175, 175, 175, 153, 175, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 199, 199, 199, 199,
199, 199, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  76,  50,  74,  74,  74,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  93,  74,  74,  74,  88,  88,
 93,  74,  93,  74,  93,  88,  74,  88,  93,  74,  74,  88,  93,  88,  93,  74,
 93,  93,  93,  94, 109, 106,  93, 109,  87, 109,  97,  93, 106, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
110, 109, 108, 110, 106, 110, 110, 118, 110, 119, 121, 119, 116, 121, 119, 118,
121, 121, 121, 119, 119, 122, 119, 119, 119, 118, 137, 122, 116, 138, 140, 122,
121, 122, 122, 137, 122, 125, 122, 137, 133, 133, 139, 132, 125, 137, 133, 145,
133, 132, 137, 137, 132, 132, 125, 133, 132, 132, 137, 132, 132, 137, 140, 154,
132, 154, 132, 154, 137, 137, 145, 154, 154, 163, 154, 161, 154, 154, 154, 154,
132, 161, 161, 161, 161, 153, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 177, 178, 178, 177, 161, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 169, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  50,  85,  85,  85,  74,  54,  85,  85,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  88,  88,  88,  88,  88,  88,
 93,  88,  88,  88,  88,  88,  88,  88,  88,  97,  88,  88,  93,  88,  93,  97,
 88,  88,  93,  88,  88,  97,  88,  97,  50,  97, 105,  93,  97, 109,  97,  97,
 97,  93,  88,  97,  97,  97, 105,  97, 109, 116, 116, 116, 116, 105, 116, 118,
116, 116, 108, 116, 108, 116, 116, 116, 116, 116, 116, 116, 105, 116, 116, 105,
116, 121, 116, 116, 116, 116, 116, 116, 116, 105, 108, 116, 105, 138, 108, 116,
145, 116, 139, 132, 132, 122, 132, 137, 132, 132, 139, 152, 124, 137, 132, 145,
132, 132, 132, 132, 132, 132, 132, 132, 132, 152, 132, 152, 132, 152, 161, 141,
152, 132, 152, 141, 137, 161, 145, 152, 152, 152, 141, 161, 141, 152, 152, 152,
152, 152, 141, 152, 152, 141, 152, 152, 152, 152, 152, 152, 141, 152, 152, 152,
152, 152, 152, 178, 181, 178, 181, 181, 181, 181, 181, 152, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 199, 199, 199, 199, 199,
199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 210, 218, 218, 218, 218,
 41,  41,  41,  41,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  57,  66,  66,  66,  66,  57,  92,  66,  66,  66,  66,  66,  92,  92,
 92,  66,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
 79,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
 92,  92,  92,  92,  92,  92,  92,  92,  87,  92,  92,  92,  92,  92,  92,  92,
 92,  93,  92,  92,  92,  92,  92,  92, 100,  92,  92, 106, 106, 109, 117, 127,
106, 106, 100, 106, 100, 106, 117, 106, 117, 117, 106, 106, 121, 106, 106, 118,
106, 106, 121, 121, 121, 106, 121, 117, 121, 121, 117, 121, 117, 140, 140, 121,
121, 121, 125, 137, 125, 140, 125, 137, 125, 125, 133, 137, 140, 137, 125, 127,
125, 125, 137, 137, 125, 125, 140, 140, 144, 137, 137, 137, 159, 137, 140, 159,
159, 140, 159, 140, 137, 140, 151, 154, 159, 132, 159, 159, 159, 159, 159, 159,
161, 159, 159, 161, 161, 156, 161, 161, 161, 161, 161, 161, 159, 161, 161, 161,
161, 161, 161, 172, 161, 159, 172, 177, 177, 161, 177, 161, 177, 177, 177, 177,
177, 177, 177, 177, 177, 187, 177, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
202, 187, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 41,  66,  41,  66,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  79,  66,  66,  66,  79,  88,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  79,  79,  92,  79,  79,  79,  79,  79,  79,  79,  92,  79,  79,  92,  79,
 79,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  79,  92, 100, 100,
 92,  92, 100,  92,  92, 100,  92, 100,  87, 100,  92, 100, 100, 100, 106, 106,
106,  93, 106, 106, 106, 106, 106, 100, 100, 106, 106, 106, 100, 106, 106, 127,
106, 106, 100, 106, 100, 106, 106, 106, 100, 140, 106, 140, 106, 100, 140, 127,
140, 100, 140, 125, 140, 140, 140, 140, 140, 127, 140, 140, 125, 140, 128, 140,
140, 140, 140, 125, 140, 140, 140, 137, 140, 140, 140, 125, 140, 137, 140, 145,
140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 140, 156, 140,
140, 140, 140, 140, 156, 156, 145, 159, 159, 154, 156, 156, 140, 156, 159, 159,
154, 156, 156, 156, 156, 156, 156, 156, 153, 154, 156, 153, 159, 156, 156, 156,
156, 153, 153, 156, 156, 156, 156, 156, 156, 153, 156, 153, 153, 153, 153, 156,
153, 153, 153, 156, 153, 153, 153, 209, 153, 209, 209, 209, 156, 209, 209, 209,
209, 153, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 210, 209, 209, 209,
209, 209, 210, 210, 210, 218, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 41,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  76,  85,  74,  76,  76,  74,  66,  74,  74,  74,
 79,  79,  74,  74,  74,  74,  79,  74,  74,  74,  74,  74,  74,  74,  88,  88,
 93,  74,  74,  74,  93,  88,  74,  74,  93,  74,  74,  88,  93,  88,  93,  74,
 93, 109,  93, 109, 109, 109,  93, 109,  87, 109,  97,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
109, 109, 108, 121, 106, 121, 117, 118, 110, 117, 121, 121, 118, 121, 121, 118,
121, 121, 121, 121, 121, 121, 121, 122, 122, 118, 137, 122, 116, 138, 140, 122,
121, 122, 122, 137, 133, 138, 133, 137, 139, 133, 139, 132, 125, 137, 133, 127,
133, 133, 137, 137, 146, 146, 144, 138, 146, 137, 137, 132, 146, 137, 140, 146,
132, 137, 154, 138, 137, 161, 145, 154, 161, 163, 154, 161, 154, 161, 161, 154,
132, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 161, 177, 178, 161, 161, 161, 177, 187, 177, 177, 177, 178,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 18,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  57,  57,  76,  76,  76,  85,  57,  76,  76,  57,  76,  76,  76,  76,
 76,  76,  76,  57,  76,  74,  74,  74,  74,  74,  74,  74,  74,  74,  85,  74,
 93,  74,  74,  74, 111,  85,  74,  74, 111,  74,  74, 111, 111, 111, 111,  74,
111, 111, 111, 111, 111, 111, 111, 117, 143, 111, 117, 111, 117, 117, 109, 117,
117,  93, 118, 109, 109, 109, 118, 109, 109, 109, 109, 117, 109, 118, 117, 123,
117, 109, 117, 109, 117, 117, 117, 109, 117, 117, 109, 117, 118, 109, 117, 118,
117, 121, 117, 117, 117, 117, 117, 117, 117, 118, 117, 117, 117, 135, 117, 121,
121, 121, 121, 117, 117, 138, 139, 117, 139, 117, 139, 139, 138, 167, 139, 127,
139, 139, 137, 137, 139, 137, 137, 138, 139, 137, 137, 139, 146, 137, 137, 146,
137, 137, 137, 138, 167, 137, 138, 158, 161, 158, 161, 161, 149, 161, 161, 161,
161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 168, 161, 161, 161,
161, 161, 161, 168, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 177,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
202, 202, 202, 202, 202, 210, 202, 202, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  74,  76,  74,  74,  74,  74,  74,  74,  74,  74,  74,  85,  85,
 93,  74,  74,  74, 111,  88,  74, 111, 111,  74, 111,  88,  93,  88, 111,  74,
111, 111,  93, 111, 111, 109,  93, 109, 143, 109, 109,  93, 117, 117, 109, 117,
109,  93, 118, 109, 109, 109, 118, 109, 109, 109, 109, 109, 109, 118, 117, 123,
109, 109, 117, 109, 106, 109, 117, 118, 117, 117, 118, 121, 118, 121, 121, 118,
121, 121, 121, 121, 121, 121, 121, 121, 121, 118, 117, 121, 116, 135, 125, 121,
127, 139, 139, 137, 138, 138, 139, 137, 139, 139, 139, 158, 138, 137, 139, 127,
139, 139, 137, 137, 139, 139, 144, 138, 139, 137, 137, 139, 146, 137, 159, 139,
139, 161, 149, 138, 137, 161, 149, 158, 161, 163, 154, 161, 155, 161, 161, 161,
158, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 168, 161, 177, 161, 161, 161, 161, 161, 187, 161, 177, 177, 178,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  76,  85,  76,  76,  76,  74,  66,  76,  76,  74,
 95,  95,  74,  74,  74,  74,  79,  74,  74,  74,  93,  74,  74,  74,  88,  88,
 93,  74,  93,  74,  93,  88,  74, 111,  93,  74, 111,  88,  93,  93, 111,  74,
 93, 111,  93, 111, 109, 109,  93, 109, 143, 109, 109,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
109, 118, 108, 121, 106, 121, 117, 118, 121, 121, 121, 121, 118, 121, 121, 118,
121, 121, 121, 121, 121, 121, 121, 122, 122, 118, 137, 122, 116, 135, 140, 122,
127, 139, 133, 137, 133, 138, 133, 137, 139, 133, 139, 139, 125, 137, 133, 145,
133, 146, 137, 137, 146, 146, 144, 138, 146, 132, 137, 139, 146, 137, 140, 146,
154, 154, 154, 159, 137, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 161, 161, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 161,
161, 161, 161, 178, 177, 177, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  50,  76,  76,  76,  74,  95,  76,  76,  85,
 93,  93,  85,  74,  88,  74,  93,  88,  88,  93,  93,  88,  93,  93,  88,  88,
 93,  88,  93,  88,  93,  88,  88,  88,  93,  97,  93,  88,  93,  88,  93, 109,
 93,  93,  93,  88,  93, 109,  93, 109,  87, 109,  97,  93, 109, 109, 109, 109,
109,  93, 118, 118, 118, 118, 118, 109, 109, 118, 118, 118, 109, 118, 116, 127,
116, 118, 108, 116, 121, 116, 116, 118, 119, 116, 118, 116, 116, 121, 116, 118,
121, 121, 116, 116, 122, 122, 122, 122, 116, 118, 137, 122, 116, 138, 125, 139,
145, 139, 139, 132, 139, 138, 139, 137, 139, 132, 139, 158, 138, 137, 139, 145,
132, 132, 137, 132, 132, 132, 154, 154, 154, 132, 132, 132, 154, 137, 159, 154,
154, 154, 154, 154, 161, 161, 145, 152, 154, 163, 154, 161, 154, 154, 154, 154,
152, 154, 154, 161, 178, 177, 178, 178, 161, 152, 178, 161, 178, 178, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 178, 178, 178, 152, 181, 178, 178, 178,
181, 181, 181, 178, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 181, 181, 181, 181, 181, 181, 181, 181, 202, 199, 199, 202, 199, 199, 199,
199, 199, 199, 210, 199, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 41,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  74,  66,  76,  76,  76,  88,  74,  76,  79,  74,  66,  79,  79,  79,
 95,  95,  79,  74,  79,  74,  79,  79,  74,  79,  79,  74,  79,  79,  88,  93,
 93, 111, 111,  74,  93,  88, 111, 111, 111,  74, 111,  88,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 106,  93, 109, 143, 109, 109,  93, 106, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 110, 127,
121, 127, 106, 121, 106, 121, 117, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 122, 121, 127, 137, 122, 139, 135, 140, 138,
127, 138, 133, 137, 133, 138, 133, 137, 133, 133, 139, 139, 140, 137, 133, 145,
133, 133, 137, 137, 144, 144, 144, 138, 146, 146, 137, 139, 144, 137, 140, 154,
154, 159, 154, 159, 137, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
154, 161, 154, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 172,
161, 161, 177, 178, 177, 177, 178, 177, 177, 177, 177, 187, 177, 177, 177, 178,
177, 177, 177, 177, 178, 187, 177, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 187, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 41,  41,  76,  76,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  57,  66,  66,  66,  66,  88,  79,  79,  66,  66,  66,  79,  79,  79,
 79,  79,  79,  74,  79,  79,  79,  79,  79,  79,  79,  92,  79,  92,  88,  92,
 93,  92,  92,  92,  92,  88,  92,  92,  92,  92,  92, 111,  93, 111,  92,  92,
111, 111, 111,  92, 111, 111, 111,  92, 143, 111, 111, 111, 106, 106, 111, 106,
109,  93, 111, 109, 109, 111, 118, 106, 100, 106, 106, 106, 106, 118, 117, 127,
106, 121, 100, 121, 106, 121, 117, 121, 106, 117, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 127, 117, 121, 137, 151, 140, 121,
127, 138, 144, 137, 144, 140, 144, 137, 144, 144, 138, 139, 140, 137, 144, 127,
144, 144, 137, 137, 144, 144, 140, 159, 144, 144, 137, 144, 159, 137, 140, 159,
159, 159, 159, 159, 137, 159, 145, 154, 159, 158, 159, 159, 159, 159, 159, 159,
161, 159, 159, 161, 172, 156, 161, 159, 161, 161, 161, 161, 172, 161, 161, 172,
177, 177, 177, 172, 177, 172, 172, 177, 177, 177, 177, 187, 177, 177, 177, 177,
177, 177, 177, 177, 177, 187, 177, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 187, 202, 202,
202, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  76,  88,  76,  76,  76,  74,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  79,  74,  74,  74,  93,  74,  93,  93,  88,  93,
 93, 111, 111,  74,  93,  88, 111, 111, 111,  74, 111,  88,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 111,  93, 109, 143, 109, 118,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 109, 109, 118, 121, 127,
121, 127, 108, 121, 135, 121, 117, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 127, 137, 133, 139, 135, 140, 138,
127, 139, 133, 139, 138, 138, 133, 137, 146, 133, 139, 139, 138, 137, 146, 145,
144, 146, 137, 137, 146, 146, 144, 138, 146, 146, 137, 139, 146, 137, 159, 154,
154, 154, 154, 159, 137, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 161, 154, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 154,
161, 161, 178, 178, 177, 177, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
177, 177, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 187, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  76,  76,  95,  95,  95,  95,
 95,  95,  74,  79,  95,  95,  95,  88,  95,  95,  95,  95,  93,  93,  93,  93,
 93,  93,  93,  74,  93,  93,  93,  93,  93,  93,  93,  88,  93,  93,  88,  93,
 93,  93,  93,  88,  93,  88,  93,  93,  93,  94,  93,  88,  93,  93,  93,  94,
 93,  93,  93,  93,  93,  93,  93, 109,  87,  93, 118,  93, 106, 106, 118, 110,
118, 145, 118, 118, 118, 127, 118, 127, 106, 127, 127, 127, 127, 118, 119, 145,
127, 127, 108, 127, 125, 127, 119, 127, 122, 122, 127, 122, 116, 127, 122, 118,
122, 145, 122, 122, 122, 122, 122, 122, 122, 145, 137, 133, 132, 145, 140, 133,
145, 145, 133, 132, 154, 145, 154, 137, 141, 154, 145, 132, 141, 137, 141, 145,
141, 141, 154, 154, 141, 141, 141, 145, 141, 141, 141, 141, 141, 154, 159, 145,
141, 141, 141, 145, 161, 141, 145, 141, 141, 163, 141, 141, 145, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 178, 152, 178, 178, 141, 178, 178, 178,
178, 178, 178, 197, 178, 175, 175, 178, 178, 178, 175, 181, 175, 175, 175, 175,
175, 175, 175, 175, 175, 181, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175,
175, 199, 175, 175, 175, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199,
199, 199, 199, 214, 214, 210, 214, 214, 214, 214, 214, 214, 214, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  95,  76,  76,  76,
 95,  95,  76,  74,  95,  74,  95,  95,  74,  74,  93,  74,  93, 111,  88,  88,
 93, 111, 111, 111, 111,  88, 111, 111, 111,  74, 111,  88,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 111,  93, 109, 143, 109, 118,  93, 109, 109, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 135, 109, 109, 109, 109, 118, 121, 123,
121, 118, 117, 121, 135, 121, 117, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 118, 137, 138, 139, 135, 140, 138,
127, 139, 138, 139, 138, 138, 146, 137, 139, 146, 139, 158, 138, 137, 146, 145,
146, 146, 137, 137, 146, 146, 144, 138, 146, 139, 137, 158, 149, 137, 159, 149,
154, 154, 154, 157, 161, 161, 145, 158, 154, 163, 154, 161, 154, 154, 154, 154,
158, 161, 154, 161, 154, 159, 161, 161, 161, 163, 161, 161, 154, 161, 161, 161,
161, 161, 178, 178, 178, 177, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
187, 187, 187, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 202, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  95,  88,  76,  95,  95,  74,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  95,  95,  74,  79,  93,  74,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111, 111,  93,  74, 111,  88,  93,  93, 111, 111,
 93,  93,  93, 111,  93, 109,  93, 109, 143, 109, 118,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 106, 109, 109, 121, 121, 118, 121, 127,
121, 127, 108, 121, 135, 121, 121, 118, 121, 121, 127, 121, 118, 121, 121, 118,
121, 135, 121, 121, 121, 121, 121, 122, 122, 127, 137, 133, 139, 135, 140, 138,
127, 139, 133, 139, 133, 138, 133, 137, 146, 133, 139, 158, 138, 137, 133, 145,
133, 146, 137, 137, 146, 154, 144, 138, 154, 154, 137, 154, 154, 137, 159, 154,
154, 154, 154, 159, 161, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
154, 154, 154, 161, 154, 159, 154, 154, 161, 161, 161, 161, 178, 161, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 187, 177, 177, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  76,  85,  76,  85,  85,  85,  85,  85,  85,
 93,  85,  85,  85,  85,  85,  85,  85, 111, 117, 111,  85, 111,  85, 111, 117,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 117, 111, 117, 117, 109, 117,
109, 123, 118, 109, 109, 109, 118, 109, 109, 109, 109, 109, 109, 118, 117, 123,
109, 118, 117, 118, 117, 117, 117, 118, 117, 117, 118, 117, 118, 121, 117, 118,
121, 135, 121, 118, 121, 117, 121, 117, 117, 118, 117, 121, 117, 135, 117, 142,
142, 139, 139, 117, 139, 138, 139, 167, 139, 139, 139, 158, 138, 167, 139, 127,
139, 139, 137, 137, 139, 139, 149, 149, 139, 158, 137, 158, 149, 167, 161, 149,
158, 149, 158, 157, 167, 161, 174, 158, 158, 163, 155, 161, 158, 161, 158, 158,
158, 161, 161, 161, 161, 161, 161, 161, 161, 163, 161, 161, 168, 161, 161, 161,
161, 161, 161, 168, 161, 177, 168, 161, 161, 161, 161, 187, 187, 187, 187, 183,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 187, 187, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 202, 210, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  50,  76,  76,  76,  76,  76,  76,  76,  85,
 85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,  85,
 93,  85,  85,  85,  85,  88,  85,  85,  85,  85,  85,  85,  93,  88,  93, 109,
 93,  85,  93,  85,  88, 109,  93, 109, 143, 118, 118,  93, 109, 109, 118, 109,
118,  93, 118, 118, 118, 118, 118, 118, 109, 118, 118, 118, 118, 118, 116, 123,
118, 118, 108, 118, 121, 118, 116, 118, 116, 116, 118, 116, 118, 121, 116, 143,
121, 127, 116, 116, 116, 116, 116, 139, 116, 143, 137, 139, 158, 138, 138, 139,
127, 139, 139, 158, 139, 138, 139, 137, 158, 139, 158, 163, 138, 137, 139, 145,
139, 158, 137, 158, 158, 158, 139, 158, 158, 158, 158, 158, 158, 137, 161, 158,
158, 158, 158, 154, 161, 161, 145, 163, 158, 163, 158, 161, 158, 158, 163, 163,
163, 154, 154, 152, 163, 161, 152, 161, 152, 163, 152, 152, 163, 152, 152, 178,
178, 152, 152, 178, 178, 178, 178, 178, 178, 178, 178, 152, 187, 178, 178, 178,
181, 181, 181, 177, 181, 187, 181, 181, 181, 181, 181, 181, 181, 181, 181, 181,
181, 187, 181, 181, 181, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 210, 202, 199, 210, 210, 210, 210, 218, 218, 218, 218,
 41,  66,  76,  66,  57,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,  66,
 66,  66,  79,  66,  66,  66,  66,  88,  79,  79,  79,  79,  66,  79,  79,  79,
 79,  95,  79,  92,  79,  79,  79,  79,  79,  79,  79,  92,  79,  92,  92,  92,
 93,  92,  92,  92,  92,  88,  92,  92,  92,  92,  92, 111,  93, 111,  92,  92,
111, 111, 111, 111, 111, 111, 111, 106, 143, 111, 111,  93, 106, 106, 111, 106,
106,  93, 127, 111, 106, 106, 118, 106, 100, 106, 106, 106, 106, 118, 121, 127,
121, 127, 140, 121, 140, 121, 121, 127, 106, 121, 127, 121, 121, 135, 121, 127,
140, 151, 121, 121, 121, 140, 121, 125, 121, 127, 137, 133, 133, 140, 140, 138,
127, 138, 144, 133, 140, 140, 144, 137, 144, 144, 142, 133, 140, 137, 144, 145,
159, 159, 140, 159, 159, 159, 140, 159, 159, 159, 159, 154, 159, 137, 140, 159,
159, 159, 159, 159, 137, 159, 145, 154, 159, 154, 159, 159, 159, 159, 159, 159,
154, 159, 159, 159, 172, 156, 172, 159, 161, 161, 172, 161, 172, 177, 172, 172,
172, 177, 172, 172, 177, 172, 172, 172, 177, 177, 177, 187, 177, 177, 177, 172,
177, 177, 177, 177, 177, 177, 177, 178, 177, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 209, 187, 187, 187, 202, 187, 202, 209, 210, 202, 209, 209,
209, 210, 210, 210, 210, 218, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  74,  95,  95,  95,  95,  88,  93,  93,  93,  93,  93,  93,  93,  93,
 93,  93,  93,  88,  93,  93,  93,  93,  93,  93,  93,  88,  93,  93,  88,  93,
 93,  93,  93,  88,  93,  88,  93,  93,  93,  94,  93,  88,  93,  93,  93,  94,
 93,  93,  93,  93,  93,  93,  93,  93,  87,  93, 118, 145, 110, 106, 118, 110,
118, 145, 145, 118, 127, 127, 118, 127, 135, 127, 127, 127, 127, 118, 119, 145,
127, 145, 108, 145, 125, 127, 119, 145, 122, 122, 145, 122, 116, 145, 122, 145,
145, 145, 145, 145, 145, 133, 145, 133, 141, 145, 124, 145, 132, 145, 140, 145,
145, 145, 145, 141, 141, 145, 141, 141, 141, 141, 145, 141, 141, 137, 141, 145,
141, 141, 141, 141, 141, 141, 141, 145, 141, 141, 141, 141, 141, 141, 141, 145,
141, 141, 141, 145, 141, 141, 145, 141, 141, 141, 141, 141, 145, 141, 141, 141,
141, 141, 141, 141, 141, 141, 141, 141, 141, 181, 141, 178, 145, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 181, 175, 175, 175, 175,
175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175, 175,
175, 199, 175, 175, 175, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199, 199,
214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214, 214,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  76,  85,  76,  76,  76,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  95,  95,  74,  74,  95,  74, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
111, 111,  93, 111, 111, 111, 111, 109, 143, 111, 118,  93, 109, 109, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 135, 109, 109, 109, 109, 118, 121, 127,
121, 127, 117, 121, 135, 121, 117, 118, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 121, 121, 121, 121, 121, 121, 121, 127, 137, 138, 139, 135, 140, 138,
127, 142, 138, 139, 138, 138, 144, 137, 146, 144, 139, 158, 138, 137, 146, 145,
146, 146, 137, 137, 146, 146, 144, 138, 149, 149, 137, 158, 149, 137, 159, 149,
155, 157, 154, 159, 161, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 161, 154, 161, 154, 159, 161, 161, 161, 161, 161, 161, 154, 161, 161, 172,
177, 177, 178, 178, 177, 172, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 202, 202, 187, 187, 202, 187, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  99,  99,
 99,  99,  57,  99,  99,  99,  99,  76,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99, 115,  99,  99, 115, 111, 117, 143, 111, 117, 111, 117, 117, 117, 117,
117, 111, 111, 117, 117, 117, 117, 117, 115, 117, 117, 117, 117, 117, 117, 123,
117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 117, 118,
117, 117, 117, 117, 117, 117, 117, 117, 117, 118, 117, 117, 117, 135, 117, 117,
148, 117, 117, 117, 117, 117, 117, 167, 117, 117, 142, 117, 117, 167, 117, 142,
117, 167, 167, 167, 167, 167, 167, 157, 167, 167, 167, 167, 167, 167, 167, 157,
167, 167, 167, 157, 167, 167, 164, 155, 167, 167, 167, 167, 157, 167, 167, 167,
167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 165, 167, 167, 167,
167, 167, 167, 168, 167, 161, 168, 206, 167, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
187, 206, 206, 206, 202, 206, 202, 202, 202, 202, 202, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  95,  88,  76,  95,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  74,  95,  95,  95,  79,  95,  74,  93, 111,  88,  93,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
 93, 111,  93, 111, 111, 111,  93, 109, 143, 109, 118,  93, 109, 106, 109, 109,
109,  93, 118, 109, 109, 109, 118, 109, 135, 109, 118, 118, 121, 118, 121, 127,
121, 127, 106, 121, 135, 121, 121, 118, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 121, 121, 121, 121, 121, 133, 121, 127, 137, 138, 139, 135, 140, 138,
127, 142, 138, 139, 138, 138, 144, 137, 146, 144, 139, 158, 138, 137, 146, 145,
144, 146, 137, 137, 146, 149, 144, 138, 149, 154, 137, 154, 154, 137, 159, 154,
154, 154, 154, 159, 161, 161, 145, 154, 154, 158, 154, 161, 154, 154, 154, 154,
158, 154, 154, 161, 154, 159, 154, 172, 161, 161, 161, 161, 154, 161, 178, 172,
177, 177, 178, 178, 178, 172, 178, 178, 177, 178, 178, 187, 177, 177, 177, 178,
178, 177, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
111, 111,  93, 111, 111, 111, 123, 111, 143, 111, 118, 123, 109, 109, 109, 109,
109, 123, 118, 118, 109, 123, 118, 123, 135, 118, 123, 118, 123, 118, 121, 123,
121, 127, 117, 127, 135, 121, 121, 118, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 121, 142, 142, 142, 142, 138, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 138, 139, 138, 138, 146, 137, 146, 144, 142, 158, 138, 137, 146, 145,
146, 149, 137, 149, 149, 149, 157, 149, 149, 155, 137, 158, 155, 137, 159, 155,
155, 157, 154, 159, 161, 161, 145, 158, 154, 158, 154, 161, 154, 154, 154, 154,
158, 168, 172, 161, 168, 159, 168, 172, 161, 163, 161, 161, 168, 161, 168, 172,
177, 177, 178, 178, 178, 172, 178, 178, 177, 178, 177, 187, 177, 177, 177, 178,
178, 187, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  95,  66,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  66,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  79,  95,  79,  95,  95,  93,  79,  93,  93,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111, 111,  93, 111, 111,  93,  93,  93,  93, 106,
 93,  93,  93, 111,  93, 106,  93, 106, 143, 123, 118,  93, 106, 106, 123, 109,
127, 136, 127, 127, 127, 127, 118, 127, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 140, 127, 135, 127, 121, 127, 121, 121, 127, 127, 127, 135, 121, 127,
127, 135, 127, 127, 138, 138, 138, 133, 133, 127, 137, 133, 139, 151, 140, 138,
145, 138, 133, 133, 138, 151, 133, 137, 133, 144, 138, 139, 140, 137, 133, 145,
154, 154, 159, 154, 154, 154, 159, 159, 154, 154, 154, 154, 154, 154, 140, 154,
154, 159, 154, 159, 161, 159, 145, 154, 154, 154, 154, 159, 145, 154, 154, 154,
154, 172, 172, 172, 154, 159, 178, 172, 177, 178, 178, 177, 178, 178, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 178, 177, 178, 178, 178,
178, 178, 178, 177, 178, 177, 178, 178, 178, 178, 187, 178, 177, 202, 202, 202,
202, 202, 202, 202, 209, 202, 202, 202, 202, 202, 209, 209, 210, 202, 209, 210,
209, 210, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  76,  76,  95,  95,
 76,  95,  76,  95,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  93,  88,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111, 111,  93, 111, 111,  88,  93,  93,  93, 111,
 93,  93,  93, 111, 123, 123, 123, 109, 143, 123, 118, 123, 109, 109, 123, 109,
118, 136, 118, 118, 123, 123, 118, 123, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 108, 127, 135, 127, 121, 127, 121, 121, 127, 121, 118, 127, 121, 118,
127, 135, 127, 127, 142, 138, 142, 133, 142, 127, 137, 138, 139, 135, 140, 138,
127, 142, 138, 139, 138, 138, 146, 137, 146, 146, 139, 158, 138, 137, 146, 145,
146, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 137, 159, 154,
154, 154, 154, 154, 161, 161, 145, 154, 154, 163, 154, 154, 174, 154, 154, 154,
158, 154, 154, 154, 154, 159, 178, 178, 161, 163, 178, 161, 178, 178, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 178, 177, 178, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 178, 178, 187, 178, 177, 202, 202, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 210, 218, 210, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  95,  76,  76,  95,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 118, 123, 109, 111, 111, 109,
109, 136, 123, 118, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 123,
127, 127, 117, 127, 135, 121, 117, 127, 121, 121, 127, 121, 118, 135, 121, 118,
121, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 142, 139, 138, 138, 144, 137, 149, 144, 142, 158, 138, 137, 149, 145,
149, 149, 137, 149, 149, 149, 157, 157, 155, 155, 155, 158, 155, 137, 159, 155,
155, 157, 165, 159, 161, 161, 174, 158, 168, 158, 168, 161, 165, 168, 168, 168,
158, 168, 172, 161, 168, 159, 168, 172, 161, 158, 168, 161, 168, 161, 168, 172,
177, 177, 183, 178, 177, 172, 178, 178, 177, 177, 177, 187, 177, 177, 177, 178,
178, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  95,  76,
 76,  95,  76,  95,  95,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 111, 118, 123, 109, 111, 111, 109,
109, 136, 123, 118, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 127,
127, 127, 117, 127, 135, 127, 121, 127, 121, 121, 127, 121, 118, 135, 121, 118,
127, 135, 127, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 142, 139, 138, 138, 144, 137, 149, 144, 142, 158, 159, 137, 149, 145,
149, 149, 157, 149, 149, 155, 157, 157, 155, 155, 155, 155, 157, 137, 159, 155,
155, 157, 165, 159, 161, 161, 145, 154, 168, 158, 168, 172, 174, 168, 168, 168,
158, 172, 172, 161, 168, 159, 168, 172, 161, 158, 172, 161, 172, 177, 172, 172,
172, 177, 178, 178, 178, 172, 178, 178, 177, 178, 177, 187, 177, 177, 177, 178,
178, 177, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  95,  95,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  66,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95, 111,  95, 111, 111, 111,  88, 111,
 93, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 123, 111, 111, 111, 111,
111, 136, 123, 111, 111, 123, 118, 123, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 140, 127, 135, 127, 121, 127, 121, 121, 127, 127, 127, 135, 121, 127,
127, 135, 127, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 151, 140, 142,
127, 142, 142, 144, 144, 151, 144, 137, 144, 144, 142, 158, 140, 137, 144, 145,
144, 157, 159, 157, 157, 157, 159, 159, 157, 157, 159, 155, 159, 137, 140, 157,
159, 159, 159, 159, 161, 159, 174, 154, 172, 158, 172, 159, 172, 172, 172, 172,
154, 172, 172, 172, 172, 159, 172, 172, 177, 161, 172, 177, 172, 172, 172, 172,
172, 172, 172, 172, 172, 172, 172, 172, 177, 177, 177, 187, 177, 177, 177, 178,
177, 177, 177, 177, 178, 187, 177, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 218, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  66,  76,  76,  95,  76,  76,  95,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  74,  95,  95,  95,  95,  95, 111,  95, 111, 111, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 115,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 111, 117, 115, 111, 111,
111, 123, 111, 111, 111, 111, 118, 111, 135, 111, 111, 111, 123, 118, 117, 123,
123, 123, 117, 123, 135, 148, 117, 127, 117, 117, 127, 121, 118, 135, 121, 118,
148, 135, 142, 142, 142, 142, 142, 142, 142, 127, 117, 142, 139, 135, 140, 142,
127, 142, 142, 139, 142, 151, 142, 167, 142, 144, 142, 158, 151, 167, 149, 127,
157, 157, 167, 157, 157, 157, 157, 157, 157, 155, 157, 155, 157, 167, 159, 157,
157, 157, 157, 151, 167, 167, 174, 165, 165, 158, 165, 161, 165, 168, 168, 168,
158, 172, 172, 161, 168, 159, 168, 172, 161, 161, 168, 161, 168, 161, 168, 172,
172, 183, 183, 172, 183, 172, 172, 183, 177, 183, 177, 187, 177, 177, 177, 183,
187, 187, 187, 177, 187, 187, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  76,  95,  95,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  95, 111,  88, 111,
 95, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 118, 123, 111, 111, 111, 111,
111, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 123,
127, 127, 117, 127, 135, 127, 117, 127, 121, 121, 127, 121, 118, 135, 142, 118,
142, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 151, 142,
127, 142, 142, 139, 142, 151, 149, 137, 149, 149, 142, 158, 151, 167, 149, 174,
149, 149, 157, 155, 149, 155, 157, 157, 155, 155, 155, 155, 157, 137, 159, 155,
165, 157, 165, 157, 161, 161, 174, 158, 168, 158, 168, 161, 174, 168, 168, 168,
158, 168, 172, 161, 168, 159, 168, 172, 161, 158, 168, 161, 168, 177, 168, 172,
183, 183, 183, 172, 183, 172, 178, 183, 177, 183, 177, 187, 177, 177, 177, 178,
187, 187, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  76,  95,  95,  95,  95,  85,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  88, 111,
 93, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111,  93, 111, 111, 111, 123, 111, 143, 123, 118, 123, 109, 109, 123, 109,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 118, 123,
127, 127, 135, 127, 135, 127, 121, 127, 121, 121, 127, 127, 118, 135, 142, 118,
127, 135, 127, 142, 142, 142, 142, 142, 142, 127, 137, 142, 158, 135, 151, 142,
127, 142, 142, 158, 138, 138, 149, 137, 149, 149, 158, 158, 138, 137, 149, 145,
149, 149, 157, 155, 155, 155, 157, 155, 155, 155, 155, 158, 155, 137, 159, 155,
165, 165, 165, 174, 161, 161, 145, 158, 168, 158, 168, 168, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 168, 161, 163, 168, 161, 168, 183, 178, 178,
178, 178, 178, 178, 178, 178, 178, 178, 177, 178, 178, 187, 177, 178, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 187, 187, 187, 187, 177, 202, 187, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  93,  88,  93,
 93, 111, 111, 111,  93,  88, 111, 111, 111, 111, 111, 111,  93,  93, 111, 111,
 93, 111,  93, 111, 123, 123, 123, 123, 143, 123, 118, 123, 109, 109, 123, 109,
123, 136, 123, 123, 123, 123, 118, 123, 135, 127, 127, 127, 127, 118, 121, 127,
127, 127, 135, 127, 135, 127, 121, 127, 121, 121, 127, 127, 127, 135, 127, 118,
127, 135, 127, 127, 142, 142, 142, 138, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 138, 139, 138, 138, 149, 137, 149, 149, 142, 158, 159, 137, 149, 145,
149, 149, 159, 154, 154, 154, 159, 157, 154, 154, 154, 154, 154, 154, 159, 174,
154, 154, 154, 174, 161, 159, 145, 154, 154, 158, 154, 172, 174, 154, 154, 154,
158, 172, 172, 178, 178, 159, 178, 178, 178, 178, 178, 177, 178, 178, 178, 178,
178, 178, 178, 197, 178, 178, 178, 178, 177, 178, 178, 178, 177, 178, 178, 178,
178, 178, 178, 177, 178, 187, 178, 178, 178, 178, 187, 178, 202, 202, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  76,  95,  95,  95,  95,  95,  85,  95, 111,  85, 111,
 95, 111, 111, 111, 111,  88, 111, 111, 111, 111, 111, 111,  93, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 123, 118, 123, 109, 111, 123, 109,
123, 136, 123, 118, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 118, 123,
123, 123, 117, 123, 135, 127, 117, 118, 121, 121, 127, 142, 118, 135, 142, 143,
142, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 158, 135, 151, 142,
127, 142, 142, 158, 142, 138, 149, 137, 149, 149, 158, 158, 138, 167, 149, 174,
149, 149, 149, 158, 149, 155, 157, 149, 155, 158, 155, 158, 155, 137, 159, 165,
165, 165, 165, 165, 161, 161, 174, 158, 168, 163, 168, 168, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 168, 161, 163, 168, 161, 168, 183, 183, 168,
183, 183, 183, 178, 183, 172, 178, 183, 177, 183, 183, 187, 177, 183, 183, 178,
183, 187, 178, 177, 178, 187, 187, 178, 187, 187, 187, 187, 202, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  76,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  95, 111,  88, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 123, 111, 111, 111, 111,
111, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 121, 123,
127, 127, 117, 127, 135, 127, 121, 127, 121, 121, 127, 127, 118, 135, 142, 118,
135, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 139, 135, 140, 142,
127, 142, 142, 139, 142, 151, 142, 137, 149, 149, 142, 158, 151, 167, 149, 174,
149, 149, 157, 155, 157, 157, 157, 157, 157, 155, 155, 155, 157, 137, 159, 157,
165, 157, 165, 159, 161, 159, 174, 165, 168, 158, 168, 172, 174, 168, 168, 168,
158, 172, 172, 168, 168, 159, 168, 172, 161, 183, 168, 161, 168, 183, 172, 172,
172, 183, 183, 172, 183, 172, 172, 183, 177, 183, 183, 187, 177, 177, 177, 178,
183, 177, 177, 177, 178, 187, 187, 178, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  88,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  93,  93,  88,  93,
 93,  93,  93, 111,  93,  88, 111,  93,  93, 111, 123,  93,  93,  93, 123, 111,
 93, 123,  93, 123, 123, 123, 123, 123, 143, 123, 118, 123, 109, 123, 123, 118,
123, 136, 127, 127, 127, 123, 118, 127, 135, 127, 127, 127, 127, 118, 121, 145,
127, 127, 135, 127, 135, 127, 121, 127, 127, 121, 127, 127, 127, 135, 127, 127,
127, 135, 127, 127, 127, 138, 142, 138, 142, 127, 133, 142, 158, 135, 140, 142,
145, 142, 138, 158, 138, 151, 149, 137, 154, 154, 145, 158, 159, 137, 154, 145,
154, 154, 154, 154, 154, 154, 154, 174, 154, 154, 154, 154, 154, 154, 159, 174,
154, 154, 154, 174, 161, 159, 145, 154, 154, 163, 154, 172, 145, 154, 154, 178,
178, 178, 178, 178, 178, 172, 178, 178, 178, 178, 178, 178, 197, 178, 178, 178,
178, 178, 178, 197, 178, 197, 197, 178, 178, 178, 178, 178, 178, 178, 178, 197,
178, 178, 178, 178, 178, 178, 178, 197, 178, 178, 178, 178, 178, 202, 202, 202,
202, 202, 202, 202, 197, 202, 202, 202, 202, 202, 202, 202, 202, 199, 199, 199,
199, 199, 210, 210, 210, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 66,  66,  95,  95,  57,  95,  66,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  92,  66,  95,  95,  95,  95,  95,  95,  95,  92,  95,  95,  95,  95,
 95,  95,  95,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,  92,
 95,  92,  92,  92,  92, 111,  92,  92,  92,  92,  92,  92, 111, 111, 115, 115,
111,  92, 115,  92, 111, 115, 111, 115, 143, 111, 111, 111, 115, 100, 111, 115,
115, 136, 127, 111, 111, 127, 127, 115, 100, 127, 127, 127, 135, 127, 148, 127,
127, 127, 140, 127, 140, 127, 140, 127, 140, 140, 127, 140, 127, 151, 140, 127,
140, 151, 151, 151, 140, 140, 140, 140, 140, 127, 140, 140, 144, 151, 140, 151,
151, 151, 140, 159, 140, 140, 140, 159, 159, 140, 151, 155, 140, 137, 140, 145,
140, 159, 140, 159, 159, 159, 140, 159, 159, 159, 159, 159, 159, 159, 156, 159,
159, 159, 159, 140, 159, 156, 145, 172, 159, 172, 159, 159, 159, 159, 159, 159,
172, 159, 159, 159, 172, 156, 172, 159, 172, 172, 172, 172, 172, 172, 172, 172,
172, 172, 172, 172, 172, 156, 172, 172, 177, 172, 172, 177, 177, 177, 177, 172,
209, 209, 209, 156, 209, 177, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 115,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 111, 117, 115, 111, 117,
111, 136, 123, 111, 111, 111, 118, 111, 135, 111, 123, 147, 123, 118, 117, 123,
147, 123, 117, 148, 135, 148, 117, 148, 147, 117, 148, 148, 118, 135, 148, 118,
148, 135, 148, 148, 148, 148, 148, 148, 148, 148, 167, 142, 117, 135, 151, 142,
148, 142, 142, 167, 142, 151, 164, 167, 164, 164, 164, 158, 151, 167, 164, 162,
164, 164, 167, 167, 157, 157, 157, 164, 157, 155, 167, 155, 157, 167, 159, 164,
165, 157, 165, 151, 167, 167, 174, 170, 165, 158, 165, 167, 170, 168, 168, 168,
158, 168, 168, 168, 168, 159, 168, 168, 167, 183, 168, 167, 176, 183, 168, 176,
183, 183, 183, 184, 183, 182, 183, 183, 177, 183, 183, 187, 206, 183, 183, 183,
183, 187, 183, 177, 183, 206, 187, 187, 187, 187, 187, 187, 177, 187, 187, 187,
187, 206, 187, 187, 187, 187, 187, 187, 187, 187, 202, 202, 187, 202, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  76,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 111, 111, 123, 111, 111, 123, 111,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 118, 123,
123, 123, 135, 127, 135, 127, 121, 127, 142, 142, 127, 142, 118, 135, 142, 118,
135, 135, 142, 142, 142, 142, 142, 142, 142, 127, 137, 142, 158, 135, 151, 142,
127, 142, 142, 149, 142, 151, 142, 167, 149, 149, 142, 158, 151, 167, 149, 174,
149, 155, 157, 155, 155, 157, 157, 157, 155, 155, 165, 155, 157, 165, 159, 165,
165, 165, 165, 174, 161, 159, 174, 170, 168, 158, 168, 172, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 172, 183, 183, 168, 161, 176, 183, 183, 172,
183, 183, 183, 172, 183, 172, 183, 183, 177, 183, 183, 187, 177, 183, 183, 183,
183, 183, 198, 177, 198, 187, 198, 198, 187, 187, 187, 187, 177, 187, 187, 187,
187, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,  95, 111, 111, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 111, 111, 143, 111, 111, 123, 111, 111, 111, 111,
111, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 135, 118, 148, 123,
127, 127, 135, 127, 135, 127, 148, 127, 148, 142, 127, 148, 127, 135, 148, 127,
135, 135, 127, 142, 142, 142, 142, 142, 142, 127, 144, 142, 142, 151, 140, 142,
127, 142, 142, 149, 142, 151, 157, 167, 157, 157, 142, 158, 151, 167, 157, 174,
157, 157, 159, 157, 157, 157, 159, 157, 157, 165, 157, 165, 157, 165, 159, 157,
165, 159, 165, 151, 161, 159, 174, 170, 172, 158, 172, 172, 174, 172, 172, 172,
168, 172, 172, 172, 172, 159, 172, 172, 172, 183, 172, 177, 172, 172, 172, 172,
172, 172, 183, 172, 183, 172, 172, 172, 177, 183, 183, 183, 177, 177, 177, 198,
198, 198, 198, 177, 198, 187, 198, 198, 198, 187, 187, 198, 177, 187, 187, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 210, 218, 210, 218, 218, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  95,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,
 95, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 111, 111, 123, 111, 111, 123, 111,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
123, 123, 135, 127, 135, 127, 147, 127, 148, 142, 127, 142, 118, 135, 142, 118,
135, 135, 142, 142, 142, 142, 142, 142, 142, 127, 167, 142, 158, 135, 151, 142,
127, 142, 142, 158, 142, 151, 164, 167, 164, 149, 164, 158, 151, 167, 164, 174,
157, 155, 157, 155, 155, 157, 157, 157, 165, 165, 165, 165, 165, 165, 159, 170,
165, 165, 165, 174, 167, 159, 174, 170, 168, 158, 168, 172, 174, 168, 168, 168,
158, 168, 168, 168, 168, 172, 168, 168, 183, 183, 183, 183, 176, 183, 183, 183,
183, 183, 183, 184, 183, 182, 183, 183, 183, 183, 183, 183, 177, 183, 183, 198,
183, 198, 198, 177, 198, 187, 198, 198, 198, 187, 187, 198, 198, 187, 187, 187,
202, 187, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 210, 202, 210, 210, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  66,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  99,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 115,  95, 115, 115, 115, 115, 115, 115, 115, 115, 115, 111, 115,
 95, 115, 115, 115, 115, 111, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115,
115, 115, 115, 115, 115, 115, 115, 115, 143, 115, 115, 115, 115, 115, 115, 115,
115, 136, 111, 115, 115, 115, 115, 115, 115, 115, 115, 115, 115, 147, 147, 123,
148, 148, 117, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 148,
148, 135, 148, 148, 148, 148, 148, 148, 148, 148, 167, 148, 167, 151, 151, 148,
148, 148, 148, 167, 148, 151, 148, 167, 148, 148, 148, 164, 151, 167, 148, 151,
164, 164, 167, 167, 164, 157, 151, 151, 157, 167, 167, 164, 157, 167, 140, 164,
157, 159, 157, 151, 167, 167, 174, 170, 176, 170, 182, 167, 182, 176, 176, 176,
180, 182, 182, 167, 176, 159, 182, 182, 167, 167, 172, 167, 182, 167, 182, 182,
182, 172, 184, 182, 182, 182, 182, 182, 206, 183, 190, 206, 206, 206, 206, 190,
206, 206, 206, 206, 190, 206, 206, 198, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 198, 206, 206, 206, 206, 206, 206, 206, 206, 206, 202, 202,
202, 202, 202, 218, 202, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  88,  93,
136,  93,  93, 111, 123, 118, 123, 123, 123, 111, 123, 123, 123, 123, 123, 123,
123, 123, 123, 123, 123, 123, 123, 123, 143, 123, 127, 123, 123, 135, 127, 127,
127, 136, 127, 127, 127, 127, 127, 127, 135, 127, 127, 127, 127, 127, 127, 145,
127, 127, 140, 127, 135, 127, 142, 127, 127, 142, 127, 127, 127, 135, 127, 162,
127, 135, 127, 127, 127, 142, 127, 142, 142, 145, 144, 142, 158, 145, 140, 174,
145, 174, 174, 154, 174, 151, 174, 154, 174, 154, 145, 158, 159, 137, 174, 145,
154, 154, 159, 154, 174, 154, 159, 174, 174, 154, 154, 154, 174, 154, 159, 174,
154, 172, 154, 174, 172, 159, 145, 174, 178, 178, 197, 172, 145, 178, 178, 197,
178, 178, 178, 178, 178, 172, 178, 178, 178, 178, 178, 178, 197, 178, 178, 197,
178, 178, 178, 197, 197, 197, 197, 197, 178, 197, 197, 178, 178, 178, 197, 197,
197, 197, 197, 197, 197, 178, 197, 197, 197, 197, 209, 197, 209, 209, 209, 209,
209, 209, 197, 209, 197, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 214, 214, 214, 218, 214, 214, 214, 214, 214, 218, 218, 218, 218, 218,
 95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,
136, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 111, 123, 111, 111, 111,
111, 111, 135, 111, 111, 135, 123, 111, 143, 123, 127, 123, 111, 135, 127, 127,
127, 136, 127, 127, 127, 127, 127, 127, 135, 127, 127, 127, 135, 127, 127, 127,
127, 127, 140, 127, 151, 127, 142, 127, 151, 151, 127, 127, 127, 151, 127, 127,
151, 151, 151, 127, 151, 151, 151, 151, 142, 127, 140, 151, 142, 151, 140, 151,
145, 174, 151, 155, 151, 151, 159, 159, 159, 159, 174, 155, 140, 137, 159, 145,
159, 159, 159, 159, 159, 159, 159, 174, 159, 159, 159, 172, 159, 159, 140, 174,
159, 159, 172, 174, 159, 159, 145, 174, 172, 154, 172, 159, 174, 172, 172, 172,
172, 172, 172, 172, 172, 156, 172, 172, 172, 178, 172, 172, 197, 172, 172, 172,
172, 172, 178, 197, 172, 197, 197, 178, 177, 178, 178, 178, 177, 178, 178, 197,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,  99,
 99,  99,  99,  99,  99, 115,  99,  99, 143,  99, 147, 115, 147, 115, 147, 147,
147, 130, 147, 147, 147, 147, 147, 147, 115, 147, 147, 147, 147, 147, 147, 147,
147, 147, 117, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 167, 147, 167, 147, 147, 147,
148, 147, 147, 167, 147, 147, 167, 167, 167, 167, 148, 167, 167, 167, 167, 148,
167, 167, 167, 167, 167, 167, 167, 164, 167, 167, 167, 167, 167, 167, 167, 164,
167, 167, 167, 164, 167, 167, 171, 167, 167, 167, 167, 167, 185, 167, 167, 167,
167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 167, 185, 167, 167, 206,
206, 206, 206, 185, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  95,  76,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  85,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 111, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 130, 111, 143, 111, 147, 123, 147, 147, 123, 147,
147, 136, 123, 147, 123, 123, 143, 123, 135, 147, 123, 147, 123, 143, 147, 123,
147, 123, 147, 123, 135, 147, 147, 123, 147, 147, 123, 147, 143, 135, 147, 143,
148, 135, 148, 148, 148, 164, 164, 147, 164, 162, 167, 164, 143, 135, 135, 164,
162, 164, 164, 158, 164, 164, 164, 167, 164, 164, 164, 158, 164, 167, 164, 162,
164, 164, 167, 164, 164, 164, 164, 164, 164, 170, 170, 158, 164, 167, 157, 164,
170, 170, 170, 174, 167, 167, 174, 170, 180, 173, 180, 168, 174, 180, 180, 180,
158, 180, 180, 183, 180, 182, 180, 180, 183, 173, 183, 183, 180, 183, 183, 184,
183, 183, 183, 193, 183, 182, 193, 183, 183, 183, 183, 183, 183, 183, 183, 193,
183, 183, 183, 198, 193, 206, 198, 193, 198, 193, 187, 198, 198, 198, 187, 187,
198, 206, 198, 202, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 202, 202, 202, 202, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 111, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 123, 111, 123, 111, 111, 123, 147,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
123, 123, 135, 123, 135, 148, 147, 127, 148, 148, 127, 148, 127, 135, 148, 162,
135, 135, 148, 148, 148, 142, 142, 142, 142, 162, 167, 142, 158, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 157, 165, 164, 165, 157, 164, 170, 170, 165, 170, 170, 165, 159, 174,
170, 165, 170, 174, 167, 159, 174, 170, 176, 158, 176, 172, 174, 176, 176, 176,
180, 176, 176, 183, 176, 182, 176, 176, 183, 183, 183, 183, 174, 183, 183, 184,
183, 183, 183, 174, 183, 182, 186, 183, 183, 183, 183, 183, 183, 183, 198, 198,
198, 198, 198, 198, 198, 187, 198, 198, 198, 198, 198, 198, 198, 198, 198, 187,
198, 187, 198, 202, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 218, 218, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  76,  76,  76,  76,  76,  76,  85,  76,  76,  76,  76,  95,  76,  76,  76,
 76,  95,  76,  76,  76,  76,  76,  76,  85,  76,  95,  85,  85,  85,  85,  85,
 95,  85,  85,  85,  85, 143,  85,  85, 130,  85, 130,  85, 130, 130, 123, 111,
130, 130, 123, 130, 123, 123, 123, 123, 143, 123, 143, 123, 147, 147, 123, 147,
123, 136, 143, 143, 123, 123, 143, 123, 135, 143, 123, 143, 123, 143, 143, 123,
143, 143, 147, 143, 135, 143, 147, 143, 147, 147, 143, 143, 143, 123, 143, 143,
123, 135, 143, 143, 143, 164, 143, 164, 143, 143, 167, 143, 143, 135, 135, 143,
143, 143, 164, 158, 164, 164, 158, 167, 158, 158, 143, 173, 164, 167, 158, 162,
158, 158, 158, 158, 158, 158, 164, 164, 158, 158, 158, 173, 158, 158, 168, 158,
158, 170, 158, 174, 167, 168, 174, 173, 158, 173, 180, 168, 174, 158, 158, 158,
173, 180, 180, 183, 173, 183, 193, 183, 183, 173, 183, 183, 193, 183, 193, 193,
193, 193, 193, 193, 193, 193, 193, 193, 183, 193, 193, 173, 183, 193, 193, 193,
193, 193, 193, 198, 193, 187, 193, 193, 193, 193, 193, 193, 198, 198, 224, 202,
198, 187, 202, 202, 224, 202, 202, 202, 224, 202, 224, 202, 202, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 218, 218, 218, 245,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 111,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 115, 111, 111, 111, 111, 111, 115,
111, 111, 111, 111, 111, 111, 111, 115, 143, 111, 111, 130, 147, 115, 111, 147,
111, 136, 130, 111, 111, 123, 118, 123, 135, 147, 123, 148, 148, 147, 147, 123,
148, 148, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
148, 164, 164, 164, 164, 151, 164, 167, 164, 164, 164, 164, 151, 167, 164, 162,
164, 164, 167, 164, 164, 164, 164, 164, 164, 170, 167, 170, 164, 167, 159, 164,
170, 170, 170, 182, 167, 167, 174, 170, 176, 158, 176, 176, 174, 176, 176, 176,
180, 176, 176, 176, 176, 182, 176, 184, 183, 183, 184, 167, 184, 183, 184, 184,
184, 183, 183, 182, 183, 182, 184, 183, 183, 183, 183, 183, 183, 183, 183, 192,
183, 198, 198, 198, 198, 206, 198, 198, 198, 198, 198, 198, 198, 198, 198, 187,
198, 206, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 202, 218, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 111, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 123, 111, 143, 123, 111, 123, 111, 135, 123, 111,
123, 136, 123, 123, 123, 123, 127, 123, 135, 127, 127, 127, 135, 127, 148, 136,
127, 127, 151, 127, 135, 127, 148, 127, 148, 148, 127, 148, 127, 135, 148, 162,
151, 135, 127, 127, 148, 151, 142, 151, 142, 162, 144, 142, 142, 151, 151, 151,
174, 174, 151, 155, 151, 151, 157, 157, 157, 157, 174, 158, 151, 167, 157, 174,
157, 157, 159, 157, 157, 159, 159, 174, 165, 165, 159, 170, 159, 172, 159, 174,
172, 159, 172, 174, 172, 159, 174, 174, 172, 170, 172, 172, 174, 172, 172, 172,
176, 172, 172, 172, 172, 159, 172, 172, 172, 183, 172, 183, 174, 172, 172, 172,
172, 172, 183, 197, 172, 182, 197, 172, 177, 198, 198, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 197, 198, 198, 198, 198, 209, 198, 198, 198,
198, 202, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  57,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  99,  99,  95,  95,  95,  76,  99,  95,  95,  99,  95,  95,  95,  95,
 95,  95,  95,  99,  95,  99,  95,  99,  99,  99,  95,  99,  99, 115,  99, 111,
 95, 115, 115, 115, 111, 111, 115, 115, 115, 115, 115, 111, 111, 111, 115, 115,
111, 115, 115, 115, 115, 115, 111, 115, 143, 115, 147, 111, 147, 115, 147, 147,
147, 136, 130, 147, 147, 147, 147, 147, 115, 147, 147, 147, 147, 147, 147, 123,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 148, 147, 147, 148, 147, 147,
147, 135, 147, 147, 147, 147, 147, 147, 147, 148, 167, 147, 147, 135, 151, 148,
148, 148, 148, 167, 164, 148, 164, 167, 164, 167, 164, 167, 151, 167, 164, 171,
164, 164, 167, 167, 164, 164, 164, 164, 164, 167, 167, 164, 164, 167, 167, 164,
164, 167, 170, 164, 167, 167, 174, 180, 180, 180, 185, 167, 185, 180, 180, 180,
167, 180, 180, 167, 180, 182, 180, 184, 167, 167, 167, 167, 180, 167, 184, 184,
184, 206, 184, 184, 184, 182, 184, 184, 206, 206, 206, 206, 206, 206, 206, 192,
206, 206, 206, 206, 206, 206, 206, 193, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
202, 206, 202, 202, 202, 206, 202, 202, 202, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 130, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 130, 111, 143, 123, 111, 123, 147, 111, 123, 147,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
148, 123, 135, 148, 135, 148, 147, 148, 148, 148, 127, 148, 148, 135, 148, 162,
135, 135, 148, 148, 148, 148, 148, 142, 148, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 157, 165, 164, 170, 157, 164, 170, 170, 165, 170, 170, 167, 159, 174,
170, 176, 170, 174, 167, 159, 174, 170, 176, 158, 176, 172, 174, 176, 176, 176,
180, 176, 176, 183, 176, 182, 176, 176, 183, 183, 183, 183, 174, 183, 184, 184,
183, 183, 183, 174, 183, 182, 186, 183, 183, 183, 183, 183, 183, 198, 198, 198,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 187, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 218, 227, 218, 218, 210, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 130, 130, 130, 111, 111,
111, 111, 111, 111, 111, 111, 130, 111, 143, 123, 111, 123, 147, 111, 123, 147,
123, 136, 123, 123, 123, 123, 118, 123, 135, 123, 123, 123, 123, 118, 147, 123,
148, 123, 135, 148, 135, 148, 147, 148, 148, 147, 123, 148, 148, 135, 148, 162,
135, 135, 148, 148, 148, 148, 148, 164, 164, 162, 167, 164, 158, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 157, 165, 164, 170, 157, 164, 170, 170, 170, 170, 170, 167, 159, 174,
170, 170, 170, 174, 167, 172, 174, 170, 176, 158, 176, 176, 174, 176, 176, 176,
180, 176, 176, 183, 176, 182, 176, 184, 183, 183, 183, 183, 174, 183, 183, 184,
183, 183, 183, 174, 183, 182, 186, 183, 183, 183, 183, 183, 183, 183, 198, 198,
198, 198, 198, 198, 198, 187, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 187, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 227, 218, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  95,  95,  76,  76,  95,  95,  95,  95,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130,  95,
 95, 111, 111, 111, 111, 130, 111, 111, 111, 111, 111, 130, 130, 130, 111, 111,
130, 111, 111, 111, 130, 111, 130, 111, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 123, 123, 123, 130, 123, 135, 123, 123, 123, 123, 147, 147, 123,
148, 123, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 164, 164, 170, 170, 170, 170, 167, 159, 174,
170, 170, 170, 174, 167, 167, 174, 180, 180, 158, 180, 176, 174, 180, 180, 180,
180, 176, 184, 184, 180, 182, 184, 184, 183, 183, 184, 183, 184, 183, 184, 184,
184, 183, 183, 186, 183, 182, 186, 186, 183, 183, 183, 183, 183, 183, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 187, 198, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
202, 202, 202, 202, 227, 218, 202, 202, 218, 218, 218, 218, 218, 218, 218, 218,
 76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,  76,
 76,  95,  76,  95,  95,  95,  95,  85,  76,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  85, 130,
 95, 130, 130, 130, 130, 143, 130, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 123, 130, 123, 143, 123, 143, 123, 147, 123, 123, 147,
123, 136, 123, 123, 123, 123, 143, 123, 135, 123, 123, 123, 123, 143, 147, 136,
123, 123, 135, 123, 135, 123, 147, 143, 147, 147, 123, 164, 143, 135, 164, 143,
135, 135, 164, 143, 164, 164, 164, 164, 164, 143, 164, 164, 143, 135, 135, 164,
162, 164, 164, 158, 164, 164, 164, 167, 164, 164, 162, 173, 164, 167, 164, 174,
164, 164, 170, 158, 170, 170, 170, 174, 170, 158, 158, 158, 170, 158, 168, 174,
170, 170, 170, 174, 167, 168, 174, 158, 180, 173, 180, 180, 174, 180, 180, 180,
173, 180, 180, 183, 193, 182, 193, 193, 183, 173, 183, 183, 193, 183, 193, 193,
193, 193, 193, 197, 193, 193, 193, 193, 183, 193, 193, 193, 183, 193, 193, 193,
193, 193, 193, 198, 193, 198, 198, 193, 198, 193, 198, 198, 198, 198, 198, 198,
198, 202, 198, 198, 198, 202, 202, 202, 224, 202, 224, 224, 202, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 111, 111, 111, 130, 130, 111, 111, 130, 111, 111, 130, 130, 130, 111, 115,
130, 130, 130, 111, 130, 111, 130, 111, 143, 130, 111, 130, 147, 115, 130, 147,
123, 136, 130, 123, 123, 123, 130, 123, 135, 148, 123, 148, 135, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 148, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 157, 170, 164, 170, 157, 174, 170, 170, 170, 170, 170, 167, 159, 174,
170, 182, 170, 174, 167, 182, 174, 180, 176, 180, 182, 182, 174, 176, 176, 176,
180, 182, 182, 184, 184, 182, 184, 182, 183, 183, 184, 183, 174, 183, 184, 182,
190, 183, 186, 195, 190, 182, 190, 190, 183, 192, 190, 183, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 202, 202, 202, 202, 202, 202, 202, 202, 202, 202,
227, 202, 227, 227, 227, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 111, 111, 111, 130, 130, 111, 111, 111, 115, 111, 130, 130, 130, 115, 115,
130, 111, 111, 111, 130, 115, 130, 115, 143, 130, 111, 130, 115, 115, 130, 147,
111, 136, 130, 130, 123, 123, 130, 123, 135, 148, 148, 148, 148, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 148, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 157, 164, 164, 164, 164, 174, 170, 170, 170, 170, 170, 167, 159, 174,
170, 182, 170, 174, 167, 182, 174, 180, 176, 180, 182, 182, 174, 176, 176, 176,
180, 182, 182, 184, 184, 182, 184, 182, 183, 183, 184, 183, 174, 184, 184, 182,
190, 190, 186, 195, 190, 182, 190, 190, 190, 190, 190, 183, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 198, 202, 217, 202, 202, 217, 202, 202, 202, 202,
227, 202, 227, 227, 227, 218, 218, 218, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
136, 130, 130, 111, 130, 130, 111, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 123, 130, 123, 143, 130, 130, 123, 123, 135, 123, 123,
123, 136, 130, 123, 123, 123, 130, 123, 135, 123, 123, 123, 135, 162, 148, 136,
123, 123, 135, 127, 135, 148, 148, 127, 148, 148, 127, 148, 162, 135, 148, 162,
135, 135, 148, 148, 148, 148, 164, 164, 164, 162, 164, 164, 164, 135, 151, 164,
162, 174, 164, 164, 164, 151, 164, 165, 164, 164, 174, 158, 151, 167, 164, 174,
164, 170, 157, 170, 170, 170, 170, 174, 170, 170, 170, 170, 170, 176, 159, 174,
170, 182, 176, 174, 183, 182, 174, 174, 176, 180, 174, 182, 174, 176, 176, 176,
180, 182, 182, 183, 184, 182, 184, 182, 183, 183, 183, 183, 174, 183, 186, 186,
183, 183, 183, 197, 183, 197, 197, 198, 198, 198, 198, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 197, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 197, 198, 202, 202, 202, 202, 202, 227, 202, 202, 227, 227,
227, 227, 227, 227, 227, 218, 227, 227, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 111, 130, 130, 111, 130, 130, 111, 130, 130, 130, 130, 111, 111,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 130, 123, 130, 130, 123, 135, 123, 123, 123, 123, 148, 147, 136,
148, 123, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 164, 164, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 164, 170, 170, 170, 170, 170, 167, 182, 174,
170, 170, 170, 174, 167, 182, 174, 180, 180, 180, 180, 182, 174, 180, 180, 180,
180, 184, 184, 184, 184, 182, 184, 184, 183, 183, 184, 183, 174, 183, 184, 184,
184, 183, 186, 195, 192, 182, 186, 192, 183, 192, 192, 183, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 198, 217, 202, 217, 202, 217, 217, 202, 202, 202, 202,
227, 202, 227, 227, 227, 218, 227, 224, 218, 218, 218, 218, 218, 218, 218, 245,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 115,  95, 115,  95,  95, 115, 115,  95, 115, 115, 115, 130, 115,
 95, 115, 115, 115, 115, 130, 115, 115, 115, 115, 115, 115, 115, 130, 115, 115,
115, 115, 115, 115, 115, 115, 115, 115, 143, 115, 115, 130, 115, 115, 115, 115,
115, 136, 130, 115, 115, 115, 148, 115, 160, 148, 148, 148, 160, 148, 148, 136,
148, 148, 140, 148, 160, 148, 148, 148, 148, 148, 148, 148, 148, 160, 148, 162,
151, 160, 148, 148, 151, 151, 151, 151, 148, 162, 140, 151, 148, 160, 140, 151,
151, 151, 151, 148, 151, 151, 151, 159, 151, 151, 174, 164, 151, 167, 151, 174,
151, 151, 159, 159, 159, 159, 151, 151, 159, 159, 159, 182, 159, 159, 140, 174,
182, 159, 182, 151, 159, 159, 174, 182, 182, 176, 182, 159, 174, 182, 182, 182,
172, 182, 182, 182, 182, 156, 182, 182, 172, 172, 182, 172, 182, 182, 182, 182,
182, 182, 182, 195, 182, 182, 182, 182, 182, 182, 182, 198, 198, 198, 198, 195,
198, 198, 198, 215, 198, 198, 215, 198, 209, 209, 209, 209, 215, 209, 209, 209,
209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209, 209,
209, 209, 209, 209, 209, 218, 209, 209, 218, 218, 218, 218, 218, 218, 218, 243,
 76,  76,  76,  76,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 111, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 123, 135, 148, 123, 148, 148, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 164, 148, 162, 167, 164, 164, 135, 151, 164,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 174, 170, 170, 170, 170, 170, 167, 182, 174,
170, 176, 170, 174, 167, 182, 174, 180, 180, 180, 180, 182, 174, 180, 180, 180,
180, 184, 182, 184, 184, 182, 184, 184, 183, 183, 184, 183, 174, 184, 184, 186,
186, 186, 186, 195, 192, 182, 186, 192, 190, 192, 192, 183, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 217, 217, 217, 217, 202, 217, 217, 202, 217, 217, 217,
227, 227, 227, 227, 227, 218, 227, 227, 227, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 111, 130, 130, 111, 130, 130, 115, 130, 130, 130, 130, 115, 115,
130, 130, 130, 130, 130, 115, 130, 115, 143, 130, 130, 130, 147, 115, 130, 147,
130, 136, 130, 130, 130, 130, 130, 123, 135, 148, 148, 148, 148, 148, 147, 136,
148, 148, 135, 148, 135, 148, 147, 148, 148, 148, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
162, 164, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 157, 170, 164, 170, 182, 174, 170, 170, 170, 170, 170, 167, 159, 174,
170, 182, 170, 174, 167, 182, 174, 180, 176, 180, 182, 182, 174, 182, 176, 184,
180, 182, 182, 184, 184, 182, 184, 182, 184, 186, 184, 183, 174, 190, 190, 190,
190, 190, 192, 195, 190, 182, 195, 190, 190, 192, 190, 198, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 217, 217, 217, 217, 217, 217, 217, 202, 217, 217, 217,
227, 227, 227, 227, 227, 218, 227, 227, 218, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 123, 130, 130, 143, 130, 130, 130, 123, 135, 123, 123,
123, 136, 130, 123, 123, 123, 162, 123, 135, 123, 123, 123, 135, 162, 148, 136,
123, 123, 135, 127, 135, 127, 148, 162, 148, 148, 162, 148, 162, 135, 148, 162,
135, 135, 127, 162, 164, 164, 164, 164, 164, 162, 164, 164, 158, 135, 151, 164,
174, 174, 164, 164, 164, 174, 164, 165, 174, 164, 174, 158, 151, 167, 174, 174,
170, 170, 165, 170, 174, 170, 170, 174, 174, 170, 170, 170, 174, 176, 182, 174,
170, 176, 174, 174, 183, 182, 174, 174, 176, 180, 174, 182, 174, 176, 176, 174,
180, 184, 182, 183, 186, 182, 186, 184, 183, 183, 183, 183, 197, 183, 186, 186,
186, 183, 193, 197, 198, 197, 197, 197, 198, 198, 198, 198, 198, 198, 198, 197,
198, 198, 198, 198, 197, 198, 198, 197, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 197, 198, 197, 217, 217, 202, 227, 202, 227, 227, 202, 227, 227, 227,
227, 227, 227, 227, 227, 218, 227, 227, 227, 218, 218, 218, 218, 218, 218, 245,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  95,  76,  95,  95,
 95,  95,  76,  95,  95,  95,  95,  85,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
136, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 123, 130, 123, 143, 130, 143, 130, 147, 123, 123, 123,
123, 136, 143, 123, 123, 123, 143, 123, 135, 123, 123, 123, 123, 143, 143, 136,
123, 123, 135, 123, 135, 123, 147, 143, 164, 164, 162, 164, 143, 135, 164, 143,
164, 135, 164, 143, 164, 164, 164, 164, 164, 162, 164, 164, 143, 135, 135, 164,
162, 162, 164, 158, 164, 164, 164, 158, 164, 164, 162, 173, 164, 167, 164, 174,
164, 170, 170, 158, 170, 170, 170, 174, 170, 158, 170, 158, 170, 180, 182, 174,
170, 180, 180, 174, 183, 183, 174, 173, 180, 173, 174, 180, 174, 180, 193, 193,
173, 193, 193, 193, 193, 182, 193, 193, 183, 173, 193, 183, 193, 193, 193, 193,
193, 193, 193, 197, 193, 197, 193, 193, 193, 193, 193, 193, 198, 193, 193, 197,
193, 193, 193, 198, 197, 198, 198, 197, 198, 224, 198, 198, 198, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 218, 218, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 111,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 135, 130, 147,
130, 136, 130, 130, 130, 130, 130, 123, 135, 123, 123, 123, 135, 162, 147, 136,
148, 123, 135, 148, 135, 148, 147, 148, 148, 148, 162, 148, 162, 135, 148, 162,
135, 135, 148, 148, 148, 148, 148, 164, 164, 162, 164, 164, 164, 135, 151, 164,
162, 162, 164, 164, 164, 151, 164, 167, 164, 164, 162, 158, 151, 167, 164, 174,
164, 164, 170, 170, 170, 170, 170, 174, 170, 170, 170, 170, 170, 170, 182, 174,
170, 182, 170, 174, 167, 182, 174, 180, 180, 180, 174, 182, 174, 184, 180, 184,
180, 184, 182, 184, 184, 182, 184, 184, 183, 183, 184, 183, 174, 183, 186, 186,
186, 186, 192, 197, 192, 182, 186, 192, 190, 192, 192, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 198, 198, 217, 217, 217, 217, 202, 217, 227, 202, 217, 227, 227,
227, 227, 227, 227, 227, 218, 227, 227, 227, 218, 218, 218, 218, 218, 218, 245,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 123, 135, 130, 123,
123, 136, 162, 123, 123, 123, 162, 123, 135, 123, 123, 123, 135, 162, 148, 136,
127, 162, 135, 127, 135, 127, 142, 162, 135, 142, 162, 127, 162, 135, 127, 162,
135, 135, 162, 162, 164, 164, 164, 164, 164, 162, 164, 174, 158, 174, 151, 174,
174, 174, 174, 164, 174, 174, 174, 170, 174, 174, 174, 158, 174, 165, 174, 174,
174, 174, 170, 170, 174, 174, 174, 174, 174, 170, 170, 174, 174, 176, 182, 174,
174, 174, 174, 174, 183, 182, 174, 174, 174, 193, 174, 182, 174, 174, 174, 174,
193, 186, 197, 183, 197, 182, 197, 197, 183, 193, 186, 183, 197, 183, 197, 197,
197, 197, 197, 197, 197, 197, 197, 197, 198, 197, 197, 198, 198, 198, 197, 197,
197, 198, 197, 197, 197, 198, 197, 197, 197, 197, 198, 197, 197, 197, 198, 198,
197, 198, 197, 227, 197, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 218, 245, 245,
 76,  76,  76,  76,  76,  76,  76,  95,  76,  76,  76,  76,  95,  76,  95,  95,
 95,  95,  99,  95,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  99,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130,
 95, 130, 130, 115, 130, 130, 115, 130, 130, 147, 115, 130, 130, 130, 115, 115,
130, 130, 130, 130, 130, 115, 130, 147, 143, 147, 147, 130, 147, 147, 147, 147,
147, 136, 130, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 130,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 162,
147, 135, 147, 147, 147, 147, 147, 147, 147, 162, 167, 147, 147, 135, 151, 147,
171, 171, 164, 167, 164, 164, 164, 167, 164, 164, 171, 164, 164, 167, 164, 171,
164, 164, 167, 167, 164, 164, 164, 164, 164, 185, 167, 185, 185, 167, 167, 185,
185, 185, 185, 185, 167, 167, 174, 185, 185, 180, 185, 167, 185, 185, 185, 185,
180, 185, 185, 167, 185, 182, 185, 185, 167, 167, 185, 167, 185, 185, 185, 185,
185, 191, 191, 195, 196, 190, 196, 196, 206, 192, 192, 206, 206, 206, 206, 196,
206, 206, 206, 206, 200, 206, 206, 193, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 208, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
217, 217, 217, 217, 217, 206, 217, 217, 227, 227, 227, 218, 218, 218, 243, 245,
 76,  76,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 135, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 135, 123, 123, 148, 135, 162, 148, 136,
148, 162, 135, 148, 135, 148, 148, 162, 148, 148, 162, 148, 162, 135, 148, 162,
135, 135, 148, 162, 148, 148, 164, 164, 164, 162, 164, 164, 164, 135, 151, 164,
162, 162, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 170, 170, 170, 170, 182, 174, 170, 170, 170, 170, 170, 176, 182, 174,
170, 182, 180, 174, 183, 182, 174, 174, 180, 180, 174, 182, 174, 184, 184, 186,
180, 182, 182, 184, 186, 182, 186, 190, 183, 193, 186, 183, 174, 186, 186, 186,
190, 192, 192, 197, 192, 182, 197, 192, 198, 192, 192, 198, 198, 198, 198, 197,
198, 198, 198, 198, 198, 198, 198, 197, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 217, 217, 217, 217, 217, 217, 217, 217, 227, 217, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 218, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 111, 130, 130, 130, 130, 130, 115,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 148, 148, 162, 147, 136,
148, 148, 147, 148, 135, 148, 147, 148, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 164, 148, 162, 167, 164, 164, 135, 151, 164,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 164, 174, 170, 170, 170, 170, 170, 167, 182, 174,
180, 182, 180, 174, 167, 182, 174, 180, 180, 180, 180, 182, 174, 180, 180, 180,
180, 184, 182, 184, 186, 182, 186, 190, 184, 193, 184, 183, 174, 186, 186, 186,
190, 192, 192, 195, 192, 190, 195, 192, 190, 192, 192, 193, 198, 198, 198, 192,
198, 198, 198, 198, 198, 198, 198, 193, 198, 198, 198, 198, 198, 198, 198, 198,
198, 198, 198, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 218, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 115, 130, 130, 130, 130, 130, 115,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 130, 130, 130, 130, 130, 135, 147, 130, 148, 148, 147, 147, 136,
148, 148, 147, 148, 135, 148, 147, 148, 147, 147, 148, 148, 148, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 148, 164, 135, 151, 148,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 171, 164, 151, 167, 164, 162,
164, 164, 164, 164, 164, 164, 185, 164, 185, 185, 185, 170, 185, 167, 182, 174,
185, 185, 185, 174, 167, 182, 174, 180, 185, 180, 185, 182, 174, 185, 185, 185,
180, 182, 182, 184, 184, 182, 184, 190, 184, 186, 184, 183, 195, 190, 186, 190,
190, 190, 192, 195, 192, 195, 195, 192, 190, 192, 192, 192, 192, 192, 192, 192,
192, 198, 198, 198, 208, 206, 198, 200, 198, 198, 198, 198, 198, 198, 198, 198,
198, 206, 198, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 217, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 218, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 148, 148, 162, 147, 136,
148, 148, 147, 148, 135, 148, 147, 148, 148, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 148, 148, 148, 148, 148, 148, 162, 167, 164, 164, 135, 151, 171,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 164, 164, 164, 164, 185, 174, 185, 170, 185, 170, 185, 185, 182, 174,
185, 182, 185, 174, 167, 182, 174, 180, 180, 180, 182, 182, 174, 184, 180, 186,
180, 182, 182, 184, 186, 182, 186, 190, 186, 186, 186, 183, 195, 190, 186, 190,
190, 192, 192, 195, 192, 195, 195, 192, 190, 192, 192, 200, 198, 192, 192, 192,
198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
198, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 243, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95, 130, 130, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 148, 162, 147, 136,
148, 162, 135, 148, 135, 148, 147, 162, 148, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 162, 148, 148, 148, 164, 164, 162, 164, 164, 164, 135, 151, 171,
162, 171, 164, 164, 164, 151, 164, 167, 164, 164, 162, 164, 151, 167, 164, 174,
164, 164, 185, 170, 164, 170, 185, 174, 170, 170, 170, 170, 185, 180, 182, 174,
185, 182, 180, 174, 167, 182, 174, 174, 180, 180, 174, 182, 174, 184, 186, 186,
193, 186, 182, 186, 186, 182, 186, 190, 186, 193, 186, 183, 174, 190, 186, 186,
192, 192, 192, 195, 192, 195, 195, 192, 190, 192, 192, 200, 198, 198, 198, 200,
198, 198, 198, 198, 198, 198, 198, 193, 198, 198, 198, 198, 198, 198, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 218, 243, 243, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 131,  95, 131,  95,  95, 131, 131,  95, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 130, 162, 147, 136,
147, 162, 147, 148, 135, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 171, 171, 164, 171, 164, 164, 162, 194, 164, 164, 135, 151, 171,
162, 171, 164, 164, 164, 164, 164, 167, 164, 164, 162, 164, 164, 167, 164, 162,
164, 164, 185, 164, 164, 185, 185, 174, 185, 185, 185, 185, 185, 185, 182, 174,
185, 185, 185, 174, 167, 182, 174, 180, 185, 180, 185, 185, 174, 185, 185, 191,
193, 191, 191, 191, 191, 182, 191, 191, 186, 193, 191, 192, 195, 191, 191, 191,
191, 192, 193, 195, 193, 195, 193, 193, 192, 200, 200, 193, 200, 200, 200, 193,
200, 200, 208, 208, 208, 198, 208, 193, 198, 193, 198, 198, 208, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 224, 227, 227, 227, 227, 243, 243, 245, 245,
 76,  76,  76,  76,  99,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 99,  95,  99,  99,  95,  95,  95,  76,  99,  99,  95,  99,  95,  95,  95,  99,
 95,  95,  99,  99,  99,  99,  95,  99,  99, 115, 131,  99, 131, 115, 130, 130,
130, 115, 115, 115, 130, 130, 115, 115, 130, 147, 115, 130, 130, 130, 115, 115,
130, 130, 115, 115, 130, 115, 130, 147, 143, 147, 147, 130, 147, 147, 147, 147,
147, 136, 130, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 130,
147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147,
147, 160, 147, 147, 147, 147, 147, 147, 147, 171, 167, 147, 147, 160, 160, 147,
171, 171, 147, 167, 147, 148, 147, 167, 171, 147, 171, 171, 164, 167, 171, 171,
164, 185, 167, 167, 185, 185, 185, 171, 185, 185, 167, 185, 185, 167, 167, 185,
185, 185, 185, 185, 167, 167, 171, 185, 185, 185, 185, 167, 185, 185, 185, 185,
185, 185, 185, 167, 185, 185, 185, 185, 207, 207, 185, 207, 185, 207, 185, 185,
185, 207, 207, 195, 196, 195, 196, 196, 207, 207, 206, 207, 207, 206, 206, 205,
206, 206, 206, 206, 206, 207, 206, 208, 206, 206, 206, 206, 206, 206, 206, 206,
206, 206, 206, 206, 213, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206, 206,
217, 206, 217, 217, 217, 206, 217, 217, 235, 235, 235, 243, 243, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 131,  95, 131,  95, 131, 131, 131,  95, 131, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 130, 162, 147, 136,
148, 130, 147, 148, 135, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 148, 171, 171, 148, 171, 164, 171, 162, 194, 171, 164, 135, 151, 171,
162, 171, 171, 164, 164, 171, 164, 194, 164, 164, 171, 171, 151, 167, 164, 162,
164, 164, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 185, 182, 174,
185, 185, 185, 174, 167, 182, 174, 185, 185, 180, 185, 185, 174, 185, 185, 185,
191, 191, 191, 191, 191, 182, 191, 191, 191, 193, 191, 192, 195, 191, 191, 191,
191, 192, 200, 195, 200, 195, 195, 196, 192, 200, 200, 200, 200, 200, 200, 208,
200, 208, 208, 208, 208, 198, 208, 208, 208, 213, 198, 208, 208, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95,  95, 115,  95, 115,  95, 115, 115, 115, 115, 115, 115, 115, 130, 115,
130, 115, 115, 115, 115, 130, 115, 115, 115, 115, 115, 130, 130, 130, 115, 115,
115, 115, 115, 115, 115, 115, 130, 115, 143, 115, 115, 130, 115, 115, 115, 115,
115, 136, 130, 115, 115, 115, 130, 115, 160, 147, 148, 148, 160, 147, 147, 160,
148, 148, 160, 148, 160, 148, 147, 148, 147, 147, 148, 148, 148, 160, 148, 162,
160, 160, 148, 148, 148, 160, 148, 148, 148, 171, 167, 148, 148, 160, 160, 148,
171, 171, 148, 148, 148, 160, 171, 167, 171, 185, 171, 171, 160, 167, 171, 171,
185, 185, 167, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 167, 151, 185,
185, 185, 185, 182, 167, 167, 174, 185, 185, 185, 185, 182, 195, 185, 185, 185,
185, 182, 182, 185, 185, 182, 185, 182, 185, 185, 185, 207, 195, 190, 195, 195,
195, 190, 195, 195, 195, 195, 195, 195, 190, 195, 195, 207, 207, 208, 208, 195,
208, 208, 208, 215, 208, 207, 208, 208, 208, 208, 206, 208, 215, 216, 213, 206,
216, 206, 216, 216, 216, 217, 217, 217, 217, 206, 217, 215, 206, 217, 217, 217,
217, 217, 217, 215, 227, 217, 227, 227, 227, 243, 243, 243, 243, 243, 243, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95, 131, 131,  95,  95, 131,  95,  95,  95, 131,
 95,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 147, 130, 130, 130, 130, 130, 115,
130, 130, 130, 130, 130, 130, 130, 147, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 147, 147, 130, 130, 147, 160, 147, 147, 147, 147, 147, 147, 136,
147, 147, 147, 147, 160, 147, 147, 147, 147, 147, 148, 147, 147, 148, 147, 162,
147, 160, 147, 147, 147, 147, 147, 147, 147, 162, 167, 171, 147, 160, 160, 171,
171, 171, 171, 147, 171, 171, 171, 167, 171, 164, 171, 171, 164, 167, 171, 171,
164, 185, 167, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 167, 185, 185,
185, 185, 185, 185, 167, 167, 174, 185, 185, 185, 185, 185, 185, 185, 185, 185,
185, 185, 185, 185, 185, 182, 185, 185, 185, 185, 185, 207, 195, 185, 185, 196,
196, 196, 196, 195, 196, 195, 195, 196, 196, 196, 196, 207, 207, 200, 200, 205,
200, 208, 208, 208, 208, 206, 208, 208, 208, 213, 206, 208, 208, 213, 213, 206,
213, 206, 213, 213, 213, 217, 217, 206, 217, 206, 217, 217, 206, 217, 217, 217,
217, 217, 217, 217, 227, 217, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95, 131, 131,  95,  95, 131,  95, 131, 131, 131,
 95,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 130, 147, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 147, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 147, 130, 147, 147, 147, 147, 136,
147, 130, 147, 148, 135, 147, 147, 148, 147, 147, 171, 147, 162, 135, 147, 162,
148, 135, 148, 171, 148, 148, 171, 147, 171, 162, 194, 171, 147, 160, 151, 171,
171, 171, 171, 164, 171, 171, 171, 194, 171, 164, 171, 171, 164, 167, 171, 171,
164, 185, 185, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 167, 182, 185,
185, 185, 185, 174, 167, 185, 204, 185, 185, 185, 185, 185, 174, 185, 185, 185,
185, 185, 185, 185, 185, 182, 191, 191, 191, 191, 191, 192, 195, 196, 191, 196,
196, 196, 196, 195, 196, 195, 195, 196, 190, 196, 196, 200, 200, 200, 208, 208,
200, 208, 208, 208, 208, 206, 208, 208, 208, 213, 213, 208, 216, 213, 213, 217,
213, 206, 213, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
217, 217, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 95,  95,  95,  95, 131,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131,  95,  95,  95,  95,  95, 131,  95,  95, 131,  95,  95,  95,  95,
 95,  95,  95, 131, 131, 131,  95, 131, 131, 131, 130, 131, 130, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 148, 162, 148, 136,
148, 162, 160, 148, 160, 148, 148, 162, 148, 148, 162, 148, 162, 135, 148, 162,
148, 160, 171, 171, 171, 148, 171, 148, 171, 162, 194, 171, 171, 160, 151, 171,
162, 171, 171, 164, 171, 151, 171, 194, 171, 164, 162, 171, 151, 194, 174, 174,
164, 174, 182, 185, 174, 185, 182, 174, 174, 185, 185, 185, 174, 185, 182, 174,
185, 182, 185, 174, 194, 182, 204, 174, 195, 186, 174, 182, 174, 195, 195, 195,
186, 195, 195, 190, 195, 182, 195, 195, 190, 186, 190, 190, 195, 190, 195, 195,
195, 190, 192, 197, 195, 195, 195, 195, 190, 192, 195, 198, 198, 198, 208, 197,
208, 198, 208, 215, 208, 198, 198, 208, 198, 217, 217, 217, 215, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 227, 217, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 243, 245,
 76,  76,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
 95,  95, 131, 131,  95,  95,  95, 131, 131, 131,  95, 131,  95, 131, 131, 131,
 95,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 135, 130, 130, 130, 130, 162, 147, 136,
148, 130, 147, 148, 135, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 171, 171, 171, 171, 171, 164, 171, 162, 194, 171, 164, 135, 151, 171,
162, 171, 171, 164, 171, 171, 171, 194, 171, 164, 171, 171, 164, 194, 171, 174,
164, 185, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 185, 182, 174,
185, 185, 185, 174, 194, 182, 204, 185, 185, 180, 185, 185, 174, 185, 185, 191,
191, 191, 191, 191, 191, 182, 191, 191, 191, 193, 191, 192, 195, 191, 191, 195,
196, 196, 200, 195, 200, 195, 195, 196, 200, 200, 200, 200, 200, 200, 208, 208,
208, 208, 208, 208, 208, 198, 208, 208, 208, 213, 213, 213, 216, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  95,  95,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,  95,
131,  95, 131, 131,  95,  95, 131, 131, 131, 131, 131, 131,  95, 131, 131, 131,
131,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
148, 130, 147, 148, 160, 148, 147, 162, 147, 147, 162, 148, 162, 135, 148, 162,
148, 135, 171, 171, 171, 171, 171, 148, 171, 162, 194, 171, 171, 160, 151, 171,
171, 171, 171, 164, 171, 171, 171, 194, 171, 164, 171, 171, 151, 194, 171, 162,
185, 185, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 194, 182, 174,
185, 185, 185, 174, 194, 182, 204, 185, 185, 203, 185, 185, 174, 185, 185, 185,
191, 191, 195, 191, 191, 182, 191, 195, 191, 191, 191, 192, 195, 196, 191, 195,
196, 196, 196, 195, 196, 195, 195, 196, 200, 200, 200, 200, 208, 208, 208, 208,
208, 208, 208, 208, 208, 208, 208, 208, 208, 213, 213, 213, 216, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 245, 245,
 76,  76,  76,  95,  76,  95,  95,  95,  95,  95,  95,  95,  95, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 143, 130, 135, 130, 130, 130, 130, 143, 147, 136,
162, 162, 135, 162, 135, 162, 147, 162, 179, 179, 162, 162, 162, 162, 162, 162,
162, 135, 162, 162, 162, 171, 162, 164, 179, 162, 194, 179, 179, 174, 135, 162,
162, 162, 179, 179, 174, 174, 174, 194, 179, 164, 162, 173, 174, 194, 174, 174,
174, 174, 180, 180, 174, 174, 174, 174, 174, 180, 180, 174, 174, 180, 182, 174,
174, 174, 193, 174, 194, 190, 204, 193, 193, 173, 174, 191, 174, 193, 193, 193,
193, 193, 193, 193, 193, 190, 193, 193, 193, 193, 193, 193, 197, 193, 193, 193,
193, 193, 193, 197, 193, 197, 197, 193, 193, 193, 193, 193, 193, 193, 193, 197,
193, 193, 193, 208, 197, 198, 193, 219, 224, 219, 224, 224, 217, 224, 224, 224,
224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224, 224,
224, 224, 224, 227, 224, 224, 224, 224, 224, 224, 224, 224, 245, 245, 245, 245,
 95,  95,  95,  95, 131,  95,  95,  95,  95, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 162, 130, 135, 130, 130, 130, 130, 162, 148, 136,
162, 162, 135, 162, 135, 162, 148, 162, 148, 148, 162, 171, 162, 135, 171, 162,
171, 135, 171, 162, 171, 171, 171, 171, 171, 162, 194, 171, 162, 174, 151, 171,
162, 162, 171, 171, 174, 174, 174, 194, 174, 174, 174, 171, 174, 194, 174, 204,
174, 174, 185, 185, 174, 174, 174, 174, 174, 185, 185, 174, 174, 185, 182, 174,
174, 174, 174, 174, 194, 182, 204, 174, 195, 203, 174, 190, 174, 195, 195, 195,
193, 195, 195, 191, 195, 182, 195, 195, 191, 193, 191, 200, 197, 200, 195, 195,
195, 200, 200, 197, 200, 197, 197, 195, 208, 200, 208, 200, 208, 208, 208, 197,
208, 208, 208, 215, 197, 217, 208, 197, 217, 217, 217, 217, 217, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 227, 227, 227, 227, 227, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 243, 243, 243, 243, 245, 245,
 76,  95,  95,  95, 131, 131,  95,  95, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130,
136, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
130, 162, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 171, 160, 151, 171,
162, 171, 171, 171, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 185, 185, 185, 185, 185, 174, 185, 185, 185, 185, 185, 194, 182, 174,
185, 185, 185, 174, 194, 182, 204, 191, 185, 203, 195, 185, 174, 191, 191, 195,
191, 195, 195, 191, 191, 182, 195, 195, 191, 193, 191, 200, 195, 196, 196, 195,
196, 196, 200, 195, 200, 195, 195, 205, 208, 200, 208, 211, 208, 208, 208, 208,
208, 208, 208, 208, 208, 213, 208, 213, 213, 213, 213, 213, 216, 217, 217, 217,
217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 227, 217, 217, 227, 227,
227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 240, 243, 243, 243, 245, 245,
 76,  95, 131,  95, 131, 131, 131,  95, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
130, 130, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 171, 160, 160, 171,
171, 171, 171, 171, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 194, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 194, 182, 174,
185, 185, 185, 174, 194, 194, 204, 203, 185, 203, 195, 185, 174, 185, 185, 195,
191, 195, 195, 191, 191, 182, 191, 195, 196, 191, 196, 196, 195, 196, 196, 195,
196, 196, 205, 195, 205, 195, 195, 205, 208, 205, 208, 211, 208, 208, 208, 208,
208, 208, 208, 208, 208, 213, 213, 213, 213, 213, 213, 213, 216, 213, 213, 217,
213, 217, 213, 217, 216, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 227, 227, 240, 240, 243, 243, 243, 245, 245,
 76,  76, 131, 131, 131, 131, 131,  95, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
130, 131, 131, 131, 130, 130, 131, 130, 130, 147, 130, 130, 130, 130, 130, 147,
130, 130, 130, 130, 130, 130, 130, 147, 143, 130, 147, 130, 147, 147, 130, 147,
147, 136, 130, 147, 130, 130, 130, 147, 160, 147, 147, 147, 147, 147, 147, 166,
147, 130, 147, 147, 160, 147, 147, 147, 147, 147, 171, 147, 147, 160, 147, 162,
147, 160, 147, 171, 147, 147, 171, 147, 147, 171, 194, 171, 194, 160, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 171,
171, 185, 194, 194, 185, 185, 185, 171, 185, 185, 194, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 185, 185, 203, 185, 185, 201, 185, 185, 185,
185, 185, 185, 185, 185, 185, 185, 185, 185, 185, 185, 207, 201, 196, 205, 205,
205, 205, 205, 195, 205, 195, 205, 205, 205, 205, 205, 207, 207, 205, 205, 205,
211, 208, 208, 212, 212, 207, 213, 211, 213, 211, 213, 213, 216, 213, 213, 206,
213, 206, 213, 213, 213, 216, 216, 217, 217, 206, 217, 226, 217, 217, 217, 217,
231, 217, 235, 235, 235, 235, 235, 235, 235, 240, 240, 243, 243, 243, 245, 245,
 76,  95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 130, 131, 130, 130, 130, 130, 130, 131, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
130, 162, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 171, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 171, 160, 171,
171, 171, 171, 179, 171, 171, 171, 194, 171, 171, 171, 179, 185, 194, 171, 204,
171, 185, 194, 185, 185, 185, 185, 171, 185, 185, 185, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 185, 191,
203, 191, 195, 191, 191, 195, 191, 196, 196, 193, 196, 200, 195, 196, 196, 205,
205, 205, 205, 195, 205, 195, 205, 205, 208, 205, 205, 211, 208, 208, 208, 205,
208, 208, 208, 208, 213, 213, 213, 219, 213, 219, 213, 213, 216, 213, 213, 217,
213, 217, 213, 217, 213, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 224, 227, 240, 240, 243, 243, 245, 245, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 131, 131, 130, 130, 131, 130, 130, 131, 130, 130, 130, 130, 130, 130,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 136,
171, 162, 147, 171, 160, 171, 147, 162, 147, 147, 162, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 194, 185, 185, 185, 185, 201, 185, 185, 185, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 185, 201,
203, 195, 195, 196, 205, 195, 205, 195, 196, 200, 196, 196, 201, 205, 205, 205,
205, 205, 205, 195, 205, 195, 205, 205, 208, 205, 205, 211, 208, 208, 208, 212,
208, 213, 213, 216, 212, 213, 213, 213, 213, 213, 213, 213, 216, 216, 213, 217,
216, 217, 216, 217, 216, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 227, 227, 227, 227, 227, 227, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 130, 131, 131, 130, 131, 130, 130, 130, 130, 130, 131,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
130, 130, 147, 171, 160, 171, 147, 171, 147, 147, 171, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 185, 194, 171, 204,
171, 185, 194, 194, 185, 185, 185, 201, 185, 185, 194, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 185, 201,
203, 195, 195, 196, 205, 195, 205, 195, 196, 211, 205, 196, 201, 205, 205, 205,
205, 205, 205, 195, 205, 195, 205, 205, 205, 205, 205, 211, 211, 208, 208, 212,
211, 213, 213, 216, 212, 213, 213, 213, 213, 213, 213, 213, 216, 216, 213, 213,
216, 217, 213, 216, 226, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217, 217,
227, 228, 227, 227, 227, 227, 227, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 130, 131, 131, 131, 131, 130, 130, 130, 130, 130, 131,
130, 130, 160, 130, 130, 160, 130, 130, 143, 130, 130, 130, 160, 160, 130, 130,
130, 136, 130, 130, 130, 130, 130, 160, 160, 160, 160, 160, 160, 162, 148, 166,
160, 160, 160, 160, 160, 160, 194, 171, 160, 160, 160, 160, 171, 160, 160, 162,
160, 160, 160, 171, 171, 160, 171, 160, 171, 171, 194, 171, 194, 160, 160, 171,
171, 171, 171, 194, 171, 160, 171, 194, 171, 171, 171, 171, 160, 194, 171, 204,
171, 171, 194, 194, 201, 185, 185, 201, 201, 185, 194, 185, 201, 194, 182, 201,
201, 195, 201, 201, 194, 194, 204, 201, 195, 203, 195, 195, 201, 195, 195, 195,
195, 195, 195, 195, 195, 215, 195, 195, 195, 196, 195, 196, 195, 195, 195, 195,
195, 195, 195, 195, 195, 215, 195, 195, 215, 195, 195, 211, 208, 208, 212, 212,
212, 216, 216, 215, 216, 216, 215, 212, 215, 216, 216, 216, 215, 215, 216, 216,
215, 215, 216, 215, 215, 215, 215, 217, 217, 215, 217, 215, 217, 217, 217, 217,
227, 227, 227, 227, 227, 243, 243, 243, 243, 243, 243, 243, 243, 243, 243, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 130, 131, 131, 131, 131, 131, 130, 130, 130, 131, 131,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 147, 147, 147, 147, 166,
147, 130, 147, 171, 160, 147, 147, 171, 147, 147, 171, 171, 171, 171, 147, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 171, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 179, 185, 194, 171, 204,
171, 185, 194, 194, 185, 185, 185, 201, 185, 185, 194, 185, 185, 194, 185, 201,
185, 185, 185, 201, 194, 194, 204, 203, 185, 203, 201, 185, 201, 185, 201, 201,
203, 185, 201, 185, 205, 195, 205, 205, 205, 211, 205, 194, 201, 205, 205, 205,
205, 205, 205, 201, 205, 205, 205, 205, 205, 205, 205, 211, 211, 211, 212, 212,
211, 211, 212, 212, 212, 211, 212, 211, 213, 211, 213, 213, 216, 213, 211, 213,
213, 216, 221, 226, 221, 226, 226, 226, 226, 217, 226, 226, 217, 231, 231, 231,
235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 95, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
136, 131, 131, 131, 130, 130, 131, 130, 130, 131, 130, 130, 130, 130, 130, 130,
130, 130, 166, 130, 130, 130, 130, 130, 143, 130, 130, 166, 130, 130, 130, 130,
130, 136, 130, 130, 130, 130, 162, 130, 160, 130, 130, 130, 130, 162, 171, 136,
162, 162, 160, 162, 160, 162, 171, 162, 171, 171, 162, 171, 162, 171, 171, 162,
171, 171, 171, 162, 171, 171, 171, 171, 171, 162, 194, 171, 171, 174, 151, 171,
162, 162, 171, 171, 174, 174, 174, 194, 174, 174, 174, 203, 174, 194, 174, 204,
174, 174, 185, 185, 174, 174, 174, 174, 174, 185, 185, 174, 174, 194, 182, 174,
174, 195, 174, 174, 194, 190, 204, 174, 195, 203, 174, 195, 174, 195, 195, 195,
203, 195, 195, 191, 195, 195, 195, 195, 200, 193, 195, 200, 197, 200, 195, 195,
205, 205, 205, 197, 208, 197, 197, 208, 208, 208, 208, 211, 208, 208, 208, 197,
213, 213, 213, 216, 197, 217, 216, 197, 216, 219, 217, 217, 216, 217, 228, 217,
217, 217, 228, 217, 228, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227, 227,
227, 227, 227, 227, 227, 227, 227, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 130, 131, 131, 131, 131, 131, 130, 130, 130, 131, 131,
130, 130, 130, 130, 130, 130, 130, 130, 143, 130, 130, 130, 147, 130, 130, 130,
130, 136, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 171, 160, 171, 160, 171, 147, 171, 147, 147, 171, 171, 162, 171, 171, 162,
171, 160, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 171, 201, 194, 171, 204,
171, 171, 194, 194, 201, 185, 201, 201, 201, 185, 194, 203, 201, 194, 185, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 185, 201, 201, 201, 201,
203, 195, 201, 205, 205, 195, 205, 205, 205, 211, 205, 205, 201, 205, 205, 205,
205, 205, 205, 201, 205, 195, 205, 205, 205, 205, 205, 211, 211, 212, 212, 212,
211, 213, 212, 216, 212, 213, 216, 213, 216, 213, 213, 216, 216, 216, 213, 216,
216, 216, 216, 226, 226, 226, 226, 217, 226, 217, 217, 226, 217, 228, 228, 228,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 243, 245, 245,
 76, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 130, 130, 130, 147, 143, 130, 147, 130, 147, 147, 130, 147,
147, 166, 130, 147, 130, 130, 130, 147, 147, 147, 147, 147, 147, 179, 147, 166,
147, 179, 147, 179, 147, 179, 147, 179, 147, 147, 179, 179, 179, 179, 179, 179,
179, 188, 179, 179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 188, 194, 179,
179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 179, 179, 179, 194, 179, 179,
179, 179, 194, 194, 179, 179, 179, 179, 179, 179, 194, 179, 179, 194, 194, 179,
179, 201, 203, 201, 194, 194, 204, 203, 203, 203, 201, 194, 203, 201, 203, 203,
203, 201, 201, 185, 203, 201, 205, 205, 194, 203, 205, 194, 203, 205, 205, 205,
205, 211, 211, 201, 211, 205, 205, 205, 211, 211, 211, 211, 211, 211, 211, 211,
211, 211, 211, 212, 211, 207, 211, 219, 211, 219, 211, 211, 221, 211, 219, 211,
221, 206, 221, 221, 221, 225, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
228, 231, 235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 130, 130, 131, 131,
131, 131, 166, 131, 130, 130, 130, 130, 143, 130, 130, 166, 147, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 171, 194, 171, 160, 171, 194, 171, 147, 147, 171, 171, 171, 171, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 203, 201, 194, 171, 204,
171, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 185, 201, 201, 201, 201,
203, 201, 201, 205, 201, 195, 205, 205, 205, 211, 205, 205, 201, 205, 205, 205,
205, 205, 205, 201, 205, 205, 205, 205, 205, 205, 205, 211, 211, 211, 212, 212,
211, 212, 212, 216, 212, 213, 212, 222, 216, 219, 213, 216, 216, 216, 221, 216,
216, 216, 221, 226, 226, 226, 226, 226, 226, 217, 231, 226, 217, 228, 228, 228,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 130, 130, 130, 130, 143, 130, 130, 130, 147, 147, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 130, 130, 130, 179, 130, 179, 147, 166,
179, 179, 147, 179, 188, 179, 147, 179, 179, 179, 179, 179, 179, 179, 179, 179,
179, 188, 179, 179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 188, 188, 179,
179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 179, 179, 179, 194, 179, 204,
179, 179, 194, 194, 179, 179, 201, 179, 179, 179, 194, 179, 179, 194, 194, 203,
203, 201, 203, 201, 194, 194, 204, 203, 203, 203, 201, 194, 203, 203, 203, 203,
203, 201, 201, 205, 203, 201, 205, 205, 211, 203, 205, 211, 203, 211, 205, 205,
205, 211, 211, 201, 211, 205, 205, 211, 211, 211, 211, 219, 211, 211, 211, 222,
211, 211, 211, 212, 211, 211, 211, 219, 211, 219, 219, 211, 221, 221, 219, 221,
221, 228, 219, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 228, 235, 235, 235, 235, 224, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 130, 130, 130, 130, 143, 130, 130, 166, 130, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 162, 194, 171, 188, 171, 194, 162, 171, 194, 162, 171, 179, 171, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 179, 188, 188, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 171, 171, 179, 201, 194, 171, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 195, 205, 205, 205, 203, 205, 211, 201, 205, 205, 205,
205, 205, 211, 201, 205, 205, 205, 205, 211, 211, 211, 211, 211, 211, 211, 222,
211, 211, 212, 216, 212, 211, 213, 219, 221, 219, 221, 221, 216, 221, 219, 228,
221, 226, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 235, 235, 240, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 130, 130, 130, 130, 143, 130, 130, 166, 147, 130, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 160, 130, 130, 130, 130, 162, 147, 166,
171, 171, 194, 171, 188, 171, 194, 171, 147, 194, 171, 171, 179, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 171, 171, 194, 171, 194, 171, 179, 201, 194, 171, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 194, 201, 205, 205, 205,
205, 205, 205, 201, 205, 205, 205, 205, 205, 205, 205, 211, 211, 211, 212, 222,
211, 211, 212, 212, 212, 211, 212, 219, 221, 219, 221, 221, 216, 221, 221, 226,
221, 226, 221, 226, 225, 226, 226, 231, 231, 231, 231, 235, 231, 231, 231, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 160, 130, 131, 143, 130, 130, 166, 160, 160, 130, 130,
130, 166, 130, 130, 130, 130, 130, 160, 160, 160, 160, 160, 160, 171, 194, 166,
160, 160, 160, 160, 160, 160, 194, 171, 160, 194, 171, 171, 171, 160, 171, 162,
160, 160, 171, 171, 171, 160, 171, 194, 171, 171, 194, 171, 194, 188, 160, 171,
171, 171, 171, 194, 171, 188, 171, 194, 171, 194, 171, 171, 160, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 201, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 201, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 215, 201, 201, 205, 205, 205, 194, 201, 205, 205, 201,
205, 205, 205, 220, 205, 215, 212, 212, 223, 212, 212, 211, 223, 223, 212, 212,
212, 223, 212, 215, 212, 223, 223, 222, 216, 221, 216, 216, 215, 216, 226, 226,
226, 215, 226, 226, 226, 226, 226, 226, 226, 226, 226, 236, 235, 235, 235, 235,
235, 235, 235, 236, 235, 243, 243, 240, 243, 243, 243, 243, 243, 243, 243, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 147, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 162, 147, 166,
171, 171, 194, 171, 188, 171, 194, 171, 171, 194, 171, 171, 171, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 194, 171, 162, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 188, 171, 194, 171, 194, 171, 203, 201, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 194, 201, 205, 205, 205,
205, 205, 205, 220, 205, 212, 205, 205, 212, 211, 212, 211, 211, 211, 212, 222,
211, 212, 212, 223, 222, 211, 221, 222, 221, 219, 221, 221, 216, 221, 221, 226,
221, 226, 225, 226, 225, 226, 226, 231, 231, 231, 231, 235, 235, 231, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 147, 130, 130, 130,
130, 166, 130, 130, 130, 130, 179, 130, 188, 130, 130, 179, 130, 179, 179, 166,
179, 179, 194, 179, 188, 179, 194, 179, 179, 179, 179, 179, 179, 179, 179, 179,
179, 188, 179, 179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 188, 188, 179,
179, 179, 179, 179, 179, 179, 179, 194, 179, 179, 179, 179, 201, 194, 179, 204,
179, 179, 194, 194, 179, 179, 201, 201, 203, 203, 194, 203, 201, 194, 201, 203,
203, 201, 203, 201, 194, 194, 204, 203, 203, 203, 201, 201, 203, 201, 203, 203,
203, 201, 201, 205, 203, 201, 203, 201, 211, 203, 205, 211, 203, 211, 205, 205,
205, 211, 211, 220, 211, 222, 222, 211, 211, 211, 211, 219, 211, 211, 211, 222,
211, 211, 211, 212, 222, 211, 211, 219, 221, 219, 219, 221, 225, 221, 219, 228,
228, 228, 219, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228, 228,
228, 228, 235, 235, 235, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 130, 130, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 162, 194, 166,
171, 162, 194, 171, 188, 171, 194, 162, 171, 194, 162, 171, 162, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 201, 201, 194, 201, 201, 203, 203, 201, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 211, 201, 205, 205, 205,
205, 205, 211, 220, 205, 222, 222, 212, 212, 211, 212, 211, 211, 212, 212, 222,
211, 221, 221, 216, 222, 216, 221, 219, 221, 219, 221, 221, 216, 226, 219, 226,
226, 226, 228, 228, 228, 228, 228, 228, 228, 228, 228, 235, 235, 228, 228, 235,
235, 235, 240, 240, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 130, 131, 143, 130, 130, 166, 147, 131, 130, 130,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 179, 147, 166,
171, 171, 194, 171, 188, 171, 194, 171, 147, 194, 171, 171, 179, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 194, 171, 171, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 171, 188, 171, 194, 171, 194, 171, 203, 201, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 205, 201, 201, 201, 201, 205, 203, 205, 194, 201, 205, 205, 201,
205, 205, 211, 220, 205, 201, 222, 205, 223, 211, 212, 211, 211, 211, 212, 222,
211, 212, 212, 223, 222, 211, 221, 222, 221, 219, 221, 221, 223, 225, 221, 226,
225, 226, 225, 226, 225, 226, 231, 231, 231, 231, 231, 235, 235, 231, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 130, 130, 166, 130, 130, 130, 130,
130, 166, 166, 130, 130, 130, 162, 130, 160, 130, 166, 130, 166, 162, 171, 166,
171, 166, 160, 171, 160, 171, 194, 162, 171, 194, 162, 171, 162, 188, 171, 162,
171, 188, 171, 171, 171, 171, 171, 171, 171, 162, 194, 171, 194, 188, 188, 171,
204, 171, 171, 194, 201, 188, 201, 194, 201, 201, 171, 203, 201, 194, 201, 204,
201, 201, 194, 201, 201, 201, 201, 201, 201, 201, 201, 201, 201, 194, 201, 201,
201, 201, 201, 204, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 205, 201, 215, 201, 201, 205, 211, 205, 211, 204, 205, 205, 195,
205, 212, 212, 204, 212, 215, 222, 212, 223, 212, 212, 211, 216, 216, 216, 222,
216, 216, 216, 215, 222, 216, 216, 222, 216, 221, 226, 226, 215, 226, 226, 226,
226, 226, 226, 226, 226, 226, 226, 228, 227, 235, 227, 227, 235, 227, 227, 227,
227, 240, 240, 240, 240, 240, 240, 240, 240, 243, 243, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 143, 131, 131, 166, 147, 131, 130, 147,
130, 166, 130, 130, 130, 130, 130, 130, 188, 130, 130, 130, 130, 179, 147, 166,
189, 189, 194, 179, 188, 179, 194, 179, 147, 194, 189, 179, 179, 188, 179, 179,
188, 188, 179, 179, 179, 179, 179, 194, 179, 179, 194, 179, 194, 188, 188, 179,
171, 179, 179, 194, 179, 188, 179, 194, 179, 194, 203, 179, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 194, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 194, 201, 201, 201, 201, 194, 203, 201, 194, 201, 205, 201, 201,
205, 211, 211, 220, 211, 220, 220, 205, 223, 211, 211, 211, 211, 211, 211, 222,
211, 211, 211, 223, 222, 211, 223, 222, 221, 219, 221, 221, 223, 225, 219, 225,
225, 226, 225, 225, 230, 230, 231, 231, 231, 231, 231, 231, 231, 231, 231, 231,
235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 130, 131,
130, 166, 166, 130, 130, 130, 130, 130, 188, 130, 189, 189, 188, 179, 194, 166,
189, 189, 194, 189, 188, 171, 194, 171, 194, 194, 189, 171, 179, 188, 171, 179,
188, 188, 171, 171, 171, 171, 171, 194, 171, 171, 194, 171, 194, 188, 188, 171,
171, 171, 171, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 205, 203, 201, 194, 201, 205, 201, 201,
205, 211, 211, 220, 211, 220, 220, 222, 223, 211, 223, 211, 223, 223, 223, 222,
211, 223, 223, 223, 222, 223, 223, 222, 221, 219, 221, 225, 223, 225, 221, 225,
225, 226, 225, 230, 230, 230, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 143, 131, 131, 166, 147, 131, 131, 147,
131, 166, 189, 130, 130, 130, 130, 130, 188, 189, 189, 189, 188, 179, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 179, 179,
188, 188, 189, 179, 179, 188, 179, 194, 179, 179, 194, 179, 194, 188, 188, 179,
189, 179, 179, 194, 194, 188, 194, 194, 179, 194, 203, 203, 188, 194, 201, 204,
194, 194, 194, 194, 201, 194, 201, 201, 201, 194, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 194, 201, 201, 201, 201, 194, 203, 201, 194, 201, 205, 201, 201,
201, 211, 211, 220, 211, 220, 220, 223, 223, 223, 223, 211, 223, 223, 223, 222,
211, 223, 223, 223, 222, 223, 223, 222, 223, 221, 225, 225, 223, 225, 225, 225,
225, 223, 230, 230, 230, 230, 230, 231, 230, 231, 231, 233, 231, 231, 231, 235,
235, 235, 235, 235, 235, 235, 235, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 130, 189, 189, 189, 189, 188, 189, 189, 189, 188, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 171, 179,
188, 188, 189, 171, 171, 188, 171, 194, 171, 189, 194, 171, 194, 188, 188, 171,
189, 171, 201, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 220, 223, 201, 201,
223, 223, 211, 220, 223, 220, 220, 222, 223, 223, 223, 211, 223, 223, 223, 222,
223, 223, 223, 223, 222, 223, 223, 222, 223, 219, 225, 225, 223, 230, 225, 230,
230, 223, 230, 230, 230, 230, 231, 231, 231, 231, 231, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 189, 189, 189, 189, 189, 188, 189, 189, 189, 188, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 189, 179,
188, 188, 189, 171, 171, 188, 171, 194, 171, 189, 194, 171, 194, 188, 188, 171,
189, 203, 201, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 211, 203, 201, 194, 220, 223, 201, 220,
223, 223, 211, 220, 223, 220, 220, 222, 223, 223, 223, 211, 223, 223, 223, 222,
223, 223, 222, 223, 222, 223, 223, 222, 225, 222, 225, 225, 223, 230, 230, 230,
230, 223, 230, 230, 230, 230, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235,
235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 179, 188, 189, 179,
188, 188, 189, 171, 171, 188, 171, 194, 171, 189, 194, 171, 194, 188, 188, 171,
189, 203, 201, 194, 201, 188, 201, 194, 201, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 211, 203, 201, 194, 220, 223, 220, 220,
223, 223, 222, 220, 222, 220, 220, 222, 223, 222, 222, 211, 223, 223, 223, 222,
222, 223, 222, 223, 222, 223, 223, 222, 225, 219, 225, 225, 223, 230, 231, 230,
230, 226, 230, 230, 222, 231, 231, 231, 231, 235, 235, 235, 235, 235, 235, 235,
235, 235, 240, 240, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 194, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 179, 189, 194, 189, 194, 188, 188, 189,
189, 203, 201, 194, 201, 188, 201, 194, 203, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 201, 201, 201, 201,
203, 201, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 220, 223, 220, 220,
220, 223, 222, 220, 223, 220, 220, 220, 223, 223, 223, 211, 223, 223, 223, 222,
223, 223, 223, 223, 222, 223, 223, 222, 223, 219, 230, 230, 223, 230, 230, 230,
230, 223, 230, 230, 230, 230, 233, 233, 233, 233, 233, 235, 235, 235, 235, 235,
235, 235, 235, 235, 235, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 131, 131,
131, 166, 166, 189, 189, 189, 189, 166, 188, 189, 189, 189, 188, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 188, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 171, 189, 194, 171, 194, 188, 188, 201,
204, 203, 201, 194, 201, 188, 201, 194, 201, 201, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 201, 194, 203, 201, 194, 201, 201,
201, 201, 201, 204, 194, 194, 204, 203, 201, 203, 201, 201, 204, 201, 201, 201,
203, 201, 201, 201, 201, 223, 220, 220, 223, 203, 201, 223, 220, 223, 220, 220,
220, 223, 222, 220, 222, 220, 220, 222, 223, 222, 222, 211, 223, 223, 223, 222,
222, 223, 222, 223, 222, 223, 223, 222, 222, 222, 230, 230, 236, 230, 231, 230,
230, 230, 230, 230, 222, 231, 235, 235, 235, 235, 235, 235, 235, 235, 235, 235,
235, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 243, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 131, 131, 143, 131, 131, 166, 131, 131, 131, 131,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 201, 194, 188, 188, 201, 194, 203, 194, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 194, 201,
201, 201, 201, 201, 194, 194, 204, 203, 201, 203, 201, 194, 220, 201, 201, 201,
203, 201, 201, 201, 220, 223, 220, 220, 194, 203, 201, 194, 220, 223, 220, 220,
220, 223, 220, 220, 220, 220, 220, 220, 223, 223, 223, 211, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 222, 223, 222, 230, 230, 223, 230, 230, 230,
230, 223, 230, 233, 234, 233, 233, 233, 233, 233, 233, 237, 235, 237, 237, 237,
237, 237, 239, 237, 239, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 188, 194, 188, 188, 188, 194, 201, 194, 189, 203, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 194, 194, 203, 201, 194, 188, 201,
201, 201, 201, 229, 194, 194, 204, 203, 201, 203, 201, 194, 220, 201, 201, 220,
203, 220, 220, 223, 220, 229, 220, 220, 194, 203, 223, 194, 220, 223, 220, 220,
220, 223, 220, 220, 223, 229, 220, 220, 223, 223, 223, 223, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 234, 223, 234, 223, 223, 236, 223, 230, 223,
230, 223, 234, 230, 234, 233, 233, 233, 233, 236, 237, 236, 237, 237, 237, 237,
237, 237, 239, 242, 239, 242, 239, 240, 240, 240, 240, 243, 243, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 189, 131,
189, 166, 166, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
188, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
204, 203, 201, 194, 201, 188, 201, 194, 201, 201, 203, 203, 188, 194, 201, 204,
201, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 201, 201,
201, 201, 201, 204, 194, 194, 204, 203, 201, 203, 220, 201, 204, 220, 220, 220,
203, 220, 220, 223, 220, 229, 220, 220, 223, 203, 220, 223, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 222, 222, 223, 223, 223, 222, 220,
222, 223, 222, 223, 222, 223, 223, 234, 222, 234, 230, 230, 236, 230, 233, 233,
233, 233, 234, 233, 234, 233, 233, 235, 233, 235, 235, 236, 235, 235, 235, 235,
240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 166, 131, 143, 131, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 189, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 203, 194, 203, 194, 203, 203, 188, 194, 203, 204,
203, 203, 194, 194, 203, 201, 201, 201, 203, 203, 194, 203, 201, 194, 194, 203,
203, 201, 203, 220, 194, 194, 204, 203, 203, 203, 220, 194, 220, 220, 203, 220,
203, 220, 220, 220, 220, 229, 220, 220, 223, 203, 220, 194, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 220, 220, 219, 223, 223, 222, 220,
222, 223, 222, 223, 222, 223, 223, 234, 222, 234, 233, 234, 223, 233, 233, 233,
233, 233, 234, 233, 234, 233, 233, 233, 233, 233, 233, 237, 237, 237, 237, 237,
237, 239, 239, 239, 239, 240, 240, 240, 240, 240, 240, 245, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 189, 131, 143, 189, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 188, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 201, 194, 203, 194, 189, 203, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 194, 194, 203, 201, 194, 194, 201,
201, 201, 201, 229, 194, 194, 204, 203, 201, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 223, 220, 229, 220, 220, 194, 203, 220, 194, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 220, 220, 223, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 234, 223, 234, 230, 234, 223, 233, 234, 233,
233, 223, 234, 233, 234, 233, 233, 233, 233, 233, 237, 236, 237, 237, 237, 237,
237, 239, 239, 242, 239, 239, 239, 240, 240, 240, 240, 240, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 189, 131, 143, 189, 131, 166, 131, 131, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 194, 166,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 189, 189, 194, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 201, 194, 203, 194, 189, 203, 188, 194, 201, 204,
194, 201, 194, 194, 201, 201, 201, 201, 201, 203, 194, 203, 201, 194, 194, 201,
201, 201, 201, 229, 194, 194, 204, 203, 201, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 223, 220, 229, 220, 220, 223, 203, 220, 194, 220, 223, 220, 220,
220, 220, 220, 220, 220, 220, 220, 220, 223, 220, 220, 223, 223, 223, 223, 220,
223, 223, 223, 223, 222, 223, 223, 234, 223, 234, 233, 234, 236, 233, 234, 233,
233, 233, 234, 233, 234, 233, 233, 233, 233, 237, 237, 237, 237, 237, 237, 237,
237, 239, 239, 242, 239, 239, 239, 240, 240, 240, 240, 245, 245, 245, 245, 245,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 189, 131, 143, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 194, 188, 194, 189, 189,
194, 194, 194, 194, 194, 194, 194, 188, 201, 194, 194, 203, 201, 194, 194, 220,
201, 201, 220, 229, 194, 194, 232, 203, 220, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 194, 220, 229, 220, 220, 194, 203, 220, 194, 220, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 223, 220, 220, 223, 223, 223, 223, 220,
234, 223, 234, 223, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 233,
234, 233, 234, 234, 234, 234, 233, 233, 237, 237, 237, 237, 237, 237, 237, 237,
239, 239, 241, 242, 241, 241, 241, 244, 244, 244, 244, 244, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 131, 131, 189, 131, 143, 189, 189, 189, 131, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 194, 189, 188, 189, 194, 189, 189, 194, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 203, 188, 194, 189, 204,
194, 203, 194, 194, 203, 201, 201, 201, 201, 194, 194, 203, 201, 194, 229, 220,
201, 220, 220, 229, 194, 194, 204, 220, 220, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 220, 220, 229, 220, 220, 223, 203, 220, 194, 220, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 223, 220, 220, 223, 223, 223, 220, 220,
234, 234, 234, 223, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 233,
234, 233, 234, 234, 234, 234, 233, 237, 237, 237, 237, 237, 237, 239, 237, 239,
239, 239, 239, 242, 241, 241, 241, 244, 244, 244, 244, 244, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 166, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 194, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 203, 188, 194, 189, 204,
189, 189, 194, 194, 203, 201, 229, 229, 220, 194, 194, 203, 220, 194, 229, 220,
220, 220, 220, 229, 194, 194, 232, 220, 220, 203, 220, 194, 220, 220, 220, 220,
203, 220, 220, 220, 220, 229, 220, 220, 220, 203, 220, 194, 220, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 223, 220, 220, 234, 223, 234, 234, 220,
234, 234, 234, 223, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 234,
234, 233, 234, 234, 234, 234, 237, 237, 237, 237, 237, 237, 239, 239, 239, 239,
241, 241, 241, 242, 241, 244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 131, 131, 131,
131, 131, 166, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 194, 189, 189, 189, 189, 189, 189, 188, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 188, 188, 189, 194, 189, 194, 189, 189, 188, 194, 189, 204,
189, 189, 194, 194, 229, 229, 229, 229, 229, 194, 194, 220, 229, 194, 229, 229,
229, 229, 229, 229, 194, 194, 232, 220, 220, 203, 229, 229, 229, 229, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 223, 220, 220, 194, 229, 220, 220, 229,
220, 220, 220, 229, 220, 229, 229, 220, 223, 220, 220, 223, 223, 223, 234, 229,
234, 234, 234, 236, 234, 223, 234, 234, 234, 234, 234, 234, 236, 234, 234, 234,
234, 236, 234, 234, 234, 236, 236, 236, 236, 236, 236, 236, 239, 239, 236, 236,
241, 241, 241, 242, 241, 242, 244, 244, 244, 244, 244, 246, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 131, 131,
189, 131, 189, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 194, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 194, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 194, 229, 229, 189, 194, 194, 203, 229, 194, 229, 229,
220, 229, 220, 229, 194, 194, 232, 220, 220, 203, 229, 194, 229, 220, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 194, 220, 220, 194, 220, 220, 220, 220,
220, 220, 220, 229, 220, 229, 220, 220, 223, 220, 220, 234, 223, 234, 234, 220,
234, 234, 234, 229, 234, 223, 234, 234, 234, 234, 234, 234, 234, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 237, 234, 237, 239, 239, 239, 239, 241, 241,
241, 241, 241, 242, 241, 244, 244, 244, 244, 244, 244, 246, 249, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 166, 189, 131, 131,
189, 189, 166, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 189, 189, 203, 188, 194, 189, 232,
189, 220, 194, 194, 220, 220, 229, 229, 220, 220, 194, 220, 229, 194, 229, 229,
220, 229, 220, 229, 194, 194, 232, 220, 220, 203, 229, 229, 232, 220, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 220, 220, 220, 223, 220, 220, 220, 220,
220, 220, 220, 229, 220, 229, 220, 220, 220, 220, 220, 234, 234, 234, 234, 234,
234, 234, 234, 229, 234, 234, 234, 234, 234, 234, 234, 234, 236, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 239, 234, 239, 239, 236, 239, 241, 241, 241,
241, 241, 241, 242, 244, 244, 244, 244, 244, 244, 244, 250, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 131, 131,
189, 189, 166, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 166, 189, 189, 189, 189, 189, 189, 188, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 194, 188, 188, 189,
189, 189, 189, 194, 189, 188, 189, 194, 189, 189, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 229, 229, 229, 220, 220, 194, 220, 229, 194, 229, 229,
220, 229, 220, 229, 194, 194, 232, 220, 220, 203, 229, 229, 232, 220, 220, 220,
220, 229, 229, 220, 220, 229, 220, 229, 220, 220, 220, 194, 220, 220, 220, 220,
220, 220, 220, 229, 220, 229, 220, 220, 220, 220, 220, 234, 234, 234, 234, 234,
234, 234, 234, 229, 234, 234, 234, 238, 234, 234, 234, 234, 234, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 239, 234, 239, 241, 241, 239, 241, 241, 241,
241, 241, 241, 242, 244, 244, 244, 244, 244, 244, 249, 249, 250, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 189, 131, 131,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 189, 188, 189,
189, 189, 189, 194, 189, 189, 189, 194, 189, 189, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 220, 229, 232, 220, 220, 194, 203, 220, 194, 229, 232,
220, 229, 220, 232, 194, 194, 232, 232, 220, 203, 220, 220, 232, 220, 220, 220,
220, 220, 220, 220, 220, 229, 220, 220, 220, 220, 220, 194, 232, 220, 220, 220,
220, 220, 220, 232, 220, 229, 238, 220, 234, 234, 234, 234, 234, 234, 234, 238,
234, 234, 234, 234, 234, 234, 234, 238, 234, 238, 234, 234, 234, 234, 234, 234,
234, 239, 234, 234, 238, 234, 234, 239, 234, 239, 241, 241, 241, 241, 241, 241,
241, 241, 244, 244, 244, 244, 244, 248, 248, 248, 248, 248, 248, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 131, 189, 131, 131, 189, 131, 189, 189, 189, 189, 189, 131,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 188, 188, 189,
189, 189, 189, 194, 189, 189, 189, 194, 189, 189, 189, 189, 188, 194, 189, 232,
189, 189, 194, 194, 189, 229, 229, 229, 229, 220, 194, 220, 229, 194, 229, 232,
229, 229, 229, 229, 194, 194, 232, 232, 229, 238, 229, 229, 232, 229, 229, 229,
220, 229, 229, 229, 229, 229, 229, 229, 220, 220, 229, 194, 232, 220, 229, 229,
229, 220, 220, 232, 220, 229, 229, 229, 229, 234, 234, 234, 234, 234, 234, 238,
234, 234, 234, 229, 234, 234, 234, 238, 234, 238, 234, 234, 234, 234, 234, 234,
234, 237, 234, 234, 234, 234, 234, 241, 234, 241, 241, 241, 241, 241, 241, 241,
247, 241, 244, 244, 247, 244, 244, 244, 246, 246, 249, 249, 251, 250, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
166, 131, 131, 131, 189, 189, 131, 189, 189, 131, 189, 189, 189, 189, 189, 131,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 188, 189, 188, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 188, 188, 189,
189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 189, 229, 194, 189, 232,
189, 189, 194, 194, 229, 229, 229, 232, 229, 229, 194, 220, 229, 194, 229, 232,
229, 229, 229, 229, 194, 229, 232, 232, 229, 238, 229, 229, 232, 229, 229, 229,
238, 229, 229, 229, 229, 229, 229, 229, 220, 238, 229, 220, 232, 229, 229, 229,
229, 229, 238, 232, 229, 229, 229, 229, 229, 238, 229, 234, 234, 234, 234, 238,
234, 234, 234, 229, 238, 234, 234, 238, 234, 238, 234, 234, 234, 234, 238, 234,
234, 239, 238, 234, 238, 234, 234, 241, 241, 241, 241, 241, 241, 241, 241, 241,
247, 244, 244, 246, 247, 246, 246, 246, 246, 249, 249, 251, 251, 252, 250, 250,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
189, 131, 131, 131, 189, 189, 131, 189, 189, 131, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 189, 188, 189,
189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 189, 229, 194, 189, 232,
189, 189, 194, 194, 189, 229, 229, 232, 232, 189, 194, 232, 229, 194, 229, 232,
229, 229, 229, 232, 194, 229, 232, 232, 229, 238, 232, 229, 232, 229, 229, 232,
238, 229, 229, 229, 238, 229, 229, 229, 220, 238, 229, 220, 232, 220, 238, 229,
238, 238, 238, 232, 238, 229, 238, 238, 229, 238, 238, 238, 234, 238, 238, 238,
238, 238, 238, 229, 238, 234, 238, 238, 238, 238, 238, 238, 234, 238, 238, 234,
238, 239, 238, 238, 238, 238, 234, 241, 238, 241, 241, 247, 241, 241, 247, 247,
247, 247, 246, 246, 247, 246, 246, 248, 249, 249, 248, 251, 251, 252, 252, 253,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
189, 131, 189, 131, 189, 189, 189, 189, 189, 131, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 189, 188, 189,
232, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 189, 229, 194, 189, 232,
189, 189, 194, 194, 232, 229, 229, 232, 229, 229, 229, 232, 229, 194, 229, 232,
229, 229, 229, 232, 194, 229, 232, 232, 229, 238, 232, 229, 232, 229, 229, 229,
238, 229, 229, 229, 229, 229, 229, 229, 229, 238, 229, 234, 232, 229, 229, 229,
229, 238, 238, 232, 238, 229, 238, 238, 229, 238, 238, 238, 234, 238, 238, 238,
238, 238, 238, 229, 238, 234, 238, 238, 238, 238, 238, 238, 234, 238, 238, 234,
238, 241, 238, 238, 238, 238, 247, 241, 247, 241, 247, 247, 241, 247, 247, 247,
247, 247, 247, 246, 247, 246, 246, 249, 249, 249, 251, 251, 252, 252, 253, 253,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 194, 189, 189, 232, 229, 189,
232, 232, 189, 189, 189, 232, 189, 194, 232, 189, 232, 189, 229, 194, 232, 232,
232, 232, 229, 229, 232, 232, 229, 232, 232, 232, 229, 232, 232, 194, 229, 232,
232, 229, 232, 232, 194, 229, 232, 232, 232, 238, 232, 229, 232, 229, 232, 232,
238, 229, 229, 229, 238, 229, 238, 229, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 229, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 229, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 247, 238, 238, 238, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 249, 247, 251, 251, 251, 251, 252, 252, 253, 253, 254,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 131, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 232, 194, 189, 189, 232, 229, 232,
232, 232, 232, 189, 232, 232, 232, 194, 232, 232, 232, 232, 229, 194, 232, 232,
232, 232, 229, 232, 232, 232, 229, 232, 232, 232, 229, 232, 232, 229, 229, 232,
232, 232, 232, 232, 229, 229, 232, 232, 232, 238, 232, 229, 232, 232, 232, 232,
238, 232, 232, 238, 238, 229, 238, 238, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 229, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 247, 238, 238, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 251, 247, 251, 251, 252, 252, 252, 252, 253, 253, 254,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 232,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 232, 189, 189, 189, 189, 232, 189, 189, 232, 189, 232, 189, 232, 229, 232,
232, 232, 232, 232, 232, 232, 232, 194, 232, 232, 232, 232, 232, 194, 232, 232,
232, 232, 229, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 238, 229, 232,
232, 232, 232, 232, 229, 229, 232, 232, 232, 238, 232, 229, 232, 232, 232, 232,
238, 238, 232, 238, 238, 229, 238, 238, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 232, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 247, 238, 238, 238,
238, 247, 238, 238, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 252, 247, 252, 252, 252, 252, 253, 253, 254, 254, 255,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131,
131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189,
189, 232, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 189, 232,
189, 232, 189, 232, 232, 232, 189, 232, 189, 189, 232, 232, 232, 232, 232, 232,
232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 189, 232, 232, 232, 229, 232,
232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 238, 232, 232,
232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 232, 238, 229, 232,
232, 232, 232, 232, 238, 229, 232, 232, 232, 238, 232, 238, 232, 232, 232, 232,
238, 238, 232, 238, 238, 229, 238, 238, 238, 238, 238, 238, 232, 238, 238, 238,
238, 238, 238, 232, 238, 232, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238,
238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 247, 238, 238, 247,
238, 247, 238, 247, 238, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247, 247,
247, 247, 247, 247, 247, 253, 253, 253, 253, 253, 253, 254, 254, 254, 255, 255
};

#endif /* macintosh */

/*
$Log: hvqlut1.c,v $
Revision 1.1.1.1  1999/09/20 18:19:13  jlin
Imported sources

Revision 1.1  1996/11/21 19:19:49  aber
Initial revision

*/
